unit Debugger_Form;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, RTTICtrls, Forms, Controls, Graphics, Dialogs,
  StdCtrls, ExtCtrls, ComCtrls, CheckLst, Buttons,

  synaser, Types,

  CompilerDeklarationen;




const
  ligneMax = 30;
  Laenge_ASM_VAR_Liste = 100000;
  CRLF = CHR($0D)+CHR($0A);


  dbg_checked_Liste = 'checked_Liste.txt';
  dbg_path = 'rp_debugger';
  dbg_checked_Liste_path = dbg_path + '\' + dbg_checked_Liste;

  dbg_gutter_Liste = 'dbg.txt';
  dbg_gutter_Liste_path = dbg_path + '\' + dbg_gutter_Liste;


type


  // ASM_VAR_Record
  ASM_VAR_List_REC = record
    Bezeichner : String;
    ASM_type : ASM_type_Typ;
    Laenge : Integer;
    RAM_Offset : Word;
  end;


  // Zuweisungs-Liste
   ASM_VAR_REC = record
    Liste : array [0..Laenge_ASM_VAR_Liste] of ASM_VAR_List_REC;
    ListeCounter : Integer;
  end;




  { TForm_Debugger }

  TForm_Debugger = class(TForm)
    BitBtn_Close: TBitBtn;
    BitBtn_Weiter: TBitBtn;
    Button_mit_USB: TButton;
    Button_ohne_USB: TButton;
    Button_Connect: TButton;
    Button_dbg_aktiv: TButton;
    Button_SaveList: TButton;
    CheckListBox1: TCheckListBox;
    ComboBoxBauds: TComboBox;
    ComboBoxPort: TComboBox;
    Image_con_rt: TImage;
    Image_con_gn: TImage;
    Image_da_gn: TImage;
    Image_da_rt: TImage;
    Label1: TLabel;
    Label2: TLabel;
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    Terminal: TListBox;
    PageControl1: TPageControl;
    TabSheet_Terminal: TTabSheet;
    TabSheet_02_DEF_VAR_List: TTabSheet;
    Timer1: TTimer;
    procedure BitBtn_CloseClick(Sender: TObject);
    procedure BitBtn_WeiterClick(Sender: TObject);
    procedure Button_ConnectClick(Sender: TObject);
    procedure Button_dbg_aktivClick(Sender: TObject);
    procedure Button_mit_USBClick(Sender: TObject);
    procedure Button_ohne_USBClick(Sender: TObject);
    procedure Button_SaveListClick(Sender: TObject);
    procedure CheckListBox1Click(Sender: TObject);
    procedure ComboBoxBaudsChange(Sender: TObject);
    procedure ComboBoxPortChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormDestroy(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { private declarations }
    PortConnected : Boolean;
    PortName, ReadCOM : String;
    TimeOut: integer;
    ASM_VAR : ASM_VAR_REC;
    Checked_gesetzt : Boolean;
    ComboBoxPort_Liste : TStringList;
    procedure DBG_aktivieren;
    procedure DBG_deaktivieren;
    procedure COM_Ports_einlesen;
    procedure COM_Port_verbinden;
    procedure COM_Port_trennen;
    procedure Anzeige_der_Zeile(DateiReiterNr, ZeilenNr : Integer);
    procedure Anzeige_der_String_VAR(ADS_String : String);
    procedure sende_VAR_Liste;
    procedure sichere_checked_Liste;

  public
    { public declarations }
    Debugger_aktiv : Boolean;
    DBG_Line_List : TStringList;
    procedure registriere_ASM_VAR(Var_Name : String;
                                  Var_Typ : ASM_type_Typ;
                                  Var_Laenge : Integer;
                                  VAR_Offset : Word);
    procedure loesche_ASM_VAR_Liste;
    procedure lade_checked_Liste;
  end;

var
  Form_Debugger: TForm_Debugger;
  PortCom: TBlockSerial;


implementation

{$R *.lfm}

uses
  Main_Unit;


{ TForm_Debugger }


procedure TForm_Debugger.FormCreate(Sender: TObject);
var
  Font_Size : Integer;
begin

  Font_Size:=11;
  CheckListBox1.Font.Size:=Font_Size;
  CheckListBox1.ItemHeight:=Font_Size * 2;

  ReadCOM:='';

  Timer1.Enabled:=false;

  DBG_deaktivieren;

  Terminal.Clear;

  PortConnected:=false;

  ComboBoxBauds.Items.Add('   300');
  ComboBoxBauds.Items.Add('   600');
  ComboBoxBauds.Items.Add('  1200');
  ComboBoxBauds.Items.Add('  2400');
  ComboBoxBauds.Items.Add('  4800');
  ComboBoxBauds.Items.Add('  9600');
  ComboBoxBauds.Items.Add(' 19200');
  ComboBoxBauds.Items.Add(' 38400');
  ComboBoxBauds.Items.Add(' 57600');
  ComboBoxBauds.Items.Add('115200');
  ComboBoxBauds.Items.Add('128000');
  ComboBoxBauds.Items.Add('230400');
  ComboBoxBauds.Items.Add('256000');
  ComboBoxBauds.Items.Add('460800');
  ComboBoxBauds.Items.Add('921600');

  ComboBoxBauds.ItemIndex:=Form_RP.DBG_Index_BaudRate;

  PortName:=Form_RP.DBG_ComPort;

  Checked_gesetzt:=false;
  loesche_ASM_VAR_Liste;

  DBG_Line_List := TStringList.Create;

  ComboBoxPort_Liste := TStringList.Create;

end; { procedure TForm_Debugger.FormCreate }







// ****************
// Hilfs-Prozeduren
// ****************



procedure TForm_Debugger.DBG_aktivieren;
begin

  Image_da_rt.Visible:=false;
  Image_da_gn.Visible:=true;

  Button_dbg_aktiv.Caption:='DBG deaktivieren';

  Debugger_aktiv:=true;

  COM_Ports_einlesen;

end; { procedure TForm_Debugger.DBG_aktivieren }




procedure TForm_Debugger.DBG_deaktivieren;
begin

  COM_Port_trennen;

  Image_da_rt.Visible:=true;
  Image_da_gn.Visible:=false;

  Button_dbg_aktiv.Caption:='DBG aktivieren';

  Debugger_aktiv:=false;

end; { procedure TForm_Debugger.DBG_deaktivieren }






procedure TForm_Debugger.COM_Ports_einlesen;
var
  l : string;
  p, Zeiger : integer;

begin

  l := GetSerialPortNames;

  if l >'' then
    repeat begin
      p :=  pos(',',l);
      if p > 0 then begin
        ComboBoxPort.Items.Add(copy(L,1,p-1));
        delete(L,1,p);
      end
      else
        ComboBoxPort.Items.Add(L);
    end;
    until p = 0;

  Zeiger:=-1;
  for p:=0 to ComboBoxPort.Items.Count-1 do begin
    if ComboBoxPort.Items[p]=PortName then
      Zeiger:=p;

  end; { for p:=0 to ComboBoxPort.Items.Count-1 do }

  if Zeiger>-1 then
    ComboBoxPort.ItemIndex:=Zeiger
  else
    ComboBoxPort.ItemIndex:=0;

end; { procedure TForm_Debugger.COM_Ports_einlesen }








procedure TForm_Debugger.Button_ohne_USBClick(Sender: TObject);
var
  BPo_counter : Integer;
  BPo_S1 : String;
begin

  COM_Ports_einlesen;

  ComboBoxPort_Liste.Clear;
  ComboBoxPort_Liste.Sorted:=true;

  for BPo_counter:=0 to ComboBoxPort.Items.Count-1 do begin
    BPo_S1:=ComboBoxPort.Items[BPo_counter];
    ComboBoxPort_Liste.Add(BPo_S1);
  end;

  ComboBoxPort.ItemIndex:=-1;

end; { procedure TForm_Debugger.Button_ohne_USBClick }







procedure TForm_Debugger.Button_mit_USBClick(Sender: TObject);
var
  BPm_counter, BPm_ind : Integer;
  BPm_S1, BPm_S2 : String;
begin

  COM_Ports_einlesen;

  ComboBoxPort.ItemIndex:=-1;

  BPm_S2:='';

  for BPm_counter:=0 to ComboBoxPort.Items.Count-1 do begin
    BPm_S1:=ComboBoxPort.Items[BPm_counter];

    if not ComboBoxPort_Liste.Find(BPm_S1,BPm_ind) then begin
      BPm_S2:=BPm_S1;
      ComboBoxPort.ItemIndex:=BPm_counter;
    end; { if not ComboBoxPort_Liste.Find(BPm_S1) then }

  end; { for BPo_counter:=0 to ComboBoxPort.Items.Count-1 do }


  // ein neuer COM-Port wurde gefunden
  if ComboBoxPort.ItemIndex>-1 then begin
    Form_RP.Port_Name:=BPm_S2;
    Terminal.Items.Add('... COM-Port:'+BPm_S2+' gefunden');
  end { if ComboBoxPort.ItemIndex>-1 then }
  else
    Terminal.Items.Add('*** kein neuer COM-Port gefunden');

end; {  }













procedure TForm_Debugger.COM_Port_verbinden;
var
  BaudRate : String;
begin
  Button_Connect.Caption:='Trennen';
  PortConnected:=true;
  Image_con_rt.Visible:=false;
  Image_con_gn.Visible:=true;
  BaudRate:=ComboBoxBauds.Items[ComboBoxBauds.ItemIndex];
  Terminal.Items.Add('--- Port '+PortName+' ist mit einer Baudrate von '+BaudRate+' verbunden');
  Timer1.Enabled:=true;

end; { procedure TForm_Debugger.COM_Port_verbinden }





procedure TForm_Debugger.COM_Port_trennen;
begin
  Timer1.Enabled:=false;
  Button_Connect.Caption:='Verbinden';
  PortConnected:=false;
  Image_con_rt.Visible:=true;
  Image_con_gn.Visible:=false;
  Terminal.Items.Add('--- Port wurde getrennt');
end; { procedure TForm_Debugger.COM_Port_trennen }









// *******************
// *  ASM Variablen  *
// *******************





procedure TForm_Debugger.lade_checked_Liste;
var
  LCL_counter, LCL_counter2 : Integer;
  LCL_StringList : TStringList;
  Bez_ASM_List : String;
begin

  if FileExists(Form_RP.ronpas_path+'\'+dbg_checked_Liste_path) then begin

    LCL_StringList := TStringList.Create;
    LCL_StringList.Sorted:=true;
    LCL_StringList.LoadFromFile(Form_RP.ronpas_path+'\'+dbg_checked_Liste_path);

    for LCL_counter:=0 to CheckListBox1.Items.Count-1 do begin

      Bez_ASM_List:=ASM_VAR.Liste[LCL_counter].Bezeichner;

      if LCL_StringList.Find(Bez_ASM_List,LCL_counter2) then
        CheckListBox1.Checked[LCL_counter]:=true;

    end; { for LCL_counter:=0 to CheckListBox1.Items.Count-1 do }

    LCL_StringList.Free;

  end; { if FileExists(dbg_checked_Liste_path) then }

end; { procedure TForm_Debugger.lade_checked_Liste }







procedure TForm_Debugger.sichere_checked_Liste;
var
  LCL_counter : Integer;
  LCL_StringList : TStringList;
  Bez_ASM_List : String;
begin

  LCL_StringList := TStringList.Create;
  LCL_StringList.Sorted:=true;

  for LCL_counter:=0 to CheckListBox1.Items.Count-1 do begin

    if CheckListBox1.Checked[LCL_counter] then begin

      Bez_ASM_List:=ASM_VAR.Liste[LCL_counter].Bezeichner;
      LCL_StringList.Add(Bez_ASM_List);

    end;

  end; { for LCL_counter:=0 to CheckListBox1.Items.Count-1 do }

  LCL_StringList.SaveToFile(dbg_checked_Liste_path);
  LCL_StringList.Free;

end; { procedure TForm_Debugger.sichere_checked_Liste }








procedure TForm_Debugger.loesche_ASM_VAR_Liste;
var
  AVL_counter : Integer;
begin

  for AVL_counter:=0 to Laenge_ASM_VAR_Liste do begin
    ASM_VAR.Liste[AVL_counter].Bezeichner:='';
    ASM_VAR.Liste[AVL_counter].ASM_type:=AT_kein_typ;
    ASM_VAR.Liste[AVL_counter].Laenge:=0;
    ASM_VAR.Liste[AVL_counter].RAM_Offset:=0;
  end; { for AVL_counter:=0 to Laenge_ASM_VAR_List do }

  ASM_VAR.ListeCounter:=-1;

  CheckListBox1.Items.Clear;

end; { procedure TForm_Debugger.loesche_ASM_VAR_Liste }









procedure TForm_Debugger.registriere_ASM_VAR(Var_Name : String;
                                             Var_Typ : ASM_type_Typ;
                                             Var_Laenge : Integer;
                                             VAR_Offset : Word);


  function ASM_type_zu_String(ASM_Var_Typ : ASM_type_Typ) : String;
  var
    AS_String : String;
  begin

    case ASM_Var_Typ of
      AT_kein_typ     : AS_String:='AT_kein_typ';
      AT_bit          : AS_String:='Bit';
      AT_byte_con_reg : AS_String:='Byte-Register';
      AT_word_con_reg : AS_String:='Word-Register';
      AT_byte_con_var : AS_String:='Byte-Register-Var';
      AT_word_con_var : AS_String:='Word-Register-Var';
      AT_boolean      : AS_String:='Boolean';
      AT_byte         : AS_String:='Byte';
      AT_word         : AS_String:='Word';
      AT_dword        : AS_String:='Dword';
      AT_currency     : AS_String:='Currency';
      AT_char         : AS_String:='Char';
      AT_string       : AS_String:='String';
    else
      AS_String:='AT_kein_typ';
    end; { case ASM_Var_Typ of }

    Result:=AS_String;

  end; { function ASM_type_zu_String }


begin

  INC(ASM_VAR.ListeCounter);

  ASM_VAR.Liste[ASM_VAR.ListeCounter].Bezeichner:=Var_Name;
  ASM_VAR.Liste[ASM_VAR.ListeCounter].ASM_type:=Var_Typ;
  ASM_VAR.Liste[ASM_VAR.ListeCounter].Laenge:=Var_Laenge;
  ASM_VAR.Liste[ASM_VAR.ListeCounter].RAM_Offset:=VAR_Offset;

  CheckListBox1.Items.Add(Var_Name+' ('+
                          ASM_type_zu_String(Var_Typ)+')');


end; { procedure TForm_Debugger.registriere_Variable }












// **************
// *  ComboBox  *
// **************


procedure TForm_Debugger.ComboBoxBaudsChange(Sender: TObject);
begin

  Form_RP.DBG_Index_BaudRate:=ComboBoxBauds.ItemIndex;

end; { procedure TForm_Debugger.ComboBoxBaudsChange }




procedure TForm_Debugger.ComboBoxPortChange(Sender: TObject);
begin

  PortName:=ComboBoxPort.Items[ComboBoxPort.ItemIndex];
  Form_RP.DBG_ComPort:=PortName;

end; { procedure TForm_Debugger.ComboBoxPortChange }





// **************
// *  Buttons   *
// **************

procedure TForm_Debugger.Button_dbg_aktivClick(Sender: TObject);
begin

  if Debugger_aktiv then
    DBG_deaktivieren
  else
    DBG_aktivieren;

end; { procedure TForm_Debugger.Button_dbg_aktivClick }










procedure TForm_Debugger.Button_SaveListClick(Sender: TObject);
begin
  sichere_checked_Liste;
end;





procedure TForm_Debugger.CheckListBox1Click(Sender: TObject);
begin
  sichere_checked_Liste;
end;









procedure TForm_Debugger.Button_ConnectClick(Sender: TObject);
var
  bauds : Integer;
  BaudRate : String;
begin
  if not PortConnected then begin
    PortCom := TBlockSerial.Create;
    PortCom.RaiseExcept := true;
    PortName:=ComboBoxPort.Items[ComboBoxPort.ItemIndex];
    PortCom.Connect(PortName);

    BaudRate:=ComboBoxBauds.Items[ComboBoxBauds.ItemIndex];
    bauds := StrToInt(BaudRate);

    PortCom.Config(bauds,8,'N',SB1,false,false); { baud, bits: integer; parity: char; stop: integer; softflow, hardflow: boolean }
    TimeOut := LigneMax*10000 div bauds;

    COM_Port_verbinden;
  end
  else begin
    COM_Port_trennen;
  end;

  end; { procedure TForm1.ConnectButtonClick }












procedure TForm_Debugger.BitBtn_WeiterClick(Sender: TObject);
var
  SendText : String;
begin
 if PortConnected then begin

   SendText:='D';
   PortCom.SendString(SendText);
   Terminal.Items.Add('>> '+SendText+#13+#10);

  end
  else
    Terminal.Items.Add('*** Fehler: Port ist nicht verbunden');

end; { procedure TForm_Debugger.BitBtn_WeiterClick }












procedure TForm_Debugger.sende_VAR_Liste;
var
  SVL_counter : Integer;



  procedure sende_PortCom(COM_Code : Char; POS_Liste : Byte; RAM_OFFSET : Word);
  var
    SendText : String;
  begin

   SendText:=COM_Code+IntToHex(POS_Liste,2)+IntToHex(RAM_OFFSET,4);
   PortCom.SendString(SendText);

  end; { procedure sende_PortCom }



  procedure sende_PortCom_Laenge(COM_Code : Char; POS_Liste, SPC_Laenge : Byte; RAM_OFFSET : Word);
  var
    SendText : String;
  begin

   SendText:=COM_Code+IntToHex(POS_Liste,2)+IntToHex(SPC_Laenge,2)+IntToHex(RAM_OFFSET,4);
   PortCom.SendString(SendText);

  end; { procedure sende_PortCom_Laenge }





begin

  for SVL_counter:=0 to CheckListBox1.Items.Count-1 do begin

    if CheckListBox1.Checked[SVL_counter] then begin

      case ASM_VAR.Liste[SVL_counter].ASM_type of

        AT_byte    : sende_PortCom('B',SVL_counter,ASM_VAR.Liste[SVL_counter].RAM_Offset);
        AT_boolean : sende_PortCom('O',SVL_counter,ASM_VAR.Liste[SVL_counter].RAM_Offset);
        AT_char    : sende_PortCom('C',SVL_counter,ASM_VAR.Liste[SVL_counter].RAM_Offset);
        AT_word    : sende_PortCom('W',SVL_counter,ASM_VAR.Liste[SVL_counter].RAM_Offset);
        AT_dword   : sende_PortCom('E',SVL_counter,ASM_VAR.Liste[SVL_counter].RAM_Offset);
        AT_string  : sende_PortCom('S',SVL_counter,ASM_VAR.Liste[SVL_counter].RAM_Offset);

      end; { case ASM_VAR.Liste[SVL_counter].ASM_type of }

      sleep(20);

    end; { if CheckListBox1.Checked[SVL_counter] then }

  end; { for AVL_counter:=0 to Laenge_ASM_VAR_List do }

end; { sende_VAR_Liste }














procedure TForm_Debugger.BitBtn_CloseClick(Sender: TObject);
begin

  sichere_checked_Liste;

  Form_RP.DBG_Left:=Left;
  Form_RP.DBG_Top:=Top;

  DBG_deaktivieren;
  Form_Debugger.Visible:=false;

end; { procedure TForm_Debugger.BitBtn_CloseClick }










procedure TForm_Debugger.Anzeige_der_Zeile(DateiReiterNr, ZeilenNr : Integer);
var
  Zeile : String;
begin

  Form_RP.Zeile_in_SynEdit_markieren(DateiReiterNr,ZeilenNr-1,Zeile);

  Form_RP.ListBox_Meldungen.Clear;

  sende_VAR_Liste;

end; { procedure TForm_Debugger.Anzeige_der_Zeile }











// (s) 05 06 42 43 44 45 46 47 = POS ges_Laene String(CHAR + CHAR ...)
procedure TForm_Debugger.Anzeige_der_String_VAR(ADS_String : String);
var
  ADS_String_02, ADS_String_03, ADS_String_04 : String;
  ADS_Pos{, ADS_Zaehler} : Integer;
begin

  if Length(ADS_String)>1 then begin
    ADS_String_02:=Copy(ADS_String,1,2);
    ADS_Pos:=StrToInt(ADS_String_02);
    Delete(ADS_String,1,2);

    ADS_String_04:='';
    while Length(ADS_String)>1 do begin

      ADS_String_02:='$'+Copy(ADS_String,1,2);
      ADS_String_04:=ADS_String_04+Char(StrToInt(ADS_String_02));
      Delete(ADS_String,1,2);

    end; { while Length(ADS_String)>1 do }


    // absichern !!!
    ADS_String_03:=ASM_VAR.Liste[ADS_Pos].Bezeichner;

    Form_RP.Add_Item_ASMType('VAR - '+ADS_String_03+'='+ADS_String_04+' (String)',AT_string);

  end { if Length(ADS_String)>1 then }
  else
    Terminal.Items.Add('*** Fehler: String Laenge kleiner 2 ('+ADS_String+')');




end; { procedure TForm_Debugger.Anzeige_der_Zeile }





// **************
// *   Timer    *
// **************




procedure TForm_Debugger.Timer1Timer(Sender: TObject);
var
  Kommando : Char;
  EmpfangsZeile,
  DatenString_01, DatenString_02 : String;
  POS_KA, DatenZahl_01, DatenZahl_02 : Integer;
  DatenZahl_DWord : DWord;

begin

  if PortCom.CanReadEx(0) = true then begin

    ReadCOM:=ReadCOM+PortCom.RecvPacket(50);

    Caption:=ReadCOM;

    // Anfangsinitialisierung - ReadCOM leeren
    POS_KA:=Pos('@',ReadCOM);
    if POS_KA>0 then begin
        ReadCOM := '';
        Terminal.Clear;
        Terminal.Items.Add('>> RESET von der Hardware empfangen');
    end; { if POS_KA>0 then }


    while Pos(CRLF,ReadCOM)>0 do begin { Befehlszeile wurde vollstaendig empfangen }

      caption:='<'+ReadCOM+'>';


      if Length(ReadCOM)>Length(CRLF) then begin
        Kommando:=ReadCOM[1];
        Delete(ReadCOM,1,1);
        case Kommando of


          'b' : begin // (b)01 77 CR LF  Byte
                  if Pos(CRLF,ReadCOM)=5 then begin
                    EmpfangsZeile:=Copy(ReadCOM,1,2);
                    DatenZahl_01:=StrToInt('$'+EmpfangsZeile);
                    Delete(ReadCOM,1,2);

                    EmpfangsZeile:=Copy(ReadCOM,1,2);
                    DatenZahl_02:=StrToInt('$'+EmpfangsZeile);
                    Delete(ReadCOM,1,2+Length(CRLF));

                    // absichern !!!
                    DatenString_01:=ASM_VAR.Liste[DatenZahl_01].Bezeichner;

                    Form_RP.Add_Item_ASMType('VAR - '+DatenString_01+'='+
                                       IntToHex(DatenZahl_02,2)+'H ='+
                                       IntToStr(DatenZahl_02)+' (Byte)',
                                       AT_byte);

                  end
                  else
                    Terminal.Items.Add('*** Fehler: zu viele Parameter in den Daten ('+ReadCOM+') ***');

                end; { 'b' }



          'c' : begin // (c)01 77 CR LF = Char
                  if Pos(CRLF,ReadCOM)=5 then begin
                    EmpfangsZeile:=Copy(ReadCOM,1,2);
                    DatenZahl_01:=StrToInt('$'+EmpfangsZeile);
                    Delete(ReadCOM,1,2);

                    EmpfangsZeile:=Copy(ReadCOM,1,2);
                    DatenZahl_02:=StrToInt('$'+EmpfangsZeile);
                    Delete(ReadCOM,1,2+Length(CRLF));

                    // absichern !!!
                    DatenString_01:=ASM_VAR.Liste[DatenZahl_01].Bezeichner;

                    Form_RP.Add_Item_ASMType('VAR - '+DatenString_01+'="'+
                                             Chr(DatenZahl_02)+'"  '+
                                             IntToHex(DatenZahl_02,2)+'H (Char)',
                                             AT_char);

                  end
                  else
                    Terminal.Items.Add('*** Fehler: zu viele Parameter in den Daten ('+ReadCOM+') ***');

                end; { 'c' }




          'o' : begin // (o)01 77 CR LF = Boolean
                  if Pos(CRLF,ReadCOM)=5 then begin
                    EmpfangsZeile:=Copy(ReadCOM,1,2);
                    DatenZahl_01:=StrToInt('$'+EmpfangsZeile);
                    Delete(ReadCOM,1,2);

                    EmpfangsZeile:=Copy(ReadCOM,1,2);
                    DatenZahl_02:=StrToInt('$'+EmpfangsZeile);
                    Delete(ReadCOM,1,2+Length(CRLF));

                    DatenString_01:=ASM_VAR.Liste[DatenZahl_01].Bezeichner;

                    if DatenZahl_02=0 then
                      DatenString_02:='FALSE'
                    else
                      DatenString_02:='TRUE';

                    Form_RP.Add_Item_ASMType('VAR - '+DatenString_01+'='+
                                             DatenString_02+' (Boolean)',
                                             AT_boolean);

                  end
                  else
                    Terminal.Items.Add('*** Fehler: zu viele Parameter in den Daten ('+ReadCOM+') ***');

                end; { 'o' }




          'w' : begin // (w)010377 CR LF = Word
                  if Pos(CRLF,ReadCOM)=7 then begin
                    EmpfangsZeile:=Copy(ReadCOM,1,2);
                    DatenZahl_01:=StrToInt('$'+EmpfangsZeile);
                    Delete(ReadCOM,1,2);

                    EmpfangsZeile:=Copy(ReadCOM,1,4);
                    DatenZahl_02:=StrToInt('$'+EmpfangsZeile);
                    Delete(ReadCOM,1,4+Length(CRLF));

                    // absichern !!!
                    DatenString_01:=ASM_VAR.Liste[DatenZahl_01].Bezeichner;

                    Form_RP.Add_Item_ASMType('VAR - '+DatenString_01+'='+
                                       IntToHex(DatenZahl_02,4)+'H ='+
                                       IntToStr(DatenZahl_02)+' (Word)',
                                       AT_word);

                  end
                  else
                    Terminal.Items.Add('*** Fehler: zu viele Parameter in den Daten ('+ReadCOM+') ***');

                end; { 'w' }


          'e' : begin // (e)0100000377 CR LF = DWord
                  if Pos(CRLF,ReadCOM)=11 then begin
                    EmpfangsZeile:=Copy(ReadCOM,1,2);
                    DatenZahl_01:=StrToInt('$'+EmpfangsZeile);
                    Delete(ReadCOM,1,2);

                    EmpfangsZeile:=Copy(ReadCOM,1,8);
                    DatenZahl_DWord:=StrToInt('$'+EmpfangsZeile);
                    Delete(ReadCOM,1,8+Length(CRLF));

                    // absichern !!!
                    DatenString_01:=ASM_VAR.Liste[DatenZahl_01].Bezeichner;

                    Form_RP.Add_Item_ASMType('VAR - '+DatenString_01+'='+
                                       IntToHex(DatenZahl_DWord,8)+'H ='+
                                       IntToStr(DatenZahl_DWord)+' (DWord)',
                                       AT_dword);

                  end
                  else
                    Terminal.Items.Add('*** Fehler: zu viele Parameter in den Daten ('+ReadCOM+') ***');

                end; { 'e' }


          's' : begin  // String
                    EmpfangsZeile:=Copy(ReadCOM,1,Pos(CRLF,ReadCOM)-1);
                    Delete(ReadCOM,1,Pos(CRLF,ReadCOM)-1+Length(CRLF));

                    Anzeige_der_String_VAR(EmpfangsZeile);

                end; { 's' }



          // Sonderbehandlungen


          'd' : begin // (d)00010077 CR LF -> Weiter
                  if Pos(CRLF,ReadCOM)=9 then begin
                    EmpfangsZeile:=Copy(ReadCOM,1,4);
                    DatenZahl_01:=StrToInt('$'+EmpfangsZeile);
                    Delete(ReadCOM,1,4);
                    EmpfangsZeile:=Copy(ReadCOM,1,4);
                    DatenZahl_02:=StrToInt('$'+EmpfangsZeile);
                    Delete(ReadCOM,1,4+Length(CRLF));
                    Terminal.Items.Add('<< Datei='+IntToStr(DatenZahl_01)+
                                       ' Zeile='+IntToStr(DatenZahl_02));

                    Anzeige_der_Zeile(DatenZahl_01,DatenZahl_02);

                  end
                  else
                    Terminal.Items.Add('*** Fehler: zu viele Parameter in den Daten ('+ReadCOM+') ***');

                end; { 'd' }


          'x' : begin // Fehlernummer
                  if Pos(CRLF,ReadCOM)=3 then begin
                    EmpfangsZeile:=Copy(ReadCOM,1,2);
                    Delete(ReadCOM,1,2+Length(CRLF));
                    Terminal.Items.Add('>> Fehler Nr: '+EmpfangsZeile+' vom Controller gesendet');
                  end
                  else
                    Terminal.Items.Add('*** Fehler: zu viele Parameter in den Daten ('+ReadCOM+') ***');

                end; { 'x' }


          'y' : begin  // Kommentare
                    EmpfangsZeile:=Copy(ReadCOM,1,Pos(CRLF,ReadCOM)-1);
                    Delete(ReadCOM,1,Pos(CRLF,ReadCOM)-1+Length(CRLF));
                    Terminal.Items.Add('*** '+EmpfangsZeile);
                end; { 'y' }


          else
            Terminal.Items.Add('*** Fehler: das Kommando:'+Kommando+' ('+IntToHex(Ord(Kommando),2)+') ist nicht definiert ***');
          end;

        end { if Length(ReadCOM)>Length(CRLF) then }
        else
          Terminal.Items.Add('*** Fehler: kein Kommando in der Befehlszeile ***');


      end; { while Pos(CRLF,ReadCOM)>0 do }

  end; { if PortCom.CanReadEx(0) = true then begin }

end; { procedure TForm_Debugger.Timer1Timer }












// **************
// *   Close    *
// **************






procedure TForm_Debugger.FormClose(Sender: TObject;
                                   var CloseAction: TCloseAction);
begin

  Form_RP.DBG_Left:=Left;
  Form_RP.DBG_Top:=Top;
  sichere_checked_Liste;

end; { procedure TForm_Debugger.FormClose }



procedure TForm_Debugger.FormDestroy(Sender: TObject);
begin

  Form_RP.DBG_Left:=Left;
  Form_RP.DBG_Top:=Top;
  sichere_checked_Liste;

end; { procedure TForm_Debugger.FormDestroy }






end.

