



// ****************************************************
// ** Einlesen des ATMEGA - Arrays
// ****************************************************






procedure TForm_Device.Read_ATMEGA_Array;
var
  PA_Read_active : Boolean;
  PA_List : TStringList;
  PA_List_counter : Integer;
  PA_Line : String;
  PA_counter : Integer;
  one_char : Char;
  PA_name : String;



  procedure Read_String_Element(STR3 : String;
                                var ZielFeld : String);
  begin

    if PA_Read_active then begin

      if POS(STR3,PA_Line)=1 then begin

        if Length(PA_Line)>4 then begin
          ZielFeld:=Copy(PA_Line,5,Length(PA_Line));
        end; { if Length(PA_Line)>4 then }

      end; { if POS(STR3,PA_Line)=1 then }

    end; { if PA_Read_active then }

  end; { procedure Read_String_Element }



  procedure Read_Boolean_Element(STR3 : String;
                                 var ZielFeld : Boolean);
  var
    one_char2 : Char;
  begin

    if PA_Read_active then begin

      if POS(STR3,PA_Line)=1 then begin

        if Length(PA_Line)>4 then begin
          one_char2:=PA_Line[5];

          case one_char2 of
            'T' : ZielFeld:=true;
            'F' : ZielFeld:=false;
            'J' : ZielFeld:=true;
            'N' : ZielFeld:=false;
          else
            ZielFeld:=false;
          end;
        end; { if Length(PA_Line)>4 then }

      end; { if POS(STR3,PA_Line)=1 then }

    end; { if PA_Read_active then }

  end; { procedure Read_Boolean_Element }



  procedure Read_INT_Element(STR3 : String;
                             var ZielFeld : Integer);
  begin

    if PA_Read_active then begin

      if POS(STR3,PA_Line)=1 then begin

        if Length(PA_Line)>4 then begin
          ZielFeld:=StrToInt(Copy(PA_Line,5,Length(PA_Line)));
        end; { if Length(PA_Line)>4 then }

      end; { if POS(STR3,PA_Line)=1 then }

    end; { if PA_Read_active then }

  end; { procedure Read_INT_Element }




begin

  PA_name:=Form_RP.ronpas_path+'\'+atmega_path+'\'+atmega_array_name;

  if FileExists(PA_name) then begin


    for PA_counter:=0 to Length_ATMEGA_Array do begin

      ATMEGA_Array[PA_counter].Bezeichner:='';
      ATMEGA_Array[PA_counter].RONPAS_name:='';
      ATMEGA_Array[PA_counter].AVRDUDE_name:='';
      ATMEGA_Array[PA_counter].INC_name:='';
      ATMEGA_Array[PA_counter].REG_name:='';
      ATMEGA_Array[PA_counter].Image_name:='';
      ATMEGA_Array[PA_counter].PDF_name:='';
      ATMEGA_Array[PA_counter].Fuses_name:='';
      ATMEGA_Array[PA_counter].Device_Signature:='';

      ATMEGA_Array[PA_counter].ASM_Switch.JMP_Sprungdistanz:=JMP_nicht_definiert;
      ATMEGA_Array[PA_counter].ASM_Switch.LPM_erweitern_auf_ELPM:=false;
      ATMEGA_Array[PA_counter].ASM_Switch.use_MOVW:=false;
      ATMEGA_Array[PA_counter].ASM_Switch.use_SPH:=false;

      ATMEGA_Array[PA_counter].ISR_LISTE_max_Anzahl:=0;



    end; { for PA_counter:=0 to Length_ATMEGA_Array do }

    PA_List := TStringList.Create;
    PA_List.LoadFromFile(PA_name);

    PA_Read_active:=true;

    ATMEGA_Array_Counter:=0;

    for PA_List_counter:=0 to PA_List.Count-1 do begin

      PA_Line:=PA_List[PA_List_counter];

      if PA_Read_active then begin

        // Bezeichner fuer ComboBox
        if POS('BEZ',PA_Line)=1 then begin

          Inc(ATMEGA_Array_Counter);
          if (ATMEGA_Array_Counter>0) and (ATMEGA_Array_Counter<Length_ATMEGA_Array) then begin

            if Length(PA_Line)>4 then begin
              ATMEGA_Array[ATMEGA_Array_Counter-1].Bezeichner:=Copy(PA_Line,5,Length(PA_Line));

            end; { if Length(PA_Line)>4 then }

          end
          else begin
            PA_Read_active:=false;
          end;

        end; { if POS('BEZ',PA_Line)=1 then }

      end; { if PA_Read_active then }

      Read_String_Element('PAS',ATMEGA_Array[ATMEGA_Array_Counter-1].RONPAS_name);
      Read_String_Element('DUD',ATMEGA_Array[ATMEGA_Array_Counter-1].AVRDUDE_name);
      Read_String_Element('INC',ATMEGA_Array[ATMEGA_Array_Counter-1].INC_name);
      Read_String_Element('REG',ATMEGA_Array[ATMEGA_Array_Counter-1].REG_name);
      Read_String_Element('IMG',ATMEGA_Array[ATMEGA_Array_Counter-1].Image_Name);
      Read_String_Element('PDF',ATMEGA_Array[ATMEGA_Array_Counter-1].PDF_name);
      Read_String_Element('FUS',ATMEGA_Array[ATMEGA_Array_Counter-1].Fuses_name);
      Read_String_Element('SIG',ATMEGA_Array[ATMEGA_Array_Counter-1].Device_Signature);


      // JMP_Sprungdistanz
      if PA_Read_active then begin

        // AVRDUDE_Param
        if POS('JMP',PA_Line)=1 then begin

          if Length(PA_Line)>4 then begin

            one_char:=PA_Line[5];

            case one_char of
              'R' : ATMEGA_Array[ATMEGA_Array_Counter-1].ASM_Switch.JMP_Sprungdistanz:=JMP_Relativ;
              'W' : ATMEGA_Array[ATMEGA_Array_Counter-1].ASM_Switch.JMP_Sprungdistanz:=JMP_Word;
              'E' : ATMEGA_Array[ATMEGA_Array_Counter-1].ASM_Switch.JMP_Sprungdistanz:=JMP_als_EIJMP;
            else
              ATMEGA_Array[ATMEGA_Array_Counter-1].ASM_Switch.JMP_Sprungdistanz:=JMP_nicht_definiert;
            end;

          end; { if Length(PA_Line)>4 then }

        end; { if POS('JMP',PA_Line)=1 then }

      end; { if PA_Read_active then }



      // ASM_Switch LPM_erweitern_auf_ELPM
      Read_Boolean_Element('LPM',ATMEGA_Array[ATMEGA_Array_Counter-1].ASM_Switch.LPM_erweitern_auf_ELPM);
      // ASM_Switch use_MOVW
      Read_Boolean_Element('MOV',ATMEGA_Array[ATMEGA_Array_Counter-1].ASM_Switch.use_MOVW);
      // ASM_Switch SPH
      Read_Boolean_Element('SPH',ATMEGA_Array[ATMEGA_Array_Counter-1].ASM_Switch.use_SPH);
      // ASM_Switch MUL
      Read_Boolean_Element('MUL',ATMEGA_Array[ATMEGA_Array_Counter-1].ASM_Switch.use_MUL);


      // ISR_LISTE_max_Anzahl
      Read_INT_Element('ILA',ATMEGA_Array[ATMEGA_Array_Counter-1].ISR_LISTE_max_Anzahl);


      if PA_Read_active then begin

        // Ende
        if POS('END',PA_Line)=1 then begin

          PA_Read_active:=false;

        end; { if POS('COM',PA_Line)=1 then }

      end; { if PA_Read_active then }


    end; { for PA_Line_counter:=0 to PA_List.Count-1 do }

  end
  else begin

    ListBox_Meldungen.Items.Add('*** Fehler: Datei <'+PA_name+'> nicht gefunden');

  end; { if FileExists('Prommer_Array.txt') then }


  if ATMEGA_Array_Counter>0 then
    ListBox_Meldungen.Items.Add('... es wurden '+
                 IntToStr(ATMEGA_Array_Counter)+' ATmega-Typen eingelesen')
  else
    ListBox_Meldungen.Items.Add('*** Fehler: es wurden keine ATmega-Typen eingelesen');


end; { procedure TForm_Prommer.Read_ATMEGA_Array }














