unit Main_Unit;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, ExtCtrls,
  StdCtrls, Menus, ComCtrls,  SynEdit, SynEditTypes,
  SynHighlighterAny, Windows, IniFiles, LCLProc, Buttons,
  SynEditMarks, Types, dateutils,

  Modul_Compiler, Modul_Scanner, Modul_Parser, Modul_Assembler, ZwischenCode,
  CompilerDeklarationen, Einstellungen_Unit,
  Neu_Form, Debugger_Form, Device_Form, Prommer_Form;


const
  source_ext='.pas';
  caption_text='RONPAS64 - Version 1.5 - ';


  html_path = 'rp_html';
  start_page_name = 'index.htm';
  html_start_page = html_path + '\' + start_page_name;

  help_index_name = 'help_index.txt';
  help_start_page = html_path + '\' + help_index_name;

  ic_grau  = 1;
  ic_gelb  = 2;
  ic_gruen = 3;
  ic_rot   = 4;


type

  { TForm_RP }

  Fehler_class = class(TObject)
  public
    { public declarations }
    gemeldet : Boolean;
    Text, Modul : String;
    Datei_Nr, ZeilenNr, SpaltenNr : Integer;
    procedure Registrieren(F_Modul, F_Text : String;
                           F_Datei, F_Zeile, F_Spalte : Integer);
  private
    { private declarations }
    procedure Ausgeben;
  end;


  TForm_RP = class(TForm)
    BitBtn_Suchen_und_Ersetzen: TBitBtn;
    BitBtn_Suchen: TBitBtn;
    Edit_Ersetzen: TEdit;
    Edit_Suchen: TEdit;
    Image_COMPILE_rot: TImage;
    Image_COMPILE_gelb: TImage;
    Image_COMPILE_gruen: TImage;
    ImageList3: TImageList;
    Image_COMPILE_grau: TImage;
    ImageList1: TImageList;
    ImageList2: TImageList;
    Label3: TLabel;
    Label4: TLabel;
    ListBox_Meldungen: TListBox;
    Panel2: TPanel;
    OpenDialog_Datei_oeffnen: TOpenDialog;
    PageControl1: TPageControl;
    Panel1: TPanel;
    Panel3: TPanel;
    Splitter1: TSplitter;
    SynAnySyn_PAS: TSynAnySyn;
    SynEdit_PAS: TSynEdit;
    SynEdit_INC20: TSynEdit;
    SynEdit_INC19: TSynEdit;
    SynEdit_INC18: TSynEdit;
    SynEdit_INC17: TSynEdit;
    SynEdit_INC16: TSynEdit;
    SynEdit_INC15: TSynEdit;
    SynEdit_INC14: TSynEdit;
    SynEdit_INC13: TSynEdit;
    SynEdit_INC12: TSynEdit;
    SynEdit_INC11: TSynEdit;
    SynEdit_INC10: TSynEdit;
    SynEdit_INC9: TSynEdit;
    SynEdit_INC8: TSynEdit;
    SynEdit_INC7: TSynEdit;
    SynEdit_INC6: TSynEdit;
    SynEdit_INC5: TSynEdit;
    SynEdit_INC4: TSynEdit;
    SynEdit_INC3: TSynEdit;
    SynEdit_INC2: TSynEdit;
    SynEdit_INC1: TSynEdit;
    SynEdit_TRC: TSynEdit;
    SynEdit_ASM: TSynEdit;
    SynAnySyn_ASM: TSynAnySyn;
    SynAnySyn_LST: TSynAnySyn;
    TabSheet_INC20: TTabSheet;
    TabSheet_INC19: TTabSheet;
    TabSheet_INC18: TTabSheet;
    TabSheet_INC17: TTabSheet;
    TabSheet_INC16: TTabSheet;
    TabSheet_INC15: TTabSheet;
    TabSheet_INC14: TTabSheet;
    TabSheet_INC13: TTabSheet;
    TabSheet_INC12: TTabSheet;
    TabSheet_INC11: TTabSheet;
    TabSheet_INC10: TTabSheet;
    TabSheet_INC9: TTabSheet;
    TabSheet_INC8: TTabSheet;
    TabSheet_INC7: TTabSheet;
    TabSheet_INC6: TTabSheet;
    TabSheet_PAS: TTabSheet;
    TabSheet_ASM: TTabSheet;
    TabSheet_TRC: TTabSheet;
    TabSheet_INC5: TTabSheet;
    TabSheet_INC4: TTabSheet;
    TabSheet_INC3: TTabSheet;
    TabSheet_INC2: TTabSheet;
    TabSheet_INC1: TTabSheet;
    ToolBar1: TToolBar;
    ToolButton1: TToolButton;
    ToolButton10: TToolButton;
    ToolButton3: TToolButton;
    ToolButton_Device: TToolButton;
    ToolButton8: TToolButton;
    ToolButton_Debugger: TToolButton;
    ToolButton_Einstellungen: TToolButton;
    ToolButton_Compile_and_Run: TToolButton;
    ToolButton_Prommer: TToolButton;
    ToolButton_Datei_oeffnen: TToolButton;
    ToolButton6: TToolButton;
    ToolButton_Hilfe: TToolButton;
    ToolButton_Datei_neu: TToolButton;
    ToolButton_Speichern: TToolButton;
    ToolButton_Compilieren: TToolButton;
    ToolButton_Beenden: TToolButton;
    procedure BitBtn_SuchenClick(Sender: TObject);
    procedure BitBtn_Suchen_und_ErsetzenClick(Sender: TObject);
    procedure Button_DebuggerClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure ListBox_MeldungenDrawItem(Control: TWinControl; Index: Integer;
                                        ARect: TRect; State: TOwnerDrawState);
    procedure MenuItem_Dat_BeendenClick(Sender: TObject);
    procedure MenuItem_Dat_NeuClick(Sender: TObject);
    procedure MenuItem_Dat_OeffnenClick(Sender: TObject);
    procedure MenuItem_Dat_SpeichernClick(Sender: TObject);
    procedure MenuItem_EinstellungenClick(Sender: TObject);
    procedure MenuItem_HilfeClick(Sender: TObject);
    procedure MenuItem_Start_Compile_and_RunClick(Sender: TObject);
    procedure MenuItem_Start_KompilierenClick(Sender: TObject);
    procedure MenuItem_Start_ProgrammierenClick(Sender: TObject);
    procedure PageControl1Change(Sender: TObject);
    procedure SynEdit_PASGutterClick(Sender: TObject; X, Y, Line: integer;
                                     mark: TSynEditMark);
    procedure SynEdit_PASKeyDown(Sender: TObject; var Key: Word;
                                 Shift: TShiftState);
    procedure ToolButton_DebuggerClick(Sender: TObject);
    procedure ToolButton_DeviceClick(Sender: TObject);
    procedure ToolButton_EinstellungenClick(Sender: TObject);
    procedure ToolButton_Compile_and_RunClick(Sender: TObject);
    procedure ToolButton_Datei_oeffnenClick(Sender: TObject);
    procedure ToolButton_BeendenClick(Sender: TObject);
    procedure ToolButton_CompilierenClick(Sender: TObject);
    procedure ToolButton_Datei_neuClick(Sender: TObject);
    procedure ToolButton_HilfeClick(Sender: TObject);
    procedure ToolButton_PrommerClick(Sender: TObject);
    procedure ToolButton_SpeichernClick(Sender: TObject);

  private
    { private declarations }
    IniFile: TIniFile;
    INI_Datei_Name : String;
    Memo_Zeile, Memo_Spalte : Integer;
    Hilfe_Datenbank_eingelesen : Boolean;
    HD_Keyword, HD_HTML_Seite : TStringList;
    Color_List : Array [0..Length_Color_List] of TColor;



    procedure Hilfe_Datenbank_einlesen;
    procedure Hilfe_anzeigen;
    procedure Datei_oeffnen;
    procedure Kompilieren;
    procedure ARRAY_Zeilen_markieren;
    procedure Add_Gutter(AG_ZeiNr, AG_ImageIndex : Integer);
    procedure Remove_Gutter(AG_ZeiNr, AG_ImageIndex : Integer);

  public
    { public declarations }
    source_path, source_name,
    ronpas_path, Port_Name, Port_Typ : String;
    CheckBox_TRC_Datei, CheckBox_LOG_Dateien,
    Neue_Datei_OK : Boolean;
    CB_FontGroesse,
    CB_Meldungen_FontGroesse : Integer;

    CB_Device_Index, CB_Board_Index, CB_Prommer_Index : Integer;
    CB_PageControl_Index : Integer;

    DBG_Left, DBG_Top : Integer;
    DBG_ComPort : String;
    DBG_Index_BaudRate : Integer;
    function Read_Source_name : String;
    procedure INC_TAB_anzeigen(TAB_Nummer : Integer);
    procedure INC_Datei_laden(TAB_Nummer : Integer);
    procedure INC_Dateien_Sichern;
    procedure INC_Dateien_Sichern_und_Schliessen;
    procedure Source_laden;
    procedure ComboBox_FontGroesse_aendern;
    procedure ComboBox_Meldungen_FontGroesse_aendern;
    procedure Zeile_in_SynEdit_markieren(DateiReiterNr, ZeilenNr : Integer;
                                         var Zeile : String);
    procedure Add_Item_ASMType(AI_Text : String;
                               AI_ASM_Typ : ASM_type_Typ);
    procedure ListBox_Meldungen_Add_Item_Color(AI_Text : String;
                                               AI_Color : TColor);
    procedure ListBox_Meldungen_Clear;
    procedure Image_COMPILE(Farb_Bitmap : Integer);

  end; { TForm_RP = class(TForm) }



var
  Form_RP: TForm_RP;
  Fehler_cl : Fehler_class;

implementation



{$R *.lfm}

{ TForm_RP }



procedure TForm_RP.FormCreate(Sender: TObject);
var
  p_pos{, FC_counter} : Integer;
  Zeile : String;
  SI_Unter : SI_Unter_Typ;
  RW_Bezeichner : RW_Bez;
  Keyword_Liste : TStringList;
begin

  Fehler_cl := Fehler_class.Create;
  Fehler_cl.gemeldet:=False;

  Scanner_cl := Scanner_class.Create;
  Parser_cl := Parser_class.Create;
  Compiler_cl := Compiler_class.Create;
  ZWC_cl := ZWC_class.Create;
  Assembler_cl := Assembler_class.Create;

  SynEdit_PAS.Lines.Clear;
  SynEdit_ASM.Lines.Clear;
  SynEdit_TRC.Lines.Clear;

  ListBox_Meldungen_Clear;

  ListBox_Meldungen_Add_Item_Color('RONPAS wurde gestartet ...',cl_dunkel_gruen);

  ronpas_path:=ExtractFileDir(ParamStr(0));



  OpenDialog_Datei_oeffnen.Filter:='RONPAS-Dateien|*.pas|alle Dateien|*.*';
  OpenDialog_Datei_oeffnen.InitialDir:=ronpas_path;

  INI_Datei_Name:=ronpas_path+'\'+'RONPAS.ini';
  IniFile := TIniFile.Create(INI_Datei_Name);

  if FileExists(INI_Datei_Name) then begin
    source_path:=IniFile.ReadString('SYSTEM','source_path','');
    source_name:=IniFile.ReadString('SYSTEM','source_name','');

    Zeile:=ParamStr(1);
    if Length(Zeile)>0 then begin
      source_path:=ExtractFileDir(Zeile);
      Zeile:=ChangeFileExt(Zeile, '');
      source_name:=ExtractFileName(Zeile);
                   {
      Edit_Suchen.Text:=ParamStr(0);
      Edit_Ersetzen.Text:=Zeile;
                }
    end;

    Label3.Caption:='Quell-Pfad: '+source_path;
    CheckBox_TRC_Datei:=IniFile.ReadBool('SYSTEM','TRC_Datei_erzeugen',false);
    CheckBox_LOG_Dateien:=IniFile.ReadBool('SYSTEM','LOG_Dateien_erzeugen',false);

    // IDE
    Left:=IniFile.ReadInteger('IDE','Left',200);
    Top:=IniFile.ReadInteger('IDE','Top',100);
    Width:=IniFile.ReadInteger('IDE','Width',200);
    Height:=IniFile.ReadInteger('IDE','Height',300);
    PageControl1.Height:=IniFile.ReadInteger('IDE','PageControl1_Height',Height-50);
    CB_FontGroesse:=IniFile.ReadInteger('IDE', 'Item_Index_FontGroesse', 1);
    CB_Meldungen_FontGroesse:=IniFile.ReadInteger('IDE', 'Item_Index_Meldungen_FontGroesse', 1);

    // Device
    CB_Device_Index:=IniFile.ReadInteger('Device', 'Device_Index', 0);
    CB_Board_Index:=IniFile.ReadInteger('Device', 'Board_Index', 0);

    // Prommer
    CB_Prommer_Index:=IniFile.ReadInteger('Prommer', 'Prommer_Index', 1);
    Port_Name:=IniFile.ReadString('Prommer','Port_Name','');
    Port_Typ:=IniFile.ReadString('Prommer','Port_Typ','');
    CB_PageControl_Index:=IniFile.ReadInteger('Prommer', 'PageControl_Index', 1);

    // Debugger
    DBG_Left:=IniFile.ReadInteger('Debugger','Left',200);
    DBG_Top:=IniFile.ReadInteger('Debugger','Top',100);
    DBG_ComPort:=IniFile.ReadString('Debugger','ComPort','COM1');
    DBG_Index_BaudRate:=IniFile.ReadInteger('Debugger','Index_BaudRate',1);



  end
  else begin
    if OpenDialog_Datei_oeffnen.Execute then begin

      source_path:=ExtractFileDir(OpenDialog_Datei_oeffnen.FileName);
      source_name:=ExtractFileName(OpenDialog_Datei_oeffnen.FileName);
      p_pos:=Pos('.',source_name);
      if p_pos>0 then
        source_name:=copy(source_name,1,p_pos-1);

    end;
  end;




  Source_laden;

  SynEdit_ASM.Lines.Clear;
  SynEdit_TRC.Lines.Clear;


  Keyword_Liste := TStringList.Create;
  Keyword_Liste.Sorted:=true;

  for SI_Unter:=kein_UT to UT_ende do begin
    Zeile:=Compiler_cl.UnterTyp_in_Bezeichner(SI_Unter);
    Zeile:=copy(Zeile,2,Length(Zeile)-2);
    Zeile:=Uppercase(Zeile);
    if Zeile<>'** Fehler (UT) **' then begin
      Keyword_Liste.Add(Zeile);
    end;

  end;

  SynAnySyn_LST.KeyWords.Clear;

  for p_pos:=0 to Keyword_Liste.Count-1 do begin
    Zeile:=Keyword_Liste[p_pos];
    SynAnySyn_LST.KeyWords.Add(Zeile);
  end;

  Keyword_Liste.Free;


  Keyword_Liste := TStringList.Create;
  Keyword_Liste.Sorted:=true;

  for RW_Bezeichner:=RB_keiner to RB_Ende do begin
    Zeile:=Compiler_cl.RW_Bez_To_String(RW_Bezeichner);
    Zeile:=copy(Zeile,2,Length(Zeile)-2);
    Zeile:=Uppercase(Zeile);
    if Zeile<>'*** Fehler *** Bez_To_String Eintrag fehlt -' then begin
      Keyword_Liste.Add(Zeile);
    end;

  end;

  SynAnySyn_LST.Objects.Clear;

  for p_pos:=0 to Keyword_Liste.Count-1 do begin
    Zeile:=Keyword_Liste[p_pos];
    SynAnySyn_LST.Objects.Add(Zeile);
  end;

  Keyword_Liste.Free;


  Keyword_Liste := TStringList.Create;
  Keyword_Liste.Sorted:=true;

  for p_pos:=1 to LEN_BEZ_CONST do begin
    Zeile:=CompilerDeklarationen.BEZ_CONST[p_pos].bezeichner;
    Keyword_Liste.Add(Zeile);
  end;

  SynAnySyn_PAS.KeyWords.Clear;

  for p_pos:=0 to Keyword_Liste.Count-1 do begin
    Zeile:=Keyword_Liste[p_pos];
    SynAnySyn_PAS.KeyWords.Add(Zeile);
  end;

  Keyword_Liste.Free;


  // Include TabSheets
  TabSheet_INC1.TabVisible:=false;
  TabSheet_INC2.TabVisible:=false;
  TabSheet_INC3.TabVisible:=false;
  TabSheet_INC4.TabVisible:=false;
  TabSheet_INC5.TabVisible:=false;
  TabSheet_INC6.TabVisible:=false;
  TabSheet_INC7.TabVisible:=false;
  TabSheet_INC8.TabVisible:=false;
  TabSheet_INC9.TabVisible:=false;
  TabSheet_INC10.TabVisible:=false;

  TabSheet_INC11.TabVisible:=false;
  TabSheet_INC12.TabVisible:=false;
  TabSheet_INC13.TabVisible:=false;
  TabSheet_INC14.TabVisible:=false;
  TabSheet_INC15.TabVisible:=false;
  TabSheet_INC16.TabVisible:=false;
  TabSheet_INC17.TabVisible:=false;
  TabSheet_INC18.TabVisible:=false;
  TabSheet_INC19.TabVisible:=false;
  TabSheet_INC20.TabVisible:=false;

  if CheckBox_TRC_Datei then begin
    TabSheet_TRC.TabVisible:=true;
  end
  else begin
    TabSheet_TRC.TabVisible:=false;
  end;

  SynEdit_PAS.CaretX:=IniFile.ReadInteger('IDE','CaretX',1);
  SynEdit_PAS.CaretY:=IniFile.ReadInteger('IDE','CaretY',1);

  PageControl1.ActivePage:=TabSheet_PAS;

  Hilfe_Datenbank_eingelesen:=false;
  HD_Keyword := TStringList.Create;
  HD_HTML_Seite := TStringList.Create;


  Image_COMPILE(ic_grau);



end; { procedure TForm_RP.FormCreate }








procedure TForm_RP.FormShow(Sender: TObject);
begin
  SynEdit_PAS.SetFocus;
end; { procedure TForm_RP.FormShow }





procedure TForm_RP.FormPaint(Sender: TObject);
begin

  if PageControl1.ActivePage=TabSheet_PAS then begin
    SynEdit_PAS.SetFocus;
  end;

  if PageControl1.ActivePage=TabSheet_ASM then begin
    SynEdit_ASM.SetFocus;
  end;

  if PageControl1.ActivePage=TabSheet_TRC then begin
    SynEdit_TRC.SetFocus;
  end;

  if PageControl1.ActivePage=TabSheet_INC1 then begin
    SynEdit_INC1.SetFocus;
  end;

  if PageControl1.ActivePage=TabSheet_INC2 then begin
    SynEdit_INC2.SetFocus;
  end;

  if PageControl1.ActivePage=TabSheet_INC3 then begin
    SynEdit_INC3.SetFocus;
  end;

  if PageControl1.ActivePage=TabSheet_INC4 then begin
    SynEdit_INC4.SetFocus;
  end;

  if PageControl1.ActivePage=TabSheet_INC5 then begin
    SynEdit_INC5.SetFocus;
  end;

  if PageControl1.ActivePage=TabSheet_INC6 then begin
    SynEdit_INC6.SetFocus;
  end;

  if PageControl1.ActivePage=TabSheet_INC7 then begin
    SynEdit_INC7.SetFocus;
  end;

  if PageControl1.ActivePage=TabSheet_INC8 then begin
    SynEdit_INC8.SetFocus;
  end;



  if PageControl1.ActivePage=TabSheet_INC9 then begin
    SynEdit_INC9.SetFocus;
  end;

  if PageControl1.ActivePage=TabSheet_INC10 then begin
    SynEdit_INC10.SetFocus;
  end;

  if PageControl1.ActivePage=TabSheet_INC11 then begin
    SynEdit_INC11.SetFocus;
  end;

  if PageControl1.ActivePage=TabSheet_INC12 then begin
    SynEdit_INC12.SetFocus;
  end;

  if PageControl1.ActivePage=TabSheet_INC13 then begin
    SynEdit_INC13.SetFocus;
  end;

  if PageControl1.ActivePage=TabSheet_INC14 then begin
    SynEdit_INC14.SetFocus;
  end;

  if PageControl1.ActivePage=TabSheet_INC15 then begin
    SynEdit_INC15.SetFocus;
  end;

  if PageControl1.ActivePage=TabSheet_INC16 then begin
    SynEdit_INC16.SetFocus;
  end;

  if PageControl1.ActivePage=TabSheet_INC17 then begin
    SynEdit_INC17.SetFocus;
  end;

  if PageControl1.ActivePage=TabSheet_INC18 then begin
    SynEdit_INC18.SetFocus;
  end;

  if PageControl1.ActivePage=TabSheet_INC19 then begin
    SynEdit_INC19.SetFocus;
  end;

  if PageControl1.ActivePage=TabSheet_INC20 then begin
    SynEdit_INC20.SetFocus;
  end;


end; { procedure TForm_RP.FormPaint }





{ ***** Hilfs-Module ***** }






procedure TForm_RP.Source_laden;
var
  source_pne{, Zeile} : String;

begin
  { Source laden }

  source_pne:=source_path+'\'+source_name+source_ext;

  if FileExists(source_pne) then begin

    SynEdit_PAS.Lines.LoadFromFile(source_pne);

  end
  else begin
    ListBox_Meldungen_Add_Item_Color('Datei: '+source_pne+' nicht gefunden ...',
                                     cl_dunkel_blau);
  end;

  Caption:=caption_text+source_name+source_ext;

  Label3.Caption:='Quell-Pfad: '+source_path;

end; { procedure TForm_RP.Source_laden }





function TForm_RP.Read_Source_name : String;
begin
  Result:=source_path+'\'+source_name+source_ext;
end; { function Source_name }








procedure TForm_RP.INC_TAB_anzeigen(TAB_Nummer : Integer);
begin
  case TAB_Nummer of

     2 : TabSheet_INC1.TabVisible:=true;
     3 : TabSheet_INC2.TabVisible:=true;
     4 : TabSheet_INC3.TabVisible:=true;
     5 : TabSheet_INC4.TabVisible:=true;
     6 : TabSheet_INC5.TabVisible:=true;
     7 : TabSheet_INC6.TabVisible:=true;
     8 : TabSheet_INC7.TabVisible:=true;
     9 : TabSheet_INC8.TabVisible:=true;
    10 : TabSheet_INC9.TabVisible:=true;
    11 : TabSheet_INC10.TabVisible:=true;
    12 : TabSheet_INC11.TabVisible:=true;
    13 : TabSheet_INC12.TabVisible:=true;
    14 : TabSheet_INC13.TabVisible:=true;
    15 : TabSheet_INC14.TabVisible:=true;
    16 : TabSheet_INC15.TabVisible:=true;
    17 : TabSheet_INC16.TabVisible:=true;
    18 : TabSheet_INC17.TabVisible:=true;
    19 : TabSheet_INC18.TabVisible:=true;
    20 : TabSheet_INC19.TabVisible:=true;
    21 : TabSheet_INC20.TabVisible:=true;

  end; { case TAB_Nummer of }
end; { procedure TForm_RP.INC_TAB_anzeigen }





procedure TForm_RP.INC_Datei_laden(TAB_Nummer : Integer);
var
  DateiName, DateiPfad : String;
begin
  DateiName:=Compiler_cl.INCLUDE_LIST[TAB_Nummer].Name;
  DateiPfad:=Compiler_cl.INCLUDE_LIST[TAB_Nummer].Pfad;
  case TAB_Nummer of
    2 : begin
          SynEdit_INC1.Lines.LoadFromFile(DateiPfad+'\'+DateiName);
          TabSheet_INC1.Caption:=DateiName;
        end;
    3 : begin
          SynEdit_INC2.Lines.LoadFromFile(DateiPfad+'\'+DateiName);
          TabSheet_INC2.Caption:=DateiName;
        end;
    4 : begin
          SynEdit_INC3.Lines.LoadFromFile(DateiPfad+'\'+DateiName);
          TabSheet_INC3.Caption:=DateiName;
        end;
    5 : begin
          SynEdit_INC4.Lines.LoadFromFile(DateiPfad+'\'+DateiName);
          TabSheet_INC4.Caption:=DateiName;
        end;
    6 : begin
          SynEdit_INC5.Lines.LoadFromFile(DateiPfad+'\'+DateiName);
          TabSheet_INC5.Caption:=DateiName;
        end;
    7 : begin
          SynEdit_INC6.Lines.LoadFromFile(DateiPfad+'\'+DateiName);
          TabSheet_INC6.Caption:=DateiName;
        end;
    8 : begin
          SynEdit_INC7.Lines.LoadFromFile(DateiPfad+'\'+DateiName);
          TabSheet_INC7.Caption:=DateiName;
        end;
    9 : begin
          SynEdit_INC8.Lines.LoadFromFile(DateiPfad+'\'+DateiName);
          TabSheet_INC8.Caption:=DateiName;
        end;
    10 : begin
          SynEdit_INC9.Lines.LoadFromFile(DateiPfad+'\'+DateiName);
          TabSheet_INC9.Caption:=DateiName;
        end;
    11 : begin
          SynEdit_INC10.Lines.LoadFromFile(DateiPfad+'\'+DateiName);
          TabSheet_INC10.Caption:=DateiName;
        end;
    12 : begin
          SynEdit_INC11.Lines.LoadFromFile(DateiPfad+'\'+DateiName);
          TabSheet_INC11.Caption:=DateiName;
        end;
    13 : begin
          SynEdit_INC12.Lines.LoadFromFile(DateiPfad+'\'+DateiName);
          TabSheet_INC12.Caption:=DateiName;
        end;
    14 : begin
          SynEdit_INC13.Lines.LoadFromFile(DateiPfad+'\'+DateiName);
          TabSheet_INC13.Caption:=DateiName;
        end;
    15 : begin
          SynEdit_INC14.Lines.LoadFromFile(DateiPfad+'\'+DateiName);
          TabSheet_INC14.Caption:=DateiName;
        end;
    16 : begin
          SynEdit_INC15.Lines.LoadFromFile(DateiPfad+'\'+DateiName);
          TabSheet_INC15.Caption:=DateiName;
        end;
    17 : begin
          SynEdit_INC16.Lines.LoadFromFile(DateiPfad+'\'+DateiName);
          TabSheet_INC16.Caption:=DateiName;
        end;
    18 : begin
          SynEdit_INC17.Lines.LoadFromFile(DateiPfad+'\'+DateiName);
          TabSheet_INC17.Caption:=DateiName;
        end;
    19 : begin
          SynEdit_INC18.Lines.LoadFromFile(DateiPfad+'\'+DateiName);
          TabSheet_INC18.Caption:=DateiName;
        end;

    20 : begin
          SynEdit_INC19.Lines.LoadFromFile(DateiPfad+'\'+DateiName);
          TabSheet_INC19.Caption:=DateiName;
        end;
    21 : begin
          SynEdit_INC20.Lines.LoadFromFile(DateiPfad+'\'+DateiName);
          TabSheet_INC20.Caption:=DateiName;
        end;

  end; { case TAB_Nummer of }
end; { procedure TForm_RP.INC_Datei_laden }










procedure TForm_RP.INC_Dateien_Sichern;
var
  INC_Zaehler : Cardinal;
  DateiName, DateiPfad : String;
begin

  for INC_Zaehler:=2 to Compiler_cl.INCLUDE_LIST_Zeiger do begin
    if Compiler_cl.INCLUDE_LIST[INC_Zaehler].Datei_eingelesen then begin
      DateiName:=Compiler_cl.INCLUDE_LIST[INC_Zaehler].Name;
      DateiPfad:=Compiler_cl.INCLUDE_LIST[INC_Zaehler].Pfad;
      case INC_Zaehler of
        2  : SynEdit_INC1.Lines.SaveToFile(DateiPfad+'\'+DateiName);
        3  : SynEdit_INC2.Lines.SaveToFile(DateiPfad+'\'+DateiName);
        4  : SynEdit_INC3.Lines.SaveToFile(DateiPfad+'\'+DateiName);
        5  : SynEdit_INC4.Lines.SaveToFile(DateiPfad+'\'+DateiName);
        6  : SynEdit_INC5.Lines.SaveToFile(DateiPfad+'\'+DateiName);
        7  : SynEdit_INC6.Lines.SaveToFile(DateiPfad+'\'+DateiName);
        8  : SynEdit_INC7.Lines.SaveToFile(DateiPfad+'\'+DateiName);
        9  : SynEdit_INC8.Lines.SaveToFile(DateiPfad+'\'+DateiName);
        10 : SynEdit_INC9.Lines.SaveToFile(DateiPfad+'\'+DateiName);
        11 : SynEdit_INC10.Lines.SaveToFile(DateiPfad+'\'+DateiName);
        12 : SynEdit_INC11.Lines.SaveToFile(DateiPfad+'\'+DateiName);
        13 : SynEdit_INC12.Lines.SaveToFile(DateiPfad+'\'+DateiName);
        14 : SynEdit_INC13.Lines.SaveToFile(DateiPfad+'\'+DateiName);
        15 : SynEdit_INC14.Lines.SaveToFile(DateiPfad+'\'+DateiName);
        16 : SynEdit_INC15.Lines.SaveToFile(DateiPfad+'\'+DateiName);
        17 : SynEdit_INC16.Lines.SaveToFile(DateiPfad+'\'+DateiName);
        18 : SynEdit_INC17.Lines.SaveToFile(DateiPfad+'\'+DateiName);
        19 : SynEdit_INC18.Lines.SaveToFile(DateiPfad+'\'+DateiName);
        20 : SynEdit_INC19.Lines.SaveToFile(DateiPfad+'\'+DateiName);
        21 : SynEdit_INC20.Lines.SaveToFile(DateiPfad+'\'+DateiName);

      end; { case INC_Zaehler of }
    end; { if Compiler_cl.INCLUDE_LIST[INCLUDE_LIST_Zeiger].Datei_eingelesen then }

  end; { for INC_Zaehler:=2 to INCLUDE_LIST_Zeiger do }

end; { procedure TForm_RP.INC_Dateien_Sichern }









procedure TForm_RP.INC_Dateien_Sichern_und_Schliessen;
var
  INC_Zaehler : Cardinal;
  DateiName, DateiPfad : String;
begin

  for INC_Zaehler:=2 to Compiler_cl.INCLUDE_LIST_Zeiger do begin
    if Compiler_cl.INCLUDE_LIST[INC_Zaehler].Datei_eingelesen then begin
      DateiName:=Compiler_cl.INCLUDE_LIST[INC_Zaehler].Name;
      DateiPfad:=Compiler_cl.INCLUDE_LIST[INC_Zaehler].Pfad;
      case INC_Zaehler of
        2  : begin
               SynEdit_INC1.Lines.SaveToFile(DateiPfad+'\'+DateiName);
               SynEdit_INC1.Lines.Clear;
               TabSheet_INC1.TabVisible:=false;
             end; { 2 }

        3  : begin
               SynEdit_INC2.Lines.SaveToFile(DateiPfad+'\'+DateiName);
               SynEdit_INC2.Lines.Clear;
               TabSheet_INC2.TabVisible:=false;
             end; { 3 }

        4  : begin
               SynEdit_INC3.Lines.SaveToFile(DateiPfad+'\'+DateiName);
               SynEdit_INC3.Lines.Clear;
               TabSheet_INC3.TabVisible:=false;
             end; { 4 }

        5  : begin
               SynEdit_INC4.Lines.SaveToFile(DateiPfad+'\'+DateiName);
               SynEdit_INC4.Lines.Clear;
               TabSheet_INC4.TabVisible:=false;
             end; { 5 }

        6  : begin
               SynEdit_INC5.Lines.SaveToFile(DateiPfad+'\'+DateiName);
               SynEdit_INC5.Lines.Clear;
               TabSheet_INC5.TabVisible:=false;
             end; { 6 }

        7  : begin
               SynEdit_INC6.Lines.SaveToFile(DateiPfad+'\'+DateiName);
               SynEdit_INC6.Lines.Clear;
               TabSheet_INC6.TabVisible:=false;
             end; { 7 }

        8  : begin
               SynEdit_INC7.Lines.SaveToFile(DateiPfad+'\'+DateiName);
               SynEdit_INC7.Lines.Clear;
               TabSheet_INC7.TabVisible:=false;
             end; { 8 }

        9  : begin
               SynEdit_INC8.Lines.SaveToFile(DateiPfad+'\'+DateiName);
               SynEdit_INC8.Lines.Clear;
               TabSheet_INC8.TabVisible:=false;
             end; { 9 }

        10 : begin
               SynEdit_INC9.Lines.SaveToFile(DateiPfad+'\'+DateiName);
               SynEdit_INC9.Lines.Clear;
               TabSheet_INC9.TabVisible:=false;
             end; { 10 }

        11 : begin
               SynEdit_INC10.Lines.SaveToFile(DateiPfad+'\'+DateiName);
               SynEdit_INC10.Lines.Clear;
               TabSheet_INC10.TabVisible:=false;
             end; { 11 }

        12 : begin
               SynEdit_INC11.Lines.SaveToFile(DateiPfad+'\'+DateiName);
               SynEdit_INC11.Lines.Clear;
               TabSheet_INC11.TabVisible:=false;
             end; { 12 }

        13 : begin
               SynEdit_INC12.Lines.SaveToFile(DateiPfad+'\'+DateiName);
               SynEdit_INC12.Lines.Clear;
               TabSheet_INC12.TabVisible:=false;
             end; { 13 }

        14 : begin
               SynEdit_INC13.Lines.SaveToFile(DateiPfad+'\'+DateiName);
               SynEdit_INC13.Lines.Clear;
               TabSheet_INC13.TabVisible:=false;
             end; { 14 }

        15 : begin
               SynEdit_INC14.Lines.SaveToFile(DateiPfad+'\'+DateiName);
               SynEdit_INC14.Lines.Clear;
               TabSheet_INC14.TabVisible:=false;
             end; { 15 }

        16 : begin
               SynEdit_INC15.Lines.SaveToFile(DateiPfad+'\'+DateiName);
               SynEdit_INC15.Lines.Clear;
               TabSheet_INC15.TabVisible:=false;
             end; { 16 }

        17 : begin
               SynEdit_INC16.Lines.SaveToFile(DateiPfad+'\'+DateiName);
               SynEdit_INC16.Lines.Clear;
               TabSheet_INC16.TabVisible:=false;
             end; { 17 }

        18 : begin
               SynEdit_INC17.Lines.SaveToFile(DateiPfad+'\'+DateiName);
               SynEdit_INC17.Lines.Clear;
               TabSheet_INC17.TabVisible:=false;
             end; { 18 }

        19 : begin
               SynEdit_INC18.Lines.SaveToFile(DateiPfad+'\'+DateiName);
               SynEdit_INC18.Lines.Clear;
               TabSheet_INC18.TabVisible:=false;
             end; { 19 }


        20 : begin
               SynEdit_INC19.Lines.SaveToFile(DateiPfad+'\'+DateiName);
               SynEdit_INC19.Lines.Clear;
               TabSheet_INC19.TabVisible:=false;
             end; { 20 }

        21 : begin
               SynEdit_INC20.Lines.SaveToFile(DateiPfad+'\'+DateiName);
               SynEdit_INC20.Lines.Clear;
               TabSheet_INC20.TabVisible:=false;
             end; { 21 }

      end; { case INC_Zaehler of }
      Compiler_cl.INCLUDE_LIST[INC_Zaehler].Datei_eingelesen:=false;
      Compiler_cl.INCLUDE_LIST[INC_Zaehler].TabSheet_aktiv:=false;
      Compiler_cl.INCLUDE_LIST[INC_Zaehler].Name:='';
      Compiler_cl.INCLUDE_LIST[INC_Zaehler].Pfad:='';
    end; { if Compiler_cl.INCLUDE_LIST[INCLUDE_LIST_Zeiger].Datei_eingelesen then }

  end; { for INC_Zaehler:=2 to INCLUDE_LIST_Zeiger do }
  Compiler_cl.INCLUDE_LIST_Zeiger := 1;

end; { procedure TForm_RP.INC_Dateien_Sichern_und_Schliessen }





procedure TForm_RP.Hilfe_Datenbank_einlesen;
var
  Hilfe_Datenbank, Hilfe_Datenbank2 : TStringList;
  HD_Zaehler : Integer;
  Zeile, HD_Zeile_Keyword, HD_Zeile_HTML_Seite : String;
begin

  HD_Keyword.Clear;
  HD_HTML_Seite.Clear;

  // 1. Sortieren der Hilfe-Datenbank
  // ================================

  Hilfe_Datenbank := TStringList.Create;
  Hilfe_Datenbank2 := TStringList.Create;
  Hilfe_Datenbank2.Sorted:=true;
  HD_Keyword.LoadFromFile(ronpas_path+'\'+help_start_page);


  for HD_Zaehler:=0 to HD_Keyword.Count-1 do begin
    Zeile:=HD_Keyword[HD_Zaehler];
    Zeile:=UpperCase(Zeile);
    while Length(Zeile)<120 do
      Zeile:=Zeile+' ';

    Hilfe_Datenbank2.Add(Zeile);
  end; { for HD_Zaehler:=0 to Hilfe_Datenbank.Count-1 do }

  Hilfe_Datenbank2.SaveToFile(ronpas_path+'\'+help_start_page);

  Hilfe_Datenbank2.Sorted:=false;
  HD_Keyword.Clear;
  Hilfe_Datenbank2.Clear;

  // *****************************

  Hilfe_Datenbank.LoadFromFile(ronpas_path+'\'+help_start_page);

  for HD_Zaehler:=0 to Hilfe_Datenbank.Count-1 do begin
    Zeile:=Hilfe_Datenbank[HD_Zaehler];
    Zeile:=Trim(Zeile);
    Hilfe_Datenbank2.Add(Zeile);
    if Length(Zeile)>25 then begin
      HD_Zeile_Keyword:=Copy(Zeile,1,21);
      HD_Zeile_Keyword:=Trim(HD_Zeile_Keyword);
      HD_Keyword.Add(HD_Zeile_Keyword);
      HD_Zeile_HTML_Seite:=Copy(Zeile,22,Length(Zeile));
      HD_Zeile_HTML_Seite:=Trim(HD_Zeile_HTML_Seite);
      HD_HTML_Seite.Add(HD_Zeile_HTML_Seite);
    end; { if Length(Zeile)>0 then }
  end; { for HD_Zaehler:=0 to Hilfe_Datenbank.Count-1 do }

  Hilfe_Datenbank2.SaveToFile(ronpas_path+'\'+help_start_page);

//  HD_Keyword.SaveToFile('HD_Keyword.txt');
//  HD_HTML_Seite.SaveToFile('HD_HTML_Seite.txt');

  Hilfe_Datenbank.Free;

end; { procedure TForm_RP.Hilfe_Datenbank_einlesen }








procedure TForm_RP.Hilfe_anzeigen;
var
  markierter_Text, URL, Hilfeseite : String;
  SelStart, SelEnd, Laenge_Markierung : Integer;



  procedure Text_To_HTML_Seite;
  var
    Hilfe_Datenbank : TStringList;
    HD_Zaehler : Integer;
    HD_Zeile, HD_Zeile2, Ergebnis : String;
  begin
    Ergebnis:='';
    Hilfe_Datenbank := TStringList.Create;
    Hilfe_Datenbank.LoadFromFile(ronpas_path+'\'+help_start_page);
    for HD_Zaehler:=0 to Hilfe_Datenbank.Count-1 do begin
      HD_Zeile:=Hilfe_Datenbank[HD_Zaehler];
      HD_Zeile2:=Copy(HD_Zeile,1,21);
      HD_Zeile2:=TrimRight(HD_Zeile2);

      if HD_Zeile2=markierter_Text then begin
        Ergebnis:=Copy(HD_Zeile,22,Length(HD_Zeile));

      end; { if HD_Zeile2=mark_Text then }

    end; { for HD_Zaehler:=0 to Hilfe_Datenbank.Count-1 do }
    markierter_Text:=Ergebnis;

  end; { procedure Text_To_HTML_Seite }



begin

  if not Hilfe_Datenbank_eingelesen then begin
    Hilfe_Datenbank_einlesen;
    Hilfe_Datenbank_eingelesen:=true;
    ListBox_Meldungen_Add_Item_Color('... Hilfe_Datenbank wird eingelesen',cl_dunkel_gruen);
  end; { if not Hilfe_Datenbank_eingelesen then }

  SelStart:=SynEdit_PAS.SelStart;
  SelEnd:=SynEdit_PAS.SelEnd;
  Laenge_Markierung:=SelEnd-SelStart;

  if Laenge_Markierung>0 then begin

    markierter_Text:=copy(SynEdit_PAS.Text,SelStart,Laenge_Markierung);

    ListBox_Meldungen_Add_Item_Color('... Text:'+markierter_Text+
                                     ' wird gesucht',cl_dunkel_gruen);

    markierter_Text:=UpperCase(markierter_Text);

    Text_To_HTML_Seite;

    if Length(markierter_Text)>0 then
      Hilfeseite:=ronpas_path+'\'+html_path+'\'+markierter_Text
    else
      Hilfeseite:=ronpas_path+'\'+html_start_page;

  end { if Laenge_Markierung>0 then }
  else begin
    Hilfeseite:=ronpas_path+'\'+html_start_page;
  end;


  URL:='file:///'+Hilfeseite;

  if FileExists(Hilfeseite) then begin

    ListBox_Meldungen_Add_Item_Color('... Browser wird gestartet',cl_dunkel_gruen);

    if (ShellExecute(Handle, 'open', PChar(URL), nil, nil, SW_SHOW) <= 32) then begin

      ShowMessage('Hilfeseite konnte nicht geöffnet werden!');

    end; { if (ShellExecute(Handle, 'open', }
  end
  else
    ShowMessage('Hilfeseite konnte nicht gefunden werden!');



end; { procedure TForm_RP.Hilfe_anzeigen }








{ ***** Fehler-Module ***** }


procedure Fehler_class.Registrieren(F_Modul, F_Text : String;
                                    F_Datei, F_Zeile, F_Spalte : Integer);
begin
  if not Fehler_cl.gemeldet then begin
    Fehler_cl.gemeldet:=True;
    Fehler_cl.Modul:=F_Modul;
    Fehler_cl.Text:=F_Text;
    Fehler_cl.Datei_Nr:=F_Datei;
    Fehler_cl.ZeilenNr:=F_Zeile;
    Fehler_cl.SpaltenNr:=F_Spalte;
  end; { if not Fehler_cl.gemeldet then }
end; { procedure Fehler_class.Registrieren }








procedure TForm_RP.Zeile_in_SynEdit_markieren(DateiReiterNr, ZeilenNr : Integer;
                                              var Zeile : String);



  procedure SynEditSelLine(const Line: Integer; const Synedit: TSynEdit);
  var i, l: Integer;
  begin
    if (Line < Synedit.Lines.Count + 1) and (Line > -1) and (Synedit <> nil) then
    begin
      l := 0;

      for i := -1 to Line -2 do
        inc(l, Length(Synedit.Lines[i]) + 2);

      Synedit.SelStart := l-1;
      Synedit.SelEnd := l + Length(Synedit.Lines[Line-1]);

    end; { if (Line < Synedit.Lines.Count + 1) ... }
  end; { procedure SynEditSelLine }



begin


  if DateiReiterNr=1 then begin

    Form_RP.SynEdit_PAS.CaretY:=ZeilenNr+15;
    SynEditSelLine(ZeilenNr+1,Form_RP.SynEdit_PAS);
    Zeile:=Form_RP.SynEdit_PAS.Lines[ZeilenNr];
    Form_RP.PageControl1.ActivePage:=Form_RP.TabSheet_PAS;

  end
  else begin

    case DateiReiterNr of

      2 : begin
            Form_RP.SynEdit_INC1.CaretY:=ZeilenNr+15;
            SynEditSelLine(ZeilenNr+1,Form_RP.SynEdit_INC1);
            Zeile:=Form_RP.SynEdit_INC1.Lines[ZeilenNr];
            Form_RP.PageControl1.ActivePage:=Form_RP.TabSheet_INC1;
          end; { 2 }

      3 : begin
            Form_RP.SynEdit_INC2.CaretY:=ZeilenNr+15;
            SynEditSelLine(ZeilenNr+1,Form_RP.SynEdit_INC2);
            Zeile:=Form_RP.SynEdit_INC2.Lines[ZeilenNr];
            Form_RP.PageControl1.ActivePage:=Form_RP.TabSheet_INC2;
          end; { 3 }

      4 : begin
            Form_RP.SynEdit_INC3.CaretY:=ZeilenNr+15;
            SynEditSelLine(ZeilenNr+1,Form_RP.SynEdit_INC3);
            Zeile:=Form_RP.SynEdit_INC3.Lines[ZeilenNr];
            Form_RP.PageControl1.ActivePage:=Form_RP.TabSheet_INC3;
          end; { 4 }

      5 : begin
            Form_RP.SynEdit_INC4.CaretY:=ZeilenNr+15;
            SynEditSelLine(ZeilenNr+1,Form_RP.SynEdit_INC4);
            Zeile:=Form_RP.SynEdit_INC4.Lines[ZeilenNr];
            Form_RP.PageControl1.ActivePage:=Form_RP.TabSheet_INC4;
          end; { 5 }

      6 : begin
            Form_RP.SynEdit_INC5.CaretY:=ZeilenNr+15;
            SynEditSelLine(ZeilenNr+1,Form_RP.SynEdit_INC5);
            Zeile:=Form_RP.SynEdit_INC5.Lines[ZeilenNr];
            Form_RP.PageControl1.ActivePage:=Form_RP.TabSheet_INC5;
          end; { 6 }

      7 : begin
            Form_RP.SynEdit_INC6.CaretY:=ZeilenNr+15;
            SynEditSelLine(ZeilenNr+1,Form_RP.SynEdit_INC6);
            Zeile:=Form_RP.SynEdit_INC6.Lines[ZeilenNr];
            Form_RP.PageControl1.ActivePage:=Form_RP.TabSheet_INC6;
          end; { 7 }

      8 : begin
            Form_RP.SynEdit_INC7.CaretY:=ZeilenNr+15;
            SynEditSelLine(ZeilenNr+1,Form_RP.SynEdit_INC7);
            Zeile:=Form_RP.SynEdit_INC7.Lines[ZeilenNr];
            Form_RP.PageControl1.ActivePage:=Form_RP.TabSheet_INC7;
          end; { 8 }

      9 : begin
            Form_RP.SynEdit_INC8.CaretY:=ZeilenNr+15;
            SynEditSelLine(ZeilenNr+1,Form_RP.SynEdit_INC8);
            Zeile:=Form_RP.SynEdit_INC8.Lines[ZeilenNr];
            Form_RP.PageControl1.ActivePage:=Form_RP.TabSheet_INC8;
          end; { 9 }

      10 : begin
            Form_RP.SynEdit_INC9.CaretY:=ZeilenNr+15;
            SynEditSelLine(ZeilenNr+1,Form_RP.SynEdit_INC9);
            Zeile:=Form_RP.SynEdit_INC9.Lines[ZeilenNr];
            Form_RP.PageControl1.ActivePage:=Form_RP.TabSheet_INC9;
          end; { 10 }

      11 : begin
            Form_RP.SynEdit_INC10.CaretY:=ZeilenNr+15;
            SynEditSelLine(ZeilenNr+1,Form_RP.SynEdit_INC10);
            Zeile:=Form_RP.SynEdit_INC10.Lines[ZeilenNr];
            Form_RP.PageControl1.ActivePage:=Form_RP.TabSheet_INC10;
          end; { 11 }

      12 : begin
            Form_RP.SynEdit_INC11.CaretY:=ZeilenNr+15;
            SynEditSelLine(ZeilenNr+1,Form_RP.SynEdit_INC11);
            Zeile:=Form_RP.SynEdit_INC11.Lines[ZeilenNr];
            Form_RP.PageControl1.ActivePage:=Form_RP.TabSheet_INC11;
          end; { 12 }

      13 : begin
            Form_RP.SynEdit_INC12.CaretY:=ZeilenNr+15;
            SynEditSelLine(ZeilenNr+1,Form_RP.SynEdit_INC12);
            Zeile:=Form_RP.SynEdit_INC12.Lines[ZeilenNr];
            Form_RP.PageControl1.ActivePage:=Form_RP.TabSheet_INC12;
          end; { 13 }

      14 : begin
            Form_RP.SynEdit_INC13.CaretY:=ZeilenNr+15;
            SynEditSelLine(ZeilenNr+1,Form_RP.SynEdit_INC13);
            Zeile:=Form_RP.SynEdit_INC13.Lines[ZeilenNr];
            Form_RP.PageControl1.ActivePage:=Form_RP.TabSheet_INC13;
          end; { 14 }

      15 : begin
            Form_RP.SynEdit_INC14.CaretY:=ZeilenNr+15;
            SynEditSelLine(ZeilenNr+1,Form_RP.SynEdit_INC14);
            Zeile:=Form_RP.SynEdit_INC14.Lines[ZeilenNr];
            Form_RP.PageControl1.ActivePage:=Form_RP.TabSheet_INC14;
          end; { 15 }

      16 : begin
            Form_RP.SynEdit_INC15.CaretY:=ZeilenNr+15;
            SynEditSelLine(ZeilenNr+1,Form_RP.SynEdit_INC15);
            Zeile:=Form_RP.SynEdit_INC15.Lines[ZeilenNr];
            Form_RP.PageControl1.ActivePage:=Form_RP.TabSheet_INC15;
          end; { 16 }

      17 : begin
            Form_RP.SynEdit_INC16.CaretY:=ZeilenNr+15;
            SynEditSelLine(ZeilenNr+1,Form_RP.SynEdit_INC16);
            Zeile:=Form_RP.SynEdit_INC16.Lines[ZeilenNr];
            Form_RP.PageControl1.ActivePage:=Form_RP.TabSheet_INC16;
          end; { 17 }

      18 : begin
            Form_RP.SynEdit_INC17.CaretY:=ZeilenNr+15;
            SynEditSelLine(ZeilenNr+1,Form_RP.SynEdit_INC17);
            Zeile:=Form_RP.SynEdit_INC17.Lines[ZeilenNr];
            Form_RP.PageControl1.ActivePage:=Form_RP.TabSheet_INC17;
          end; { 18 }

      19 : begin
            Form_RP.SynEdit_INC18.CaretY:=ZeilenNr+15;
            SynEditSelLine(ZeilenNr+1,Form_RP.SynEdit_INC18);
            Zeile:=Form_RP.SynEdit_INC18.Lines[ZeilenNr];
            Form_RP.PageControl1.ActivePage:=Form_RP.TabSheet_INC18;
          end; { 19 }

      20 : begin
            Form_RP.SynEdit_INC19.CaretY:=ZeilenNr+15;
            SynEditSelLine(ZeilenNr+1,Form_RP.SynEdit_INC19);
            Zeile:=Form_RP.SynEdit_INC19.Lines[ZeilenNr];
            Form_RP.PageControl1.ActivePage:=Form_RP.TabSheet_INC19;
          end; { 20 }

      21 : begin
            Form_RP.SynEdit_INC20.CaretY:=ZeilenNr+15;
            SynEditSelLine(ZeilenNr+1,Form_RP.SynEdit_INC20);
            Zeile:=Form_RP.SynEdit_INC20.Lines[ZeilenNr];
            Form_RP.PageControl1.ActivePage:=Form_RP.TabSheet_INC20;
          end; { 21 }

    end; { case Fehler_cl.Datei_Nr of }

  end; { if Fehler_cl.Datei_Nr=1 then }

end; { procedure TForm_RP.Zeile_in_SynEdit_markieren }









procedure Fehler_class.Ausgeben;
var
  Zeile : String;
  SpaltenZaehler : Integer;

begin
 // Form_RP.ListBox_Meldungen_Clear;

  Form_RP.ListBox_Meldungen_Add_Item_Color('*** Fehler im Modul: '+Fehler_cl.Modul,cl_dunkel_rot);
  Form_RP.ListBox_Meldungen_Add_Item_Color('*** Fehlertext: '+Fehler_cl.Text,cl_dunkel_rot);
  Form_RP.ListBox_Meldungen.Items.Add(' ');

  Form_RP.Zeile_in_SynEdit_markieren(Fehler_cl.Datei_Nr,Fehler_cl.ZeilenNr,
                                     Zeile);

  Form_RP.ListBox_Meldungen_Add_Item_Color(Zeile,cl_dunkel_rot);

  Zeile:='';
  for SpaltenZaehler:=1 to Fehler_cl.SpaltenNr-1 do begin
    Zeile:=Zeile+'-';
  end;
  Zeile:=Zeile+'|';

  Form_RP.ListBox_Meldungen_Add_Item_Color(Zeile,cl_dunkel_braun);

end; { procedure Fehler_class.Ausgeben }




{ ***** Font-Groesse ***** }



procedure TForm_RP.ComboBox_FontGroesse_aendern;
var
  Font_Size : Integer;
begin

  case CB_FontGroesse of
    0 : Font_Size:=10;
    1 : Font_Size:=12;
    2 : Font_Size:=14;
    3 : Font_Size:=16;
    4 : Font_Size:=18;
    5 : Font_Size:=20;
  else
    Font_Size:=14;
  end;

  SynEdit_PAS.Font.Size:=Font_Size;
  SynEdit_ASM.Font.Size:=Font_Size;
  SynEdit_TRC.Font.Size:=Font_Size;

  SynEdit_INC1.Font.Size:=Font_Size;
  SynEdit_INC2.Font.Size:=Font_Size;
  SynEdit_INC3.Font.Size:=Font_Size;
  SynEdit_INC4.Font.Size:=Font_Size;
  SynEdit_INC5.Font.Size:=Font_Size;
  SynEdit_INC6.Font.Size:=Font_Size;
  SynEdit_INC7.Font.Size:=Font_Size;
  SynEdit_INC8.Font.Size:=Font_Size;
  SynEdit_INC9.Font.Size:=Font_Size;
  SynEdit_INC10.Font.Size:=Font_Size;

  SynEdit_INC11.Font.Size:=Font_Size;
  SynEdit_INC12.Font.Size:=Font_Size;
  SynEdit_INC13.Font.Size:=Font_Size;
  SynEdit_INC14.Font.Size:=Font_Size;
  SynEdit_INC15.Font.Size:=Font_Size;
  SynEdit_INC16.Font.Size:=Font_Size;
  SynEdit_INC17.Font.Size:=Font_Size;
  SynEdit_INC18.Font.Size:=Font_Size;
  SynEdit_INC19.Font.Size:=Font_Size;
  SynEdit_INC20.Font.Size:=Font_Size;

  if TabSheet_PAS.TabVisible then begin
    SynEdit_PAS.Refresh;
  end;

  if TabSheet_ASM.TabVisible then begin
    SynEdit_ASM.Refresh;
  end;

  if TabSheet_TRC.TabVisible then begin
    SynEdit_TRC.Refresh;
  end;

  if TabSheet_INC1.TabVisible then begin
    SynEdit_INC1.Refresh;
  end;

  if TabSheet_INC2.TabVisible then begin
    SynEdit_INC2.Refresh;
  end;

  if TabSheet_INC3.TabVisible then begin
    SynEdit_INC3.Refresh;
  end;

  if TabSheet_INC4.TabVisible then begin
    SynEdit_INC4.Refresh;
  end;

  if TabSheet_INC5.TabVisible then begin
    SynEdit_INC5.Refresh;
  end;

  if TabSheet_INC6.TabVisible then begin
    SynEdit_INC6.Refresh;
  end;

  if TabSheet_INC7.TabVisible then begin
    SynEdit_INC7.Refresh;
  end;

  if TabSheet_INC8.TabVisible then begin
    SynEdit_INC8.Refresh;
  end;

  if TabSheet_INC9.TabVisible then begin
    SynEdit_INC9.Refresh;
  end;

  if TabSheet_INC10.TabVisible then begin
    SynEdit_INC10.Refresh;
  end;

  if TabSheet_INC11.TabVisible then begin
    SynEdit_INC11.Refresh;
  end;

  if TabSheet_INC12.TabVisible then begin
    SynEdit_INC12.Refresh;
  end;

  if TabSheet_INC13.TabVisible then begin
    SynEdit_INC13.Refresh;
  end;

  if TabSheet_INC14.TabVisible then begin
    SynEdit_INC14.Refresh;
  end;

  if TabSheet_INC15.TabVisible then begin
    SynEdit_INC15.Refresh;
  end;

  if TabSheet_INC16.TabVisible then begin
    SynEdit_INC16.Refresh;
  end;

  if TabSheet_INC17.TabVisible then begin
    SynEdit_INC17.Refresh;
  end;

  if TabSheet_INC18.TabVisible then begin
    SynEdit_INC18.Refresh;
  end;

  if TabSheet_INC19.TabVisible then begin
    SynEdit_INC19.Refresh;
  end;

  if TabSheet_INC20.TabVisible then begin
    SynEdit_INC20.Refresh;
  end;

end; { procedure TForm_RP.ComboBox_FontGroesse_aendern }









procedure TForm_RP.ComboBox_Meldungen_FontGroesse_aendern;
var
  Font_Size : Integer;
begin

  case CB_Meldungen_FontGroesse of
    0 : Font_Size:=10;
    1 : Font_Size:=12;
    2 : Font_Size:=14;
    3 : Font_Size:=16;
    4 : Font_Size:=18;
    5 : Font_Size:=20;
  else
    Font_Size:=14;
  end;

  ListBox_Meldungen.Font.Size:=Font_Size;
  ListBox_Meldungen.ItemHeight:=Font_Size * 20 div 13;

  ListBox_Meldungen.Refresh;

end; { procedure TForm_RP.ComboBox_FontGroesse_aendern }









procedure TForm_RP.Datei_oeffnen;
var
  p_pos : Integer;
begin
  if OpenDialog_Datei_oeffnen.Execute then begin

    INC_Dateien_Sichern_und_Schliessen;
    source_path:=ExtractFileDir(OpenDialog_Datei_oeffnen.FileName);
    source_name:=ExtractFileName(OpenDialog_Datei_oeffnen.FileName);
    p_pos:=Pos('.',source_name);

    if p_pos>0 then
      source_name:=copy(source_name,1,p_pos-1);


    Source_laden;

  end; { if OpenDialog_Datei_oeffnen.Execute then }

end; { procedure TForm_RP.Datei_oeffnen }





procedure TForm_RP.Kompilieren;
begin

    ListBox_Meldungen.SetFocus;

    ListBox_Meldungen_Clear;
    Fehler_cl.gemeldet:=False;

    Memo_Zeile := Form_RP.SynEdit_PAS.CaretY;
    Memo_Spalte := Form_RP.SynEdit_PAS.CaretX;

    SynEdit_PAS.Lines.SaveToFile(Read_Source_name);
    INC_Dateien_Sichern;

    ZWC_cl.Ruecksetzen;

    Compiler_cl.Start_Compiler;

    if not Fehler_cl.gemeldet then begin
      SynEdit_ASM.Lines.LoadFromFile(source_path+'\'+source_name+'.asm');
    end;

    if CheckBox_TRC_Datei then begin
      SynEdit_TRC.Lines.LoadFromFile(source_path+'\'+source_name+'.par');
    end;

    if Fehler_cl.gemeldet then
      Fehler_cl.Ausgeben;

    SendMessage(ListBox_Meldungen.Handle, LB_SETTOPINDEX, ListBox_Meldungen.Items.Count-1, 0);

end; { procedure TForm_RP.Kompilieren }





{ ***** Menue-Eintraege ***** }


{ Menue-Oeffnen }


procedure TForm_RP.MenuItem_Dat_NeuClick(Sender: TObject);
begin
  // Neu
  Form_Neu.Visible:=true;
end;



procedure TForm_RP.MenuItem_Dat_OeffnenClick(Sender: TObject);
begin
  // Oeffnen
  Datei_oeffnen;
end;


procedure TForm_RP.MenuItem_Dat_SpeichernClick(Sender: TObject);
begin
  // Speichern
  SynEdit_PAS.Lines.SaveToFile(Read_Source_name);
  SynEdit_ASM.Lines.SaveToFile(source_path+'\'+source_name+'.asm');
  SynEdit_TRC.Lines.SaveToFile(source_path+'\'+source_name+'.par');
end; { procedure TForm_RP.MenuItem_Dat_SpeichernClick }




procedure TForm_RP.MenuItem_Dat_BeendenClick(Sender: TObject);
begin
  // Beenden
  Close;
end; { procedure TForm_RP.MenuItem_Dat_BeendenClick }



{ Menue-Start }


procedure TForm_RP.MenuItem_Start_KompilierenClick(Sender: TObject);
begin
  // Kompilieren
  Kompilieren;
end;


procedure TForm_RP.MenuItem_Start_ProgrammierenClick(Sender: TObject);
begin
  // Programmieren
  if not Fehler_cl.gemeldet then begin
    Form_Prommer.Start_Programmer;
    SendMessage(ListBox_Meldungen.Handle, LB_SETTOPINDEX, ListBox_Meldungen.Items.Count-1, 0);
  end;
end; { procedure TForm_RP.MenuItem_Start_ProgrammierenClick }

procedure TForm_RP.PageControl1Change(Sender: TObject);
begin

end;





procedure TForm_RP.MenuItem_Start_Compile_and_RunClick(Sender: TObject);
begin
  // Kompilieren und Programmieren
  ToolButton_CompilierenClick(Sender);
  ToolButton_PrommerClick(Sender);
end; { procedure TForm_RP.MenuItem_Start_Compile_and_RunClick }




{ Menue-Einstellungen }


procedure TForm_RP.MenuItem_EinstellungenClick(Sender: TObject);
begin
  // Einstelungen
  Einstellungen_Form.Visible:=true;
end; { procedure TForm_RP.MenuItem_EinstellungenClick }



{ Menue-Hilfe }


procedure TForm_RP.MenuItem_HilfeClick(Sender: TObject);
begin
  // Hilfe
  Hilfe_anzeigen;
end; { procedure TForm_RP.MenuItem_HilfeClick }





{ ***** F1 -> Hilfe Taste ***** }





procedure TForm_RP.SynEdit_PASKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin

  if Key=112 then begin
    ListBox_Meldungen_Add_Item_Color('... F1 Taste gedrückt',cl_dunkel_gruen);
    Hilfe_anzeigen;
  end;

end; { procedure TForm_RP.SynEdit_PASKeyDown }












{ ********************** }
{ ***** ToolButton ***** }
{ ********************** }



// Datei neu
procedure TForm_RP.ToolButton_Datei_neuClick(Sender: TObject);
begin
  // Datei neu
  Form_Neu.Visible:=true;
end;





// Datei oeffnen
procedure TForm_RP.ToolButton_Datei_oeffnenClick(Sender: TObject);
begin
  // Oeffnen
  Datei_oeffnen;
end; { procedure TForm_RP.ToolButton_Datei_oeffnenClick }




// Speichern
procedure TForm_RP.ToolButton_SpeichernClick(Sender: TObject);
begin

  SynEdit_PAS.Lines.SaveToFile(Read_Source_name);
  SynEdit_ASM.Lines.SaveToFile(source_path+'\'+source_name+'.asm');
  SynEdit_TRC.Lines.SaveToFile(source_path+'\'+source_name+'.par');

end; { procedure TForm_RP.ToolButton_SpeichernClick }





// Einstellungen
procedure TForm_RP.ToolButton_EinstellungenClick(Sender: TObject);
begin
  // Einstellungen
  Einstellungen_Form.Visible:=true;
end; { procedure TForm_RP.ToolButton_EinstellungenClick }





// Debugger
procedure TForm_RP.ToolButton_DebuggerClick(Sender: TObject);
begin

  Form_Debugger.Visible:=true;
  Form_Debugger.Left:=DBG_Left;
  Form_Debugger.Top:=DBG_Top;

  ARRAY_Zeilen_markieren;

end; { procedure TForm_RP.ToolButton_DebuggerClick }







procedure TForm_RP.ToolButton_CompilierenClick(Sender: TObject);
begin
  // Kompilieren
  Kompilieren;

  if not Fehler_cl.gemeldet then begin
    Form_Prommer.setze_Hex_DateiName;
    SendMessage(ListBox_Meldungen.Handle, LB_SETTOPINDEX, ListBox_Meldungen.Items.Count-1, 0);
  end;


end; { procedure TForm_RP.ToolButton_CompilierenClick }






procedure TForm_RP.ToolButton_DeviceClick(Sender: TObject);
begin
  Form_Device.Visible:=true;
end; { procedure TForm_RP.ToolButton_DeviceClick }






procedure TForm_RP.ToolButton_PrommerClick(Sender: TObject);
begin
  Form_Prommer.Visible:=true;
end; { procedure TForm_RP.ToolButton_ProgrammierenClick }







procedure TForm_RP.ToolButton_Compile_and_RunClick(Sender: TObject);
var
   Zeit_Zaehler_msec, Zeit_Zaehler_sec : LongInt;
   Start_Zeit, Stop_Zeit : TDateTime;
   dauer : Int64;
   CR_Text1, CR_Text2, CR_Text3 : String;

begin

  Start_Zeit:=Now;

  // Kompilieren
  Kompilieren;

  // Programmieren
  if not Fehler_cl.gemeldet then begin

    CB_PageControl_Index:=0;
    Form_Prommer.Start_Programmer;

    Stop_Zeit:=Now;
    dauer:=MilliSecondsBetween(Start_Zeit,Stop_Zeit);
    Zeit_Zaehler_msec:=dauer mod 1000;
    Zeit_Zaehler_sec:=dauer div 1000;
    CR_Text1:=IntToStr(Zeit_Zaehler_msec);
    CR_Text2:=IntToStr(Zeit_Zaehler_sec);
    CR_Text3:='Brenndauer='+CR_Text2+','+CR_Text1+' Sekunden';
    ListBox_Meldungen.Items.Add(CR_Text3);

    SendMessage(ListBox_Meldungen.Handle, LB_SETTOPINDEX, ListBox_Meldungen.Items.Count-1, 0);
  end;

end; { procedure TForm_RP.ToolButton_Compile_and_RunClick }








procedure TForm_RP.ToolButton_HilfeClick(Sender: TObject);
begin
  // Hilfe
  Hilfe_anzeigen;

end; { procedure TForm_RP.ToolButton_HilfeClick }




procedure TForm_RP.ToolButton_BeendenClick(Sender: TObject);
begin
  // Beenden
  Close;
end; { procedure TForm_RP.ToolButton_BeendenClick }






procedure TForm_RP.BitBtn_SuchenClick(Sender: TObject);
var
  Options: TSynSearchOptions;
begin
  // Suchen

  Options:=[ssoSelectedOnly, ssoFindContinue];

  if PageControl1.ActivePage=TabSheet_PAS then begin
    SynEdit_PAS.SetFocus;
    SynEdit_PAS.SearchReplace(Edit_Suchen.Text,Edit_Suchen.Text,Options);
  end;

  if PageControl1.ActivePage=TabSheet_INC1 then begin
    SynEdit_INC1.SetFocus;
    SynEdit_INC1.SearchReplace(Edit_Suchen.Text,Edit_Suchen.Text,Options);
  end;

  if PageControl1.ActivePage=TabSheet_INC2 then begin
    SynEdit_INC2.SetFocus;
    SynEdit_INC2.SearchReplace(Edit_Suchen.Text,Edit_Suchen.Text,Options);
  end;

  if PageControl1.ActivePage=TabSheet_INC3 then begin
    SynEdit_INC3.SetFocus;
    SynEdit_INC3.SearchReplace(Edit_Suchen.Text,Edit_Suchen.Text,Options);
  end;

  if PageControl1.ActivePage=TabSheet_INC4 then begin
    SynEdit_INC4.SetFocus;
    SynEdit_INC4.SearchReplace(Edit_Suchen.Text,Edit_Suchen.Text,Options);
  end;

  if PageControl1.ActivePage=TabSheet_INC5 then begin
    SynEdit_INC5.SetFocus;
    SynEdit_INC5.SearchReplace(Edit_Suchen.Text,Edit_Suchen.Text,Options);
  end;

  if PageControl1.ActivePage=TabSheet_INC6 then begin
    SynEdit_INC6.SetFocus;
    SynEdit_INC6.SearchReplace(Edit_Suchen.Text,Edit_Suchen.Text,Options);
  end;

  if PageControl1.ActivePage=TabSheet_INC7 then begin
    SynEdit_INC7.SetFocus;
    SynEdit_INC7.SearchReplace(Edit_Suchen.Text,Edit_Suchen.Text,Options);
  end;

  if PageControl1.ActivePage=TabSheet_INC8 then begin
    SynEdit_INC8.SetFocus;
    SynEdit_INC8.SearchReplace(Edit_Suchen.Text,Edit_Suchen.Text,Options);
  end;

  if PageControl1.ActivePage=TabSheet_INC9 then begin
    SynEdit_INC9.SetFocus;
    SynEdit_INC9.SearchReplace(Edit_Suchen.Text,Edit_Suchen.Text,Options);
  end;

  if PageControl1.ActivePage=TabSheet_INC10 then begin
    SynEdit_INC10.SetFocus;
    SynEdit_INC10.SearchReplace(Edit_Suchen.Text,Edit_Suchen.Text,Options);
  end;

  if PageControl1.ActivePage=TabSheet_INC11 then begin
    SynEdit_INC11.SetFocus;
    SynEdit_INC11.SearchReplace(Edit_Suchen.Text,Edit_Suchen.Text,Options);
  end;

  if PageControl1.ActivePage=TabSheet_INC12 then begin
    SynEdit_INC12.SetFocus;
    SynEdit_INC12.SearchReplace(Edit_Suchen.Text,Edit_Suchen.Text,Options);
  end;

  if PageControl1.ActivePage=TabSheet_INC13 then begin
    SynEdit_INC13.SetFocus;
    SynEdit_INC13.SearchReplace(Edit_Suchen.Text,Edit_Suchen.Text,Options);
  end;

  if PageControl1.ActivePage=TabSheet_INC14 then begin
    SynEdit_INC14.SetFocus;
    SynEdit_INC14.SearchReplace(Edit_Suchen.Text,Edit_Suchen.Text,Options);
  end;

  if PageControl1.ActivePage=TabSheet_INC15 then begin
    SynEdit_INC15.SetFocus;
    SynEdit_INC15.SearchReplace(Edit_Suchen.Text,Edit_Suchen.Text,Options);
  end;

  if PageControl1.ActivePage=TabSheet_INC16 then begin
    SynEdit_INC16.SetFocus;
    SynEdit_INC16.SearchReplace(Edit_Suchen.Text,Edit_Suchen.Text,Options);
  end;

  if PageControl1.ActivePage=TabSheet_INC17 then begin
    SynEdit_INC17.SetFocus;
    SynEdit_INC17.SearchReplace(Edit_Suchen.Text,Edit_Suchen.Text,Options);
  end;

  if PageControl1.ActivePage=TabSheet_INC18 then begin
    SynEdit_INC18.SetFocus;
    SynEdit_INC18.SearchReplace(Edit_Suchen.Text,Edit_Suchen.Text,Options);
  end;

  if PageControl1.ActivePage=TabSheet_INC19 then begin
    SynEdit_INC19.SetFocus;
    SynEdit_INC19.SearchReplace(Edit_Suchen.Text,Edit_Suchen.Text,Options);
  end;

  if PageControl1.ActivePage=TabSheet_INC20 then begin
    SynEdit_INC20.SetFocus;
    SynEdit_INC20.SearchReplace(Edit_Suchen.Text,Edit_Suchen.Text,Options);
  end;

  if PageControl1.ActivePage=TabSheet_ASM then begin
    SynEdit_ASM.SetFocus;
    SynEdit_ASM.SearchReplace(Edit_Suchen.Text,Edit_Suchen.Text,Options);
  end;

  if PageControl1.ActivePage=TabSheet_TRC then begin
    SynEdit_TRC.SetFocus;
    SynEdit_TRC.SearchReplace(Edit_Suchen.Text,Edit_Suchen.Text,Options);
  end;



end; { procedure TForm_RP.BitBtn_SuchenClick }






procedure TForm_RP.BitBtn_Suchen_und_ErsetzenClick(Sender: TObject);
var
  Options: TSynSearchOptions;
begin
  // Suchen und Ersetzen
  Options:=[ssoReplace];

  if PageControl1.ActivePage=TabSheet_PAS then begin
    SynEdit_PAS.SetFocus;
    SynEdit_PAS.SearchReplace(Edit_Suchen.Text,Edit_Ersetzen.Text,Options);
  end;

  if PageControl1.ActivePage=TabSheet_INC1 then begin
    SynEdit_INC1.SetFocus;
    SynEdit_INC1.SearchReplace(Edit_Suchen.Text,Edit_Ersetzen.Text,Options);
  end;

  if PageControl1.ActivePage=TabSheet_INC2 then begin
    SynEdit_INC2.SetFocus;
    SynEdit_INC2.SearchReplace(Edit_Suchen.Text,Edit_Ersetzen.Text,Options);
  end;

  if PageControl1.ActivePage=TabSheet_INC3 then begin
    SynEdit_INC3.SetFocus;
    SynEdit_INC3.SearchReplace(Edit_Suchen.Text,Edit_Ersetzen.Text,Options);
  end;

  if PageControl1.ActivePage=TabSheet_INC4 then begin
    SynEdit_INC4.SetFocus;
    SynEdit_INC4.SearchReplace(Edit_Suchen.Text,Edit_Ersetzen.Text,Options);
  end;

  if PageControl1.ActivePage=TabSheet_INC5 then begin
    SynEdit_INC5.SetFocus;
    SynEdit_INC5.SearchReplace(Edit_Suchen.Text,Edit_Ersetzen.Text,Options);
  end;

  if PageControl1.ActivePage=TabSheet_INC6 then begin
    SynEdit_INC6.SetFocus;
    SynEdit_INC6.SearchReplace(Edit_Suchen.Text,Edit_Ersetzen.Text,Options);
  end;

  if PageControl1.ActivePage=TabSheet_INC7 then begin
    SynEdit_INC7.SetFocus;
    SynEdit_INC7.SearchReplace(Edit_Suchen.Text,Edit_Ersetzen.Text,Options);
  end;

  if PageControl1.ActivePage=TabSheet_INC8 then begin
    SynEdit_INC8.SetFocus;
    SynEdit_INC8.SearchReplace(Edit_Suchen.Text,Edit_Ersetzen.Text,Options);
  end;

  if PageControl1.ActivePage=TabSheet_INC9 then begin
    SynEdit_INC9.SetFocus;
    SynEdit_INC9.SearchReplace(Edit_Suchen.Text,Edit_Ersetzen.Text,Options);
  end;

  if PageControl1.ActivePage=TabSheet_INC10 then begin
    SynEdit_INC10.SetFocus;
    SynEdit_INC10.SearchReplace(Edit_Suchen.Text,Edit_Ersetzen.Text,Options);
  end;

  if PageControl1.ActivePage=TabSheet_INC11 then begin
    SynEdit_INC11.SetFocus;
    SynEdit_INC11.SearchReplace(Edit_Suchen.Text,Edit_Ersetzen.Text,Options);
  end;

  if PageControl1.ActivePage=TabSheet_INC12 then begin
    SynEdit_INC12.SetFocus;
    SynEdit_INC12.SearchReplace(Edit_Suchen.Text,Edit_Ersetzen.Text,Options);
  end;

  if PageControl1.ActivePage=TabSheet_INC13 then begin
    SynEdit_INC13.SetFocus;
    SynEdit_INC13.SearchReplace(Edit_Suchen.Text,Edit_Ersetzen.Text,Options);
  end;

  if PageControl1.ActivePage=TabSheet_INC14 then begin
    SynEdit_INC14.SetFocus;
    SynEdit_INC14.SearchReplace(Edit_Suchen.Text,Edit_Ersetzen.Text,Options);
  end;

  if PageControl1.ActivePage=TabSheet_INC15 then begin
    SynEdit_INC15.SetFocus;
    SynEdit_INC15.SearchReplace(Edit_Suchen.Text,Edit_Ersetzen.Text,Options);
  end;

  if PageControl1.ActivePage=TabSheet_INC16 then begin
    SynEdit_INC16.SetFocus;
    SynEdit_INC16.SearchReplace(Edit_Suchen.Text,Edit_Ersetzen.Text,Options);
  end;

  if PageControl1.ActivePage=TabSheet_INC17 then begin
    SynEdit_INC17.SetFocus;
    SynEdit_INC17.SearchReplace(Edit_Suchen.Text,Edit_Ersetzen.Text,Options);
  end;

  if PageControl1.ActivePage=TabSheet_INC18 then begin
    SynEdit_INC18.SetFocus;
    SynEdit_INC18.SearchReplace(Edit_Suchen.Text,Edit_Ersetzen.Text,Options);
  end;

  if PageControl1.ActivePage=TabSheet_INC19 then begin
    SynEdit_INC19.SetFocus;
    SynEdit_INC19.SearchReplace(Edit_Suchen.Text,Edit_Ersetzen.Text,Options);
  end;

  if PageControl1.ActivePage=TabSheet_INC20 then begin
    SynEdit_INC20.SetFocus;
    SynEdit_INC20.SearchReplace(Edit_Suchen.Text,Edit_Ersetzen.Text,Options);
  end;

  if PageControl1.ActivePage=TabSheet_ASM then begin
    SynEdit_ASM.SetFocus;
    SynEdit_ASM.SearchReplace(Edit_Suchen.Text,Edit_Ersetzen.Text,Options);
  end;

  if PageControl1.ActivePage=TabSheet_TRC then begin
    SynEdit_TRC.SetFocus;
    SynEdit_TRC.SearchReplace(Edit_Suchen.Text,Edit_Ersetzen.Text,Options);
  end;


end; { procedure TForm_RP.BitBtn_Suchen_und_ErsetzenClick }









// *************************************************************

// DEBUGGER

// *************************************************************





procedure TForm_RP.Add_Gutter(AG_ZeiNr, AG_ImageIndex : Integer);
var
  m: TSynEditMark;
begin
  m := TSynEditMark.Create(SynEdit_PAS);
  m.Line := AG_ZeiNr;
  m.Visible := true;
  m.ImageList := ImageList2;
  m.ImageIndex := AG_ImageIndex;
  SynEdit_PAS.Marks.Add(m);

end; { procedure TForm_RP.Add_Gutter }






procedure TForm_RP.Remove_Gutter(AG_ZeiNr, AG_ImageIndex : Integer);
var
  m: TSynEditMark;
begin
  m := TSynEditMark.Create(SynEdit_PAS);
  m.Line := AG_ZeiNr;
  m.Visible := true;
  m.ImageList := ImageList2;
  m.ImageIndex := AG_ImageIndex;
  SynEdit_PAS.Marks.Remove(m);

end; { procedure TForm_RP.Add_Gutter }





procedure TForm_RP.ARRAY_Zeilen_markieren;
var
  AZ_Zaehler : Integer;
  AZ_Marke : Char;
begin

  Form_Debugger.DBG_Line_List.Clear;

  for AZ_Zaehler:=0 to  SynEdit_PAS.Lines.Count-1 do begin

    AZ_Marke:='a';

    if Length(Trim(SynEdit_PAS.Lines[AZ_Zaehler]))=0 then begin
      Add_Gutter(AZ_Zaehler+1,0);
      AZ_Marke:='b';
    end;

    Form_Debugger.DBG_Line_List.Add(AZ_Marke);

  end; { for Zaehler:=0 to List_Array_Zeiger do }

  // Form_Debugger.DBG_Line_List.SaveToFile('dbg.txt');


end; { procedure TForm_TRACE.ARRAY_Zeilen_markieren }







procedure TForm_RP.Button_DebuggerClick(Sender: TObject);
begin
  Form_Debugger.Visible:=true;
  Form_Debugger.Left:=DBG_Left;
  Form_Debugger.Top:=DBG_Top;

  ARRAY_Zeilen_markieren;

end; { procedure TForm_RP.Button_DebuggerClick }






procedure TForm_RP.SynEdit_PASGutterClick(Sender: TObject; X, Y, Line: integer;
                                          mark: TSynEditMark);

var
  GC_Marke : String;

begin

  GC_Marke:=Form_Debugger.DBG_Line_List[Line-1];

  case GC_Marke of

    'a' : begin
            ListBox_Meldungen_Add_Item_Color(
              '*** Fehler im Debugger: die zu markierenden Zeile muss eine Leerzeile sein ***',
              cl_dunkel_rot);
          end;

    'b' : begin
            Form_Debugger.DBG_Line_List[Line-1]:='c';
            Add_Gutter(Line,1);
            ListBox_Meldungen_Add_Item_Color('... Zeile markiert',cl_dunkel_gruen);
          end;

    'c' : begin
            Form_Debugger.DBG_Line_List[Line-1]:='b';
            Remove_Gutter(Line,1);
            Add_Gutter(Line,0);
            ListBox_Meldungen_Add_Item_Color('... Markierung aufgehoben',cl_dunkel_blau);
          end;

  end;



  SendMessage(ListBox_Meldungen.Handle, LB_SETTOPINDEX, ListBox_Meldungen.Items.Count-1, 0);



end; { procedure TForm_RP.SynEdit_PASGutterClick }





{ ***** Listbox_Meldungen ***** }





procedure TForm_RP.ListBox_Meldungen_Clear;
var
  FC_counter : Integer;

begin

  for FC_counter:=0 to Length_Color_List do begin
    Color_List[FC_counter]:=ClBlack;
  end;

  ListBox_Meldungen.Clear;

end; { procedure TForm_RP.ListBox_Meldungen_Clear }





procedure TForm_RP.ListBox_Meldungen_Add_Item_Color(AI_Text : String;
                                  AI_Color : TColor);
var
  AI_Index : Integer;

begin

  ListBox_Meldungen.Items.Add(AI_Text);
  AI_Index:=ListBox_Meldungen.Count-1;
  Color_List[AI_Index]:=AI_Color;

end; { procedure TForm_RP.ListBox_Meldungen_Add_Item_Color }









procedure TForm_RP.Add_Item_ASMType(AI_Text : String;
                                    AI_ASM_Typ : ASM_type_Typ);
var
  AI_Index : Integer;
  AI_Color : TColor;
begin

  ListBox_Meldungen.Items.Add(AI_Text);
  AI_Index:=ListBox_Meldungen.Count-1;

  case AI_ASM_Typ of

    // gelb
    AT_byte_con_reg : AI_Color:=$028680;
    AT_word_con_reg : AI_Color:=$01413D;
    AT_byte_con_var : AI_Color:=$15647D;
    AT_word_con_var : AI_Color:=$1C7A88;

    // blau
    AT_bit      : AI_Color:=$054B58;
    AT_byte     : AI_Color:=$979A0C;
    AT_word     : AI_Color:=$DC7814;
    AT_dword    : AI_Color:=$700741;

    // gruen
    AT_boolean : AI_Color:=$09A246;

    AT_currency : AI_Color:=$148723;

    // braun
    AT_char     : AI_Color:=$2174EF;
    AT_string   : AI_Color:=$0A3F8D;

  else
    AI_Color:=clBlack;
  end; { case AI_ASM_Typ of }

  Color_List[AI_Index]:=AI_Color;

end; { procedure TForm_RP.Add_Item_ASMType }














procedure TForm_RP.ListBox_MeldungenDrawItem(Control: TWinControl;
                     Index: Integer; ARect: TRect; State: TOwnerDrawState);
var
  VG_Color : TColor;
begin

  with (Control as TListbox) do begin

    if Index<Length_Color_List then begin

      VG_Color:=Color_List[Index];
      Canvas.Font.Color:=VG_Color;

      Canvas.FillRect(ARect); // Hintergrund malen
      Canvas.TextOut(ARect.Left, ARect.Top, Items[Index]); // Text ausgeben

    end; { if Index<Length_Color_List then }

  end; { with (Control as TListbox) do }

end; { procedure TForm_RP.ListBox_MeldungenDrawItem }






procedure TForm_RP.Image_COMPILE(Farb_Bitmap : Integer);
begin

  case Farb_Bitmap of

    ic_grau : begin

                Image_COMPILE_grau.Visible:=true;
                Image_COMPILE_gruen.Visible:=false;
                Image_COMPILE_gelb.Visible:=false;
                Image_COMPILE_rot.Visible:=false;

              end;

    ic_gelb : begin

                Image_COMPILE_grau.Visible:=false;
                Image_COMPILE_gruen.Visible:=false;
                Image_COMPILE_gelb.Visible:=true;
                Image_COMPILE_rot.Visible:=false;

              end;

    ic_gruen: begin

                Image_COMPILE_grau.Visible:=false;
                Image_COMPILE_gruen.Visible:=true;
                Image_COMPILE_gelb.Visible:=false;
                Image_COMPILE_rot.Visible:=false;

              end;

    ic_rot  : begin

                Image_COMPILE_grau.Visible:=false;
                Image_COMPILE_gruen.Visible:=false;
                Image_COMPILE_gelb.Visible:=false;
                Image_COMPILE_rot.Visible:=true;

              end;

  end; { case Farb_Bitmap of }


end; { procedure TForm_RP.Image_COMPILE }











{ ***** FormDestroy ***** }


procedure TForm_RP.FormDestroy(Sender: TObject);
begin

  if FileExists(Read_Source_name) then begin
    SynEdit_PAS.Lines.SaveToFile(Read_Source_name);
  end;

  INC_Dateien_Sichern;

  // SYSTEM
  IniFile.WriteString('SYSTEM','source_path',source_path);
  IniFile.WriteString('SYSTEM','source_name',source_name);
  IniFile.WriteBool('SYSTEM','TRC_Datei_erzeugen',CheckBox_TRC_Datei);
  IniFile.WriteBool('SYSTEM','LOG_Dateien_erzeugen',CheckBox_LOG_Dateien);

  // IDE
  IniFile.WriteInteger('IDE','Left',Left);
  IniFile.WriteInteger('IDE','Top',Top);
  IniFile.WriteInteger('IDE','Width',Width);
  IniFile.WriteInteger('IDE','Height',Height);
  IniFile.WriteInteger('IDE','CaretY',SynEdit_PAS.CaretY);
  IniFile.WriteInteger('IDE','CaretX',SynEdit_PAS.CaretX);
  IniFile.WriteInteger('IDE','Item_Index_FontGroesse',CB_FontGroesse);
  IniFile.WriteInteger('IDE','Item_Index_Meldungen_FontGroesse',CB_Meldungen_FontGroesse);

  // Device
  IniFile.WriteInteger('Device','Device_Index',CB_Device_Index);
  IniFile.WriteInteger('Device','Board_Index',CB_Board_Index);

  // PROMMER
  IniFile.WriteInteger('Prommer','Prommer_Index',CB_Prommer_Index);
  IniFile.WriteString('Prommer','Port_Name',Port_Name);
  IniFile.WriteString('Prommer','Port_Typ',Port_Typ);
  IniFile.WriteInteger('Prommer','PageControl_Index',CB_PageControl_Index);

  // Debugger
  IniFile.WriteInteger('Debugger','Left',DBG_Left);
  IniFile.WriteInteger('Debugger','Top',DBG_Top);
  IniFile.WriteInteger('Debugger','Index_BaudRate',DBG_Index_BaudRate);
  IniFile.WriteString('Debugger','ComPort',DBG_ComPort);


  IniFile.Free;

  Scanner_cl.Free;
  Parser_cl.Free;
  Compiler_cl.Free;
  ZWC_cl.Free;
  Assembler_cl.Free;

  HD_Keyword.Free;
  HD_HTML_Seite.Free;

end; { procedure TForm_RP.FormDestroy }






end.

