unit Modul_Compiler;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils,

  CompilerDeklarationen, ZwischenCode, Modul_Scanner, Modul_Parser,
  Modul_Assembler, Debugger_Form;


const
  Laenge_INCLUDE_LIST = 20;


type


  INCLUDE_RECORD = record
    Name, Pfad : String;
    TabSheet_aktiv, Datei_eingelesen : Boolean;
  end;


  Compiler_class = class(TObject)
  public
    PC_Source_file, SC_Source_file,
    SC_Dest_file : TStringList;
    SI_ARR : SI_ARR_type;
    INCLUDE_LIST : Array [2..Laenge_INCLUDE_LIST+1] of INCLUDE_RECORD;
    INCLUDE_LIST_Zeiger : Cardinal;
    constructor Create;
    procedure STR_Laenge(var STR_Zahl : String; STR_Laen : Integer);
    procedure PreCompiler;
    function ASM_type_Typ_in_Bezeichner(ASM_type : ASM_type_Typ) : String;
    function UnterTyp_in_Bezeichner(UnterTyp : SI_Unter_Typ) : String;
    function UnterTyp_in_Bezeichnertext(UnterTyp : SI_Unter_Typ) : String;
    function RW_Bez_To_String(RW_Bezeichnung : RW_Bez) : String;
    procedure Start_Compiler;
    destructor Destroy; override;
  private
    function INC_Eintrag_erzeugen(INC_Name : String) : String;
    function INC_Eintrag_suchen(INC_Name : String) : Cardinal;
  end; { Compiler_class = class(TObject) }





var
  Compiler_cl : Compiler_class;


implementation

uses
  Main_Unit;




{
***************************************************
*
*                COMPILER
*
***************************************************
}





constructor Compiler_class.Create;
begin
  inherited Create;
  PC_Source_file := TStringList.Create;
  SC_Source_file := TStringList.Create;
  SC_Dest_file := TStringList.Create;
  INCLUDE_LIST_Zeiger := 1;
end;  { constructor Compiler_class.Create }




procedure Compiler_class.STR_Laenge(var STR_Zahl : String; STR_Laen : Integer);
begin
  while Length(STR_Zahl)<STR_Laen do
    STR_Zahl:='0'+STR_Zahl;

end; { function Compiler_class.STR_Laenge }







function Compiler_class.INC_Eintrag_suchen(INC_Name : String) : Cardinal;
var
  INC_Zaehler, INC_Position : Cardinal;
begin
  INC_Position:=0;
  for INC_Zaehler:=2 to INCLUDE_LIST_Zeiger do begin
    if INCLUDE_LIST[INC_Zaehler].Name=INC_Name then
      INC_Position:=INC_Zaehler;

  end; { for INC_Zaehler:=2 to INCLUDE_LIST_Zeiger do }

  Result:=INC_Position;
end; { function Compiler_class.INC_Eintrag_suchen }







function Compiler_class.INC_Eintrag_erzeugen(INC_Name : String) : String;
var
  STR_Nr_Eintrag : String;
  INC_Eintrag_Position : Cardinal;
begin
  STR_Nr_Eintrag:='002';
  INC_Eintrag_Position:=INC_Eintrag_suchen(INC_Name);

  if INC_Eintrag_Position>1 then begin

    if not INCLUDE_LIST[INC_Eintrag_Position].Datei_eingelesen then
      Form_RP.INC_Datei_laden(INC_Eintrag_Position);

    if not INCLUDE_LIST[INC_Eintrag_Position].TabSheet_aktiv then
      Form_RP.INC_TAB_anzeigen(INC_Eintrag_Position);

    STR_Nr_Eintrag:=IntToStr(INC_Eintrag_Position);
    STR_Laenge(STR_Nr_Eintrag,3);

  end
  else begin

    if FileExists(Form_RP.source_path+'\'+INC_Name) then begin

      if INCLUDE_LIST_Zeiger<Laenge_INCLUDE_LIST+1 then begin
        Inc(INCLUDE_LIST_Zeiger);

        INCLUDE_LIST[INCLUDE_LIST_Zeiger].Name:=INC_Name;
        INCLUDE_LIST[INCLUDE_LIST_Zeiger].Pfad:=Form_RP.source_path;

        Form_RP.INC_Datei_laden(INCLUDE_LIST_Zeiger);
        INCLUDE_LIST[INCLUDE_LIST_Zeiger].Datei_eingelesen:=true;

        Form_RP.INC_TAB_anzeigen(INCLUDE_LIST_Zeiger);
        INCLUDE_LIST[INCLUDE_LIST_Zeiger].TabSheet_aktiv:=true;

        STR_Nr_Eintrag:=IntToStr(INCLUDE_LIST_Zeiger);
        STR_Laenge(STR_Nr_Eintrag,3);

      end
      else
        Fehler_cl.Registrieren('Compiler/INC_Eintrag_erzeugen',
                               'maximale Anzahl der INCLUDE-Dateien ('+
                               IntToStr(Laenge_INCLUDE_LIST) +') ueberschritten',0,0,1);

    end
    else
      Fehler_cl.Registrieren('Compiler/INC_Eintrag_erzeugen',
                             'INCLUDE-Dateien <'+INC_Name+
                             '> konnte nicht gefunden werden',0,0,1);

  end; { if INC_Eintrag_Position>1 then }

  Result:=STR_Nr_Eintrag;

end; { procedure Compiler_class.INC_Eintrag_erzeugen }




{
***************************************************
*
*                PRE-Compiler
*
***************************************************
}







procedure Compiler_class.PreCompiler;
var
  PC_Zaehler : Integer;
  PC_Zeile, PC_Zeile_Add, PAS_Zeilen_Nr,
  INC_Dateiname, INC_Datei_Nummer : String;
  Define_NamensListe : TStringList;
  Define_Name : String;
  Zeilen_kommentieren_aktiv_Source,
  Zeilen_kommentieren_aktiv_Include : Boolean;
  Pos_NamensListe : Integer;





  procedure Compilerschalter_Zeile_bearbeiten(var CS_Zeile :String;
                                              var Zeilen_kommentieren : Boolean);
  begin

    // Einlesen und Auswerten der Compilerschalter
    //
    // unterstuetzt werden derzeit:
    // {$DEFINE ...}
    // {$IFDEF ...}
    // {$ELSE}
    // {$ENDIF}
    //


    // DEFINE
    if NOT Zeilen_kommentieren then begin

      if Pos('{$DEFINE ',CS_Zeile)=1 then begin

        if Pos('}',CS_Zeile)=Length(CS_Zeile) then begin

          Define_Name:=Copy(CS_Zeile,9,Length(CS_Zeile)-9);
          Define_Name:=Trim(Define_Name);
          Define_NamensListe.Add(Define_Name);

        end; { if Pos('',CS_Zeile)=Length(CS_Zeile) then }

      end; { if Pos('$DEFINE',PC_Zeile)=1 then }

    end; { if NOT Zeilen_kommentieren then }


    // IFDEF
    if Pos('{$IFDEF ',CS_Zeile)=1 then begin

      if Pos('}',CS_Zeile)=Length(CS_Zeile) then begin

        Define_Name:=Copy(CS_Zeile,8,Length(CS_Zeile)-8);
        Define_Name:=Trim(Define_Name);

        if Define_NamensListe.Find(Define_Name,Pos_NamensListe) then
          Zeilen_kommentieren:=false
        else
          Zeilen_kommentieren:=true;

      end; { if Pos('',CS_Zeile)=Length(CS_Zeile) then }

    end; { if Pos('$IFDEF',CS_Zeile)=1 then }


    // ELSE
    if Pos('{$ELSE}',CS_Zeile)=1 then begin
      Zeilen_kommentieren:=NOT Zeilen_kommentieren;
    end; { if Pos('$ENDIF',CS_Zeile)=1 then }


    // ENDIF
    if Pos('{$ENDIF}',CS_Zeile)=1 then begin
      Zeilen_kommentieren:=false;
    end; { if Pos('$ENDIF',CS_Zeile)=1 then }


  end; { procedure Compilerschalter_Zeile_bearbeiten }





  procedure Datei_einfuegen(STR_Datei_Nummer : String);
  var
    INC_Zaehler, Datei_Nummer : Integer;
    INC_Source_file : TStringList;
    INC_Zeile, INC_Zahl,
    Datei_Name, Datei_Pfad : String;
  begin
    Datei_Nummer:=StrToInt(STR_Datei_Nummer);
    Datei_Name:=INCLUDE_LIST[Datei_Nummer].Name;
    Datei_Pfad:=INCLUDE_LIST[Datei_Nummer].Pfad;
    INC_Source_file:=TStringList.Create;
    INC_Source_file.LoadFromFile(Datei_Pfad+'\'+Datei_Name);

    for INC_Zaehler:=0 to INC_Source_file.Count-1 do begin
      INC_Zeile:=INC_Source_file[INC_Zaehler];
      INC_Zeile:=Trim(INC_Zeile);

      Compilerschalter_Zeile_bearbeiten(INC_Zeile,Zeilen_kommentieren_aktiv_Include);

      INC_Zahl:=IntToStr(INC_Zaehler);
      STR_Laenge(INC_Zahl,4);

      if Zeilen_kommentieren_aktiv_Include then
        INC_Zeile:=STR_Datei_Nummer+INC_Zahl+'// '+INC_Zeile
      else
        INC_Zeile:=STR_Datei_Nummer+INC_Zahl+INC_Zeile;

      SC_Source_file.Add(INC_Zeile);

    end; { for PC_Zaehler:=0 to INC_Source_file.Count-1 do }

    // Fehler, wenn eine Includedatei nicht abgeschlossen wird
    if Zeilen_kommentieren_aktiv_Include then begin

      Form_RP.ListBox_Meldungen.Items.Add(
            '*** Fehler im PreCompiler: alle Compilerschalter in den '+
            'INCLUDE-Dateien muessen mit $ENDIF abgeschlossen werden ***');

      Zeilen_kommentieren_aktiv_Include:=false;

    end; { if Zeilen_kommentieren_aktiv_Include then }

    INC_Source_file.Free;

  end; { procedure Datei_einfuegen }





  procedure Include_Zeile_bearbeiten;
  begin

    if Pos('{$I ',PC_Zeile)=1 then begin

      INC_Dateiname:=Copy(PC_Zeile,5,Length(PC_Zeile)-5);
      INC_Datei_Nummer:=INC_Eintrag_erzeugen(INC_Dateiname);

      if not Fehler_cl.gemeldet then begin
        Datei_einfuegen(INC_Datei_Nummer);
      end; { if not Fehler_cl.gemeldet then }

    end; { if Pos('$I ',PC_Zeile)=1 then }

  end; { procedure Include_Zeile_bearbeiten }



  procedure Debugger_Zeile_bearbeiten;
  begin

    // Debugger
    if Form_Debugger.Debugger_aktiv then begin

      if Form_Debugger.DBG_Line_List[PC_Zaehler]='c' then begin

        if Length(PC_Zeile)=0 then begin
          PC_Zeile:='dbg(1,'+IntToStr(PC_Zaehler+1)+');';
          Form_RP.ListBox_Meldungen.Items.Add('... Debugger Zeile aktiviert');
        end
        else begin
          Form_RP.ListBox_Meldungen.Items.Add(
            '*** Fehler im Debugger: die markierte Zeile muss eine Leerzeile sein ***');
        end;

      end; { if Form_Debugger.DBG_Line_List[PC_Zaehler]='c' then }

    end; { if Form_Debugger.Debugger_aktiv then }

  end; { procedure Debugger_Zeile_bearbeiten }







begin

  Zeilen_kommentieren_aktiv_Source:=false;
  Zeilen_kommentieren_aktiv_Include:=false;

  Define_NamensListe:=TStringList.Create;
  Define_NamensListe.Sorted:=true;


  if FileExists(Form_RP.Read_Source_name) then begin
    SC_Source_file.Clear;
    PC_Source_file.LoadFromFile(Form_RP.Read_Source_name);

    for PC_Zaehler:=0 to PC_Source_file.Count-1 do begin

      PC_Zeile:=PC_Source_file[PC_Zaehler];
      PC_Zeile:=Trim(PC_Zeile);

      Debugger_Zeile_bearbeiten;

      Compilerschalter_Zeile_bearbeiten(PC_Zeile,Zeilen_kommentieren_aktiv_Source);

      PAS_Zeilen_Nr:=IntToStr(PC_Zaehler);
      STR_Laenge(PAS_Zeilen_Nr,4);

      if Zeilen_kommentieren_aktiv_Source then
        PC_Zeile_Add:='001'+PAS_Zeilen_Nr+'// '+PC_Zeile
      else
        PC_Zeile_Add:='001'+PAS_Zeilen_Nr+PC_Zeile;

      SC_Source_file.Add(PC_Zeile_Add);

      if NOT Zeilen_kommentieren_aktiv_Source then begin
        Include_Zeile_bearbeiten;
      end;

    end; { for PC_Zaehler:=0 to PC_Source_file.Count-1 do }



    // Fehler, wenn eine Includedatei nicht abgeschlossen wird
    if Zeilen_kommentieren_aktiv_Source then begin

      Form_RP.ListBox_Meldungen.Items.Add(
            '*** Fehler im PreCompiler: alle Compilerschalter in den '+
            'Quell-Dateien muessen mit $ENDIF abgeschlossen werden ***');

    end; { if Zeilen_kommentieren_aktiv_Source then }




    // Abspeichern oder Loeschen der LOG-Dateien PRE und DEF
    if Form_RP.CheckBox_LOG_Dateien then begin
      SC_Source_file.SaveToFile(Form_RP.source_path+'\'+Form_RP.source_name+'.pre');
      Define_NamensListe.SaveToFile(Form_RP.source_path+'\'+Form_RP.source_name+'.def');
    end
    else begin
      if FileExists(Form_RP.source_path+'\'+Form_RP.source_name+'.pre') then
        DeleteFile(Form_RP.source_path+'\'+Form_RP.source_name+'.pre');

      if FileExists(Form_RP.source_path+'\'+Form_RP.source_name+'.def') then
        DeleteFile(Form_RP.source_path+'\'+Form_RP.source_name+'.def');

    end; { if Form_RP.CheckBox_LOG_Dateien then }


    Define_NamensListe.Free;


  end
  else
    Fehler_cl.Registrieren('Compiler/Start_PreCompiler','Quelldatei:'+Form_RP.Read_Source_name+
                           ' nicht vorhanden',0,0,1);


end; { procedure Compiler_class.PreCompiler }







function Compiler_class.ASM_type_Typ_in_Bezeichner(ASM_type : ASM_type_Typ) : String;
var
  ASM_Zeile : String;
begin
  case ASM_type of

    AT_kein_typ     : ASM_Zeile:='kein Typ';
    AT_byte_con_reg : ASM_Zeile:='BYTECONREG';
    AT_word_con_reg : ASM_Zeile:='WORDCONREG';
    AT_byte_con_var : ASM_Zeile:='BYTECONVAR';
    AT_word_con_var : ASM_Zeile:='WORDCONVAR';
    AT_bit          : ASM_Zeile:='BIT';
    AT_boolean      : ASM_Zeile:='BOOLEAN';
    AT_byte         : ASM_Zeile:='BYTE';
    AT_word         : ASM_Zeile:='WORD';
    AT_dword        : ASM_Zeile:='DWORD';
    AT_char         : ASM_Zeile:='CHAR';
    AT_string       : ASM_Zeile:='STRING';
    AT_currency     : ASM_Zeile:='CURRENCY';

  else
    ASM_Zeile:='*** Fehler (ASM_type) ***';
  end; { case ASM_type of }
  Result:=ASM_Zeile;
end; { function Compiler_class.ASM_type_Typ_in_Bezeichner }










function Compiler_class.UnterTyp_in_Bezeichner(UnterTyp : SI_Unter_Typ) : String;
var
  UT_Zeile : String;
begin
  case UnterTyp of
    kein_UT             : UT_Zeile:='<kein_UT>';
    { ## Untertyp fuer Zahlen ## }
    UT_Dezi_Zahl        : UT_Zeile:='<UT_Dezi_Zahl>';
    UT_Bin_Zahl         : UT_Zeile:='<UT_Bin_Zahl>';
    UT_Hex_Zahl         : UT_Zeile:='<UT_Hex_Zahl>';
    UT_Char_Zahl        : UT_Zeile:='<UT_Char_Zahl>';
    UT_Curr_Zahl        : UT_Zeile:='<UT_Curr_Zahl>';
    { ## Untertyp fuer Char ## }
    UT_Char             : UT_Zeile:='<UT_Char>';
    { ## Untertyp fuer Zeichenkette ## }
    UT_String           : UT_Zeile:='<UT_String>';
    { ## Untertyp fuer Zeichen ## }
    UT_Zei_DZ_KG        : UT_Zeile:='<UT_Zei_DZ_KG>';
    UT_Zei_DZ_GG        : UT_Zeile:='<UT_Zei_DZ_GG>';
    UT_Zei_DZ_DG        : UT_Zeile:='<UT_Zei_DZ_DG>';
    UT_Zei_DZ_UG        : UT_Zeile:='<UT_Zei_DZ_UG>';
    UT_Zei_PLUS         : UT_Zeile:='<UT_Zei_PLUS>';
    UT_Zei_MINUS        : UT_Zeile:='<UT_Zei_MINUS>';
    UT_Zei_MAL          : UT_Zeile:='<UT_Zei_MAL>';
    UT_Zei_DURCH        : UT_Zeile:='<UT_Zei_DURCH>';
    UT_Zei_SEMI         : UT_Zeile:='<UT_Zei_SEMI>';
    UT_Zei_DP           : UT_Zeile:='<UT_Zei_DP>';
    UT_Zei_KOMMAR       : UT_Zeile:='<UT_Zei_KOMMAR>';
    UT_Zei_PUNKT        : UT_Zeile:='<UT_Zei_PUNKT>';
    UT_Zei_GLEICH       : UT_Zeile:='<UT_Zei_GLEICH>';
    UT_Zei_KA           : UT_Zeile:='<UT_Zei_KA>';
    UT_Zei_KZ           : UT_Zeile:='<UT_Zei_KZ>';
    UT_Zei_KLEINER      : UT_Zeile:='<UT_Zei_KLEINER>';
    UT_Zei_GROESSER     : UT_Zeile:='<UT_Zei_GROESSER>';
    UT_Zei_EKA          : UT_Zeile:='<UT_Zei_EKA>';
    UT_Zei_EKZ          : UT_Zeile:='<UT_Zei_EKZ>';
    UT_Zei_SS           : UT_Zeile:='<UT_Zei_SS>';
    UT_Zei_PUNKT_PUNKT  : UT_Zeile:='<UT_Zei_PUNKT_PUNKT>';
    { ## Untertyp fuer Bezeichner ## }
    UT_Bezeichner_PAR            : UT_Zeile:='<UT_Bezeichner_PAR>';
    UT_Bez_PROGRAM               : UT_Zeile:='<UT_Bez_PROGRAM>';
    UT_Bez_DEVICE                : UT_Zeile:='<UT_Bez_DEVICE>';
    UT_Bez_IMPORT                : UT_Zeile:='<UT_Bez_IMPORT>';
    UT_Bez_DEFINE                : UT_Zeile:='<UT_Bez_DEFINE>';
    UT_Bez_IMPLEMENTATION        : UT_Zeile:='<UT_Bez_IMPLEMENTATION>';
    UT_Bez_END                   : UT_Zeile:='<UT_Bez_END>';
    UT_Bez_VAR                   : UT_Zeile:='<UT_Bez_VAR>';
    UT_Bez_CONST                 : UT_Zeile:='<UT_Bez_CONST>';
    UT_Bez_BEGIN                 : UT_Zeile:='<UT_Bez_BEGIN>';
    UT_Bez_PROCEDURE             : UT_Zeile:='<UT_Bez_PROCEDURE>';
    UT_Bez_FUNCTION              : UT_Zeile:='<UT_Bez_FUNCTION>';
    UT_Bez_ASM                   : UT_Zeile:='<UT_Bez_ASM>';
    UT_Bez_ENDASM                : UT_Zeile:='<UT_Bez_ENDASM>';
    UT_Bez_RESULT                : UT_Zeile:='<UT_Bez_RESULT>';

    UT_Bez_FOR                   : UT_Zeile:='<UT_Bez_FOR>';
    UT_Bez_TO                    : UT_Zeile:='<UT_Bez_TO>';
    UT_Bez_DOWNTO                : UT_Zeile:='<UT_Bez_DOWNTO>';
    UT_Bez_DO                    : UT_Zeile:='<UT_Bez_DO>';
    UT_Bez_ENDFOR                : UT_Zeile:='<UT_Bez_ENDFOR>';

    UT_Bez_LOOP                  : UT_Zeile:='<UT_Bez_LOOP>';
    UT_Bez_ENDLOOP               : UT_Zeile:='<UT_Bez_ENDLOOP>';

    UT_Bez_IF                    : UT_Zeile:='<UT_Bez_IF>';
    UT_Bez_THEN                  : UT_Zeile:='<UT_Bez_THEN>';
    UT_Bez_ELSE                  : UT_Zeile:='<UT_Bez_ELSE>';
    UT_Bez_ENDIF                 : UT_Zeile:='<UT_Bez_ENDIF>';

    UT_Bez_INC                   : UT_Zeile:='<UT_Bez_INC>';
    UT_Bez_DEC                   : UT_Zeile:='<UT_Bez_DEC>';
    UT_Bez_SHL                   : UT_Zeile:='<UT_Bez_SHL>';
    UT_Bez_SHR                   : UT_Zeile:='<UT_Bez_SHR>';
    UT_Bez_NOP                   : UT_Zeile:='<UT_Bez_NOP>';

    UT_Bez_DIV                   : UT_Zeile:='<UT_Bez_DIV>';
    UT_Bez_MOD                   : UT_Zeile:='<UT_Bez_MOD>';
    UT_Bez_IN                    : UT_Zeile:='<UT_Bez_IN>';
    UT_Bez_AND                   : UT_Zeile:='<UT_Bez_AND>';
    UT_Bez_OR                    : UT_Zeile:='<UT_Bez_OR>';
    UT_Bez_ARRAY                 : UT_Zeile:='<UT_Bez_ARRAY>';
    UT_Bez_OF                    : UT_Zeile:='<UT_Bez_OF>';

    UT_Bez_SetBit                : UT_Zeile:='<UT_Bez_SetBit>';
    UT_Bez_ClearBit              : UT_Zeile:='<UT_Bez_ClearBit>';

    UT_Bez_BYTETOWORD            : UT_Zeile:='<UT_Bez_BYTETOWORD>';
    UT_Bez_HIGH                  : UT_Zeile:='<UT_Bez_HIGH>';
    UT_Bez_LOW                   : UT_Zeile:='<UT_Bez_LOW>';
    UT_Bez_BITHIGH               : UT_Zeile:='<UT_Bez_BITHIGH>';
    UT_Bez_BITLOW                : UT_Zeile:='<UT_Bez_BITLOW>';

    UT_Bez_WHILE                 : UT_Zeile:='<UT_Bez_WHILE>';
    UT_Bez_ENDWHILE              : UT_Zeile:='<UT_Bez_ENDWHILE>';

    UT_Bez_CASE                  : UT_Zeile:='<UT_Bez_CASE>';
    UT_Bez_ENDCASE               : UT_Zeile:='<UT_Bez_ENDCASE>';

    UT_Bez_BYTETOCHAR            : UT_Zeile:='<UT_Bez_BYTETOCHAR>';
    UT_Bez_CHARTOBYTE            : UT_Zeile:='<UT_Bez_CHARTOBYTE>';

    UT_Bez_LENGTH                : UT_Zeile:='<UT_Bez_LENGTH>';

    UT_Bez_DWORDTOBYTE           : UT_Zeile:='<UT_Bez_DWORDTOBYTE>';
    UT_Bez_DWLOW                 : UT_Zeile:='<UT_Bez_DWLOW>';
    UT_Bez_DWHIGH                : UT_Zeile:='<UT_Bez_DWHIGH>';
    UT_Bez_WORDTODWORD           : UT_Zeile:='<UT_Bez_WORDTODWORD>';
    UT_Bez_BYTETODWORD           : UT_Zeile:='<UT_Bez_BYTETODWORD>';

    UT_Bez_ISR                   : UT_Zeile:='<UT_Bez_ISR>';
    UT_Bez_EnableInts            : UT_Zeile:='<UT_Bez_EnableInts>';
    UT_Bez_DisableInts           : UT_Zeile:='<UT_Bez_DisableInts>';
    UT_Bez_ISR_LISTE             : UT_Zeile:='<UT_Bez_ISR_LISTE>';

    { ## Untertyp fuer PARSER ## }
    UT_Par_prog_name_rd          : UT_Zeile:='<UT_Par_prog_name_rd>';
    UT_Par_prog_device           : UT_Zeile:='<UT_Par_prog_device>';
    UT_Par_prog_kopf             : UT_Zeile:='<UT_Par_prog_kopf>';
    UT_Par_prog_jump             : UT_Zeile:='<UT_Par_prog_jump>';
    UT_Par_prog_name_cp          : UT_Zeile:='<UT_Par_prog_name_cp>';
    UT_Par_call_bez              : UT_Zeile:='<UT_Par_call_bez>';

    UT_Par_var_name              : UT_Zeile:='<UT_Par_var_name>';
    UT_Par_var_liste             : UT_Zeile:='<UT_Par_var_liste>';
    UT_Par_var_type              : UT_Zeile:='<UT_Par_var_type>';
    UT_Par_var_bit_reg           : UT_Zeile:='<UT_Par_var_bit_reg>';
    UT_Par_var_bit_pos           : UT_Zeile:='<UT_Par_var_bit_pos>';
    UT_Par_var_bit_type          : UT_Zeile:='<UT_Par_var_bit_type>';
    UT_Par_var_array_von         : UT_Zeile:='<UT_Par_var_array_von>';
    UT_Par_var_array_bis         : UT_Zeile:='<UT_Par_var_array_bis>';
    UT_Par_var_array_type        : UT_Zeile:='<UT_Par_var_array_type>';
    UT_Par_var_array_2d_von      : UT_Zeile:='<UT_Par_var_array_2d_von>';
    UT_Par_var_array_2d_bis      : UT_Zeile:='<UT_Par_var_array_2d_bis>';
    UT_Par_var_string            : UT_Zeile:='<UT_Par_var_string>';
    UT_Par_var_str_len           : UT_Zeile:='<UT_Par_var_str_len>';
    UT_Par_var_ende              : UT_Zeile:='<UT_Par_var_ende>';

    UT_Par_const_name            : UT_Zeile:='<UT_Par_const_name>';
    UT_Par_const_type            : UT_Zeile:='<UT_Par_const_type>';
    UT_Par_const_wert            : UT_Zeile:='<UT_Par_const_wert>';
    UT_Par_const_bez             : UT_Zeile:='<UT_Par_const_bez>';
    UT_Par_const_operator        : UT_Zeile:='<UT_Par_const_operator>';
    UT_Par_const_ende            : UT_Zeile:='<UT_Par_const_ende>';
    UT_Par_const_array_von       : UT_Zeile:='<UT_Par_const_array_von>';
    UT_Par_const_array_bis       : UT_Zeile:='<UT_Par_const_array_bis>';
    UT_Par_const_array_type      : UT_Zeile:='<UT_Par_const_array_type>';
    UT_Par_const_array_element   : UT_Zeile:='<UT_Par_const_array_element>';
    UT_Par_const_array_end       : UT_Zeile:='<UT_Par_const_array_end>';

    UT_Par_zuw_Ziel              : UT_Zeile:='<UT_Par_zuw_Ziel>';

    UT_Par_zuw_Z_V_ARR_1D        : UT_Zeile:='<UT_Par_zuw_Z_V_ARR_1D>';
    UT_Par_zuw_Z_V_ARR_POS_1D    : UT_Zeile:='<UT_Par_zuw_Z_V_ARR_POS_1D>';

    UT_Par_zuw_Z_V_ARR_2D        : UT_Zeile:='<UT_Par_zuw_Z_V_ARR_2D>';
    UT_Par_zuw_Z_V_ARR_POS_2D_01 : UT_Zeile:='<UT_Par_zuw_Z_V_ARR_POS_2D_01>';
    UT_Par_zuw_Z_V_ARR_POS_2D_02 : UT_Zeile:='<UT_Par_zuw_Z_V_ARR_POS_2D_02>';

    UT_Par_zuw_Z_WAA_ADR         : UT_Zeile:='<UT_Par_zuw_Z_WAA_ADR>';

    UT_Par_zuw_fak_VAR           : UT_Zeile:='<UT_Par_zuw_fak_VAR>';
    UT_Par_zuw_fak_CONST         : UT_Zeile:='<UT_Par_zuw_fak_CONST>';
    UT_Par_zuw_fak_CONRD         : UT_Zeile:='<UT_Par_zuw_fak_CONRD>';
    UT_Par_zuw_fak_FKT           : UT_Zeile:='<UT_Par_zuw_fak_FKT>';
    UT_Par_zuw_fak_CON_ARR       : UT_Zeile:='<UT_Par_zuw_fak_CON_ARR>';
    UT_Par_zuw_Q_V_ARR_POS_1D    : UT_Zeile:='<UT_Par_zuw_Q_V_ARR_POS_1D>';
    UT_Par_zuw_Q_V_ARR_1D        : UT_Zeile:='<UT_Par_zuw_Q_V_ARR_1D>';
    UT_Par_zuw_operator          : UT_Zeile:='<UT_Par_zuw_operator>';
    UT_Par_zuw_abschl            : UT_Zeile:='<UT_Par_zuw_abschl>';

    UT_Par_zuw_fak_B2W           : UT_Zeile:='<UT_Par_zuw_fak_BYTETOWORD>';
    UT_Par_zuw_fak_HIGH          : UT_Zeile:='<UT_Par_zuw_fak_HIGH>';
    UT_Par_zuw_fak_LOW           : UT_Zeile:='<UT_Par_zuw_fak_LOW>';
    UT_Par_zuw_fak_BITHIGH       : UT_Zeile:='<UT_Par_zuw_fak_BITHIGH>';
    UT_Par_zuw_fak_BITLOW        : UT_Zeile:='<UT_Par_zuw_fak_BITLOW>';
    UT_Par_zuw_fak_B2C           : UT_Zeile:='<UT_Par_zuw_fak_B2C>';
    UT_Par_zuw_fak_C2B           : UT_Zeile:='<UT_Par_zuw_fak_C2B>';
    UT_Par_zuw_fak_LENGTH        : UT_Zeile:='<UT_Par_zuw_fak_LENGTH>';

    UT_Par_zuw_fak_DWBYTE1        : UT_Zeile:='<UT_Par_zuw_fak_DWBYTE1>';
    UT_Par_zuw_fak_DWBYTE2        : UT_Zeile:='<UT_Par_zuw_fak_DWBYTE2>';
    UT_Par_zuw_fak_DWLOW         : UT_Zeile:='<UT_Par_zuw_fak_DWLOW>';
    UT_Par_zuw_fak_DWHIGH        : UT_Zeile:='<UT_Par_zuw_fak_DWHIGH>';
    UT_Par_zuw_fak_WORDTODW      : UT_Zeile:='<UT_Par_zuw_fak_WORDTODW>';
    UT_Par_zuw_fak_BYTETODW      : UT_Zeile:='<UT_Par_zuw_fak_BYTETODW>';
    UT_Par_zuw_fak_ARRTOADR      : UT_Zeile:='<UT_Par_zuw_fak_ARRTOADR>';
    UT_Par_zuw_fak_RDADRARR      : UT_Zeile:='<UT_Par_zuw_fak_RDADRARR>';

    UT_Par_proc_name_rd          : UT_Zeile:='<UT_Par_proc_name_rd>';
    UT_Par_proc_name_cp          : UT_Zeile:='<UT_Par_proc_name_cp>';
    UT_Par_proc_par_name_rd      : UT_Zeile:='<UT_Par_proc_par_name_rd>';
    UT_Par_proc_par_liste_rd     : UT_Zeile:='<UT_Par_proc_par_liste_rd>';
    UT_Par_proc_par_type_rd      : UT_Zeile:='<UT_Par_proc_par_type_rd>';
    UT_Par_proc_lvar_name_rd     : UT_Zeile:='<UT_Par_proc_lvar_name_rd>';
    UT_Par_proc_lvar_liste_rd    : UT_Zeile:='<UT_Par_proc_lvar_liste_rd>';
    UT_Par_proc_lvar_type_rd     : UT_Zeile:='<UT_Par_proc_lvar_type_rd>';

    UT_Par_proc_call_name        : UT_Zeile:='<UT_Par_proc_call_name>';
    UT_Par_proc_call_par         : UT_Zeile:='<UT_Par_proc_call_par>';
    UT_Par_proc_call_par_lst     : UT_Zeile:='<UT_Par_proc_call_par_lst>';
    UT_Par_proc_call_exec        : UT_Zeile:='<UT_Par_proc_call_exec>';

    UT_Par_func_name_rd          : UT_Zeile:='<UT_Par_func_name_rd>';
    UT_Par_func_name_cp          : UT_Zeile:='<UT_Par_func_name_cp>';
    UT_Par_func_result_type_rd   : UT_Zeile:='<UT_Par_func_result_type_rd>';
    UT_Par_func_result_rd        : UT_Zeile:='<UT_Par_func_result_rd>';
    UT_Par_func_end              : UT_Zeile:='<UT_Par_func_end>';
    UT_Par_func_call_exec        : UT_Zeile:='<UT_Par_func_call_exec>';

    UT_Par_asm_start             : UT_Zeile:='<UT_Par_asm_start>';

    UT_Par_ftd_ziel              : UT_Zeile:='<UT_Par_ftd_ziel>';
    UT_Par_ftd_vergl             : UT_Zeile:='<UT_Par_ftd_vergl>';
    UT_Par_ftd_loop              : UT_Zeile:='<UT_Par_ftd_loop>';
    UT_Par_ftd_to                : UT_Zeile:='<UT_Par_ftd_to>';
    UT_Par_ftd_downto            : UT_Zeile:='<UT_Par_ftd_downto>';

    UT_Par_loop_start            : UT_Zeile:='<UT_Par_loop_start>';
    UT_Par_loop_end              : UT_Zeile:='<UT_Par_loop_end>';

    UT_Par_if_then_init          : UT_Zeile:='<UT_Par_if_then_init>';
    UT_Par_if_then_start         : UT_Zeile:='<UT_Par_if_then_start>';
    UT_Par_if_then_else          : UT_Zeile:='<UT_Par_if_then_else>';
    UT_Par_if_then_end           : UT_Zeile:='<UT_Par_if_then_end>';

    UT_Par_inc                   : UT_Zeile:='<UT_Par_inc>';
    UT_Par_dec                   : UT_Zeile:='<UT_Par_dec>';
    UT_Par_shl                   : UT_Zeile:='<UT_Par_shl>';
    UT_Par_shr                   : UT_Zeile:='<UT_Par_shr>';
    UT_Par_nop                   : UT_Zeile:='<UT_Par_nop>';

    UT_Par_setbit                : UT_Zeile:='<UT_Par_setbit>';
    UT_Par_clearbit              : UT_Zeile:='<UT_Par_clearbit>';

    UT_Par_while_init            : UT_Zeile:='<UT_Par_while_init>';
    UT_Par_while_start           : UT_Zeile:='<UT_Par_while_start>';
    UT_Par_while_end             : UT_Zeile:='<UT_Par_while_end>';

    UT_Par_case_var              : UT_Zeile:='<UT_Par_case_var>';
    UT_Par_case_element          : UT_Zeile:='<UT_Par_case_element>';
    UT_Par_case_ele_ein          : UT_Zeile:='<UT_Par_case_ele_ein>';
    UT_Par_case_ele_ber          : UT_Zeile:='<UT_Par_case_ele_ber>';
    UT_Par_case_ele_lis          : UT_Zeile:='<UT_Par_case_ele_lis>';
    UT_Par_case_ele_lis_end      : UT_Zeile:='<UT_Par_case_ele_lis_end>';

    UT_Par_case_else             : UT_Zeile:='<UT_Par_case_else>';
    UT_Par_case_end              : UT_Zeile:='<UT_Par_case_end>';

    UT_Par_isr_name_rd           : UT_Zeile:='<UT_Par_isr_name_rd>';
    UT_Par_isr_name_cp           : UT_Zeile:='<UT_Par_isr_name_cp>';
    UT_Par_EnableInts            : UT_Zeile:='<UT_Par_EnableInts>';
    UT_Par_DisableInts           : UT_Zeile:='<UT_Par_DisableInts>';
    UT_Par_isrl_nr               : UT_Zeile:='<UT_Par_isrl_nr>';
    UT_Par_isrl_org              : UT_Zeile:='<UT_Par_isrl_org>';
    UT_Par_isrl_isr              : UT_Zeile:='<UT_Par_isrl_isr>';
    UT_Par_isrl_bez              : UT_Zeile:='<UT_Par_isrl_bez>';

  else
    UT_Zeile:='*** Fehler (UT) ***';
  end; { case SI_ARR[SC_Zaehler_ZE2].Unter_Typ of }
  Result:=UT_Zeile;
end; { function UnterTyp_in_Bezeichner }






function Compiler_class.UnterTyp_in_Bezeichnertext(UnterTyp : SI_Unter_Typ) : String;
var
  UT_Zeile : String;
begin
  case UnterTyp of
    kein_UT             : UT_Zeile:='<kein_UT>';
    { ## Untertyp fuer Zahlen ## }
    UT_Dezi_Zahl        : UT_Zeile:='Dezimalzahl';
    UT_Bin_Zahl         : UT_Zeile:='Binaerzahl';
    UT_Hex_Zahl         : UT_Zeile:='Hexadezimalzahl';
    { ## Untertyp fuer Char ## }
    UT_Char             : UT_Zeile:='Zeichen (Char)';
    { ## Untertyp fuer Zeichenkette ## }
    UT_String           : UT_Zeile:='Zeichenkette (String)';
    { ## Untertyp fuer Zeichen ## }
    UT_Zei_DZ_KG        : UT_Zeile:='<=';
    UT_Zei_DZ_GG        : UT_Zeile:='>=';
    UT_Zei_DZ_DG        : UT_Zeile:=':=';
    UT_Zei_DZ_UG        : UT_Zeile:='<>';
    UT_Zei_PLUS         : UT_Zeile:='+';
    UT_Zei_MINUS        : UT_Zeile:='-';
    UT_Zei_MAL          : UT_Zeile:='*';
    UT_Zei_DURCH        : UT_Zeile:='/';
    UT_Zei_SEMI         : UT_Zeile:=';';
    UT_Zei_DP           : UT_Zeile:=':';
    UT_Zei_KOMMAR       : UT_Zeile:=',';
    UT_Zei_PUNKT        : UT_Zeile:='.';
    UT_Zei_GLEICH       : UT_Zeile:='=';
    UT_Zei_KA           : UT_Zeile:='(';
    UT_Zei_KZ           : UT_Zeile:=')';
    UT_Zei_KLEINER      : UT_Zeile:='<';
    UT_Zei_GROESSER     : UT_Zeile:='>';
    UT_Zei_EKA          : UT_Zeile:='[';
    UT_Zei_EKZ          : UT_Zeile:=']';
    UT_Zei_SS           : UT_Zeile:='|';
    { ## Untertyp fuer Bezeichner ## }
    UT_Bezeichner_PAR     : UT_Zeile:='Parameter';
    UT_Bez_PROGRAM        : UT_Zeile:='PROGRAM';
    UT_Bez_DEVICE         : UT_Zeile:='DEVICE';
    UT_Bez_IMPORT         : UT_Zeile:='IMPORT';
    UT_Bez_DEFINE         : UT_Zeile:='DEFINE';
    UT_Bez_IMPLEMENTATION : UT_Zeile:='IMPLEMENTATION';
    UT_Bez_END            : UT_Zeile:='END';
    UT_Bez_VAR            : UT_Zeile:='VAR';
    UT_Bez_CONST          : UT_Zeile:='CONST';
    UT_Bez_BEGIN          : UT_Zeile:='BEGIN';
    UT_Bez_PROCEDURE      : UT_Zeile:='PROCEDURE';
    UT_Bez_FUNCTION       : UT_Zeile:='FUNCTION';
    UT_Bez_ASM            : UT_Zeile:='ASM';
    UT_Bez_ENDASM         : UT_Zeile:='ENDASM';
    UT_Bez_RESULT         : UT_Zeile:='RESULT';
    UT_Bez_FOR            : UT_Zeile:='FOR';
    UT_Bez_TO             : UT_Zeile:='TO';
    UT_Bez_DOWNTO         : UT_Zeile:='DOWNTO';
    UT_Bez_DO             : UT_Zeile:='DO';
    UT_Bez_ENDFOR         : UT_Zeile:='ENDFOR';
    UT_Bez_LOOP           : UT_Zeile:='LOOP';
    UT_Bez_ENDLOOP        : UT_Zeile:='ENDLOOP';

    UT_Bez_IF             : UT_Zeile:='IF';
    UT_Bez_THEN           : UT_Zeile:='THEN';
    UT_Bez_ELSE           : UT_Zeile:='ELSE';
    UT_Bez_ENDIF          : UT_Zeile:='ENDIF';

    UT_Bez_INC            : UT_Zeile:='INC';
    UT_Bez_DEC            : UT_Zeile:='DEC';
    UT_Bez_SHL            : UT_Zeile:='SHL';
    UT_Bez_SHR            : UT_Zeile:='SHR';
    UT_Bez_NOP            : UT_Zeile:='NOP';

    UT_Bez_DIV            : UT_Zeile:='DIV';
    UT_Bez_MOD            : UT_Zeile:='MOD';
    UT_Bez_IN             : UT_Zeile:='IN';
    UT_Bez_AND            : UT_Zeile:='AND';
    UT_Bez_OR             : UT_Zeile:='OR';

    UT_Bez_ARRAY          : UT_Zeile:='ARRAY';
    UT_Bez_OF             : UT_Zeile:='OF';

    UT_Bez_SETBIT         : UT_Zeile:='SETBIT';
    UT_Bez_CLEARBIT       : UT_Zeile:='CLEARBIT';

    UT_Bez_BYTETOWORD     : UT_Zeile:='BYTETOWORD';
    UT_Bez_HIGH           : UT_Zeile:='HIGH';
    UT_Bez_LOW            : UT_Zeile:='LOW';
    UT_Bez_BITHIGH        : UT_Zeile:='BITHIGH';
    UT_Bez_BITLOW         : UT_Zeile:='BITLOW';

    UT_Bez_WHILE          : UT_Zeile:='WHILE';
    UT_Bez_ENDWHILE       : UT_Zeile:='ENDWHILE';

    UT_Bez_CASE           : UT_Zeile:='CASE';
    UT_Bez_ENDCASE        : UT_Zeile:='ENDCASE';

    UT_Bez_BYTETOCHAR     : UT_Zeile:='BYTETOCHAR';
    UT_Bez_CHARTOBYTE     : UT_Zeile:='CHARTOBYTE';

    UT_Bez_LENGTH         : UT_Zeile:='LENGTH';

    UT_Bez_DWORDTOBYTE    : UT_Zeile:='DWORDTOBYTE';
    UT_Bez_DWLOW          : UT_Zeile:='DWLOW';
    UT_Bez_DWHIGH         : UT_Zeile:='DWHIGH';
    UT_Bez_WORDTODWORD    : UT_Zeile:='WORDTODWORD';
    UT_Bez_BYTETODWORD    : UT_Zeile:='BYTETODWORD';

    UT_Bez_ISR            : UT_Zeile:='ISR';
    UT_Bez_EnableInts     : UT_Zeile:='ENABLEINTS';
    UT_Bez_DisableInts    : UT_Zeile:='DISABLEINTS';
    UT_Bez_ISR_LISTE      : UT_Zeile:='ISR_LISTE';

  else
    UT_Zeile:='*** Fehlertext (UT) ***  ';
  end; { case SI_ARR[SC_Zaehler_ZE2].Unter_Typ of }
  Result:=UT_Zeile;
end; { function UnterTyp_in_Bezeichnertext }








function Compiler_class.RW_Bez_To_String(RW_Bezeichnung : RW_Bez) : String;
var
  RW_String : String;
begin
  case RW_Bezeichnung of

    RB_keiner             : RW_String:='<RB_keiner>';
    RB_prog               : RW_String:='<RB_prog>';
    RB_prog2              : RW_String:='<RB_prog2>';
    RB_prog3              : RW_String:='<RB_prog3>';
    RB_element            : RW_String:='<RB_element>';
    RB_var_element        : RW_String:='<RB_var_element>';
    RB_var_ele_sch        : RW_String:='<RB_var_ele_sch>';
    RB_var_ele_sch2       : RW_String:='<RB_var_ele_sch2>';
    RB_var_ele_lst        : RW_String:='<RB_var_ele_lst>';
    RB_var_ele_lst2       : RW_String:='<RB_var_ele_lst2>';
    RB_var_varianten      : RW_String:='<RB_var_varianten>';
    RB_var_std            : RW_String:='<RB_var_std>';
    RB_var_bit            : RW_String:='<RB_var_bit>';
    RB_var_bit2           : RW_String:='<RB_var_bit2>';
    RB_var_array          : RW_String:='<RB_var_array>';
    RB_var_array2         : RW_String:='<RB_var_array2>';
    RB_var_array_1D       : RW_String:='<RB_var_array_1D>';
    RB_var_array_2D       : RW_String:='<RB_var_array_2D>';
    RB_var_std2           : RW_String:='<RB_var_std2>';
    RB_var_std3           : RW_String:='<RB_var_std3>';
    RB_var_string         : RW_String:='<RB_var_string>';

    RB_const_ele_sch      : RW_String:='<RB_const_ele_sch>';
    RB_const_ele_sch2     : RW_String:='<RB_const_ele_sch2>';
    RB_const_element      : RW_String:='<RB_const_element>';
    RB_const_type         : RW_String:='<RB_const_type>';
    RB_const_type_grund   : RW_String:='<RB_const_type_grund>';
    RB_const_gt_elemente  : RW_String:='<RB_const_gt_elemente>';
    RB_const_array        : RW_String:='<RB_const_array>';
    RB_const_array2       : RW_String:='<RB_const_array2>';
    RB_const_array3       : RW_String:='<RB_const_array3>';
    RB_const_array_liste  : RW_String:='<RB_const_array_liste>';
    RB_const_array_liste2 : RW_String:='<RB_const_array_liste2>';

    RB_statement_list     : RW_String:='<RB_statement_list>';
    RB_statement_list1    : RW_String:='<RB_statement_list1>';
    RB_statement_list2    : RW_String:='<RB_statement_list2>';
    RB_statement_list3    : RW_String:='<RB_statement_list3>';
    RB_statement_list4    : RW_String:='<RB_statement_list4>';
    RB_statement_list5    : RW_String:='<RB_statement_list5>';
    RB_zuweisung          : RW_String:='<RB_zuweisung>';
    RB_zuweisung2         : RW_String:='<RB_zuweisung2>';
    RB_zuw_ziel_v_array_1d : RW_String:='<RB_zuw_ziel_v_array_1d>';


    RB_zuw_ziel_v_array_2d : RW_String:='<RB_zuw_ziel_v_array_2d>';
    RB_zuw_ziel_v_array_2d_02 : RW_String:='<RB_zuw_ziel_v_array_2d_02>';

    RB_term               : RW_String:='<RB_term >';
    RB_term2              : RW_String:='<RB_term2>';
    RB_term3              : RW_String:='<RB_term3>';
    RB_term4              : RW_String:='<RB_term4>';
    RB_term5              : RW_String:='<RB_term5>';
    RB_term6              : RW_String:='<RB_term6>';
    RB_terme1             : RW_String:='<RB_terme1>';
    RB_terme2             : RW_String:='<RB_terme2>';

    RB_procedure          : RW_String:='<RB_procedure>';
    RB_procedure2         : RW_String:='<RB_procedure2>';
    RB_proc_param         : RW_String:='<RB_proc_param>';
    RB_proc_param2        : RW_String:='<RB_proc_param2>';
    RB_proc_call          : RW_String:='<RB_proc_call>';
    RB_proc_call_par      : RW_String:='<RB_proc_call_par>';
    RB_proc_call_par2     : RW_String:='<RB_proc_call_par2>';
    RB_proc_call_par_lst  : RW_String:='<RB_proc_call_par_lst>';
    RB_proc_call_par_lst2 : RW_String:='<RB_proc_call_par_lst2>';
    RB_proc_par_lst       : RW_String:='<RB_proc_par_lst>';
    RB_proc_par_lst2      : RW_String:='<RB_proc_par_lst2>';
    RB_fak_fkt            : RW_String:='<RB_fak_fkt>';
    RB_fak_con_arr        : RW_String:='<RB_fak_con_arr>';
    RB_zuw_quelle_var_arr_1d : RW_String:='<RB_zuw_quelle_var_arr_1d>';
    RB_zuw_quelle_var_arr_2d : RW_String:='<RB_zuw_quelle_var_arr_2d>';
    RB_zuw_quelle_var_arr_2d_02 : RW_String:='<RB_zuw_quelle_var_arr_2d_02>';
    RB_fak_b2c            : RW_String:='<RB_fak_b2c>';
    RB_fak_c2b            : RW_String:='<RB_fak_c2b>';


    RB_asm                : RW_String:='<RB_asm>';
    RB_inc                : RW_String:='<RB_inc>';
    RB_dec                : RW_String:='<RB_dec>';
    RB_shl                : RW_String:='<RB_shl>';
    RB_shr                : RW_String:='<RB_shr>';
    RB_nop                : RW_String:='<RB_nop>';
    RB_function           : RW_String:='<RB_function>';
    RB_function2          : RW_String:='<RB_function2>';
    RB_function3          : RW_String:='<RB_function3>';
    RB_func_call          : RW_String:='<RB_func_call>';
    RB_func_call_par      : RW_String:='<RB_func_call_par>';
    RB_func_call_par2     : RW_String:='<RB_func_call_par2>';
    RB_func_return        : RW_String:='<RB_func_return>';
    RB_for_to_do          : RW_String:='<RB_for_to_do>';
    RB_for_to_do2         : RW_String:='<RB_for_to_do2>';
    RB_for_to_do3         : RW_String:='<RB_for_to_do3>';
    RB_for_to_downto      : RW_String:='<RB_for_to_downto>';
    RB_for_to_downto2     : RW_String:='<RB_for_to_downto2>';
    RB_for_to_downto3     : RW_String:='<RB_for_to_downto3>';

    RB_proc_VAR           : RW_String:='<RB_proc_VAR>';
    RB_proc_VAR2          : RW_String:='<RB_proc_VAR2>';
    RB_proc_VAR3          : RW_String:='<RB_proc_VAR3>';
    RB_proc_VAR4          : RW_String:='<RB_proc_VAR4>';

    RB_loop               : RW_String:='<RB_loop>';
    RB_loop2              : RW_String:='<RB_loop2>';

    RB_if_then            : RW_String:='<RB_if_then>';
    RB_if_then2           : RW_String:='<RB_if_then2>';
    RB_if_else            : RW_String:='<RB_if_else>';
    RB_if_else2           : RW_String:='<RB_if_else2>';

    RB_setbit             : RW_String:='<RB_setbit>';
    RB_clearbit           : RW_String:='<RB_clearbit>';

    RB_fak_b2w            : RW_String:='<RB_fak_b2w>';
    RB_fak_low            : RW_String:='<RB_fak_low>';
    RB_fak_high           : RW_String:='<RB_fak_high>';
    RB_fak_bithigh        : RW_String:='<RB_fak_bithigh>';
    RB_fak_bitlow         : RW_String:='<RB_fak_bitlow>';
    RB_fak_length         : RW_String:='<RB_fak_length>';

    RB_fak_dwbyte         : RW_String:='<RB_fak_dwbyte>';
    RB_fak_dwlow          : RW_String:='<RB_fak_dwlow>';
    RB_fak_dwhigh         : RW_String:='<RB_fak_dwhigh>';
    RB_fak_wordtodw       : RW_String:='<RB_fak_wordtodw>';
    RB_fak_bytetodw       : RW_String:='<RB_fak_bytetodw>';

    RB_while              : RW_String:='<RB_while>';
    RB_while2             : RW_String:='<RB_while2>';

    RB_case               : RW_String:='<RB_case>';
    RB_case2              : RW_String:='<RB_case2>';
    RB_case_liste         : RW_String:='<RB_case_liste>';
    RB_case_liste2        : RW_String:='<RB_case_liste2>';
    RB_case_else          : RW_String:='<RB_case_else>';
    RB_case_else2         : RW_String:='<RB_case_else2>';
    RB_case_ele_typ       : RW_String:='<RB_case_ele_typ>';
    RB_case_ele_ein       : RW_String:='<RB_case_ele_ein>';
    RB_case_ele_ber       : RW_String:='<RB_case_ele_ber>';
    RB_case_ele_lis       : RW_String:='<RB_case_ele_lis>';
    RB_case_ele_lis2      : RW_String:='<RB_case_ele_lis2>';
    RB_case_ele_lis3      : RW_String:='<RB_case_ele_lis3>';

    RB_isr                : RW_String:='<RB_isr>';
    RB_isr2               : RW_String:='<RB_isr2>';
    RB_EnableInts         : RW_String:='<RB_EnableInts>';
    RB_DisableInts        : RW_String:='<RB_DisableInts>';
    RB_ISR_LISTE          : RW_String:='<RB_ISR_LISTE>';
    RB_ISR_LISTE2         : RW_String:='<RB_ISR_LISTE2>';
  else
    RW_String:='*** Fehler *** Bez_To_String Eintrag fehlt -';
  end;
  Result:=RW_String;
end; { function Compiler_class.RW_Bez_To_String }









procedure Compiler_class.Start_Compiler;
begin
  Form_RP.ListBox_Meldungen.Items.Add('Compiler wurde gestartet ...');
  PreCompiler;

  if not Fehler_cl.gemeldet then
    Scanner_cl.Scanner(SI_ARR);

  if not Fehler_cl.gemeldet then
    Parser_cl.Parser(SI_ARR);

  if not Fehler_cl.gemeldet then
    ZWC_cl.Start_ZWC;

  if not Fehler_cl.gemeldet then
    Assembler_cl.Start_Assembler;


end; { procedure Compiler_class.Start_Compiler }







destructor Compiler_class.Destroy;
begin
  PC_Source_file.Free;
  SC_Source_file.Free;
  inherited Destroy;
end; { destructor Compiler_class.Destroy }







end.

