unit Modul_Parser;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils,

  CompilerDeklarationen, ZwischenCode;


type

    Parser_class = class(TObject)
    public
      SI_ARR_PAR_zaehler : Integer;
      constructor Create;
      procedure Parser(var PSI_ARR : SI_ARR_type);
      destructor Destroy; override;
    private
      PAR_Datei : TStringList;
      Prozent, letzte_Prozent : LongInt;
      BytePosition : Integer;

      xxx : Integer;

      function Abarbeitung_des_Regelwerkes(var PSI_ARR : SI_ARR_type;
                                           RW_Position, Tiefe : Integer) : Boolean;
    end; { Parser_class = class(TObject) }








var
  Parser_cl : Parser_class;

implementation

uses
  Main_Unit, Modul_Compiler, Modul_Scanner;




{
***************************************************
*
*                P A R S E R
*
***************************************************
}



constructor Parser_class.Create;
begin
  inherited Create;
  xxx:=1;

end;  { constructor Parser_class.Create }






function Parser_class.Abarbeitung_des_Regelwerkes(var PSI_ARR : SI_ARR_type;
                                                  RW_Position, Tiefe : Integer) : Boolean;
var
  RecArray_zaehler, Z_Tiefe : Integer;
  akt_RW_REC : RW_REC;
  Ab_RW_laeuft, Regel_erfolgreich, eine_Regel_erfolgreich : Boolean;
  MB_Zeile, S_Tiefe : String;




    procedure Parserlauf_in_LOG_Datei_Kopf;
    var
      L_Zeile : String;
      L_Zaehler : Integer;
    begin
      PAR_Datei.Add(S_Tiefe+';-------------------------------- ('+IntToStr(Tiefe)+')');

      L_Zeile:=S_Tiefe+'Bezeichner:'+Compiler_cl.RW_Bez_To_String(akt_RW_REC.Bez);
      PAR_Datei.Add(L_Zeile);
      PAR_Datei.Add(' ');

      L_Zeile:=S_Tiefe+'Scan:'+Compiler_cl.UnterTyp_in_Bezeichner(PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ)+
                       ' '+PSI_ARR[SI_ARR_PAR_zaehler].parameter;
      PAR_Datei.Add(L_Zeile);
      PAR_Datei.Add(' ');

      for L_Zaehler:=1 to RecArray_LEN do begin
        if akt_RW_REC.Rec[L_Zaehler].RW_SI_Unter_Typ<>kein_UT then begin
          if L_Zaehler=RecArray_zaehler then
            L_Zeile:='-> '
          else
            L_Zeile:='   ';

          L_Zeile:=S_Tiefe+L_Zeile+Compiler_cl.UnterTyp_in_Bezeichner(akt_RW_REC.Rec[L_Zaehler].RW_SI_Unter_Typ);

          if akt_RW_REC.Rec[L_Zaehler].RW_SI_Unter_Typ=UT_Par_call_bez then begin
            L_Zeile:=L_Zeile+' '+Compiler_cl.RW_Bez_To_String(akt_RW_REC.Rec[L_Zaehler].RW_Call_Bez);
          end;

          PAR_Datei.Add(L_Zeile);
        end; { if akt_RW_REC.Rec[RecArray_zaehler].RW_SI_Unter_Typ<>kein_UT then }
      end; { for L_Zaehler:=1 to RecArray_LEN do }
      PAR_Datei.Add(' ');



    end; { procedure Parserlauf_in_LOG_Datei_Kopf }




      procedure Parserlauf_in_LOG_Datei_Fuss;
      var
        L_Zeile : String;
      begin

        case akt_RW_REC.Typ of
          RW_UND_REC          : L_Zeile:=S_Tiefe+'RW_UND_REC';
          RW_0_1_REC          : L_Zeile:=S_Tiefe+'RW_0_1_REC';
          RW_ODER_SCH_0_N_REC : L_Zeile:=S_Tiefe+'RW_ODER_SCH_0_N_REC';
          RW_ODER_REC         : L_Zeile:=S_Tiefe+'RW_ODER_REC';
        end;

        if Regel_erfolgreich then begin
          PAR_Datei.Add(L_Zeile+' - Regel_erfolgreich=true');
          PAR_Datei.Add(' ');
        end
        else begin
          PAR_Datei.Add(L_Zeile+' - Regel_erfolgreich=false');
          PAR_Datei.Add(' ');
        end;

        if Fehler_cl.gemeldet then begin
          PAR_Datei.Add(S_Tiefe+'*** Fehler gemeldet *** ('+Fehler_cl.Text+')');
          PAR_Datei.Add(' ');
        end; { if Fehler_cl.gemeldet then }

      end; { procedure Parserlauf_in_LOG_Datei_Fuss }




  function PROC_UT_Parser_call_bez : Boolean;
  var
    Bez_Position, RW_CONST_counter : Integer;
    Regel_CB_erfolgreich : Boolean;
  begin
    Bez_Position:=0;
    Regel_CB_erfolgreich:=false;

    for RW_CONST_counter:=1 to RW_LEN do begin
      if RW_CONST[RW_CONST_counter].Bez=akt_RW_REC.Rec[RecArray_zaehler].RW_Call_Bez then
        Bez_Position:=RW_CONST_counter;

    end; { for RW_CONST_counter:=1 to RW_LEN do }
    if Bez_Position>0 then begin

      if Form_RP.CheckBox_TRC_Datei then
        PAR_Datei.Add(S_Tiefe+';>>>>>>>>>>>>>>>>>>>>>');


      Regel_CB_erfolgreich:=Abarbeitung_des_Regelwerkes(PSI_ARR,Bez_Position,Tiefe+1);

      if Form_RP.CheckBox_TRC_Datei then begin
        PAR_Datei.Add(S_Tiefe+';<<<<<<<<<<<<<<<<<<<<<');
        Parserlauf_in_LOG_Datei_Kopf;
      end;

    end
    else
      Fehler_cl.Registrieren('Modul_Parser/Abarbeitung_des_Regelwerkes/PROC_UT_Parser_call_bez',
                             'Element: '+
                             Compiler_cl.RW_Bez_To_String(akt_RW_REC.Rec[RecArray_zaehler].RW_Call_Bez)+
                             ' in Regelwerk nicht gefunden',
                             PSI_ARR[SI_ARR_PAR_zaehler].datei,
                             PSI_ARR[SI_ARR_PAR_zaehler].zeile,
                             PSI_ARR[SI_ARR_PAR_zaehler].spalte);

    Result:=Regel_CB_erfolgreich;

  end; { procedure PROC_UT_Parser_call_bez }




  procedure Inc_SI_ARR;
  var
    st_pro : String;
    li_pro : LongInt;
  begin
    Inc(SI_ARR_PAR_zaehler);
    if SI_ARR_PAR_zaehler>LEN_SI_ARR then
      Fehler_cl.Registrieren('Compiler/Abarbeitung_des_Regelwerkes/Inc_SI_ARR',
                             'SI_ARR_PAR_zaehler>LEN_SI_ARR - Array-Zeiger ausserhalb des Bereiches ('+
                             IntToStr(LEN_SI_ARR)+')',
                             PSI_ARR[SI_ARR_PAR_zaehler].datei,
                             PSI_ARR[SI_ARR_PAR_zaehler].zeile,
                             PSI_ARR[SI_ARR_PAR_zaehler].spalte);

    li_pro:=SI_ARR_PAR_zaehler*100 div Scanner_cl.SI_REC_CNT;

    if li_pro>Prozent then begin

      letzte_Prozent:=Prozent;
      Prozent:=li_pro;

      st_pro:=IntToStr(li_pro);

      if Length(st_pro)<2 then
        st_pro:=' '+st_pro;

      if Length(st_pro)<3 then
        st_pro:=' '+st_pro;

      Form_RP.ListBox_Meldungen.Items[Form_RP.ListBox_Meldungen.Items.Count-1]:='Parserlauf : '+st_pro+' %';
      Form_RP.ListBox_Meldungen.Refresh;



    end; { if li_pro>Prozent then }

  end; { procedure Inc_SI_ARR }



  function PROC_UT_Zeichen_auswerten : Boolean;
  var
    Regel_Zei_erfolgreich : Boolean;


    procedure Scan_Zeichen_auswerten(UT_Zeichen : SI_Unter_Typ);
    var
      Name_Bezeichner : String;
    begin
      if PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ=UT_Zeichen then begin
        Regel_Zei_erfolgreich:=true;
        Inc_SI_ARR;

      end
      else begin

        Name_Bezeichner:=Compiler_cl.UnterTyp_in_Bezeichnertext(UT_Zeichen);

        if  akt_RW_REC.Rec[RecArray_zaehler].Ele_erf then
          Fehler_cl.Registrieren('Compiler/Abarbeitung_des_Regelwerkes/PROC_UT_Zeichen_auswerten',
                                 'Zeichen: '+Name_Bezeichner+' erwartet',
                                 PSI_ARR[SI_ARR_PAR_zaehler].datei,
                                 PSI_ARR[SI_ARR_PAR_zaehler].zeile,
                                 PSI_ARR[SI_ARR_PAR_zaehler].spalte);

      end; { if SI_ARR[SI_ARR_PAR_zaehler].Unter_Typ=UT_Bezeichner then }

    end; { procedure Scan_Zeichen_auswerten }


  begin
    Regel_Zei_erfolgreich:=false;

    case akt_RW_REC.Rec[RecArray_zaehler].RW_SI_Unter_Typ of
      UT_Zei_DZ_KG  : Scan_Zeichen_auswerten(UT_Zei_DZ_KG);  { <= }
      UT_Zei_DZ_GG  : Scan_Zeichen_auswerten(UT_Zei_DZ_GG);  { >= }
      UT_Zei_DZ_UG  : Scan_Zeichen_auswerten(UT_Zei_DZ_UG);  { <> }
      UT_Zei_DZ_DG  : Scan_Zeichen_auswerten(UT_Zei_DZ_DG);  { := }
      UT_Zei_PLUS   : Scan_Zeichen_auswerten(UT_Zei_PLUS);   { + }
      UT_Zei_MINUS  : Scan_Zeichen_auswerten(UT_Zei_MINUS);  { - }
      UT_Zei_MAL    : Scan_Zeichen_auswerten(UT_Zei_MAL);    { * }
      UT_Zei_DURCH  : Scan_Zeichen_auswerten(UT_Zei_DURCH);  { / }
      UT_Zei_SEMI   : Scan_Zeichen_auswerten(UT_Zei_SEMI);   { ; }
      UT_Zei_DP     : Scan_Zeichen_auswerten(UT_Zei_DP);     { : }
      UT_Zei_PUNKT  : Scan_Zeichen_auswerten(UT_Zei_PUNKT);  { . }
      UT_Zei_KOMMAR : Scan_Zeichen_auswerten(UT_Zei_KOMMAR); { , }
      UT_Zei_GLEICH : Scan_Zeichen_auswerten(UT_Zei_GLEICH); { = }
      UT_Zei_KA     : Scan_Zeichen_auswerten(UT_Zei_KA);     { ( }
      UT_Zei_KZ     : Scan_Zeichen_auswerten(UT_Zei_KZ);     { ) }
      UT_Zei_EKA    : Scan_Zeichen_auswerten(UT_Zei_EKA);    { [ }
      UT_Zei_EKZ    : Scan_Zeichen_auswerten(UT_Zei_EKZ);    { ] }
      UT_Zei_SS     : Scan_Zeichen_auswerten(UT_Zei_SS);     { | }
      UT_Zei_PUNKT_PUNKT : Scan_Zeichen_auswerten(UT_Zei_PUNKT_PUNKT); { .. }

    else
      Fehler_cl.Registrieren('akt_RW_REC.Rec[RecArray_zaehler].RW_SI_Unter_Typ nicht gefunden',
                             'Fehler im Parser (PROC_UT_Zeichen_auswerten)',
                             PSI_ARR[SI_ARR_PAR_zaehler].datei,
                             PSI_ARR[SI_ARR_PAR_zaehler].zeile,
                             PSI_ARR[SI_ARR_PAR_zaehler].spalte);

    end; { case akt_RW_REC.Rec[RecArray_zaehler].RW_SI_Unter_Typ }

    Result:=Regel_Zei_erfolgreich;
  end; { function PROC_UT_Zeichen_auswerten }





  function PROC_UT_Bezeichner_auswerten : Boolean;
  var
    Regel_Bez_erfolgreich : Boolean;
    Name_Bezeichner : String;
  begin
    Regel_Bez_erfolgreich:=false;

    if PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ=akt_RW_REC.Rec[RecArray_zaehler].RW_SI_Unter_Typ then begin
      Regel_Bez_erfolgreich:=true;
      Inc_SI_ARR;
    end
    else begin
      Name_Bezeichner:=Compiler_cl.UnterTyp_in_Bezeichnertext(akt_RW_REC.Rec[RecArray_zaehler].RW_SI_Unter_Typ);

      if  akt_RW_REC.Rec[RecArray_zaehler].Ele_erf then
        Fehler_cl.Registrieren('Compiler/Abarbeitung_des_Regelwerkes/PROC_UT_Bezeichner_auswerten',
                               'Bezeichner: '+Name_Bezeichner+' erwartet',
                               PSI_ARR[SI_ARR_PAR_zaehler].datei,
                               PSI_ARR[SI_ARR_PAR_zaehler].zeile,
                               PSI_ARR[SI_ARR_PAR_zaehler].spalte);

    end; { if SI_ARR[SI_ARR_PAR_zaehler].Unter_Typ=UT_Bezeichner then }

    Result:=Regel_Bez_erfolgreich;
  end; { function PROC_UT_Bezeichner_auswerten }










  { *** Hauptprogramm *** }



  function PROC_UT_Par_prog_name_rd : Boolean;
  var
    Regel_PN_erfolgreich : Boolean;
  begin
    Regel_PN_erfolgreich:=false;
    if PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ=UT_Bezeichner_PAR then begin
      ZWC_cl.Program_Name:=PSI_ARR[SI_ARR_PAR_zaehler].parameter;
      Regel_PN_erfolgreich:=true;
      Inc_SI_ARR;
    end
    else
      Fehler_cl.Registrieren('Compiler/Abarbeitung_des_Regelwerkes/PROC_UT_Par_prog_name_rd','Programmname erwartet',
                              PSI_ARR[SI_ARR_PAR_zaehler].datei,
                               PSI_ARR[SI_ARR_PAR_zaehler].zeile,
                               PSI_ARR[SI_ARR_PAR_zaehler].spalte);

    Result:=Regel_PN_erfolgreich;
  end; { function PROC_UT_Par_prog_name_rd }





  function PROC_UT_Par_prog_device : Boolean;
  var
    Regel_PD_erfolgreich : Boolean;
  begin
    Regel_PD_erfolgreich:=false;
    if PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ=UT_Bezeichner_PAR then begin
      if ZWC_cl.DEFINE_lesen(PSI_ARR[SI_ARR_PAR_zaehler].parameter) then begin
        Regel_PD_erfolgreich:=true;
        Inc_SI_ARR;
      end;

    end
    else
      Fehler_cl.Registrieren('Compiler/Abarbeitung_des_Regelwerkes/PROC_UT_Par_prog_device',
                             'Name des Devices erwartet <'+PSI_ARR[SI_ARR_PAR_zaehler].parameter+'>',
                             PSI_ARR[SI_ARR_PAR_zaehler].datei,
                             PSI_ARR[SI_ARR_PAR_zaehler].zeile,
                             PSI_ARR[SI_ARR_PAR_zaehler].spalte);

    Result:=Regel_PD_erfolgreich;
  end; { function PROC_UT_Par_prog_device }




  function PROC_UT_Par_prog_kopf : Boolean;
  begin
    ZWC_cl.Kopfteil_Code_Segment;
    Result:=true;
  end; { function PROC_UT_Par_prog_kopf }



  function PROC_UT_Par_prog_jump : Boolean;
  begin
    ZWC_cl.Einsprung_Hauptprogramm_eintragen;
    Result:=true;
  end; { function PROC_UT_Par_prog_jump }



  function PROC_UT_Par_prog_name_cp : Boolean;
  var
    Regel_PN_erfolgreich : Boolean;
  begin
    Regel_PN_erfolgreich:=false;
    if PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ=UT_Bezeichner_PAR then begin
      if ZWC_cl.Program_Name=PSI_ARR[SI_ARR_PAR_zaehler].parameter then begin
        Regel_PN_erfolgreich:=true;
        Inc_SI_ARR;
      end
      else
        Fehler_cl.Registrieren('Compiler/Abarbeitung_des_Regelwerkes/PROC_UT_Par_prog_name_cp',
                               'Programmname ungleich Deklaration:'+ZWC_cl.Program_Name+
                               '/'+PSI_ARR[SI_ARR_PAR_zaehler].parameter,
                              PSI_ARR[SI_ARR_PAR_zaehler].datei,
                              PSI_ARR[SI_ARR_PAR_zaehler].zeile,
                              PSI_ARR[SI_ARR_PAR_zaehler].spalte);

    end
    else
      Fehler_cl.Registrieren('Compiler/Abarbeitung_des_Regelwerkes/PROC_UT_Par_prog_name_cp','Programmname erwartet',
                              PSI_ARR[SI_ARR_PAR_zaehler].datei,
                              PSI_ARR[SI_ARR_PAR_zaehler].zeile,
                              PSI_ARR[SI_ARR_PAR_zaehler].spalte);

    Result:=Regel_PN_erfolgreich;
  end; { function PROC_UT_Par_prog_name_cp }




  { *** VAR *** }


  function PROC_UT_Par_var_name : Boolean;
  var
    Regel_VN_erfolgreich : Boolean;
    Var_Name : String;
  begin
    Regel_VN_erfolgreich:=false;
    if PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ=UT_Bezeichner_PAR then begin
      Var_Name:=PSI_ARR[SI_ARR_PAR_zaehler].parameter;
      if ZWC_cl.VAR_NAME_eintragen(Var_Name) then begin
        Inc_SI_ARR;
        Regel_VN_erfolgreich:=true;
      end;
    end;

    Result:=Regel_VN_erfolgreich;
  end; { function PROC_UT_Par_var_name }



  function PROC_UT_Par_var_liste : Boolean;
  var
    Regel_VN_erfolgreich : Boolean;
    Var_Name : String;
  begin
    Regel_VN_erfolgreich:=false;
    if PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ=UT_Bezeichner_PAR then begin
      Var_Name:=PSI_ARR[SI_ARR_PAR_zaehler].parameter;
      if ZWC_cl.VAR_LISTE_eintragen(Var_Name) then begin
        Inc_SI_ARR;
        Regel_VN_erfolgreich:=true;
      end;
    end;

    Result:=Regel_VN_erfolgreich;
  end; { function PROC_UT_Par_var_liste }




  function PROC_UT_Par_var_type : Boolean;
  var
    Regel_VT_erfolgreich : Boolean;
    Var_Type : String;
  begin
    Regel_VT_erfolgreich:=false;
    if PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ=UT_Bezeichner_PAR then begin
      Var_Type:=PSI_ARR[SI_ARR_PAR_zaehler].parameter;
      if ZWC_cl.VAR_TYPE_eintragen(Var_Type) then begin
        Inc_SI_ARR;
        Regel_VT_erfolgreich:=true;
      end;
    end
    else
      Fehler_cl.Registrieren('Compiler/Abarbeitung_des_Regelwerkes/PROC_UT_Par_var_type','Variablentyp erwartet',
                              PSI_ARR[SI_ARR_PAR_zaehler].datei,
                              PSI_ARR[SI_ARR_PAR_zaehler].zeile,
                              PSI_ARR[SI_ARR_PAR_zaehler].spalte);

    Result:=Regel_VT_erfolgreich;
  end; { function PROC_UT_Par_var_type }















  function PROC_UT_Par_var_bit_reg : Boolean;
  var
    VBR_erfolgreich : Boolean;
    Bit_Var_Reg : String;
  begin
    VBR_erfolgreich:=false;
    if PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ=UT_Bezeichner_PAR then begin
      Bit_Var_Reg:=PSI_ARR[SI_ARR_PAR_zaehler].parameter;
      if ZWC_cl.VAR_BIT_REGISTER_eintragen(Bit_Var_Reg) then begin
        Inc_SI_ARR;
        VBR_erfolgreich:=true;
      end;
    end
    else
      Fehler_cl.Registrieren('Compiler/Abarbeitung_des_Regelwerkes/PROC_UT_Par_var_bit_reg',
                             'Variable oder Register erwartet',
                             PSI_ARR[SI_ARR_PAR_zaehler].datei,
                             PSI_ARR[SI_ARR_PAR_zaehler].zeile,
                             PSI_ARR[SI_ARR_PAR_zaehler].spalte);

    Result:=VBR_erfolgreich;
  end; { function PROC_UT_Par_var_bit_reg }




  function PROC_UT_Par_var_bit_pos : Boolean;
  var
    VBP_erfolgreich : Boolean;
  begin
    VBP_erfolgreich:=false;
    if PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ=UT_Dezi_Zahl then begin

      if ZWC_cl.VAR_BIT_POSITION_eintragen(PSI_ARR[SI_ARR_PAR_zaehler].parameter) then begin
        Inc_SI_ARR;
        VBP_erfolgreich:=true;
      end;

    end
    else
      Fehler_cl.Registrieren('Compiler/Abarbeitung_des_Regelwerkes/PROC_UT_Par_var_bit_pos',
                             'Bitposition erwartet',
                             PSI_ARR[SI_ARR_PAR_zaehler].datei,
                             PSI_ARR[SI_ARR_PAR_zaehler].zeile,
                             PSI_ARR[SI_ARR_PAR_zaehler].spalte);

    Result:=VBP_erfolgreich;
  end; { function PROC_UT_Par_var_bit_pos }





  function PROC_UT_Par_var_bit_type : Boolean;
  var
    Regel_VT_erfolgreich : Boolean;
    Var_Type : String;
  begin
    Regel_VT_erfolgreich:=false;
    if PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ=UT_Bezeichner_PAR then begin
      Var_Type:=PSI_ARR[SI_ARR_PAR_zaehler].parameter;
      if ZWC_cl.VAR_BIT_TYPE_eintragen(Var_Type) then begin
        Inc_SI_ARR;
        Regel_VT_erfolgreich:=true;
      end;
    end
    else
      Fehler_cl.Registrieren('Compiler/Abarbeitung_des_Regelwerkes/PROC_UT_Par_var_bit_type',
                             'Variablen/Register-Type erwartet',
                             PSI_ARR[SI_ARR_PAR_zaehler].datei,
                             PSI_ARR[SI_ARR_PAR_zaehler].zeile,
                             PSI_ARR[SI_ARR_PAR_zaehler].spalte);

    Result:=Regel_VT_erfolgreich;
  end; { function PROC_UT_Par_var_bit_type }






  function PROC_UT_Par_var_array_von : Boolean;
  var
    Regel_VAV_erfolgreich : Boolean;
    Const_Wert : String;
    Const_Type : SI_Unter_Typ;
  begin
    Regel_VAV_erfolgreich:=false;
    if PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ IN [UT_Dezi_Zahl, UT_Bin_Zahl, UT_Hex_Zahl] then begin
      Const_Wert:=PSI_ARR[SI_ARR_PAR_zaehler].parameter;
      Const_Type:=PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ;
      ZWC_cl.VAR_ARRAY_von_eintragen(Const_Wert,Const_Type);
      Regel_VAV_erfolgreich:=true;
      Inc_SI_ARR;
    end
    else
      Fehler_cl.Registrieren('Compiler/Abarbeitung_des_Regelwerkes/PROC_UT_Par_var_array_von',
                             'Anfangswert fuer ARRAY erwartet',
                             PSI_ARR[SI_ARR_PAR_zaehler].datei,
                             PSI_ARR[SI_ARR_PAR_zaehler].zeile,
                             PSI_ARR[SI_ARR_PAR_zaehler].spalte);

    Result:=Regel_VAV_erfolgreich;
  end; { function PROC_UT_Par_var_array_von }




  function PROC_UT_Par_var_array_bis : Boolean;
  var
    Regel_VAB_erfolgreich : Boolean;
    Const_Wert : String;
    Const_Type : SI_Unter_Typ;
  begin
    Regel_VAB_erfolgreich:=false;

    if PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ IN [UT_Dezi_Zahl, UT_Bin_Zahl, UT_Hex_Zahl] then begin
      Const_Wert:=PSI_ARR[SI_ARR_PAR_zaehler].parameter;
      Const_Type:=PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ;
      ZWC_cl.VAR_ARRAY_bis_eintragen(Const_Wert,Const_Type);
      Regel_VAB_erfolgreich:=true;
      Inc_SI_ARR;
    end
    else begin

      if PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ=UT_Bezeichner_PAR then begin
        if ZWC_cl.VAR_ARRAY_CONST_bis_eintragen(PSI_ARR[SI_ARR_PAR_zaehler].parameter) then begin
          Regel_VAB_erfolgreich:=true;
          Inc_SI_ARR;
        end;
      end;

    end; { if PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ IN [UT_Dezi_Zahl, UT_Bin_Zahl, UT_Hex_Zahl] then }

    Result:=Regel_VAB_erfolgreich;
  end; { function PROC_UT_Par_var_array_bis }









  function PROC_UT_Par_var_array_2d_von : Boolean;
  var
    Regel_VAV_erfolgreich : Boolean;
    Const_Wert : String;
    Const_Type : SI_Unter_Typ;
  begin
    Regel_VAV_erfolgreich:=false;
    if PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ IN [UT_Dezi_Zahl, UT_Bin_Zahl, UT_Hex_Zahl] then begin
      Const_Wert:=PSI_ARR[SI_ARR_PAR_zaehler].parameter;
      Const_Type:=PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ;
      ZWC_cl.VAR_ARRAY_2d_von_eintragen(Const_Wert,Const_Type);
      Regel_VAV_erfolgreich:=true;
      Inc_SI_ARR;
    end
    else
      Fehler_cl.Registrieren('Compiler/Abarbeitung_des_Regelwerkes/PROC_UT_Par_var_array_2d_von',
                             'Anfangswert fuer die zweite ARRAY-Dimension erwartet',
                             PSI_ARR[SI_ARR_PAR_zaehler].datei,
                             PSI_ARR[SI_ARR_PAR_zaehler].zeile,
                             PSI_ARR[SI_ARR_PAR_zaehler].spalte);

    Result:=Regel_VAV_erfolgreich;
  end; { function PROC_UT_Par_var_array_2d_von }




  function PROC_UT_Par_var_array_2d_bis : Boolean;
  var
    Regel_VAB_erfolgreich : Boolean;
    Const_Wert : String;
    Const_Type : SI_Unter_Typ;
  begin
    Regel_VAB_erfolgreich:=false;

    if PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ IN [UT_Dezi_Zahl, UT_Bin_Zahl, UT_Hex_Zahl] then begin
      Const_Wert:=PSI_ARR[SI_ARR_PAR_zaehler].parameter;
      Const_Type:=PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ;
      ZWC_cl.VAR_ARRAY_2d_bis_eintragen(Const_Wert,Const_Type);
      Regel_VAB_erfolgreich:=true;
      Inc_SI_ARR;
    end
    else begin

      if PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ=UT_Bezeichner_PAR then begin
        if ZWC_cl.VAR_ARRAY_2d_CONST_bis_eintragen(PSI_ARR[SI_ARR_PAR_zaehler].parameter) then begin
          Regel_VAB_erfolgreich:=true;
          Inc_SI_ARR;
        end;
      end;

    end; { if PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ IN [UT_Dezi_Zahl, UT_Bin_Zahl, UT_Hex_Zahl] then }

    Result:=Regel_VAB_erfolgreich;
  end; { function PROC_UT_Par_var_array_2d_bis }























  function PROC_UT_Par_var_array_type : Boolean;
  var
    Regel_VAT_erfolgreich : Boolean;
  begin
    Regel_VAT_erfolgreich:=false;
    if PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ=UT_Bezeichner_PAR then begin
      ZWC_cl.VAR_ARRAY_Type_eintragen(PSI_ARR[SI_ARR_PAR_zaehler].parameter);
      Inc_SI_ARR;
      Regel_VAT_erfolgreich:=true;
    end;

    Result:=Regel_VAT_erfolgreich;
  end; { function PROC_UT_Par_var_array_type }





  function PROC_UT_Par_var_string : Boolean;
  var
    Regel_VSTR_erfolgreich : Boolean;
 //   Const_Name : String;
  begin
    Regel_VSTR_erfolgreich:=false;
    if PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ=UT_Bezeichner_PAR then begin
      if ZWC_cl.VAR_STRING_Type_eintragen(PSI_ARR[SI_ARR_PAR_zaehler].parameter) then begin
        Inc_SI_ARR;
        Regel_VSTR_erfolgreich:=true;
      end; { if ZWC_cl.VAR_STRING_Type_eintragen(PSI_ARR[SI_ARR_PAR_zaehler].parameter) then }
    end; { if PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ=UT_Bezeichner_PAR then }

    Result:=Regel_VSTR_erfolgreich;
  end; { function PROC_UT_Par_var_string }






  function PROC_UT_Par_var_str_len : Boolean;
  var
    Regel_VSL_erfolgreich : Boolean;
    Const_Wert : String;
    Const_Type : SI_Unter_Typ;
  begin
    Regel_VSL_erfolgreich:=false;
    if PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ IN [UT_Dezi_Zahl, UT_Bin_Zahl, UT_Hex_Zahl] then begin
      Const_Wert:=PSI_ARR[SI_ARR_PAR_zaehler].parameter;
      Const_Type:=PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ;
      ZWC_cl.VAR_STRING_LEN_eintragen(Const_Wert,Const_Type);
      Regel_VSL_erfolgreich:=true;
      Inc_SI_ARR;
    end
    else
      Fehler_cl.Registrieren('Compiler/Abarbeitung_des_Regelwerkes/PROC_UT_Par_var_str_len',
                             'STRING-Laenge erwartet',
                             PSI_ARR[SI_ARR_PAR_zaehler].datei,
                             PSI_ARR[SI_ARR_PAR_zaehler].zeile,
                             PSI_ARR[SI_ARR_PAR_zaehler].spalte);

    Result:=Regel_VSL_erfolgreich;
  end; { function PROC_UT_Par_var_str_len }




  function PROC_UT_Par_var_ende : Boolean;
  begin
    Result:=ZWC_cl.VAR_Ende;
  end; { function PROC_UT_Par_var_ende }







   { *** CONST *** }


  function PROC_UT_Par_const_name : Boolean;
  var
    Regel_CN_erfolgreich : Boolean;
    Const_Name : String;
  begin
    Regel_CN_erfolgreich:=false;
    if PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ=UT_Bezeichner_PAR then begin
      Const_Name:=PSI_ARR[SI_ARR_PAR_zaehler].parameter;
      if ZWC_cl.CONST_NAME_eintragen(Const_Name) then begin
        Inc_SI_ARR;
        Regel_CN_erfolgreich:=true;
      end;
    end;

    Result:=Regel_CN_erfolgreich;
  end; { function PROC_UT_Par_const_name }






  function PROC_UT_Par_const_type : Boolean;
  var
    Regel_CT_erfolgreich : Boolean;
    Const_Type : String;
  begin
    Regel_CT_erfolgreich:=false;
    if PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ=UT_Bezeichner_PAR then begin
      Const_Type:=PSI_ARR[SI_ARR_PAR_zaehler].parameter;
      if ZWC_cl.CONST_TYPE_eintragen(Const_Type) then begin
        Inc_SI_ARR;
        Regel_CT_erfolgreich:=true;
      end;
    end
    else
      Fehler_cl.Registrieren('Compiler/Abarbeitung_des_Regelwerkes/PROC_UT_Par_const_type','Konstantentyp erwartet',
                              PSI_ARR[SI_ARR_PAR_zaehler].datei,
                              PSI_ARR[SI_ARR_PAR_zaehler].zeile,
                              PSI_ARR[SI_ARR_PAR_zaehler].spalte);

    Result:=Regel_CT_erfolgreich;
  end; { function PROC_UT_Par_const_type }




  function PROC_UT_Par_const_wert : Boolean;
  var
    Regel_CW_erfolgreich : Boolean;
    Const_Wert : String;
    Const_Type : SI_Unter_Typ;
  begin
    Regel_CW_erfolgreich:=false;
    if PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ IN [UT_Dezi_Zahl, UT_Bin_Zahl, UT_Hex_Zahl,
                                                 UT_Char, UT_Bez_TRUE, UT_Bez_FALSE, UT_Curr_Zahl,
                                                 UT_String, UT_Char_Zahl] then begin
      Const_Wert:=PSI_ARR[SI_ARR_PAR_zaehler].parameter;
      Const_Type:=PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ;
      if  ZWC_cl.CONST_WERT_eintragen(Const_Wert, Const_Type) then begin
        Regel_CW_erfolgreich:=true;
        Inc_SI_ARR;
      end;
    end; { if PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ IN }

    Result:=Regel_CW_erfolgreich;
  end; { function PROC_UT_Par_const_wert }








  function PROC_UT_Par_const_bez : Boolean;
  var
    Regel_CB_erfolgreich : Boolean;
  begin
    Regel_CB_erfolgreich:=false;

    if PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ=UT_Bezeichner_PAR then begin

      if ZWC_cl.CONST_Bezeichner_eintragen(PSI_ARR[SI_ARR_PAR_zaehler].parameter) then begin
        Regel_CB_erfolgreich:=true;
        Inc_SI_ARR;
      end;

    end; { if SI_ARR[SI_ARR_PAR_zaehler].Unter_Typ=UT_Bezeichner_PAR then }

    Result:=Regel_CB_erfolgreich;
  end; { function PROC_UT_Par_const_bez }








  function PROC_UT_Par_const_operator : Boolean;
  var
    Regel_COP_erfolgreich : Boolean;
  begin
    Regel_COP_erfolgreich:=false;

    if PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ IN [UT_Zei_PLUS, UT_Zei_MINUS,
                                        UT_Zei_MAL, UT_Zei_DURCH] then begin

      case PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ of
        UT_Zei_PLUS  : ZWC_cl.CONST_Operator_eintragen('+');
        UT_Zei_MINUS : ZWC_cl.CONST_Operator_eintragen('-');
        UT_Zei_MAL   : ZWC_cl.CONST_Operator_eintragen('*');
        UT_Zei_DURCH : ZWC_cl.CONST_Operator_eintragen('/');
      end; { case PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ of }

      Regel_COP_erfolgreich:=true;
      Inc_SI_ARR;

    end; { if PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ IN }

    Result:=Regel_COP_erfolgreich;

  end; { function PROC_UT_Par_const_plus_lesen }










  function PROC_UT_Par_const_ende : Boolean;
  begin
    Result:=ZWC_cl.CONST_Term_berechnen;
  end; { function PROC_UT_Par_const_ende }
















  function PROC_UT_Par_const_array_von : Boolean;
  var
    Regel_CAA_erfolgreich : Boolean;
    Const_Wert : String;
    Const_Type : SI_Unter_Typ;
  begin
    Regel_CAA_erfolgreich:=false;
    if PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ IN [UT_Dezi_Zahl, UT_Bin_Zahl, UT_Hex_Zahl] then begin
      Const_Wert:=PSI_ARR[SI_ARR_PAR_zaehler].parameter;
      Const_Type:=PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ;
      if  ZWC_cl.CONST_ARRAY_von_eintragen(Const_Wert,Const_Type) then begin
        Regel_CAA_erfolgreich:=true;
        Inc_SI_ARR;
      end;
    end
    else
      Fehler_cl.Registrieren('Compiler/Abarbeitung_des_Regelwerkes/PROC_UT_Par_const_wert',
                             'Wert fuer Konstante erwartet',
                             PSI_ARR[SI_ARR_PAR_zaehler].datei,
                             PSI_ARR[SI_ARR_PAR_zaehler].zeile,
                             PSI_ARR[SI_ARR_PAR_zaehler].spalte);

    Result:=Regel_CAA_erfolgreich;
  end; { function PROC_UT_Par_const_array_von }




  function PROC_UT_Par_const_array_bis : Boolean;
  var
    Regel_CAE_erfolgreich : Boolean;
    Const_Wert : String;
    Const_Type : SI_Unter_Typ;
  begin
    Regel_CAE_erfolgreich:=false;

    if PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ IN [UT_Dezi_Zahl, UT_Bin_Zahl, UT_Hex_Zahl] then begin
      Const_Wert:=PSI_ARR[SI_ARR_PAR_zaehler].parameter;
      Const_Type:=PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ;
      if  ZWC_cl.CONST_ARRAY_bis_WERT_eintragen(Const_Wert,Const_Type) then begin
        Regel_CAE_erfolgreich:=true;
        Inc_SI_ARR;
      end;
    end;

    if PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ=UT_Bezeichner_PAR then begin
      if ZWC_cl.CONST_ARRAY_bis_CONST_eintragen(PSI_ARR[SI_ARR_PAR_zaehler].parameter) then begin
        Inc_SI_ARR;
        Regel_CAE_erfolgreich:=true;
      end;
    end;

    if not Regel_CAE_erfolgreich then
      Fehler_cl.Registrieren('Compiler/Abarbeitung_des_Regelwerkes/PROC_UT_Par_const_array_bis',
                             'Endwert fuer Konstanten-Array erwartet',
                             PSI_ARR[SI_ARR_PAR_zaehler].datei,
                             PSI_ARR[SI_ARR_PAR_zaehler].zeile,
                             PSI_ARR[SI_ARR_PAR_zaehler].spalte);

    Result:=Regel_CAE_erfolgreich;
  end; { function PROC_UT_Par_const_array_bis }





  function PROC_UT_Par_const_array_type : Boolean;
  var
    Regel_CT_erfolgreich : Boolean;
    Const_Type : String;
  begin
    Regel_CT_erfolgreich:=false;
    if PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ=UT_Bezeichner_PAR then begin
      Const_Type:=PSI_ARR[SI_ARR_PAR_zaehler].parameter;
      if ZWC_cl.CONST_ARRAY_Type_eintragen(Const_Type) then begin
        Inc_SI_ARR;
        Regel_CT_erfolgreich:=true;
      end;
    end
    else
      Fehler_cl.Registrieren('Compiler/Abarbeitung_des_Regelwerkes/PROC_UT_Par_const_array_type','Konstantentyp erwartet',
                              PSI_ARR[SI_ARR_PAR_zaehler].datei,
                              PSI_ARR[SI_ARR_PAR_zaehler].zeile,
                              PSI_ARR[SI_ARR_PAR_zaehler].spalte);

    Result:=Regel_CT_erfolgreich;
  end; { function PROC_UT_Par_const_array_type }








  function PROC_UT_Par_const_array_element : Boolean;
  var
    Regel_CAE_erfolgreich : Boolean;
    Const_Wert : String;
    Const_Type : SI_Unter_Typ;
  begin
    Regel_CAE_erfolgreich:=false;
    if PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ IN [UT_Dezi_Zahl, UT_Bin_Zahl, UT_Hex_Zahl,
                                                 UT_Char, UT_Char_Zahl] then begin
      Const_Wert:=PSI_ARR[SI_ARR_PAR_zaehler].parameter;
      Const_Type:=PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ;
      if  ZWC_cl.CONST_ARRAY_Element_eintragen(Const_Wert,Const_Type) then begin
        Regel_CAE_erfolgreich:=true;
        Inc_SI_ARR;
      end;
    end
    else
      Fehler_cl.Registrieren('Compiler/Abarbeitung_des_Regelwerkes/PROC_UT_Par_const_array_element',
                             'Wert fuer ARRAY-Element erwartet',
                             PSI_ARR[SI_ARR_PAR_zaehler].datei,
                             PSI_ARR[SI_ARR_PAR_zaehler].zeile,
                             PSI_ARR[SI_ARR_PAR_zaehler].spalte);

    Result:=Regel_CAE_erfolgreich;
  end; { function PROC_UT_Par_const_array_element }




  function PROC_UT_Par_const_array_end : Boolean;
  begin
    ZWC_cl.CONST_ARRAY_Ende_eintragen;
    Result:=true;
  end; { function PROC_UT_Par_const_array_end }















  { *** Zuweisungen *** }


  function PROC_UT_Par_zuw_Ziel : Boolean;
  var
    Regel_ZZ_erfolgreich : Boolean;
  begin
    Regel_ZZ_erfolgreich:=false;

    if PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ=UT_Bezeichner_PAR then begin

      if ZWC_cl.Zuweisung_Ziel_eintragen(PSI_ARR[SI_ARR_PAR_zaehler].parameter) then begin
        Regel_ZZ_erfolgreich:=true;
        Inc_SI_ARR;
      end;

    end; { if SI_ARR[SI_ARR_PAR_zaehler].Unter_Typ=UT_Bezeichner_PAR then }

    Result:=Regel_ZZ_erfolgreich;
  end; { function PROC_UT_Par_zuw_Ziel }










  function PROC_UT_Par_zuw_Z_V_ARR_1D : Boolean;
  var
    Regel_ZZ_erfolgreich : Boolean;
  begin
    Regel_ZZ_erfolgreich:=false;

    if PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ=UT_Bezeichner_PAR then begin

      if ZWC_cl.Zuweisung_Ziel_VAR_ARRAY_1D_eintragen(PSI_ARR[SI_ARR_PAR_zaehler].parameter) then begin
        Regel_ZZ_erfolgreich:=true;
        Inc_SI_ARR;
      end;

    end; { if SI_ARR[SI_ARR_PAR_zaehler].Unter_Typ=UT_Bezeichner_PAR then }

    Result:=Regel_ZZ_erfolgreich;
  end; { function PROC_UT_Par_zuw_Z_V_ARR_1D }












  function PROC_UT_Par_zuw_Z_V_ARR_2D : Boolean;
  var
    Regel_ZZ_erfolgreich : Boolean;
  begin
    Regel_ZZ_erfolgreich:=false;

    if PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ=UT_Bezeichner_PAR then begin

      if ZWC_cl.Zuweisung_Ziel_VAR_ARRAY_2D_eintragen(PSI_ARR[SI_ARR_PAR_zaehler].parameter) then begin
        Regel_ZZ_erfolgreich:=true;
        Inc_SI_ARR;
      end;

    end; { if SI_ARR[SI_ARR_PAR_zaehler].Unter_Typ=UT_Bezeichner_PAR then }

    Result:=Regel_ZZ_erfolgreich;
  end; { function PROC_UT_Par_zuw_Z_V_ARR_2D }







  function PROC_UT_Par_zuw_Z_V_ARR_POS_1D : Boolean;
  begin
    ZWC_cl.Zuweisung_Ziel_VAR_ARRAY_POS_1D_eintragen;
    Result:=true;
  end; { function PROC_UT_Par_zuw_Z_V_ARR_POS_1D }






  function PROC_UT_Par_zuw_Z_V_ARR_POS_2D_01 : Boolean;
  begin
    ZWC_cl.Zuweisung_Ziel_VAR_ARRAY_POS_2D_01_eintragen;
    Result:=true;
  end; { function PROC_UT_Par_zuw_Z_V_ARR_POS_2D_01 }




  function PROC_UT_Par_zuw_Z_V_ARR_POS_2D_02 : Boolean;
  begin
    ZWC_cl.Zuweisung_Ziel_VAR_ARRAY_POS_2D_02_eintragen;
    Result:=true;
  end; { function PROC_UT_Par_zuw_Z_V_ARR_POS_2D_02 }








  function PROC_UT_Par_zuw_fak_VAR : Boolean;
  var
    Regel_ZFV_erfolgreich : Boolean;
  begin
    Regel_ZFV_erfolgreich:=false;

    if PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ=UT_Bezeichner_PAR then begin

      if ZWC_cl.Zuweisung_Quelle_VAR_eintragen(PSI_ARR[SI_ARR_PAR_zaehler].parameter) then begin
        Regel_ZFV_erfolgreich:=true;
        Inc_SI_ARR;
      end;

    end; { if SI_ARR[SI_ARR_PAR_zaehler].Unter_Typ=UT_Bezeichner_PAR then }

    Result:=Regel_ZFV_erfolgreich;
  end; { function PROC_UT_Par_zuw_fak_VAR }




  function PROC_UT_Par_zuw_fak_CONST : Boolean;
  var
    Regel_ZFC_erfolgreich : Boolean;
  begin
    Regel_ZFC_erfolgreich:=false;

    if PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ=UT_Bezeichner_PAR then begin

      if ZWC_cl.Zuweisung_Quelle_CONST_eintragen(PSI_ARR[SI_ARR_PAR_zaehler].parameter) then begin
        Regel_ZFC_erfolgreich:=true;
        Inc_SI_ARR;
      end;

    end; { if SI_ARR[SI_ARR_PAR_zaehler].Unter_Typ=UT_Bezeichner_PAR then }

    Result:=Regel_ZFC_erfolgreich;
  end; { function PROC_UT_Par_zuw_fak_CONST }





  function PROC_UT_Par_zuw_fak_CONRD : Boolean;
  var
    Regel_ZFW_erfolgreich, VZ_ist_negativ : Boolean;
    Const_Wert : String;
    Const_Type : SI_Unter_Typ;
  begin
    Regel_ZFW_erfolgreich:=false;
    VZ_ist_negativ:=false;

    if PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ = UT_Zei_MINUS then begin

      if PSI_ARR[SI_ARR_PAR_zaehler+1].Unter_Typ IN [UT_Dezi_Zahl, UT_Bin_Zahl, UT_Hex_Zahl, UT_Char,
                                                     UT_Bez_TRUE, UT_Bez_FALSE, UT_String, UT_Curr_Zahl] then begin
        VZ_ist_negativ:=true;
        Inc_SI_ARR;

      end; { if PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ }

    end; { if PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ = UT_Zei_MINUS then }


    if PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ IN [UT_Dezi_Zahl, UT_Bin_Zahl, UT_Hex_Zahl, UT_Char,
                                                 UT_Bez_TRUE, UT_Bez_FALSE, UT_String, UT_Curr_Zahl] then begin
      Const_Wert:=PSI_ARR[SI_ARR_PAR_zaehler].parameter;
      Const_Type:=PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ;

      if  ZWC_cl.Zuweisung_Quelle_CONRD_eintragen(Const_Wert, Const_Type, VZ_ist_negativ) then begin
        Regel_ZFW_erfolgreich:=true;
        Inc_SI_ARR;
      end; { if  ZWC_cl.Zuweisung_Quelle_CONRD_eintragen(Const_Wert, Const_Type) then }

    end; { if PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ IN }

    Result:=Regel_ZFW_erfolgreich;

  end; { function PROC_UT_Par_zuw_fak_CONRD }




  function PROC_UT_Par_zuw_fak_FKT : Boolean;
  var
    Regel_ZFKT_erfolgreich : Boolean;
  begin
    Regel_ZFKT_erfolgreich:=false;

    if PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ=UT_Bezeichner_PAR then begin

      if ZWC_cl.Zuweisung_Quelle_FKT_eintragen(PSI_ARR[SI_ARR_PAR_zaehler].parameter) then begin
        Regel_ZFKT_erfolgreich:=true;
        Inc_SI_ARR;
      end;

    end; { if SI_ARR[SI_ARR_PAR_zaehler].Unter_Typ=UT_Bezeichner_PAR then }

    Result:=Regel_ZFKT_erfolgreich;
  end; { function PROC_UT_Par_zuw_fak_FKT }





  function PROC_UT_Par_zuw_fak_CON_ARR : Boolean;
  var
    Regel_ZFCA_erfolgreich : Boolean;
  begin
    Regel_ZFCA_erfolgreich:=false;

    if PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ=UT_Bezeichner_PAR then begin

      if ZWC_cl.Zuweisung_Quelle_CONST_ARRAY_eintragen(PSI_ARR[SI_ARR_PAR_zaehler].parameter) then begin
        Regel_ZFCA_erfolgreich:=true;
        Inc_SI_ARR;
      end;

    end; { if SI_ARR[SI_ARR_PAR_zaehler].Unter_Typ=UT_Bezeichner_PAR then }

    Result:=Regel_ZFCA_erfolgreich;
  end; { function PROC_UT_Par_zuw_fak_CON_ARR }













  function PROC_UT_Par_zuw_Q_V_ARR_1D : Boolean;
  var
    Regel_ZFCA_erfolgreich : Boolean;
  begin
    Regel_ZFCA_erfolgreich:=false;

    if PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ=UT_Bezeichner_PAR then begin

      if ZWC_cl.Zuweisung_Quelle_VAR_ARRAY_1D_eintragen(PSI_ARR[SI_ARR_PAR_zaehler].parameter) then begin
        Regel_ZFCA_erfolgreich:=true;
        Inc_SI_ARR;
      end;

    end; { if SI_ARR[SI_ARR_PAR_zaehler].Unter_Typ=UT_Bezeichner_PAR then }

    Result:=Regel_ZFCA_erfolgreich;
  end; { function PROC_UT_Par_zuw_Q_V_ARR_1D }








  function PROC_UT_Par_zuw_Q_V_ARR_2D : Boolean;
  var
    Regel_ZFCA_erfolgreich : Boolean;
  begin
    Regel_ZFCA_erfolgreich:=false;

    if PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ=UT_Bezeichner_PAR then begin

      if ZWC_cl.Zuweisung_Quelle_VAR_ARRAY_2D_eintragen(PSI_ARR[SI_ARR_PAR_zaehler].parameter) then begin
        Regel_ZFCA_erfolgreich:=true;
        Inc_SI_ARR;
      end;

    end; { if SI_ARR[SI_ARR_PAR_zaehler].Unter_Typ=UT_Bezeichner_PAR then }

    Result:=Regel_ZFCA_erfolgreich;
  end; { function PROC_UT_Par_zuw_Q_V_ARR_2D }







  function PROC_UT_Par_zuw_Q_V_ARR_POS_1D : Boolean;
  begin
    ZWC_cl.Zuweisung_Quelle_VAR_ARRAY_POS_1D_eintragen;
    Result:=true;
  end; { function PROC_UT_Par_zuw_Q_V_ARR_POS_1D }



  function PROC_UT_Par_zuw_Q_V_ARR_POS_2D_01 : Boolean;
  begin
    ZWC_cl.Zuweisung_Quelle_VAR_ARRAY_POS_2D_01_eintragen;
    Result:=true;
  end; { function PROC_UT_Par_zuw_Q_V_ARR_POS_1D }



  function PROC_UT_Par_zuw_Q_V_ARR_POS_2D_02 : Boolean;
  begin
    ZWC_cl.Zuweisung_Quelle_VAR_ARRAY_POS_2D_02_eintragen;
    Result:=true;
  end; { function PROC_UT_Par_zuw_Q_V_ARR_POS_1D }













  function PROC_UT_Par_zuw_operator : Boolean;
  var
    Regel_ZO_erfolgreich : Boolean;
  begin
    Regel_ZO_erfolgreich:=false;

    if PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ IN [UT_Zei_DZ_KG, UT_Zei_DZ_GG, UT_Zei_DZ_UG, UT_Zei_GLEICH,
                                                 UT_Zei_KLEINER, UT_Zei_GROESSER,
                                                 UT_Zei_PLUS, UT_Zei_MINUS, UT_Zei_MAL,
                                                 UT_Zei_DURCH, UT_Bez_DIV, UT_Bez_MOD,
                                                 UT_Bez_IN, UT_Bez_AND, UT_Bez_OR] then begin

      if ZWC_cl.Zuweisung_DZ_Operator_eintragen(PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ) then begin

        Regel_ZO_erfolgreich:=true;
        Inc_SI_ARR;

      end; { if ZWC_cl.Zuweisung_DZ_Operator_eintragen(UT_Operator) then }

    end; { if SI_ARR[SI_ARR_PAR_zaehler].Unter_Typ=UT_Bezeichner_PAR then }



    Result:=Regel_ZO_erfolgreich;
  end; { function PROC_UT_Par_zuw_operator }






  function PROC_UT_Par_zuw_fak_B2W : Boolean;
  var
    Regel_B2W_erfolgreich : Boolean;
  begin
    Regel_B2W_erfolgreich:=false;

    if PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ=UT_Bezeichner_PAR then begin

      if ZWC_cl.Zuweisung_Quelle_B2W_eintragen(PSI_ARR[SI_ARR_PAR_zaehler].parameter) then begin
        Regel_B2W_erfolgreich:=true;
        Inc_SI_ARR;
      end;

    end; { if SI_ARR[SI_ARR_PAR_zaehler].Unter_Typ=UT_Bezeichner_PAR then }
    Result:=Regel_B2W_erfolgreich;
  end; { function PROC_UT_Par_zuw_fak_B2W }













  function PROC_UT_Par_zuw_fak_B2C : Boolean;
  var
    Regel_B2C_erfolgreich : Boolean;
  begin
    Regel_B2C_erfolgreich:=false;

    if PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ=UT_Bezeichner_PAR then begin

      if ZWC_cl.Zuweisung_Quelle_B2C_eintragen(PSI_ARR[SI_ARR_PAR_zaehler].parameter) then begin
        Regel_B2C_erfolgreich:=true;
        Inc_SI_ARR;
      end;

    end; { if SI_ARR[SI_ARR_PAR_zaehler].Unter_Typ=UT_Bezeichner_PAR then }
    Result:=Regel_B2C_erfolgreich;
  end; { function PROC_UT_Par_zuw_fak_B2C }



  function PROC_UT_Par_zuw_fak_C2B : Boolean;
  var
    Regel_C2B_erfolgreich : Boolean;
  begin
    Regel_C2B_erfolgreich:=false;

    if PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ=UT_Bezeichner_PAR then begin

      if ZWC_cl.Zuweisung_Quelle_C2B_eintragen(PSI_ARR[SI_ARR_PAR_zaehler].parameter) then begin
        Regel_C2B_erfolgreich:=true;
        Inc_SI_ARR;
      end;

    end; { if SI_ARR[SI_ARR_PAR_zaehler].Unter_Typ=UT_Bezeichner_PAR then }
    Result:=Regel_C2B_erfolgreich;
  end; { function PROC_UT_Par_zuw_fak_C2B }






  function PROC_UT_Par_zuw_fak_HIGH : Boolean;
  var
    Regel_B2W_erfolgreich : Boolean;
  begin
    Regel_B2W_erfolgreich:=false;

    if PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ=UT_Bezeichner_PAR then begin

      if ZWC_cl.Zuweisung_Quelle_HIGH_eintragen(PSI_ARR[SI_ARR_PAR_zaehler].parameter) then begin
        Regel_B2W_erfolgreich:=true;
        Inc_SI_ARR;
      end;

    end; { if SI_ARR[SI_ARR_PAR_zaehler].Unter_Typ=UT_Bezeichner_PAR then }
    Result:=Regel_B2W_erfolgreich;
  end; { function PROC_UT_Par_zuw_fak_HIGH }






  function PROC_UT_Par_zuw_fak_LOW : Boolean;
  var
    Regel_B2W_erfolgreich : Boolean;
  begin
    Regel_B2W_erfolgreich:=false;

    if PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ=UT_Bezeichner_PAR then begin

      if ZWC_cl.Zuweisung_Quelle_LOW_eintragen(PSI_ARR[SI_ARR_PAR_zaehler].parameter) then begin
        Regel_B2W_erfolgreich:=true;
        Inc_SI_ARR;
      end;

    end; { if SI_ARR[SI_ARR_PAR_zaehler].Unter_Typ=UT_Bezeichner_PAR then }
    Result:=Regel_B2W_erfolgreich;
  end; { function PROC_UT_Par_zuw_fak_LOW }




  function PROC_UT_Par_zuw_fak_BITHIGH(HL : Boolean) : Boolean;
  var
    Regel_TB_erfolgreich : Boolean;
  begin
    Regel_TB_erfolgreich:=false;

    if PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ=UT_Bezeichner_PAR then begin

      if ZWC_cl.Zuweisung_Quelle_BITHIGH_eintragen(PSI_ARR[SI_ARR_PAR_zaehler].parameter, HL) then begin
        Regel_TB_erfolgreich:=true;
        Inc_SI_ARR;
      end;

    end; { if SI_ARR[SI_ARR_PAR_zaehler].Unter_Typ=UT_Bezeichner_PAR then }
    Result:=Regel_TB_erfolgreich;
  end; { function PROC_UT_Par_zuw_fak_BITHIGH }







  function PROC_UT_Par_zuw_fak_LENGTH : Boolean;
  var
    Regel_ZL_erfolgreich : Boolean;
  begin
    Regel_ZL_erfolgreich:=false;

    if PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ=UT_Bezeichner_PAR then begin

      if ZWC_cl.Zuweisung_Quelle_LENGTH_eintragen(PSI_ARR[SI_ARR_PAR_zaehler].parameter) then begin
        Regel_ZL_erfolgreich:=true;
        Inc_SI_ARR;
      end;

    end; { if SI_ARR[SI_ARR_PAR_zaehler].Unter_Typ=UT_Bezeichner_PAR then }
    Result:=Regel_ZL_erfolgreich;
  end; { function PROC_UT_Par_zuw_fak_LENGTH }





  function PROC_UT_Par_zuw_fak_DWBYTE1 : Boolean;
  var
    Regel_DWBY_erfolgreich : Boolean;
  begin
    Regel_DWBY_erfolgreich:=false;

    if PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ=UT_Dezi_Zahl then begin

      BytePosition:=StrToInt(PSI_ARR[SI_ARR_PAR_zaehler].parameter);

      if (BytePosition>-1) and (BytePosition<4) then begin
        Regel_DWBY_erfolgreich:=true;
        Inc_SI_ARR;
      end
      else
        Fehler_cl.Registrieren('Compiler/Abarbeitung_des_Regelwerkes/PROC_UT_Par_zuw_fak_DWBYTE1',
                               'Byte-Position muss zwische 0 und 3 liegen',
                               PSI_ARR[SI_ARR_PAR_zaehler].datei,
                               PSI_ARR[SI_ARR_PAR_zaehler].zeile,
                               PSI_ARR[SI_ARR_PAR_zaehler].spalte);

    end { if SI_ARR[SI_ARR_PAR_zaehler].Unter_Typ=UT_Bezeichner_PAR then }
    else
      Fehler_cl.Registrieren('Compiler/Abarbeitung_des_Regelwerkes/PROC_UT_Par_zuw_fak_DWBYTE1',
                             'Byte-Position erwartet',
                             PSI_ARR[SI_ARR_PAR_zaehler].datei,
                             PSI_ARR[SI_ARR_PAR_zaehler].zeile,
                             PSI_ARR[SI_ARR_PAR_zaehler].spalte);


    Result:=Regel_DWBY_erfolgreich;
  end; { function PROC_UT_Par_zuw_fak_DWBYTE1 }





  function PROC_UT_Par_zuw_fak_DWBYTE2 : Boolean;
  var
    Regel_DWBY_erfolgreich : Boolean;
  begin
    Regel_DWBY_erfolgreich:=false;

    if PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ=UT_Bezeichner_PAR then begin

      if ZWC_cl.Zuweisung_Quelle_DWBYTE_eintragen(BytePosition,
                           PSI_ARR[SI_ARR_PAR_zaehler].parameter) then begin
        Regel_DWBY_erfolgreich:=true;
        Inc_SI_ARR;
      end;

    end; { if SI_ARR[SI_ARR_PAR_zaehler].Unter_Typ=UT_Bezeichner_PAR then }
    Result:=Regel_DWBY_erfolgreich;
  end; { function PROC_UT_Par_zuw_fak_DWBYTE2 }





  function PROC_UT_Par_zuw_fak_DWLOW : Boolean;
  var
    Regel_DWL_erfolgreich : Boolean;
  begin
    Regel_DWL_erfolgreich:=false;

    if PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ=UT_Bezeichner_PAR then begin

      if ZWC_cl.Zuweisung_Quelle_DWLOW_eintragen(PSI_ARR[SI_ARR_PAR_zaehler].parameter) then begin
        Regel_DWL_erfolgreich:=true;
        Inc_SI_ARR;
      end;

    end; { if SI_ARR[SI_ARR_PAR_zaehler].Unter_Typ=UT_Bezeichner_PAR then }
    Result:=Regel_DWL_erfolgreich;
  end; { function PROC_UT_Par_zuw_fak_DWLOW }



  function PROC_UT_Par_zuw_fak_DWHIGH : Boolean;
  var
    Regel_DWH_erfolgreich : Boolean;
  begin
    Regel_DWH_erfolgreich:=false;

    if PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ=UT_Bezeichner_PAR then begin

      if ZWC_cl.Zuweisung_Quelle_DWHIGH_eintragen(PSI_ARR[SI_ARR_PAR_zaehler].parameter) then begin
        Regel_DWH_erfolgreich:=true;
        Inc_SI_ARR;
      end;

    end; { if SI_ARR[SI_ARR_PAR_zaehler].Unter_Typ=UT_Bezeichner_PAR then }
    Result:=Regel_DWH_erfolgreich;
  end; { function PROC_UT_Par_zuw_fak_DWHIGH }



  function PROC_UT_Par_zuw_fak_WORDTODW : Boolean;
  var
    Regel_DWH_erfolgreich : Boolean;
  begin
    Regel_DWH_erfolgreich:=false;

    if PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ=UT_Bezeichner_PAR then begin

      if ZWC_cl.Zuweisung_Quelle_WORDTODW_eintragen(PSI_ARR[SI_ARR_PAR_zaehler].parameter) then begin
        Regel_DWH_erfolgreich:=true;
        Inc_SI_ARR;
      end;

    end; { if SI_ARR[SI_ARR_PAR_zaehler].Unter_Typ=UT_Bezeichner_PAR then }
    Result:=Regel_DWH_erfolgreich;
  end; { function PROC_UT_Par_zuw_fak_WORDTODW }



  function PROC_UT_Par_zuw_fak_BYTETODW : Boolean;
  var
    Regel_DWH_erfolgreich : Boolean;
  begin
    Regel_DWH_erfolgreich:=false;

    if PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ=UT_Bezeichner_PAR then begin

      if ZWC_cl.Zuweisung_Quelle_BYTETODW_eintragen(PSI_ARR[SI_ARR_PAR_zaehler].parameter) then begin
        Regel_DWH_erfolgreich:=true;
        Inc_SI_ARR;
      end;

    end; { if SI_ARR[SI_ARR_PAR_zaehler].Unter_Typ=UT_Bezeichner_PAR then }
    Result:=Regel_DWH_erfolgreich;
  end; { function PROC_UT_Par_zuw_fak_BYTETODW }








  function PROC_UT_Par_zuw_abschl : Boolean;
  begin
    ZWC_cl.Zuweisung_in_STM_TAB_eintragen;
    Result:=true;
  end; { function PROC_UT_Par_zuw_abschl }




  { *** PROCEDURE *** }


  // Einschreiben des Deklarations-Namens der Prozedur
  function PROC_UT_Par_proc_name_rd : Boolean;
  var
    Regel_PNR_erfolgreich : Boolean;
  begin
    Regel_PNR_erfolgreich:=false;

    if PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ=UT_Bezeichner_PAR then begin
      Regel_PNR_erfolgreich:=ZWC_cl.PROC_FUNC_name_eintragen(PSI_ARR[SI_ARR_PAR_zaehler].parameter,'P');
      Inc_SI_ARR;
    end
    else
      Fehler_cl.Registrieren('Compiler/Abarbeitung_des_Regelwerkes/PROC_UT_Par_proc_name_rd','PROCEDURE-Name erwartet',
                              PSI_ARR[SI_ARR_PAR_zaehler].datei,
                              PSI_ARR[SI_ARR_PAR_zaehler].zeile,
                              PSI_ARR[SI_ARR_PAR_zaehler].spalte);


    Result:=Regel_PNR_erfolgreich;
  end; { function PROC_UT_Par_proc_name_rd }










  // Einschreiben des Namens des laufenden Deklarations-Parameter der Prozedur
  function PROC_UT_Par_proc_par_name_rd : Boolean;
  var
    Regel_PPN_erfolgreich : Boolean;
  begin
    Regel_PPN_erfolgreich:=false;

    if PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ=UT_Bezeichner_PAR then begin

      if ZWC_cl.PROC_FUNC_param_name_eintragen(PSI_ARR[SI_ARR_PAR_zaehler].parameter,'L') then begin
        Regel_PPN_erfolgreich:=true;
        Inc_SI_ARR;
      end; { if ZWC_cl.PROCEDURE_param_name_eintragen(PSI_ARR[SI_ARR_PAR_zaehler].parameter) then }

    end
    else
      Fehler_cl.Registrieren('Compiler/Abarbeitung_des_Regelwerkes/PROC_UT_Par_proc_par_name_rd',
                             'Parameter-Name erwartet',
                             PSI_ARR[SI_ARR_PAR_zaehler].datei,
                             PSI_ARR[SI_ARR_PAR_zaehler].zeile,
                             PSI_ARR[SI_ARR_PAR_zaehler].spalte);


    Result:=Regel_PPN_erfolgreich;
  end; { function PROC_UT_Par_proc_par_name_rd }







  // Einschreiben eines weiteren Namens (zum gleichen Typ) des laufenden Deklarations-Parameter der Prozedur
  function PROC_UT_Par_proc_par_liste_rd : Boolean;
  var
    Regel_PPL_erfolgreich : Boolean;
  begin
    Regel_PPL_erfolgreich:=false;

    if PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ=UT_Bezeichner_PAR then begin
      if ZWC_cl.PROC_FUNC_param_liste_eintragen(PSI_ARR[SI_ARR_PAR_zaehler].parameter,'L') then begin
        Regel_PPL_erfolgreich:=true;
        Inc_SI_ARR;
      end; { if ZWC_cl.PROC_FUNC_param_liste_eintragen(PSI_ARR[SI_ARR_PAR_zaehler].parameter) then }

    end
    else
      Fehler_cl.Registrieren('Compiler/Abarbeitung_des_Regelwerkes/PROC_UT_Par_proc_par_name_rd',
                             'Parameter-Name erwartet',
                             PSI_ARR[SI_ARR_PAR_zaehler].datei,
                             PSI_ARR[SI_ARR_PAR_zaehler].zeile,
                             PSI_ARR[SI_ARR_PAR_zaehler].spalte);


    Result:=Regel_PPL_erfolgreich;
  end; { function PROC_UT_Par_proc_par_liste_rd }



  // Einschreiben des Typs des laufenden Deklarations-Parameter der Prozedur
  function PROC_UT_Par_proc_par_type_rd : Boolean;
  var
    Regel_PPT_erfolgreich : Boolean;
  begin
    Regel_PPT_erfolgreich:=false;

    if PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ=UT_Bezeichner_PAR then begin
      if ZWC_cl.PROC_FUNC_param_type_eintragen(PSI_ARR[SI_ARR_PAR_zaehler].parameter) then begin
        Regel_PPT_erfolgreich:=true;
        Inc_SI_ARR;
      end; { if ZWC_cl.PROCEDURE_param_type_eintragen(PSI_ARR[SI_ARR_PAR_zaehler].parameter) then }
    end
    else
      Fehler_cl.Registrieren('Compiler/Abarbeitung_des_Regelwerkes/PROC_UT_Par_proc_par_type_rd',
                             'Parameter-Typ erwartet',
                             PSI_ARR[SI_ARR_PAR_zaehler].datei,
                             PSI_ARR[SI_ARR_PAR_zaehler].zeile,
                             PSI_ARR[SI_ARR_PAR_zaehler].spalte);


    Result:=Regel_PPT_erfolgreich;
  end; { function PROC_UT_Par_proc_par_type_rd }



  // Vergleichen des Deklarations-Namens der Prozedur am Ende der Deklaration hinter END
  function PROC_UT_Par_proc_name_cp : Boolean;
  var
    Regel_PNC_erfolgreich : Boolean;
  begin
    Regel_PNC_erfolgreich:=false;

    if PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ=UT_Bezeichner_PAR then begin

      if ZWC_cl.PROC_FUNC_name_vergleichen(PSI_ARR[SI_ARR_PAR_zaehler].parameter) then begin
        Regel_PNC_erfolgreich:=true;
        Inc_SI_ARR;
      end; { if ZWC_cl.PROC_FUNC_name_vergleichen(PSI_ARR[SI_ARR_PAR_zaehler].parameter) then }

    end
    else
      Fehler_cl.Registrieren('Compiler/Abarbeitung_des_Regelwerkes/PROC_UT_Par_proc_name_cp',
                             'PROCEDURE-Name erwartet',
                             PSI_ARR[SI_ARR_PAR_zaehler].datei,
                             PSI_ARR[SI_ARR_PAR_zaehler].zeile,
                             PSI_ARR[SI_ARR_PAR_zaehler].spalte);


    Result:=Regel_PNC_erfolgreich;
  end; { function PROC_UT_Par_proc_name_cp }




  // Einschreiben des Namens der lokalen Variable der Prozedur
  function PROC_UT_Par_proc_lvar_name_rd : Boolean;
  var
    Regel_PLN_erfolgreich : Boolean;
  begin
    Regel_PLN_erfolgreich:=false;

    if PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ=UT_Bezeichner_PAR then begin
      if ZWC_cl.PROC_FUNC_param_name_eintragen(PSI_ARR[SI_ARR_PAR_zaehler].parameter,'D') then begin
        Regel_PLN_erfolgreich:=true;
        Inc_SI_ARR;
      end; { if ZWC_cl.PROCEDURE_param_type_eintragen(PSI_ARR[SI_ARR_PAR_zaehler].parameter) then }
    end;

    Result:=Regel_PLN_erfolgreich;
  end; { function PROC_UT_Par_proc_lvar_name_rd }



  // Einschreiben des Namens der lokalen Variable der Prozedur
  function PROC_UT_Par_proc_lvar_liste_rd : Boolean;
  var
    Regel_PLL_erfolgreich : Boolean;
  begin
    Regel_PLL_erfolgreich:=false;

    if PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ=UT_Bezeichner_PAR then begin
      if ZWC_cl.PROC_FUNC_param_liste_eintragen(PSI_ARR[SI_ARR_PAR_zaehler].parameter,'D') then begin
        Regel_PLL_erfolgreich:=true;
        Inc_SI_ARR;
      end; { if ZWC_cl.PROCEDURE_param_type_eintragen(PSI_ARR[SI_ARR_PAR_zaehler].parameter) then }
    end
    else
      Fehler_cl.Registrieren('Compiler/Abarbeitung_des_Regelwerkes/PROC_UT_Par_proc_lvar_name_rd',
                             'Name fuer lokale Variable erwartet',
                             PSI_ARR[SI_ARR_PAR_zaehler].datei,
                             PSI_ARR[SI_ARR_PAR_zaehler].zeile,
                             PSI_ARR[SI_ARR_PAR_zaehler].spalte);


    Result:=Regel_PLL_erfolgreich;
  end; { function PROC_UT_Par_proc_lvar_liste_rd }




  // Einschreiben des Namens der lokalen Variable der Prozedur
  function PROC_UT_Par_proc_lvar_type_rd : Boolean;
  var
    Regel_PLT_erfolgreich : Boolean;
  begin
    Regel_PLT_erfolgreich:=false;

    if PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ=UT_Bezeichner_PAR then begin
      if ZWC_cl.PROC_FUNC_param_type_eintragen(PSI_ARR[SI_ARR_PAR_zaehler].parameter) then begin
        Regel_PLT_erfolgreich:=true;
        Inc_SI_ARR;
      end; { if ZWC_cl.PROCEDURE_param_type_eintragen(PSI_ARR[SI_ARR_PAR_zaehler].parameter) then }
    end
    else
      Fehler_cl.Registrieren('Compiler/Abarbeitung_des_Regelwerkes/PROC_UT_Par_proc_lvar_name_rd',
                             'Name fuer lokale Variable erwartet',
                             PSI_ARR[SI_ARR_PAR_zaehler].datei,
                             PSI_ARR[SI_ARR_PAR_zaehler].zeile,
                             PSI_ARR[SI_ARR_PAR_zaehler].spalte);


    Result:=Regel_PLT_erfolgreich;
  end; { function PROC_UT_Par_proc_lvar_type_rd }







  { *** CALL PROCEDURE *** }


  // Lesen des Namens einer aufzurufenden Prozedur
  function PROC_UT_Par_proc_call_name : Boolean;
  var
    Regel_PCN_erfolgreich : Boolean;
  begin
    Regel_PCN_erfolgreich:=false;

    if PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ=UT_Bezeichner_PAR then begin
      if ZWC_cl.PCALL_name_vergleichen(PSI_ARR[SI_ARR_PAR_zaehler].parameter) then begin
        Regel_PCN_erfolgreich:=true;
        Inc_SI_ARR;
      end; { if ZWC_cl.PROCEDURE_call_name_vergleichen(PSI_ARR[SI_ARR_PAR_zaehler].parameter) then }
    end;

    Result:=Regel_PCN_erfolgreich;
  end; { function PROC_UT_Par_proc_call_name }




  // Lesen des Parameter-Namens einer aufzurufenden Prozedur
  function PROC_UT_Par_proc_call_par : Boolean;
  var
    Regel_PCP_erfolgreich : Boolean;
    Const_Wert : String;
    Const_Type : SI_Unter_Typ;

  begin
    Regel_PCP_erfolgreich:=false;

    if PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ=UT_Bezeichner_PAR then begin
      if ZWC_cl.PCALL_var_parameter_eintragen(PSI_ARR[SI_ARR_PAR_zaehler].parameter) then begin
        Regel_PCP_erfolgreich:=true;
        Inc_SI_ARR;
      end; { if ZWC_cl.PROCEDURE_call_name_vergleichen(PSI_ARR[SI_ARR_PAR_zaehler].parameter) then }
    end; { if PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ=UT_Bezeichner_PAR then }


    if PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ IN [UT_Dezi_Zahl, UT_Bin_Zahl, UT_Hex_Zahl, UT_Char,
                                                 UT_Bez_TRUE, UT_Bez_FALSE, UT_String] then begin
      Const_Wert:=PSI_ARR[SI_ARR_PAR_zaehler].parameter;
      Const_Type:=PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ;

     if ZWC_cl.PCALL_wert_parameter_eintragen(Const_Wert,Const_Type) then begin
       Regel_PCP_erfolgreich:=true;
       Inc_SI_ARR;
     end; { if ZWC_cl.PROCEDURE_call_name_vergleichen(PSI_ARR[SI_ARR_PAR_zaehler].parameter) then }
   end; { if PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ IN }


    Result:=Regel_PCP_erfolgreich;
  end; { function PROC_UT_Par_proc_call_par }





  function PROC_UT_Par_proc_call_exec : Boolean;
  begin
    Result:=ZWC_cl.PCALL_exec('P');
  end; { function PROC_UT_Par_proc_call_exec }





  { *** ASM *** }



  function PROC_UT_Par_asm_start : Boolean;
  var
    Datei_Nr, ZeiNr_Anfang, ZeiNr_Ende{, SI_ARR_PAR_Fehler} : Integer;
    weiter : Boolean;
    STR_Wert_Anfang, STR_Wert_Ende, STR_Wert_Datei : String;
  begin
    ZeiNr_Anfang:=PSI_ARR[SI_ARR_PAR_zaehler].zeile;
    Datei_Nr:=PSI_ARR[SI_ARR_PAR_zaehler].datei;
 //   SI_ARR_PAR_Fehler:=SI_ARR_PAR_zaehler;
    weiter:=true;
    while weiter do begin
      if PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ=UT_Bez_ENDASM then begin
        weiter:=false;
      end
      else
        Inc_SI_ARR;

      if SI_ARR_PAR_zaehler>Scanner_cl.SI_REC_CNT then begin

        Fehler_cl.Registrieren('Compiler/Abarbeitung_des_Regelwerkes/PROC_UT_Par_asm_start',
                               'Bezeichner <ENDASM> fuer das Ende der Assembleranweisung <ASM> nicht gefunden',
                                PSI_ARR[SI_ARR_PAR_zaehler].datei,
                                PSI_ARR[SI_ARR_PAR_zaehler].zeile,
                                PSI_ARR[SI_ARR_PAR_zaehler].spalte);

        weiter:=false;
      end;

    end; { while weiter do }

    ZeiNr_Ende:=PSI_ARR[SI_ARR_PAR_zaehler].zeile;

    if ZeiNr_Ende>=ZeiNr_Anfang then begin
      STR_Wert_Datei:=IntToStr(Datei_Nr);
      Compiler_cl.STR_Laenge(STR_Wert_Datei,3);

      STR_Wert_Anfang:=IntToStr(ZeiNr_Anfang);
      Compiler_cl.STR_Laenge(STR_Wert_Anfang,4);
      STR_Wert_Anfang:=STR_Wert_Datei+STR_Wert_Anfang;

      STR_Wert_Ende:=IntToStr(ZeiNr_Ende);
      Compiler_cl.STR_Laenge(STR_Wert_Ende,4);
      STR_Wert_Ende:=STR_Wert_Datei+STR_Wert_Ende;

      ZWC_cl.ASM_Zeilen_in_Assembler(STR_Wert_Anfang, STR_Wert_Ende);
    end;

    Result:=true;
  end; { function PROC_UT_Par_asm_start }




  { *** FUNCTION *** }



  function PROC_UT_Par_func_name_rd : Boolean;
  var
    Regel_PFN_erfolgreich : Boolean;
  begin
    Regel_PFN_erfolgreich:=false;

    if PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ=UT_Bezeichner_PAR then begin
      Regel_PFN_erfolgreich:=ZWC_cl.PROC_FUNC_name_eintragen(PSI_ARR[SI_ARR_PAR_zaehler].parameter,'F');
      Inc_SI_ARR;
    end
    else
      Fehler_cl.Registrieren('Compiler/Abarbeitung_des_Regelwerkes/PROC_UT_Par_func_name_rd',
                             'Name der FUNCTION erwartet',
                             PSI_ARR[SI_ARR_PAR_zaehler].datei,
                             PSI_ARR[SI_ARR_PAR_zaehler].zeile,
                             PSI_ARR[SI_ARR_PAR_zaehler].spalte);


    Result:=Regel_PFN_erfolgreich;
  end; { function PROC_UT_Par_func_name_rd }





  function PROC_UT_Par_func_result_type_rd : Boolean;
  var
    Regel_PFN_erfolgreich : Boolean;
  begin
    Regel_PFN_erfolgreich:=false;

    if PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ=UT_Bezeichner_PAR then begin
      Regel_PFN_erfolgreich:=ZWC_cl.FUNCTION_result_type_eintragen(PSI_ARR[SI_ARR_PAR_zaehler].parameter);
      Inc_SI_ARR;
    end
    else
      Fehler_cl.Registrieren('Compiler/Abarbeitung_des_Regelwerkes/PROC_UT_Par_func_result_type_rd',
                             'Typ-Name fuer Funktionswert erwartet',
                             PSI_ARR[SI_ARR_PAR_zaehler].datei,
                             PSI_ARR[SI_ARR_PAR_zaehler].zeile,
                             PSI_ARR[SI_ARR_PAR_zaehler].spalte);

    Result:=Regel_PFN_erfolgreich;
  end; { function PROC_UT_Par_func_result_type_rd }




  function PROC_UT_Par_func_result_rd : Boolean;
  var
    Regel_RET_erfolgreich : Boolean;
    Const_Wert : String;
    Const_Type : SI_Unter_Typ;

  begin
    Regel_RET_erfolgreich:=false;

    if PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ=UT_Bezeichner_PAR then begin
      Regel_RET_erfolgreich:=ZWC_cl.FUNCTION_result_var_const_eintragen(PSI_ARR[SI_ARR_PAR_zaehler].parameter);
      Inc_SI_ARR;
    end
    else begin


      if PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ IN [UT_Dezi_Zahl, UT_Bin_Zahl, UT_Hex_Zahl, UT_Char,
                                                   UT_Bez_TRUE, UT_Bez_FALSE, UT_String] then begin
        Const_Wert:=PSI_ARR[SI_ARR_PAR_zaehler].parameter;
        Const_Type:=PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ;
        if  ZWC_cl.FUNCTION_result_const_eintragen(Const_Wert, Const_Type) then begin
          Regel_RET_erfolgreich:=true;
          Inc_SI_ARR;
        end;


      end
      else
        Fehler_cl.Registrieren('Compiler/Abarbeitung_des_Regelwerkes/PROC_UT_Par_func_result_rd',
                               'RETURN Wert oder Variable erwartet',
                               PSI_ARR[SI_ARR_PAR_zaehler].datei,
                               PSI_ARR[SI_ARR_PAR_zaehler].zeile,
                               PSI_ARR[SI_ARR_PAR_zaehler].spalte);
    end;

    Result:=Regel_RET_erfolgreich;
  end; { function PROC_UT_Par_func_result_rd }




  function PROC_UT_Par_func_end : Boolean;
  var
    Regel_FED_erfolgreich : Boolean;
  begin
    Regel_FED_erfolgreich:=ZWC_cl.FUNCTION_beenden;

    Result:=Regel_FED_erfolgreich;
  end; { function PROC_UT_Par_func_ret_type_rd }




  function PROC_UT_Par_func_call_exec : Boolean;
  begin
    Result:=ZWC_cl.PCALL_exec('F');
  end; { function PROC_UT_Par_func_call_exec }






  { *** FOR TO DO *** }



  function PROC_UT_Par_ftd_ziel : Boolean;
  begin
    ZWC_cl.FTD_Ziel_uebernehmen;
    Result:=true;
  end; { function PROC_UT_Par_ftd_ziel }





  function PROC_UT_Par_ftd_downto : Boolean;
  begin
    ZWC_cl.FTD_Schalter_DOWNTO;
    Result:=true;
  end; { function PROC_UT_Par_ftd_downto }





  function PROC_UT_Par_ftd_to : Boolean;
  begin
    ZWC_cl.FTD_Schalter_TO;
    Result:=true;
  end; { function PROC_UT_Par_ftd_to }





  function PROC_UT_Par_ftd_vergl : Boolean;
  begin
    ZWC_cl.FTD_Vergleich_uebernehmen;
    Result:=true;
  end; { function PROC_UT_Par_ftd_vergl }




  function PROC_UT_Par_ftd_loop : Boolean;
  begin
    ZWC_cl.FTD_Abschluss_der_Schleife;
    Result:=true;
  end; { function PROC_UT_Par_ftd_loop }











  { *** LOOP *** }



  function PROC_UT_Par_loop_start : Boolean;
  begin
    ZWC_cl.loop_start;
    Result:=true;
  end; { function PROC_UT_Par_loop_start }



  function PROC_UT_Par_loop_end : Boolean;
  begin
    ZWC_cl.loop_end;
    Result:=true;
  end; { function PROC_UT_Par_loop_end }




  { *** IF THEN *** }



  function PROC_UT_Par_if_then_init : Boolean;
  begin
    ZWC_cl.if_then_init;
    Result:=true;
  end; { function PROC_UT_Par_if_then_init }




  function PROC_UT_Par_if_then_start : Boolean;
  begin
    ZWC_cl.if_then_start;
    Result:=true;
  end; { function PROC_UT_Par_if_then_start }




  function PROC_UT_Par_if_then_else : Boolean;
  begin
    ZWC_cl.if_then_else;
    Result:=true;
  end; { function PROC_UT_Par_if_then_else }




  function PROC_UT_Par_if_then_end : Boolean;
  begin
    ZWC_cl.if_then_end;
    Result:=true;
  end; { function PROC_UT_Par_if_then_end }




  { *** INC, DEC, SHL, SHR, NOP *** }




  function PROC_UT_Par_inc : Boolean;
  var
    Regel_INC_erfolgreich : Boolean;
  begin
    Regel_INC_erfolgreich:=false;

    if PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ=UT_Bezeichner_PAR then begin
      Regel_INC_erfolgreich:=ZWC_cl.INC_var_lesen(PSI_ARR[SI_ARR_PAR_zaehler].parameter);
      Inc_SI_ARR;
    end
    else
      Fehler_cl.Registrieren('Compiler/Abarbeitung_des_Regelwerkes/PROC_UT_Par_inc',
                             'Variable fuer INC erwartet',
                             PSI_ARR[SI_ARR_PAR_zaehler].datei,
                             PSI_ARR[SI_ARR_PAR_zaehler].zeile,
                             PSI_ARR[SI_ARR_PAR_zaehler].spalte);

    Result:=Regel_INC_erfolgreich;
  end; { function PROC_UT_Par_inc }





  function PROC_UT_Par_dec : Boolean;
  var
    Regel_DEC_erfolgreich : Boolean;
  begin
    Regel_DEC_erfolgreich:=false;

    if PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ=UT_Bezeichner_PAR then begin
      Regel_DEC_erfolgreich:=ZWC_cl.DEC_var_lesen(PSI_ARR[SI_ARR_PAR_zaehler].parameter);
      Inc_SI_ARR;
    end
    else
      Fehler_cl.Registrieren('Compiler/Abarbeitung_des_Regelwerkes/PROC_UT_Par_inc',
                             'Variable fuer DEC erwartet',
                             PSI_ARR[SI_ARR_PAR_zaehler].datei,
                             PSI_ARR[SI_ARR_PAR_zaehler].zeile,
                             PSI_ARR[SI_ARR_PAR_zaehler].spalte);

    Result:=Regel_DEC_erfolgreich;
  end; { function PROC_UT_Par_dec }





  function PROC_UT_Par_shl : Boolean;
  var
    Regel_SHL_erfolgreich : Boolean;
  begin
    Regel_SHL_erfolgreich:=false;

    if PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ=UT_Bezeichner_PAR then begin
      Regel_SHL_erfolgreich:=ZWC_cl.SHL_var_lesen(PSI_ARR[SI_ARR_PAR_zaehler].parameter);
      Inc_SI_ARR;
    end
    else
      Fehler_cl.Registrieren('Compiler/Abarbeitung_des_Regelwerkes/PROC_UT_Par_inc',
                             'Variable fuer SHL erwartet',
                             PSI_ARR[SI_ARR_PAR_zaehler].datei,
                             PSI_ARR[SI_ARR_PAR_zaehler].zeile,
                             PSI_ARR[SI_ARR_PAR_zaehler].spalte);

    Result:=Regel_SHL_erfolgreich;
  end; { function PROC_UT_Par_shl }




  function PROC_UT_Par_shr : Boolean;
  var
    Regel_SHR_erfolgreich : Boolean;
  begin
    Regel_SHR_erfolgreich:=false;

    if PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ=UT_Bezeichner_PAR then begin
      Regel_SHR_erfolgreich:=ZWC_cl.SHR_var_lesen(PSI_ARR[SI_ARR_PAR_zaehler].parameter);
      Inc_SI_ARR;
    end
    else
      Fehler_cl.Registrieren('Compiler/Abarbeitung_des_Regelwerkes/PROC_UT_Par_inc',
                             'Variable fuer SHR erwartet',
                             PSI_ARR[SI_ARR_PAR_zaehler].datei,
                             PSI_ARR[SI_ARR_PAR_zaehler].zeile,
                             PSI_ARR[SI_ARR_PAR_zaehler].spalte);

    Result:=Regel_SHR_erfolgreich;
  end; { function PROC_UT_Par_shr }




  function PROC_UT_Par_nop : Boolean;
  begin
    ZWC_cl.NOP_schreiben;
    Result:=true;
  end; { function PROC_UT_Par_nop }





  function PROC_UT_Par_setbit : Boolean;
  var
    Regel_SB_erfolgreich : Boolean;
  begin
    Regel_SB_erfolgreich:=false;

    if PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ=UT_Bezeichner_PAR then begin
      Regel_SB_erfolgreich:=ZWC_cl.SETBIT_var_lesen(PSI_ARR[SI_ARR_PAR_zaehler].parameter);
      Inc_SI_ARR;
    end
    else
      Fehler_cl.Registrieren('Compiler/Abarbeitung_des_Regelwerkes/PROC_UT_Par_setbit',
                             'Variable fuer SetBit erwartet',
                             PSI_ARR[SI_ARR_PAR_zaehler].datei,
                             PSI_ARR[SI_ARR_PAR_zaehler].zeile,
                             PSI_ARR[SI_ARR_PAR_zaehler].spalte);

    Result:=Regel_SB_erfolgreich;
  end; { function PROC_UT_Par_setbit }





  function PROC_UT_Par_clearbit : Boolean;
  var
    Regel_CB_erfolgreich : Boolean;
  begin
    Regel_CB_erfolgreich:=false;

    if PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ=UT_Bezeichner_PAR then begin
      Regel_CB_erfolgreich:=ZWC_cl.CLEARBIT_var_lesen(PSI_ARR[SI_ARR_PAR_zaehler].parameter);
      Inc_SI_ARR;
    end
    else
      Fehler_cl.Registrieren('Compiler/Abarbeitung_des_Regelwerkes/PROC_UT_Par_clearbit',
                             'Variable fuer ClearBit erwartet',
                             PSI_ARR[SI_ARR_PAR_zaehler].datei,
                             PSI_ARR[SI_ARR_PAR_zaehler].zeile,
                             PSI_ARR[SI_ARR_PAR_zaehler].spalte);

    Result:=Regel_CB_erfolgreich;
  end; { function PROC_UT_Par_clearbit }




    { *** WHILE DO *** }



  function PROC_UT_Par_while_init : Boolean;
  begin
    ZWC_cl.while_init;
    Result:=true;
  end; { function PROC_UT_Par_while_init }




  function PROC_UT_Par_while_start : Boolean;
  begin
    ZWC_cl.while_start;
    Result:=true;
  end; { function PROC_UT_Par_while_start }




  function PROC_UT_Par_while_end : Boolean;
  begin
    ZWC_cl.while_end;
    Result:=true;
  end; { function PROC_UT_Par_while_end }





  { *** CASE OF *** }




  function PROC_UT_Par_case_var : Boolean;
  var
    Regel_CV_erfolgreich : Boolean;
  begin
    Regel_CV_erfolgreich:=false;

    if PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ=UT_Bezeichner_PAR then begin
      Regel_CV_erfolgreich:=ZWC_cl.CASE_var_lesen(PSI_ARR[SI_ARR_PAR_zaehler].parameter);
      Inc_SI_ARR;
    end
    else
      Fehler_cl.Registrieren('Compiler/Abarbeitung_des_Regelwerkes/PROC_UT_Par_case_var',
                             'Variable fuer ClearBit erwartet',
                             PSI_ARR[SI_ARR_PAR_zaehler].datei,
                             PSI_ARR[SI_ARR_PAR_zaehler].zeile,
                             PSI_ARR[SI_ARR_PAR_zaehler].spalte);

    Result:=Regel_CV_erfolgreich;
  end; { function PROC_UT_Par_case_var }




  function PROC_UT_Par_case_element : Boolean;
  var
    Regel_CE_erfolgreich : Boolean;
    Element_Wert : String;
    Element_Type : SI_Unter_Typ;
  begin
    Regel_CE_erfolgreich:=false;

    if PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ IN [UT_Dezi_Zahl, UT_Bin_Zahl,
                                                 UT_Hex_Zahl, UT_Char] then begin
      Element_Wert:=PSI_ARR[SI_ARR_PAR_zaehler].parameter;
      Element_Type:=PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ;
      if  ZWC_cl.CASE_Element_Wert_lesen('E',Element_Wert, Element_Type) then begin
        Regel_CE_erfolgreich:=true;
        Inc_SI_ARR;
      end;

    end { if PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ IN }
    else begin

      if PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ=UT_Bezeichner_PAR then begin
        if ZWC_cl.CASE_Element_CONST_lesen('E',PSI_ARR[SI_ARR_PAR_zaehler].parameter) then begin
          Regel_CE_erfolgreich:=true;
          Inc_SI_ARR;
        end;
      end;

    end; { if PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ IN }


    Result:=Regel_CE_erfolgreich;
  end; { function PROC_UT_Par_case_element }





  function PROC_UT_Par_case_ele_ein : Boolean;
  begin
    ZWC_cl.CASE_Einzel_Element;
    Result:=true;
  end; { function PROC_UT_Par_case_ele_ein }




  function PROC_UT_Par_case_ele_ber : Boolean;
  var
    Regel_CE_erfolgreich : Boolean;
    Element_Wert : String;
    Element_Type : SI_Unter_Typ;
  begin
    Regel_CE_erfolgreich:=false;

    if PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ IN [UT_Dezi_Zahl, UT_Bin_Zahl,
                                                 UT_Hex_Zahl, UT_Char] then begin
      Element_Wert:=PSI_ARR[SI_ARR_PAR_zaehler].parameter;
      Element_Type:=PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ;
      if  ZWC_cl.CASE_Element_Wert_lesen('B',Element_Wert, Element_Type) then begin
        Regel_CE_erfolgreich:=true;
        Inc_SI_ARR;
      end;

    end { if PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ IN }
    else begin

      if PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ=UT_Bezeichner_PAR then begin
        if ZWC_cl.CASE_Element_CONST_lesen('B',PSI_ARR[SI_ARR_PAR_zaehler].parameter) then begin
          Regel_CE_erfolgreich:=true;
          Inc_SI_ARR;
        end;
      end;

    end; { if PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ IN }


    Result:=Regel_CE_erfolgreich;
  end; { function PROC_UT_Par_case_ele_ber }










  function PROC_UT_Par_case_ele_lis : Boolean;
  var
    Regel_CE_erfolgreich : Boolean;
    Element_Wert : String;
    Element_Type : SI_Unter_Typ;
  begin
    Regel_CE_erfolgreich:=false;

    if PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ IN [UT_Dezi_Zahl, UT_Bin_Zahl,
                                                 UT_Hex_Zahl, UT_Char] then begin
      Element_Wert:=PSI_ARR[SI_ARR_PAR_zaehler].parameter;
      Element_Type:=PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ;
      if  ZWC_cl.CASE_Element_Wert_lesen('L',Element_Wert, Element_Type) then begin
        Regel_CE_erfolgreich:=true;
        Inc_SI_ARR;
      end;

    end { if PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ IN }
    else begin

      if PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ=UT_Bezeichner_PAR then begin
        if ZWC_cl.CASE_Element_CONST_lesen('L',PSI_ARR[SI_ARR_PAR_zaehler].parameter) then begin
          Regel_CE_erfolgreich:=true;
          Inc_SI_ARR;
        end;
      end;

    end; { if PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ IN }


    Result:=Regel_CE_erfolgreich;
  end; { function PROC_UT_Par_case_ele_lis }





  function PROC_UT_Par_case_ele_lis_end : Boolean;
  begin
    ZWC_cl.CASE_Listen_Element_Ende;
    Result:=true;
  end; { function PROC_UT_Par_case_ele_lis_end }






  function PROC_UT_Par_isr_name_rd : Boolean;
  var
    Regel_ISR_RD_erfolgreich : Boolean;
  begin
    Regel_ISR_RD_erfolgreich:=false;

    if PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ=UT_Bezeichner_PAR then begin
      Regel_ISR_RD_erfolgreich:=ZWC_cl.ISR_NAME_RD(PSI_ARR[SI_ARR_PAR_zaehler].parameter);
      Inc_SI_ARR;
    end
    else
      Fehler_cl.Registrieren('Compiler/Abarbeitung_des_Regelwerkes/PROC_UT_Par_isr_name_rd',
                             'Name fuer ISR erwartet',
                             PSI_ARR[SI_ARR_PAR_zaehler].datei,
                             PSI_ARR[SI_ARR_PAR_zaehler].zeile,
                             PSI_ARR[SI_ARR_PAR_zaehler].spalte);

    Result:=Regel_ISR_RD_erfolgreich;
  end; { function PROC_UT_Par_isr_name_rd }







  function PROC_UT_Par_isr_name_cp : Boolean;
  var
    Regel_ISR_CP_erfolgreich : Boolean;
  begin
    Regel_ISR_CP_erfolgreich:=false;

    if PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ=UT_Bezeichner_PAR then begin
      Regel_ISR_CP_erfolgreich:=ZWC_cl.ISR_NAME_CP(PSI_ARR[SI_ARR_PAR_zaehler].parameter);
      Inc_SI_ARR;
    end
    else
      Fehler_cl.Registrieren('Compiler/Abarbeitung_des_Regelwerkes/PROC_UT_Par_isr_name_cp',
                             'Name fuer ISR erwartet',
                             PSI_ARR[SI_ARR_PAR_zaehler].datei,
                             PSI_ARR[SI_ARR_PAR_zaehler].zeile,
                             PSI_ARR[SI_ARR_PAR_zaehler].spalte);

    Result:=Regel_ISR_CP_erfolgreich;
  end; { function PROC_UT_Par_isr_name_cp }




  function PROC_UT_Par_case_else : Boolean;
  begin
    ZWC_cl.case_else;
    Result:=true;
  end; { function PROC_UT_Par_case_else }



  function PROC_UT_Par_case_end : Boolean;
  begin
    ZWC_cl.case_end;
    Result:=true;
  end; { function PROC_UT_Par_case_end }









  function PROC_UT_Par_EnableInts : Boolean;
  begin
    ZWC_cl.EnableInts;
    Result:=true;
  end; { function PROC_UT_Par_EnableInts }


  function PROC_UT_Par_DisableInts : Boolean;
  begin
    ZWC_cl.DisableInts;
    Result:=true;
  end; { function PROC_UT_Par_DisableInts }







  function PROC_UT_Par_isrl_nr : Boolean;
  var
    Regel_ISR_LISTE_NR_erfolgreich : Boolean;
  begin
    Regel_ISR_LISTE_NR_erfolgreich:=false;

    if PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ=UT_Dezi_Zahl then begin

      if  ZWC_cl.ISR_LISTE_NR(PSI_ARR[SI_ARR_PAR_zaehler].parameter) then begin
        Regel_ISR_LISTE_NR_erfolgreich:=true;
        Inc_SI_ARR;
      end; { if  ZWC_cl.Zuweisung_Quelle_CONRD_eintragen(Const_Wert, Const_Type) then }

    end
    else
      Fehler_cl.Registrieren('Compiler/Abarbeitung_des_Regelwerkes/PROC_UT_Par_ISR_LISTE_NR',
                             'ISR-Nummer fuer ISR-Liste erwartet',
                             PSI_ARR[SI_ARR_PAR_zaehler].datei,
                             PSI_ARR[SI_ARR_PAR_zaehler].zeile,
                             PSI_ARR[SI_ARR_PAR_zaehler].spalte);

    Result:=Regel_ISR_LISTE_NR_erfolgreich;
  end; { function PROC_UT_Par_isrl_nr }






  function PROC_UT_Par_isrl_org : Boolean;
  var
    Regel_ISR_LISTE_ORG_erfolgreich : Boolean;
  begin
    Regel_ISR_LISTE_ORG_erfolgreich:=false;

    if PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ=UT_STRING then begin
      Regel_ISR_LISTE_ORG_erfolgreich:=ZWC_cl.ISR_LISTE_PAR('O',PSI_ARR[SI_ARR_PAR_zaehler].parameter);
      Inc_SI_ARR;
    end
    else
      Fehler_cl.Registrieren('Compiler/Abarbeitung_des_Regelwerkes/PROC_UT_Par_ISR_LISTE_ORG',
                             'ORG-Name fuer ISR-Liste erwartet',
                             PSI_ARR[SI_ARR_PAR_zaehler].datei,
                             PSI_ARR[SI_ARR_PAR_zaehler].zeile,
                             PSI_ARR[SI_ARR_PAR_zaehler].spalte);

    Result:=Regel_ISR_LISTE_ORG_erfolgreich;
  end; { function PROC_UT_Par_isrl_org }





  function PROC_UT_Par_isrl_isr : Boolean;
  var
    Regel_ISR_LISTE_ISR_erfolgreich : Boolean;
  begin
    Regel_ISR_LISTE_ISR_erfolgreich:=false;

    if PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ=UT_STRING then begin
      Regel_ISR_LISTE_ISR_erfolgreich:=ZWC_cl.ISR_LISTE_PAR('I',PSI_ARR[SI_ARR_PAR_zaehler].parameter);
      Inc_SI_ARR;
    end
    else
      Fehler_cl.Registrieren('Compiler/Abarbeitung_des_Regelwerkes/PROC_UT_Par_ISR_LISTE_ISR',
                             'ISR-Name fuer ISR-Liste erwartet',
                             PSI_ARR[SI_ARR_PAR_zaehler].datei,
                             PSI_ARR[SI_ARR_PAR_zaehler].zeile,
                             PSI_ARR[SI_ARR_PAR_zaehler].spalte);

    Result:=Regel_ISR_LISTE_ISR_erfolgreich;
  end; { function PROC_UT_Par_isrl_isr }




  function PROC_UT_Par_isrl_bez : Boolean;
  var
    Regel_ISR_LISTE_BEZ_erfolgreich : Boolean;
  begin
    Regel_ISR_LISTE_BEZ_erfolgreich:=false;

    if PSI_ARR[SI_ARR_PAR_zaehler].Unter_Typ=UT_STRING then begin
      Regel_ISR_LISTE_BEZ_erfolgreich:=ZWC_cl.ISR_LISTE_PAR('B',PSI_ARR[SI_ARR_PAR_zaehler].parameter);
      Inc_SI_ARR;
    end
    else
      Fehler_cl.Registrieren('Compiler/Abarbeitung_des_Regelwerkes/PROC_UT_Par_ISR_LISTE_BEZ',
                             'Bezeichnung fuer ISR-Liste erwartet',
                             PSI_ARR[SI_ARR_PAR_zaehler].datei,
                             PSI_ARR[SI_ARR_PAR_zaehler].zeile,
                             PSI_ARR[SI_ARR_PAR_zaehler].spalte);

    Result:=Regel_ISR_LISTE_BEZ_erfolgreich;
  end; { function PROC_UT_Par_isrl_bez }








begin

  if not Fehler_cl.gemeldet then begin

    S_Tiefe:='';
    for Z_Tiefe:=1 to Tiefe do begin
      S_Tiefe:=S_Tiefe+' ';
    end;

    Regel_erfolgreich:=false;
    eine_Regel_erfolgreich:=false; // fuer ODER

    akt_RW_REC:=RW_CONST[RW_Position];

    RecArray_zaehler:=1;

    Ab_RW_laeuft:=true;
    while Ab_RW_laeuft do begin


      if akt_RW_REC.Rec[RecArray_zaehler].RW_SI_Unter_Typ<>kein_UT then begin
        // normale Regel auswerten

        if Form_RP.CheckBox_TRC_Datei then
          Parserlauf_in_LOG_Datei_Kopf;


        case akt_RW_REC.Rec[RecArray_zaehler].RW_SI_Unter_Typ of
          UT_Par_call_bez                          : Regel_erfolgreich:=PROC_UT_Parser_call_bez;
          UT_Zeichen_Anfang..UT_Zeichen_Ende       : Regel_erfolgreich:=PROC_UT_Zeichen_auswerten;
          UT_Bezeichner_Anfang..UT_Bezeichner_Ende : Regel_erfolgreich:=PROC_UT_Bezeichner_auswerten;

          { - spezielle Parser UT - }
          UT_Par_prog_name_rd                      : Regel_erfolgreich:=PROC_UT_Par_prog_name_rd;
          UT_Par_prog_device                       : Regel_erfolgreich:=PROC_UT_Par_prog_device;
          UT_Par_prog_kopf                         : Regel_erfolgreich:=PROC_UT_Par_prog_kopf;
          UT_Par_prog_jump                         : Regel_erfolgreich:=PROC_UT_Par_prog_jump;
          UT_Par_prog_name_cp                      : Regel_erfolgreich:=PROC_UT_Par_prog_name_cp;

          UT_Par_var_name                          : Regel_erfolgreich:=PROC_UT_Par_var_name;
          UT_Par_var_type                          : Regel_erfolgreich:=PROC_UT_Par_var_type;
          UT_Par_var_liste                         : Regel_erfolgreich:=PROC_UT_Par_var_liste;
          UT_Par_var_bit_reg                       : Regel_erfolgreich:=PROC_UT_Par_var_bit_reg;
          UT_Par_var_bit_pos                       : Regel_erfolgreich:=PROC_UT_Par_var_bit_pos;
          UT_Par_var_bit_type                      : Regel_erfolgreich:=PROC_UT_Par_var_bit_type;
          UT_Par_var_array_von                     : Regel_erfolgreich:=PROC_UT_Par_var_array_von;
          UT_Par_var_array_bis                     : Regel_erfolgreich:=PROC_UT_Par_var_array_bis;





          UT_Par_var_array_2d_von                  : Regel_erfolgreich:=PROC_UT_Par_var_array_2d_von;
          UT_Par_var_array_2d_bis                  : Regel_erfolgreich:=PROC_UT_Par_var_array_2d_bis;





          UT_Par_var_array_type                    : Regel_erfolgreich:=PROC_UT_Par_var_array_type;
          UT_Par_var_string                        : Regel_erfolgreich:=PROC_UT_Par_var_string;
          UT_Par_var_str_len                       : Regel_erfolgreich:=PROC_UT_Par_var_str_len;
          UT_Par_var_ende                          : Regel_erfolgreich:=PROC_UT_Par_var_ende;

          UT_Par_const_name                        : Regel_erfolgreich:=PROC_UT_Par_const_name;
          UT_Par_const_type                        : Regel_erfolgreich:=PROC_UT_Par_const_type;
          UT_Par_const_wert                        : Regel_erfolgreich:=PROC_UT_Par_const_wert;
          UT_Par_const_bez                         : Regel_erfolgreich:=PROC_UT_Par_const_bez;
          UT_Par_const_operator                    : Regel_erfolgreich:=PROC_UT_Par_const_operator;
          UT_Par_const_ende                        : Regel_erfolgreich:=PROC_UT_Par_const_ende;
          UT_Par_const_array_von                   : Regel_erfolgreich:=PROC_UT_Par_const_array_von;
          UT_Par_const_array_bis                   : Regel_erfolgreich:=PROC_UT_Par_const_array_bis;
          UT_Par_const_array_type                  : Regel_erfolgreich:=PROC_UT_Par_const_array_type;
          UT_Par_const_array_element               : Regel_erfolgreich:=PROC_UT_Par_const_array_element;
          UT_Par_const_array_end                   : Regel_erfolgreich:=PROC_UT_Par_const_array_end;

          UT_Par_zuw_Ziel                          : Regel_erfolgreich:=PROC_UT_Par_zuw_Ziel;
          UT_Par_zuw_Z_V_ARR_1D                    : Regel_erfolgreich:=PROC_UT_Par_zuw_Z_V_ARR_1D;
          UT_Par_zuw_Z_V_ARR_POS_1D                : Regel_erfolgreich:=PROC_UT_Par_zuw_Z_V_ARR_POS_1D;

          UT_Par_zuw_Z_V_ARR_2D                    : Regel_erfolgreich:=PROC_UT_Par_zuw_Z_V_ARR_2D;
          UT_Par_zuw_Z_V_ARR_POS_2D_01             : Regel_erfolgreich:=PROC_UT_Par_zuw_Z_V_ARR_POS_2D_01;
          UT_Par_zuw_Z_V_ARR_POS_2D_02             : Regel_erfolgreich:=PROC_UT_Par_zuw_Z_V_ARR_POS_2D_02;

          UT_Par_zuw_fak_VAR                       : Regel_erfolgreich:=PROC_UT_Par_zuw_fak_VAR;
          UT_Par_zuw_fak_CONST                     : Regel_erfolgreich:=PROC_UT_Par_zuw_fak_CONST;
          UT_Par_zuw_fak_CONRD                     : Regel_erfolgreich:=PROC_UT_Par_zuw_fak_CONRD;
          UT_Par_zuw_fak_FKT                       : Regel_erfolgreich:=PROC_UT_Par_zuw_fak_FKT;
          UT_Par_zuw_fak_CON_ARR                   : Regel_erfolgreich:=PROC_UT_Par_zuw_fak_CON_ARR;


          UT_Par_zuw_Q_V_ARR_1D                    : Regel_erfolgreich:=PROC_UT_Par_zuw_Q_V_ARR_1D;
          UT_Par_zuw_Q_V_ARR_POS_1D                : Regel_erfolgreich:=PROC_UT_Par_zuw_Q_V_ARR_POS_1D;

          UT_Par_zuw_Q_V_ARR_2D                    : Regel_erfolgreich:=PROC_UT_Par_zuw_Q_V_ARR_2D;
          UT_Par_zuw_Q_V_ARR_POS_2D_01             : Regel_erfolgreich:=PROC_UT_Par_zuw_Q_V_ARR_POS_2D_01;
          UT_Par_zuw_Q_V_ARR_POS_2D_02             : Regel_erfolgreich:=PROC_UT_Par_zuw_Q_V_ARR_POS_2D_02;





          UT_Par_zuw_operator                      : Regel_erfolgreich:=PROC_UT_Par_zuw_operator;
          UT_Par_zuw_abschl                        : Regel_erfolgreich:=PROC_UT_Par_zuw_abschl;
          UT_Par_zuw_fak_B2W                       : Regel_erfolgreich:=PROC_UT_Par_zuw_fak_B2W;
          UT_Par_zuw_fak_HIGH                      : Regel_erfolgreich:=PROC_UT_Par_zuw_fak_HIGH;
          UT_Par_zuw_fak_LOW                       : Regel_erfolgreich:=PROC_UT_Par_zuw_fak_LOW;
          UT_Par_zuw_fak_BITHIGH                   : Regel_erfolgreich:=PROC_UT_Par_zuw_fak_BITHIGH(true);
          UT_Par_zuw_fak_BITLOW                    : Regel_erfolgreich:=PROC_UT_Par_zuw_fak_BITHIGH(false);
          UT_Par_zuw_fak_B2C                       : Regel_erfolgreich:=PROC_UT_Par_zuw_fak_B2C;
          UT_Par_zuw_fak_C2B                       : Regel_erfolgreich:=PROC_UT_Par_zuw_fak_C2B;
          UT_Par_zuw_fak_LENGTH                    : Regel_erfolgreich:=PROC_UT_Par_zuw_fak_LENGTH;
          UT_Par_zuw_fak_DWBYTE1                   : Regel_erfolgreich:=PROC_UT_Par_zuw_fak_DWBYTE1;
          UT_Par_zuw_fak_DWBYTE2                   : Regel_erfolgreich:=PROC_UT_Par_zuw_fak_DWBYTE2;
          UT_Par_zuw_fak_DWLOW                     : Regel_erfolgreich:=PROC_UT_Par_zuw_fak_DWLOW;
          UT_Par_zuw_fak_DWHIGH                    : Regel_erfolgreich:=PROC_UT_Par_zuw_fak_DWHIGH;
          UT_Par_zuw_fak_WORDTODW                  : Regel_erfolgreich:=PROC_UT_Par_zuw_fak_WORDTODW;
          UT_Par_zuw_fak_BYTETODW                  : Regel_erfolgreich:=PROC_UT_Par_zuw_fak_BYTETODW;

          UT_Par_func_call_exec                    : Regel_erfolgreich:=PROC_UT_Par_func_call_exec;

          UT_Par_proc_name_rd                      : Regel_erfolgreich:=PROC_UT_Par_proc_name_rd;
          UT_Par_proc_name_cp                      : Regel_erfolgreich:=PROC_UT_Par_proc_name_cp;
          UT_Par_proc_par_name_rd                  : Regel_erfolgreich:=PROC_UT_Par_proc_par_name_rd;
          UT_Par_proc_par_liste_rd                 : Regel_erfolgreich:=PROC_UT_Par_proc_par_liste_rd;
          UT_Par_proc_par_type_rd                  : Regel_erfolgreich:=PROC_UT_Par_proc_par_type_rd;

          UT_Par_proc_lvar_name_rd                 : Regel_erfolgreich:=PROC_UT_Par_proc_lvar_name_rd;
          UT_Par_proc_lvar_liste_rd                : Regel_erfolgreich:=PROC_UT_Par_proc_lvar_liste_rd;
          UT_Par_proc_lvar_type_rd                 : Regel_erfolgreich:=PROC_UT_Par_proc_lvar_type_rd;

          UT_Par_proc_call_name                    : Regel_erfolgreich:=PROC_UT_Par_proc_call_name;
          UT_Par_proc_call_par,
          UT_Par_proc_call_par_lst                 : Regel_erfolgreich:=PROC_UT_Par_proc_call_par;
          UT_Par_proc_call_exec                    : Regel_erfolgreich:=PROC_UT_Par_proc_call_exec;

          UT_Par_asm_start                         : Regel_erfolgreich:=PROC_UT_Par_asm_start;

          UT_Par_func_name_rd                      : Regel_erfolgreich:=PROC_UT_Par_func_name_rd;
          UT_Par_func_name_cp                      : Regel_erfolgreich:=PROC_UT_Par_proc_name_cp;
          UT_Par_func_result_type_rd               : Regel_erfolgreich:=PROC_UT_Par_func_result_type_rd;
          UT_Par_func_result_rd                    : Regel_erfolgreich:=PROC_UT_Par_func_result_rd;
          UT_Par_func_end                          : Regel_erfolgreich:=PROC_UT_Par_func_end;

          UT_Par_ftd_ziel                          : Regel_erfolgreich:=PROC_UT_Par_ftd_ziel;
          UT_Par_ftd_vergl                         : Regel_erfolgreich:=PROC_UT_Par_ftd_vergl;
          UT_Par_ftd_loop                          : Regel_erfolgreich:=PROC_UT_Par_ftd_loop;
          UT_Par_ftd_to                            : Regel_erfolgreich:=PROC_UT_Par_ftd_to;
          UT_Par_ftd_downto                        : Regel_erfolgreich:=PROC_UT_Par_ftd_downto;

          UT_Par_loop_start                        : Regel_erfolgreich:=PROC_UT_Par_loop_start;
          UT_Par_loop_end                          : Regel_erfolgreich:=PROC_UT_Par_loop_end;

          UT_Par_if_then_init                      : Regel_erfolgreich:=PROC_UT_Par_if_then_init;
          UT_Par_if_then_start                     : Regel_erfolgreich:=PROC_UT_Par_if_then_start;
          UT_Par_if_then_else                      : Regel_erfolgreich:=PROC_UT_Par_if_then_else;
          UT_Par_if_then_end                       : Regel_erfolgreich:=PROC_UT_Par_if_then_end;

          UT_Par_inc                               : Regel_erfolgreich:=PROC_UT_Par_inc;
          UT_Par_dec                               : Regel_erfolgreich:=PROC_UT_Par_dec;
          UT_Par_shl                               : Regel_erfolgreich:=PROC_UT_Par_shl;
          UT_Par_shr                               : Regel_erfolgreich:=PROC_UT_Par_shr;
          UT_Par_nop                               : Regel_erfolgreich:=PROC_UT_Par_nop;

          UT_Par_setbit                            : Regel_erfolgreich:=PROC_UT_Par_setbit;
          UT_Par_clearbit                          : Regel_erfolgreich:=PROC_UT_Par_clearbit;

          UT_Par_while_init                        : Regel_erfolgreich:=PROC_UT_Par_while_init;
          UT_Par_while_start                       : Regel_erfolgreich:=PROC_UT_Par_while_start;
          UT_Par_while_end                         : Regel_erfolgreich:=PROC_UT_Par_while_end;

          UT_Par_case_var                          : Regel_erfolgreich:=PROC_UT_Par_case_var;
          UT_Par_case_element                      : Regel_erfolgreich:=PROC_UT_Par_case_element;
          UT_Par_case_ele_ein                      : Regel_erfolgreich:=PROC_UT_Par_case_ele_ein;
          UT_Par_case_ele_ber                      : Regel_erfolgreich:=PROC_UT_Par_case_ele_ber;
          UT_Par_case_ele_lis                      : Regel_erfolgreich:=PROC_UT_Par_case_ele_lis;
          UT_Par_case_ele_lis_end                  : Regel_erfolgreich:=PROC_UT_Par_case_ele_lis_end;

          UT_Par_case_else                         : Regel_erfolgreich:=PROC_UT_Par_case_else;
          UT_Par_case_end                          : Regel_erfolgreich:=PROC_UT_Par_case_end;

          UT_Par_isr_name_rd                       : Regel_erfolgreich:=PROC_UT_Par_isr_name_rd;
          UT_Par_isr_name_cp                       : Regel_erfolgreich:=PROC_UT_Par_isr_name_cp;

          UT_Par_EnableInts                        : Regel_erfolgreich:=PROC_UT_Par_EnableInts;
          UT_Par_DisableInts                       : Regel_erfolgreich:=PROC_UT_Par_DisableInts;
          UT_Par_isrl_nr                           : Regel_erfolgreich:=PROC_UT_Par_isrl_nr;
          UT_Par_isrl_org                          : Regel_erfolgreich:=PROC_UT_Par_isrl_org;
          UT_Par_isrl_isr                          : Regel_erfolgreich:=PROC_UT_Par_isrl_isr;
          UT_Par_isrl_bez                          : Regel_erfolgreich:=PROC_UT_Par_isrl_bez;


        else
          MB_Zeile:=Compiler_cl.UnterTyp_in_Bezeichner(akt_RW_REC.Rec[RecArray_zaehler].RW_SI_Unter_Typ);
          Ab_RW_laeuft:=false;
          Regel_erfolgreich:=false;
          Fehler_cl.Registrieren('Compiler/Abarbeitung_des_Regelwerkes','UnterTyp:'+MB_Zeile+' nicht gefunden',
                                 PSI_ARR[SI_ARR_PAR_zaehler].datei,
                                 PSI_ARR[SI_ARR_PAR_zaehler].zeile,
                                 PSI_ARR[SI_ARR_PAR_zaehler].spalte);

        end; { case akt_RW_REC.Rec[RecArray_zaehler].RW_SI_Unter_Typ }

        if Form_RP.CheckBox_TRC_Datei then
          Parserlauf_in_LOG_Datei_Fuss;


        case akt_RW_REC.Typ of
          RW_UND_REC :
            begin
              Ab_RW_laeuft := Regel_erfolgreich;
            end; { RW_UND_REC }

          RW_ODER_SCH_0_N_REC :
            begin
              if Regel_erfolgreich then
                eine_Regel_erfolgreich:=true
              else
                Regel_erfolgreich:=true;

            end; { RW_ODER_SCH_0_N_REC }

          RW_ODER_REC :
            begin
              if Regel_erfolgreich then
                Ab_RW_laeuft := false;

            end; { RW_ODER_REC }

          RW_0_1_REC :
            begin
              Regel_erfolgreich:=true;
              Ab_RW_laeuft := false;
            end; { RW_ODER_REC }


        end; { case akt_RW_REC.Typ of }


      end
      else begin
        // es ist keine Regel in diesem Datensatz mehr vorhanden

        case akt_RW_REC.Typ of
          RW_UND_REC :
            begin
              Ab_RW_laeuft:=false;
              Regel_erfolgreich:=true;
            end; { RW_UND_REC }

          RW_ODER_SCH_0_N_REC :
            begin
              if eine_Regel_erfolgreich then begin
                Ab_RW_laeuft:=true;
                RecArray_zaehler:=0; // nachher + 1
              end
              else begin
                Ab_RW_laeuft:=false;
              end;
              Regel_erfolgreich:=true;
              eine_Regel_erfolgreich:=false;
            end; { RW_ODER_SCH_0_N_REC }

          RW_ODER_REC :
            begin
              if not Regel_erfolgreich then begin
                Ab_RW_laeuft := false;
              end;

            end; { RW_ODER_REC }

          RW_0_1_REC :
            begin
              Regel_erfolgreich:=true;
              Ab_RW_laeuft := false;
            end; { RW_ODER_REC }


        end; { case akt_RW_REC.Typ of }

      end; { if akt_RW_REC.Rec[RecArray_zaehler].RW_SI_Unter_Typ<>kein_UT then }

      if Ab_RW_laeuft then begin
        Inc(RecArray_zaehler);
        if RecArray_zaehler>RecArray_LEN then begin

         case akt_RW_REC.Typ of
           RW_UND_REC :
             begin
               Ab_RW_laeuft:=false;
               Regel_erfolgreich:=true;
             end; { RW_UND_REC }

           RW_ODER_SCH_0_N_REC :
             begin
               if eine_Regel_erfolgreich then begin
                 Ab_RW_laeuft:=true;
                 RecArray_zaehler:=1;
               end
               else begin
                 Ab_RW_laeuft:=false;
               end;
               Regel_erfolgreich:=true;
               eine_Regel_erfolgreich:=false;
             end; {RW_ODER_SCH_0_N_REC  }

           RW_ODER_REC :
             begin
               if not Regel_erfolgreich then begin

                 Ab_RW_laeuft := false;
               end;

             end; { RW_ODER_REC }

           RW_0_1_REC :
             begin
               Regel_erfolgreich:=true;
               Ab_RW_laeuft := false;
             end; { RW_ODER_REC }


          end; { case akt_RW_REC.Typ of }

        end; { if RecArray_zaehler>RecArray_LEN then }

      end; { if Ab_RW_laeuft then }

      if Fehler_cl.gemeldet then begin
        Ab_RW_laeuft:=false;
        Regel_erfolgreich:=false;
      end; { if Fehler_cl.gemeldet then }

    end; { while Ab_RW_laeuft do }

  end; { if not Fehler_cl.gemeldet then }

  Result:=Regel_erfolgreich;

end; { procedure Parser_class.Abarbeitung_des_Regelwerkes }



procedure Parser_class.Parser(var PSI_ARR : SI_ARR_type);
var
  Regel_erfolgreich : Boolean;
begin
  Prozent:=0;

  PAR_Datei:=TStringList.Create;

  Form_RP.ListBox_Meldungen.Items.Add('Parser wurde gestartet ...');
  Form_RP.ListBox_Meldungen.Items.Add('Parserlauf :');
  Form_RP.Refresh;

  SI_ARR_PAR_zaehler:=1;
  Regel_erfolgreich:=Abarbeitung_des_Regelwerkes(PSI_ARR,1,1);

//  Form1.ListBox_Meldungen.Items.Add('Parser endete mit:'+IntToStr(letzte_Prozent));

  if (not Fehler_cl.gemeldet) and (not Regel_erfolgreich) then begin

    Fehler_cl.Registrieren('Compiler/Abarbeitung_des_Regelwerkes',
                           'Parserlauf war nicht erfolgreich',0,1,1);
  end; { if (not Fehler_cl.gemeldet) and  }

  if Form_RP.CheckBox_TRC_Datei then begin
    PAR_Datei.SaveToFile(Form_RP.source_path+'\'+Form_RP.source_name+'.par');
  end;

  PAR_Datei.Free;

  if not Form_RP.CheckBox_TRC_Datei then begin
    DeleteFile(Form_RP.source_path+'\'+Form_RP.source_name+'.par');
  end;


end; { procedure Parser_class.Parser }




destructor Parser_class.Destroy;
begin

  inherited Destroy;
end; { destructor Parser_class.Destroy }






end.

