unit Modul_Scanner;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils,

  CompilerDeklarationen;


type

  Scanner_class = class(TObject)
  public
    SI_REC_CNT : Integer;
    constructor Create;
    procedure Scanner(var SSI_ARR : SI_ARR_type);
    destructor Destroy; override;
  private

  end; { Scanner_class = class(TObject) }






var
  Scanner_cl  : Scanner_class;



implementation

uses
  Main_Unit, Modul_Compiler;





{
***************************************************
*
*                S C A N N E R
*
***************************************************
}






constructor Scanner_class.Create;
begin
  inherited Create;

end;  { constructor Scanner_class.Create }








procedure Scanner_class.Scanner(var SSI_ARR : SI_ARR_type);
var
  SC_Zeile, Teil_Zeile,
  lfd_Param : String;
  SC_Zaehler_ZE, SC_Zaehler_SP, SC_Zaehler_erste_SP,
  VAR_DATEI, VAR_ZEILE : Integer;
  ScanItem : SI_Typ;
  SI_UT : SI_Unter_Typ;
  Zeichen : Char;
  Zeichen_ausgewertet,
  Zeilen_Kommentar_begonnen,
  Abschnitts_Kommentar_begonnen : Boolean;




  procedure SSI_ARR_loeschen;
  var
    REC_Zaehler : Integer;
  begin
    for REC_Zaehler:=1 to LEN_SI_ARR do begin
      SSI_ARR[SI_REC_CNT].datei:=0;
      SSI_ARR[SI_REC_CNT].zeile:=0;
      SSI_ARR[SI_REC_CNT].typ:=kein_SI;
      SSI_ARR[SI_REC_CNT].Unter_Typ:=kein_UT;
      SSI_ARR[SI_REC_CNT].parameter:='';
      SSI_ARR[SI_REC_CNT].spalte:=0;
    end; { for REC_Zaehler:=1 to LEN_SI_ARR do }
  end; { procedure SSI_ARR_loeschen }




  procedure LOG_Abspeichern;
  var
    SC_LOG_file : TStringList;
    SC_Zaehler_ZE2 : Integer;
    LOG_Zeile, SI_Zeile, UT_Zeile : String;


    procedure fuelle_Zeile(var X_Zeile : String; LPos : Integer);
    begin
      While Length(X_Zeile)<LPos do
        X_Zeile:=X_Zeile+' ';
    end;


  begin
    SC_LOG_file := TStringList.Create;

    for SC_Zaehler_ZE2:=1 to SI_REC_CNT-1 do begin

      case SSI_ARR[SC_Zaehler_ZE2].typ of
        kein_SI         : SI_Zeile:='<kein_SI>        ';
        SI_Zahl         : SI_Zeile:='<SI_Zahl>        ';
        SI_Bezeichner   : SI_Zeile:='<SI_Bezeichner>  ';
        SI_Zeichen      : SI_Zeile:='<SI_Zeichen>     ';
        SI_Zeichenkette : SI_Zeile:='<SI_Zeichenkette>';

      else
        SI_Zeile:='*** Fehler (SI) ***';
      end; { case SI_ARR[SC_Zaehler_ZE2].typ of }

      UT_Zeile:=Compiler_cl.UnterTyp_in_Bezeichner(SSI_ARR[SC_Zaehler_ZE2].Unter_Typ);
      fuelle_Zeile(UT_Zeile,20);

      LOG_Zeile:='DATEI:'+IntToStr(SSI_ARR[SC_Zaehler_ZE2].datei)+
                ' ZEILE:'+IntToStr(SSI_ARR[SC_Zaehler_ZE2].zeile)+
                ' SPALTE:'+IntToStr(SSI_ARR[SC_Zaehler_ZE2].spalte);

      fuelle_Zeile(LOG_Zeile,25);

      LOG_Zeile:=LOG_Zeile+
                ' '+SI_Zeile+' '+UT_Zeile+' PARAM:<'+
                SSI_ARR[SC_Zaehler_ZE2].parameter+'>';
      SC_LOG_file.Add(LOG_Zeile);
    end; { for SC_Zaehler_ZE:=1 to SI_REC_CNT do }

    SC_LOG_file.SaveToFile(Form_RP.source_path+'\'+Form_RP.source_name+'.scn');
    SC_LOG_file.Free;
  end; { procedure LOG_Abspeichern }




  procedure Bezeichner_in_UT;
  var
    SC_Zaehler_UT, UT_Zaehler : Integer;
    Bez_Par : String;
    Bez_UT : SI_Unter_Typ;
  begin

    for SC_Zaehler_UT:=1 to SI_REC_CNT-1 do begin
      if SSI_ARR[SC_Zaehler_UT].typ=SI_Bezeichner then begin
        Bez_Par:=UpperCase(SSI_ARR[SC_Zaehler_UT].parameter);
        SSI_ARR[SC_Zaehler_UT].parameter:=Bez_Par;
        Bez_UT:=UT_Bezeichner_PAR;
        for UT_Zaehler:=1 to LEN_BEZ_CONST do begin
          if UpperCase(BEZ_CONST[UT_Zaehler].bezeichner)=Bez_Par then
            Bez_UT:=BEZ_CONST[UT_Zaehler].UT_Bez;

        end; { for UT_Zaehler:=1 to LEN_BEZ_CONST do }
        SSI_ARR[SC_Zaehler_UT].Unter_Typ:=Bez_UT;
      end; { if SI_ARR[SC_Zaehler_UT].typ=SI_Bezeichner then }
    end; { for SC_Zaehler_UT:=1 to SI_REC_CNT-1 do }

  end; { procedure Bezeichner_in_UT }





  procedure SI_REC_abspeichern;
  begin
    SSI_ARR[SI_REC_CNT].datei:=VAR_DATEI;
    SSI_ARR[SI_REC_CNT].zeile:=VAR_ZEILE;
    SSI_ARR[SI_REC_CNT].typ:=ScanItem;
    SSI_ARR[SI_REC_CNT].Unter_Typ:=SI_UT;
    SSI_ARR[SI_REC_CNT].parameter:=lfd_Param;
    SSI_ARR[SI_REC_CNT].spalte:=SC_Zaehler_erste_SP;
    { Grundeinstellungen }
    ScanItem:=kein_SI;
    SI_UT:=kein_UT;
    lfd_Param:='';

    if SI_REC_CNT<LEN_SI_ARR-2 then
      INC(SI_REC_CNT)
    else
      Fehler_cl.Registrieren('Compiler/Scanner/SI_REC_abspeichern',
                             'Die maximale Laenge ('+IntToStr(LEN_SI_ARR)+
                             ') fuer das SSI_ARR wurde erreicht '+
                             '(aendern unter CompilerDeklarationen -> Konstante LEN_SI_ARR)',
                             VAR_DATEI,VAR_ZEILE,SC_Zaehler_SP);

  end; { procedure SI_REC_abspeichern }





  function naechstes_Zeichen : Char;
  var
    nae_Zei : Char;
  begin
    nae_Zei:=' ';
    if SC_Zaehler_SP<Length(SC_Zeile) then begin
      nae_Zei:=SC_Zeile[SC_Zaehler_SP+1];
    end;
    Result:=nae_Zei;
  end; { function naechstes_Zeichen }



  procedure Scan_erstes_Zeichen;
  var
    Doppel_Zei : Char;
  begin

    SC_Zaehler_erste_SP:=SC_Zaehler_SP;


    if Zeichen=CHR($27) then begin
       ScanItem:=SI_Zeichenkette;
       SI_UT:=UT_String;
       lfd_Param:='';
       Zeichen_ausgewertet:=true;
     end; { if Zeichen=CHR($27) then }



    if Zeichen IN ['0','1','2','3','4','5','6','7','8','9'] then begin
      ScanItem:=SI_Zahl;
      SI_UT:=UT_Dezi_Zahl;
      lfd_Param:=Zeichen;
      Zeichen_ausgewertet:=true;
    end; { if Zeichen IN ['0' }


    if Zeichen='%' then begin
      ScanItem:=SI_Zahl;
      SI_UT:=UT_Bin_Zahl;
      lfd_Param:=Zeichen;
      Zeichen_ausgewertet:=true;
    end; { if Zeichen IN ['%' }


    if Zeichen='#' then begin
      ScanItem:=SI_Zeichen;
      SI_UT:=UT_Char_Zahl;
      lfd_Param:=Zeichen;
      Zeichen_ausgewertet:=true;
    end; { if Zeichen IN ['#' }


    if Zeichen='$' then begin
      ScanItem:=SI_Zahl;
      SI_UT:=UT_Hex_Zahl;
      lfd_Param:=Zeichen;
      Zeichen_ausgewertet:=true;
    end; { if Zeichen IN ['$' }



    if Zeichen IN ['A','B','C','D','E','F','G','H','I','J','K','L','M','N','O',
                   'P','Q','R','S','T','U','V','W','X','Y','Z','_',
                   'a','b','c','d','e','f','g','h','i','j','k','l','m','n','o',
                   'p','q','r','s','t','u','v','w','x','y','z'] then begin
      ScanItem:=SI_Bezeichner;
      lfd_Param:=Zeichen;
      Zeichen_ausgewertet:=true;
    end; { if Zeichen IN ['A' }


    { nur Doppelzeichen }
    if Zeichen IN ['<','>',':','.'] then begin

      Doppel_Zei:=naechstes_Zeichen;

      if (Zeichen='<') and (Doppel_Zei='=') then begin
        ScanItem:=SI_Zeichen;
        SI_UT:=UT_Zei_DZ_KG;
        Inc(SC_Zaehler_SP);
        Zeichen_ausgewertet:=true;
        SI_REC_abspeichern;
      end;

      if (Zeichen='<') and (Doppel_Zei='>') then begin
        ScanItem:=SI_Zeichen;
        SI_UT:=UT_Zei_DZ_UG;
        Inc(SC_Zaehler_SP);
        Zeichen_ausgewertet:=true;
        SI_REC_abspeichern;
      end;

      if (Zeichen='>') and (Doppel_Zei='=') then begin
        ScanItem:=SI_Zeichen;
        SI_UT:=UT_Zei_DZ_GG;
        Inc(SC_Zaehler_SP);
        Zeichen_ausgewertet:=true;
        SI_REC_abspeichern;
      end;

      if (Zeichen=':') and (Doppel_Zei='=') then begin
        ScanItem:=SI_Zeichen;
        SI_UT:=UT_Zei_DZ_DG;
        Inc(SC_Zaehler_SP);
        Zeichen_ausgewertet:=true;
        SI_REC_abspeichern;
      end;





      if (Zeichen='.') and (Doppel_Zei='.') then begin
        ScanItem:=SI_Zeichen;
        SI_UT:=UT_Zei_PUNKT_PUNKT;
        Inc(SC_Zaehler_SP);
        Zeichen_ausgewertet:=true;
        SI_REC_abspeichern;
      end;




    end; { if Zeichen IN ['+' }



    { nur Einzelzeichen }
    if not Zeichen_ausgewertet then begin
      if Zeichen IN ['+','-','*','/',';',':','.',',','=',
                     '(',')','<','>','[',']','|'] then begin
        ScanItem:=SI_Zeichen;
        case Zeichen of
          '+' : SI_UT:=UT_Zei_PLUS;
          '-' : SI_UT:=UT_Zei_MINUS;
          '*' : SI_UT:=UT_Zei_MAL;
          '/' : SI_UT:=UT_Zei_DURCH;
          ';' : SI_UT:=UT_Zei_SEMI;
          ':' : SI_UT:=UT_Zei_DP;
          '.' : SI_UT:=UT_Zei_PUNKT;
          ',' : SI_UT:=UT_Zei_KOMMAR;
          '=' : SI_UT:=UT_Zei_GLEICH;
          '(' : SI_UT:=UT_Zei_KA;
          ')' : SI_UT:=UT_Zei_KZ;
          '<' : SI_UT:=UT_Zei_KLEINER;
          '>' : SI_UT:=UT_Zei_GROESSER;
          '[' : SI_UT:=UT_Zei_EKA;
          ']' : SI_UT:=UT_Zei_EKZ;
          '|' : SI_UT:=UT_Zei_SS;
        end;
        Zeichen_ausgewertet:=true;
        SI_REC_abspeichern;
      end; { if Zeichen IN ['+' }
    end; { if not Zeichen_ausgewertet then }


  end; { procedure Scan_erstes_Zeichen }



  procedure Scan_SI_Zahl;
  var
    Doppel_Zei : Char;
  begin

    case SI_UT of
      UT_Dezi_Zahl : begin
          if Zeichen IN ['0','1','2','3','4','5','6','7','8','9'] then begin
            lfd_Param:=lfd_Param+Zeichen;
            Zeichen_ausgewertet:=true;
          end; { if Zeichen IN ['0' }

          if Zeichen = '.' then begin
            Doppel_Zei:=naechstes_Zeichen;
            if Doppel_Zei='.' then begin

              // Abspeichern des alten Standes
              Inc(SC_Zaehler_SP);
              SI_REC_abspeichern;

              // Abspeichern von ".."
              ScanItem:=SI_Zeichen;
              SI_UT:=UT_Zei_PUNKT_PUNKT;
              lfd_Param:='';
              SI_REC_abspeichern;
              Zeichen_ausgewertet:=true;

            end
            else begin

              lfd_Param:=lfd_Param+Zeichen;
              SI_UT:=UT_Curr_Zahl;
              Zeichen_ausgewertet:=true;

            end;
          end; { if Zeichen = '.' then }

        end; { UT_Dezi_Zahl }

      UT_Hex_Zahl :
        if Zeichen IN ['0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F'] then begin
          lfd_Param:=lfd_Param+Zeichen;
          Zeichen_ausgewertet:=true;
        end; { if Zeichen IN ['0' }

      UT_Bin_Zahl :
        if Zeichen IN ['0','1'] then begin
          lfd_Param:=lfd_Param+Zeichen;
          Zeichen_ausgewertet:=true;
        end; { if Zeichen IN ['0' }

      UT_Curr_Zahl :
          if Zeichen IN ['0','1','2','3','4','5','6','7','8','9'] then begin
            lfd_Param:=lfd_Param+Zeichen;
            Zeichen_ausgewertet:=true;
          end; { if Zeichen IN ['0' }

    end; { case SI_UT of }


    if not Zeichen_ausgewertet then begin
      if Length(lfd_Param)>0 then begin
        SI_REC_abspeichern;
      end;
    end;

  end; { procedure Scan_SI_Zahl }



  procedure Scan_SI_Bezeichner;
  begin

    if Zeichen IN ['A','B','C','D','E','F','G','H','I','J','K','L','M','N','O',
                   'P','Q','R','S','T','U','V','W','X','Y','Z','_',
                   '0','1','2','3','4','5','6','7','8','9',
                   'a','b','c','d','e','f','g','h','i','j','k','l','m','n','o',
                   'p','q','r','s','t','u','v','w','x','y','z'] then begin
      lfd_Param:=lfd_Param+Zeichen;
      Zeichen_ausgewertet:=true;
    end; { if Zeichen IN ['A' }

    if not Zeichen_ausgewertet then begin
      if Length(lfd_Param)>0 then begin
        SI_REC_abspeichern;
      end;
    end;

  end; { procedure Scan_SI_Bezeichner }





  procedure Scan_SI_Zeichenkette;
  begin

    if Zeichen=CHR($27) then begin
      if Length(lfd_Param)=1 then
        SI_UT:=UT_Char;

      SI_REC_abspeichern;
    end { if Zeichen=CHR($27) then }
    else begin
      lfd_Param:=lfd_Param+Zeichen;
    end; { else Zeichen=CHR($27) then }
    Zeichen_ausgewertet:=true;

  end; { procedure Scan_SI_Zeichenkette }





    procedure Scan_SI_Zeichen;
    begin

      if SI_UT=UT_Char_Zahl then begin
        if Zeichen IN ['0','1','2','3','4','5','6','7','8','9'] then begin
          lfd_Param:=lfd_Param+Zeichen;
          Zeichen_ausgewertet:=true;
        end; { if Zeichen IN ['0' }
      end; { if SI_UT=UT_Char_Zahl then }

      if not Zeichen_ausgewertet then begin
        if Length(lfd_Param)>0 then begin
          SI_REC_abspeichern;
        end;
      end;

    end; { procedure Scan_SI_Zeichen }







begin

  ScanItem:=kein_SI;
  SI_UT:=kein_UT;
  SI_REC_CNT:=1;

  Zeilen_Kommentar_begonnen:=false;
  Abschnitts_Kommentar_begonnen:=false;
  lfd_Param:='';
  for SC_Zaehler_ZE:=0 to Compiler_cl.SC_Source_file.Count-1 do begin
    if not Fehler_cl.gemeldet then begin
      SC_Zeile:=Compiler_cl.SC_Source_file[SC_Zaehler_ZE];
      Teil_Zeile:=Copy(SC_Zeile,1,3);
      VAR_DATEI:=StrToInt(Teil_Zeile);
      Teil_Zeile:=Copy(SC_Zeile,4,4);
      VAR_ZEILE:=StrToInt(Teil_Zeile);
      if length(SC_Zeile)>7 then begin
        SC_Zeile:=Copy(SC_Zeile,8,Length(SC_Zeile));
        for SC_Zaehler_SP:=1 to Length(SC_Zeile) do begin
          if not Fehler_cl.gemeldet then begin
            Zeichen:=SC_Zeile[SC_Zaehler_SP];
            Zeichen_ausgewertet:=false;

            if (not Abschnitts_Kommentar_begonnen) and
               (not Zeilen_Kommentar_begonnen) then begin

              if (Zeichen='{') and (ScanItem<>SI_Zeichenkette) then begin
                Abschnitts_Kommentar_begonnen:=true;
                Zeichen_ausgewertet:=true;
                if ScanItem<>kein_SI then
                  SI_REC_abspeichern;

              end; { if Zeichen='' then }

              if ScanItem<>SI_Zeichenkette then begin
                if Zeichen IN [' ',CHR($09)] then begin
                  Zeichen_ausgewertet:=true;
                  if ScanItem<>kein_SI then
                    SI_REC_abspeichern;

                end; { if Zeichen IN [' ' }
              end; { if ScanItem<>SI_Zeichenkette then }

              if Zeichen='/' then begin
                if SC_Zaehler_SP<Length(SC_Zeile) then begin
                  if SC_Zeile[SC_Zaehler_SP+1]='/' then begin
                    Zeilen_Kommentar_begonnen:=true;
                    Zeichen_ausgewertet:=true;
                  end; { if SC_Zeile[SC_Zaehler_SP+1]='/' then }
                end; { if SC_Zaehler_SP<Length(SC_Zeile) then }
              end; { if Zeichen='/' then }


              if not Zeichen_ausgewertet then begin
                case ScanItem of
                  kein_SI         : Scan_erstes_Zeichen;
                  SI_Zahl         : Scan_SI_Zahl;
                  SI_Bezeichner   : Scan_SI_Bezeichner;
                  SI_Zeichenkette : Scan_SI_Zeichenkette;
                  SI_Zeichen      : Scan_SI_Zeichen;
                end; { case ScanItem of }
              end; { if not Zeichen_ausgewertet then }


               if not Zeichen_ausgewertet then begin
                 if ScanItem=kein_SI then
                   Scan_erstes_Zeichen;

               end { if not Zeichen_ausgewertet then }
               else begin
                 if (ScanItem=SI_Zeichen) and (SI_UT<>UT_Char_Zahl) then
                   SI_REC_abspeichern;

               end; { else not Zeichen_ausgewertet then }

            end { if (not Abschnitts_Kommentar_begonnen) }
            else begin
              if Abschnitts_Kommentar_begonnen then begin
                if Zeichen='}' then begin
                  Abschnitts_Kommentar_begonnen:=false;
                end;
              end; { if Abschnitts_Kommentar_begonnen then }
              Zeichen_ausgewertet:=true;
            end; { else (not Abschnitts_Kommentar_begonnen) }

            if not Zeichen_ausgewertet then begin
              Fehler_cl.Registrieren('Compiler/Scanner','Ausdruck konnte nicht ausgewertet werden',
                                     VAR_DATEI,VAR_ZEILE,SC_Zaehler_SP);
            end;

          end; { if not Fehler_cl.gemeldet then }

        end; { for SC_Zaehler_SP:=0 to Length(SC_Zeile) do }

      end; { if length(SC_Zeile)>7 then }


      if ScanItem=SI_Zeichenkette then begin
        Fehler_cl.Registrieren('Compiler/Scanner','Zeichenkette nicht abgeschlossen',
                               VAR_DATEI,VAR_ZEILE,SC_Zaehler_SP);
      end; { if ScanItem=SI_Zeichenkette then }



      if ScanItem<>kein_SI then begin
        SI_REC_abspeichern;
      end; { if ScanItem=kein_SI }


    end; { if not Fehler_cl.gemeldet then }
    Zeilen_Kommentar_begonnen:=false;
  end; { for SC_Zaehler_ZE:=0 to SC_Source_file.Count-1 do }

  Bezeichner_in_UT;

  if Form_RP.CheckBox_LOG_Dateien then begin
    LOG_Abspeichern;
  end
  else begin

    if FileExists(Form_RP.source_path+'\'+Form_RP.source_name+'.scn') then
      DeleteFile(Form_RP.source_path+'\'+Form_RP.source_name+'.scn');

  end; { if Form_RP.CheckBox_LOG_Dateien then }

end; { procedure Scanner_class.Scanner }







destructor Scanner_class.Destroy;
begin

  inherited Destroy;
end; { destructor Scanner_class.Destroy }







end.

