


// ****************************************************
// ** Einlesen des Board - Arrays
// ****************************************************




procedure TForm_Neu.Read_Board_Array;
var
  BA_Read_active : Boolean;
  BA_List : TStringList;
  BA_List_counter : Integer;
  BA_Line : String;
  BA_counter : Integer;
  BA_name : String;



  procedure Read_String_Element(STR3 : String;
                                var ZielFeld : String;
                                Zaehlfeld : Boolean);
  begin

    if BA_Read_active then begin

      if POS(STR3,BA_Line)=1 then begin

        if Length(BA_Line)>4 then begin

          ZielFeld:=Copy(BA_Line,5,Length(BA_Line));

        end; { if Length(PA_Line)>4 then }


        if Zaehlfeld then
          Inc(Board_Array_Counter);


      end; { if POS(STR3,PA_Line)=1 then }

    end; { if PA_Read_active then }

  end; { procedure Read_String_Element }




begin

  BA_name:=board_names;

  if FileExists(BA_name) then begin


    for BA_counter:=0 to Length_Board_Array do begin

      Board_Array[BA_counter].Bezeichner:='';

    end; { for BA_counter:=0 to Length_Board_Array do }

    BA_List := TStringList.Create;
    BA_List.LoadFromFile(BA_name);

    BA_Read_active:=true;

    Board_Array_Counter:=0;

    for BA_List_counter:=0 to BA_List.Count-1 do begin

      BA_Line:=BA_List[BA_List_counter];


      // Bezeichnung
      Read_String_Element('BEZ',Board_Array[Board_Array_Counter].Bezeichner,false);
      Read_String_Element('BEM',Board_Array[Board_Array_Counter].Bemerkung,false);
      Read_String_Element('PAS',Board_Array[Board_Array_Counter].RONPAS_name,false);
      Read_String_Element('DAT',Board_Array[Board_Array_Counter].Datei,false);
      Read_String_Element('IMG',Board_Array[Board_Array_Counter].Bild,true);


      if BA_Read_active then begin

        // END-Kennung
        if POS('END',BA_Line)=1 then begin

          BA_Read_active:=false;

        end; { if POS('END',BA_Line)=1 then }

      end; { if BA_Read_active then }


    end; { for BA_List_counter:=0 to BA_List.Count-1 do }

  end
  else begin

    ListBox_Meldungen.Items.Add('*** Fehler: Datei <'+BA_name+'> nicht gefunden');

  end; { if FileExists(BA_name) then }


  if Board_Array_Counter>0 then
    ListBox_Meldungen.Items.Add('... es wurden '+
                 IntToStr(Board_Array_Counter)+' Boards eingelesen')
  else
    ListBox_Meldungen.Items.Add('*** Fehler: es wurden keine Boards eingelesen');


end; { procedure TForm_Neu.Read_Board_Array }





procedure TForm_Neu.Anzeige_Board_Array;
var
  AB_string : String;

begin

  AB_string:=Board_Array[ComboBox_Board.ItemIndex].Bezeichner;
  ListBox_Bemerkung.Items.Text:=AB_string;

  if Length(Board_Array[ComboBox_Board.ItemIndex].Bild)>0 then begin

    AB_string:=atmega_picture_path+'\'+Board_Array[ComboBox_Board.ItemIndex].Bild;

    if FileExists(AB_string) then begin

      Image_Board_Device.Picture.LoadFromFile(AB_string);

    end
    else
      ListBox_Meldungen.Items.Add('*** Fehler: Bilddatei:'+
                                  Board_Array[ComboBox_Board.ItemIndex].Bild+
                                  ' konnte nicht gefunden werden');


  end; { if Length(Board_Array[ComboBox_Board.ItemIndex].Image)>0 then }

  Form_RP.CB_Board_Index:=ComboBox_Board.ItemIndex;

end; { procedure TForm_Neu.Anzeige_Board_Array }







procedure TForm_Neu.DEFINE_NAME_IN_ATMEGA_Typ_Index(DEF_Name : String);
var
  DN_Zaehler, ATMEGA_Typ_Index : Integer;
begin
  ATMEGA_Typ_Index:=-1;
  DEF_Name:=UpperCase(DEF_Name);
  for DN_Zaehler:=0 to Form_Device.ATMEGA_Array_Counter do begin
    if UpperCase(Form_Device.ATMEGA_Array[DN_Zaehler].RONPAS_name)=DEF_Name then
      ATMEGA_Typ_Index:=DN_Zaehler;

  end; { for TN_Zaehler:=1 to LEN_AT_CONST do }

  if ATMEGA_Typ_Index=-1 then begin
    ListBox_Meldungen.Items.Add('*** Fehler: Device:'+DEF_Name+
                                  ' konnte nicht gefunden werden');

  end { else ATMEGA_Typ_Index=-1 then }
  else begin

    ComboBox_uC_Typ.ItemIndex:=ATMEGA_Typ_Index;

  end; { if ATMEGA_Typ_Index=-1 then }

end; { procedure TForm_Neu.DEFINE_NAME_IN_uC }






procedure TForm_Neu.Anzeige_ATMEGA_Array;
var
  AB_string : String;
begin

  if ComboBox_Board.ItemIndex>0 then begin
    ComboBox_uC_Typ.Enabled:=false;
    AB_string:=Board_Array[ComboBox_Board.ItemIndex].RONPAS_name;
    DEFINE_NAME_IN_ATMEGA_Typ_Index(AB_string);
  end
  else begin

    ComboBox_uC_Typ.Enabled:=true;
    Form_RP.CB_Device_Index:=ComboBox_uC_Typ.ItemIndex;



    if Length(Form_Device.ATMEGA_Array[ComboBox_uC_Typ.ItemIndex].Image_name)>0 then begin

      AB_string:=atmega_picture_path+'\'+Form_Device.ATMEGA_Array[ComboBox_uC_Typ.ItemIndex].Image_name;

      if FileExists(AB_string) then begin

        Image_Board_Device.Picture.LoadFromFile(AB_string);

      end
      else
        ListBox_Meldungen.Items.Add('*** Fehler: Bilddatei:'+
                                    Board_Array[ComboBox_Board.ItemIndex].Bild+
                                    ' konnte nicht gefunden werden');


    end; { if Length(Board_Array[ComboBox_Board.ItemIndex].Image)>0 then }


  end;

end; { procedure TForm_Neu.Anzeige_ATMEGA_Array }











