unit Prommer_Form;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms,
  Controls, Graphics, Dialogs, StdCtrls, ComCtrls, ExtCtrls, CheckLst,
  EditBtn, Windows, Registry,

  CompilerDeklarationen, ZwischenCode,
  Device_Form;



const


  Length_Prommer_Array = 100;


  prommer_path = 'rp_prommer';
  prommer_picture_path = prommer_path + '\' + 'picture';
  prommer_bat_name = 'programming.bat';
  prommer_array_name = 'prommer_array.txt';


 { fuses_file_name_lock  = 'temp_lock.txt';
  fuses_file_name_efuse = 'temp_efuse.txt';  }
  fuses_file_name_hfuse = 'temp_hfuse.txt';
  fuses_file_name_lfuse = 'temp_lfuse.txt';


  COM_Port_Max = 99;



type

  REC_Port_Liste = record
    Port_Name, Port_Typ : String;
  end;


  REC_Button_Fuses = record
    BT_FUSE_Hfuse, BT_FUSE_Lfuse : Byte;
    BT_Hfuse_ok, BT_Lfuse_ok : Boolean;
    BT_Caption, BT_Text_1,
    BT_Text_2, BT_Text_3, BT_Text_4 : String;
    BT_Bild_Nummer : Integer;
  end;



  ct_type = (ct_keiner, ct_serial, ct_usb);

  dt_type = (dt_keiner, dt_mega, dt_tiny);

  ba_prommer_type = (ba_pr_Read_Device,
                     ba_pr_Read_Flash, ba_pr_Write_Flash,
                     ba_pr_Read_Fuses, ba_pr_Write_Fuses);



  Prommer_Array_Record = record
    Bezeichner, AVRDUDE_ProgrammerID,
    Picture_Name, Device_Name : String;
    ConnectionType : ct_type;
  end;







  { TForm_Prommer }

  TForm_Prommer = class(TForm)
    Button_Change_Fuses: TButton;
    Button_E: TButton;
    Button_D: TButton;
    Button_C: TButton;
    Button_Ports_neu_einlesen: TButton;
    Button_Send_Line: TButton;
    Button_Close: TButton;
    Button_Read_Signature: TButton;
    Button_Write_Fuses: TButton;
    Button_Write_Flash: TButton;
    Button_Read_Fuses: TButton;
    Button_Flash_Quelle_suchen: TButton;
    CheckListBox_Lock: TCheckListBox;
    CheckListBox_EFuses: TCheckListBox;
    CheckListBox_LFuses: TCheckListBox;
    CheckListBox_HFuses: TCheckListBox;
    ComboBoxPort: TComboBox;
    ComboBox_PrommerTyp: TComboBox;
    Edit_Device_Signature: TEdit;
    Edit_ATMEGA_Typ: TEdit;
    Edit_AVRDUDE: TEdit;
    Edit_Flash_Quelle: TEdit;
    Edit_FUSE_Lock: TEdit;
    Edit_FUSE_Efuse: TEdit;
    Edit_FUSE_Lfuse: TEdit;
    Edit_FUSE_Hfuse: TEdit;
    Image_Button_E: TImage;
    Image_Button_D: TImage;
    Image_Button_C: TImage;
    ImageList1: TImageList;
    Image_PROMMER: TImage;
    Label1: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label_E_04: TLabel;
    Label_E_03: TLabel;
    Label_E_02: TLabel;
    Label_D_04: TLabel;
    Label_D_03: TLabel;
    Label_D_02: TLabel;
    Label_C_04: TLabel;
    Label_C_03: TLabel;
    Label_C_02: TLabel;
    Label_E_01: TLabel;
    Label_D_01: TLabel;
    Label_C_01: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label_Port: TLabel;
    ListBox_Meldungen: TListBox;
    OpenDialog_Flash_Quelle_oeffnen: TOpenDialog;
    PageControl_Prommer: TPageControl;
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    TabSheet_EL_FUSES: TTabSheet;
    TabSheet_HL_FUSES: TTabSheet;
    TabSheet_Flash: TTabSheet;
    procedure Button_Change_FusesClick(Sender: TObject);
    procedure Button_CloseClick(Sender: TObject);
    procedure Button_DClick(Sender: TObject);
    procedure Button_CClick(Sender: TObject);
    procedure Button_Ports_neu_einlesenClick(Sender: TObject);
    procedure Button_Read_SignatureClick(Sender: TObject);
    procedure Button_Read_FusesClick(Sender: TObject);
    procedure Button_Flash_Quelle_suchenClick(Sender: TObject);
    procedure Button_Write_FlashClick(Sender: TObject);
    procedure Button_Send_LineClick(Sender: TObject);
    procedure Button_Write_FusesClick(Sender: TObject);
    procedure CheckListBox_EFusesClickCheck(Sender: TObject);
    procedure CheckListBox_HFusesClickCheck(Sender: TObject);
    procedure CheckListBox_LFusesClickCheck(Sender: TObject);
    procedure CheckListBox_LockClickCheck(Sender: TObject);
    procedure ComboBoxPortChange(Sender: TObject);
    procedure ComboBox_PrommerTypChange(Sender: TObject);
    procedure Edit_FUSE_LfuseChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure PageControl_PrommerChange(Sender: TObject);
  private
    { private declarations }
    Prommer_Array : ARRAY [0..Length_Prommer_Array] of Prommer_Array_Record;
    Prommer_Array_Counter : Integer;

    AVRDUDE_line : String;

    FUSE_Lock, FUSE_Efuse, FUSE_Hfuse, FUSE_Lfuse : Byte;

    ComboBoxPort_Liste : TStringList;

    prommer_log_zaehler : Integer;

    ba_prommer : ba_prommer_type;


    COM_Port_Array : Array [0..COM_Port_Max] of REC_Port_Liste;
    COM_Port_Array_Zeiger : Integer;

    Button_C_Fuses, Button_D_Fuses, Button_E_Fuses : REC_Button_Fuses;


    procedure GetSerialPortNamesExt;


    procedure Read_Prommer_Array;
    procedure PrommerTyp_change;

    procedure ComPort_laden;
    procedure FUSES_Dateien_einlesen;
    procedure FUSES_anzeigen;
    procedure Read_Fuse_Bezeichner;
    procedure FuseByte_zu_CheckListBox;
    function CheckListBox_zu_FuseByte(var CF_CheckListBox : TCheckListBox) : Byte;

    // AVRDUDE_line
    procedure RunCaptured(var Ausgabe: TStringList;
                          const _dirName, _exeName: string);
    procedure generiere_AVRDUDE_line_Grundeintrag;
    procedure generiere_AVRDUDE_line_Read_Fuses;
    procedure generiere_AVRDUDE_line_Write_Flash;
    procedure generiere_AVRDUDE_line_Write_Fuses;
    procedure generiere_AVRDUDE_line_Write_Button_C;
    procedure generiere_AVRDUDE_line_Write_Board_Fuses;
    procedure generiere_AVRDUDE_line_Read_Device;
    procedure lese_Device_Signatur(var Konsolen_Ausgabe : TStringList);


  public
    JMP_Sprungdistanz : JMP_Sprungdistanz_Type;

    procedure Start_Programmer;
    procedure setze_Hex_DateiName;

    { public declarations }
  end;

var
  Form_Prommer: TForm_Prommer;


implementation

{$R *.lfm}


uses
  Main_Unit;


{ TForm_Prommer }


// ************************
// * INCLUDE
// ************************

{$I Prommer_Form_01.inc}






// ************************
// * Initialisiereung
// ************************



procedure TForm_Prommer.FormCreate(Sender: TObject);
var
  RP_cnt : Integer;
  RP_Line : String;

begin

  prommer_log_zaehler:=0;

  FUSE_Lock:=$FF;
  FUSE_Efuse:=$FF;
  FUSE_Hfuse:=$FF;
  FUSE_Lfuse:=$FF;
  FUSES_anzeigen;

  Form_Prommer.Caption:=caption_text;



  Image_PROMMER.Picture.Bitmap.Width:=Image_PROMMER.Width;
  Image_PROMMER.Picture.Bitmap.Height:=Image_PROMMER.Height;


  ListBox_Meldungen.Clear;
  ListBox_Meldungen.Items.Add('RGUI wurde gestartet ...');

  //
  OpenDialog_Flash_Quelle_oeffnen.Filter:='Hex-Dateien|*.hex|alle Dateien|*.*';
  OpenDialog_Flash_Quelle_oeffnen.InitialDir:=Form_RP.ronpas_path;



  // Einlesen der PROMMER
  Read_Prommer_Array;

  for RP_cnt:=0 to Prommer_Array_Counter-1 do begin

    RP_Line:=Prommer_Array[RP_cnt].Bezeichner+' ('+
             Prommer_Array[RP_cnt].AVRDUDE_ProgrammerID+')';
    ComboBox_PrommerTyp.Items.Add(RP_Line);

  end; { for RP_cnt:=0 to Prommer_Array_Counter-1 do }


  ComboBox_PrommerTyp.ItemIndex := Form_RP.CB_Prommer_Index;

  PrommerTyp_change;

  Edit_Flash_Quelle.Text:=Form_RP.source_path+'\'+Form_RP.source_name+'.hex';



  PageControl_Prommer.PageIndex:=Form_RP.CB_PageControl_Index;

  ComboBoxPort_Liste := TStringList.Create;



end; { procedure TForm_Prommer.FormCreate }








procedure TForm_Prommer.FormShow(Sender: TObject);
begin

  Edit_ATMEGA_Typ.Text:=Form_Device.ATMEGA_Array[Form_Device.ComboBox_ATMEGA_Typ.ItemIndex].RONPAS_name;

  Read_Fuse_Bezeichner;

end; { procedure TForm_Prommer.FormShow }






// *****************************************
// *** Hilfsprogramme zur den List-Boxen ***
// *****************************************






procedure TForm_Prommer.PrommerTyp_change;
var
  Picture_Path_Name : String;
  Picture_loaded : boolean;
begin

  ComboBoxPort.Items.Clear;

  case Prommer_Array[ComboBox_PrommerTyp.ItemIndex].ConnectionType of

    ct_serial : begin
                  ComPort_laden;

                end;

    ct_usb    : begin
                  ComboBoxPort.Items.Clear;
                  ComboBoxPort.Items.Add('USB');
                  ComboBoxPort.ItemIndex:=0;
                end;

  end; { case Prommer_Array... }


  Picture_loaded:=false;

  if Length(Prommer_Array[ComboBox_PrommerTyp.ItemIndex].Picture_Name)>0 then begin

    Picture_Path_Name:=Form_RP.ronpas_path+'\'+prommer_picture_path+
                       '\'+Prommer_Array[ComboBox_PrommerTyp.ItemIndex].Picture_Name;

    if FileExists(Picture_Path_Name) then begin

      Image_PROMMER.Picture.LoadFromFile(Picture_Path_Name);
      Picture_loaded:=true;

    end;

  end; { if Length(Prommer_Array... }


  if Picture_loaded=false then begin
    Image_PROMMER.Picture.Bitmap.Canvas.Brush.Color:=clWhite;
    Image_PROMMER.Picture.Bitmap.Canvas.Pen.Color:=clBlack;
    Image_PROMMER.Picture.Bitmap.Canvas.Rectangle(0,0,Image_PROMMER.Width,Image_PROMMER.Height);
  end; { if Picture_loaded=false then }


end; { procedure TForm_Prommer.PrommerTyp_change }














procedure TForm_Prommer.ComboBox_PrommerTypChange(Sender: TObject);
begin
  Form_RP.CB_Prommer_Index:=ComboBox_PrommerTyp.ItemIndex;
  PrommerTyp_change;
end; { procedure TForm_Prommer.ComboBox_PrommerTypChange }

procedure TForm_Prommer.Edit_FUSE_LfuseChange(Sender: TObject);
begin

end;








// *** COM-Port ***





procedure TForm_Prommer.GetSerialPortNamesExt;
var
  reg  : TRegistry;
  com_list : TStringList;
  n    : integer;
  pn,fn: string;



  function findFriendlyName(key: string; port: string): string;
  var
    r : TRegistry;
    k : TStringList;
    i : Integer;
    ck: string;
    rs: string;
  begin

    r := TRegistry.Create;
    k := TStringList.Create;

    r.RootKey := HKEY_LOCAL_MACHINE;
    r.OpenKeyReadOnly(key);
    r.GetKeyNames(k);
    r.CloseKey;

    try
      for i := 0 to k.Count - 1 do begin

        ck := key + k[i] + '\'; // current key

        // looking for "PortName" stringvalue in "Device Parameters" subkey
        if r.OpenKeyReadOnly(ck + 'Device Parameters') then begin

          if r.ReadString('PortName') = port then begin

            r.CloseKey;
            r.OpenKeyReadOnly(ck);
            rs := r.ReadString('FriendlyName');
            Break;

          end { if r.ReadString('PortName') = port then }

        end { if r.OpenKeyReadOnly(ck + 'Device Parameters') then }
        // keep looking on subkeys for "PortName"
        else begin

          if r.OpenKeyReadOnly(ck) and r.HasSubKeys then begin

            rs := findFriendlyName(ck, port);

            if rs <> '' then Break;

          end; { if r.OpenKeyReadOnly(ck) and r.HasSubKeys then }

        end; { if r.OpenKeyReadOnly(ck + 'Device Parameters') then }

      end; { for i := 0 to k.Count - 1 do }

      result := rs;

    finally
      r.Free;
      k.Free;
    end; // try ...

  end; { function findFriendlyName ... }



begin

  com_list := TStringList.Create;
  reg      := TRegistry.Create;


  try

    reg.RootKey := HKEY_LOCAL_MACHINE;

    if reg.OpenKeyReadOnly('HARDWARE\DEVICEMAP\SERIALCOMM') then begin
      reg.GetValueNames(com_list);

      for n := 0 to com_list.Count - 1 do begin

        pn := reg.ReadString(com_list[n]);
        fn := findFriendlyName('\System\CurrentControlSet\Enum\', pn);

        if POS('(COM',fn)>0 then begin
          Delete(fn,POS(' (COM',fn),10);
        end;

        COM_Port_Array[COM_Port_Array_Zeiger].Port_Name:=pn;
        COM_Port_Array[COM_Port_Array_Zeiger].Port_Typ:=fn;
        Inc(COM_Port_Array_Zeiger);

      end; // for n := 0 to l.Count - 1 ...

    end; // if reg.OpenKeyReadOnly('HARDWARE\DEVICEMAP\SERIALCOMM') ...

  finally

    reg.Free;

  end; // try ...

end; { function TForm_Prommer.GetSerialPortNamesExt }








procedure TForm_Prommer.ComPort_laden;
var
  CPA_Zaehler : Integer;
  COMPort_gefunden : Boolean;
begin

  COM_Port_Array_Zeiger:=0;

  GetSerialPortNamesExt;

  ComboBoxPort.Items.Clear;

  ComboBoxPort.ItemIndex:=-1;

  COMPort_gefunden:=false;

  for CPA_Zaehler:=0 to COM_Port_Array_Zeiger-1 do begin

    ComboBoxPort.Items.Add(COM_Port_Array[CPA_Zaehler].Port_Name+
                        ' = '+
                        COM_Port_Array[CPA_Zaehler].Port_Typ);

    if COMPort_gefunden=false then begin

      if (COM_Port_Array[CPA_Zaehler].Port_Typ=
          Prommer_Array[ComboBox_PrommerTyp.ItemIndex].Device_Name) then begin

          ComboBoxPort.ItemIndex:=CPA_Zaehler;

          COMPort_gefunden:=true;

      end; { if (COM_Port_Array[CPA_Zaehler].Port_Name=Form_RP.Port_Name) then }

    end; { if COMPort_gefunden=false then }

  end; { for CPA_Zaehler:=0 to COM_Port_Array_Zeiger-1 do }


  if COMPort_gefunden then begin
    ListBox_Meldungen.Items.Add('COM-Port für Prommer wurde gefunden ...');
  end
  else begin
    ListBox_Meldungen.Items.Add('*** Fehler: kein COM-Port für Prommer gefunden ...');
  end;


end; { procedure TForm_Prommer.ComPort_laden }







procedure TForm_Prommer.Button_Ports_neu_einlesenClick(Sender: TObject);
begin
  ComPort_laden;
end;








procedure TForm_Prommer.ComboBoxPortChange(Sender: TObject);
begin

  Form_RP.Port_Name:=COM_Port_Array[ComboBoxPort.ItemIndex].Port_Name;
  Form_RP.Port_Typ:=COM_Port_Array[ComboBoxPort.ItemIndex].Port_Typ;

end; { procedure TForm_Prommer.ComboBoxPortChange }





// *********************
// * Buttons
// *********************



procedure TForm_Prommer.FUSES_Dateien_einlesen;
var
  Error_detected : Boolean;


  function FUSE_File_Read_Convert(fuses_file_name : String) : Byte;
  var
    FF_List : TStringList;
    FF_Byte : Byte;
    temp_fuses_file, fuse_line, fuse_line_Byte : String;
  begin

    FF_Byte:=$FF;

    temp_fuses_file:=Form_RP.ronpas_path+'\'+prommer_path+'\'+fuses_file_name;

    FF_List := TStringList.Create;

    if FileExists(temp_fuses_file) then begin

      FF_List.LoadFromFile(temp_fuses_file);

      if FF_List.Count=1 then begin

        fuse_line:=FF_List[0];

        if Length(fuse_line)=4 then begin

          if Pos('0x',fuse_line)=1 then begin

            fuse_line_Byte:='$'+Copy(fuse_line,3,2);
            FF_Byte:=StrToInt(fuse_line_Byte);

            DeleteFile(PChar(temp_fuses_file));

          end
          else
            Error_detected:=true;

        end
        else
          Error_detected:=true;

      end
      else
        Error_detected:=true;

    end { if FileExists(temp_fuses_file) then }
    else
      Error_detected:=true;

    Result:=FF_Byte;

  end; { function FUSE_File_Read_Convert }


begin

  Error_detected:=false;

{  FUSE_Lock  := FUSE_File_Read_Convert(fuses_file_name_lock);
  FUSE_Efuse := FUSE_File_Read_Convert(fuses_file_name_efuse);  }
  FUSE_Hfuse := FUSE_File_Read_Convert(fuses_file_name_hfuse);
  FUSE_Lfuse := FUSE_File_Read_Convert(fuses_file_name_lfuse);


  if Error_detected then
    ListBox_Meldungen.Items.Add('*** Fehler: FUSES konnten nicht gelesen werden')
  else
    ListBox_Meldungen.Items.Add('... FUSES gelesen');

  FuseByte_zu_CheckListBox;

end; { procedure TForm_Prommer.FUSES_Dateien_einlesen }







procedure TForm_Prommer.FUSES_anzeigen;
begin

{  Edit_FUSE_Lock.Text:=IntToHex(FUSE_Lock,2);
  Edit_FUSE_Efuse.Text:=IntToHex(FUSE_Efuse,2);    }
  Edit_FUSE_Hfuse.Text:=IntToHex(FUSE_Hfuse,2);
  Edit_FUSE_Lfuse.Text:=IntToHex(FUSE_Lfuse,2);

end; { procedure TForm_Prommer.FUSES_anzeigen }















// ****************************************************
// *** Umschalten der Reiter
// ****************************************************



procedure TForm_Prommer.PageControl_PrommerChange(Sender: TObject);
begin

  Form_RP.CB_PageControl_Index:=PageControl_Prommer.PageIndex;

end; { procedure TForm_Prommer.PageControl_PrommerChange }








procedure TForm_Prommer.generiere_AVRDUDE_line_Grundeintrag;

begin

  AVRDUDE_line:='avrdude.exe';
  // Device
  AVRDUDE_line:=AVRDUDE_line+' -p '+Form_Device.ATMEGA_Array[Form_Device.ComboBox_ATMEGA_Typ.ItemIndex].AVRDUDE_name;
  // Prommer
  AVRDUDE_line:=AVRDUDE_line+' -c '+Prommer_Array[ComboBox_PrommerTyp.ItemIndex].AVRDUDE_ProgrammerID;

  // Port
  if Prommer_Array[ComboBox_PrommerTyp.ItemIndex].ConnectionType=ct_serial then begin
    AVRDUDE_line:=AVRDUDE_line+' -P '+ COM_Port_Array[ComboBoxPort.ItemIndex].Port_Name;
  end
  else begin
    AVRDUDE_line:=AVRDUDE_line+' -P usb';
  end;


end; { procedure Assembler_class.generiere_AVRDUDE_line_Grundeintrag }















// ********************************************************
// *** Flash-Routinen
// ********************************************************



procedure TForm_Prommer.Button_Flash_Quelle_suchenClick(Sender: TObject);
begin

  if OpenDialog_Flash_Quelle_oeffnen.Execute then begin

    Edit_Flash_Quelle.Text := OpenDialog_Flash_Quelle_oeffnen.FileName;

  end; { if OpenDialog_Flash_Quelle_oeffnen.Execute then }

end; { procedure TForm_Prommer.Button_Flash_Quelle_suchenClick }









procedure TForm_Prommer.generiere_AVRDUDE_line_Write_Flash;
var
  p01 : String;

begin

  generiere_AVRDUDE_line_Grundeintrag;

  p01:='"'+Edit_Flash_Quelle.Text+'"';
  AVRDUDE_line:=AVRDUDE_line+' -U flash:w:'+p01+':i';

  Form_Prommer.ListBox_Meldungen.Items.Add('AVRDUDE Parameter wurden generiert ...');

end; { procedure Assembler_class.generiere_AVRDUDE_line_Write_Flash }






procedure TForm_Prommer.Button_Write_FlashClick(Sender: TObject);
begin

  ba_prommer:=ba_pr_Write_Flash;
  generiere_AVRDUDE_line_Write_Flash;
  Edit_AVRDUDE.Text:=AVRDUDE_line;
  Button_Send_LineClick(Sender);

end; { procedure TForm_Prommer.Button_Write_FlashClick }

















procedure TForm_Prommer.generiere_AVRDUDE_line_Read_Device;
begin

  generiere_AVRDUDE_line_Grundeintrag;
  Form_Prommer.ListBox_Meldungen.Items.Add('AVRDUDE Parameter wurden generiert ...');

end; { procedure Assembler_class.generiere_AVRDUDE_line_Read_Device }





//
procedure TForm_Prommer.Button_Read_SignatureClick(Sender: TObject);
begin

  ba_prommer:=ba_pr_Read_Device;
  generiere_AVRDUDE_line_Read_Device;
  Edit_AVRDUDE.Text:=AVRDUDE_line;
  Button_Send_LineClick(Sender);

end; { procedure TForm_Prommer.Button_Read_DeviceClick }









// ********************************************************
// *** H, L, E, Lock Fuses-Routinen
// ********************************************************


procedure TForm_Prommer.CheckListBox_HFusesClickCheck(Sender: TObject);
begin
  FUSE_Hfuse:=CheckListBox_zu_FuseByte(CheckListBox_HFuses);
  FUSES_anzeigen;
end; { procedure TForm_Prommer.CheckListBox_HFusesClickCheck }



procedure TForm_Prommer.CheckListBox_LFusesClickCheck(Sender: TObject);
begin
  FUSE_Lfuse:=CheckListBox_zu_FuseByte(CheckListBox_LFuses);
  FUSES_anzeigen;
end; { procedure TForm_Prommer.CheckListBox_LFusesClickCheck }



procedure TForm_Prommer.CheckListBox_EFusesClickCheck(Sender: TObject);
begin
  FUSE_Efuse:=CheckListBox_zu_FuseByte(CheckListBox_EFuses);
  FUSES_anzeigen;
end; { procedure TForm_Prommer.CheckListBox_EFusesClickCheck }




procedure TForm_Prommer.CheckListBox_LockClickCheck(Sender: TObject);
begin
  FUSE_Lock:=CheckListBox_zu_FuseByte(CheckListBox_Lock);
  FUSES_anzeigen;
end; { procedure TForm_Prommer.CheckListBox_LockClickCheck }










// *** Uebernehmen_Fuses ***


procedure TForm_Prommer.Button_Change_FusesClick(Sender: TObject);
begin

end; { procedure TForm_Prommer.Button_Change_FusesClick }








// *** Read_Fuses ***


procedure TForm_Prommer.generiere_AVRDUDE_line_Read_Fuses;



  procedure Delete_Fuse_File(fuses_file_name : String);
  var
    temp_fuses_file : String;
  begin
    temp_fuses_file:=Form_RP.ronpas_path+'\'+prommer_path+'\'+fuses_file_name;
    if FileExists(temp_fuses_file) then begin
      DeleteFile(PChar(temp_fuses_file));
    end;
  end;




begin

  generiere_AVRDUDE_line_Grundeintrag;


// ***********************************

{  Delete_Fuse_File(fuses_file_name_lock);
  Delete_Fuse_File(fuses_file_name_efuse);   }
  Delete_Fuse_File(fuses_file_name_hfuse);
  Delete_Fuse_File(fuses_file_name_lfuse);

  AVRDUDE_line:=AVRDUDE_line+
              {  ' -Ulock:r:'+fuses_file_name_lock+':h'+
                ' -Uefuse:r:'+fuses_file_name_efuse+':h'+  }
                ' -Uhfuse:r:'+fuses_file_name_hfuse+':h'+
                ' -Ulfuse:r:'+fuses_file_name_lfuse+':h';

// ***********************************

  Form_Prommer.ListBox_Meldungen.Items.Add('AVRDUDE Parameter wurden generiert ...');

end; { procedure Assembler_class.generiere_AVRDUDE_line_Read_Fuses }







procedure TForm_Prommer.Button_Read_FusesClick(Sender: TObject);
begin

  ba_prommer:=ba_pr_Read_Fuses;
  generiere_AVRDUDE_line_Read_Fuses;
  Edit_AVRDUDE.Text:=AVRDUDE_line;
  Button_Send_LineClick(Sender);

end; { procedure TForm_Prommer.Button_generateClick }









// *** Write_Fuses ***



procedure TForm_Prommer.generiere_AVRDUDE_line_Write_Fuses;
begin

  generiere_AVRDUDE_line_Grundeintrag;


// ***********************************



  AVRDUDE_line:=AVRDUDE_line+
            {    ' -U "lock:w:0x'+IntToHex(FUSE_Lock,2)+':m"'+
                ' -U "efuse:w:0x'+IntToHex(FUSE_Efuse,2)+':m"'+  }
                ' -U "hfuse:w:0x'+IntToHex(FUSE_Hfuse,2)+':m"'+
                ' -U "lfuse:w:0x'+IntToHex(FUSE_Lfuse,2)+':m"';


// ***********************************

  Form_Prommer.ListBox_Meldungen.Items.Add('AVRDUDE Parameter wurden generiert ...');

end; { procedure TForm_Prommer.generiere_AVRDUDE_line_Write_Fuses }







procedure TForm_Prommer.Button_Write_FusesClick(Sender: TObject);
begin

  ba_prommer:=ba_pr_Write_Fuses;
  generiere_AVRDUDE_line_Write_Fuses;
  Edit_AVRDUDE.Text:=AVRDUDE_line;
  Button_Send_LineClick(Sender);

end; { procedure TForm_Prommer.Button_Write_FusesClick }










// ********************************************************
// *** Original / Board ***
// ********************************************************







procedure TForm_Prommer.generiere_AVRDUDE_line_Write_Button_C;
begin

  generiere_AVRDUDE_line_Grundeintrag;


// ***********************************

  FUSE_Hfuse:=Button_C_Fuses.BT_FUSE_Hfuse;
  FUSE_Lfuse:=Button_C_Fuses.BT_FUSE_Lfuse;

  AVRDUDE_line:=AVRDUDE_line+
                ' -U "hfuse:w:0x'+IntToHex(FUSE_Hfuse,2)+':m"'+
                ' -U "lfuse:w:0x'+IntToHex(FUSE_Lfuse,2)+':m"';


// ***********************************

  Form_Prommer.ListBox_Meldungen.Items.Add('AVRDUDE Parameter wurden generiert ...');

end; { procedure TForm_Prommer.generiere_AVRDUDE_line_Write_Original_Fuses }








procedure TForm_Prommer.Button_CClick(Sender: TObject);
begin

  ba_prommer:=ba_pr_Write_Fuses;
  generiere_AVRDUDE_line_Write_Button_C;
  Edit_AVRDUDE.Text:=AVRDUDE_line;
  Button_Send_LineClick(Sender);

  Button_Read_FusesClick(Sender);

end; { procedure TForm_Prommer.Button_Fuses_OriginalClick }









procedure TForm_Prommer.generiere_AVRDUDE_line_Write_Board_Fuses;
begin

  generiere_AVRDUDE_line_Grundeintrag;


// ***********************************

  FUSE_Hfuse:=$D9;
  FUSE_Lfuse:=$FF;

  AVRDUDE_line:=AVRDUDE_line+
                ' -U "hfuse:w:0x'+IntToHex(FUSE_Hfuse,2)+':m"'+
                ' -U "lfuse:w:0x'+IntToHex(FUSE_Lfuse,2)+':m"';


// ***********************************

  Form_Prommer.ListBox_Meldungen.Items.Add('AVRDUDE Parameter wurden generiert ...');

end; { procedure TForm_Prommer.generiere_AVRDUDE_line_Write_Board_Fuses }








procedure TForm_Prommer.Button_DClick(Sender: TObject);
begin

  ba_prommer:=ba_pr_Write_Fuses;
  generiere_AVRDUDE_line_Write_Board_Fuses;
  Edit_AVRDUDE.Text:=AVRDUDE_line;
  Button_Send_LineClick(Sender);

  Button_Read_FusesClick(Sender);

end; { procedure TForm_Prommer.Button_Fuses_BoardClick }











// ********************************************************
// *** Brenner - Routinen ***
// ********************************************************







procedure TForm_Prommer.RunCaptured(var Ausgabe: TStringList;
                                 const _dirName, _exeName: string);
const
  max_read=3000;

var
  StartupInfo: TStartupInfo;
  ProcessInfo: TProcessInformation;
  Buffer: array[0..4000] of char;
  bRead: DWord;
  hRead, hWrite: THandle;
  saAttr: TSECURITYATTRIBUTES;
  Output: TMemoryStream;
  exitcode: cardinal;
  AExitCode: boolean;



begin
  AExitCode:=False;

  saAttr.nLength := sizeof(TSECURITYATTRIBUTES);
  saAttr.bInheritHandle := true;
  saAttr.lpSecurityDescriptor := nil;
  if not CreatePipe(hRead, hWrite, @saAttr, 0) then
  begin
    Ausgabe.Add('Fehler: Die Pipe kann nicht erzeugt werden!');
    Exit;
  end;
  try
    FillChar(StartupInfo, Sizeof(StartupInfo), #0);
    StartupInfo.cb := Sizeof(StartupInfo);
    StartupInfo.dwFlags := STARTF_USESHOWWINDOW or STARTF_USESTDHANDLES;
    StartupInfo.wShowWindow := SW_HIDE and SW_SHOWMINNOACTIVE;
    { Handle mit Childhandle Assoziieren }
    StartupInfo.hStdInput := GetStdHandle(STD_INPUT_HANDLE);
    { Ausgaben abfangen }
    StartupInfo.hStdOutput := hWrite;
    { Fehler abfangen }
    StartupInfo.hStdError := hWrite;
    if not CreateProcess(nil, PChar(_exeName), nil, nil, True,
      0, nil, PChar(_dirName), StartupInfo, ProcessInfo) then
    begin
      Ausgabe.Add('Fehler: Der Prozess kann nicht erzeugt werden!');
      Ausgabe.Add('ExeName='+_exeName);
      Ausgabe.Add('DirName='+_dirName);
    end
    else
    begin
      { loop bis zum Abbruch }
      while WaitforSingleObject(ProcessInfo.hProcess, 0) <> WAIT_OBJECT_0 do
        { dummy }
        ;

      GetExitCodeProcess(ProcessInfo.hProcess, exitcode);

      if AExitCode = False then
      begin
        { Den gesamten Output lesen und in eine StringList kopieren }
        Output := TMemoryStream.Create;
        Output.Clear;
        repeat
          Buffer := #0;
          if ReadFile(hRead, Buffer, max_read, bRead, nil) then
          begin
            Output.WriteBuffer(Buffer, bRead);
            Output.Position := bRead;
          end
          else
            break;
        until bRead <> max_read;
        Output.Position := 0;
        Buffer := #0;
        { Die Ausgaben hinzufuegen }
        output.Read(Buffer, output.Size);
        Ausgabe.Text:=Buffer;
        FreeAndNil(Output);
      end
      else
        Ausgabe.Add('FEHLER: mit Fehlercode='+IntToStr(exitcode));

    end;
  finally
    { Lese- und Schreibhandles der Pipe schliessen }
    CloseHandle(hRead);
    CloseHandle(hWrite);
  end;
end; { TForm_Prommer.RunCaptured }









procedure TForm_Prommer.lese_Device_Signatur(var Konsolen_Ausgabe : TStringList);
var
  AKA_counter : Integer;
  AKA_zeile, AKA_signatur,
  AKA_dev_signatur : String;
  AKA_signatur_gefunden : Boolean;



  procedure gelesene_Signatur_suchen_und_Device_einstellen(AKA_signatur_neu :String);
  var
    SuD_counter : Integer;
    SuD_zeile : String;
  begin

    ListBox_Meldungen.Items.Add('gelesene Signatur wird im Device-Array gesucht ...');

    for SuD_counter:=0 to Form_Device.ATMEGA_Array_Counter do begin

      SuD_zeile:=Form_Device.ATMEGA_Array[SuD_counter].Device_Signature;

      if SuD_zeile=AKA_signatur_neu then begin

        Form_Device.ComboBox_ATMEGA_Typ.ItemIndex:=SuD_counter;

        Form_Device.ComboBox_ATMEGA_TypChange(self);

        ListBox_Meldungen.Items.Add('ATMEGA-Device zur gelesenen Signatur gefunden: '+
                    Form_Device.ATMEGA_Array[SuD_counter].Bezeichner);

        Form_Device.ComboBox_ATMEGA_Typ.Refresh;

      end; { if SuD_zeile=AKA_signatur_neu then }

    end; { for SuD_counter:=0 to ATMEGA_Array_Counter do }

  end; { procedure gelesene_Signatur_suchen_und_Device_einstellen }




begin
  AKA_signatur:='';
  AKA_signatur_gefunden:=false;



    for AKA_counter:=0 to Konsolen_Ausgabe.Count-1 do begin

      AKA_zeile:=Konsolen_Ausgabe[AKA_counter];

      if POS('avrdude.exe: Device signature =',AKA_zeile)=1 then begin
        AKA_signatur:=Copy(AKA_zeile,35,6);
        AKA_signatur_gefunden:=true;
      end;

    end; { for AKA_counter:=0 to Konsolen_Ausgabe.Count-1 do }

    if AKA_signatur_gefunden then begin

      ListBox_Meldungen.Items.Add('Device Signature ='+AKA_signatur);

      Edit_Device_Signature.Text:=AKA_signatur;

      AKA_dev_signatur:=Form_Device.ATMEGA_Array[Form_Device.ComboBox_ATMEGA_Typ.ItemIndex].Device_Signature;
      if Length(AKA_dev_signatur)=6 then begin

        if AKA_dev_signatur=AKA_signatur then begin

          ListBox_Meldungen.Items.Add('Device Signature ist richtig');

        end { if AKA_dev_signatur=AKA_signatur then }
        else begin
          ListBox_Meldungen.Items.Add('*** Fehler: die vorgegebene Device Signature <'+
          AKA_dev_signatur+
          '> stimmt nicht mit der gelesenen Device Signature <'+
          AKA_signatur+'> ueberein');

          gelesene_Signatur_suchen_und_Device_einstellen(AKA_signatur);

        end; { else AKA_dev_signatur=AKA_signatur then }

      end { if Length(AKA_dev_signatur)=6 then }
      else begin
        ListBox_Meldungen.Items.Add('*** Fehler: keine Device signature angegeben');

        gelesene_Signatur_suchen_und_Device_einstellen(AKA_signatur);

      end; { else Length(AKA_dev_signatur)=6 then }

     end
    else
      ListBox_Meldungen.Items.Add('*** Fehler: Device Signature konnte nicht gelesen werden');


end; { procedure TForm_Prommer.lese_Device_Signatur }







procedure TForm_Prommer.Button_Send_LineClick(Sender: TObject);
var
  bat_datei, Konsolen_Ausgabe : TStringList;
  SL_Zaehler : Integer;
  SL_Zeile,
  bat_path : String;
begin

  ListBox_Meldungen.Items.Clear;


  // BAT-Datei erzeugen
  bat_datei := TStringList.Create;

  bat_datei.Add('cd '+prommer_path);
  bat_datei.Add(AVRDUDE_line);

  bat_datei.SaveToFile(Form_RP.ronpas_path+'\'+prommer_bat_name);

  bat_datei.Free;


  // Konsolen-Ausgabe in Datei umleiten
  Konsolen_Ausgabe := TStringList.Create;

  bat_path:=Form_RP.ronpas_path+'\';

  // BAT_Datei ausfuehren



  RunCaptured(Konsolen_Ausgabe,bat_path,Form_RP.ronpas_path+'\'+prommer_bat_name);


  for SL_Zaehler:=0 to Konsolen_Ausgabe.Count-1 do begin
    SL_Zeile:= Konsolen_Ausgabe[SL_Zaehler];
    ListBox_Meldungen.Items.Add(SL_Zeile);
  end;



  if ba_prommer=ba_pr_Read_Device then
    lese_Device_Signatur(Konsolen_Ausgabe);


  Konsolen_Ausgabe.Free;

  // BAT-Datei loeschen
  DeleteFile(PChar(Form_RP.ronpas_path+'\'+prommer_bat_name));



  // nur wenn FUSES betroffen
  if ba_prommer=ba_pr_Read_Fuses then begin
    FUSES_Dateien_einlesen;
    FUSES_anzeigen;
  end; { if (PF_Tab_Zeiger=pf_tab_HL_FUSES) or }


  SendMessage(ListBox_Meldungen.Handle, LB_SETTOPINDEX, ListBox_Meldungen.Items.Count-1, 0);



end; { procedure TForm_Prommer.Button_Send_LineClick }








// ****************************************************



procedure TForm_Prommer.setze_Hex_DateiName;
begin
  Edit_Flash_Quelle.Text:=Form_RP.source_path+'\'+Form_RP.source_name+'.hex';
end; { procedure TForm_Prommer.setze_Hex_DateiName }




procedure TForm_Prommer.Start_Programmer;
begin

  ListBox_Meldungen.Items.Add('Programmer wurde gestartet ...');
  PageControl_Prommer.PageIndex:=Form_RP.CB_PageControl_Index;
  setze_Hex_DateiName;
  Button_Write_FlashClick(Self);
  Button_Send_LineClick(Self);

end; { procedure TForm_Prommer.Start_Programmer }













// ********************************************************
// *** Ende
// ********************************************************


procedure TForm_Prommer.Button_CloseClick(Sender: TObject);
begin

  Form_RP.CB_PageControl_Index:=PageControl_Prommer.PageIndex;
  Form_Prommer.Visible:=false;

end; { procedure TForm_Prommer.Button_CloseClick }









procedure TForm_Prommer.FormDestroy(Sender: TObject);
begin

  Form_RP.CB_PageControl_Index:=PageControl_Prommer.PageIndex;
  Close;

end; { procedure TForm_Prommer.FormDestroy }








end.

