


// ****************************************************
// ** Einlesen des PROMMER - Arrays
// ****************************************************




procedure TForm_Prommer.Read_Prommer_Array;
var
  PA_Read_active : Boolean;
  PA_List : TStringList;
  PA_List_counter : Integer;
  PA_Line : String;
  PA_counter : Integer;
  one_char : Char;
  PA_name : String;



  procedure Read_String_Element(STR3 : String;
                                var ZielFeld : String);
  begin

    if PA_Read_active then begin

      if POS(STR3,PA_Line)=1 then begin

        if Length(PA_Line)>4 then begin
          ZielFeld:=Copy(PA_Line,5,Length(PA_Line));
        end; { if Length(PA_Line)>4 then }

      end; { if POS(STR3,PA_Line)=1 then }

    end; { if PA_Read_active then }

  end; { procedure Read_String_Element }




begin

  PA_name:=Form_RP.ronpas_path+'\'+prommer_path+'\'+prommer_array_name;

  if FileExists(PA_name) then begin


    for PA_counter:=0 to Length_Prommer_Array do begin

      Prommer_Array[PA_counter].Bezeichner:='';
      Prommer_Array[PA_counter].AVRDUDE_ProgrammerID:='';
      Prommer_Array[PA_counter].Picture_Name:='';
      Prommer_Array[PA_counter].ConnectionType:=ct_keiner;

    end; { for Prommer_Array_Counter:=0 to Length_Prommer_Array do }

    PA_List := TStringList.Create;
    PA_List.LoadFromFile(PA_name);

    PA_Read_active:=true;

    Prommer_Array_Counter:=0;

    for PA_List_counter:=0 to PA_List.Count-1 do begin

      PA_Line:=PA_List[PA_List_counter];

      if PA_Read_active then begin

        // Bezeichner fuer ComboBox
        if POS('BEZ',PA_Line)=1 then begin

          Inc(Prommer_Array_Counter);
          if (Prommer_Array_Counter>0) and (Prommer_Array_Counter<Length_Prommer_Array) then begin

            if Length(PA_Line)>4 then begin
              Prommer_Array[Prommer_Array_Counter-1].Bezeichner:=Copy(PA_Line,5,Length(PA_Line));
            end; { if Length(PA_Line)>4 then }

          end
          else begin
            PA_Read_active:=false;
          end;

        end; { if POS('BEZ',PA_Line)=1 then }

      end; { if PA_Read_active then }


      // AVRDUDE ProgrammerID
      Read_String_Element('PID',Prommer_Array[Prommer_Array_Counter-1].AVRDUDE_ProgrammerID);
      // Image-Name
      Read_String_Element('PIC',Prommer_Array[Prommer_Array_Counter-1].Picture_Name);
      // Device-Name
      Read_String_Element('DNA',Prommer_Array[Prommer_Array_Counter-1].Device_Name);



      if PA_Read_active then begin

        // AVRDUDE-Connection-Typ
        if POS('CON',PA_Line)=1 then begin

          if Length(PA_Line)>4 then begin

            one_char:=PA_Line[5];

            case one_char of
              'U' : Prommer_Array[Prommer_Array_Counter-1].ConnectionType:=ct_usb;
              'S' : Prommer_Array[Prommer_Array_Counter-1].ConnectionType:=ct_serial;
            else
              Prommer_Array[Prommer_Array_Counter-1].ConnectionType:=ct_serial;
            end;

          end; { if Length(PA_Line)>4 then }

        end; { if POS('COM',PA_Line)=1 then }

      end; { if PA_Read_active then }



      if PA_Read_active then begin

        // AVRDUDE_Param
        if POS('END',PA_Line)=1 then begin

          PA_Read_active:=false;

        end; { if POS('COM',PA_Line)=1 then }

      end; { if PA_Read_active then }


    end; { for PA_Line_counter:=0 to PA_List.Count-1 do }

  end
  else begin

    ListBox_Meldungen.Items.Add('*** Fehler: Datei <'+PA_name+'> nicht gefunden');

  end; { if FileExists('Prommer_Array.txt') then }


  if Prommer_Array_Counter>0 then
    ListBox_Meldungen.Items.Add('... es wurden '+
                 IntToStr(Prommer_Array_Counter)+' Programmer eingelesen')
  else
    ListBox_Meldungen.Items.Add('*** Fehler: es wurden keine Programmer eingelesen');


end; { procedure TForm_Prommer.Read_Prommer_Array }











procedure TForm_Prommer.Read_Fuse_Bezeichner;
var
  RF_name, RF_line, RF_text : String;
  RF_List : TStringList;
  RF_counter : Integer;
  RF_list_code, RF_fuse_byte,
  RF_bit_nr : Char;
  No_Fuses_Info : Boolean;



  function Text_to_Byte(var TB_Byte : Byte; WF_text2 : String) : Boolean;
  var
    TB_ok : Boolean;
    TB_Zeile : String;
    TB_Zeichen : Char;
  begin

    TB_ok:=false;

    TB_Byte:=$FF;

    if Length(WF_text2)=2 then begin

      TB_Zeichen:=WF_text2[1];

      if TB_Zeichen IN ['0'..'9','a'..'f','A'..'F'] then begin

         TB_Zeichen:=WF_text2[2];

         if TB_Zeichen IN ['0'..'9','a'..'f','A'..'F'] then begin

           TB_Byte:=StrToInt('$'+WF_text2);
           TB_ok:=true;

         end; { if TB_Zeichen IN }

      end; { if TB_Zeichen IN }

    end; { if Length(WF_text2)=2 then }

    Result:=TB_ok;

  end; { function Text_to_Byte }





  procedure Write_to_form(WF_list_code, WF_fuse_byte, WF_bit_nr : Char;
                          WF_text : String);
  var
    WF_byte : Byte;
  begin


    if WF_list_code='B' then begin


      WF_byte:=StrToInt(WF_bit_nr);
      // umgekehrte Reihenfolge in der Anzeige
      WF_byte:=7-WF_byte;


      if (WF_byte>=0) and (WF_byte<=7) then begin

        case WF_fuse_byte of

          'H' : CheckListBox_HFuses.Items[WF_byte]:=WF_text;
          'L' : CheckListBox_LFuses.Items[WF_byte]:=WF_text;
          'E' : CheckListBox_EFuses.Items[WF_byte]:=WF_text;
          'O' : CheckListBox_Lock.Items[WF_byte]:=WF_text;

        end; { case WF_fuse_byte of }


        if WF_text='not used' then begin

          case WF_fuse_byte of

            'H' : CheckListBox_HFuses.ItemEnabled[WF_byte]:=false;
            'L' : CheckListBox_LFuses.ItemEnabled[WF_byte]:=false;
            'E' : CheckListBox_EFuses.ItemEnabled[WF_byte]:=false;
            'O' : CheckListBox_Lock.ItemEnabled[WF_byte]:=false;

          end; { case WF_fuse_byte of }

        end { ELSE WF_text='not used' then }
        else begin

          case WF_fuse_byte of

            'H' : CheckListBox_HFuses.ItemEnabled[WF_byte]:=true;
            'L' : CheckListBox_LFuses.ItemEnabled[WF_byte]:=true;
            'E' : CheckListBox_EFuses.ItemEnabled[WF_byte]:=true;
            'O' : CheckListBox_Lock.ItemEnabled[WF_byte]:=true;

          end; { case WF_fuse_byte of }

        end; { if WF_text='not used' then }


      end; { if (WF_byte>=0) and (WF_byte<=7) then }

    end; { if WF_list_code='B' then }






    if WF_list_code='C' then begin

      {
      CBL=F1
      CBH=D9
      CTC=Original Fuses
      }

      case WF_fuse_byte of

        'B' : case WF_bit_nr of

                'L' : if Text_to_Byte(Button_C_Fuses.BT_FUSE_Lfuse,WF_text) then
                        Button_C_Fuses.BT_Lfuse_ok:=true
                      else
                        Button_C_Fuses.BT_Lfuse_ok:=false;


                'H' : if Text_to_Byte(Button_C_Fuses.BT_FUSE_Hfuse,WF_text) then
                        Button_C_Fuses.BT_Hfuse_ok:=true
                      else
                        Button_C_Fuses.BT_Hfuse_ok:=false;

              end; { case WF_bit_nr of }


        'T' : case WF_bit_nr of

                'C' : if (Length(WF_text)>0) and (Length(WF_text)<30) then begin
                        if (Button_C_Fuses.BT_Hfuse_ok and Button_C_Fuses.BT_Hfuse_ok) then
                          Button_C_Fuses.BT_Caption:=WF_text;

                      end; { if (Length(WF_text)>0) and }

                '1' : if (Length(WF_text)>0) and (Length(WF_text)<30) then begin
                        if (Button_C_Fuses.BT_Hfuse_ok and Button_C_Fuses.BT_Hfuse_ok) then
                          Button_C_Fuses.BT_Text_1:=WF_text;

                      end; { if (Length(WF_text)>0) and }

                '2' : if (Length(WF_text)>0) and (Length(WF_text)<30) then begin
                        if (Button_C_Fuses.BT_Hfuse_ok and Button_C_Fuses.BT_Hfuse_ok) then
                          Button_C_Fuses.BT_Text_2:=WF_text;

                      end; { if (Length(WF_text)>0) and }

                '3' : if (Length(WF_text)>0) and (Length(WF_text)<30) then begin
                        if (Button_C_Fuses.BT_Hfuse_ok and Button_C_Fuses.BT_Hfuse_ok) then
                          Button_C_Fuses.BT_Text_3:=WF_text;

                      end; { if (Length(WF_text)>0) and }

                '4' : if (Length(WF_text)>0) and (Length(WF_text)<30) then begin
                        if (Button_C_Fuses.BT_Hfuse_ok and Button_C_Fuses.BT_Hfuse_ok) then
                          Button_C_Fuses.BT_Text_3:=WF_text;

                      end; { if (Length(WF_text)>0) and }

              end; { case WF_bit_nr of }


        'I' : case WF_bit_nr of

                'N' : if (Length(WF_text)=1) then begin

                         if WF_text[1] IN ['0'..'9'] then begin

                           Button_C_Fuses.BT_Bild_Nummer:=StrToInt(WF_text[1]);

                           if Button_C_Fuses.BT_Bild_Nummer>=ImageList1.Count then
                             Button_C_Fuses.BT_Bild_Nummer:=0;

                         end; { if WF_text[1] IN ['0'..'9'] then }

                       end; { if (Length(WF_text)=1) then }

              end; { case WF_bit_nr of }

      end; { case WF_fuse_byte of }

    end; { if WF_list_code='C' then }



    if WF_list_code='D' then begin

      {
      DBL=F1
      DBH=D9
      DTC=Original Fuses
      }

      case WF_fuse_byte of

        'B' : case WF_bit_nr of

                'L' : if Text_to_Byte(Button_D_Fuses.BT_FUSE_Lfuse,WF_text) then
                        Button_D_Fuses.BT_Lfuse_ok:=true
                      else
                        Button_D_Fuses.BT_Lfuse_ok:=false;


                'H' : if Text_to_Byte(Button_D_Fuses.BT_FUSE_Hfuse,WF_text) then
                        Button_D_Fuses.BT_Hfuse_ok:=true
                      else
                        Button_D_Fuses.BT_Hfuse_ok:=false;

              end; { case WF_bit_nr of }


        'T' : case WF_bit_nr of

                'C' : if (Length(WF_text)>0) and (Length(WF_text)<30) then begin
                        if (Button_D_Fuses.BT_Hfuse_ok and Button_D_Fuses.BT_Hfuse_ok) then
                          Button_D_Fuses.BT_Caption:=WF_text;

                      end; { if (Length(WF_text)>0) and }

                '1' : if (Length(WF_text)>0) and (Length(WF_text)<30) then begin
                        if (Button_D_Fuses.BT_Hfuse_ok and Button_D_Fuses.BT_Hfuse_ok) then
                          Button_D_Fuses.BT_Text_1:=WF_text;

                      end; { if (Length(WF_text)>0) and }

                '2' : if (Length(WF_text)>0) and (Length(WF_text)<30) then begin
                        if (Button_D_Fuses.BT_Hfuse_ok and Button_D_Fuses.BT_Hfuse_ok) then
                          Button_D_Fuses.BT_Text_2:=WF_text;

                      end; { if (Length(WF_text)>0) and }

                '3' : if (Length(WF_text)>0) and (Length(WF_text)<30) then begin
                        if (Button_D_Fuses.BT_Hfuse_ok and Button_D_Fuses.BT_Hfuse_ok) then
                          Button_D_Fuses.BT_Text_3:=WF_text;

                      end; { if (Length(WF_text)>0) and }

                '4' : if (Length(WF_text)>0) and (Length(WF_text)<30) then begin
                        if (Button_D_Fuses.BT_Hfuse_ok and Button_D_Fuses.BT_Hfuse_ok) then
                          Button_D_Fuses.BT_Text_4:=WF_text;

                      end; { if (Length(WF_text)>0) and }

              end; { case WF_bit_nr of }


        'I' : case WF_bit_nr of

                'N' : if (Length(WF_text)=1) then begin

                         if WF_text[1] IN ['0'..'9'] then begin

                           Button_D_Fuses.BT_Bild_Nummer:=StrToInt(WF_text[1]);

                           if Button_D_Fuses.BT_Bild_Nummer>=ImageList1.Count then
                             Button_D_Fuses.BT_Bild_Nummer:=0;

                         end; { if WF_text[1] IN ['0'..'9'] then }

                       end; { if (Length(WF_text)=1) then }

              end; { case WF_bit_nr of }

      end; { case WF_fuse_byte of }

    end; { if WF_list_code='D' then }



    if WF_list_code='E' then begin

      {
      EBL=F1
      EBH=D9
      ETC=Original Fuses
      }

      case WF_fuse_byte of

        'B' : case WF_bit_nr of

                'L' : if Text_to_Byte(Button_E_Fuses.BT_FUSE_Lfuse,WF_text) then
                        Button_E_Fuses.BT_Lfuse_ok:=true
                      else
                        Button_E_Fuses.BT_Lfuse_ok:=false;


                'H' : if Text_to_Byte(Button_E_Fuses.BT_FUSE_Hfuse,WF_text) then
                        Button_E_Fuses.BT_Hfuse_ok:=true
                      else
                        Button_E_Fuses.BT_Hfuse_ok:=false;

              end; { case WF_bit_nr of }


        'T' : case WF_bit_nr of

                'C' : if (Length(WF_text)>0) and (Length(WF_text)<30) then begin
                        if (Button_E_Fuses.BT_Hfuse_ok and Button_E_Fuses.BT_Hfuse_ok) then
                          Button_E_Fuses.BT_Caption:=WF_text;

                      end; { if (Length(WF_text)>0) and }

                '1' : if (Length(WF_text)>0) and (Length(WF_text)<30) then begin
                        if (Button_E_Fuses.BT_Hfuse_ok and Button_E_Fuses.BT_Hfuse_ok) then
                          Button_E_Fuses.BT_Text_1:=WF_text;

                      end; { if (Length(WF_text)>0) and }

                '2' : if (Length(WF_text)>0) and (Length(WF_text)<30) then begin
                        if (Button_E_Fuses.BT_Hfuse_ok and Button_E_Fuses.BT_Hfuse_ok) then
                          Button_E_Fuses.BT_Text_2:=WF_text;

                      end; { if (Length(WF_text)>0) and }

                '3' : if (Length(WF_text)>0) and (Length(WF_text)<30) then begin
                        if (Button_E_Fuses.BT_Hfuse_ok and Button_E_Fuses.BT_Hfuse_ok) then
                          Button_E_Fuses.BT_Text_3:=WF_text;

                      end; { if (Length(WF_text)>0) and }

                '4' : if (Length(WF_text)>0) and (Length(WF_text)<30) then begin
                        if (Button_E_Fuses.BT_Hfuse_ok and Button_E_Fuses.BT_Hfuse_ok) then
                          Button_E_Fuses.BT_Text_4:=WF_text;

                      end; { if (Length(WF_text)>0) and }


              end; { case WF_bit_nr of }


        'I' : case WF_bit_nr of

                'N' : if (Length(WF_text)=1) then begin

                         if WF_text[1] IN ['0'..'9'] then begin

                           Button_E_Fuses.BT_Bild_Nummer:=StrToInt(WF_text[1]);

                           if Button_E_Fuses.BT_Bild_Nummer>=ImageList1.Count then
                             Button_E_Fuses.BT_Bild_Nummer:=0;

                         end; { if WF_text[1] IN ['0'..'9'] then }

                       end; { if (Length(WF_text)=1) then }

              end; { case WF_bit_nr of }

      end; { case WF_fuse_byte of }

    end; { if WF_list_code='E' then }



  end; { procedure Write_to_form }



  procedure Loesche_Fuses_Info;
  var
    LFI_counter : Integer;
  begin

    for LFI_counter:=0 to CheckListBox_HFuses.Items.Count-1 do begin
      CheckListBox_HFuses.Items[LFI_counter]:='';
      CheckListBox_HFuses.ItemEnabled[LFI_counter]:=false;
    end; { for LFI_counter:=0 to CheckListBox_HFuses.Items.Count-1 do }

    for LFI_counter:=0 to CheckListBox_LFuses.Items.Count-1 do begin
      CheckListBox_LFuses.Items[LFI_counter]:='';
      CheckListBox_LFuses.ItemEnabled[LFI_counter]:=false;
    end; { for LFI_counter:=0 to CheckListBox_LFuses.Items.Count-1 do }

    for LFI_counter:=0 to CheckListBox_EFuses.Items.Count-1 do begin
      CheckListBox_EFuses.Items[LFI_counter]:='';
      CheckListBox_EFuses.ItemEnabled[LFI_counter]:=false;
    end; { for LFI_counter:=0 to CheckListBox_EFuses.Items.Count-1 do }

    for LFI_counter:=0 to CheckListBox_Lock.Items.Count-1 do begin
      CheckListBox_Lock.Items[LFI_counter]:='';
      CheckListBox_Lock.ItemEnabled[LFI_counter]:=false;
    end; { for LFI_counter:=0 to CheckListBox_Lock.Items.Count-1 do }

  end; { procedure Loesche_Fuses_Info }


begin

  No_Fuses_Info:=true;

  // Loeschen der Angaben zu den Buttons
  // 1. Button_C_Fuses
  Button_C_Fuses.BT_Caption:='Original Fuses';
  Button_C_Fuses.BT_FUSE_Hfuse:=$FF;
  Button_C_Fuses.BT_FUSE_Lfuse:=$FF;
  Button_C_Fuses.BT_Hfuse_ok:=false;
  Button_C_Fuses.BT_Lfuse_ok:=false;
  Button_C_Fuses.BT_Text_1:='';
  Button_C_Fuses.BT_Text_2:='';
  Button_C_Fuses.BT_Text_3:='';
  Button_C_Fuses.BT_Text_4:='';
  Button_C_Fuses.BT_Bild_Nummer:=0;

  // 2. Button_D_Fuses
  Button_D_Fuses.BT_Caption:='Fuses Board';
  Button_D_Fuses.BT_FUSE_Hfuse:=$FF;
  Button_D_Fuses.BT_FUSE_Lfuse:=$FF;
  Button_D_Fuses.BT_Hfuse_ok:=false;
  Button_D_Fuses.BT_Lfuse_ok:=false;
  Button_D_Fuses.BT_Text_1:='';
  Button_D_Fuses.BT_Text_2:='';
  Button_D_Fuses.BT_Text_3:='';
  Button_D_Fuses.BT_Text_4:='';
  Button_D_Fuses.BT_Bild_Nummer:=0;

  // 3. Button_E_Fuses
  Button_E_Fuses.BT_Caption:='Fuses Board 2';
  Button_E_Fuses.BT_FUSE_Hfuse:=$FF;
  Button_E_Fuses.BT_FUSE_Lfuse:=$FF;
  Button_E_Fuses.BT_Hfuse_ok:=false;
  Button_E_Fuses.BT_Lfuse_ok:=false;
  Button_E_Fuses.BT_Text_1:='';
  Button_E_Fuses.BT_Text_2:='';
  Button_E_Fuses.BT_Text_3:='';
  Button_E_Fuses.BT_Text_4:='';
  Button_E_Fuses.BT_Bild_Nummer:=0;


  if Length(Form_Device.ATMEGA_Array[Form_Device.ComboBox_ATMEGA_Typ.ItemIndex].Fuses_name)>0 then begin

    RF_name:=Form_RP.ronpas_path+'\'+atmega_fuse_path+'\'+
             Form_Device.ATMEGA_Array[Form_Device.ComboBox_ATMEGA_Typ.ItemIndex].Fuses_name;

    if FileExists(RF_name) then begin

      RF_List := TStringList.Create;
      RF_List.LoadFromFile(RF_name);

      if RF_List.Count>0 then begin

        No_Fuses_Info:=false;

        for RF_counter:=0 to RF_List.Count-1 do begin

          RF_line:=RF_List[RF_counter];

          if Length(RF_line)>4 then begin

            RF_list_code:=RF_line[1];
            RF_fuse_byte:=RF_line[2];
            RF_bit_nr   :=RF_line[3];
            RF_text     :=Copy(RF_line,5,Length(RF_line)-4);

            Write_to_form(RF_list_code,RF_fuse_byte,RF_bit_nr,RF_text);

          end; { if Length(RF_line)>4 then }

        end; { for RF_counter:=0 to RF_List.Count-1 do }

      end; { if RF_List.Count>0 then }


    end
    else begin

      ListBox_Meldungen.Items.Add('*** Fehler: Datei <'+RF_name+'> nicht gefunden');

    end; { if FileExists(RF_name) then }



  end { if Length(ATMEGA_Array[ATMEGA_Array_Counter-1].Fuses_name)>0 then }
  else begin

    ListBox_Meldungen.Items.Add('*** Fehler: keine Fuses-Informationen zum <'+
                       Form_Device.ATMEGA_Array[Form_Device.ComboBox_ATMEGA_Typ.ItemIndex].Bezeichner+
                             '> vorhanden');

  end; { if FileExists(RF_name) then }

  if No_Fuses_Info then begin
    Loesche_Fuses_Info;
  end;


  // Button_C
  if (Button_C_Fuses.BT_Hfuse_ok and Button_C_Fuses.BT_Hfuse_ok) then begin

    // Button_C
    Button_C.Visible:=true;
    Button_C.Caption:=Button_C_Fuses.BT_Caption;

    // Label_C
    Label_C_01.Left:=Button_C.Left+100+5;
    Label_C_01.Top:=Button_C.Top-1;
    Label_C_01.Visible:=true;
    Label_C_01.Caption:='H='+IntToHex(Button_C_Fuses.BT_FUSE_Hfuse,2)+
                        'H  L='+IntToHex(Button_C_Fuses.BT_FUSE_Lfuse,2)+'H';

    if Length(Button_C_Fuses.BT_Text_1)>0 then begin
      Label_C_02.Visible:=true;
      Label_C_02.Left:=Label_C_01.Left;
      Label_C_02.Top:=Label_C_01.Top+15;
      Label_C_02.Caption:=Button_C_Fuses.BT_Text_1;
    end
    else
      Label_C_02.Visible:=false;


    if Length(Button_C_Fuses.BT_Text_2)>0 then begin
      Label_C_03.Visible:=true;
      Label_C_03.Left:=Label_C_01.Left;
      Label_C_03.Top:=Label_C_02.Top+15;
      Label_C_03.Caption:=Button_C_Fuses.BT_Text_2;
    end
    else
      Label_C_03.Visible:=false;


    if Length(Button_C_Fuses.BT_Text_3)>0 then begin
      Label_C_04.Visible:=true;
      Label_C_04.Left:=Label_C_01.Left;
      Label_C_04.Top:=Label_C_03.Top+15;
      Label_C_04.Caption:=Button_C_Fuses.BT_Text_3;
    end
    else
      Label_C_04.Visible:=false;



    // Image_Button_C
    Image_Button_C.Visible:=true;
    Image_Button_C.Top:=Button_C.Top+30+4;
    Image_Button_C.Left:=Button_C.Left;
    ImageList1.GetBitmap(0,Image_Button_C.Picture.Bitmap);

  end
  else begin
    // Button_C
    Button_C.Visible:=false;
    // Label_C
    Label_C_01.Visible:=false;
    Label_C_01.Caption:='';
    Label_C_02.Visible:=false;
    Label_C_02.Caption:='';
    Label_C_03.Visible:=false;
    Label_C_03.Caption:='';
    Label_C_04.Visible:=false;
    Label_C_04.Caption:='';
    // Image_Button_C
    Image_Button_C.Visible:=false;
  end; { Button_C }




  // Button_D
  if (Button_D_Fuses.BT_Hfuse_ok and Button_D_Fuses.BT_Hfuse_ok) and
      Button_C.Visible then begin

    // Button_D
    Button_D.Visible:=true;
    Button_D.Left:=Button_C.Left+100+150;
    Button_D.Top:=Button_C.Top;
    Button_D.Caption:=Button_D_Fuses.BT_Caption;

    // Label_D
    Label_D_01.Left:=Button_D.Left+100+5;
    Label_D_01.Top:=Button_D.Top-1;
    Label_D_01.Visible:=true;
    Label_D_01.Caption:='H='+IntToHex(Button_D_Fuses.BT_FUSE_Hfuse,2)+
                        'H  L='+IntToHex(Button_D_Fuses.BT_FUSE_Lfuse,2)+'H';



    if Length(Button_D_Fuses.BT_Text_1)>0 then begin
      Label_D_02.Visible:=true;
      Label_D_02.Left:=Label_D_01.Left;
      Label_D_02.Top:=Label_D_01.Top+15;
      Label_D_02.Caption:=Button_D_Fuses.BT_Text_1;
    end
    else
      Label_D_02.Visible:=false;


    if Length(Button_D_Fuses.BT_Text_2)>0 then begin
      Label_D_03.Visible:=true;
      Label_D_03.Left:=Label_D_01.Left;
      Label_D_03.Top:=Label_D_02.Top+15;
      Label_D_03.Caption:=Button_D_Fuses.BT_Text_2;
    end
    else
      Label_D_03.Visible:=false;


    if Length(Button_D_Fuses.BT_Text_3)>0 then begin
      Label_D_04.Visible:=true;
      Label_D_04.Left:=Label_D_01.Left;
      Label_D_04.Top:=Label_D_03.Top+15;
      Label_D_04.Caption:=Button_D_Fuses.BT_Text_3;
    end
    else
      Label_D_04.Visible:=false;



    // Image_Button_D
    Image_Button_D.Visible:=true;
    Image_Button_D.Top:=Button_D.Top+30+4;
    Image_Button_D.Left:=Button_D.Left;
    ImageList1.GetBitmap(0,Image_Button_D.Picture.Bitmap);

  end
  else begin
    // Button_D
    Button_D.Visible:=false;
    // Label_D
    Label_D_01.Visible:=false;
    Label_D_01.Caption:='';
    Label_D_02.Visible:=false;
    Label_D_02.Caption:='';
    Label_D_03.Visible:=false;
    Label_D_03.Caption:='';
    Label_D_04.Visible:=false;
    Label_D_04.Caption:='';
    // Image_Button_D
    Image_Button_D.Visible:=false;
  end; { Button_D }




  // Button_E
  if (Button_E_Fuses.BT_Hfuse_ok and Button_E_Fuses.BT_Hfuse_ok) and
      Button_D.Visible then begin

    // Button_E
    Button_E.Visible:=true;
    Button_E.Top:=Button_C.Top;
    Button_E.Left:=Button_D.Left+100+150;
    Button_E.Caption:=Button_E_Fuses.BT_Caption;

    // Label_E
    Label_E_01.Left:=Button_E.Left+100+5;
    Label_E_01.Top:=Button_E.Top-1;
    Label_E_01.Visible:=true;
    Label_E_01.Caption:='H='+IntToHex(Button_E_Fuses.BT_FUSE_Hfuse,2)+
                        'H  L='+IntToHex(Button_E_Fuses.BT_FUSE_Lfuse,2)+'H';


    if Length(Button_E_Fuses.BT_Text_1)>0 then begin
      Label_E_02.Visible:=true;
      Label_E_02.Left:=Label_E_01.Left;
      Label_E_02.Top:=Label_E_01.Top+15;
      Label_E_02.Caption:=Button_E_Fuses.BT_Text_1;
    end
    else
      Label_E_02.Visible:=false;


    if Length(Button_E_Fuses.BT_Text_2)>0 then begin
      Label_E_03.Visible:=true;
      Label_E_03.Left:=Label_E_01.Left;
      Label_E_03.Top:=Label_E_02.Top+15;
      Label_e_03.Caption:=Button_E_Fuses.BT_Text_2;
    end
    else
      Label_E_03.Visible:=false;


    if Length(Button_E_Fuses.BT_Text_3)>0 then begin
      Label_E_04.Visible:=true;
      Label_E_04.Left:=Label_E_01.Left;
      Label_E_04.Top:=Label_E_03.Top+15;
      Label_E_04.Caption:=Button_E_Fuses.BT_Text_3;
    end
    else
      Label_E_04.Visible:=false;



    // Image_Button_E
    Image_Button_E.Visible:=true;
    Image_Button_E.Top:=Button_E.Top+30+4;
    Image_Button_E.Left:=Button_E.Left;
    ImageList1.GetBitmap(0,Image_Button_E.Picture.Bitmap);

  end
  else begin
    // Button_E
    Button_E.Visible:=false;
    // Label_E
    Label_E_01.Visible:=false;
    Label_E_01.Caption:='';
    Label_E_02.Visible:=false;
    Label_E_02.Caption:='';
    Label_E_03.Visible:=false;
    Label_E_03.Caption:='';
    Label_E_04.Visible:=false;
    Label_E_04.Caption:='';
    // Image_Button_E
    Image_Button_E.Visible:=false;
  end; { Button_E }



end; { procedure TForm_Prommer.Read_Fuse_Bezeichner }










procedure TForm_Prommer.FuseByte_zu_CheckListBox;



  procedure FuseByte_eintragen(FB_Byte : Byte;
                               var FB_CheckListBox : TCheckListBox);
  var
    FB_counter : Integer;
    FB_Byte_Test : Byte;
  begin

    for FB_counter:=0 to 7 do begin

      FB_Byte_Test:=FB_Byte and %10000000;

      if FB_Byte_Test=0 then
        FB_CheckListBox.Checked[FB_counter]:=true
      else
        FB_CheckListBox.Checked[FB_counter]:=false;

      FB_Byte:=FB_Byte shl 1;

    end; { for FB_counter:=0 to 7 do }

  end; { procedure FuseByte_eintragen }


begin

 FuseByte_eintragen(FUSE_Hfuse,CheckListBox_HFuses);
 FuseByte_eintragen(FUSE_Lfuse,CheckListBox_LFuses);
{ FuseByte_eintragen(FUSE_Efuse,CheckListBox_EFuses);
 FuseByte_eintragen(FUSE_Lock,CheckListBox_Lock);  }

end; { procedure TForm_Prommer.FuseByte_zu_CheckListBox }







function TForm_Prommer.CheckListBox_zu_FuseByte(var CF_CheckListBox : TCheckListBox) : Byte;

var
  FB_counter : Integer;
  CF_Byte : Byte;

begin

  CF_Byte:=%00000000;

  for FB_counter:=0 to 7 do begin

      CF_Byte:=CF_Byte shl 1;

      if CF_CheckListBox.Checked[FB_counter]=false then
        CF_Byte:=CF_Byte or %00000001;

    end; { for FB_counter:=0 to 7 do }

  Result:=CF_Byte;

end; { function TForm_Prommer.CheckListBox_zu_FuseByte }













