



// ********************************************
//           PROCEDURE / FUNCTION
// ********************************************



function ZWC_class.PROC_FUNC_name_eintragen(PNAME : String;
                                            ANWType : Char) : Boolean;
 var
  PN_erfolgreich : Boolean;
begin
  PN_erfolgreich:=false;

  if not NAME_vorhanden(PNAME) then begin
    NAME_TAB[NAME_TAB_counter].bezeichner:=PNAME;
    NAME_TAB[NAME_TAB_counter].ANW_type:=ANWType;
    Inc_NAME_TAB_counter;
    PN_erfolgreich:=true;

    PROC_LIS.LISTE[PROC_LIS.counter].Name:=PNAME;
    PROC_LIS.LISTE[PROC_LIS.counter].ANW_Type:=ANWType;

    if ANWType='P' then
      STM_LISTE[STM_LISTE_counter].Bemerkung:='; PROCEDURE - Anfang ('+PNAME+')'
    else
      STM_LISTE[STM_LISTE_counter].Bemerkung:='; FUNCTION - Anfang ('+PNAME+')';

    STM_LISTE[STM_LISTE_counter].statement:=STM_sprungmarke;
    STM_LISTE[STM_LISTE_counter].parameter1:=PNAME;
    Inc_STM_TAB_counter;

  end
  else
    Fehler_cl.Registrieren('ZwischenCode/PROC_FUNC_name_eintragen','Name bereits vergeben ('+PNAME+')',
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

  Result:=PN_erfolgreich;

end; { function ZWC_class.PROC_FUNC_name_eintragen }





function ZWC_class.PROC_FUNC_param_name_eintragen(PNAME : String;
                                                  ANWType : CHAR) : Boolean;
var
  PN_erfolgreich : Boolean;
begin
  VAR_Liste_aktiv:=false;
  VAR_Listen_Pos:=0;
  PN_erfolgreich:=false;
  if NAME_TAB[NAME_TAB_counter].bezeichner='' then begin
      if NAME_TAB[NAME_TAB_counter].ASM_type=AT_kein_typ  then begin
        if not NAME_vorhanden(PNAME) then begin
          NAME_TAB[NAME_TAB_counter].bezeichner:=PNAME;
          NAME_TAB[NAME_TAB_counter].ANW_type:=ANWType;
          PN_erfolgreich:=true;
          VAR_Listen_Pos:=NAME_TAB_counter;
        end
        else
          Fehler_cl.Registrieren('ZwischenCode/PROC_FUNC_param_name_eintragen',
                                 'Name bereits vergeben ('+PNAME+')',
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

      end
      else
        Fehler_cl.Registrieren('ZwischenCode/PROC_FUNC_param_name_eintragen',
                               'Typ zur Variable bereits eingetragen ('+PNAME+')',
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);
  end
  else
    Fehler_cl.Registrieren('ZwischenCode/PROC_FUNC_param_name_eintragen',
                           'Variable bereits eingetragen ('+PNAME+')',
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

  Result:=PN_erfolgreich;

end; { function ZWC_class.PROC_FUNC_param_name_eintragen }






function ZWC_class.PROC_FUNC_param_liste_eintragen(PLISTE : String;
                                                   ANWType : CHAR) : Boolean;
var
  PL_erfolgreich : Boolean;
begin
  VAR_Liste_aktiv:=true;
  PL_erfolgreich:=false;
  Inc_NAME_TAB_counter;
  if NAME_TAB[NAME_TAB_counter].bezeichner='' then begin
      if NAME_TAB[NAME_TAB_counter].ASM_type=AT_kein_typ  then begin
        if not NAME_vorhanden(PLISTE) then begin
          NAME_TAB[NAME_TAB_counter].bezeichner:=PLISTE;
          NAME_TAB[NAME_TAB_counter].ANW_type:=ANWType;
          PL_erfolgreich:=true;
        end
        else
          Fehler_cl.Registrieren('ZwischenCode/PROC_FUNC_param_liste_eintragen',
                                 'Parametername bereits vorhanden ('+PLISTE+')',
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

      end
      else
        Fehler_cl.Registrieren('ZwischenCode/PROC_FUNC_param_liste_eintragen',
                               'Typ zum Parameter bereits eingetragen ('+PLISTE+')',
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);
  end
  else
    Fehler_cl.Registrieren('ZwischenCode/PROC_FUNC_param_liste_eintragen',
                           'Parametername bereits eingetragen ('+PLISTE+')',
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

  Result:=PL_erfolgreich;

end; { function ZWC_class.PROC_FUNC_param_liste_eintragen }







function ZWC_class.naechstes_Register : String;
var
  das_Register : String;
begin

  if REG_ARRAY_LOW_pointer<=MAX_ANZ_LOW_REG then begin
    das_Register:=REG_ARRAY_LOW[REG_ARRAY_LOW_pointer];
    Inc(REG_ARRAY_LOW_pointer);
  end
  else
    Fehler_cl.Registrieren('ZwischenCode/naechstes_Register',
                           'Es stehen nur maximal '+IntToStr(MAX_ANZ_LOW_REG)+
                           ' Register fuer die Parameteruebergabe zur Verfuegung',
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

  Result:=das_Register;
end; { function ZWC_class.naechstes_Register }





function ZWC_class.PROC_FUNC_param_type_eintragen(PTYPE : String) : Boolean;
var
  PT_erfolgreich : Boolean;




   procedure PROC_LISTE_Eintrag(PL_Param : String; PL_ASM_type : ASM_type_Typ; PL_ANW_Type : Char);
   begin
     PROC_LIS.LISTE[PROC_LIS.counter].PPR_ARR[PROC_LIS.LISTE[PROC_LIS.counter].counter].Parameter:=PL_Param;
     PROC_LIS.LISTE[PROC_LIS.counter].PPR_ARR[PROC_LIS.LISTE[PROC_LIS.counter].counter].ASM_type:=PL_ASM_type;
     PROC_LIS.LISTE[PROC_LIS.counter].PPR_ARR[PROC_LIS.LISTE[PROC_LIS.counter].counter].ANW_Type:=PL_ANW_Type;

     case PL_ASM_type of

       AT_boolean, AT_byte, AT_char :
         begin
           PROC_LIS.LISTE[PROC_LIS.counter].PPR_ARR[PROC_LIS.LISTE[PROC_LIS.counter].counter].Register_L:=
             naechstes_Register;

         end; { AT_boolean, AT_byte, AT_char }

       AT_word :
         begin
           PROC_LIS.LISTE[PROC_LIS.counter].PPR_ARR[PROC_LIS.LISTE[PROC_LIS.counter].counter].Register_L:=
              naechstes_Register;
           PROC_LIS.LISTE[PROC_LIS.counter].PPR_ARR[PROC_LIS.LISTE[PROC_LIS.counter].counter].Register_H:=
              naechstes_Register;
         end; { AT_word }

       AT_dword :
         begin
           PROC_LIS.LISTE[PROC_LIS.counter].PPR_ARR[PROC_LIS.LISTE[PROC_LIS.counter].counter].Register_L:=
              naechstes_Register;
           PROC_LIS.LISTE[PROC_LIS.counter].PPR_ARR[PROC_LIS.LISTE[PROC_LIS.counter].counter].Register_H:=
              naechstes_Register;
           PROC_LIS.LISTE[PROC_LIS.counter].PPR_ARR[PROC_LIS.LISTE[PROC_LIS.counter].counter].Register_LH:=
              naechstes_Register;
           PROC_LIS.LISTE[PROC_LIS.counter].PPR_ARR[PROC_LIS.LISTE[PROC_LIS.counter].counter].Register_HH:=
              naechstes_Register;
         end; { AT_dword }


       AT_currency :
         begin

           PROC_LIS.LISTE[PROC_LIS.counter].PPR_ARR[PROC_LIS.LISTE[PROC_LIS.counter].counter].Register_L:=
              naechstes_Register;
           PROC_LIS.LISTE[PROC_LIS.counter].PPR_ARR[PROC_LIS.LISTE[PROC_LIS.counter].counter].Register_H:=
              naechstes_Register;
           PROC_LIS.LISTE[PROC_LIS.counter].PPR_ARR[PROC_LIS.LISTE[PROC_LIS.counter].counter].Register_LH:=
              naechstes_Register;
           PROC_LIS.LISTE[PROC_LIS.counter].PPR_ARR[PROC_LIS.LISTE[PROC_LIS.counter].counter].Register_HH:=
              naechstes_Register;

           PROC_LIS.LISTE[PROC_LIS.counter].PPR_ARR[PROC_LIS.LISTE[PROC_LIS.counter].counter].Register_LLH:=
              naechstes_Register;
           PROC_LIS.LISTE[PROC_LIS.counter].PPR_ARR[PROC_LIS.LISTE[PROC_LIS.counter].counter].Register_LHH:=
              naechstes_Register;
           PROC_LIS.LISTE[PROC_LIS.counter].PPR_ARR[PROC_LIS.LISTE[PROC_LIS.counter].counter].Register_HLH:=
              naechstes_Register;
           PROC_LIS.LISTE[PROC_LIS.counter].PPR_ARR[PROC_LIS.LISTE[PROC_LIS.counter].counter].Register_HHH:=
              naechstes_Register;

         end; { AT_currency }


     else
       Fehler_cl.Registrieren('ZwischenCode/PROC_FUNC_param_type_eintragen/PROC_LISTE_Eintrag',
                              'kein gueltiger Typ angegeben',
                              Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                              Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                              Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

     end; { case PL_ASM_type of }

     Inc(PROC_LIS.LISTE[PROC_LIS.counter].counter);

     if PROC_LIS.LISTE[PROC_LIS.counter].counter>Laenge_PROC_PAR_Liste then
       Fehler_cl.Registrieren('ZwischenCode/PROC_FUNC_param_type_eintragen/PROC_LISTE_Eintrag',
                              'Es duerfen nur maximal '+IntToStr(Laenge_PROC_PAR_Liste)+
                              ' Parameter in einer Prozedur uebergeben werden',
                              Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                              Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                              Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

   end; { procedure PROC_LISTE_Eintrag }




   procedure Type_in_VAR_und_PROC_Liste_eintragen;
   var
     L_Zaehler : Integer;
     AST : ASM_type_Typ;
   begin
     if VAR_Listen_Pos>0 then begin
       AST:=TYPENAME_IN_TYPE(PTYPE);
       for L_Zaehler:=VAR_Listen_Pos to NAME_TAB_counter do begin
         NAME_TAB[L_Zaehler].ASM_type:=AST;
         PROC_LISTE_Eintrag(NAME_TAB[L_Zaehler].Bezeichner,AST,NAME_TAB[L_Zaehler].ANW_type);
       end; { for L_Zaehler:=VAR_Listen_Pos to NAME_TAB_counter do }
     end; { if VAR_Listen_Pos>0 then }
   end; { procedure Type_in_VAR_Liste_eintragen }



begin
  PT_erfolgreich:=false;
  if NAME_TAB[NAME_TAB_counter].bezeichner<>'' then begin
      if NAME_TAB[NAME_TAB_counter].ASM_type=AT_kein_typ  then begin
        if VAR_Liste_aktiv then
          Type_in_VAR_und_PROC_Liste_eintragen
        else begin
          NAME_TAB[NAME_TAB_counter].ASM_type:=TYPENAME_IN_TYPE(PTYPE);
          PROC_LISTE_Eintrag(NAME_TAB[NAME_TAB_counter].Bezeichner,NAME_TAB[NAME_TAB_counter].ASM_type,
                             NAME_TAB[NAME_TAB_counter].ANW_type);

        end;

        // Eintragen der (Anzahl) lokalen Register fuer die Parameteruebergabe
        PROC_LIS.LISTE[PROC_LIS.counter].REG_ARRAY_LOW_pointer:=REG_ARRAY_LOW_pointer;

        PT_erfolgreich:=true;
        Inc_NAME_TAB_counter;

      end
      else
        Fehler_cl.Registrieren('ZwischenCode/PROC_FUNC_param_type_eintragen',
                               'Typ zur Variable bereits eingetragen ('+PTYPE+')',
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);
  end
  else
    Fehler_cl.Registrieren('ZwischenCode/PROC_FUNC_param_type_eintragen',
                           'Variablenname zum Typ noch nicht eingetragen ('+PTYPE+')',
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

  VAR_Liste_aktiv:=false;
  VAR_Listen_Pos:=0;
  Result:=PT_erfolgreich;
end; { function ZWC_class.PROC_FUNC_param_type_eintragen }







function ZWC_class.PROC_FUNC_name_vergleichen(PNAME : String) : Boolean;
 var
  PN_erfolgreich : Boolean;


  // Loeschen der lokalen Parameternamen der deklarierten Prozedur nach dem Ende der Deklaration
  procedure Loeschen_der_Parameternamen;
  var
    lpn_counter : Integer;
  begin
    for lpn_counter:=PROC_LIS.LISTE[PROC_LIS.counter].counter-1 downto 1 do begin
      dec(NAME_TAB_counter);
      if PROC_LIS.LISTE[PROC_LIS.counter].PPR_ARR[lpn_counter].Parameter=
                     NAME_TAB[NAME_TAB_counter].Bezeichner then begin
        NAME_TAB[NAME_TAB_counter].Bezeichner:='';
        NAME_TAB[NAME_TAB_counter].Wert:='';
        NAME_TAB[NAME_TAB_counter].ASM_type:=AT_kein_typ;
        NAME_TAB[NAME_TAB_counter].ANW_type:='X';
      end { if PROC_LISTE[PROC_LISTE_counter].PPR_ARR[lpn_counter].Parameter= }
      else
        Fehler_cl.Registrieren('ZwischenCode/PROCEDURE_name_vergleichen/Loeschen_der_Parameternamen',
                           'Parameter ('+PROC_LIS.LISTE[PROC_LIS.counter].PPR_ARR[lpn_counter].Parameter+') '+
                           'ungleich Bezeichner ('+NAME_TAB[NAME_TAB_counter].Bezeichner+')',
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

    end; { for lpn_counter:=1 to }

  end; { procedure Loeschen_der_Parameternamen }



begin
  PN_erfolgreich:=false;

  if PROC_LIS.LISTE[PROC_LIS.counter].Name=PNAME then begin

    PN_erfolgreich:=true;

    if PROC_LIS.LISTE[PROC_LIS.counter].ANW_Type='P' then
      STM_LISTE[STM_LISTE_counter].Bemerkung:='; PROCEDURE - Ende ('+PNAME+')'
    else
      STM_LISTE[STM_LISTE_counter].Bemerkung:='; FUNCTION - Ende ('+PNAME+')';

    STM_LISTE[STM_LISTE_counter].statement:=STM_RET;
    Inc_STM_TAB_counter;

    Result:=PN_erfolgreich;

    if PROC_LIS.LISTE[PROC_LIS.counter].counter>1 then
      Loeschen_der_Parameternamen;

    REG_ARRAY_LOW_pointer:=1;

    Inc_PROC_LISTE_counter;

  end
  else
    if PROC_LIS.LISTE[PROC_LIS.counter].ANW_Type='P' then
      Fehler_cl.Registrieren('ZwischenCode/PROC_FUNC_name_vergleichen',
                             'PROCEDURE-Name ('+PNAME+') stimmt nicht mit dem deklarierten Namen ('+
                             PROC_LIS.LISTE[PROC_LIS.counter].Name+') ueberein',
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte)
    else
      Fehler_cl.Registrieren('ZwischenCode/PROC_FUNC_name_vergleichen',
                             'FUNCTION-Name ('+PNAME+') stimmt nicht mit dem deklarierten Namen ('+
                             PROC_LIS.LISTE[PROC_LIS.counter].Name+') ueberein',
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

end; { function ZWC_class.PROC_FUNC_name_vergleichen }







// ********************************************
//          Aufruf einer PROCEDURE
// ********************************************




function ZWC_class.PCALL_name_vergleichen(CNAME : String) : Boolean;
var
  PCN_erfolgreich : Boolean;

begin
  PCN_erfolgreich:=false;

  if NAME_und_ANW_type_vorhanden(CNAME,'P') then begin
    PCN_erfolgreich:=true;
    akt_CALL_PROC.PROC_Pos:=Name_in_PROC_LIS_suchen(CNAME);
  end; { if NAME_und_ANW_type_vorhanden(CNAME,'P') then }

  Result:=PCN_erfolgreich;

end; { function ZWC_class.PROCEDURE_call_name_vergleichen }






function ZWC_class.PCALL_var_parameter_eintragen(PNAME : String) : Boolean;
var
  PCP_erfolgreich : Boolean;
  Type_dekl, Type_ueber : ASM_type_Typ;
  ANW_Type : Char;
begin

  PCP_erfolgreich:=false;

  if NAME_TO_ANW_und_ASM(PNAME,ANW_Type,Type_ueber) then begin
    Type_dekl:=PROC_LIS.LISTE[akt_CALL_PROC.PROC_Pos].PPR_ARR[akt_CALL_PROC.counter].ASM_type;

    if Type_dekl=Type_ueber then begin
      akt_CALL_PROC.PPR_ARR[akt_CALL_PROC.counter].Parameter:=PNAME;
      akt_CALL_PROC.PPR_ARR[akt_CALL_PROC.counter].ANW_Type:=ANW_Type;
      akt_CALL_PROC.PPR_ARR[akt_CALL_PROC.counter].ASM_type:=Type_ueber;

      akt_CALL_PROC.PPR_ARR[akt_CALL_PROC.counter].Register_L:=
               PROC_LIS.LISTE[akt_CALL_PROC.PROC_Pos].PPR_ARR[akt_CALL_PROC.counter].Register_L;
      akt_CALL_PROC.PPR_ARR[akt_CALL_PROC.counter].Register_H:=
               PROC_LIS.LISTE[akt_CALL_PROC.PROC_Pos].PPR_ARR[akt_CALL_PROC.counter].Register_H;
      akt_CALL_PROC.PPR_ARR[akt_CALL_PROC.counter].Register_LH:=
               PROC_LIS.LISTE[akt_CALL_PROC.PROC_Pos].PPR_ARR[akt_CALL_PROC.counter].Register_LH;
      akt_CALL_PROC.PPR_ARR[akt_CALL_PROC.counter].Register_HH:=
               PROC_LIS.LISTE[akt_CALL_PROC.PROC_Pos].PPR_ARR[akt_CALL_PROC.counter].Register_HH;

      akt_CALL_PROC.PPR_ARR[akt_CALL_PROC.counter].Register_LLH:=
               PROC_LIS.LISTE[akt_CALL_PROC.PROC_Pos].PPR_ARR[akt_CALL_PROC.counter].Register_LLH;
      akt_CALL_PROC.PPR_ARR[akt_CALL_PROC.counter].Register_LHH:=
               PROC_LIS.LISTE[akt_CALL_PROC.PROC_Pos].PPR_ARR[akt_CALL_PROC.counter].Register_LHH;
      akt_CALL_PROC.PPR_ARR[akt_CALL_PROC.counter].Register_HLH:=
               PROC_LIS.LISTE[akt_CALL_PROC.PROC_Pos].PPR_ARR[akt_CALL_PROC.counter].Register_HLH;
      akt_CALL_PROC.PPR_ARR[akt_CALL_PROC.counter].Register_HHH:=
               PROC_LIS.LISTE[akt_CALL_PROC.PROC_Pos].PPR_ARR[akt_CALL_PROC.counter].Register_HHH;

      PCP_erfolgreich:=true;

      Inc_akt_CALL_PROC_counter;

    end
    else
      Fehler_cl.Registrieren('ZwischenCode/PCALL_var_parameter_eintragen',
                             'Der Typ des deklarierten Parameters ('+TYPE_IN_TYPENAME(Type_dekl)+
                             ') stimmt nicht mit dem Typ des uebergebenen Parameters ('+
                             TYPE_IN_TYPENAME(Type_ueber)+') ueberein',
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

  end
  else
    Fehler_cl.Registrieren('ZwischenCode/PCALL_var_parameter_eintragen',
                           'Der Parameter ('+PNAME+') wurde nicht als Variable deklariert',
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

  Result:=PCP_erfolgreich;

end; { function ZWC_class.PCALL_var_parameter_eintragen }





function ZWC_class.PCALL_wert_parameter_eintragen(PW : String; PUT : SI_Unter_Typ) : Boolean;
var
  PCP_erfolgreich : Boolean;
  Type_dekl : ASM_type_Typ;
begin
  PCP_erfolgreich:=false;

  Type_dekl:=PROC_LIS.LISTE[akt_CALL_PROC.PROC_Pos].PPR_ARR[akt_CALL_PROC.counter].ASM_type;

  if CONST_WERT_ueberpruefen(PW,PUT,Type_dekl) then begin
    akt_CALL_PROC.PPR_ARR[akt_CALL_PROC.counter].ASM_type:=Type_dekl;
    akt_CALL_PROC.PPR_ARR[akt_CALL_PROC.counter].ANW_Type:='W';

    akt_CALL_PROC.PPR_ARR[akt_CALL_PROC.counter].Register_L:=
               PROC_LIS.LISTE[akt_CALL_PROC.PROC_Pos].PPR_ARR[akt_CALL_PROC.counter].Register_L;
    akt_CALL_PROC.PPR_ARR[akt_CALL_PROC.counter].Register_H:=
               PROC_LIS.LISTE[akt_CALL_PROC.PROC_Pos].PPR_ARR[akt_CALL_PROC.counter].Register_H;
    akt_CALL_PROC.PPR_ARR[akt_CALL_PROC.counter].Register_LH:=
               PROC_LIS.LISTE[akt_CALL_PROC.PROC_Pos].PPR_ARR[akt_CALL_PROC.counter].Register_LH;
    akt_CALL_PROC.PPR_ARR[akt_CALL_PROC.counter].Register_HH:=
               PROC_LIS.LISTE[akt_CALL_PROC.PROC_Pos].PPR_ARR[akt_CALL_PROC.counter].Register_HH;

    akt_CALL_PROC.PPR_ARR[akt_CALL_PROC.counter].Register_LLH:=
               PROC_LIS.LISTE[akt_CALL_PROC.PROC_Pos].PPR_ARR[akt_CALL_PROC.counter].Register_LLH;
    akt_CALL_PROC.PPR_ARR[akt_CALL_PROC.counter].Register_LHH:=
               PROC_LIS.LISTE[akt_CALL_PROC.PROC_Pos].PPR_ARR[akt_CALL_PROC.counter].Register_LHH;
    akt_CALL_PROC.PPR_ARR[akt_CALL_PROC.counter].Register_HLH:=
               PROC_LIS.LISTE[akt_CALL_PROC.PROC_Pos].PPR_ARR[akt_CALL_PROC.counter].Register_HLH;
    akt_CALL_PROC.PPR_ARR[akt_CALL_PROC.counter].Register_HHH:=
               PROC_LIS.LISTE[akt_CALL_PROC.PROC_Pos].PPR_ARR[akt_CALL_PROC.counter].Register_HHH;

    akt_CALL_PROC.PPR_ARR[akt_CALL_PROC.counter].Parameter:=PW;
    PCP_erfolgreich:=true;

    Inc_akt_CALL_PROC_counter;

  end; { if CONST_WERT_ueberpruefen(CW,CUT,ZC_CONST_TAB[ZC_CONST_TAB_counter].ASM_type) then }

  Result:=PCP_erfolgreich;

end; { function ZWC_class.PCALL_wert_parameter_eintragen }







// wird nach Aufruf des Prozedur/Funktionsnamens aufgerufen
// hier werden auch die erforderlichen Parameter fr die Prozedur/Funktion bergeben
function ZWC_class.PCALL_exec(ANWType : Char) : Boolean;
var
  PCE_erfolgreich : Boolean;
  PL_Zaehler, PL_Anzahl : Integer;
  Wert, ByteWert, HexWert : String;
  QWord_Wert : QWord;


  // Diese Prozedur behandelt die bergabe von lokalen Variablen
  // der Mutter-Prozedur/Funktion an die Tochter-Prozedur/Funktion
  procedure Uebergabe_lokaler_Variablen_an_PCALL;
  var
    PROC_LOK_PAR : array [1..Laenge_PROC_PAR_Liste] of PROC_LOK_PAR_REC;
    LV_Zaehler, LV_Zaehler2, PPR_ARR_counter,
    REG_ARRAY_HIGH_counter : Integer;
    Register_kopieren : Boolean;
  begin


    // Aufruf einer PROCEDURE/FUNCTION innerhalb einer PROCEDURE/FUNCTION
    // hier wird nur weiter gemacht, wenn eine PROCEDURE/FUNCTION innerhalb
    // einer PROCEDURE/FUNCTION aufgerufen wird
    if PROC_LIS.LISTE[PROC_LIS.counter].ANW_Type<>'X' then begin
      PPR_ARR_counter:=1;
      REG_ARRAY_HIGH_counter:=1;
      Register_kopieren:=false;

      // Schleife fr die Abarbeitung der Parameter der Mutter-PROCEDURE/FUNCTION
      for LV_Zaehler:=1 to PROC_LIS.LISTE[PROC_LIS.counter].counter-1 do begin

        // hier sollen nur die lokalen Parameter der Mutter-PROCEDURE/FUNCTION beachtet werden
        if PROC_LIS.LISTE[PROC_LIS.counter].PPR_ARR[LV_Zaehler].ANW_Type IN ['L','D'] then begin

          PROC_LOK_PAR[PPR_ARR_counter].Parameter:=PROC_LIS.LISTE[PROC_LIS.counter].PPR_ARR[LV_Zaehler].Parameter;
          PROC_LOK_PAR[PPR_ARR_counter].ASM_type:=PROC_LIS.LISTE[PROC_LIS.counter].PPR_ARR[LV_Zaehler].ASM_type;
          PROC_LOK_PAR[PPR_ARR_counter].ANW_Type:=PROC_LIS.LISTE[PROC_LIS.counter].PPR_ARR[LV_Zaehler].ANW_Type;
          PROC_LOK_PAR[PPR_ARR_counter].Register_von_L:=PROC_LIS.LISTE[PROC_LIS.counter].PPR_ARR[LV_Zaehler].Register_L;
          PROC_LOK_PAR[PPR_ARR_counter].Register_von_H:=PROC_LIS.LISTE[PROC_LIS.counter].PPR_ARR[LV_Zaehler].Register_H;
          PROC_LOK_PAR[PPR_ARR_counter].Register_von_LH:=PROC_LIS.LISTE[PROC_LIS.counter].PPR_ARR[LV_Zaehler].Register_LH;
          PROC_LOK_PAR[PPR_ARR_counter].Register_von_HH:=PROC_LIS.LISTE[PROC_LIS.counter].PPR_ARR[LV_Zaehler].Register_HH;

          PROC_LOK_PAR[PPR_ARR_counter].Register_kopieren:=false;

          // jeder Parameter-Typ muss extra behandelt werden
          case PROC_LOK_PAR[PPR_ARR_counter].ASM_type of

            AT_boolean, AT_byte, AT_char :
              begin
                PROC_LOK_PAR[PPR_ARR_counter].Register_nach_L:=REG_ARRAY_HIGH[REG_ARRAY_HIGH_counter];
                INC(REG_ARRAY_HIGH_counter);
              end; { AT_boolean, AT_byte, AT_char }

            AT_word :
              begin
                PROC_LOK_PAR[PPR_ARR_counter].Register_nach_L:=REG_ARRAY_HIGH[REG_ARRAY_HIGH_counter];
                INC(REG_ARRAY_HIGH_counter);
                PROC_LOK_PAR[PPR_ARR_counter].Register_nach_H:=REG_ARRAY_HIGH[REG_ARRAY_HIGH_counter];
                INC(REG_ARRAY_HIGH_counter);
              end; { AT_word }

            AT_dword :
              begin
                PROC_LOK_PAR[PPR_ARR_counter].Register_nach_L:=REG_ARRAY_HIGH[REG_ARRAY_HIGH_counter];
                INC(REG_ARRAY_HIGH_counter);
                PROC_LOK_PAR[PPR_ARR_counter].Register_nach_H:=REG_ARRAY_HIGH[REG_ARRAY_HIGH_counter];
                INC(REG_ARRAY_HIGH_counter);
                PROC_LOK_PAR[PPR_ARR_counter].Register_nach_LH:=REG_ARRAY_HIGH[REG_ARRAY_HIGH_counter];
                INC(REG_ARRAY_HIGH_counter);
                PROC_LOK_PAR[PPR_ARR_counter].Register_nach_HH:=REG_ARRAY_HIGH[REG_ARRAY_HIGH_counter];
                INC(REG_ARRAY_HIGH_counter);
              end; { AT_dword }

            AT_currency :
              begin

                PROC_LOK_PAR[PPR_ARR_counter].Register_nach_L:=REG_ARRAY_HIGH[REG_ARRAY_HIGH_counter];
                INC(REG_ARRAY_HIGH_counter);
                PROC_LOK_PAR[PPR_ARR_counter].Register_nach_H:=REG_ARRAY_HIGH[REG_ARRAY_HIGH_counter];
                INC(REG_ARRAY_HIGH_counter);
                PROC_LOK_PAR[PPR_ARR_counter].Register_nach_LH:=REG_ARRAY_HIGH[REG_ARRAY_HIGH_counter];
                INC(REG_ARRAY_HIGH_counter);
                PROC_LOK_PAR[PPR_ARR_counter].Register_nach_HH:=REG_ARRAY_HIGH[REG_ARRAY_HIGH_counter];
                INC(REG_ARRAY_HIGH_counter);

                PROC_LOK_PAR[PPR_ARR_counter].Register_nach_LLH:=REG_ARRAY_HIGH[REG_ARRAY_HIGH_counter];
                INC(REG_ARRAY_HIGH_counter);
                PROC_LOK_PAR[PPR_ARR_counter].Register_nach_LHH:=REG_ARRAY_HIGH[REG_ARRAY_HIGH_counter];
                INC(REG_ARRAY_HIGH_counter);
                PROC_LOK_PAR[PPR_ARR_counter].Register_nach_HLH:=REG_ARRAY_HIGH[REG_ARRAY_HIGH_counter];
                INC(REG_ARRAY_HIGH_counter);
                PROC_LOK_PAR[PPR_ARR_counter].Register_nach_HHH:=REG_ARRAY_HIGH[REG_ARRAY_HIGH_counter];
                INC(REG_ARRAY_HIGH_counter);

              end; { AT_currency }

          else
            Fehler_cl.Registrieren('ZWC_03/PCALL_exec/Uebergabe_lokaler_Variablen_an_PCALL',
                             'ASM_type <'+TYPE_IN_TYPENAME(PROC_LOK_PAR[PPR_ARR_counter].ASM_type)+
                             '> zum Parameter ('+
                             PROC_LIS.LISTE[PROC_LIS.counter].PPR_ARR[LV_Zaehler].Parameter+
                             ') nicht definiert (Boolean, Byte, Char, Word)',
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

          end; { case PPR_ARR[PPR_ARR_counter].ASM_type of }

          INC(PPR_ARR_counter);

        end; { if PROC_LIS.LISTE[PROC_LIS.counter].PPR_ARR[LV_Zaehler].ANW_Type IN ['L','D'] then }
      end; { for PL_Zaehler:=1 to PROC_LIS.LISTE[PROC_LIS.counter].counter-1 do }


      // Durchlaufen der Parameter der Tochter-PROCEDURE/FUNCTION
      for LV_Zaehler:=1 to akt_CALL_PROC.counter-1 do begin


        // es sollen nur die lokalen Parameter beachtet werden
        if akt_CALL_PROC.PPR_ARR[LV_Zaehler].ANW_Type IN ['L','D'] then begin

          // Durchlaufen aller lokalen Parameter der Mutter-PROCEDURE/FUNCTION
          for LV_Zaehler2:=1 to PPR_ARR_counter-1 do begin

            // Vergleich der lokalen Parameter der Mutter-PROCEDURE/FUNCTION mit
            // jedem einzelnen Parameter der Tochter-PROCEDURE/FUNCTION
            if PROC_LOK_PAR[LV_Zaehler2].Parameter=akt_CALL_PROC.PPR_ARR[LV_Zaehler].Parameter then begin


              if PROC_LOK_PAR[LV_Zaehler2].Register_von_L<>akt_CALL_PROC.PPR_ARR[LV_Zaehler].Register_L then begin

                PROC_LOK_PAR[LV_Zaehler2].Register_zu_L:=akt_CALL_PROC.PPR_ARR[LV_Zaehler].Register_L;
                PROC_LOK_PAR[LV_Zaehler2].Register_zu_H:=akt_CALL_PROC.PPR_ARR[LV_Zaehler].Register_H;
                PROC_LOK_PAR[LV_Zaehler2].Register_zu_LH:=akt_CALL_PROC.PPR_ARR[LV_Zaehler].Register_LH;
                PROC_LOK_PAR[LV_Zaehler2].Register_zu_HH:=akt_CALL_PROC.PPR_ARR[LV_Zaehler].Register_HH;
                PROC_LOK_PAR[LV_Zaehler2].Register_kopieren:=true;
                Register_kopieren:=true;

              end; { if PROC_LOK_PAR[LV_Zaehler2].Register_von_L<> }

            end; { if PROC_LOK_PAR[PPR_ARR_counter].Parameter }

          end; { for LV_Zaehler2:=1 to PPR_ARR_counter-1 do }

        end; { if PROC_LIS.LISTE[PROC_LIS.counter].PPR_ARR[LV_Zaehler].ANW_Type IN ['L','D'] then }

      end; { for PL_Zaehler:=1 to PROC_LIS.LISTE[PROC_LIS.counter].counter-1 do }



      if Register_kopieren then begin

        for LV_Zaehler:=1 to PPR_ARR_counter-1 do begin
          if PROC_LOK_PAR[LV_Zaehler].Register_kopieren then begin

            STM_LISTE[STM_LISTE_counter].Bemerkung:='; Parameter ('+PROC_LOK_PAR[LV_Zaehler].Parameter+') retten';


            case PROC_LOK_PAR[LV_Zaehler].ASM_type of

              AT_boolean, AT_byte, AT_char :
                begin
                  STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
                  STM_LISTE[STM_LISTE_counter].parameter1:=PROC_LOK_PAR[LV_Zaehler].Register_von_L;
                  STM_LISTE[STM_LISTE_counter].parameter2:=PROC_LOK_PAR[LV_Zaehler].Register_nach_L;
                  Inc_STM_TAB_counter;
                end; { AT_boolean, AT_byte, AT_char }

              AT_word :
                begin
                  STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
                  STM_LISTE[STM_LISTE_counter].parameter1:=PROC_LOK_PAR[LV_Zaehler].Register_von_L;
                  STM_LISTE[STM_LISTE_counter].parameter2:=PROC_LOK_PAR[LV_Zaehler].Register_nach_L;
                  Inc_STM_TAB_counter;
                  STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
                  STM_LISTE[STM_LISTE_counter].parameter1:=PROC_LOK_PAR[LV_Zaehler].Register_von_H;
                  STM_LISTE[STM_LISTE_counter].parameter2:=PROC_LOK_PAR[LV_Zaehler].Register_nach_H;
                  Inc_STM_TAB_counter;
                end; { AT_word }

              AT_dword :
                begin
                  STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
                  STM_LISTE[STM_LISTE_counter].parameter1:=PROC_LOK_PAR[LV_Zaehler].Register_von_L;
                  STM_LISTE[STM_LISTE_counter].parameter2:=PROC_LOK_PAR[LV_Zaehler].Register_nach_L;
                  Inc_STM_TAB_counter;
                  STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
                  STM_LISTE[STM_LISTE_counter].parameter1:=PROC_LOK_PAR[LV_Zaehler].Register_von_H;
                  STM_LISTE[STM_LISTE_counter].parameter2:=PROC_LOK_PAR[LV_Zaehler].Register_nach_H;
                  Inc_STM_TAB_counter;
                  STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
                  STM_LISTE[STM_LISTE_counter].parameter1:=PROC_LOK_PAR[LV_Zaehler].Register_von_LH;
                  STM_LISTE[STM_LISTE_counter].parameter2:=PROC_LOK_PAR[LV_Zaehler].Register_nach_LH;
                  Inc_STM_TAB_counter;
                  STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
                  STM_LISTE[STM_LISTE_counter].parameter1:=PROC_LOK_PAR[LV_Zaehler].Register_von_HH;
                  STM_LISTE[STM_LISTE_counter].parameter2:=PROC_LOK_PAR[LV_Zaehler].Register_nach_HH;
                  Inc_STM_TAB_counter;
                end; { AT_dword }

              AT_currency :
                begin

                  STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
                  STM_LISTE[STM_LISTE_counter].parameter1:=PROC_LOK_PAR[LV_Zaehler].Register_von_L;
                  STM_LISTE[STM_LISTE_counter].parameter2:=PROC_LOK_PAR[LV_Zaehler].Register_nach_L;
                  Inc_STM_TAB_counter;
                  STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
                  STM_LISTE[STM_LISTE_counter].parameter1:=PROC_LOK_PAR[LV_Zaehler].Register_von_H;
                  STM_LISTE[STM_LISTE_counter].parameter2:=PROC_LOK_PAR[LV_Zaehler].Register_nach_H;
                  Inc_STM_TAB_counter;
                  STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
                  STM_LISTE[STM_LISTE_counter].parameter1:=PROC_LOK_PAR[LV_Zaehler].Register_von_LH;
                  STM_LISTE[STM_LISTE_counter].parameter2:=PROC_LOK_PAR[LV_Zaehler].Register_nach_LH;
                  Inc_STM_TAB_counter;
                  STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
                  STM_LISTE[STM_LISTE_counter].parameter1:=PROC_LOK_PAR[LV_Zaehler].Register_von_HH;
                  STM_LISTE[STM_LISTE_counter].parameter2:=PROC_LOK_PAR[LV_Zaehler].Register_nach_HH;
                  Inc_STM_TAB_counter;

                  STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
                  STM_LISTE[STM_LISTE_counter].parameter1:=PROC_LOK_PAR[LV_Zaehler].Register_von_LLH;
                  STM_LISTE[STM_LISTE_counter].parameter2:=PROC_LOK_PAR[LV_Zaehler].Register_nach_LLH;
                  Inc_STM_TAB_counter;
                  STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
                  STM_LISTE[STM_LISTE_counter].parameter1:=PROC_LOK_PAR[LV_Zaehler].Register_von_LHH;
                  STM_LISTE[STM_LISTE_counter].parameter2:=PROC_LOK_PAR[LV_Zaehler].Register_nach_LHH;
                  Inc_STM_TAB_counter;
                  STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
                  STM_LISTE[STM_LISTE_counter].parameter1:=PROC_LOK_PAR[LV_Zaehler].Register_von_HLH;
                  STM_LISTE[STM_LISTE_counter].parameter2:=PROC_LOK_PAR[LV_Zaehler].Register_nach_HLH;
                  Inc_STM_TAB_counter;
                  STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
                  STM_LISTE[STM_LISTE_counter].parameter1:=PROC_LOK_PAR[LV_Zaehler].Register_von_HHH;
                  STM_LISTE[STM_LISTE_counter].parameter2:=PROC_LOK_PAR[LV_Zaehler].Register_nach_HHH;
                  Inc_STM_TAB_counter;

                end; { AT_currency }

            else
              Fehler_cl.Registrieren('ZWC_03/PCALL_exec/Uebergabe_lokaler_Variablen_an_PCALL',
                                     'ASM_type <'+TYPE_IN_TYPENAME(PROC_LOK_PAR[LV_Zaehler].ASM_type)+
                                     '> zum Parameter ('+
                                     PROC_LOK_PAR[LV_Zaehler].Parameter+
                                     ') nicht definiert (Boolean, Byte, Char, Word)',
                                     Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                                     Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                                     Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

            end; { case PROC_LOK_PAR[LV_Zaehler].ASM_type of }


          end; { if PROC_LOK_PAR[LV_Zaehler].Register_kopieren then }
        end; { for LV_Zaehler:=1 to PPR_ARR_counter-1 do }



        for LV_Zaehler:=1 to PPR_ARR_counter-1 do begin
          if PROC_LOK_PAR[LV_Zaehler].Register_kopieren then begin


            if ANWType='F' then
              STM_LISTE[STM_LISTE_counter].Bemerkung:='; lokalen Parameter ('+PROC_LOK_PAR[LV_Zaehler].Parameter+
              ') an Funktion ('+akt_CALL_PROC.Name+')'
            else
              STM_LISTE[STM_LISTE_counter].Bemerkung:='; lokalen Parameter ('+PROC_LOK_PAR[LV_Zaehler].Parameter+
              ') an Prozedur ('+akt_CALL_PROC.Name+')';


            case PROC_LOK_PAR[LV_Zaehler].ASM_type of

              AT_boolean, AT_byte, AT_char :
                begin
                  STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
                  STM_LISTE[STM_LISTE_counter].parameter1:=PROC_LOK_PAR[LV_Zaehler].Register_nach_L;
                  STM_LISTE[STM_LISTE_counter].parameter2:=PROC_LOK_PAR[LV_Zaehler].Register_zu_L;
                  Inc_STM_TAB_counter;
                end; { AT_boolean, AT_byte, AT_char }

              AT_word :
                begin
                  STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
                  STM_LISTE[STM_LISTE_counter].parameter1:=PROC_LOK_PAR[LV_Zaehler].Register_nach_L;
                  STM_LISTE[STM_LISTE_counter].parameter2:=PROC_LOK_PAR[LV_Zaehler].Register_zu_L;
                  Inc_STM_TAB_counter;
                  STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
                  STM_LISTE[STM_LISTE_counter].parameter1:=PROC_LOK_PAR[LV_Zaehler].Register_nach_H;
                  STM_LISTE[STM_LISTE_counter].parameter2:=PROC_LOK_PAR[LV_Zaehler].Register_zu_H;
                  Inc_STM_TAB_counter;

                end; { AT_word }

              AT_dword :
                begin
                  STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
                  STM_LISTE[STM_LISTE_counter].parameter1:=PROC_LOK_PAR[LV_Zaehler].Register_nach_L;
                  STM_LISTE[STM_LISTE_counter].parameter2:=PROC_LOK_PAR[LV_Zaehler].Register_zu_L;
                  Inc_STM_TAB_counter;
                  STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
                  STM_LISTE[STM_LISTE_counter].parameter1:=PROC_LOK_PAR[LV_Zaehler].Register_nach_H;
                  STM_LISTE[STM_LISTE_counter].parameter2:=PROC_LOK_PAR[LV_Zaehler].Register_zu_H;
                  Inc_STM_TAB_counter;
                  STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
                  STM_LISTE[STM_LISTE_counter].parameter1:=PROC_LOK_PAR[LV_Zaehler].Register_nach_LH;
                  STM_LISTE[STM_LISTE_counter].parameter2:=PROC_LOK_PAR[LV_Zaehler].Register_zu_LH;
                  Inc_STM_TAB_counter;
                  STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
                  STM_LISTE[STM_LISTE_counter].parameter1:=PROC_LOK_PAR[LV_Zaehler].Register_nach_HH;
                  STM_LISTE[STM_LISTE_counter].parameter2:=PROC_LOK_PAR[LV_Zaehler].Register_zu_HH;
                  Inc_STM_TAB_counter;

                end; { AT_word }

              AT_currency :
                begin

                  STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
                  STM_LISTE[STM_LISTE_counter].parameter1:=PROC_LOK_PAR[LV_Zaehler].Register_nach_L;
                  STM_LISTE[STM_LISTE_counter].parameter2:=PROC_LOK_PAR[LV_Zaehler].Register_zu_L;
                  Inc_STM_TAB_counter;
                  STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
                  STM_LISTE[STM_LISTE_counter].parameter1:=PROC_LOK_PAR[LV_Zaehler].Register_nach_H;
                  STM_LISTE[STM_LISTE_counter].parameter2:=PROC_LOK_PAR[LV_Zaehler].Register_zu_H;
                  Inc_STM_TAB_counter;
                  STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
                  STM_LISTE[STM_LISTE_counter].parameter1:=PROC_LOK_PAR[LV_Zaehler].Register_nach_LH;
                  STM_LISTE[STM_LISTE_counter].parameter2:=PROC_LOK_PAR[LV_Zaehler].Register_zu_LH;
                  Inc_STM_TAB_counter;
                  STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
                  STM_LISTE[STM_LISTE_counter].parameter1:=PROC_LOK_PAR[LV_Zaehler].Register_nach_HH;
                  STM_LISTE[STM_LISTE_counter].parameter2:=PROC_LOK_PAR[LV_Zaehler].Register_zu_HH;
                  Inc_STM_TAB_counter;

                  STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
                  STM_LISTE[STM_LISTE_counter].parameter1:=PROC_LOK_PAR[LV_Zaehler].Register_nach_LLH;
                  STM_LISTE[STM_LISTE_counter].parameter2:=PROC_LOK_PAR[LV_Zaehler].Register_zu_LLH;
                  Inc_STM_TAB_counter;
                  STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
                  STM_LISTE[STM_LISTE_counter].parameter1:=PROC_LOK_PAR[LV_Zaehler].Register_nach_LHH;
                  STM_LISTE[STM_LISTE_counter].parameter2:=PROC_LOK_PAR[LV_Zaehler].Register_zu_LHH;
                  Inc_STM_TAB_counter;
                  STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
                  STM_LISTE[STM_LISTE_counter].parameter1:=PROC_LOK_PAR[LV_Zaehler].Register_nach_HLH;
                  STM_LISTE[STM_LISTE_counter].parameter2:=PROC_LOK_PAR[LV_Zaehler].Register_zu_HLH;
                  Inc_STM_TAB_counter;
                  STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
                  STM_LISTE[STM_LISTE_counter].parameter1:=PROC_LOK_PAR[LV_Zaehler].Register_nach_HHH;
                  STM_LISTE[STM_LISTE_counter].parameter2:=PROC_LOK_PAR[LV_Zaehler].Register_zu_HHH;
                  Inc_STM_TAB_counter;

                end; { AT_currency }

            else
              Fehler_cl.Registrieren('ZwischenCode/PCALL_exec/Uebergabe_lokaler_Variablen_an_PCALL',
                                     'ASM_type <'+TYPE_IN_TYPENAME(PROC_LOK_PAR[LV_Zaehler].ASM_type)+
                                     '> zum Parameter ('+
                                     PROC_LOK_PAR[LV_Zaehler].Parameter+
                                     ') nicht definiert (Boolean, Byte, Char, Word)',
                                     Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                                     Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                                     Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

            end; { case PROC_LOK_PAR[LV_Zaehler].ASM_type of }

          end; { if PROC_LOK_PAR[LV_Zaehler].Register_kopieren then }
        end; { for LV_Zaehler:=1 to PPR_ARR_counter-1 do }

      end; { if Register_kopieren then }

    end; { if PROC_LIS.LISTE[PROC_LIS.counter].ANW_Type<>'X' then }
  end; { procedure Uebergabe_lokale_Register_an_Proc_Func }


begin
  PCE_erfolgreich:=false;

  akt_CALL_PROC.Name:=PROC_LIS.LISTE[akt_CALL_PROC.PROC_Pos].Name;

  PL_Anzahl:=1;
  for PL_Zaehler:=1 to PROC_LIS.LISTE[akt_CALL_PROC.PROC_Pos].counter-1 do
    if PROC_LIS.LISTE[akt_CALL_PROC.PROC_Pos].PPR_ARR[PL_Zaehler].ANW_Type='L' then
      INC(PL_Anzahl);

  if PL_Anzahl<>akt_CALL_PROC.counter then begin
    if ANWType='P' then
      Fehler_cl.Registrieren('ZwischenCode/PCALL_exec',
                             'In der Deklaration der Prozedur wurde(n) '+
                             IntToStr(PL_Anzahl-1)+
                             ' Parameter definiert, es wurde(n) aber nur '+
                             IntToStr(akt_CALL_PROC.counter-1)+' Parameter uebergeben',
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte)
    else
      Fehler_cl.Registrieren('ZwischenCode/PCALL_exec',
                             'In der Deklaration der Funktion wurde(n) '+
                             IntToStr(PL_Anzahl-1)+
                             ' Parameter definiert, es wurde(n) aber nur '+
                             IntToStr(akt_CALL_PROC.counter-1)+' Parameter uebergeben',
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

  end; { if PROC_LIS.LISTE[akt_CALL_PROC.PROC_Pos].counter<>akt_CALL_PROC.counter then }




  // beim Aufruf einer PROCEDURE/FUNCTION innerhalb einer PROCEDURE/FUNCTION
  if PROC_LIS.LISTE[PROC_LIS.counter].ANW_Type<>'X' then begin


    // Retten der lokalen Parameter der uebergeordneten PROCEDURE/FUNCTION
    for PL_Zaehler:=1 to PROC_LIS.LISTE[PROC_LIS.counter].REG_ARRAY_LOW_pointer-1 do begin

      if PL_Zaehler=1 then
        STM_LISTE[STM_LISTE_counter].Bemerkung:='; Retten der lokalen Parameter fuer PROCEDURE ('+
                      PROC_LIS.LISTE[PROC_LIS.counter].Name+')';

      STM_LISTE[STM_LISTE_counter].statement:=STM_PUSH;
      STM_LISTE[STM_LISTE_counter].Parameter1:=REG_ARRAY_LOW[PL_Zaehler];

      Inc_STM_TAB_counter;

    end; { for PL_Zaehler:=1 to PROC_LIS.LISTE[akt_CALL_PROC.PROC_Pos].counter-1 do }

  end; { if PROC_LIS.LISTE[akt_CALL_PROC.PROC_Pos].ANW_Type<>'X' then }


  // hat die Tochter-PROCEDURE/FUNCTION Parameter ? - dann hier weiter
  if akt_CALL_PROC.counter>1 then begin

    // 1. Sonderbehandlung fr lokale Parameter der Mutter-PROCEDURE/FUNCTION
    Uebergabe_lokaler_Variablen_an_PCALL;

    // 2. normale Parameterbergabe fr die restlichen (nicht lokalen) Parameter
    for PL_Zaehler:=1 to akt_CALL_PROC.counter-1 do begin

      // nur fr nicht lokale Parameter
      if not (akt_CALL_PROC.PPR_ARR[PL_Zaehler].ANW_Type IN ['L','D']) then begin


        case akt_CALL_PROC.PPR_ARR[PL_Zaehler].ASM_type of


          AT_boolean, AT_byte, AT_char :
            begin

              if ANWType='P' then
                STM_LISTE[STM_LISTE_counter].Bemerkung:=
                  '; Byte-Parameter('+IntToStr(PL_Zaehler)+') fuer PROCEDURE ('+
                  PROC_LIS.LISTE[akt_CALL_PROC.PROC_Pos].Name+')'
              else
                STM_LISTE[STM_LISTE_counter].Bemerkung:=
                  '; Byte-Parameter('+IntToStr(PL_Zaehler)+') fuer FUNCTION ('+
                  PROC_LIS.LISTE[akt_CALL_PROC.PROC_Pos].Name+')';


              case akt_CALL_PROC.PPR_ARR[PL_Zaehler].ANW_Type of
                'V' : begin
                        STM_LISTE[STM_LISTE_counter].statement:=STM_LDS;
                        STM_LISTE[STM_LISTE_counter].parameter1:=
                                    akt_CALL_PROC.PPR_ARR[PL_Zaehler].Parameter;
                        STM_LISTE[STM_LISTE_counter].parameter2:=
                                    akt_CALL_PROC.PPR_ARR[PL_Zaehler].Register_L;
                        Inc_STM_TAB_counter;
                      end; { 'V' }
                'C','W' : begin

                        if akt_CALL_PROC.PPR_ARR[PL_Zaehler].ANW_Type='C' then
                          Wert:=CONST_NAME_TO_WERT(akt_CALL_PROC.PPR_ARR[PL_Zaehler].Parameter)
                        else
                          Wert:=akt_CALL_PROC.PPR_ARR[PL_Zaehler].Parameter;

                        STM_LISTE[STM_LISTE_counter].statement:=STM_LDI;
                        STM_LISTE[STM_LISTE_counter].Parameter1:=Wert;
                        STM_LISTE[STM_LISTE_counter].Parameter2:='R16';
                        Inc_STM_TAB_counter;
                        STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
                        STM_LISTE[STM_LISTE_counter].Parameter1:='R16';
                        STM_LISTE[STM_LISTE_counter].Parameter2:=
                                    akt_CALL_PROC.PPR_ARR[PL_Zaehler].Register_L;
                        Inc_STM_TAB_counter;

                      end; { 'C','W' }
              else
                Fehler_cl.Registrieren('ZwischenCode/PCALL_exec',
                               'ANW_type <'+akt_CALL_PROC.PPR_ARR[PL_Zaehler].ANW_Type+
                               '> zum Parameter ('+akt_CALL_PROC.PPR_ARR[PL_Zaehler].Parameter+
                               ') nicht definiert (Boolean, Byte, Char)',
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);
              end; { case akt_CALL_PROC.PPR_ARR[PL_Zaehler].ANW_Type of }


            end; { AT_boolean, AT_byte, AT_char }


          AT_word :
            begin

              if ANWType='P' then
                STM_LISTE[STM_LISTE_counter].Bemerkung:=
                  '; Word-Parameter('+IntToStr(PL_Zaehler)+') fuer PROCEDURE ('+
                  PROC_LIS.LISTE[akt_CALL_PROC.PROC_Pos].Name+')'
              else
                STM_LISTE[STM_LISTE_counter].Bemerkung:=
                  '; Word-Parameter('+IntToStr(PL_Zaehler)+') fuer FUNCTION ('+
                  PROC_LIS.LISTE[akt_CALL_PROC.PROC_Pos].Name+')';


              case akt_CALL_PROC.PPR_ARR[PL_Zaehler].ANW_Type of
                'V' : begin
                        STM_LISTE[STM_LISTE_counter].statement:=STM_LDS;
                        STM_LISTE[STM_LISTE_counter].parameter1:=akt_CALL_PROC.PPR_ARR[PL_Zaehler].Parameter;
                        STM_LISTE[STM_LISTE_counter].parameter2:=akt_CALL_PROC.PPR_ARR[PL_Zaehler].Register_L;
                        Inc_STM_TAB_counter;
                        STM_LISTE[STM_LISTE_counter].statement:=STM_LDS;
                        STM_LISTE[STM_LISTE_counter].parameter1:=akt_CALL_PROC.PPR_ARR[PL_Zaehler].Parameter+'+1';
                        STM_LISTE[STM_LISTE_counter].parameter2:=akt_CALL_PROC.PPR_ARR[PL_Zaehler].Register_H;
                        Inc_STM_TAB_counter;
                      end; { 'V' }

                'C','W' : begin

                        if akt_CALL_PROC.PPR_ARR[PL_Zaehler].ANW_Type='C' then
                          Wert:=CONST_NAME_TO_WERT(akt_CALL_PROC.PPR_ARR[PL_Zaehler].Parameter)
                        else
                          Wert:=akt_CALL_PROC.PPR_ARR[PL_Zaehler].Parameter;

                        STM_LISTE[STM_LISTE_counter].statement:=STM_LDI_word_L;
                        STM_LISTE[STM_LISTE_counter].Parameter1:=Wert;
                        STM_LISTE[STM_LISTE_counter].Parameter2:='R16';
                        Inc_STM_TAB_counter;
                        STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
                        STM_LISTE[STM_LISTE_counter].Parameter1:='R16';
                        STM_LISTE[STM_LISTE_counter].Parameter2:=
                                    akt_CALL_PROC.PPR_ARR[PL_Zaehler].Register_L;
                        Inc_STM_TAB_counter;

                        STM_LISTE[STM_LISTE_counter].statement:=STM_LDI_word_H;
                        STM_LISTE[STM_LISTE_counter].Parameter1:=Wert;
                        STM_LISTE[STM_LISTE_counter].Parameter2:='R17';
                        Inc_STM_TAB_counter;
                        STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
                        STM_LISTE[STM_LISTE_counter].Parameter1:='R17';
                        STM_LISTE[STM_LISTE_counter].Parameter2:=
                                    akt_CALL_PROC.PPR_ARR[PL_Zaehler].Register_H;
                        Inc_STM_TAB_counter;
                      end; { 'C','W' }
              else
                Fehler_cl.Registrieren('ZwischenCode/PCALL_exec',
                               'ANW_type <'+akt_CALL_PROC.PPR_ARR[PL_Zaehler].ANW_Type+
                               '> zum Word-Parameter ('+IntToStr(PL_Zaehler)+') nicht definiert',
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);
              end; { case akt_CALL_PROC.PPR_ARR[PL_Zaehler].ANW_Type of }


            end; { AT_word }


          AT_dword :
            begin

              if ANWType='P' then
                STM_LISTE[STM_LISTE_counter].Bemerkung:=
                  '; DWord-Parameter('+IntToStr(PL_Zaehler)+') fuer PROCEDURE ('+
                  PROC_LIS.LISTE[akt_CALL_PROC.PROC_Pos].Name+')'
              else
                STM_LISTE[STM_LISTE_counter].Bemerkung:=
                  '; DWord-Parameter('+IntToStr(PL_Zaehler)+') fuer FUNCTION ('+
                  PROC_LIS.LISTE[akt_CALL_PROC.PROC_Pos].Name+')';


              case akt_CALL_PROC.PPR_ARR[PL_Zaehler].ANW_Type of

                'V' : begin
                        STM_LISTE[STM_LISTE_counter].statement:=STM_LDS;
                        STM_LISTE[STM_LISTE_counter].parameter1:=akt_CALL_PROC.PPR_ARR[PL_Zaehler].Parameter;
                        STM_LISTE[STM_LISTE_counter].parameter2:=akt_CALL_PROC.PPR_ARR[PL_Zaehler].Register_L;
                        Inc_STM_TAB_counter;
                        STM_LISTE[STM_LISTE_counter].statement:=STM_LDS;
                        STM_LISTE[STM_LISTE_counter].parameter1:=akt_CALL_PROC.PPR_ARR[PL_Zaehler].Parameter+'+1';
                        STM_LISTE[STM_LISTE_counter].parameter2:=akt_CALL_PROC.PPR_ARR[PL_Zaehler].Register_H;
                        Inc_STM_TAB_counter;
                        STM_LISTE[STM_LISTE_counter].statement:=STM_LDS;
                        STM_LISTE[STM_LISTE_counter].parameter1:=akt_CALL_PROC.PPR_ARR[PL_Zaehler].Parameter+'+2';
                        STM_LISTE[STM_LISTE_counter].parameter2:=akt_CALL_PROC.PPR_ARR[PL_Zaehler].Register_LH;
                        Inc_STM_TAB_counter;
                        STM_LISTE[STM_LISTE_counter].statement:=STM_LDS;
                        STM_LISTE[STM_LISTE_counter].parameter1:=akt_CALL_PROC.PPR_ARR[PL_Zaehler].Parameter+'+3';
                        STM_LISTE[STM_LISTE_counter].parameter2:=akt_CALL_PROC.PPR_ARR[PL_Zaehler].Register_HH;
                        Inc_STM_TAB_counter;
                      end;

                'C','W' : begin

                        if akt_CALL_PROC.PPR_ARR[PL_Zaehler].ANW_Type='C' then
                          Wert:=CONST_NAME_TO_WERT(akt_CALL_PROC.PPR_ARR[PL_Zaehler].Parameter)
                        else
                          Wert:=akt_CALL_PROC.PPR_ARR[PL_Zaehler].Parameter;

                        ByteWert:='0x'+Copy(Wert,7,2);
                        STM_LISTE[STM_LISTE_counter].statement:=STM_LDI;
                        STM_LISTE[STM_LISTE_counter].Parameter1:=ByteWert;
                        STM_LISTE[STM_LISTE_counter].Parameter2:='R16';
                        Inc_STM_TAB_counter;
                        STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
                        STM_LISTE[STM_LISTE_counter].Parameter1:='R16';
                        STM_LISTE[STM_LISTE_counter].Parameter2:=akt_CALL_PROC.PPR_ARR[PL_Zaehler].Register_L;
                        Inc_STM_TAB_counter;
                        ByteWert:='0x'+Copy(Wert,5,2);
                        STM_LISTE[STM_LISTE_counter].statement:=STM_LDI;
                        STM_LISTE[STM_LISTE_counter].Parameter1:=ByteWert;
                        STM_LISTE[STM_LISTE_counter].Parameter2:='R17';
                        Inc_STM_TAB_counter;
                        STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
                        STM_LISTE[STM_LISTE_counter].Parameter1:='R17';
                        STM_LISTE[STM_LISTE_counter].Parameter2:=akt_CALL_PROC.PPR_ARR[PL_Zaehler].Register_H;
                        Inc_STM_TAB_counter;
                        ByteWert:='0x'+Copy(Wert,3,2);
                        STM_LISTE[STM_LISTE_counter].statement:=STM_LDI;
                        STM_LISTE[STM_LISTE_counter].Parameter1:=ByteWert;
                        STM_LISTE[STM_LISTE_counter].Parameter2:='R18';
                        Inc_STM_TAB_counter;
                        STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
                        STM_LISTE[STM_LISTE_counter].Parameter1:='R18';
                        STM_LISTE[STM_LISTE_counter].Parameter2:=akt_CALL_PROC.PPR_ARR[PL_Zaehler].Register_LH;
                        Inc_STM_TAB_counter;
                        ByteWert:='0x'+Copy(Wert,1,2);
                        STM_LISTE[STM_LISTE_counter].statement:=STM_LDI;
                        STM_LISTE[STM_LISTE_counter].Parameter1:=ByteWert;
                        STM_LISTE[STM_LISTE_counter].Parameter2:='R19';
                        Inc_STM_TAB_counter;
                        STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
                        STM_LISTE[STM_LISTE_counter].Parameter1:='R19';
                        STM_LISTE[STM_LISTE_counter].Parameter2:=akt_CALL_PROC.PPR_ARR[PL_Zaehler].Register_HH;
                        Inc_STM_TAB_counter;
                      end;

              else
                Fehler_cl.Registrieren('ZwischenCode/PCALL_exec',
                               'ANW_type <'+akt_CALL_PROC.PPR_ARR[PL_Zaehler].ANW_Type+
                               '> zum Word-Parameter ('+IntToStr(PL_Zaehler)+') nicht definiert',
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);
              end; { case akt_CALL_PROC.PPR_ARR[PL_Zaehler].ANW_Type of }

            end; { AT_dword }



          AT_currency :
            begin

              if ANWType='P' then
                STM_LISTE[STM_LISTE_counter].Bemerkung:=
                  '; Currency-Parameter('+IntToStr(PL_Zaehler)+') fuer PROCEDURE ('+
                  PROC_LIS.LISTE[akt_CALL_PROC.PROC_Pos].Name+')'
              else
                STM_LISTE[STM_LISTE_counter].Bemerkung:=
                  '; Currency-Parameter('+IntToStr(PL_Zaehler)+') fuer FUNCTION ('+
                  PROC_LIS.LISTE[akt_CALL_PROC.PROC_Pos].Name+')';


              case akt_CALL_PROC.PPR_ARR[PL_Zaehler].ANW_Type of

                'V' : begin

                  STM_LISTE[STM_LISTE_counter].statement:=STM_LDS;
                  STM_LISTE[STM_LISTE_counter].parameter1:=akt_CALL_PROC.PPR_ARR[PL_Zaehler].Parameter;
                  STM_LISTE[STM_LISTE_counter].parameter2:=akt_CALL_PROC.PPR_ARR[PL_Zaehler].Register_L;
                  Inc_STM_TAB_counter;
                  STM_LISTE[STM_LISTE_counter].statement:=STM_LDS;
                  STM_LISTE[STM_LISTE_counter].parameter1:=akt_CALL_PROC.PPR_ARR[PL_Zaehler].Parameter+'+1';
                  STM_LISTE[STM_LISTE_counter].parameter2:=akt_CALL_PROC.PPR_ARR[PL_Zaehler].Register_H;
                  Inc_STM_TAB_counter;
                  STM_LISTE[STM_LISTE_counter].statement:=STM_LDS;
                  STM_LISTE[STM_LISTE_counter].parameter1:=akt_CALL_PROC.PPR_ARR[PL_Zaehler].Parameter+'+2';
                  STM_LISTE[STM_LISTE_counter].parameter2:=akt_CALL_PROC.PPR_ARR[PL_Zaehler].Register_LH;
                  Inc_STM_TAB_counter;
                  STM_LISTE[STM_LISTE_counter].statement:=STM_LDS;
                  STM_LISTE[STM_LISTE_counter].parameter1:=akt_CALL_PROC.PPR_ARR[PL_Zaehler].Parameter+'+3';
                  STM_LISTE[STM_LISTE_counter].parameter2:=akt_CALL_PROC.PPR_ARR[PL_Zaehler].Register_HH;
                  Inc_STM_TAB_counter;

                  STM_LISTE[STM_LISTE_counter].statement:=STM_LDS;
                  STM_LISTE[STM_LISTE_counter].parameter1:=akt_CALL_PROC.PPR_ARR[PL_Zaehler].Parameter+'+4';
                  STM_LISTE[STM_LISTE_counter].parameter2:=akt_CALL_PROC.PPR_ARR[PL_Zaehler].Register_LLH;
                  Inc_STM_TAB_counter;
                  STM_LISTE[STM_LISTE_counter].statement:=STM_LDS;
                  STM_LISTE[STM_LISTE_counter].parameter1:=akt_CALL_PROC.PPR_ARR[PL_Zaehler].Parameter+'+5';
                  STM_LISTE[STM_LISTE_counter].parameter2:=akt_CALL_PROC.PPR_ARR[PL_Zaehler].Register_LHH;
                  Inc_STM_TAB_counter;
                  STM_LISTE[STM_LISTE_counter].statement:=STM_LDS;
                  STM_LISTE[STM_LISTE_counter].parameter1:=akt_CALL_PROC.PPR_ARR[PL_Zaehler].Parameter+'+6';
                  STM_LISTE[STM_LISTE_counter].parameter2:=akt_CALL_PROC.PPR_ARR[PL_Zaehler].Register_HLH;
                  Inc_STM_TAB_counter;
                  STM_LISTE[STM_LISTE_counter].statement:=STM_LDS;
                  STM_LISTE[STM_LISTE_counter].parameter1:=akt_CALL_PROC.PPR_ARR[PL_Zaehler].Parameter+'+7';
                  STM_LISTE[STM_LISTE_counter].parameter2:=akt_CALL_PROC.PPR_ARR[PL_Zaehler].Register_HHH;
                  Inc_STM_TAB_counter;

                end; { 'V' }


                'C','W' : begin

                   if akt_CALL_PROC.PPR_ARR[PL_Zaehler].ANW_Type='C' then
                     Wert:=CONST_NAME_TO_WERT(akt_CALL_PROC.PPR_ARR[PL_Zaehler].Parameter)
                   else
                     Wert:=akt_CALL_PROC.PPR_ARR[PL_Zaehler].Parameter;

                   QWord_Wert:=StrToInt(Wert);

                   HexWert:=IntToHex(QWord_Wert,16);

                   ByteWert:='0x'+Copy(HexWert,15,2);
                   STM_LISTE[STM_LISTE_counter].statement:=STM_LDI;
                   STM_LISTE[STM_LISTE_counter].Parameter1:=ByteWert;
                   STM_LISTE[STM_LISTE_counter].Parameter2:='R16';
                   Inc_STM_TAB_counter;
                   STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
                   STM_LISTE[STM_LISTE_counter].Parameter1:='R16';
                   STM_LISTE[STM_LISTE_counter].Parameter2:=akt_CALL_PROC.PPR_ARR[PL_Zaehler].Register_L;
                   Inc_STM_TAB_counter;

                   ByteWert:='0x'+Copy(HexWert,13,2);
                   STM_LISTE[STM_LISTE_counter].statement:=STM_LDI;
                   STM_LISTE[STM_LISTE_counter].Parameter1:=ByteWert;
                   STM_LISTE[STM_LISTE_counter].Parameter2:='R17';
                   Inc_STM_TAB_counter;
                   STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
                   STM_LISTE[STM_LISTE_counter].Parameter1:='R17';
                   STM_LISTE[STM_LISTE_counter].Parameter2:=akt_CALL_PROC.PPR_ARR[PL_Zaehler].Register_H;
                   Inc_STM_TAB_counter;

                   ByteWert:='0x'+Copy(HexWert,11,2);
                   STM_LISTE[STM_LISTE_counter].statement:=STM_LDI;
                   STM_LISTE[STM_LISTE_counter].Parameter1:=ByteWert;
                   STM_LISTE[STM_LISTE_counter].Parameter2:='R18';
                   Inc_STM_TAB_counter;
                   STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
                   STM_LISTE[STM_LISTE_counter].Parameter1:='R18';
                   STM_LISTE[STM_LISTE_counter].Parameter2:=akt_CALL_PROC.PPR_ARR[PL_Zaehler].Register_LH;
                   Inc_STM_TAB_counter;

                   ByteWert:='0x'+Copy(HexWert,9,2);
                   STM_LISTE[STM_LISTE_counter].statement:=STM_LDI;
                   STM_LISTE[STM_LISTE_counter].Parameter1:=ByteWert;
                   STM_LISTE[STM_LISTE_counter].Parameter2:='R19';
                   Inc_STM_TAB_counter;
                   STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
                   STM_LISTE[STM_LISTE_counter].Parameter1:='R19';
                   STM_LISTE[STM_LISTE_counter].Parameter2:=akt_CALL_PROC.PPR_ARR[PL_Zaehler].Register_HH;
                   Inc_STM_TAB_counter;

                   ByteWert:='0x'+Copy(HexWert,7,2);
                   STM_LISTE[STM_LISTE_counter].statement:=STM_LDI;
                   STM_LISTE[STM_LISTE_counter].Parameter1:=ByteWert;
                   STM_LISTE[STM_LISTE_counter].Parameter2:='R20';
                   Inc_STM_TAB_counter;
                   STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
                   STM_LISTE[STM_LISTE_counter].Parameter1:='R20';
                   STM_LISTE[STM_LISTE_counter].Parameter2:=akt_CALL_PROC.PPR_ARR[PL_Zaehler].Register_LLH;
                   Inc_STM_TAB_counter;

                   ByteWert:='0x'+Copy(HexWert,5,2);
                   STM_LISTE[STM_LISTE_counter].statement:=STM_LDI;
                   STM_LISTE[STM_LISTE_counter].Parameter1:=ByteWert;
                   STM_LISTE[STM_LISTE_counter].Parameter2:='R21';
                   Inc_STM_TAB_counter;
                   STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
                   STM_LISTE[STM_LISTE_counter].Parameter1:='R21';
                   STM_LISTE[STM_LISTE_counter].Parameter2:=akt_CALL_PROC.PPR_ARR[PL_Zaehler].Register_LHH;
                   Inc_STM_TAB_counter;

                   ByteWert:='0x'+Copy(HexWert,3,2);
                   STM_LISTE[STM_LISTE_counter].statement:=STM_LDI;
                   STM_LISTE[STM_LISTE_counter].Parameter1:=ByteWert;
                   STM_LISTE[STM_LISTE_counter].Parameter2:='R22';
                   Inc_STM_TAB_counter;
                   STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
                   STM_LISTE[STM_LISTE_counter].Parameter1:='R22';
                   STM_LISTE[STM_LISTE_counter].Parameter2:=akt_CALL_PROC.PPR_ARR[PL_Zaehler].Register_HLH;
                   Inc_STM_TAB_counter;

                   ByteWert:='0x'+Copy(HexWert,1,2);
                   STM_LISTE[STM_LISTE_counter].statement:=STM_LDI;
                   STM_LISTE[STM_LISTE_counter].Parameter1:=ByteWert;
                   STM_LISTE[STM_LISTE_counter].Parameter2:='R23';
                   Inc_STM_TAB_counter;
                   STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
                   STM_LISTE[STM_LISTE_counter].Parameter1:='R23';
                   STM_LISTE[STM_LISTE_counter].Parameter2:=akt_CALL_PROC.PPR_ARR[PL_Zaehler].Register_HHH;
                   Inc_STM_TAB_counter;

                end; { 'C','W' }

              else
                Fehler_cl.Registrieren('ZwischenCode/PCALL_exec',
                               'ANW_type <'+akt_CALL_PROC.PPR_ARR[PL_Zaehler].ANW_Type+
                               '> zum Word-Parameter ('+IntToStr(PL_Zaehler)+') nicht definiert',
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);
              end; { case akt_CALL_PROC.PPR_ARR[PL_Zaehler].ANW_Type of }

            end; { AT_currency }

        else

          Fehler_cl.Registrieren('ZwischenCode/PCALL_exec',
                               'ASM_type zum Parameter ('+IntToStr(PL_Zaehler)+') nicht definiert',
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

        end; { case akt_CALL_PROC.PPR_ARR[PL_Zaehler].ASM_type of }


      end; { if not (akt_CALL_PROC.PPR_ARR[PL_Zaehler].ASM_type IN ['L','D']) then }


    end; { for PL_Zaehler:=1 to PROC_LIS.LISTE[akt_CALL_PROC.PROC_Pos].counter-1 do }

  end; { if PROC_LIS.LISTE[PROC_LIS.counter].counter>1 then }




  if ANWType='P' then begin
    STM_LISTE[STM_LISTE_counter].Bemerkung:='; Aufruf PROCEDURE ('+
                                            PROC_LIS.LISTE[akt_CALL_PROC.PROC_Pos].Name+')';

    case ASM_Switch.JMP_Sprungdistanz of
      JMP_Relativ   : STM_LISTE[STM_LISTE_counter].statement:=STM_RCALL;
      JMP_Word      : STM_LISTE[STM_LISTE_counter].statement:=STM_CALL;
      JMP_als_EIJMP : STM_LISTE[STM_LISTE_counter].statement:=STM_EICALL;
    else
      Fehler_cl.Registrieren('ZwischenCode/PCALL_exec',
                             'JMP_Sprungdistanz nicht definiert',
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);
    end; { case JMP_Sprungdistanz of }


    STM_LISTE[STM_LISTE_counter].parameter1:=PROC_LIS.LISTE[akt_CALL_PROC.PROC_Pos].Name;
    Inc_STM_TAB_counter;
  end; { if ANWType='P' then }



  if ANWType='F' then begin
    STM_LISTE[STM_LISTE_counter].Bemerkung:='; Aufruf Funktion ('+
              ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Quelle[ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].
                        QUELLcounter].Name+')';


    case ASM_Switch.JMP_Sprungdistanz of
      JMP_Relativ   : STM_LISTE[STM_LISTE_counter].statement:=STM_RCALL;
      JMP_Word      : STM_LISTE[STM_LISTE_counter].statement:=STM_CALL;
      JMP_als_EIJMP : STM_LISTE[STM_LISTE_counter].statement:=STM_EICALL;
    else
      Fehler_cl.Registrieren('ZwischenCode/PCALL_exec',
                                 'JMP_Sprungdistanz nicht definiert',
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);
    end; { case JMP_Sprungdistanz of }


    STM_LISTE[STM_LISTE_counter].Parameter1:=
              ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Quelle[ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].
                        QUELLcounter].Name;
    Inc_STM_TAB_counter;

    if ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].QUELLcounter>1 then begin
      STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
      STM_LISTE[STM_LISTE_counter].Parameter2:='R18';
      STM_LISTE[STM_LISTE_counter].Parameter1:='R16';
      Inc_STM_TAB_counter;
    end; { if ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].QUELLcounter>1 then }

  end; { if ANWType='F' then }




  // beim Aufruf einer PROCEDURE/FUNCTION innerhalb einer PROCEDURE/FUNCTION
  if PROC_LIS.LISTE[PROC_LIS.counter].ANW_Type<>'X' then begin

    // zurckholen der geretteten Parameter-Register der uebergeordneten PROCEDURE/FUNCTION
    for PL_Zaehler:=PROC_LIS.LISTE[PROC_LIS.counter].REG_ARRAY_LOW_pointer-1 downto 1 do begin

      if PL_Zaehler=PROC_LIS.LISTE[PROC_LIS.counter].REG_ARRAY_LOW_pointer-1 then
        STM_LISTE[STM_LISTE_counter].Bemerkung:='; Retten der Parameter-Register fuer PROCEDURE ('+
                      PROC_LIS.LISTE[PROC_LIS.counter].Name+')';

      STM_LISTE[STM_LISTE_counter].statement:=STM_POP;
      STM_LISTE[STM_LISTE_counter].Parameter1:=REG_ARRAY_LOW[PL_Zaehler];

      Inc_STM_TAB_counter;

    end; { for PL_Zaehler:=1 to PROC_LIS.LISTE[akt_CALL_PROC.PROC_Pos].counter-1 do }

  end; { if PROC_LIS.LISTE[akt_CALL_PROC.PROC_Pos].ANW_Type<>'X' then }




  Ruecksetzen_akt_CALL_PROC;
  PCE_erfolgreich:=true;

  Result:=PCE_erfolgreich;

end; { function ZWC_class.PROCEDURE_call_exec }







// ********************************************
//              FUNCTION
// ********************************************




function ZWC_class.FUNCTION_result_type_eintragen(RTYPE : String) : Boolean;
var
  PT_erfolgreich : Boolean;
  ASM_TYPE : ASM_type_Typ;




  procedure PROC_LISTE_Eintrag(PL_ASM_type : ASM_type_Typ);
  begin
    PROC_LIS.LISTE[PROC_LIS.counter].RESULT.ASM_type:=PL_ASM_type;

    case PL_ASM_type of

      AT_boolean, AT_byte, AT_char :
        begin
          PROC_LIS.LISTE[PROC_LIS.counter].RESULT.Register_L:=naechstes_Register;
        end; { AT_boolean, AT_byte, AT_char }

      AT_word :
        begin
          PROC_LIS.LISTE[PROC_LIS.counter].RESULT.Register_L:=naechstes_Register;
          PROC_LIS.LISTE[PROC_LIS.counter].RESULT.Register_H:=naechstes_Register;
        end; { AT_word }

      AT_dword :
        begin
          PROC_LIS.LISTE[PROC_LIS.counter].RESULT.Register_L:=naechstes_Register;
          PROC_LIS.LISTE[PROC_LIS.counter].RESULT.Register_H:=naechstes_Register;
          PROC_LIS.LISTE[PROC_LIS.counter].RESULT.Register_LH:=naechstes_Register;
          PROC_LIS.LISTE[PROC_LIS.counter].RESULT.Register_HH:=naechstes_Register;
        end; { AT_dword }

      AT_currency :
        begin
          PROC_LIS.LISTE[PROC_LIS.counter].RESULT.Register_L:=naechstes_Register;
          PROC_LIS.LISTE[PROC_LIS.counter].RESULT.Register_H:=naechstes_Register;
          PROC_LIS.LISTE[PROC_LIS.counter].RESULT.Register_LH:=naechstes_Register;
          PROC_LIS.LISTE[PROC_LIS.counter].RESULT.Register_HH:=naechstes_Register;
          PROC_LIS.LISTE[PROC_LIS.counter].RESULT.Register_LLH:=naechstes_Register;
          PROC_LIS.LISTE[PROC_LIS.counter].RESULT.Register_LHH:=naechstes_Register;
          PROC_LIS.LISTE[PROC_LIS.counter].RESULT.Register_HLH:=naechstes_Register;
          PROC_LIS.LISTE[PROC_LIS.counter].RESULT.Register_HHH:=naechstes_Register;
        end; { AT_currency }


    else
      Fehler_cl.Registrieren('ZWC_03/FUNCTION_result_type_eintragen/PROC_LISTE_Eintrag', 'Der Typ '+
                             Compiler_cl.ASM_type_Typ_in_Bezeichner(PL_ASM_type)+
                             ' des RETURN-Wertes wird nicht unterstuetzt',
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

    end; { case PL_ASM_type of }

  end; { procedure PROC_LISTE_Eintrag }




    procedure NAME_LISTE_Eintrag(PL_ASM_type : ASM_type_Typ);
    var
      NLIS_Pos, NLIS_Zaehler : Integer;
    begin
      NLIS_Pos:=0;
      for NLIS_Zaehler:=1 to NAME_TAB_counter do begin
        if NAME_TAB[NLIS_Zaehler].Bezeichner=PROC_LIS.LISTE[PROC_LIS.counter].Name then begin
          NLIS_Pos:=NLIS_Zaehler;
          NAME_TAB[NLIS_Pos].ASM_type:=PL_ASM_type;
        end;
      end; { for NLIS_Zaehler:=1 to NAME_TAB_counter-1 do }

      if NLIS_Pos=0 then
        Fehler_cl.Registrieren('ZwischenCode/FUNCTION_result_type_eintragen/NAME_LISTE_Eintrag',
                               'Der Name der Funktion <'+PROC_LIS.LISTE[PROC_LIS.counter].Name
                               +'> konnte in der NAME_TAB nicht gefunden werden',
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

    end; { procedure NAME_LISTE_Eintrag }


begin
  PT_erfolgreich:=false;

  ASM_TYPE:=TYPENAME_IN_TYPE(RTYPE);

  if ASM_TYPE<>AT_kein_typ then begin
    NAME_LISTE_Eintrag(ASM_TYPE);
    PROC_LISTE_Eintrag(ASM_TYPE);
    PT_erfolgreich:=true;

  end; { if ASM_TYPE<>AT_kein_typ then }

  Result:=PT_erfolgreich;
end; { function ZWC_class.FUNCTION_result_type_eintragen }







function ZWC_class.FUNCTION_result_const_eintragen(RW : String; RUT : SI_Unter_Typ) : Boolean;
var
  FRW_erfolgreich : Boolean;
  FRW_ASM_type : ASM_type_Typ;
  ByteWert, HexWert : String;
  QWord_Wert : QWord;

begin
  FRW_erfolgreich:=false;

  FRW_ASM_type:=PROC_LIS.LISTE[PROC_LIS.counter].RESULT.ASM_type;

  if FRW_ASM_type=AT_byte_con_reg then
    FRW_ASM_type:=AT_byte;

  if FRW_ASM_type=AT_word_con_reg then
    FRW_ASM_type:=AT_word;


  if CONST_WERT_ueberpruefen(RW,RUT,FRW_ASM_type) then begin
    case FRW_ASM_type of

     AT_boolean, AT_byte, AT_char :
        begin
          STM_LISTE[STM_LISTE_counter].Bemerkung:='; RESULT Byte-Konstante - FUNCTION ('+
                                                  PROC_LIS.LISTE[PROC_LIS.counter].Name+');';

          STM_LISTE[STM_LISTE_counter].statement:=STM_LDI;
          STM_LISTE[STM_LISTE_counter].parameter1:=RW;
          STM_LISTE[STM_LISTE_counter].parameter2:='R16';
          Inc_STM_TAB_counter;
          STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
          STM_LISTE[STM_LISTE_counter].parameter1:='R16';
          STM_LISTE[STM_LISTE_counter].parameter2:=PROC_LIS.LISTE[PROC_LIS.counter].RESULT.Register_L;
          Inc_STM_TAB_counter;

        end; { AT_boolean, AT_byte, AT_char }

      AT_word :
        begin
          STM_LISTE[STM_LISTE_counter].Bemerkung:='; RESULT Word-Konstante - FUNCTION ('+
                                                  PROC_LIS.LISTE[PROC_LIS.counter].Name+');';

          STM_LISTE[STM_LISTE_counter].statement:=STM_LDI_word_L;
          STM_LISTE[STM_LISTE_counter].parameter1:=RW;
          STM_LISTE[STM_LISTE_counter].parameter2:='R16';
          Inc_STM_TAB_counter;
          STM_LISTE[STM_LISTE_counter].statement:=STM_LDI_word_H;
          STM_LISTE[STM_LISTE_counter].parameter1:=RW;
          STM_LISTE[STM_LISTE_counter].parameter2:='R17';
          Inc_STM_TAB_counter;


          STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
          STM_LISTE[STM_LISTE_counter].parameter1:='R16';
          STM_LISTE[STM_LISTE_counter].parameter2:=PROC_LIS.LISTE[PROC_LIS.counter].RESULT.Register_L;
          Inc_STM_TAB_counter;
          STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
          STM_LISTE[STM_LISTE_counter].parameter1:='R17';
          STM_LISTE[STM_LISTE_counter].parameter2:=PROC_LIS.LISTE[PROC_LIS.counter].RESULT.Register_H;
          Inc_STM_TAB_counter;

        end; { AT_word }


      AT_dword :
        begin

          STM_LISTE[STM_LISTE_counter].Bemerkung:='; RESULT DWord-Konstante - FUNCTION ('+
                                                  PROC_LIS.LISTE[PROC_LIS.counter].Name+');';

          ByteWert:='0x'+Copy(RW,7,2);
          STM_LISTE[STM_LISTE_counter].statement:=STM_LDI;
          STM_LISTE[STM_LISTE_counter].parameter1:=ByteWert;
          STM_LISTE[STM_LISTE_counter].parameter2:='R16';
          Inc_STM_TAB_counter;

          ByteWert:='0x'+Copy(RW,5,2);
          STM_LISTE[STM_LISTE_counter].statement:=STM_LDI;
          STM_LISTE[STM_LISTE_counter].parameter1:=ByteWert;
          STM_LISTE[STM_LISTE_counter].parameter2:='R17';
          Inc_STM_TAB_counter;

          ByteWert:='0x'+Copy(RW,3,2);
          STM_LISTE[STM_LISTE_counter].statement:=STM_LDI;
          STM_LISTE[STM_LISTE_counter].parameter1:=ByteWert;
          STM_LISTE[STM_LISTE_counter].parameter2:='R18';
          Inc_STM_TAB_counter;

          ByteWert:='0x'+Copy(RW,1,2);
          STM_LISTE[STM_LISTE_counter].statement:=STM_LDI;
          STM_LISTE[STM_LISTE_counter].parameter1:=ByteWert;
          STM_LISTE[STM_LISTE_counter].parameter2:='R19';
          Inc_STM_TAB_counter;


          STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
          STM_LISTE[STM_LISTE_counter].parameter1:='R16';
          STM_LISTE[STM_LISTE_counter].parameter2:=PROC_LIS.LISTE[PROC_LIS.counter].RESULT.Register_L;
          Inc_STM_TAB_counter;

          STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
          STM_LISTE[STM_LISTE_counter].parameter1:='R17';
          STM_LISTE[STM_LISTE_counter].parameter2:=PROC_LIS.LISTE[PROC_LIS.counter].RESULT.Register_H;
          Inc_STM_TAB_counter;

          STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
          STM_LISTE[STM_LISTE_counter].parameter1:='R18';
          STM_LISTE[STM_LISTE_counter].parameter2:=PROC_LIS.LISTE[PROC_LIS.counter].RESULT.Register_LH;
          Inc_STM_TAB_counter;

          STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
          STM_LISTE[STM_LISTE_counter].parameter1:='R19';
          STM_LISTE[STM_LISTE_counter].parameter2:=PROC_LIS.LISTE[PROC_LIS.counter].RESULT.Register_HH;
          Inc_STM_TAB_counter;

        end; { AT_dword }




      AT_currency :
        begin

          STM_LISTE[STM_LISTE_counter].Bemerkung:='; RESULT DWord-Konstante - FUNCTION ('+
                                                  PROC_LIS.LISTE[PROC_LIS.counter].Name+');';

          QWord_Wert:=StrToInt(RW);

          HexWert:=IntToHex(QWord_Wert,16);

          ByteWert:='0x'+Copy(HexWert,15,2);
          STM_LISTE[STM_LISTE_counter].statement:=STM_LDI;
          STM_LISTE[STM_LISTE_counter].parameter1:=ByteWert;
          STM_LISTE[STM_LISTE_counter].parameter2:='R16';
          Inc_STM_TAB_counter;

          ByteWert:='0x'+Copy(HexWert,13,2);
          STM_LISTE[STM_LISTE_counter].statement:=STM_LDI;
          STM_LISTE[STM_LISTE_counter].parameter1:=ByteWert;
          STM_LISTE[STM_LISTE_counter].parameter2:='R17';
          Inc_STM_TAB_counter;

          ByteWert:='0x'+Copy(HexWert,11,2);
          STM_LISTE[STM_LISTE_counter].statement:=STM_LDI;
          STM_LISTE[STM_LISTE_counter].parameter1:=ByteWert;
          STM_LISTE[STM_LISTE_counter].parameter2:='R18';
          Inc_STM_TAB_counter;

          ByteWert:='0x'+Copy(HexWert,9,2);
          STM_LISTE[STM_LISTE_counter].statement:=STM_LDI;
          STM_LISTE[STM_LISTE_counter].parameter1:=ByteWert;
          STM_LISTE[STM_LISTE_counter].parameter2:='R19';
          Inc_STM_TAB_counter;

          ByteWert:='0x'+Copy(HexWert,7,2);
          STM_LISTE[STM_LISTE_counter].statement:=STM_LDI;
          STM_LISTE[STM_LISTE_counter].parameter1:=ByteWert;
          STM_LISTE[STM_LISTE_counter].parameter2:='R20';
          Inc_STM_TAB_counter;

          ByteWert:='0x'+Copy(HexWert,5,2);
          STM_LISTE[STM_LISTE_counter].statement:=STM_LDI;
          STM_LISTE[STM_LISTE_counter].parameter1:=ByteWert;
          STM_LISTE[STM_LISTE_counter].parameter2:='R21';
          Inc_STM_TAB_counter;

          ByteWert:='0x'+Copy(HexWert,3,2);
          STM_LISTE[STM_LISTE_counter].statement:=STM_LDI;
          STM_LISTE[STM_LISTE_counter].parameter1:=ByteWert;
          STM_LISTE[STM_LISTE_counter].parameter2:='R22';
          Inc_STM_TAB_counter;

          ByteWert:='0x'+Copy(HexWert,1,2);
          STM_LISTE[STM_LISTE_counter].statement:=STM_LDI;
          STM_LISTE[STM_LISTE_counter].parameter1:=ByteWert;
          STM_LISTE[STM_LISTE_counter].parameter2:='R23';
          Inc_STM_TAB_counter;


          STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
          STM_LISTE[STM_LISTE_counter].parameter1:='R16';
          STM_LISTE[STM_LISTE_counter].parameter2:=PROC_LIS.LISTE[PROC_LIS.counter].RESULT.Register_L;
          Inc_STM_TAB_counter;

          STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
          STM_LISTE[STM_LISTE_counter].parameter1:='R17';
          STM_LISTE[STM_LISTE_counter].parameter2:=PROC_LIS.LISTE[PROC_LIS.counter].RESULT.Register_H;
          Inc_STM_TAB_counter;

          STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
          STM_LISTE[STM_LISTE_counter].parameter1:='R18';
          STM_LISTE[STM_LISTE_counter].parameter2:=PROC_LIS.LISTE[PROC_LIS.counter].RESULT.Register_LH;
          Inc_STM_TAB_counter;

          STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
          STM_LISTE[STM_LISTE_counter].parameter1:='R19';
          STM_LISTE[STM_LISTE_counter].parameter2:=PROC_LIS.LISTE[PROC_LIS.counter].RESULT.Register_HH;
          Inc_STM_TAB_counter;

          STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
          STM_LISTE[STM_LISTE_counter].parameter1:='R20';
          STM_LISTE[STM_LISTE_counter].parameter2:=PROC_LIS.LISTE[PROC_LIS.counter].RESULT.Register_LLH;
          Inc_STM_TAB_counter;

          STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
          STM_LISTE[STM_LISTE_counter].parameter1:='R21';
          STM_LISTE[STM_LISTE_counter].parameter2:=PROC_LIS.LISTE[PROC_LIS.counter].RESULT.Register_LHH;
          Inc_STM_TAB_counter;

          STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
          STM_LISTE[STM_LISTE_counter].parameter1:='R22';
          STM_LISTE[STM_LISTE_counter].parameter2:=PROC_LIS.LISTE[PROC_LIS.counter].RESULT.Register_HLH;
          Inc_STM_TAB_counter;

          STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
          STM_LISTE[STM_LISTE_counter].parameter1:='R23';
          STM_LISTE[STM_LISTE_counter].parameter2:=PROC_LIS.LISTE[PROC_LIS.counter].RESULT.Register_HHH;
          Inc_STM_TAB_counter;

        end; { AT_currency }



    else
      Fehler_cl.Registrieren('ZwischenCode/FUNCTION_result_const_eintragen', 'Der Typ '+
                             Compiler_cl.ASM_type_Typ_in_Bezeichner(FRW_ASM_type)+
                             ' des RETURN-Wertes wird nicht unterstuetzt',
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

    end; { case FRW_ASM_type of }

    FRW_erfolgreich:=true;

    PROC_LIS.LISTE[PROC_LIS.counter].RESULT_vorhanden:=true;

  end; { if CONST_WERT_ueberpruefen(CW,CUT,ZC_CONST_TAB[ZC_CONST_TAB_counter].ASM_type) then }

  Result:=FRW_erfolgreich;

end; { function ZWC_class.FUNCTION_result_const_eintragen }





function ZWC_class.FUNCTION_result_var_const_eintragen(R_VAR : String) : Boolean;
var
  FRV_erfolgreich : Boolean;
  FRV_type : ASM_type_Typ;
  FRV_ANW_Type : Char;
  lok_PAR_Pos : Integer;
  Wert, ByteWert, HexWert : String;
  QWord_Wert : QWord;


begin

  FRV_erfolgreich:=false;

  if NAME_TO_ANW_und_ASM(R_VAR,FRV_ANW_Type,FRV_type) then begin

  if FRV_ANW_Type IN ['V','D','L','C'] then begin

    if FRV_type=PROC_LIS.LISTE[PROC_LIS.counter].RESULT.ASM_type then begin

      FRV_erfolgreich:=true;

      PROC_LIS.LISTE[PROC_LIS.counter].RESULT_vorhanden:=true;

      case FRV_ANW_Type of

      'V' :  begin

        case FRV_type of

          AT_boolean, AT_byte, AT_char :
            begin
              STM_LISTE[STM_LISTE_counter].Bemerkung:='; RESULT Byte-Variable - FUNCTION ('+
                                                      PROC_LIS.LISTE[PROC_LIS.counter].Name+')';
              STM_LISTE[STM_LISTE_counter].statement:=STM_LDS;
              STM_LISTE[STM_LISTE_counter].parameter1:=R_VAR;
              STM_LISTE[STM_LISTE_counter].parameter2:=PROC_LIS.LISTE[PROC_LIS.counter].RESULT.Register_L;
              Inc_STM_TAB_counter;
            end; { AT_boolean, AT_byte, AT_char }


          AT_word :
            begin
              STM_LISTE[STM_LISTE_counter].Bemerkung:='; RESULT Word-Variable - FUNCTION ('+
                                                      PROC_LIS.LISTE[PROC_LIS.counter].Name+')';
              STM_LISTE[STM_LISTE_counter].statement:=STM_LDS;
              STM_LISTE[STM_LISTE_counter].parameter1:=R_VAR;
              STM_LISTE[STM_LISTE_counter].parameter2:=PROC_LIS.LISTE[PROC_LIS.counter].RESULT.Register_L;
              Inc_STM_TAB_counter;

              STM_LISTE[STM_LISTE_counter].statement:=STM_LDS;
              STM_LISTE[STM_LISTE_counter].parameter1:=R_VAR+'+1';
              STM_LISTE[STM_LISTE_counter].parameter2:=PROC_LIS.LISTE[PROC_LIS.counter].RESULT.Register_H;
              Inc_STM_TAB_counter;
            end; { AT_word }

          AT_dword :
            begin
              STM_LISTE[STM_LISTE_counter].Bemerkung:='; RESULT DWord-Variable - FUNCTION ('+
                                                      PROC_LIS.LISTE[PROC_LIS.counter].Name+')';
              STM_LISTE[STM_LISTE_counter].statement:=STM_LDS;
              STM_LISTE[STM_LISTE_counter].parameter1:=R_VAR;
              STM_LISTE[STM_LISTE_counter].parameter2:=PROC_LIS.LISTE[PROC_LIS.counter].RESULT.Register_L;
              Inc_STM_TAB_counter;

              STM_LISTE[STM_LISTE_counter].statement:=STM_LDS;
              STM_LISTE[STM_LISTE_counter].parameter1:=R_VAR+'+1';
              STM_LISTE[STM_LISTE_counter].parameter2:=PROC_LIS.LISTE[PROC_LIS.counter].RESULT.Register_H;
              Inc_STM_TAB_counter;

              STM_LISTE[STM_LISTE_counter].statement:=STM_LDS;
              STM_LISTE[STM_LISTE_counter].parameter1:=R_VAR+'+2';
              STM_LISTE[STM_LISTE_counter].parameter2:=PROC_LIS.LISTE[PROC_LIS.counter].RESULT.Register_LH;
              Inc_STM_TAB_counter;

              STM_LISTE[STM_LISTE_counter].statement:=STM_LDS;
              STM_LISTE[STM_LISTE_counter].parameter1:=R_VAR+'+3';
              STM_LISTE[STM_LISTE_counter].parameter2:=PROC_LIS.LISTE[PROC_LIS.counter].RESULT.Register_HH;
              Inc_STM_TAB_counter;

            end; { AT_dword }


          AT_currency :
            begin
              STM_LISTE[STM_LISTE_counter].Bemerkung:='; RESULT Currency-Variable - FUNCTION ('+
                                                      PROC_LIS.LISTE[PROC_LIS.counter].Name+')';

              STM_LISTE[STM_LISTE_counter].statement:=STM_LDS;
              STM_LISTE[STM_LISTE_counter].parameter1:=R_VAR;
              STM_LISTE[STM_LISTE_counter].parameter2:=PROC_LIS.LISTE[PROC_LIS.counter].RESULT.Register_L;
              Inc_STM_TAB_counter;

              STM_LISTE[STM_LISTE_counter].statement:=STM_LDS;
              STM_LISTE[STM_LISTE_counter].parameter1:=R_VAR+'+1';
              STM_LISTE[STM_LISTE_counter].parameter2:=PROC_LIS.LISTE[PROC_LIS.counter].RESULT.Register_H;
              Inc_STM_TAB_counter;

              STM_LISTE[STM_LISTE_counter].statement:=STM_LDS;
              STM_LISTE[STM_LISTE_counter].parameter1:=R_VAR+'+2';
              STM_LISTE[STM_LISTE_counter].parameter2:=PROC_LIS.LISTE[PROC_LIS.counter].RESULT.Register_LH;
              Inc_STM_TAB_counter;

              STM_LISTE[STM_LISTE_counter].statement:=STM_LDS;
              STM_LISTE[STM_LISTE_counter].parameter1:=R_VAR+'+3';
              STM_LISTE[STM_LISTE_counter].parameter2:=PROC_LIS.LISTE[PROC_LIS.counter].RESULT.Register_HH;
              Inc_STM_TAB_counter;

              STM_LISTE[STM_LISTE_counter].statement:=STM_LDS;
              STM_LISTE[STM_LISTE_counter].parameter1:=R_VAR+'+4';
              STM_LISTE[STM_LISTE_counter].parameter2:=PROC_LIS.LISTE[PROC_LIS.counter].RESULT.Register_LLH;
              Inc_STM_TAB_counter;

              STM_LISTE[STM_LISTE_counter].statement:=STM_LDS;
              STM_LISTE[STM_LISTE_counter].parameter1:=R_VAR+'+5';
              STM_LISTE[STM_LISTE_counter].parameter2:=PROC_LIS.LISTE[PROC_LIS.counter].RESULT.Register_LHH;
              Inc_STM_TAB_counter;

              STM_LISTE[STM_LISTE_counter].statement:=STM_LDS;
              STM_LISTE[STM_LISTE_counter].parameter1:=R_VAR+'+6';
              STM_LISTE[STM_LISTE_counter].parameter2:=PROC_LIS.LISTE[PROC_LIS.counter].RESULT.Register_HLH;
              Inc_STM_TAB_counter;

              STM_LISTE[STM_LISTE_counter].statement:=STM_LDS;
              STM_LISTE[STM_LISTE_counter].parameter1:=R_VAR+'+7';
              STM_LISTE[STM_LISTE_counter].parameter2:=PROC_LIS.LISTE[PROC_LIS.counter].RESULT.Register_HHH;
              Inc_STM_TAB_counter;

            end; { AT_currency }


        else
          Fehler_cl.Registrieren('ZwischenCode/FUNCTION_result_var_const_eintragen', 'Der Typ '+
                                 Compiler_cl.ASM_type_Typ_in_Bezeichner(FRV_type)+
                                 ' des RETURN-Wertes wird nicht unterstuetzt',
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

        end; { case FRV_type of }

      end; { 'V' }


      'L','D' : begin

        lok_PAR_Pos:=lokalen_Parameter_suchen(R_VAR);

        case FRV_type of

          AT_boolean, AT_byte, AT_char :
            begin
              STM_LISTE[STM_LISTE_counter].Bemerkung:='; RESULT Byte-Variable - FUNCTION ('+
                                                      PROC_LIS.LISTE[PROC_LIS.counter].Name+')';
              STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
              STM_LISTE[STM_LISTE_counter].parameter1:=PROC_LIS.LISTE[PROC_LIS.counter].PPR_ARR[lok_PAR_Pos].Register_L;
              STM_LISTE[STM_LISTE_counter].parameter2:=PROC_LIS.LISTE[PROC_LIS.counter].RESULT.Register_L;
              Inc_STM_TAB_counter;
            end; { AT_boolean, AT_byte, AT_char }

          AT_word :
            begin
              STM_LISTE[STM_LISTE_counter].Bemerkung:='; RESULT Word-Variable - FUNCTION ('+
                                                      PROC_LIS.LISTE[PROC_LIS.counter].Name+')';
              STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
              STM_LISTE[STM_LISTE_counter].parameter1:=PROC_LIS.LISTE[PROC_LIS.counter].PPR_ARR[lok_PAR_Pos].Register_L;
              STM_LISTE[STM_LISTE_counter].parameter2:=PROC_LIS.LISTE[PROC_LIS.counter].RESULT.Register_L;
              Inc_STM_TAB_counter;

              STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
              STM_LISTE[STM_LISTE_counter].parameter1:=PROC_LIS.LISTE[PROC_LIS.counter].PPR_ARR[lok_PAR_Pos].Register_H;
              STM_LISTE[STM_LISTE_counter].parameter2:=PROC_LIS.LISTE[PROC_LIS.counter].RESULT.Register_H;
              Inc_STM_TAB_counter;
            end; { AT_word }

          AT_dword :
            begin
              STM_LISTE[STM_LISTE_counter].Bemerkung:='; RESULT DWord-Variable - FUNCTION ('+
                                                      PROC_LIS.LISTE[PROC_LIS.counter].Name+')';
              STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
              STM_LISTE[STM_LISTE_counter].parameter1:=
                                PROC_LIS.LISTE[PROC_LIS.counter].PPR_ARR[lok_PAR_Pos].Register_L;
              STM_LISTE[STM_LISTE_counter].parameter2:=
                                PROC_LIS.LISTE[PROC_LIS.counter].RESULT.Register_L;
              Inc_STM_TAB_counter;

              STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
              STM_LISTE[STM_LISTE_counter].parameter1:=
                                PROC_LIS.LISTE[PROC_LIS.counter].PPR_ARR[lok_PAR_Pos].Register_H;
              STM_LISTE[STM_LISTE_counter].parameter2:=
                                PROC_LIS.LISTE[PROC_LIS.counter].RESULT.Register_H;
              Inc_STM_TAB_counter;

              STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
              STM_LISTE[STM_LISTE_counter].parameter1:=
                                PROC_LIS.LISTE[PROC_LIS.counter].PPR_ARR[lok_PAR_Pos].Register_LH;
              STM_LISTE[STM_LISTE_counter].parameter2:=
                                PROC_LIS.LISTE[PROC_LIS.counter].RESULT.Register_LH;
              Inc_STM_TAB_counter;

              STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
              STM_LISTE[STM_LISTE_counter].parameter1:=
                                PROC_LIS.LISTE[PROC_LIS.counter].PPR_ARR[lok_PAR_Pos].Register_HH;
              STM_LISTE[STM_LISTE_counter].parameter2:=
                                PROC_LIS.LISTE[PROC_LIS.counter].RESULT.Register_HH;
              Inc_STM_TAB_counter;

            end; { AT_dword }



          AT_currency :
            begin
              STM_LISTE[STM_LISTE_counter].Bemerkung:='; RESULT Currency-Variable - FUNCTION ('+
                                                      PROC_LIS.LISTE[PROC_LIS.counter].Name+')';

              STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
              STM_LISTE[STM_LISTE_counter].parameter1:=
                                PROC_LIS.LISTE[PROC_LIS.counter].PPR_ARR[lok_PAR_Pos].Register_L;
              STM_LISTE[STM_LISTE_counter].parameter2:=
                                PROC_LIS.LISTE[PROC_LIS.counter].RESULT.Register_L;
              Inc_STM_TAB_counter;

              STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
              STM_LISTE[STM_LISTE_counter].parameter1:=
                                PROC_LIS.LISTE[PROC_LIS.counter].PPR_ARR[lok_PAR_Pos].Register_H;
              STM_LISTE[STM_LISTE_counter].parameter2:=
                                PROC_LIS.LISTE[PROC_LIS.counter].RESULT.Register_H;
              Inc_STM_TAB_counter;

              STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
              STM_LISTE[STM_LISTE_counter].parameter1:=
                                PROC_LIS.LISTE[PROC_LIS.counter].PPR_ARR[lok_PAR_Pos].Register_LH;
              STM_LISTE[STM_LISTE_counter].parameter2:=
                                PROC_LIS.LISTE[PROC_LIS.counter].RESULT.Register_LH;
              Inc_STM_TAB_counter;

              STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
              STM_LISTE[STM_LISTE_counter].parameter1:=
                                PROC_LIS.LISTE[PROC_LIS.counter].PPR_ARR[lok_PAR_Pos].Register_HH;
              STM_LISTE[STM_LISTE_counter].parameter2:=
                                PROC_LIS.LISTE[PROC_LIS.counter].RESULT.Register_HH;
              Inc_STM_TAB_counter;


              STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
              STM_LISTE[STM_LISTE_counter].parameter1:=
                                PROC_LIS.LISTE[PROC_LIS.counter].PPR_ARR[lok_PAR_Pos].Register_LLH;
              STM_LISTE[STM_LISTE_counter].parameter2:=
                                PROC_LIS.LISTE[PROC_LIS.counter].RESULT.Register_LLH;
              Inc_STM_TAB_counter;

              STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
              STM_LISTE[STM_LISTE_counter].parameter1:=
                                PROC_LIS.LISTE[PROC_LIS.counter].PPR_ARR[lok_PAR_Pos].Register_LHH;
              STM_LISTE[STM_LISTE_counter].parameter2:=
                                PROC_LIS.LISTE[PROC_LIS.counter].RESULT.Register_LHH;
              Inc_STM_TAB_counter;

              STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
              STM_LISTE[STM_LISTE_counter].parameter1:=
                                PROC_LIS.LISTE[PROC_LIS.counter].PPR_ARR[lok_PAR_Pos].Register_HLH;
              STM_LISTE[STM_LISTE_counter].parameter2:=
                                PROC_LIS.LISTE[PROC_LIS.counter].RESULT.Register_HLH;
              Inc_STM_TAB_counter;

              STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
              STM_LISTE[STM_LISTE_counter].parameter1:=
                                PROC_LIS.LISTE[PROC_LIS.counter].PPR_ARR[lok_PAR_Pos].Register_HHH;
              STM_LISTE[STM_LISTE_counter].parameter2:=
                                PROC_LIS.LISTE[PROC_LIS.counter].RESULT.Register_HHH;
              Inc_STM_TAB_counter;


            end; { AT_currency }


        else
          Fehler_cl.Registrieren('ZwischenCode/FUNCTION_result_var_const_eintragen', 'Der Typ '+
                                 Compiler_cl.ASM_type_Typ_in_Bezeichner(FRV_type)+
                                 ' des RESULT-Wertes wird nicht unterstuetzt',
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

        end; { case FRV_type of }

      end; { 'L','D' }



      'C' :  begin

               Wert:=CONST_NAME_TO_WERT(R_VAR);

        case FRV_type of

          AT_boolean, AT_byte, AT_char :
            begin
              STM_LISTE[STM_LISTE_counter].Bemerkung:='; RESULT Byte-CONST - FUNCTION ('+
                                                      PROC_LIS.LISTE[PROC_LIS.counter].Name+')';

              STM_LISTE[STM_LISTE_counter].statement:=STM_LDI;
              STM_LISTE[STM_LISTE_counter].parameter1:=R_VAR;
              STM_LISTE[STM_LISTE_counter].parameter2:='R16';
              Inc_STM_TAB_counter;

              STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
              STM_LISTE[STM_LISTE_counter].parameter1:='R16';
              STM_LISTE[STM_LISTE_counter].parameter2:=PROC_LIS.LISTE[PROC_LIS.counter].RESULT.Register_L;
              Inc_STM_TAB_counter;

            end; { AT_boolean, AT_byte, AT_char }

          AT_word :
            begin
              STM_LISTE[STM_LISTE_counter].Bemerkung:='; RESULT Word-CONST - FUNCTION ('+
                                                      PROC_LIS.LISTE[PROC_LIS.counter].Name+')';

              STM_LISTE[STM_LISTE_counter].statement:=STM_LDI_word_L;
              STM_LISTE[STM_LISTE_counter].parameter1:=R_VAR;
              STM_LISTE[STM_LISTE_counter].parameter2:='R16';
              Inc_STM_TAB_counter;

              STM_LISTE[STM_LISTE_counter].statement:=STM_LDI_word_H;
              STM_LISTE[STM_LISTE_counter].parameter1:=R_VAR;
              STM_LISTE[STM_LISTE_counter].parameter2:='R17';
              Inc_STM_TAB_counter;

              STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
              STM_LISTE[STM_LISTE_counter].parameter1:='R16';
              STM_LISTE[STM_LISTE_counter].parameter2:=PROC_LIS.LISTE[PROC_LIS.counter].RESULT.Register_L;
              Inc_STM_TAB_counter;

              STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
              STM_LISTE[STM_LISTE_counter].parameter1:='R17';
              STM_LISTE[STM_LISTE_counter].parameter2:=PROC_LIS.LISTE[PROC_LIS.counter].RESULT.Register_H;
              Inc_STM_TAB_counter;

            end; { AT_word }


          AT_dword :
            begin
              STM_LISTE[STM_LISTE_counter].Bemerkung:='; RESULT DWord-CONST - FUNCTION ('+
                                                      PROC_LIS.LISTE[PROC_LIS.counter].Name+')';

              ByteWert:='0x'+Copy(Wert,7,2);
              STM_LISTE[STM_LISTE_counter].statement:=STM_LDI;
              STM_LISTE[STM_LISTE_counter].parameter1:=ByteWert;
              STM_LISTE[STM_LISTE_counter].parameter2:='R16';
              Inc_STM_TAB_counter;

              ByteWert:='0x'+Copy(Wert,5,2);
              STM_LISTE[STM_LISTE_counter].statement:=STM_LDI;
              STM_LISTE[STM_LISTE_counter].parameter1:=ByteWert;
              STM_LISTE[STM_LISTE_counter].parameter2:='R17';
              Inc_STM_TAB_counter;

              ByteWert:='0x'+Copy(Wert,3,2);
              STM_LISTE[STM_LISTE_counter].statement:=STM_LDI;
              STM_LISTE[STM_LISTE_counter].parameter1:=ByteWert;
              STM_LISTE[STM_LISTE_counter].parameter2:='R18';
              Inc_STM_TAB_counter;

              ByteWert:='0x'+Copy(Wert,1,2);
              STM_LISTE[STM_LISTE_counter].statement:=STM_LDI;
              STM_LISTE[STM_LISTE_counter].parameter1:=ByteWert;
              STM_LISTE[STM_LISTE_counter].parameter2:='R19';
              Inc_STM_TAB_counter;

              STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
              STM_LISTE[STM_LISTE_counter].parameter1:='R16';
              STM_LISTE[STM_LISTE_counter].parameter2:=PROC_LIS.LISTE[PROC_LIS.counter].RESULT.Register_L;
              Inc_STM_TAB_counter;

              STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
              STM_LISTE[STM_LISTE_counter].parameter1:='R17';
              STM_LISTE[STM_LISTE_counter].parameter2:=PROC_LIS.LISTE[PROC_LIS.counter].RESULT.Register_H;
              Inc_STM_TAB_counter;

              STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
              STM_LISTE[STM_LISTE_counter].parameter1:='R18';
              STM_LISTE[STM_LISTE_counter].parameter2:=PROC_LIS.LISTE[PROC_LIS.counter].RESULT.Register_LH;
              Inc_STM_TAB_counter;

              STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
              STM_LISTE[STM_LISTE_counter].parameter1:='R19';
              STM_LISTE[STM_LISTE_counter].parameter2:=PROC_LIS.LISTE[PROC_LIS.counter].RESULT.Register_HH;
              Inc_STM_TAB_counter;

            end; { AT_dword }




          AT_currency :
            begin
              STM_LISTE[STM_LISTE_counter].Bemerkung:='; RESULT Currency-CONST - FUNCTION ('+
                                                      PROC_LIS.LISTE[PROC_LIS.counter].Name+')';

              QWord_Wert:=StrToInt(Wert);

              HexWert:=IntToHex(QWord_Wert,16);

              ByteWert:='0x'+Copy(HexWert,15,2);
              STM_LISTE[STM_LISTE_counter].statement:=STM_LDI;
              STM_LISTE[STM_LISTE_counter].parameter1:=ByteWert;
              STM_LISTE[STM_LISTE_counter].parameter2:='R16';
              Inc_STM_TAB_counter;

              ByteWert:='0x'+Copy(HexWert,13,2);
              STM_LISTE[STM_LISTE_counter].statement:=STM_LDI;
              STM_LISTE[STM_LISTE_counter].parameter1:=ByteWert;
              STM_LISTE[STM_LISTE_counter].parameter2:='R17';
              Inc_STM_TAB_counter;

              ByteWert:='0x'+Copy(HexWert,11,2);
              STM_LISTE[STM_LISTE_counter].statement:=STM_LDI;
              STM_LISTE[STM_LISTE_counter].parameter1:=ByteWert;
              STM_LISTE[STM_LISTE_counter].parameter2:='R18';
              Inc_STM_TAB_counter;

              ByteWert:='0x'+Copy(HexWert,9,2);
              STM_LISTE[STM_LISTE_counter].statement:=STM_LDI;
              STM_LISTE[STM_LISTE_counter].parameter1:=ByteWert;
              STM_LISTE[STM_LISTE_counter].parameter2:='R19';
              Inc_STM_TAB_counter;

              ByteWert:='0x'+Copy(HexWert,7,2);
              STM_LISTE[STM_LISTE_counter].statement:=STM_LDI;
              STM_LISTE[STM_LISTE_counter].parameter1:=ByteWert;
              STM_LISTE[STM_LISTE_counter].parameter2:='R20';
              Inc_STM_TAB_counter;

              ByteWert:='0x'+Copy(HexWert,5,2);
              STM_LISTE[STM_LISTE_counter].statement:=STM_LDI;
              STM_LISTE[STM_LISTE_counter].parameter1:=ByteWert;
              STM_LISTE[STM_LISTE_counter].parameter2:='R21';
              Inc_STM_TAB_counter;

              ByteWert:='0x'+Copy(HexWert,3,2);
              STM_LISTE[STM_LISTE_counter].statement:=STM_LDI;
              STM_LISTE[STM_LISTE_counter].parameter1:=ByteWert;
              STM_LISTE[STM_LISTE_counter].parameter2:='R22';
              Inc_STM_TAB_counter;

              ByteWert:='0x'+Copy(HexWert,1,2);
              STM_LISTE[STM_LISTE_counter].statement:=STM_LDI;
              STM_LISTE[STM_LISTE_counter].parameter1:=ByteWert;
              STM_LISTE[STM_LISTE_counter].parameter2:='R23';
              Inc_STM_TAB_counter;


              STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
              STM_LISTE[STM_LISTE_counter].parameter1:='R16';
              STM_LISTE[STM_LISTE_counter].parameter2:=PROC_LIS.LISTE[PROC_LIS.counter].RESULT.Register_L;
              Inc_STM_TAB_counter;

              STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
              STM_LISTE[STM_LISTE_counter].parameter1:='R17';
              STM_LISTE[STM_LISTE_counter].parameter2:=PROC_LIS.LISTE[PROC_LIS.counter].RESULT.Register_H;
              Inc_STM_TAB_counter;

              STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
              STM_LISTE[STM_LISTE_counter].parameter1:='R18';
              STM_LISTE[STM_LISTE_counter].parameter2:=PROC_LIS.LISTE[PROC_LIS.counter].RESULT.Register_LH;
              Inc_STM_TAB_counter;

              STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
              STM_LISTE[STM_LISTE_counter].parameter1:='R19';
              STM_LISTE[STM_LISTE_counter].parameter2:=PROC_LIS.LISTE[PROC_LIS.counter].RESULT.Register_HH;
              Inc_STM_TAB_counter;


              STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
              STM_LISTE[STM_LISTE_counter].parameter1:='R20';
              STM_LISTE[STM_LISTE_counter].parameter2:=PROC_LIS.LISTE[PROC_LIS.counter].RESULT.Register_LLH;
              Inc_STM_TAB_counter;

              STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
              STM_LISTE[STM_LISTE_counter].parameter1:='R21';
              STM_LISTE[STM_LISTE_counter].parameter2:=PROC_LIS.LISTE[PROC_LIS.counter].RESULT.Register_LHH;
              Inc_STM_TAB_counter;

              STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
              STM_LISTE[STM_LISTE_counter].parameter1:='R22';
              STM_LISTE[STM_LISTE_counter].parameter2:=PROC_LIS.LISTE[PROC_LIS.counter].RESULT.Register_HLH;
              Inc_STM_TAB_counter;

              STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
              STM_LISTE[STM_LISTE_counter].parameter1:='R23';
              STM_LISTE[STM_LISTE_counter].parameter2:=PROC_LIS.LISTE[PROC_LIS.counter].RESULT.Register_HHH;
              Inc_STM_TAB_counter;

            end; { AT_currency }


        else
          Fehler_cl.Registrieren('ZwischenCode/FUNCTION_result_var_const_eintragen', 'Der Typ '+
                                 Compiler_cl.ASM_type_Typ_in_Bezeichner(FRV_type)+
                                 ' des RETURN-Wertes wird nicht unterstuetzt',
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

        end; { case FRV_type of }

      end; { 'C' }



    else
      Fehler_cl.Registrieren('ZwischenCode/FUNCTION_result_var_const_eintragen',
                            'Zieltyp ('+TYPE_IN_TYPENAME(
                                 ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_type)+') ungleich Quelltyp ('+
                            TYPE_IN_TYPENAME(FRV_type),
                            Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                            Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                            Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

    end; { case FRV_ANW_Type of }


    end; { if FRV_type=PROC_LIS.LISTE[PROC_LIS.counter].Return.ASM_type then }

  end; { if ZQV_type<>AT_kein_typ then }


  end; { if NAME_TO_ANW_und_ASM(R_VAR,FRV_ANW_Type,FRV_type) then }


  Result:=FRV_erfolgreich;
end; { function ZWC_class.FUNCTION_result_var_const_eintragen }





function ZWC_class.FUNCTION_beenden : Boolean;
var
  FEN_erfolgreich : Boolean;

begin
  FEN_erfolgreich:=false;
  if PROC_LIS.LISTE[PROC_LIS.counter].RESULT_vorhanden then begin
    FEN_erfolgreich:=true;


      case PROC_LIS.LISTE[PROC_LIS.counter].RESULT.ASM_type of

        AT_boolean, AT_byte, AT_char :
          begin
            STM_LISTE[STM_LISTE_counter].Bemerkung:='; Ende Byte - FUNCTION ('+
                                                 PROC_LIS.LISTE[PROC_LIS.counter].Name+')';
            STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
             STM_LISTE[STM_LISTE_counter].parameter1:=PROC_LIS.LISTE[PROC_LIS.counter].RESULT.Register_L;
             STM_LISTE[STM_LISTE_counter].parameter2:='R16';
            Inc_STM_TAB_counter;
          end; { AT_boolean, AT_byte, AT_char }

        AT_word :
          begin
            STM_LISTE[STM_LISTE_counter].Bemerkung:='; Ende Word - FUNCTION ('+
                                               PROC_LIS.LISTE[PROC_LIS.counter].Name+')';
            STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
            STM_LISTE[STM_LISTE_counter].parameter1:=PROC_LIS.LISTE[PROC_LIS.counter].RESULT.Register_L;
            STM_LISTE[STM_LISTE_counter].parameter2:='R16';
            Inc_STM_TAB_counter;
            STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
            STM_LISTE[STM_LISTE_counter].parameter1:=PROC_LIS.LISTE[PROC_LIS.counter].RESULT.Register_H;
            STM_LISTE[STM_LISTE_counter].parameter2:='R17';
            Inc_STM_TAB_counter;
          end; { AT_word }


        AT_dword :
          begin

            STM_LISTE[STM_LISTE_counter].Bemerkung:='; Ende DWord - FUNCTION ('+
                                               PROC_LIS.LISTE[PROC_LIS.counter].Name+')';
            STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
            STM_LISTE[STM_LISTE_counter].parameter1:=PROC_LIS.LISTE[PROC_LIS.counter].RESULT.Register_L;
            STM_LISTE[STM_LISTE_counter].parameter2:='R16';
            Inc_STM_TAB_counter;
            STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
            STM_LISTE[STM_LISTE_counter].parameter1:=PROC_LIS.LISTE[PROC_LIS.counter].RESULT.Register_H;
            STM_LISTE[STM_LISTE_counter].parameter2:='R17';
            Inc_STM_TAB_counter;
            STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
            STM_LISTE[STM_LISTE_counter].parameter1:=PROC_LIS.LISTE[PROC_LIS.counter].RESULT.Register_LH;
            STM_LISTE[STM_LISTE_counter].parameter2:='R18';
            Inc_STM_TAB_counter;
            STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
            STM_LISTE[STM_LISTE_counter].parameter1:=PROC_LIS.LISTE[PROC_LIS.counter].RESULT.Register_HH;
            STM_LISTE[STM_LISTE_counter].parameter2:='R19';
            Inc_STM_TAB_counter;

          end; { AT_dword }



        AT_currency :
          begin

            STM_LISTE[STM_LISTE_counter].Bemerkung:='; Ende Currency - FUNCTION ('+
                                               PROC_LIS.LISTE[PROC_LIS.counter].Name+')';

            STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
            STM_LISTE[STM_LISTE_counter].parameter1:=PROC_LIS.LISTE[PROC_LIS.counter].RESULT.Register_L;
            STM_LISTE[STM_LISTE_counter].parameter2:='R16';
            Inc_STM_TAB_counter;
            STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
            STM_LISTE[STM_LISTE_counter].parameter1:=PROC_LIS.LISTE[PROC_LIS.counter].RESULT.Register_H;
            STM_LISTE[STM_LISTE_counter].parameter2:='R17';
            Inc_STM_TAB_counter;
            STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
            STM_LISTE[STM_LISTE_counter].parameter1:=PROC_LIS.LISTE[PROC_LIS.counter].RESULT.Register_LH;
            STM_LISTE[STM_LISTE_counter].parameter2:='R18';
            Inc_STM_TAB_counter;
            STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
            STM_LISTE[STM_LISTE_counter].parameter1:=PROC_LIS.LISTE[PROC_LIS.counter].RESULT.Register_HH;
            STM_LISTE[STM_LISTE_counter].parameter2:='R19';
            Inc_STM_TAB_counter;


            STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
            STM_LISTE[STM_LISTE_counter].parameter1:=PROC_LIS.LISTE[PROC_LIS.counter].RESULT.Register_LLH;
            STM_LISTE[STM_LISTE_counter].parameter2:='R20';
            Inc_STM_TAB_counter;
            STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
            STM_LISTE[STM_LISTE_counter].parameter1:=PROC_LIS.LISTE[PROC_LIS.counter].RESULT.Register_LHH;
            STM_LISTE[STM_LISTE_counter].parameter2:='R21';
            Inc_STM_TAB_counter;
            STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
            STM_LISTE[STM_LISTE_counter].parameter1:=PROC_LIS.LISTE[PROC_LIS.counter].RESULT.Register_HLH;
            STM_LISTE[STM_LISTE_counter].parameter2:='R22';
            Inc_STM_TAB_counter;
            STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
            STM_LISTE[STM_LISTE_counter].parameter1:=PROC_LIS.LISTE[PROC_LIS.counter].RESULT.Register_HHH;
            STM_LISTE[STM_LISTE_counter].parameter2:='R23';
            Inc_STM_TAB_counter;


          end; { AT_currency }



      else
        Fehler_cl.Registrieren('ZwischenCode/FUNCTION_beenden', 'Der Typ '+
                Compiler_cl.ASM_type_Typ_in_Bezeichner(PROC_LIS.LISTE[PROC_LIS.counter].RESULT.ASM_type)+
                               ' des RESULT-Wertes wird nicht unterstuetzt',
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

      end; { case FRV_type of }


  end
  else
    Fehler_cl.Registrieren('ZwischenCode/FUNCTION_beenden',
                            'RESULT-Wert nicht angegeben',
                            Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                            Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                            Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

  Result:=FEN_erfolgreich;
end; { function ZWC_class.FUNCTION_beenden }


