{ ZWC_Start }


// ********************************************
//             Start des Zwischencodes
// ********************************************





procedure ZWC_class.Start_ZWC;
var
  ASM_Zeile, UP_DateiName, STR_Wert1, STR_Wert2, STR_Wert3 : String;
  VT_Zaehler, VX_Zaehler, ASM_Zaehler : Integer;
  erster_Wert, KopierSchalter : Boolean;
  ASM_UP_Datei, ASM_UP_Liste : TStringList;
  CONST_currency : Int64;
  VAR_Offset : Word;



  procedure ASM_UP_wird_benoetigt(ASM_UP : String);
  var
    UP_Index : Integer;
  begin
    if not ASM_UP_Liste.Find(ASM_UP,UP_Index) then begin
      ASM_UP_Liste.Add(ASM_UP);
    end; { if ASM_UP_Liste.Find(ASM_UP,UP_Index) then }

  end; { procedure ASM_UP_wird_benoetigt }





  procedure UP_Interrupttabelle;
  var
    i_zaehler : Integer;
    ORG_Name, ISR_Name, Bemerkung : String;
  begin

    for i_zaehler:=1 to ISR_LISTE.max_anzahl do begin
      if ISR_LISTE.LISTE[i_zaehler].enable then begin
        ORG_Name:=ISR_LISTE.LISTE[i_zaehler].ORG_Name;
        ISR_Name:=ISR_LISTE.LISTE[i_zaehler].ISR_Name;
        Bemerkung:=ISR_LISTE.LISTE[i_zaehler].Bemerkung;

        ASM_Datei.Add(' ');
        ASM_Zeile:='; '+Bemerkung;
        ASM_Datei.Add(ASM_Zeile);

        ASM_Zeile:='.ORG '+ORG_Name;
        ASM_Datei.Add(ASM_Zeile);

        case ASM_Switch.JMP_Sprungdistanz of
          JMP_Relativ : ASM_Zeile:='        RJMP       '+ISR_Name;
          JMP_Word    : ASM_Zeile:='        JMP        '+ISR_Name;
          JMP_als_EIJMP : begin
                            ASM_Zeile:='        LDI   ZL,byte3('+ISR_Name+')';
                            ASM_Datei.Add(ASM_Zeile);
                            ASM_Zeile:='        OUT   EIND,ZL';
                            ASM_Datei.Add(ASM_Zeile);
                            ASM_Zeile:='        LDI   ZL,low('+ISR_Name+')';
                            ASM_Datei.Add(ASM_Zeile);
                            ASM_Zeile:='        LDI   ZH,high('+ISR_Name+')';
                            ASM_Datei.Add(ASM_Zeile);
                            ASM_Zeile:='        EIJMP';
                          end; { JMP_als_EIJMP }

        else
          Fehler_cl.Registrieren('ZWC_Start/Start_ZWC',
                           'JMP_Sprungdistanz nicht definiert',
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);
        end; { case JMP_Sprungdistanz of }

        ASM_Datei.Add(ASM_Zeile);

      end { if ISR_LISTE.LISTE[i_zaehler].enable then }

    end; { for i_zaehler:=1 to ISR_LISTE.max_anzahl do }
  end; { procedure UP_Interrupttabelle }




begin
  ASM_Datei.Clear;
  ASM_UP_Liste := TStringList.Create;
  ASM_UP_Liste.Sorted:=true;

  { - Ausgabe des Assemblerkopfes - }
  ASM_Zeile:='; Assemblerquelltext des RONPAS-Compilers (c) by Ronald Daleske';
  ASM_Datei.Add(ASM_Zeile);
  ASM_Zeile:='; PROGRAM-NAME: '+Program_Name+'.PAS';
  ASM_Datei.Add(ASM_Zeile);
  ASM_Datei.Add(' ');
  ASM_Zeile:='.nolist';
  ASM_Datei.Add(ASM_Zeile);

  ASM_Zeile:=ASM_Include_Datei;

  ASM_Datei.Add(ASM_Zeile);
  ASM_Zeile:='.list';
  ASM_Datei.Add(ASM_Zeile);
  ASM_Datei.Add(' ');


  { - Ausgabe der Konstantentabelle - }
  erster_Wert:=true;

  for VT_Zaehler:=1 to NAME_TAB_counter-1 do begin

    if NAME_TAB[VT_Zaehler].ANW_type='C' then begin

      if erster_Wert then begin
        ASM_Datei.Add('; *** Konstantentabelle ***');
        ASM_Datei.Add(' ');
        erster_Wert:=false;
      end;

      case NAME_TAB[VT_Zaehler].ASM_type of

        AT_dword :
          begin
            ASM_Zeile:='.equ        '+NAME_TAB[VT_Zaehler].bezeichner+'  =  0x'+NAME_TAB[VT_Zaehler].wert+
                   ' ; '+TYPE_IN_TYPENAME(NAME_TAB[VT_Zaehler].ASM_type);
          end; { AT_dword }

        AT_currency :
          begin
            CONST_currency:=StrToInt(NAME_TAB[VT_Zaehler].wert);
            ASM_Zeile:=IntToHex(CONST_currency,16);
            ASM_Zeile:='.equ        '+NAME_TAB[VT_Zaehler].bezeichner+'  =  0x'+ASM_Zeile+
                   ' ; '+TYPE_IN_TYPENAME(NAME_TAB[VT_Zaehler].ASM_type);
          end; { AT_currency }

      else

        ASM_Zeile:='.equ        '+NAME_TAB[VT_Zaehler].bezeichner+'  =  '+NAME_TAB[VT_Zaehler].wert+
                   ' ; '+TYPE_IN_TYPENAME(NAME_TAB[VT_Zaehler].ASM_type);

      end; { case NAME_TAB[VT_Zaehler].ASM_type of }


      ASM_Datei.Add(ASM_Zeile);
    end; { if NAME_TAB[VT_Zaehler].ANW_type='C' then }

  end; { for VT_Zaehler:=1 to NAME_TAB_counter-1 do }


  if not erster_Wert then
    ASM_Datei.Add(' ');


  { - Ausgabe der Variablentabelle - }
  erster_Wert:=true;

  VAR_Offset:=0;

  if Form_Debugger.Debugger_aktiv then begin
    Form_Debugger.loesche_ASM_VAR_Liste;
  end;

  for VT_Zaehler:=1 to NAME_TAB_counter-1 do begin

    if (NAME_TAB[VT_Zaehler].ANW_type='V') and
         (not (NAME_TAB[VT_Zaehler].ASM_type IN
           [AT_byte_con_reg, AT_word_con_reg, AT_byte_con_var, AT_word_con_var])) then begin

      if erster_Wert then begin
        ASM_Datei.Add('; *** Variablentabelle ***');
        ASM_Datei.Add(' ');
        ASM_Zeile:='.dseg';
        ASM_Datei.Add(ASM_Zeile);
        ASM_Datei.Add(' ');


        // fuer Debugger
        ASM_Datei.Add('DBG_ANFANG_VAR_TABELLE:');
        ASM_Datei.Add(' ');


        erster_Wert:=false;
      end; { if erster_Wert then }

      ASM_Zeile:=NAME_TAB[VT_Zaehler].bezeichner+':';

      case NAME_TAB[VT_Zaehler].ASM_type of
        AT_boolean  : ASM_Zeile:=ASM_Zeile+'   ; Boolean';
        AT_byte     : ASM_Zeile:=ASM_Zeile+'   ; Byte';
        AT_char     : ASM_Zeile:=ASM_Zeile+'   ; Char';
        AT_word     : ASM_Zeile:=ASM_Zeile+'   ; Word';
        AT_dword    : ASM_Zeile:=ASM_Zeile+'   ; DWord';
        AT_currency : ASM_Zeile:=ASM_Zeile+'   ; Currency';
        AT_string   : ASM_Zeile:=ASM_Zeile+'   ; String('+IntToStr(NAME_TAB[VT_Zaehler].Laenge)+')';
      else
        Fehler_cl.Registrieren('ZwischenCode/Start_ZWC','kein Typ zur Variable <'+
                               NAME_TAB[VT_Zaehler].bezeichner+'>',
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

      end; { case NAME_TAB[VT_Zaehler].ASM_type of }
      ASM_Datei.Add(ASM_Zeile);

      case NAME_TAB[VT_Zaehler].ASM_type of
        AT_boolean, AT_byte, AT_char :
          begin
            ASM_Zeile:='.byte     1';
            ASM_Datei.Add(ASM_Zeile);
          end;
        AT_word :
          begin
            ASM_Zeile:='.byte     2';
            ASM_Datei.Add(ASM_Zeile);
          end;
        AT_dword :
          begin
            ASM_Zeile:='.byte     4';
            ASM_Datei.Add(ASM_Zeile);
          end;
        AT_currency :
          begin
            ASM_Zeile:='.byte     8';
            ASM_Datei.Add(ASM_Zeile);
          end;
        AT_string :
          begin
            ASM_Zeile:='.byte     1     ; STRING-Laenge';
            ASM_Datei.Add(ASM_Zeile);
            ASM_Zeile:='.byte     '+IntToStr(NAME_TAB[VT_Zaehler].Laenge);
            ASM_Datei.Add(ASM_Zeile);
          end
      else
        Fehler_cl.Registrieren('ZwischenCode/Start_ZWC','kein Typ zur Variable <'+
                               NAME_TAB[VT_Zaehler].bezeichner+'>',
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

      end; { case NAME_TAB[VT_Zaehler].ASM_type of }








      // Debugger
      if Form_Debugger.Debugger_aktiv then begin

        Form_Debugger.registriere_ASM_VAR(NAME_TAB[VT_Zaehler].Bezeichner,
                                          NAME_TAB[VT_Zaehler].ASM_type,
                                          NAME_TAB[VT_Zaehler].Laenge,
                                          VAR_Offset);



        case NAME_TAB[VT_Zaehler].ASM_type of
          AT_boolean, AT_byte, AT_char : VAR_Offset:=VAR_Offset+1;
          AT_word                      : VAR_Offset:=VAR_Offset+2;
          AT_dword                     : VAR_Offset:=VAR_Offset+4;
          AT_currency                  : VAR_Offset:=VAR_Offset+8;
          AT_string                    : VAR_Offset:=VAR_Offset+1+
                                                     NAME_TAB[VT_Zaehler].Laenge;

        end; { case NAME_TAB[VT_Zaehler].ASM_type of }

      end; { if Form_Debugger.Debugger_aktiv then }











    end; { if NAME_TAB[VT_Zaehler].ANW_type='V' then }

  end; { for VT_Zaehler:=1 to NAME_TAB_counter-1 do }


  if not erster_Wert then
    ASM_Datei.Add(' ');


  { - Ausgabe der ARRAY-Tabelle - }
  if VAR_ARRAY.counter>0 then begin


    if erster_Wert then begin
      ASM_Datei.Add('; *** Variablentabelle ***');
      ASM_Datei.Add(' ');
      ASM_Zeile:='.dseg';
      ASM_Datei.Add(ASM_Zeile);
      ASM_Datei.Add(' ');
      erster_Wert:=false;
    end; { if erster_Wert then }



    for VT_Zaehler:=1 to VAR_ARRAY.counter do begin

      ASM_Zeile:=VAR_ARRAY.LISTE[VT_Zaehler].Bezeichner+':';
      ASM_Datei.Add(ASM_Zeile);


      if VAR_ARRAY.LISTE[VT_Zaehler].Array_ist_1d then begin


        case VAR_ARRAY.LISTE[VT_Zaehler].ASM_type of

          AT_boolean, AT_byte, AT_char :
            ASM_Zeile:='.byte     '+IntToStr(VAR_ARRAY.LISTE[VT_Zaehler].Laenge_1d);

          AT_word :
            ASM_Zeile:='.byte     '+IntToStr(VAR_ARRAY.LISTE[VT_Zaehler].Laenge_1d*2);

          AT_dword :
            ASM_Zeile:='.byte     '+IntToStr(VAR_ARRAY.LISTE[VT_Zaehler].Laenge_1d*4);

        else
          Fehler_cl.Registrieren('ZwischenCode/Start_ZWC','kein Typ zur Variable <'+
                                 NAME_TAB[VT_Zaehler].bezeichner+'>',
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

        end; { case VAR_ARRAY.LISTE[VT_Zaehler].ASM_type of }

      end
      else begin



        case VAR_ARRAY.LISTE[VT_Zaehler].ASM_type of

          AT_boolean, AT_byte, AT_char :
            ASM_Zeile:='.byte     '+IntToStr(VAR_ARRAY.LISTE[VT_Zaehler].Laenge_1d*
                                             VAR_ARRAY.LISTE[VT_Zaehler].Laenge_2d);

          AT_word :
            ASM_Zeile:='.byte     '+IntToStr(VAR_ARRAY.LISTE[VT_Zaehler].Laenge_1d*
                                             VAR_ARRAY.LISTE[VT_Zaehler].Laenge_2d*2);

          AT_dword :
            ASM_Zeile:='.byte     '+IntToStr(VAR_ARRAY.LISTE[VT_Zaehler].Laenge_1d*
                                             VAR_ARRAY.LISTE[VT_Zaehler].Laenge_2d*4);

        else
          Fehler_cl.Registrieren('ZwischenCode/Start_ZWC','kein Typ zur Variable <'+
                                 NAME_TAB[VT_Zaehler].bezeichner+'>',
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

        end; { case VAR_ARRAY.LISTE[VT_Zaehler].ASM_type of }

      end;

      ASM_Datei.Add(ASM_Zeile);

    end; { for VT_Zaehler:=1 to VAR_ARRAY.counter do }

    ASM_Datei.Add(' ');

  end; { if VAR_ARRAY.counter>0 then }



  // Debugger
  if Form_Debugger.Debugger_aktiv then begin

    Form_Debugger.lade_checked_Liste;

  end; { if Form_Debugger.Debugger_aktiv then }


  if not erster_Wert then
    ASM_Datei.Add(' ');





  { - Eintragen der Maschinen-Befehle - }
  if STM_LISTE_counter>1 then begin

    // Statement-Schleife
    for VT_Zaehler:=1 to STM_LISTE_counter-1 do begin


      if STM_LISTE[VT_Zaehler].Bemerkung>'' then begin
        ASM_Datei.Add(' ');
        ASM_Datei.Add(STM_LISTE[VT_Zaehler].Bemerkung);
      end; { if STM_LISTE[VT_Zaehler].Bemerkung>'' then }


      case STM_LISTE[VT_Zaehler].statement of


        // Codesegment
        STM_Codesegment :
          begin
            ASM_Zeile:='.cseg';
            ASM_Datei.Add(ASM_Zeile);
          end;



        // Sprungtabelle
        STM_Sprungtabelle :
          begin
            ASM_Zeile:='.ORG 0';
            ASM_Datei.Add(ASM_Zeile);
          end;



        // Interrupttabelle
        STM_Interrupttabelle :
          begin
            if ISR_LISTE.enable then
              UP_Interrupttabelle;
          end;



        // ORG
        STM_ORG :
          begin
            ASM_Zeile:='.ORG '+STM_LISTE[VT_Zaehler].parameter1;
            ASM_Datei.Add(ASM_Zeile);
          end;



        // Initialisieren des Stacks
        STM_stack_init :
          begin
            ASM_Zeile:='        LDI        R16, LOW(RAMEND)';
            ASM_Datei.Add(ASM_Zeile);
            ASM_Zeile:='        OUT        SPL, R16';
            ASM_Datei.Add(ASM_Zeile);

            if ASM_Switch.use_SPH then begin

              ASM_Zeile:='        LDI        R16, HIGH(RAMEND)';
              ASM_Datei.Add(ASM_Zeile);
              ASM_Zeile:='        OUT        SPH, R16';
              ASM_Datei.Add(ASM_Zeile);

            end;

          end; { STM_stack_init }


        // Marke
        STM_sprungmarke :
          begin
            ASM_Zeile:=STM_LISTE[VT_Zaehler].parameter1+':';
            ASM_Datei.Add(ASM_Zeile);
          end;




        // BST
        STM_BST :
          begin
            ASM_Zeile:='        BST        '+STM_LISTE[VT_Zaehler].parameter2+', '+STM_LISTE[VT_Zaehler].parameter1;
            ASM_Datei.Add(ASM_Zeile);
          end;




        // AAAAAAAAAA

        // ADIW
        STM_ADIW :
          begin
            ASM_Zeile:='        ADIW       '+STM_LISTE[VT_Zaehler].parameter2+
                       ':'+STM_LISTE[VT_Zaehler].parameter1+', 1';
            ASM_Datei.Add(ASM_Zeile);
          end;



        // AND
        STM_AND :
          begin
            ASM_Zeile:='        AND        '+STM_LISTE[VT_Zaehler].parameter2+', '+
                                             STM_LISTE[VT_Zaehler].parameter1;
            ASM_Datei.Add(ASM_Zeile);
          end;



        // ASM
        STM_asm :
          begin

            STR_Wert1:=STM_LISTE[VT_Zaehler].Parameter1;
            STR_Wert2:=STM_LISTE[VT_Zaehler].Parameter2;

            KopierSchalter:=false;
            for ASM_Zaehler:=0 to Compiler_cl.SC_Source_file.Count-1 do begin
              ASM_Zeile:=Compiler_cl.SC_Source_file[ASM_Zaehler];
              STR_Wert3:=Copy(ASM_Zeile,1,7);

              if STR_Wert3=STR_Wert1 then
                KopierSchalter:=true;

              if STR_Wert3=STR_Wert2 then
                KopierSchalter:=false;

              if KopierSchalter then begin
                ASM_Zeile:=Copy(ASM_Zeile,8,Length(ASM_Zeile));
                ASM_Datei.Add(ASM_Zeile);
              end;

            end; { for ASM_Zaehler:=ZeiNr_Anfang to ZeiNr_Ende do }

            ASM_Datei.Add(' ');
          end; { STM_asm }





        // BBBBBBBBBB


        // BRCC zu Marke
        STM_BRCC_Marke :
          begin
            ASM_Zeile:='        BRCC       '+STM_LISTE[VT_Zaehler].parameter1;
            ASM_Datei.Add(ASM_Zeile);
          end;

        // BRCS zu Marke
        STM_BRCS_Marke :
          begin
            ASM_Zeile:='        BRCS       '+STM_LISTE[VT_Zaehler].parameter1;
            ASM_Datei.Add(ASM_Zeile);
          end;

        // BREQ zu Marke
        STM_BREQ_Marke :
          begin
            ASM_Zeile:='        BREQ       '+STM_LISTE[VT_Zaehler].parameter1;
            ASM_Datei.Add(ASM_Zeile);
          end;

        // BRNE zu Marke
        STM_BRNE_Marke :
          begin
            ASM_Zeile:='        BRNE       '+STM_LISTE[VT_Zaehler].parameter1;
            ASM_Datei.Add(ASM_Zeile);
          end;


        // BRTS zu Marke
        STM_BRTS_Marke :
          begin
            ASM_Zeile:='        BRTS       '+STM_LISTE[VT_Zaehler].parameter1;
            ASM_Datei.Add(ASM_Zeile);
          end;

        // BRTC zu Marke
        STM_BRTC_Marke :
          begin
            ASM_Zeile:='        BRTC       '+STM_LISTE[VT_Zaehler].parameter1;
            ASM_Datei.Add(ASM_Zeile);
          end;


        // CCCCCCCCCC



        // CALL
        STM_CALL :
          begin
            ASM_Zeile:='        CALL       '+STM_LISTE[VT_Zaehler].parameter1;
            ASM_Datei.Add(ASM_Zeile);
          end;



        // CBI
        STM_CBI :
           begin
             ASM_Zeile:='        CBI        '+STM_LISTE[VT_Zaehler].parameter2+
                               ', '+STM_LISTE[VT_Zaehler].parameter1;
             ASM_Datei.Add(ASM_Zeile);
           end;


        // CBR
        STM_CBR :
           begin
             ASM_Zeile:='        CBR        '+STM_LISTE[VT_Zaehler].parameter2+
                               ', '+STM_LISTE[VT_Zaehler].parameter1;
             ASM_Datei.Add(ASM_Zeile);
           end;


        // CLR = FALSE
        STM_CLR :
          begin
            ASM_Zeile:='        CLR        '+STM_LISTE[VT_Zaehler].parameter1;
            ASM_Datei.Add(ASM_Zeile);
          end;


        // CLI – Clear Global Interrupt Flag
        STM_CLI :
          begin
            ASM_Zeile:='        CLI';
            ASM_Datei.Add(ASM_Zeile);
          end;


        // CP
        STM_CP :
          begin
            ASM_Zeile:='        CP         '+STM_LISTE[VT_Zaehler].parameter2+', '+
                            STM_LISTE[VT_Zaehler].parameter1;
            ASM_Datei.Add(ASM_Zeile);
          end;


        // CP - TYPE
        STM_CP_byte, STM_CP_word_L :
          begin
            ASM_Zeile:='        CP         '+STM_LISTE[VT_Zaehler].parameter2+', '+
                            STM_LISTE[VT_Zaehler].parameter1;
            ASM_Datei.Add(ASM_Zeile);
          end;

        STM_CP_word_H :
          begin
            ASM_Zeile:='        CPC        '+STM_LISTE[VT_Zaehler].parameter2+
                                ', '+STM_LISTE[VT_Zaehler].parameter1;
            ASM_Datei.Add(ASM_Zeile);
          end;


        // CPC
        STM_CPC :
          begin
            ASM_Zeile:='        CPC        '+STM_LISTE[VT_Zaehler].parameter2+
                                ', '+STM_LISTE[VT_Zaehler].parameter1;
            ASM_Datei.Add(ASM_Zeile);
          end;


        // CPI
        STM_CPI :
          begin
            ASM_Zeile:='        CPI        '+STM_LISTE[VT_Zaehler].parameter2+', '+
                            STM_LISTE[VT_Zaehler].parameter1;
            ASM_Datei.Add(ASM_Zeile);
          end;



        // DDDDDDDDDD

        // DEC
        STM_DEC_byte :
           begin
             ASM_Zeile:='        DEC        '+STM_LISTE[VT_Zaehler].parameter1;
             ASM_Datei.Add(ASM_Zeile);
           end;



        STM_DEC_word :
                 begin
                   ASM_Zeile:='        LDI        R20, 1';
                   ASM_Datei.Add(ASM_Zeile);
                   ASM_Zeile:='        SUB        '+STM_LISTE[VT_Zaehler].parameter1+', R20';
                   ASM_Datei.Add(ASM_Zeile);
                   ASM_Zeile:='        CLR        R20';
                   ASM_Datei.Add(ASM_Zeile);
                   ASM_Zeile:='        SBC        '+STM_LISTE[VT_Zaehler].parameter2+', R20';
                   ASM_Datei.Add(ASM_Zeile);
                 end; { STM_dec_var_word }



        // EEEEEEEEEE


        // EICALL
        STM_EICALL :
          begin
            ASM_Zeile:='        LDI   ZL,byte3('+STM_LISTE[VT_Zaehler].parameter1+')';
            ASM_Datei.Add(ASM_Zeile);
            ASM_Zeile:='        OUT   EIND,ZL';
            ASM_Datei.Add(ASM_Zeile);
            ASM_Zeile:='        LDI   ZL,low('+STM_LISTE[VT_Zaehler].parameter1+')';
            ASM_Datei.Add(ASM_Zeile);
            ASM_Zeile:='        LDI   ZH,high('+STM_LISTE[VT_Zaehler].parameter1+')';
            ASM_Datei.Add(ASM_Zeile);
            ASM_Zeile:='        EICALL';
            ASM_Datei.Add(ASM_Zeile);
          end;


        // EIJMP zu Marke
        STM_EIJMP_Marke :
          begin
            ASM_Zeile:='        LDI   ZL,byte3('+STM_LISTE[VT_Zaehler].parameter1+')';
            ASM_Datei.Add(ASM_Zeile);
            ASM_Zeile:='        OUT   EIND,ZL';
            ASM_Datei.Add(ASM_Zeile);
            ASM_Zeile:='        LDI   ZL,low('+STM_LISTE[VT_Zaehler].parameter1+')';
            ASM_Datei.Add(ASM_Zeile);
            ASM_Zeile:='        LDI   ZH,high('+STM_LISTE[VT_Zaehler].parameter1+')';
            ASM_Datei.Add(ASM_Zeile);
            ASM_Zeile:='        EIJMP';
            ASM_Datei.Add(ASM_Zeile);
          end; { STM_EIJMP_Marke }





        // ELPM - REG
        STM_ELPM :
          begin
            ASM_Zeile:='        ELPM       '+STM_LISTE[VT_Zaehler].parameter2+', '+STM_LISTE[VT_Zaehler].parameter1;
            ASM_Datei.Add(ASM_Zeile);
          end;





        // IIIIIIIIII

        // IN
        STM_IN_byte, STM_IN_word_L :
          begin
            ASM_Zeile:='        IN         '+STM_LISTE[VT_Zaehler].parameter2+
                       ', '+STM_LISTE[VT_Zaehler].parameter1;
            ASM_Datei.Add(ASM_Zeile);
          end;

        STM_IN_word_H :
          begin
            ASM_Zeile:='        IN         '+STM_LISTE[VT_Zaehler].parameter2+
                       ', '+STM_LISTE[VT_Zaehler].parameter1+'+1';
            ASM_Datei.Add(ASM_Zeile);
          end;



        // INC
        STM_INC_byte :
           begin
             ASM_Zeile:='        INC        '+STM_LISTE[VT_Zaehler].parameter1;
             ASM_Datei.Add(ASM_Zeile);
           end;



        /// JJJJJJJJJJ

        // JMP zu Marke
        STM_JMP_Marke :
          begin
            ASM_Zeile:='        JMP       '+STM_LISTE[VT_Zaehler].parameter1;
            ASM_Datei.Add(ASM_Zeile);
          end;



        // LLLLLLLLLL




        // LD - REG
        STM_LD :
          begin
            ASM_Zeile:='        LD         '+STM_LISTE[VT_Zaehler].parameter2+', '+STM_LISTE[VT_Zaehler].parameter1;
            ASM_Datei.Add(ASM_Zeile);
          end;




        // LDI - REG
        STM_LDI :
          begin
            ASM_Zeile:='        LDI        '+STM_LISTE[VT_Zaehler].parameter2+', '+STM_LISTE[VT_Zaehler].parameter1;
            ASM_Datei.Add(ASM_Zeile);
          end;

        STM_LDI_word_L :
          begin
            ASM_Zeile:='        LDI        '+STM_LISTE[VT_Zaehler].parameter2+', LOW('+STM_LISTE[VT_Zaehler].parameter1+')';
            ASM_Datei.Add(ASM_Zeile);
          end;

        STM_LDI_word_H :
          begin
            ASM_Zeile:='        LDI        '+STM_LISTE[VT_Zaehler].parameter2+', HIGH('+STM_LISTE[VT_Zaehler].parameter1+')';
            ASM_Datei.Add(ASM_Zeile);
          end;

        STM_LDI_word_3 :
          begin
            ASM_Zeile:='        LDI        '+STM_LISTE[VT_Zaehler].parameter2+', Byte3('+STM_LISTE[VT_Zaehler].parameter1+')';
            ASM_Datei.Add(ASM_Zeile);
          end;


        // LDS
        STM_LDS :
          begin
            ASM_Zeile:='        LDS        '+STM_LISTE[VT_Zaehler].parameter2+', '+
                                             STM_LISTE[VT_Zaehler].parameter1;
            ASM_Datei.Add(ASM_Zeile);
          end;


        // LSL
        STM_LSL :
           begin
             ASM_Zeile:='        LSL        '+STM_LISTE[VT_Zaehler].parameter1;
             ASM_Datei.Add(ASM_Zeile);
           end;



        // LSR
        STM_LSR :
           begin
             ASM_Zeile:='        LSR        '+STM_LISTE[VT_Zaehler].parameter1;
             ASM_Datei.Add(ASM_Zeile);
           end;



        // LPM - REG
        STM_LPM :
          begin
            ASM_Zeile:='        LPM        '+STM_LISTE[VT_Zaehler].parameter2+', '+STM_LISTE[VT_Zaehler].parameter1;
            ASM_Datei.Add(ASM_Zeile);
          end;



        // MMMMMMMMMM


        // MOV
        STM_MOV :
          begin
            ASM_Zeile:='        MOV        '+STM_LISTE[VT_Zaehler].parameter2+', '+STM_LISTE[VT_Zaehler].parameter1;
            ASM_Datei.Add(ASM_Zeile);
          end;

        // MOVW
        STM_MOVW :
          begin
            ASM_Zeile:='        MOVW       '+STM_LISTE[VT_Zaehler].parameter2+
                                           ', '+STM_LISTE[VT_Zaehler].parameter1;
            ASM_Datei.Add(ASM_Zeile);
          end;



        // NNNNNNNNNN

        // NOP
        STM_NOP :
           begin
             ASM_Zeile:='        NOP';
             ASM_Datei.Add(ASM_Zeile);
           end;




        // OOOOOOOOOO


        // OR
        STM_OR :
          begin
            ASM_Zeile:='        OR         '+STM_LISTE[VT_Zaehler].parameter2+', '+
                                             STM_LISTE[VT_Zaehler].parameter1;
            ASM_Datei.Add(ASM_Zeile);
          end;


        // OUT
        STM_OUT :
        begin
          ASM_Zeile:='        OUT        '+STM_LISTE[VT_Zaehler].parameter2+', '+STM_LISTE[VT_Zaehler].parameter1;
          ASM_Datei.Add(ASM_Zeile);
        end;





        // PPPPPPPPPP


        // PUSH - REG
        STM_PUSH :
          begin
            ASM_Zeile:='        PUSH       '+STM_LISTE[VT_Zaehler].parameter1;
            ASM_Datei.Add(ASM_Zeile);
          end;



        // PUSH - A
        STM_PUSH_byte_A, STM_PUSH_word_AL :
          begin
            ASM_Zeile:='        PUSH       R16';
            ASM_Datei.Add(ASM_Zeile);
          end;

        STM_PUSH_word_AH :
          begin
            ASM_Zeile:='        PUSH       R17';
            ASM_Datei.Add(ASM_Zeile);
          end;


         // PUSH - B
        STM_PUSH_byte_B :
          begin
            ASM_Zeile:='        PUSH       R17';
            ASM_Datei.Add(ASM_Zeile);
          end;

        STM_PUSH_word_BL :
          begin
            ASM_Zeile:='        PUSH       R18';
            ASM_Datei.Add(ASM_Zeile);
          end;

        STM_PUSH_word_BH :
          begin
            ASM_Zeile:='        PUSH       R19';
            ASM_Datei.Add(ASM_Zeile);
          end;





        // POP - REG
        STM_POP :
          begin
            ASM_Zeile:='        POP        '+STM_LISTE[VT_Zaehler].parameter1;
            ASM_Datei.Add(ASM_Zeile);
          end;



        // RRRRRRRRRR

        // RCALL
        STM_RCALL :
          begin
            ASM_Zeile:='        RCALL      '+STM_LISTE[VT_Zaehler].parameter1;
            ASM_Datei.Add(ASM_Zeile);
          end;


        STM_RET :
          begin
            ASM_Zeile:='        RET';
            ASM_Datei.Add(ASM_Zeile);
          end;


        STM_RETI :
          begin
            ASM_Zeile:='        RETI';
            ASM_Datei.Add(ASM_Zeile);
          end;



        // RJMP zu Marke
        STM_RJMP_Marke :
          begin
            ASM_Zeile:='        RJMP       '+STM_LISTE[VT_Zaehler].parameter1;
            ASM_Datei.Add(ASM_Zeile);
          end;



        // ROL
        STM_ROL :
          begin
            ASM_Zeile:='        ROL        '+STM_LISTE[VT_Zaehler].parameter1;
            ASM_Datei.Add(ASM_Zeile);
          end;





        // ROR
        STM_ROR :
          begin
            ASM_Zeile:='        ROR        '+STM_LISTE[VT_Zaehler].parameter1;
            ASM_Datei.Add(ASM_Zeile);
          end;



        // SSSSSSSSSS



        // SBI
        STM_SBI :
           begin
             ASM_Zeile:='        SBI        '+STM_LISTE[VT_Zaehler].parameter2+
                               ', '+STM_LISTE[VT_Zaehler].parameter1;
             ASM_Datei.Add(ASM_Zeile);
           end;



        // SBIW          SBIW       R25:R24, 1
        STM_SBIW_1 :
           begin
             ASM_Zeile:='        SBIW       '+STM_LISTE[VT_Zaehler].parameter2+
                       ':'+STM_LISTE[VT_Zaehler].parameter1+', 1';
             ASM_Datei.Add(ASM_Zeile);
           end; { STM_SBIW }



        // SBR
        STM_SBR :
           begin
             ASM_Zeile:='        SBR        '+STM_LISTE[VT_Zaehler].parameter2+
                               ', '+STM_LISTE[VT_Zaehler].parameter1;
             ASM_Datei.Add(ASM_Zeile);
           end;




        // SEI – Set Global Interrupt Flag
        STM_SEI :
          begin
            ASM_Zeile:='        SEI';
            ASM_Datei.Add(ASM_Zeile);
          end;



        // SER = TRUE
        STM_SER :
          begin
            ASM_Zeile:='        SER        '+STM_LISTE[VT_Zaehler].parameter1;
            ASM_Datei.Add(ASM_Zeile);
          end;



         STM_SHL_word :
           begin
             ASM_Zeile:='        LSL        '+STM_LISTE[VT_Zaehler].parameter1;
             ASM_Datei.Add(ASM_Zeile);
             ASM_Zeile:='        ROL        '+STM_LISTE[VT_Zaehler].parameter2;
             ASM_Datei.Add(ASM_Zeile);
           end;



         // SHR
         STM_SHR_byte :
            begin
              ASM_Zeile:='        LSR        '+STM_LISTE[VT_Zaehler].parameter1;
              ASM_Datei.Add(ASM_Zeile);
            end;




         STM_SHR_word :
            begin
              // Oberes Byte
              ASM_Zeile:='        LSR        '+STM_LISTE[VT_Zaehler].parameter1;
              ASM_Datei.Add(ASM_Zeile);
              // Unteres Byte
              ASM_Zeile:='        ROR        '+STM_LISTE[VT_Zaehler].parameter2;
              ASM_Datei.Add(ASM_Zeile);
            end;



        // ST - REG
        STM_ST :
          begin
            ASM_Zeile:='        ST         '+STM_LISTE[VT_Zaehler].parameter2+', '+STM_LISTE[VT_Zaehler].parameter1;
            ASM_Datei.Add(ASM_Zeile);
          end;



        // STS - REG
        STM_STS :
          begin
            ASM_Zeile:='        STS        '+STM_LISTE[VT_Zaehler].parameter2+', '+
                       STM_LISTE[VT_Zaehler].parameter1;
            ASM_Datei.Add(ASM_Zeile);
          end;



         // TTTTTTTTTT

         // TST
         STM_TST :
           begin
             ASM_Zeile:='        TST        '+STM_LISTE[VT_Zaehler].parameter1;
             ASM_Datei.Add(ASM_Zeile);
           end;






        // *** Zuweisungen ***


        // Zuweisung Operationen

        // Addition
        STM_zuw_op_add_byte, STM_zuw_op_add_word_L :
          begin
            ASM_Zeile:='        ADD        '+STM_LISTE[VT_Zaehler].parameter2+', '+
                                           STM_LISTE[VT_Zaehler].parameter1;
            ASM_Datei.Add(ASM_Zeile);
          end;

        STM_zuw_op_add_word_H :
          begin
            ASM_Zeile:='        ADC        '+STM_LISTE[VT_Zaehler].parameter2+', '+
                                           STM_LISTE[VT_Zaehler].parameter1;
            ASM_Datei.Add(ASM_Zeile);
          end;



        STM_zuw_op_add_curr :
          begin

            case ASM_Switch.JMP_Sprungdistanz of
              JMP_Relativ : ASM_Zeile:='        RCALL      ASM_UP_ADD_CURR';
              JMP_Word    : ASM_Zeile:='        CALL       ASM_UP_ADD_CURR';
              JMP_als_EIJMP : begin
                            ASM_Zeile:='        LDI   ZL,byte3(ASM_UP_ADD_CURR)';
                            ASM_Datei.Add(ASM_Zeile);
                            ASM_Zeile:='        OUT   EIND,ZL';
                            ASM_Datei.Add(ASM_Zeile);
                            ASM_Zeile:='        LDI   ZL,low(ASM_UP_ADD_CURR)';
                            ASM_Datei.Add(ASM_Zeile);
                            ASM_Zeile:='        LDI   ZH,high(ASM_UP_ADD_CURR)';
                            ASM_Datei.Add(ASM_Zeile);
                            ASM_Zeile:='        EICALL';
                          end; { JMP_als_EIJMP }
            else
              Fehler_cl.Registrieren('ZWC_Start/STM_zuw_op_add_curr',
                                     'JMP_Sprungdistanz nicht definiert',
                                     Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                                     Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                                     Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);
            end; { case JMP_Sprungdistanz of }

            ASM_Datei.Add(ASM_Zeile);
            ASM_UP_wird_benoetigt('ASM_UP_ADD_CURR.ASM');
            ASM_UP_wird_benoetigt('ASM_UP_CURR_TOOL01.ASM');
          end; { STM_zuw_op_add_curr }





        // Subtraktion
        STM_zuw_op_sub_byte, STM_zuw_op_sub_word_L :
          begin
            ASM_Zeile:='        SUB        '+STM_LISTE[VT_Zaehler].parameter2+', '+
                                             STM_LISTE[VT_Zaehler].parameter1;
            ASM_Datei.Add(ASM_Zeile);
          end;

        STM_zuw_op_sub_word_H :
          begin
            ASM_Zeile:='        SBC        '+STM_LISTE[VT_Zaehler].parameter2+', '+
                                             STM_LISTE[VT_Zaehler].parameter1;
            ASM_Datei.Add(ASM_Zeile);
          end;



        STM_zuw_op_sub_curr :
          begin
            case ASM_Switch.JMP_Sprungdistanz of
              JMP_Relativ : ASM_Zeile:='        RCALL      ASM_UP_SUB_CURR';
              JMP_Word    : ASM_Zeile:='        CALL       ASM_UP_SUB_CURR';
              JMP_als_EIJMP : begin
                            ASM_Zeile:='        LDI   ZL,byte3(ASM_UP_SUB_CURR)';
                            ASM_Datei.Add(ASM_Zeile);
                            ASM_Zeile:='        OUT   EIND,ZL';
                            ASM_Datei.Add(ASM_Zeile);
                            ASM_Zeile:='        LDI   ZL,low(ASM_UP_SUB_CURR)';
                            ASM_Datei.Add(ASM_Zeile);
                            ASM_Zeile:='        LDI   ZH,high(ASM_UP_SUB_CURR)';
                            ASM_Datei.Add(ASM_Zeile);
                            ASM_Zeile:='        EICALL';
                          end; { JMP_als_EIJMP }
            else
              Fehler_cl.Registrieren('ZWC_Start/STM_zuw_op_sub_curr',
                                     'JMP_Sprungdistanz nicht definiert',
                                     Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                                     Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                                     Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);
            end; { case JMP_Sprungdistanz of }

            ASM_Datei.Add(ASM_Zeile);
            ASM_UP_wird_benoetigt('ASM_UP_SUB_CURR.ASM');
            ASM_UP_wird_benoetigt('ASM_UP_CURR_TOOL01.ASM');

          end; { STM_zuw_op_sub_curr }




        // MUL aendern !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!


        // Multiplikation
        STM_zuw_op_mul_byte :
          begin
            ASM_Zeile:='        MUL        '+STM_LISTE[VT_Zaehler].parameter2+', '+
                                             STM_LISTE[VT_Zaehler].parameter1;
            ASM_Datei.Add(ASM_Zeile);
            ASM_Zeile:='        MOV        '+STM_LISTE[VT_Zaehler].parameter2+', R0';
            ASM_Datei.Add(ASM_Zeile);
          end;

        STM_zuw_op_mul_word :
          begin

            case ASM_Switch.JMP_Sprungdistanz of
              JMP_Relativ : ASM_Zeile:='        RCALL      ASM_UP_MUL16';
              JMP_Word    : ASM_Zeile:='        CALL       ASM_UP_MUL16';
              JMP_als_EIJMP : begin
                            ASM_Zeile:='        LDI   ZL,byte3(ASM_UP_MUL16)';
                            ASM_Datei.Add(ASM_Zeile);
                            ASM_Zeile:='        OUT   EIND,ZL';
                            ASM_Datei.Add(ASM_Zeile);
                            ASM_Zeile:='        LDI   ZL,low(ASM_UP_MUL16)';
                            ASM_Datei.Add(ASM_Zeile);
                            ASM_Zeile:='        LDI   ZH,high(ASM_UP_MUL16)';
                            ASM_Datei.Add(ASM_Zeile);
                            ASM_Zeile:='        EICALL';
                          end; { JMP_als_EIJMP }
            else
              Fehler_cl.Registrieren('ZWC_Start/STM_zuw_op_mul_word',
                                     'JMP_Sprungdistanz nicht definiert',
                                     Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                                     Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                                     Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);
            end; { case JMP_Sprungdistanz of }

            ASM_Datei.Add(ASM_Zeile);
            ASM_UP_wird_benoetigt('ASM_UP_MUL16.ASM');
          end;


        STM_zuw_op_mul_dword :
          begin

            case ASM_Switch.JMP_Sprungdistanz of
              JMP_Relativ : ASM_Zeile:='        RCALL      ASM_UP_MUL32';
              JMP_Word    : ASM_Zeile:='        CALL       ASM_UP_MUL32';
              JMP_als_EIJMP : begin
                            ASM_Zeile:='        LDI   ZL,byte3(ASM_UP_MUL32)';
                            ASM_Datei.Add(ASM_Zeile);
                            ASM_Zeile:='        OUT   EIND,ZL';
                            ASM_Datei.Add(ASM_Zeile);
                            ASM_Zeile:='        LDI   ZL,low(ASM_UP_MUL32)';
                            ASM_Datei.Add(ASM_Zeile);
                            ASM_Zeile:='        LDI   ZH,high(ASM_UP_MUL32)';
                            ASM_Datei.Add(ASM_Zeile);
                            ASM_Zeile:='        EICALL';
                          end; { JMP_als_EIJMP }
            else
              Fehler_cl.Registrieren('ZWC_Start/STM_zuw_op_mul_dword',
                                     'JMP_Sprungdistanz nicht definiert',
                                     Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                                     Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                                     Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);
            end; { case JMP_Sprungdistanz of }

            ASM_Datei.Add(ASM_Zeile);
            ASM_UP_wird_benoetigt('ASM_UP_MUL32.ASM');
          end;



        STM_zuw_op_mul_curr :
          begin

            case ASM_Switch.JMP_Sprungdistanz of
              JMP_Relativ : ASM_Zeile:='        RCALL      ASM_UP_MUL_CURR';
              JMP_Word    : ASM_Zeile:='        CALL       ASM_UP_MUL_CURR';
              JMP_als_EIJMP : begin
                            ASM_Zeile:='        LDI   ZL,byte3(ASM_UP_MUL_CURR)';
                            ASM_Datei.Add(ASM_Zeile);
                            ASM_Zeile:='        OUT   EIND,ZL';
                            ASM_Datei.Add(ASM_Zeile);
                            ASM_Zeile:='        LDI   ZL,low(ASM_UP_MUL_CURR)';
                            ASM_Datei.Add(ASM_Zeile);
                            ASM_Zeile:='        LDI   ZH,high(ASM_UP_MUL_CURR)';
                            ASM_Datei.Add(ASM_Zeile);
                            ASM_Zeile:='        EICALL';
                          end; { JMP_als_EIJMP }
            else
              Fehler_cl.Registrieren('ZWC_Start/STM_zuw_op_mul_curr',
                                     'JMP_Sprungdistanz nicht definiert',
                                     Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                                     Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                                     Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);
            end; { case JMP_Sprungdistanz of }

            ASM_Datei.Add(ASM_Zeile);
            ASM_UP_wird_benoetigt('ASM_UP_MUL_CURR.ASM');
            ASM_UP_wird_benoetigt('ASM_UP_CURR_TOOL01.ASM');
            ASM_UP_wird_benoetigt('ASM_UP_CURR_TOOL02.ASM');
          end; { STM_zuw_op_mul_curr }



        // Division
        STM_zuw_op_div_byte :
          begin

            case ASM_Switch.JMP_Sprungdistanz of
              JMP_Relativ : ASM_Zeile:='        RCALL      ASM_UP_MDIV8';
              JMP_Word    : ASM_Zeile:='        CALL       ASM_UP_MDIV8';
              JMP_als_EIJMP : begin
                            ASM_Zeile:='        LDI   ZL,byte3(ASM_UP_MDIV8)';
                            ASM_Datei.Add(ASM_Zeile);
                            ASM_Zeile:='        OUT   EIND,ZL';
                            ASM_Datei.Add(ASM_Zeile);
                            ASM_Zeile:='        LDI   ZL,low(ASM_UP_MDIV8)';
                            ASM_Datei.Add(ASM_Zeile);
                            ASM_Zeile:='        LDI   ZH,high(ASM_UP_MDIV8)';
                            ASM_Datei.Add(ASM_Zeile);
                            ASM_Zeile:='        EICALL';
                          end; { JMP_als_EIJMP }
            else
              Fehler_cl.Registrieren('ZWC_Start/STM_zuw_op_div_byte',
                                     'JMP_Sprungdistanz nicht definiert',
                                     Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                                     Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                                     Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);
            end; { case JMP_Sprungdistanz of }

            ASM_Datei.Add(ASM_Zeile);
            ASM_UP_wird_benoetigt('ASM_UP_DIV8.ASM');
          end;

        STM_zuw_op_div_word :
          begin

            case ASM_Switch.JMP_Sprungdistanz of
              JMP_Relativ : ASM_Zeile:='        RCALL      ASM_UP_MDIV16';
              JMP_Word    : ASM_Zeile:='        CALL       ASM_UP_MDIV16';
              JMP_als_EIJMP : begin
                            ASM_Zeile:='        LDI   ZL,byte3(ASM_UP_MDIV16)';
                            ASM_Datei.Add(ASM_Zeile);
                            ASM_Zeile:='        OUT   EIND,ZL';
                            ASM_Datei.Add(ASM_Zeile);
                            ASM_Zeile:='        LDI   ZL,low(ASM_UP_MDIV16)';
                            ASM_Datei.Add(ASM_Zeile);
                            ASM_Zeile:='        LDI   ZH,high(ASM_UP_MDIV16)';
                            ASM_Datei.Add(ASM_Zeile);
                            ASM_Zeile:='        EICALL';
                          end; { JMP_als_EIJMP }
            else
              Fehler_cl.Registrieren('ZWC_Start/STM_zuw_op_div_word',
                                     'JMP_Sprungdistanz nicht definiert',
                                     Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                                     Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                                     Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);
            end; { case JMP_Sprungdistanz of }

            ASM_Datei.Add(ASM_Zeile);
            ASM_UP_wird_benoetigt('ASM_UP_DIV16.ASM');
          end;

        STM_zuw_op_div_dword :
          begin

            case ASM_Switch.JMP_Sprungdistanz of
              JMP_Relativ : ASM_Zeile:='        RCALL      ASM_UP_MDIV32';
              JMP_Word    : ASM_Zeile:='        CALL       ASM_UP_MDIV32';
              JMP_als_EIJMP : begin
                            ASM_Zeile:='        LDI   ZL,byte3(ASM_UP_MDIV32)';
                            ASM_Datei.Add(ASM_Zeile);
                            ASM_Zeile:='        OUT   EIND,ZL';
                            ASM_Datei.Add(ASM_Zeile);
                            ASM_Zeile:='        LDI   ZL,low(ASM_UP_MDIV32)';
                            ASM_Datei.Add(ASM_Zeile);
                            ASM_Zeile:='        LDI   ZH,high(ASM_UP_MDIV32)';
                            ASM_Datei.Add(ASM_Zeile);
                            ASM_Zeile:='        EICALL';
                          end; { JMP_als_EIJMP }
            else
              Fehler_cl.Registrieren('ZWC_Start/STM_zuw_op_div_word',
                                     'JMP_Sprungdistanz nicht definiert',
                                     Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                                     Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                                     Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);
            end; { case JMP_Sprungdistanz of }

            ASM_Datei.Add(ASM_Zeile);
            ASM_UP_wird_benoetigt('ASM_UP_DIV32.ASM');
          end;



        STM_zuw_op_div_curr :
          begin

            case ASM_Switch.JMP_Sprungdistanz of
              JMP_Relativ : ASM_Zeile:='        RCALL      ASM_UP_DIV_CURR';
              JMP_Word    : ASM_Zeile:='        CALL       ASM_UP_DIV_CURR';
              JMP_als_EIJMP : begin
                            ASM_Zeile:='        LDI   ZL,byte3(ASM_UP_DIV_CURR)';
                            ASM_Datei.Add(ASM_Zeile);
                            ASM_Zeile:='        OUT   EIND,ZL';
                            ASM_Datei.Add(ASM_Zeile);
                            ASM_Zeile:='        LDI   ZL,low(ASM_UP_DIV_CURR)';
                            ASM_Datei.Add(ASM_Zeile);
                            ASM_Zeile:='        LDI   ZH,high(ASM_UP_DIV_CURR)';
                            ASM_Datei.Add(ASM_Zeile);
                            ASM_Zeile:='        EICALL';
                          end; { JMP_als_EIJMP }
            else
              Fehler_cl.Registrieren('ZWC_Start/STM_zuw_op_div_curr',
                                     'JMP_Sprungdistanz nicht definiert',
                                     Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                                     Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                                     Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);
            end; { case JMP_Sprungdistanz of }

            ASM_Datei.Add(ASM_Zeile);
            ASM_UP_wird_benoetigt('ASM_UP_DIV_CURR.ASM');
            ASM_UP_wird_benoetigt('ASM_UP_CURR_TOOL01.ASM');
            ASM_UP_wird_benoetigt('ASM_UP_CURR_TOOL02.ASM');
          end; { STM_zuw_op_div_curr }





        // Vergleich


        // V1 < V2 (oder V2 >= V1)
        STM_VERGL_A_curr :
          begin

            case ASM_Switch.JMP_Sprungdistanz of
              JMP_Relativ : ASM_Zeile:='        RCALL      ASM_UP_VER_A_CURR';
              JMP_Word    : ASM_Zeile:='        CALL       ASM_UP_VER_A_CURR';
              JMP_als_EIJMP : begin
                            ASM_Zeile:='        LDI   ZL,byte3(ASM_UP_VER_A_CURR)';
                            ASM_Datei.Add(ASM_Zeile);
                            ASM_Zeile:='        OUT   EIND,ZL';
                            ASM_Datei.Add(ASM_Zeile);
                            ASM_Zeile:='        LDI   ZL,low(ASM_UP_VER_A_CURR)';
                            ASM_Datei.Add(ASM_Zeile);
                            ASM_Zeile:='        LDI   ZH,high(ASM_UP_VER_A_CURR)';
                            ASM_Datei.Add(ASM_Zeile);
                            ASM_Zeile:='        EICALL';
                          end; { JMP_als_EIJMP }
            else
              Fehler_cl.Registrieren('ZWC_Start/STM_VERGL_A_curr',
                                     'JMP_Sprungdistanz nicht definiert',
                                     Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                                     Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                                     Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);
            end; { case JMP_Sprungdistanz of }

            ASM_Datei.Add(ASM_Zeile);
            ASM_UP_wird_benoetigt('ASM_UP_VER_A_CURR.ASM');
            ASM_UP_wird_benoetigt('ASM_UP_CURR_TOOL01.ASM');
          end; { STM_VERGL_A_curr }




        // V1 > V2 (oder V2 <= V1)
        STM_VERGL_B_curr :
          begin

            case ASM_Switch.JMP_Sprungdistanz of
              JMP_Relativ : ASM_Zeile:='        RCALL      ASM_UP_VER_B_CURR';
              JMP_Word    : ASM_Zeile:='        CALL       ASM_UP_VER_B_CURR';
              JMP_als_EIJMP : begin
                            ASM_Zeile:='        LDI   ZL,byte3(ASM_UP_VER_B_CURR)';
                            ASM_Datei.Add(ASM_Zeile);
                            ASM_Zeile:='        OUT   EIND,ZL';
                            ASM_Datei.Add(ASM_Zeile);
                            ASM_Zeile:='        LDI   ZL,low(ASM_UP_VER_B_CURR)';
                            ASM_Datei.Add(ASM_Zeile);
                            ASM_Zeile:='        LDI   ZH,high(ASM_UP_VER_B_CURR)';
                            ASM_Datei.Add(ASM_Zeile);
                            ASM_Zeile:='        EICALL';
                          end; { JMP_als_EIJMP }
            else
              Fehler_cl.Registrieren('ZWC_Start/STM_VERGL_B_curr',
                                     'JMP_Sprungdistanz nicht definiert',
                                     Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                                     Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                                     Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);
            end; { case JMP_Sprungdistanz of }

            ASM_Datei.Add(ASM_Zeile);
            ASM_UP_wird_benoetigt('ASM_UP_VER_B_CURR.ASM');
            ASM_UP_wird_benoetigt('ASM_UP_CURR_TOOL01.ASM');
          end; { STM_VERGL_B_curr }




        // V1 = V2
        STM_VERGL_C_curr :
          begin

            case ASM_Switch.JMP_Sprungdistanz of
              JMP_Relativ : ASM_Zeile:='        RCALL      ASM_UP_VER_C_CURR';
              JMP_Word    : ASM_Zeile:='        CALL       ASM_UP_VER_C_CURR';
              JMP_als_EIJMP : begin
                            ASM_Zeile:='        LDI   ZL,byte3(ASM_UP_VER_C_CURR)';
                            ASM_Datei.Add(ASM_Zeile);
                            ASM_Zeile:='        OUT   EIND,ZL';
                            ASM_Datei.Add(ASM_Zeile);
                            ASM_Zeile:='        LDI   ZL,low(ASM_UP_VER_C_CURR)';
                            ASM_Datei.Add(ASM_Zeile);
                            ASM_Zeile:='        LDI   ZH,high(ASM_UP_VER_C_CURR)';
                            ASM_Datei.Add(ASM_Zeile);
                            ASM_Zeile:='        EICALL';
                          end; { JMP_als_EIJMP }
            else
              Fehler_cl.Registrieren('ZWC_Start/STM_VERGL_C_curr',
                                     'JMP_Sprungdistanz nicht definiert',
                                     Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                                     Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                                     Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);
            end; { case JMP_Sprungdistanz of }

            ASM_Datei.Add(ASM_Zeile);
            ASM_UP_wird_benoetigt('ASM_UP_VER_C_CURR.ASM');
            ASM_UP_wird_benoetigt('ASM_UP_CURR_TOOL01.ASM');
          end; { STM_VERGL_C_curr }





        // Inkrement

        // INC
       STM_INC_word :
         begin
           ASM_Zeile:='        LDI        R20, 1';
           ASM_Datei.Add(ASM_Zeile);
           ASM_Zeile:='        ADD        '+STM_LISTE[VT_Zaehler].parameter1+', R20';
           ASM_Datei.Add(ASM_Zeile);
           ASM_Zeile:='        CLR        R20';
           ASM_Datei.Add(ASM_Zeile);
           ASM_Zeile:='        ADC        '+STM_LISTE[VT_Zaehler].parameter2+', R20';
           ASM_Datei.Add(ASM_Zeile);
         end; { STM_inc_var_word }


       STM_INC_dword :
         begin
           ASM_Zeile:='        CLR        R24';
           ASM_Datei.Add(ASM_Zeile);
           ASM_Zeile:='        SEC';
           ASM_Datei.Add(ASM_Zeile);
           ASM_Zeile:='        ADC        R16, R24';
           ASM_Datei.Add(ASM_Zeile);
           ASM_Zeile:='        ADC        R17, R24';
           ASM_Datei.Add(ASM_Zeile);
           ASM_Zeile:='        ADC        R18, R24';
           ASM_Datei.Add(ASM_Zeile);
           ASM_Zeile:='        ADC        R19, R24';
           ASM_Datei.Add(ASM_Zeile);
         end; { STM_INC_dword }




       STM_INC_dword_l1 :
         begin

           ASM_Zeile:='        CLR        R24';
           ASM_Datei.Add(ASM_Zeile);
           ASM_Zeile:='        SEC';
           ASM_Datei.Add(ASM_Zeile);
           ASM_Zeile:='        ADC        '+STM_LISTE[VT_Zaehler].parameter1+', R24';
           ASM_Datei.Add(ASM_Zeile);
           ASM_Zeile:='        ADC        '+STM_LISTE[VT_Zaehler].parameter2+', R24';
           ASM_Datei.Add(ASM_Zeile);

         end; { STM_INC_dword_l1 }




       STM_INC_dword_l2 :
         begin

           ASM_Zeile:='        ADC        '+STM_LISTE[VT_Zaehler].parameter1+', R24';
           ASM_Datei.Add(ASM_Zeile);
           ASM_Zeile:='        ADC        '+STM_LISTE[VT_Zaehler].parameter2+', R24';
           ASM_Datei.Add(ASM_Zeile);

         end; { STM_INC_dword_l2 }




       STM_DEC_dword :
         begin
           ASM_Zeile:='        CLR        R24';
           ASM_Datei.Add(ASM_Zeile);
           ASM_Zeile:='        SEC';
           ASM_Datei.Add(ASM_Zeile);
           ASM_Zeile:='        SBC        R16, R24';
           ASM_Datei.Add(ASM_Zeile);
           ASM_Zeile:='        SBC        R17, R24';
           ASM_Datei.Add(ASM_Zeile);
           ASM_Zeile:='        SBC        R18, R24';
           ASM_Datei.Add(ASM_Zeile);
           ASM_Zeile:='        SBC        R19, R24';
           ASM_Datei.Add(ASM_Zeile);
         end; { STM_DEC_dword }





       STM_DEC_dword_l1 :
         begin

           ASM_Zeile:='        CLR        R24';
           ASM_Datei.Add(ASM_Zeile);
           ASM_Zeile:='        SEC';
           ASM_Datei.Add(ASM_Zeile);
           ASM_Zeile:='        SBC        '+STM_LISTE[VT_Zaehler].parameter1+', R24';
           ASM_Datei.Add(ASM_Zeile);
           ASM_Zeile:='        SBC        '+STM_LISTE[VT_Zaehler].parameter2+', R24';
           ASM_Datei.Add(ASM_Zeile);

         end; { STM_DEC_dword_l1 }




       STM_DEC_dword_l2 :
         begin

           ASM_Zeile:='        SBC        '+STM_LISTE[VT_Zaehler].parameter1+', R24';
           ASM_Datei.Add(ASM_Zeile);
           ASM_Zeile:='        SBC        '+STM_LISTE[VT_Zaehler].parameter2+', R24';
           ASM_Datei.Add(ASM_Zeile);

         end; { STM_DEC_dword_l2 }





        // FOR TO DO - Vergleich

        STM_ftd_vergl_to_byte :
          begin
            ASM_Zeile:='        POP        R16';
            ASM_Datei.Add(ASM_Zeile);
            ASM_Zeile:='        PUSH       R16';
            ASM_Datei.Add(ASM_Zeile);
            ASM_Zeile:='        CP         R16, R17';
            ASM_Datei.Add(ASM_Zeile);
          end; { STM_ftd_vergl_to_byte }

        STM_ftd_vergl_to_word :
          begin
            ASM_Zeile:='        POP        R17';
            ASM_Datei.Add(ASM_Zeile);
            ASM_Zeile:='        POP        R16';
            ASM_Datei.Add(ASM_Zeile);
            ASM_Zeile:='        PUSH       R16';
            ASM_Datei.Add(ASM_Zeile);
            ASM_Zeile:='        PUSH       R17';
            ASM_Datei.Add(ASM_Zeile);
            ASM_Zeile:='        CP         R16, R18';
            ASM_Datei.Add(ASM_Zeile);
            ASM_Zeile:='        CPC        R17, R19';
            ASM_Datei.Add(ASM_Zeile);
          end; { STM_ftd_vergl_to_word }



        STM_ftd_vergl_to_dword :
          begin
            ASM_Zeile:='        POP        R19';
            ASM_Datei.Add(ASM_Zeile);
            ASM_Zeile:='        POP        R18';
            ASM_Datei.Add(ASM_Zeile);
            ASM_Zeile:='        POP        R17';
            ASM_Datei.Add(ASM_Zeile);
            ASM_Zeile:='        POP        R16';
            ASM_Datei.Add(ASM_Zeile);
            ASM_Zeile:='        PUSH       R16';
            ASM_Datei.Add(ASM_Zeile);
            ASM_Zeile:='        PUSH       R17';
            ASM_Datei.Add(ASM_Zeile);
            ASM_Zeile:='        PUSH       R18';
            ASM_Datei.Add(ASM_Zeile);
            ASM_Zeile:='        PUSH       R19';
            ASM_Datei.Add(ASM_Zeile);
            ASM_Zeile:='        CP         R16, R20';
            ASM_Datei.Add(ASM_Zeile);
            ASM_Zeile:='        CPC        R17, R21';
            ASM_Datei.Add(ASM_Zeile);
            ASM_Zeile:='        CPC        R18, R22';
            ASM_Datei.Add(ASM_Zeile);
            ASM_Zeile:='        CPC        R19, R23';
            ASM_Datei.Add(ASM_Zeile);

          end; { STM_ftd_vergl_to_dword }




        STM_ftd_vergl_downto_byte :
          begin
            ASM_Zeile:='        POP        R16';
            ASM_Datei.Add(ASM_Zeile);
            ASM_Zeile:='        PUSH       R16';
            ASM_Datei.Add(ASM_Zeile);
            ASM_Zeile:='        CP         R17, R16';
            ASM_Datei.Add(ASM_Zeile);
          end; { STM_ftd_vergl_downto_byte }

        STM_ftd_vergl_downto_word :
          begin
            ASM_Zeile:='        POP        R17';
            ASM_Datei.Add(ASM_Zeile);
            ASM_Zeile:='        POP        R16';
            ASM_Datei.Add(ASM_Zeile);
            ASM_Zeile:='        PUSH       R16';
            ASM_Datei.Add(ASM_Zeile);
            ASM_Zeile:='        PUSH       R17';
            ASM_Datei.Add(ASM_Zeile);
            ASM_Zeile:='        CP         R18, R16';
            ASM_Datei.Add(ASM_Zeile);
            ASM_Zeile:='        CPC        R19, R17';
            ASM_Datei.Add(ASM_Zeile);
          end; { STM_ftd_vergl_downto_word }



        STM_ftd_vergl_downto_dword :
          begin
            ASM_Zeile:='        POP        R19';
            ASM_Datei.Add(ASM_Zeile);
            ASM_Zeile:='        POP        R18';
            ASM_Datei.Add(ASM_Zeile);
            ASM_Zeile:='        POP        R17';
            ASM_Datei.Add(ASM_Zeile);
            ASM_Zeile:='        POP        R16';
            ASM_Datei.Add(ASM_Zeile);
            ASM_Zeile:='        PUSH       R16';
            ASM_Datei.Add(ASM_Zeile);
            ASM_Zeile:='        PUSH       R17';
            ASM_Datei.Add(ASM_Zeile);
            ASM_Zeile:='        PUSH       R18';
            ASM_Datei.Add(ASM_Zeile);
            ASM_Zeile:='        PUSH       R19';
            ASM_Datei.Add(ASM_Zeile);
            ASM_Zeile:='        CP         R20, R16';
            ASM_Datei.Add(ASM_Zeile);
            ASM_Zeile:='        CPC        R21, R17';
            ASM_Datei.Add(ASM_Zeile);
            ASM_Zeile:='        CPC        R22, R18';
            ASM_Datei.Add(ASM_Zeile);
            ASM_Zeile:='        CPC        R23, R19';
            ASM_Datei.Add(ASM_Zeile);
          end; { STM_ftd_vergl_downto_dword }





         // BOOL - CMP
         STM_bo_cp :
           begin
             ASM_Zeile:='        CPI        R16, 0xFF';
             ASM_Datei.Add(ASM_Zeile);
             ASM_Zeile:='        BREQ       '+STM_LISTE[VT_Zaehler].parameter1;
             ASM_Datei.Add(ASM_Zeile);
             ASM_Zeile:='        RJMP       '+STM_LISTE[VT_Zaehler].parameter2;
             ASM_Datei.Add(ASM_Zeile);
             ASM_Zeile:=STM_LISTE[VT_Zaehler].parameter1+':';
             ASM_Datei.Add(ASM_Zeile);

           end;




         // STRING-Routinen

         STM_str_const_quelle_a :
           begin
             ASM_Zeile:='        MOV        R20, R16    ; maximale Laenge';
             ASM_Datei.Add(ASM_Zeile);
             ASM_Zeile:='        SUB        R20, R17    ; noch maximal zu kopierende Laenge';
             ASM_Datei.Add(ASM_Zeile);

             if ASM_Switch.LPM_erweitern_auf_ELPM then
               ASM_Zeile:='        ELPM       R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante'
             else
               ASM_Zeile:='        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante';

             ASM_Datei.Add(ASM_Zeile);
             ASM_Zeile:='        CP         R20, R18    ; Restlaenge < Lange der STRING';
             ASM_Datei.Add(ASM_Zeile);
             ASM_Zeile:='        BRCC       '+STM_LISTE[VT_Zaehler].parameter1;
             ASM_Datei.Add(ASM_Zeile);
             ASM_Zeile:='        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen';
             ASM_Datei.Add(ASM_Zeile);
             ASM_Zeile:=STM_LISTE[VT_Zaehler].parameter1+':';
             ASM_Datei.Add(ASM_Zeile);
           end; { STM_str_const_quelle_a }


         STM_str_const_quelle_b :
           begin
             ASM_Zeile:='        CPI        R18, 0';
             ASM_Datei.Add(ASM_Zeile);
             ASM_Zeile:='        BREQ       '+STM_LISTE[VT_Zaehler].parameter2;
             ASM_Datei.Add(ASM_Zeile);
             ASM_Zeile:=STM_LISTE[VT_Zaehler].parameter1+':';
             ASM_Datei.Add(ASM_Zeile);

             if ASM_Switch.LPM_erweitern_auf_ELPM then
               ASM_Zeile:='        ELPM       R19, Z+      ; Einlesen des Zeichen in R19'
             else
               ASM_Zeile:='        LPM        R19, Z+      ; Einlesen des Zeichen in R19';

             ASM_Datei.Add(ASM_Zeile);
             ASM_Zeile:='        PUSH       R19';
             ASM_Datei.Add(ASM_Zeile);
             ASM_Zeile:='        INC        R17';
             ASM_Datei.Add(ASM_Zeile);
             ASM_Zeile:='        DEC        R18';
             ASM_Datei.Add(ASM_Zeile);
             ASM_Zeile:='        CPI        R18, 0';
             ASM_Datei.Add(ASM_Zeile);
             ASM_Zeile:='        BRNE       '+STM_LISTE[VT_Zaehler].parameter1;
             ASM_Datei.Add(ASM_Zeile);
             ASM_Zeile:=STM_LISTE[VT_Zaehler].parameter2+':';
             ASM_Datei.Add(ASM_Zeile);
           end; { STM_str_const_quelle_b }



         STM_str_var_quelle_a :
           begin
             ASM_Zeile:='        MOV        R20, R16    ; maximale Laenge';
             ASM_Datei.Add(ASM_Zeile);
             ASM_Zeile:='        SUB        R20, R17    ; noch maximal zu kopierende Laenge';
             ASM_Datei.Add(ASM_Zeile);
             ASM_Zeile:='        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante';
             ASM_Datei.Add(ASM_Zeile);
             ASM_Zeile:='        CP         R20, R18    ; Restlaenge < Lange der STRING';
             ASM_Datei.Add(ASM_Zeile);
             ASM_Zeile:='        BRCC       '+STM_LISTE[VT_Zaehler].parameter1;
             ASM_Datei.Add(ASM_Zeile);
             ASM_Zeile:='        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen';
             ASM_Datei.Add(ASM_Zeile);
             ASM_Zeile:=STM_LISTE[VT_Zaehler].parameter1+':';
             ASM_Datei.Add(ASM_Zeile);
           end; { STM_str_var_quelle_a }



         STM_str_var_quelle_b :
           begin
             ASM_Zeile:='        CPI        R18, 0';
             ASM_Datei.Add(ASM_Zeile);
             ASM_Zeile:='        BREQ       '+STM_LISTE[VT_Zaehler].parameter2;
             ASM_Datei.Add(ASM_Zeile);
             ASM_Zeile:=STM_LISTE[VT_Zaehler].parameter1+':';
             ASM_Datei.Add(ASM_Zeile);
             ASM_Zeile:='        LD         R19, Z+      ; Einlesen des Zeichen in R19';
             ASM_Datei.Add(ASM_Zeile);
             ASM_Zeile:='        PUSH       R19';
             ASM_Datei.Add(ASM_Zeile);
             ASM_Zeile:='        INC        R17';
             ASM_Datei.Add(ASM_Zeile);
             ASM_Zeile:='        DEC        R18';
             ASM_Datei.Add(ASM_Zeile);
             ASM_Zeile:='        CPI        R18, 0';
             ASM_Datei.Add(ASM_Zeile);
             ASM_Zeile:='        BRNE       '+STM_LISTE[VT_Zaehler].parameter1;
             ASM_Datei.Add(ASM_Zeile);
             ASM_Zeile:=STM_LISTE[VT_Zaehler].parameter2+':';
             ASM_Datei.Add(ASM_Zeile);
           end; { STM_str_const_quelle_b }



         STM_str_var_quelle_char :
           begin
             ASM_Zeile:='        MOV        R20, R16    ; maximale Laenge';
             ASM_Datei.Add(ASM_Zeile);
             ASM_Zeile:='        SUB        R20, R17    ; noch maximal zu kopierende Laenge';
             ASM_Datei.Add(ASM_Zeile);
             ASM_Zeile:='        CPI        R20, 1      ; Restlaenge < Lange der STRING';
             ASM_Datei.Add(ASM_Zeile);
             ASM_Zeile:='        BRCS       '+STM_LISTE[VT_Zaehler].parameter1;
             ASM_Datei.Add(ASM_Zeile);
             ASM_Zeile:='        PUSH       R19';
             ASM_Datei.Add(ASM_Zeile);
             ASM_Zeile:='        INC        R17';
             ASM_Datei.Add(ASM_Zeile);
             ASM_Zeile:=STM_LISTE[VT_Zaehler].parameter1+':';
             ASM_Datei.Add(ASM_Zeile);
           end; { STM_str_var_quelle_char }



         STM_str_var_ziel :
           begin
             ASM_Zeile:='        CLR        R21';
             ASM_Datei.Add(ASM_Zeile);
             ASM_Zeile:='        MOV        R20, R17';
             ASM_Datei.Add(ASM_Zeile);
             ASM_Zeile:='        INC        R20';
             ASM_Datei.Add(ASM_Zeile);
             ASM_Zeile:='        ADD        ZL, R20      ; Z:=Z+R17+1';
             ASM_Datei.Add(ASM_Zeile);
             ASM_Zeile:='        ADC        ZH, R21';
             ASM_Datei.Add(ASM_Zeile);
             ASM_Zeile:='        CPI        R17, 0';
             ASM_Datei.Add(ASM_Zeile);
             ASM_Zeile:='        BREQ       '+STM_LISTE[VT_Zaehler].parameter2;
             ASM_Datei.Add(ASM_Zeile);
             ASM_Zeile:='        MOV        R16, R17';
             ASM_Datei.Add(ASM_Zeile);
             ASM_Zeile:=STM_LISTE[VT_Zaehler].parameter1+':';
             ASM_Datei.Add(ASM_Zeile);
             ASM_Zeile:='        POP        R19';
             ASM_Datei.Add(ASM_Zeile);
             ASM_Zeile:='        ST         -Z, R19';
             ASM_Datei.Add(ASM_Zeile);
             ASM_Zeile:='        DEC        R16';
             ASM_Datei.Add(ASM_Zeile);
             ASM_Zeile:='        CPI        R16, 0 ';
             ASM_Datei.Add(ASM_Zeile);
             ASM_Zeile:='        BRNE       '+STM_LISTE[VT_Zaehler].parameter1;
             ASM_Datei.Add(ASM_Zeile);
             ASM_Zeile:=STM_LISTE[VT_Zaehler].parameter2+':';
             ASM_Datei.Add(ASM_Zeile);
             ASM_Zeile:='        ST         -Z, R17';
             ASM_Datei.Add(ASM_Zeile);
           end; { STM_str_var_ziel }




         STM_isr_push :
           begin

             ASM_Zeile:='        PUSH       R16';
             ASM_Datei.Add(ASM_Zeile);
             // SAVE STATUS REGISTER
             ASM_Zeile:='        IN         R16,SREG';
             ASM_Datei.Add(ASM_Zeile);
             ASM_Zeile:='        PUSH       R16';
             ASM_Datei.Add(ASM_Zeile);


             {

             ASM_Zeile:='        PUSH       R17';
             ASM_Datei.Add(ASM_Zeile);
             ASM_Zeile:='        PUSH       R18';
             ASM_Datei.Add(ASM_Zeile);
             ASM_Zeile:='        PUSH       R19';
             ASM_Datei.Add(ASM_Zeile);
             }

             {

             ASM_Datei.Add(ASM_Zeile);
             ASM_Zeile:='        PUSH       R20';
             ASM_Datei.Add(ASM_Zeile);
             ASM_Zeile:='        PUSH       R21';
             ASM_Datei.Add(ASM_Zeile);
             ASM_Zeile:='        PUSH       R22';
             ASM_Datei.Add(ASM_Zeile);
             ASM_Zeile:='        PUSH       R23';
             ASM_Datei.Add(ASM_Zeile);
             ASM_Zeile:='        PUSH       R24';
             ASM_Datei.Add(ASM_Zeile);
             ASM_Zeile:='        PUSH       R25';
             ASM_Datei.Add(ASM_Zeile);
             ASM_Zeile:='        PUSH       R26';
             ASM_Datei.Add(ASM_Zeile);
             ASM_Zeile:='        PUSH       R27';
             ASM_Datei.Add(ASM_Zeile);
             ASM_Zeile:='        PUSH       R28';
             ASM_Datei.Add(ASM_Zeile);
             ASM_Zeile:='        PUSH       R29';
             ASM_Datei.Add(ASM_Zeile);
             ASM_Zeile:='        PUSH       R30';
             ASM_Datei.Add(ASM_Zeile);
             ASM_Zeile:='        PUSH       R31';
             ASM_Datei.Add(ASM_Zeile);

             ASM_Zeile:='        PUSH       R0';
             ASM_Datei.Add(ASM_Zeile);
             ASM_Zeile:='        PUSH       R1';
             ASM_Datei.Add(ASM_Zeile);
             ASM_Zeile:='        PUSH       R2';
             ASM_Datei.Add(ASM_Zeile);
             ASM_Zeile:='        PUSH       R3';
             ASM_Datei.Add(ASM_Zeile);
             ASM_Zeile:='        PUSH       R4';
             ASM_Datei.Add(ASM_Zeile);
             ASM_Zeile:='        PUSH       R5';
             ASM_Datei.Add(ASM_Zeile);
             ASM_Zeile:='        PUSH       R6';
             ASM_Datei.Add(ASM_Zeile);
             ASM_Zeile:='        PUSH       R7';
             ASM_Datei.Add(ASM_Zeile);
             ASM_Zeile:='        PUSH       R8';
             ASM_Datei.Add(ASM_Zeile);
             ASM_Zeile:='        PUSH       R9';
             ASM_Datei.Add(ASM_Zeile);
             ASM_Zeile:='        PUSH       R10';
             ASM_Datei.Add(ASM_Zeile);
             ASM_Zeile:='        PUSH       R11';
             ASM_Datei.Add(ASM_Zeile);
             ASM_Zeile:='        PUSH       R12';
             ASM_Datei.Add(ASM_Zeile);
             ASM_Zeile:='        PUSH       R13';
             ASM_Datei.Add(ASM_Zeile);
             ASM_Zeile:='        PUSH       R14';
             ASM_Datei.Add(ASM_Zeile);
             ASM_Zeile:='        PUSH       R15';
             ASM_Datei.Add(ASM_Zeile);
             }

           end; { STM_isr_push }




         STM_isr_pop :
           begin
              {
             ASM_Zeile:='        POP        R15';
             ASM_Datei.Add(ASM_Zeile);
             ASM_Zeile:='        POP        R14';
             ASM_Datei.Add(ASM_Zeile);
             ASM_Zeile:='        POP        R13';
             ASM_Datei.Add(ASM_Zeile);
             ASM_Zeile:='        POP        R12';
             ASM_Datei.Add(ASM_Zeile);
             ASM_Zeile:='        POP        R11';
             ASM_Datei.Add(ASM_Zeile);
             ASM_Zeile:='        POP        R10';
             ASM_Datei.Add(ASM_Zeile);
             ASM_Zeile:='        POP        R9';
             ASM_Datei.Add(ASM_Zeile);
             ASM_Zeile:='        POP        R8';
             ASM_Datei.Add(ASM_Zeile);
             ASM_Zeile:='        POP        R7';
             ASM_Datei.Add(ASM_Zeile);
             ASM_Zeile:='        POP        R6';
             ASM_Datei.Add(ASM_Zeile);
             ASM_Zeile:='        POP        R5';
             ASM_Datei.Add(ASM_Zeile);
             ASM_Zeile:='        POP        R4';
             ASM_Datei.Add(ASM_Zeile);
             ASM_Zeile:='        POP        R3';
             ASM_Datei.Add(ASM_Zeile);
             ASM_Zeile:='        POP        R2';
             ASM_Datei.Add(ASM_Zeile);
             ASM_Zeile:='        POP        R1';
             ASM_Datei.Add(ASM_Zeile);
             ASM_Zeile:='        POP        R0';
             ASM_Datei.Add(ASM_Zeile);


             ASM_Zeile:='        POP        R31';
             ASM_Datei.Add(ASM_Zeile);
             ASM_Zeile:='        POP        R30';
             ASM_Datei.Add(ASM_Zeile);
             ASM_Zeile:='        POP        R29';
             ASM_Datei.Add(ASM_Zeile);
             ASM_Zeile:='        POP        R28';
             ASM_Datei.Add(ASM_Zeile);
             ASM_Zeile:='        POP        R27';
             ASM_Datei.Add(ASM_Zeile);
             ASM_Zeile:='        POP        R26';
             ASM_Datei.Add(ASM_Zeile);
             ASM_Zeile:='        POP        R25';
             ASM_Datei.Add(ASM_Zeile);
             ASM_Zeile:='        POP        R24';
             ASM_Datei.Add(ASM_Zeile);
             ASM_Zeile:='        POP        R23';
             ASM_Datei.Add(ASM_Zeile);
             ASM_Zeile:='        POP        R22';
             ASM_Datei.Add(ASM_Zeile);
             ASM_Zeile:='        POP        R21';
             ASM_Datei.Add(ASM_Zeile);
             ASM_Zeile:='        POP        R20';
             ASM_Datei.Add(ASM_Zeile);
             }

               {
             ASM_Zeile:='        POP        R19';
             ASM_Datei.Add(ASM_Zeile);
             ASM_Zeile:='        POP        R18';
             ASM_Datei.Add(ASM_Zeile);
             ASM_Zeile:='        POP        R17';
             ASM_Datei.Add(ASM_Zeile);
             }

             ASM_Zeile:='        POP        R16';
             ASM_Datei.Add(ASM_Zeile);
             ASM_Zeile:='        OUT        SREG,R16';
             ASM_Datei.Add(ASM_Zeile);
             ASM_Zeile:='        POP        R16';
             ASM_Datei.Add(ASM_Zeile);

           end; { STM_isr_pop }





         STM_arr_to_adress :
           begin
             ASM_Zeile:='        LDI        R16, LOW('+STM_LISTE[VT_Zaehler].parameter2+
                                                       STM_LISTE[VT_Zaehler].parameter1+')';
             ASM_Datei.Add(ASM_Zeile);
             ASM_Zeile:='        LDI        R17, HIGH('+STM_LISTE[VT_Zaehler].parameter2+
                                                        STM_LISTE[VT_Zaehler].parameter1+')';
             ASM_Datei.Add(ASM_Zeile);
           end; { STM_arr_to_adress }




         STM_adress_to_arr :
           begin
             ASM_Zeile:='        LDS        ZL, '+STM_LISTE[VT_Zaehler].parameter1;
             ASM_Datei.Add(ASM_Zeile);
             ASM_Zeile:='        LDS        ZH, '+STM_LISTE[VT_Zaehler].parameter1+'+1';
             ASM_Datei.Add(ASM_Zeile);
             ASM_Zeile:='        ADD        ZL, R16';
             ASM_Datei.Add(ASM_Zeile);
             ASM_Zeile:='        ADC        ZH, R17';
             ASM_Datei.Add(ASM_Zeile);
             ASM_Zeile:='        LD         R16, Z';
             ASM_Datei.Add(ASM_Zeile);
           end; { STM_adress_to_arr }





      else
        Fehler_cl.Registrieren('ZwischenCode/Start_ZWC','kein statement <'+
                               STM_LISTE[VT_Zaehler].Parameter1+'>',
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

      end; { case ZC_STM_TAB[VT_Zaehler].statement of }

    end; { for VT_Zaehler:=1 to ZC_STM_TAB_counter-1 do }
    ASM_Datei.Add(' ');
  end; { if ZC_STM_TAB_counter>1 then }




  { - Unterprogramm-Liste - }
  if ASM_UP_Liste.Count>0 then begin
    ASM_Datei.Add('; *** Unterprogramm Bibliothek ***');
    ASM_UP_Datei:=TStringList.Create;
    for VT_Zaehler:=0 to ASM_UP_Liste.Count-1 do begin

      UP_DateiName:=Form_RP.ronpas_path+'\'+asm_up_path+'\'+ASM_UP_Liste[VT_Zaehler];

      if FileExists(UP_DateiName) then begin
        ASM_UP_Datei.LoadFromFile(UP_DateiName);
        for VX_Zaehler:=0 to ASM_UP_Datei.Count-1 do begin
          ASM_Zeile:=ASM_UP_Datei[VX_Zaehler];
          ASM_Datei.Add(ASM_Zeile);
        end; { for VX_Zaehler:=0 to ASM_UP_Datei.Count-1 do }
      end { if FileExists(ASM_UP_Liste[VT_Zaehler]) then }
      else
        Fehler_cl.Registrieren('ZwischenCode/Start_ZWC','Die Datei: <'+
                               UP_DateiName+'> aus der Unterprogramm Bibliothek konnte nicht gefunden werden',
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

    end; { for VT_Zaehler:=0 to ASM_UP_Liste.Count-1 do }
    ASM_Datei.Add(' ');
    ASM_UP_Datei.Free;
  end; { if ASM_UP_Liste.Count>0 then }








  { - Namen-Liste - }
  if NAME_TAB_counter>1 then begin
    ASM_Datei.Add('; *** Namen-Liste ***');
    ASM_Datei.Add(';');
    for VT_Zaehler:=1 to NAME_TAB_counter-1 do begin
      ASM_Zeile:='; '+NAME_TAB[VT_Zaehler].Bezeichner+' ('+NAME_TAB[VT_Zaehler].ANW_type+') ';
      if not (NAME_TAB[VT_Zaehler].ANW_type IN ['P','F','A']) then
        ASM_Zeile:=ASM_Zeile+TYPE_IN_TYPENAME(NAME_TAB[VT_Zaehler].ASM_type);

      case NAME_TAB[VT_Zaehler].ANW_type of
        'C' : ASM_Zeile:=ASM_Zeile+' Wert='+NAME_TAB[VT_Zaehler].Wert;
        'L' : ASM_Zeile:=ASM_Zeile+' Procedure='+NAME_TAB[VT_Zaehler].Wert;
        'Z' : ASM_Zeile:=ASM_Zeile+' Procedure='+NAME_TAB[VT_Zaehler].Wert;
      end;

      ASM_Datei.Add(ASM_Zeile);

    end; { for VT_Zaehler:=1 to NAME_TAB_counter-1 do }
    ASM_Datei.Add(' ');
  end; { if NAME_TAB_counter>1 then }




  if PROC_LIS.counter>1 then begin

    ASM_Datei.Add('; *** Prozedur/Function-Liste ***');
    ASM_Datei.Add(';');
    for VT_Zaehler:=1 to PROC_LIS.counter-1 do begin

      if PROC_LIS.LISTE[VT_Zaehler].ANW_Type='P' then begin

        ASM_Zeile:='; PROCEDURE '+PROC_LIS.LISTE[VT_Zaehler].Name;

        if PROC_LIS.LISTE[VT_Zaehler].counter>1 then begin
          for VX_Zaehler:=1 to PROC_LIS.LISTE[VT_Zaehler].counter-1 do begin
            ASM_Zeile:=ASM_Zeile+' ('+PROC_LIS.LISTE[VT_Zaehler].PPR_ARR[VX_Zaehler].Parameter+
                     ' : '+ TYPE_IN_TYPENAME(PROC_LIS.LISTE[VT_Zaehler].PPR_ARR[VX_Zaehler].ASM_type) +')';

          end; { for VX_Zaehler:=1 to }
        end; { if PROC_LISTE[PROC_LISTE_counter] }

        ASM_Zeile:=ASM_Zeile+';';

      end; { if PROC_LIS.LISTE[VT_Zaehler].ANW_Type='P' then }


      if PROC_LIS.LISTE[VT_Zaehler].ANW_Type='F' then begin

        ASM_Zeile:='; FUNCTION '+PROC_LIS.LISTE[VT_Zaehler].Name;

        if PROC_LIS.LISTE[VT_Zaehler].counter>1 then begin
          for VX_Zaehler:=1 to PROC_LIS.LISTE[VT_Zaehler].counter-1 do begin
            ASM_Zeile:=ASM_Zeile+' ('+PROC_LIS.LISTE[VT_Zaehler].PPR_ARR[VX_Zaehler].Parameter+
                     ' : '+ TYPE_IN_TYPENAME(PROC_LIS.LISTE[VT_Zaehler].PPR_ARR[VX_Zaehler].ASM_type) +')';

          end; { for VX_Zaehler:=1 to }
        end; { if PROC_LISTE[PROC_LISTE_counter] }

        ASM_Zeile:=ASM_Zeile+' : '+TYPE_IN_TYPENAME(PROC_LIS.LISTE[VT_Zaehler].RESULT.ASM_type)+';';

      end; { if PROC_LIS.LISTE[VT_Zaehler].ANW_Type='F' then }


      ASM_Datei.Add(ASM_Zeile);

    end; { for VT_Zaehler:=1 to NAME_TAB_counter-1 do }
    ASM_Datei.Add(' ');

  end; { if PROC_LISTE_counter>1 then }





  if CONST_ARRAY.counter>0 then begin


    ASM_Datei.Add('; *** Konstanten-ARRAYs ***');
    ASM_Datei.Add(';');
    for VT_Zaehler:=1 to CONST_ARRAY.counter do begin

      ASM_Datei.Add(' ');
      ASM_Zeile:=CONST_ARRAY.LISTE[VT_Zaehler].Bezeichner+':';
      ASM_Datei.Add(ASM_Zeile);

      for VX_Zaehler:=0 to CONST_ARRAY.LISTE[VT_Zaehler].Werte.Count-1 do begin

          case CONST_ARRAY.LISTE[VT_Zaehler].ASM_type of
            AT_byte, AT_boolean, AT_char : begin

                if (VX_Zaehler mod 2)=0 then begin
                  ASM_Zeile:='.db    '+CONST_ARRAY.LISTE[VT_Zaehler].Werte[VX_Zaehler];
                end
                else begin
                  ASM_Zeile:=ASM_Zeile+','+CONST_ARRAY.LISTE[VT_Zaehler].Werte[VX_Zaehler];
                  ASM_Datei.Add(ASM_Zeile);
                end; { if (VX_Zaehler mod 2)=0 then }

              end; { AT_byte, AT_boolean, AT_char }

            AT_word : begin
                ASM_Zeile:='.dw    '+CONST_ARRAY.LISTE[VT_Zaehler].Werte[VX_Zaehler];
                ASM_Datei.Add(ASM_Zeile);
              end; { AT_word }

            AT_dword : begin
                STR_Wert1:=CONST_ARRAY.LISTE[VT_Zaehler].Werte[VX_Zaehler];
                STR_Wert2:='0x'+Copy(STR_Wert1,5,4);
                ASM_Zeile:='.dw    '+STR_Wert2;
                ASM_Datei.Add(ASM_Zeile);
                STR_Wert2:='0x'+Copy(STR_Wert1,1,4);
                ASM_Zeile:='.dw    '+STR_Wert2;
                ASM_Datei.Add(ASM_Zeile);
              end; { AT_dword }

          else
            Fehler_cl.Registrieren('ZwischenCode/Start_ZWC','Der ASM_type <'+
                               Compiler_cl.ASM_type_Typ_in_Bezeichner(CONST_ARRAY.LISTE[VT_Zaehler].ASM_type)+
                               '> aus der Konstanten-ARRAY <' +
                               CONST_ARRAY.LISTE[VT_Zaehler].Bezeichner +
                               '> wird nicht unterstuetzt',
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);
          end; { case CONST_ARRAY.LISTE[VT_Zaehler].ASM_type of }


      end; { for VX_Zaehler:=0 to CONST_ARRAY.LISTE[VT_Zaehler].Werte.Count-1 do }

      if CONST_ARRAY.LISTE[VT_Zaehler].ASM_type=AT_byte then begin
        if (CONST_ARRAY.LISTE[VT_Zaehler].Werte.Count mod 2)<>0 then begin
          ASM_Zeile:=ASM_Zeile+',0x00';
          ASM_Datei.Add(ASM_Zeile);
        end;
      end; { if CONST_ARRAY.LISTE[VT_Zaehler].ASM_type=AT_byte then }

    end; { for VT_Zaehler:=1 to CONST_ARRAY.counter do }

    ASM_Datei.Add(' ');

  end; { if CONST_ARRAY.counter>0 then }




  if STRING_Liste.Count>0 then begin


    ASM_Datei.Add('; *** Konstanten-STRING-Liste ***');
    ASM_Datei.Add(';');
    for VT_Zaehler:=0 to STRING_Liste.Count-1 do begin

      ASM_Datei.Add(' ');
      ASM_Zeile:='M_CONST_STRING_'+IntToStr(VT_Zaehler)+':';
      ASM_Datei.Add(ASM_Zeile);
      UP_DateiName:=STRING_Liste[VT_Zaehler];
      UP_DateiName:=Copy(UP_DateiName,2,Length(UP_DateiName)-2);
      ASM_Zeile:=' .db    '+IntToStr(Length(UP_DateiName))+', '+CHR($22)+UP_DateiName;
      if (Length(UP_DateiName) mod 2)=0 then
        ASM_Zeile:=ASM_Zeile+' ';

      ASM_Zeile:=ASM_Zeile+CHR($22);
      ASM_Datei.Add(ASM_Zeile);
    end; { for VT_Zaehler:=0 to STRING_Liste.Count-1 do }

    ASM_Datei.Add(' ');

  end; { if STRING_Liste.Count>0 then }










  if ISR_LISTE.enable then begin

    ASM_Datei.Add('; *** ISR-Liste ***');
    ASM_Datei.Add(';');
    for VT_Zaehler:=2 to ISR_LISTE.max_anzahl do begin

      if ISR_LISTE.LISTE[VT_Zaehler].ORG_Name>'' then begin

        ASM_Zeile:='; Nummer='+IntToStr(VT_Zaehler);

        while Length(ASM_Zeile)<13 do
          ASM_Zeile:=ASM_Zeile+' ';

        ASM_Zeile:=ASM_Zeile+' ORG='+ISR_LISTE.LISTE[VT_Zaehler].ORG_Name;

        while Length(ASM_Zeile)<30 do
          ASM_Zeile:=ASM_Zeile+' ';

        ASM_Zeile:=ASM_Zeile+' ISR='+ISR_LISTE.LISTE[VT_Zaehler].ISR_Name;

        while Length(ASM_Zeile)<48 do
          ASM_Zeile:=ASM_Zeile+' ';

        ASM_Zeile:=ASM_Zeile+' Bemerkung='+ISR_LISTE.LISTE[VT_Zaehler].Bemerkung;

        ASM_Datei.Add(ASM_Zeile);

      end; { if ISR_LISTE.LISTE[VT_Zaehler].ORG_Name>'' then }

    end; { for VT_Zaehler:=0 to STRING_Liste.Count-1 do }

    ASM_Datei.Add(' ');

  end; { if ISR_LISTE.enable then }



  ASM_Datei.SaveToFile(Form_RP.source_path+'\'+Form_RP.source_name+'.asm');
  ASM_UP_Liste.Free;


end; { procedure Start_ZWC }




