unit ZwischenCode;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils,

  CompilerDeklarationen, Debugger_Form;



const
  asm_up_path   = 'rp_asm_up';



type



  // Scan-Item-Typ
  JMP_Sprungdistanz_Type = (JMP_nicht_definiert, JMP_Relativ, JMP_Word, JMP_als_EIJMP);




  ASM_Switch_Type = record
    // bei ATtiny mit kleinem RAM wird kein SPH-Register genutzt
    use_SPH : Boolean;
    // Nutzung des Befehls MOVW
    use_MOVW : Boolean;
    // Nutzung aller Befehle des ATMega MUL
    use_MUL : Boolean;
    // LPM erweitern auf ELPM
    LPM_erweitern_auf_ELPM : Boolean;
    //
    JMP_Sprungdistanz : JMP_Sprungdistanz_Type;
  end;


  ZWC_class = class(TObject)
   public
     Program_Name : String;


     // !!!!!! Wichtige Schalter fuer die Mikrocontroller-Typen !!!!!!!!!!!
     ASM_Include_Datei, AVRDUDE_Kurzbezeichnung : String;

     ASM_Switch : ASM_Switch_Type;



     constructor Create;

     procedure Fehler_melden(Fehler_String_1, Fehler_String_2 : String);

     { VAR }
     function VAR_NAME_eintragen(VN : String) : Boolean;
     function VAR_LISTE_eintragen(VL : String) : Boolean;
     procedure Type_in_VAR_Liste_eintragen(VT : String);
     function VAR_TYPE_eintragen(VT : String) : Boolean;
     function VAR_BIT_REGISTER_eintragen(VBR : String) : Boolean;
     function VAR_BIT_POSITION_eintragen(VB_POS : String) : Boolean;
     function VAR_BIT_TYPE_eintragen(VB_TYPE : String) : Boolean;

     procedure VAR_ARRAY_von_eintragen(VAV : String; VAV_UT : SI_Unter_Typ);
     procedure VAR_ARRAY_bis_eintragen(VAB : String; VAB_UT : SI_Unter_Typ);
     function VAR_ARRAY_CONST_bis_eintragen(VAC : String) : Boolean;





     procedure VAR_ARRAY_2d_von_eintragen(VAV : String; VAV_UT : SI_Unter_Typ);
     procedure VAR_ARRAY_2d_bis_eintragen(VAB : String; VAB_UT : SI_Unter_Typ);
     function VAR_ARRAY_2d_CONST_bis_eintragen(VAC : String) : Boolean;





     procedure VAR_ARRAY_Type_eintragen(VAT : String);
     function VAR_STRING_Type_eintragen(VST : String) : Boolean;
     procedure VAR_STRING_LEN_eintragen(VSL : String; VSL_UT : SI_Unter_Typ);
     function VAR_Ende : Boolean;

     { CONST }
     function CONST_NAME_eintragen(CN : String) : Boolean;
     function CONST_TYPE_eintragen(CT : String) : Boolean;
     function CONST_WERT_eintragen(CW : String; CUT : SI_Unter_Typ) : Boolean;
     function CONST_Bezeichner_eintragen(CB : String) : Boolean;
     procedure CONST_Operator_eintragen(C_OP : Char);
     function CONST_Term_berechnen : Boolean;
     function CONST_ARRAY_von_eintragen(CAA : String; CAA_UT : SI_Unter_Typ) : Boolean;
     function CONST_ARRAY_bis_WERT_eintragen(CAE : String; CAE_UT : SI_Unter_Typ) : Boolean;
     function CONST_ARRAY_bis_CONST_eintragen(CAE : String) : Boolean;
     function CONST_ARRAY_Type_eintragen(CAT : String) : Boolean;
     function CONST_ARRAY_Element_eintragen(CAE : String; CAE_UT : SI_Unter_Typ) : Boolean;
     procedure CONST_ARRAY_Ende_eintragen;

     { Zuweisung }
     function Name_in_PROC_LIS_suchen(S_NAME : String) : Integer;
     function Name_in_CONST_ARRAY_LIS_suchen(S_NAME : String) : Integer;
     function Name_in_VAR_ARRAY_LIS_suchen(S_NAME : String) : Integer;
     function Zuweisung_Ziel_eintragen(ZZ : String) : Boolean;
     function Zuweisung_Ziel_VAR_ARRAY_1D_eintragen(ZZ : String) : Boolean;
     function Zuweisung_Ziel_VAR_ARRAY_2D_eintragen(ZZ : String) : Boolean;
     procedure Zuweisung_Ziel_VAR_ARRAY_POS_1D_eintragen;
     procedure Zuweisung_Ziel_VAR_ARRAY_POS_2D_01_eintragen;
     procedure Zuweisung_Ziel_VAR_ARRAY_POS_2D_02_eintragen;


     procedure Zuweisung_Quelle_Fehlertest;
     function Zuweisung_Quelle_VAR_eintragen(Z_Quelle : String) : Boolean;
     function Zuweisung_Quelle_CONST_ARRAY_eintragen(Z_Quelle : String) : Boolean;



     function Zuweisung_Quelle_VAR_ARRAY_1D_eintragen(Z_Quelle : String) : Boolean;
     function Zuweisung_Quelle_VAR_ARRAY_2D_eintragen(Z_Quelle : String) : Boolean;

     procedure Zuweisung_Quelle_VAR_ARRAY_POS_1D_eintragen;

     procedure Zuweisung_Quelle_VAR_ARRAY_POS_2D_01_eintragen;

     procedure Zuweisung_Quelle_VAR_ARRAY_POS_2D_02_eintragen;


     function Zuweisung_Quelle_CONST_eintragen(Z_Quelle : String) : Boolean;
     function Zuweisung_Quelle_CONRD_eintragen(CW : String; CUT : SI_Unter_Typ; VZ_negativ : Boolean) : Boolean;
     function Zuweisung_Quelle_FKT_eintragen(FKT_Name : String) : Boolean;
     function Zuweisung_DZ_Operator_eintragen(UT_Operator : SI_Unter_Typ) : Boolean;
     function Zuweisung_Quelle_B2W_eintragen(B2W_Quelle : String) : Boolean;
     function Zuweisung_Quelle_B2C_eintragen(B2C_Quelle : String) : Boolean;
     function Zuweisung_Quelle_C2B_eintragen(C2B_Quelle : String) : Boolean;
     function Zuweisung_Quelle_LOW_eintragen(LOW_Quelle : String) : Boolean;
     function Zuweisung_Quelle_HIGH_eintragen(HIGH_Quelle : String) : Boolean;
     function Zuweisung_Quelle_BITHIGH_eintragen(TB_Quelle : String;
                                                 HL : Boolean) : Boolean;
     function Zuweisung_Quelle_LENGTH_eintragen(ZL_Quelle : String) : Boolean;

     function Zuweisung_Quelle_DWBYTE_eintragen(BytePosition : Integer;
                                                DWBYTE_Quelle : String) : Boolean;
     function Zuweisung_Quelle_DWLOW_eintragen(DWLOW_Quelle : String) : Boolean;
     function Zuweisung_Quelle_DWHIGH_eintragen(DWHIGH_Quelle : String) : Boolean;
     function Zuweisung_Quelle_WORDTODW_eintragen(WORDTODW_Quelle : String) : Boolean;
     function Zuweisung_Quelle_BYTETODW_eintragen(BYTETODW_Quelle : String) : Boolean;

     procedure Quelle_in_STM_TAB_eintragen(Q_Text : String; FaktorZaehler : Integer);
     procedure Zuweisung_Operator_Sprungmarken_in_STM(SprungMarke1, SprungMarke2 : String);
     procedure Zuweisung_Operator_ausfuehren(QuellenCounter : Integer);
     procedure Typeanpassung_bei_2_Faktoren;
     procedure Faktor_STM_TAB_eintragen(F_Text : String);
     procedure Ziel_in_STM_TAB_eintragen(Z_Text : String);
     procedure Zuweisung_in_STM_TAB_eintragen;



     { PROCEDURE / FUNCTION }
     function PROC_FUNC_name_eintragen(PNAME : String;
                                       ANWType : Char) : Boolean;
     function PROC_FUNC_name_vergleichen(PNAME : String) : Boolean;
     function PROC_FUNC_param_name_eintragen(PNAME : String;
                                             ANWType : CHAR) : Boolean;
     function PROC_FUNC_param_liste_eintragen(PLISTE : String;
                                              ANWType : CHAR) : Boolean;
     function naechstes_Register : String;
     function PROC_FUNC_param_type_eintragen(PTYPE : String) : Boolean;

     { CALL }
     function PCALL_name_vergleichen(CNAME : String) : Boolean;
     function PCALL_var_parameter_eintragen(PNAME : String) : Boolean;
     function PCALL_wert_parameter_eintragen(PW : String; PUT : SI_Unter_Typ) : Boolean;
     function PCALL_exec(ANWType : Char) : Boolean;

     { FUNCTION }
     function FUNCTION_result_type_eintragen(RTYPE : String) : Boolean;
     function FUNCTION_result_const_eintragen(RW : String; RUT : SI_Unter_Typ) : Boolean;
     function FUNCTION_result_var_const_eintragen(R_VAR : String) : Boolean;
     function FUNCTION_beenden : Boolean;

     { ISR }
     function ISR_NAME_RD(ISR_NAME : String) : Boolean;
     function ISR_NAME_CP(ISR_NAME : String) : Boolean;
     procedure EnableInts;
     procedure DisableInts;
     function ISR_LISTE_NR(ISR_NR : String) : Boolean;
     function ISR_LISTE_PAR(I_POS : Char; I_NAME : String) : Boolean;


     { FOR TO DO }
     procedure FTD_Ziel_uebernehmen;
     procedure FTD_Vergleich_uebernehmen;
     procedure FTD_Abschluss_der_Schleife;
     procedure FTD_Schalter_TO;
     procedure FTD_Schalter_DOWNTO;

     { LOOP }
     procedure loop_start;
     procedure loop_end;

     { IF THEN }
     procedure if_then_init;
     procedure if_then_start;
     procedure if_then_else;
     procedure if_then_end;

     { INC, DEC, SHL, SHR, NOP }
     function INC_var_lesen(INC_VAR_NAME : String) : Boolean;
     function DEC_var_lesen(DEC_VAR_NAME : String) : Boolean;
     function SHL_var_lesen(SHL_VAR_NAME : String) : Boolean;
     function SHR_var_lesen(SHR_VAR_NAME : String) : Boolean;
     procedure NOP_schreiben;

     { SETBIT, CLEARBIT }
     function SETBIT_var_lesen(SETBIT_VAR_NAME : String) : Boolean;
     function CLEARBIT_var_lesen(CLEARBIT_VAR_NAME : String) : Boolean;


     { WHILE }
     procedure while_init;
     procedure while_start;
     procedure while_end;


     { CASE }
     function CASE_var_lesen(CASE_VAR_NAME : String) : Boolean;
     procedure CASE_STM_Einzel_Element(ASM_Wert, Ori_Wert : String);
     procedure CASE_STM_Bereich_Element(ASM_Wert_von, ASM_Wert_bis,
                                        Ori_Wert_von, Ori_Wert_bis : String);
     procedure CASE_STM_Listen_Element(ASM_Wert, Ori_Wert : String);
     procedure CASE_STM_Listen_Element_Ende(ASM_Wert, Ori_Wert : String);
     function CASE_Element_Wert_lesen(EleType, CW : String; CUT : SI_Unter_Typ) : Boolean;
     function CASE_Element_CONST_lesen(EleType, CEC : String) : Boolean;
     procedure CASE_Einzel_Element;
     procedure CASE_Listen_Element_Ende;
     procedure case_else;
     procedure case_end;



     { sonstiges }
     procedure ASM_Zeilen_in_Assembler(ZeiNr_Anfang, ZeiNr_Ende : String);
     function DEFINE_lesen(DEF_NAME : String) : Boolean;
     procedure Kopfteil_Code_Segment;
     procedure Einsprung_Hauptprogramm_eintragen;
     procedure Start_ZWC;
     procedure Ruecksetzen;
     destructor Destroy; override;
   private
     ASM_Datei : TStringList;
     VAR_Liste_aktiv : Boolean;
     VAR_Listen_Pos, Marken_Zaehler : Integer;
     STRING_Liste : TStringList;

     // Name-Tab
     NAME_TAB : array [1..LEN_NAME_TAB] of NT_REC;
     NAME_TAB_counter : Integer;

     // Konstanten-Array-Liste
     CONST_ARRAY : CONST_ARRAY_LIS;

     // Konstanten-Term-Liste
     CONST_TERM : CONST_TERM_LIS;

     // Variablen-Array-Liste
     VAR_ARRAY : VAR_ARRAY_LIS;

     // Bit-Liste
     BIT_LIS : BIT_LIS_REC;

     // Zuweisung
     ZUW_LIS : ZUW_LIS_REC;

     // Procedure-Liste
     PROC_LIS : PROC_LIS_REC;

     // aktuelle CALL-PROC
     akt_CALL_PROC : akt_CALL_REC;

     // FOR TO DO
     FTD_LIS : FTD_LIS_REC;

     // LOOP
     LOOP_MARKE : LOOP_REC;

     // IF THEN
     IF_THEN_LIS : IF_THEN_LIS_REC;

     // WHILE
     WHILE_LIS : WHILE_LIS_REC;

     // CASE
     CASE_LIS : CASE_LIS_REC;

     // ISR-Liste
     ISR_LISTE : ISR_LIS_REC;


     // Statement-Liste
     STM_LISTE : array [1..LEN_STM_LISTE] of STM_REC;
     STM_LISTE_counter : Integer;
     REG_ARRAY_LOW_pointer : Integer;

     function erzeuge_Marke(Bezeichner : String) : String;
     procedure Ruecksetzen_akt_CALL_PROC;
     procedure Ruecksetzen_Zuweisung;
     procedure Loeschen_ZuweisungsListe;
     function TYPENAME_IN_TYPE(TyNa : String) : ASM_type_Typ;
     function TYPE_IN_TYPENAME(AsTy : ASM_type_Typ) : String;

     function NAME_vorhanden(SNAME : String) : Boolean;
     function NAME_und_ANW_TO_TYPE(SNAME : String; A_TYPE : Char) : ASM_type_Typ;
     function NAME_und_ANW_type_vorhanden(SNAME : String; ANW_type : Char) : Boolean;
     function NAME_TO_ANW_und_ASM(SNAME : String;
                                  var S_ANW_type : Char;
                                  var S_ASM_type : ASM_type_Typ) : Boolean;
     function NAME_in_NAME_TAB_suchen(SNAME : String) : Integer;

     function CONST_NAME_TO_WERT(S_NAME : String) : String;
     function CONST_WERT_ueberpruefen(var CW : String; CUT : SI_Unter_Typ; CT : ASM_type_Typ) : Boolean;
     procedure Inc_STM_TAB_counter;
     procedure Inc_NAME_TAB_counter;
     procedure Inc_PROC_LISTE_counter;
     procedure Inc_akt_CALL_PROC_counter;
     procedure Inc_FTD_LISTE_counter;
     procedure Inc_IF_THEN_LIS_counter;
     procedure Inc_WHILE_LIS_counter;
     procedure Inc_CASE_LIS_counter;
     procedure Inc_ZUW_Quelle_counter;
     procedure Inc_ZUW_LIS_LISTcounter;
     procedure Inc_CONST_ARRAY_counter;
     procedure Inc_CONST_TERM_counter;
     procedure Inc_VAR_ARRAY_counter;
     procedure Inc_BIT_LIS_counter;
     function lokalen_Parameter_suchen(P_Name : String) : Integer;
     function BIT_LIS_suchen(BIT_Name : String) : Integer;
     function BIT_TO_ByteMaske(BIT_Pos : Byte) : String;

   end; { ZWC_class = class(TObject) }


var
  ZWC_cl : ZWC_class;



implementation

uses
  Main_Unit, Modul_Compiler, Modul_Parser,
  Device_Form;



constructor ZWC_class.Create;
begin
  Ruecksetzen;
  ASM_Datei := TStringList.Create;
  STRING_Liste := TStringList.Create;

end;  { constructor ZWC_class.Create }





procedure ZWC_class.Fehler_melden(Fehler_String_1, Fehler_String_2 : String);
begin

  Fehler_cl.Registrieren(Fehler_String_1, Fehler_String_2,
                         Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                         Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                         Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

end;  { procedure ZWC_class.Fehler_melden }





procedure ZWC_class.Ruecksetzen_akt_CALL_PROC;
var
  ZC_Zaeher : Integer;
begin
  for ZC_Zaeher:=1 to Laenge_akt_CALL_Liste do begin
    akt_CALL_PROC.PPR_ARR[ZC_Zaeher].Parameter:='';
    akt_CALL_PROC.PPR_ARR[ZC_Zaeher].ASM_type:=AT_kein_typ;
    akt_CALL_PROC.PPR_ARR[ZC_Zaeher].Register_L:='';
    akt_CALL_PROC.PPR_ARR[ZC_Zaeher].Register_H:='';
    akt_CALL_PROC.PPR_ARR[ZC_Zaeher].ANW_Type:='X';
  end;

  akt_CALL_PROC.PROC_Pos:=0;
  akt_CALL_PROC.Name:='';
  akt_CALL_PROC.counter:=1;

end;  { procedure ZWC_class.Ruecksetzen_PROCEDURE }




// Loeschen aller Zwischenwerte der Zuweisung
procedure ZWC_class.Ruecksetzen_Zuweisung;
var
  Z_Zaehler : Integer;
begin
  with ZUW_LIS.LISTE[ZUW_LIS.LISTcounter] do begin
    Ziel:='';
    Ziel_ASM_type:=AT_kein_typ;
    Ziel_ASM_Grund_type:=AT_kein_typ;
    Ziel_ANW_type:='X';
    Ziel_ANW_type2:='X';
    nur_eine_Quelle:=false;
    nur_ein_Array:=false;

    for Z_Zaehler:=1 to 30 do begin
      Quelle[Z_Zaehler].Name:='';
      Quelle[Z_Zaehler].Wert:='';

      Quelle[Z_Zaehler].ASM_type:=AT_kein_typ;
      Quelle[Z_Zaehler].ASM_Grund_type:=AT_kein_typ;
      Quelle[Z_Zaehler].ANW_type:='X';
      Quelle[Z_Zaehler].ANW_type2:='X';

      Quelle[Z_Zaehler].Q_Operator:=kein_UT;

    end; { for Z_Zaehler:=1 to 30 do }

    QUELLcounter:=0;

  end; { with ZUW_LIS.LISTE[ZUW_LIS.counter] do }

  DEC(ZUW_LIS.LISTcounter);

  if ZUW_LIS.LISTcounter<0 then
    Fehler_cl.Registrieren('ZwischenCode/Ruecksetzen_Zuweisung',
                           'der ZUW_LIS.LISTcounter ist kleiner 0 (keine Zuweisungsebene)',
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

end; { procedure ZWC_class.Ruecksetzen_Zuweisung }




procedure ZWC_class.Loeschen_ZuweisungsListe;
var
  Z_Zaehler : Integer;
begin

  ZUW_LIS.LISTcounter:=10;
  for Z_Zaehler:=10 downto 1 do begin
    Ruecksetzen_Zuweisung;
  end; { for Z_Zaehler:=10 to 1 downto }

end; { procedure ZWC_class.Ruecksetzen_Zuweisung }






procedure ZWC_class.Ruecksetzen;
var
  ZC_Zaeher, ZC_Zaeher2 : Integer;

begin


  // Namen-Liste
  for ZC_Zaeher:=1 to LEN_NAME_TAB do begin
    NAME_TAB[ZC_Zaeher].Bezeichner:='';
    NAME_TAB[ZC_Zaeher].Wert:='';
    NAME_TAB[ZC_Zaeher].ASM_type:=AT_kein_typ;
    NAME_TAB[ZC_Zaeher].ASM_type2:=AT_kein_typ;
    NAME_TAB[ZC_Zaeher].ANW_type:='X';
    NAME_TAB[ZC_Zaeher].ANW_type2:='X';
    NAME_TAB[ZC_Zaeher].Laenge:=0;
  end;
  NAME_TAB_counter:=1;



  // Prozedur-Liste
  for ZC_Zaeher:=1 to LEN_PROC_LISTE do begin

    PROC_LIS.LISTE[ZC_Zaeher].Name:='';
    PROC_LIS.LISTE[ZC_Zaeher].ANW_Type:='X';
    PROC_LIS.LISTE[ZC_Zaeher].RESULT_vorhanden:=false;
    PROC_LIS.LISTE[ZC_Zaeher].counter:=1;
    PROC_LIS.LISTE[ZC_Zaeher].REG_ARRAY_LOW_pointer:=1;

    for ZC_Zaeher2:=1 to 10 do begin
      PROC_LIS.LISTE[ZC_Zaeher].PPR_ARR[ZC_Zaeher2].ASM_type:=AT_kein_typ;
      PROC_LIS.LISTE[ZC_Zaeher].PPR_ARR[ZC_Zaeher2].Parameter:='';
      PROC_LIS.LISTE[ZC_Zaeher].PPR_ARR[ZC_Zaeher2].Register_L:='';
      PROC_LIS.LISTE[ZC_Zaeher].PPR_ARR[ZC_Zaeher2].Register_H:='';
      PROC_LIS.LISTE[ZC_Zaeher].PPR_ARR[ZC_Zaeher2].ANW_Type:='X';
    end;

    PROC_LIS.LISTE[ZC_Zaeher].RESULT.ASM_type:=AT_kein_typ;
    PROC_LIS.LISTE[ZC_Zaeher].RESULT.Parameter:='';
    PROC_LIS.LISTE[ZC_Zaeher].RESULT.Register_L:='';
    PROC_LIS.LISTE[ZC_Zaeher].RESULT.Register_H:='';
    PROC_LIS.LISTE[ZC_Zaeher].RESULT.ANW_Type:='X';

  end; { for ZC_Zaeher:=1 to LEN_PROC_LISTE do }

  PROC_LIS.counter:=1;



  // Statement-Liste
  for ZC_Zaeher:=1 to LEN_STM_LISTE do begin
    STM_LISTE[ZC_Zaeher].Statement:=STM_kein;
    STM_LISTE[ZC_Zaeher].Bemerkung:='';
    STM_LISTE[ZC_Zaeher].Parameter1:='';
    STM_LISTE[ZC_Zaeher].Parameter2:='';
  end;
  STM_LISTE_counter:=1;


  // FOR_TO_DO-Liste
  for ZC_Zaeher:=1 to Laenge_FTD_Liste do begin
    FTD_LIS.LISTE[ZC_Zaeher].Ziel:='';
    FTD_LIS.LISTE[ZC_Zaeher].Marke_Start:='';
    FTD_LIS.LISTE[ZC_Zaeher].Marke_StatementList:='';
    FTD_LIS.LISTE[ZC_Zaeher].Marke_Ende:='';
    FTD_LIS.LISTE[ZC_Zaeher].ASM_type:=AT_kein_typ;
    FTD_LIS.LISTE[ZC_Zaeher].Ziel_ANW_type:='X';
    FTD_LIS.LISTE[ZC_Zaeher].to_downto:=true;
  end; { for ZC_Zaeher:=1 to Laenge_FTD_Liste do }

  FTD_LIS.counter:=0;


  // Konstanten-Array-Liste
  for ZC_Zaeher:=1 to Laenge_CONST_ARRAY_Liste do begin
    CONST_ARRAY.LISTE[ZC_Zaeher].Bezeichner:='';
    CONST_ARRAY.LISTE[ZC_Zaeher].Anfang:=0;
    CONST_ARRAY.LISTE[ZC_Zaeher].Laenge:=0;
    CONST_ARRAY.LISTE[ZC_Zaeher].ASM_type:=AT_kein_typ;
    CONST_ARRAY.LISTE[ZC_Zaeher].Werte:=TStringList.Create;
  end; { for ZC_Zaeher:=1 to Laenge_CONST_ARRAY_Liste do }

  CONST_ARRAY.counter:=0;


  // Konstanten-Term-Liste
  for ZC_Zaeher:=1 to Laenge_CONST_TERM_Liste do begin
    CONST_TERM.LISTE[ZC_Zaeher].Kennzeichner:=' ';
    CONST_TERM.LISTE[ZC_Zaeher].Wert:='';
  end; { for ZC_Zaeher:=1 to Laenge_CONST_ARRAY_Liste do }

  CONST_TERM.counter:=0;



  // Variablen-Array-Liste
  for ZC_Zaeher:=1 to Laenge_VAR_ARRAY_Liste do begin
    VAR_ARRAY.LISTE[ZC_Zaeher].Bezeichner:='';
    VAR_ARRAY.LISTE[ZC_Zaeher].Anfang_1d:=0;
    VAR_ARRAY.LISTE[ZC_Zaeher].Laenge_1d:=0;
    VAR_ARRAY.LISTE[ZC_Zaeher].Anfang_2d:=0;
    VAR_ARRAY.LISTE[ZC_Zaeher].Laenge_2d:=0;
    VAR_ARRAY.LISTE[ZC_Zaeher].Array_ist_1d:=true;
    VAR_ARRAY.LISTE[ZC_Zaeher].ASM_type:=AT_kein_typ;
  end; { for ZC_Zaeher:=1 to Laenge_VAR_ARRAY_Liste do }

  VAR_ARRAY.counter:=0;


  // Bit-Liste
  for ZC_Zaeher:=1 to Laenge_Bit_Liste do begin
    BIT_LIS.LISTE[ZC_Zaeher].Bezeichner:='';
    BIT_LIS.LISTE[ZC_Zaeher].VAR_REG:='';
    BIT_LIS.LISTE[ZC_Zaeher].ANW_Type:='X';
    BIT_LIS.LISTE[ZC_Zaeher].ASM_type:=AT_kein_typ;
    BIT_LIS.LISTE[ZC_Zaeher].ASM_Grund_type:=AT_kein_typ;
    BIT_LIS.LISTE[ZC_Zaeher].Bit_Position:=0;
  end; { for ZC_Zaeher:=1 to Laenge_Bit_Liste do }

  BIT_LIS.counter:=0;



  // IF_THEN_LIS-Liste
  for ZC_Zaeher:=1 to Lange_IF_THEN_Liste do begin
    IF_THEN_LIS.LISTE[ZC_Zaeher].Start_Marke:='';
    IF_THEN_LIS.LISTE[ZC_Zaeher].Ende_Else_Marke:='';
    IF_THEN_LIS.LISTE[ZC_Zaeher].Ende_True_Marke:='';
    IF_THEN_LIS.LISTE[ZC_Zaeher].mit_Else:=false;
  end; { for ZC_Zaeher:=1 to Lange_IF_THEN_Liste do }

  IF_THEN_LIS.counter:=0;



  // WHILE-Liste
  for ZC_Zaeher:=1 to Laenge_While_Liste do begin
    WHILE_LIS.LISTE[ZC_Zaeher].Start_Marke:='';
    WHILE_LIS.LISTE[ZC_Zaeher].Ende_Marke:='';
    WHILE_LIS.LISTE[ZC_Zaeher].Vergleich_Marke:='';
  end; { for ZC_Zaeher:=1 to Laenge_While_Liste do }

  WHILE_LIS.counter:=0;



  // CASE-Liste
  for ZC_Zaeher:=1 to Laenge_CASE_Liste do begin

    CASE_LIS.LISTE[ZC_Zaeher].naechstes_Element_Marke:='';
    CASE_LIS.LISTE[ZC_Zaeher].Ende_Marke:='';
    CASE_LIS.LISTE[ZC_Zaeher].Listen_Element_Marke:='';
    CASE_LIS.LISTE[ZC_Zaeher].Wert_ASM:='';
    CASE_LIS.LISTE[ZC_Zaeher].Wert_Original:='';
    CASE_LIS.LISTE[ZC_Zaeher].ASM_type:=AT_kein_typ;
    CASE_LIS.LISTE[ZC_Zaeher].erstes_Element:=true;
    CASE_LIS.LISTE[ZC_Zaeher].erstes_Listen_Element:=true;
    CASE_LIS.LISTE[ZC_Zaeher].mit_ELSE:=false;

  end; { for ZC_Zaeher:=1 to Laenge_CASE_Liste do }

  CASE_LIS.counter:=0;


  // Loeschen aller Zwischenwerte der Zuweisung
  Loeschen_ZuweisungsListe;


  // Loeschen der STRING_Liste
  STRING_Liste := TStringList.Create;


  // Loeschen der ISR-Liste
  for ZC_Zaeher:=1 to Laenge_ISR_Liste do begin

    ISR_LISTE.LISTE[ZC_Zaeher].ORG_Name:='';
    ISR_LISTE.LISTE[ZC_Zaeher].ISR_Name:='';
    ISR_LISTE.LISTE[ZC_Zaeher].Bemerkung:='';
    ISR_LISTE.LISTE[ZC_Zaeher].enable:=false;

  end; { for ZC_Zaeher:=1 to Laenge_CASE_Liste do }
  ISR_LISTE.counter:=1;
  ISR_LISTE.max_anzahl:=1;
  ISR_LISTE.enable:=false;


  VAR_Liste_aktiv:=false;
  VAR_Listen_Pos:=0;
  ASM_Datei := TStringList.Create;

  REG_ARRAY_LOW_pointer:=1;

  Ruecksetzen_akt_CALL_PROC;

  Marken_Zaehler:=0;

end;  { procedure ZWC_class.Ruecksetzen }





function ZWC_class.erzeuge_Marke(Bezeichner : String) : String;
begin
  Inc(Marken_Zaehler);
  Result:='M_'+Bezeichner+'_0'+IntToStr(Marken_Zaehler);
end; { function ZWC_class.erzeuge_Marke }







function ZWC_class.TYPENAME_IN_TYPE(TyNa : String) : ASM_type_Typ;
var
  TN_Zaehler : Integer;
  AST : ASM_type_Typ;
begin
  AST:=AT_kein_typ;
  TyNa:=UpperCase(TyNa);
  for TN_Zaehler:=1 to LEN_AT_CONST do begin
    if UpperCase(ASM_TARR[TN_Zaehler].bezeichner)=TyNa then
      AST:=ASM_TARR[TN_Zaehler].ASM_type;

  end; { for TN_Zaehler:=1 to LEN_AT_CONST do }
  if AST=AT_kein_typ then
    Fehler_cl.Registrieren('ZwischenCode/TYPE_NAME_IN_TYPE','der Name des Typs ('+TyNa+
                               ') ist nicht bekannt',
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

  Result:=AST;
end; { function ZWC_class.TYPE_NAME_IN_TYPE }








function ZWC_class.TYPE_IN_TYPENAME(AsTy : ASM_type_Typ) : String;
var
  TN_Zaehler : Integer;
  TyNa : String;
begin
  TyNa:='';
  for TN_Zaehler:=1 to LEN_AT_CONST do begin
    if ASM_TARR[TN_Zaehler].ASM_type=AsTy then
      TyNa:=ASM_TARR[TN_Zaehler].bezeichner;

  end; { for TN_Zaehler:=1 to LEN_AT_CONST do }
  if TyNa='' then
    Fehler_cl.Registrieren('ZwischenCode/TYPE_IN_TYPENAME','der Name des Typs ist nicht bekannt',
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

  Result:=TyNa;
end; { function ZWC_class.TYPE_IN_TYPENAME }





procedure ZWC_class.Inc_STM_TAB_counter;
begin
  Inc(STM_LISTE_counter);
  if STM_LISTE_counter>LEN_STM_LISTE then
    Fehler_cl.Registrieren('ZwischenCode/Inc_STM_TAB_counter',
                           'Es duerfen nur maximal '+IntToStr(LEN_STM_LISTE)+
                           ' Statements deklariert werden (siehe CompilerDeklarationen LEN_STM_LISTE)',
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

end; { procedure ZWC_class.Inc_STM_TAB_counter }





procedure ZWC_class.Inc_NAME_TAB_counter;
begin
  Inc(NAME_TAB_counter);
  if NAME_TAB_counter>LEN_NAME_TAB then
    Fehler_cl.Registrieren('ZwischenCode/Inc_NAME_TAB_counter',
                           'Es duerfen nur maximal '+IntToStr(LEN_NAME_TAB)+
                           ' Namen deklariert werden (jetzt sind es '+
                           IntToStr(NAME_TAB_counter)+')',
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

end; { procedure ZWC_class.Inc_NAME_TAB_counter }





procedure ZWC_class.Inc_PROC_LISTE_counter;
begin
  Inc(PROC_LIS.counter);

  if PROC_LIS.counter>LEN_PROC_LISTE then
    Fehler_cl.Registrieren('ZwischenCode/Inc_PROC_LISTE_counter',
                           'Es duerfen nur maximal '+IntToStr(LEN_PROC_LISTE)+
                           ' Prozeduren und Funktionen deklariert werden (jetzt sind es '+
                           IntToStr(PROC_LIS.counter)+')',
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

end; { procedure ZWC_class.Inc_PROC_LISTE_counter }







procedure ZWC_class.Inc_akt_CALL_PROC_counter;
begin

  Inc(akt_CALL_PROC.counter);
  if akt_CALL_PROC.counter>Laenge_akt_CALL_Liste then
    Fehler_cl.Registrieren('ZwischenCode/PCALL_var_parameter_eintragen',
                           'es duerfen nur maximal '+IntToStr(Laenge_akt_CALL_Liste)+
                           ' Parameter uebergeben werden',
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

end; { procedure ZWC_class.Inc_akt_CALL_PROC_counter }







procedure ZWC_class.Inc_FTD_LISTE_counter;
begin
  Inc(FTD_LIS.counter);

  if FTD_LIS.counter>Laenge_FTD_Liste then
    Fehler_cl.Registrieren('ZwischenCode/Inc_FTD_LISTE_counter',
                           'Es duerfen nur maximal '+IntToStr(Laenge_FTD_Liste)+
                           ' FOR-TO-DO-Schleifen ineinander aufgerufen werden',
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

end; { procedure ZWC_class.Inc_FTD_LISTE_counter }







procedure ZWC_class.Inc_IF_THEN_LIS_counter;
begin
  Inc(IF_THEN_LIS.counter);

  if IF_THEN_LIS.counter>Lange_IF_THEN_Liste then
    Fehler_cl.Registrieren('ZwischenCode/Inc_IF_THEN_LIS_counter',
                           'Es duerfen nur maximal '+IntToStr(Lange_IF_THEN_Liste)+
                           ' IF-THEN-Schleifen ineinander aufgerufen werden',
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

end; { procedure ZWC_class.Inc_IF_THEN_LIS_counter }





procedure ZWC_class.Inc_WHILE_LIS_counter;
begin
  Inc(WHILE_LIS.counter);

  if WHILE_LIS.counter>Laenge_While_Liste then
    Fehler_cl.Registrieren('ZwischenCode/Inc_WHILE_LIS_counter',
                           'Es duerfen nur maximal '+IntToStr(Laenge_While_Liste)+
                           ' WHILE-Schleifen ineinander aufgerufen werden',
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

end; { procedure ZWC_class.Inc_WHILE_LIS_counter }









procedure ZWC_class.Inc_CASE_LIS_counter;
begin
  Inc(CASE_LIS.counter);

  if CASE_LIS.counter>Laenge_CASE_Liste then
    Fehler_cl.Registrieren('ZwischenCode/Inc_CASE_LIS_counter',
                           'Es duerfen nur maximal '+IntToStr(Laenge_CASE_Liste)+
                           ' CASE-Schleifen ineinander aufgerufen werden',
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

end; { procedure ZWC_class.Inc_CASE_LIS_counter }









procedure ZWC_class.Inc_ZUW_Quelle_counter;
begin
  Inc(ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].QUELLcounter);

  if ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].QUELLcounter>30 then
    Fehler_cl.Registrieren('ZwischenCode/Inc_ZUW_Quelle_counter',
                           'Es duerfen nur maximal 30 Werte in einer Berechnung genutzt werden',
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

end; { procedure ZWC_class.Inc_ZUW_Quelle_counter }








procedure ZWC_class.Inc_ZUW_LIS_LISTcounter;
begin
  Inc(ZUW_LIS.LISTcounter);

  if ZUW_LIS.LISTcounter>10 then
    Fehler_cl.Registrieren('ZwischenCode/Inc_ZUW_LIS_LISTcounter',
                           'Es duerfen nur maximal 10 Berechnungsebenen genutzt werden',
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

end; { procedure ZWC_class.Inc_ZUW_LIS_LISTcounter }




procedure ZWC_class.Inc_CONST_ARRAY_counter;
begin
  Inc(CONST_ARRAY.counter);

  if CONST_ARRAY.counter>Laenge_CONST_ARRAY_Liste then
    Fehler_cl.Registrieren('ZwischenCode/Inc_CONST_ARRAY_counter',
                           'Es duerfen nur maximal '+IntToStr(Laenge_CONST_ARRAY_Liste)+
                           ' Konstanten-Arrays in einer Berechnung genutzt werden',
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

end; { procedure ZWC_class.Inc_CONST_ARRAY_counter }





procedure ZWC_class.Inc_CONST_TERM_counter;
begin
  Inc(CONST_TERM.counter);

  if CONST_TERM.counter>Laenge_CONST_TERM_Liste then
    Fehler_cl.Registrieren('ZwischenCode/Inc_CONST_TERM_counter',
                           'Es duerfen nur maximal '+IntToStr(Laenge_CONST_TERM_Liste)+
                           ' Term-Elemente fuer die Berechnung einer Konstante genutzt werden',
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

end; { procedure ZWC_class.Inc_CONST_TERM_counter }




procedure ZWC_class.Inc_VAR_ARRAY_counter;
begin
  Inc(VAR_ARRAY.counter);

  if VAR_ARRAY.counter>Laenge_VAR_ARRAY_Liste then
    Fehler_cl.Registrieren('ZwischenCode/Inc_VAR_ARRAY_counter',
                           'Es duerfen nur maximal '+IntToStr(Laenge_VAR_ARRAY_Liste)+
                           ' Konstanten-Arrays in einer Berechnung genutzt werden',
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

end; { procedure ZWC_class.Inc_VAR_ARRAY_counter }







procedure ZWC_class.Inc_BIT_LIS_counter;
begin
  Inc(BIT_LIS.counter);

  if BIT_LIS.counter>Laenge_Bit_Liste then
    Fehler_cl.Registrieren('ZwischenCode/Inc_BIT_LIS_counter',
                           'Es duerfen nur maximal '+IntToStr(Laenge_Bit_Liste)+
                           ' Bit-Variablen genutzt werden',
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

end; { procedure ZWC_class.Inc_BIT_LIS_counter }







function ZWC_class.lokalen_Parameter_suchen(P_Name : String) : Integer;
var
  PAR_Pos, PAR_Zaehler : Integer;
begin
  PAR_Pos:=0;

  for PAR_Zaehler:=1 to PROC_LIS.LISTE[PROC_LIS.counter].counter do begin
    if PROC_LIS.LISTE[PROC_LIS.counter].PPR_ARR[PAR_Zaehler].Parameter=P_Name then
      PAR_Pos:=PAR_Zaehler;

  end;

  if PAR_Pos=0 then
    Fehler_cl.Registrieren('ZwischenCode/lokalen_Parameter_suchen',
                           'Der Parameter '+P_Name+' konnte nicht gefunden werden',
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

  Result:=PAR_Pos;
end; { function ZWC_class.lokalen_Parameter_suchen }





function ZWC_class.BIT_LIS_suchen(BIT_Name : String) : Integer;
var
  BIT_Pos, BIT_Zaehler : Integer;
begin
  BIT_Pos:=0;

  for BIT_Zaehler:=1 to BIT_LIS.counter do begin
    if BIT_LIS.LISTE[BIT_Zaehler].Bezeichner=BIT_Name then
      BIT_Pos:=BIT_Zaehler;

  end;

  if BIT_Pos=0 then
    Fehler_cl.Registrieren('ZwischenCode/BIT_LIS_suchen',
                           'Die BIT-Variable <'+BIT_Name+'> konnte nicht gefunden werden',
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

  Result:=BIT_Pos;
end; { function ZWC_class.BIT_LIS_suchen }





function ZWC_class.BIT_TO_ByteMaske(BIT_Pos : Byte) : String;
var
  ByteMaske : String;
begin

  case BIT_Pos of

    0 : ByteMaske:='0b00000001';
    1 : ByteMaske:='0b00000010';
    2 : ByteMaske:='0b00000100';
    3 : ByteMaske:='0b00001000';
    4 : ByteMaske:='0b00010000';
    5 : ByteMaske:='0b00100000';
    6 : ByteMaske:='0b01000000';
    7 : ByteMaske:='0b10000000';

  else
    Fehler_cl.Registrieren('ZwischenCode/BIT_TO_BITMaske',
                           'Der Bit-Wert muss zwischen 0 und 7 liegen ('+IntToStr(BIT_Pos)+')',
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

  end; { case BitWert of }

  Result:=ByteMaske;
end; { function ZWC_class.BIT_TO_BITMaske }



{$I ZWC_01.inc}


{$I ZWC_02.inc}


{$I ZWC_03.inc}


{$I ZWC_04.inc}


// ********************************************
//             Start des Zwischencodes
// ********************************************


{$I ZWC_Start.inc}



destructor ZWC_class.Destroy;
begin

  ASM_Datei.Free;
  STRING_Liste.Free;

  inherited Destroy;

end; { destructor ZWC_class.Destroy }




end.

