unit Neu_Form;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  ExtCtrls, Windows, Types,

  Device_Form, CompilerDeklarationen, Modul_Assembler;


const
  Length_Board_Array = 100;

  board_names = atmega_path + '\' + 'board_array.txt';
  templates_path = 'rp_templates';

type



  Board_Array_Record = record
    Bezeichner, Bemerkung,
    RONPAS_name, Datei, Bild : String;
  end;



  { TForm_Neu }

  TForm_Neu = class(TForm)
    Button_Schliessen: TButton;
    Button_Datei_erzeugen: TButton;
    Button_Neu_Name: TButton;
    ComboBox_Board: TComboBox;
    ComboBox_uC_Typ: TComboBox;
    Edit_Neu_Name: TEdit;
    Edit_Neu_Pfad: TEdit;
    Image_Board_Device: TImage;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    ListBox_Bemerkung: TListBox;
    ListBox_Meldungen: TListBox;
    Panel1: TPanel;
    SelectDirectoryDialog1: TSelectDirectoryDialog;
    procedure Button_Datei_erzeugenClick(Sender: TObject);
    procedure Button_Neu_NameClick(Sender: TObject);
    procedure Button_SchliessenClick(Sender: TObject);
    procedure ComboBox_BoardChange(Sender: TObject);
    procedure ComboBox_uC_TypChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure ListBox_MeldungenDrawItem(Control: TWinControl; Index: Integer;
      ARect: TRect; State: TOwnerDrawState);
  private
    { private declarations }
    Color_List : Array [0..Length_Color_List] of TColor;
    Board_Array : ARRAY [0..Length_Board_Array] of Board_Array_Record;
    Board_Array_Counter : Integer;
    procedure ListBox_Meldungen_Clear;
    procedure ListBox_Meldungen_Add_Item_Color(AI_Text : String;
                                  AI_Color : TColor);
    procedure Read_Board_Array;
    procedure Anzeige_Board_Array;
    procedure Anzeige_ATMEGA_Array;
    procedure Datei_erzeugen(ziel_pfad_name : String);
    procedure Muster_Datei_kopieren(ziel_pfad_name : String);
    procedure Register_Datei_kopieren;
    procedure SYSTEM_Datei_kopieren;
    procedure neue_Datei_erzeugen;
    procedure DEFINE_NAME_IN_ATMEGA_Typ_Index(DEF_Name : String);
  public
    { public declarations }
  end;

var
  Form_Neu: TForm_Neu;

implementation

uses
  Main_Unit;

{$R *.lfm}


{ TForm_Neu }

// ************************
// * INCLUDE
// ************************

{$I Neu_Form_01.inc}


procedure TForm_Neu.FormCreate(Sender: TObject);
begin

  ComboBox_uC_Typ.Items.Clear;
  ComboBox_uC_Typ.ItemIndex:=0;

  Form_Neu.Height:=450;
  Form_Neu.Visible:=false;


end; { procedure TForm_Neu.FormCreate }








procedure TForm_Neu.FormShow(Sender: TObject);
var
  RD_cnt : Integer;
  RD_Line : String;
begin

  Form_Neu.Left := Form_RP.Left + (Form_RP.Width - Form_Neu.Width) DIV 2;
  Form_Neu.Top := Form_RP.Top + (Form_RP.Height - Form_Neu.Height) DIV 2;

  Edit_Neu_Pfad.Text := Form_RP.source_path;
  Edit_Neu_Name.Text := Form_RP.source_name;


  ListBox_Meldungen_Clear;

  ListBox_Meldungen_Add_Item_Color('Formular geoeffnet ...',cl_dunkel_gruen);


  // Einlesen der Boards
  Read_Board_Array;

  ComboBox_Board.Items.Clear;

  for RD_cnt:=0 to Board_Array_Counter-1 do begin

    RD_Line:=Board_Array[RD_cnt].Bezeichner;
    ComboBox_Board.Items.Add(RD_Line);

  end; { for RD_cnt:=0 to Board_Array_Counter-1 do }

  ComboBox_Board.ItemIndex := Form_RP.CB_Board_Index;

  Anzeige_Board_Array;


  // Einlesen der Devices
  Form_Device.Read_ATMEGA_Array;

  ComboBox_uC_Typ.Items.Clear;

  for RD_cnt:=0 to Form_Device.ATMEGA_Array_Counter-1 do begin

    RD_Line:=Form_Device.ATMEGA_Array[RD_cnt].Bezeichner+' ('+
             Form_Device.ATMEGA_Array[RD_cnt].AVRDUDE_name+')';
    ComboBox_uC_Typ.Items.Add(RD_Line);

  end; { for RD_cnt:=0 to Form_Device.ATMEGA_Array_Counter-1 do }

  ComboBox_uC_Typ.ItemIndex := Form_RP.CB_Device_Index;

  Anzeige_ATMEGA_Array;

end; { procedure TForm_Neu.FormShow }






procedure TForm_Neu.neue_Datei_erzeugen;
var
  buttonSelected : Integer;
  ziel_pfad_name : String;
begin

  if not DirectoryExists(Edit_Neu_Pfad.Text) then begin

    ListBox_Meldungen_Add_Item_Color('Ordner '+Edit_Neu_Pfad.Text+' nicht vorhanden',cl_dunkel_blau);

    if CreateDir(Edit_Neu_Pfad.Text) then begin
      ListBox_Meldungen_Add_Item_Color('Ordner '+Edit_Neu_Pfad.Text+' wurde erzeugt',cl_dunkel_gruen);
    end
    else begin

      ListBox_Meldungen_Add_Item_Color('*** Fehler: Ordner '+Edit_Neu_Pfad.Text+
                           ' konnte nicht erzeugt werden',cl_dunkel_rot);

      ListBox_Meldungen_Add_Item_Color('    Fehlernummer:'+IntToStr(GetLastError),cl_dunkel_braun);

    end; { if CreateDir(Edit_Neu_Pfad.Text) then }

  end; { if not DirectoryExists(Edit_Neu_Pfad.Text) then }


  Form_RP.source_path := Edit_Neu_Pfad.Text;



  ziel_pfad_name := Edit_Neu_Name.Text;

  ziel_pfad_name := ChangeFileExt(ziel_pfad_name,'');

  Edit_Neu_Name.Text := ExtractFileName(ziel_pfad_name);

  Form_RP.source_name := Edit_Neu_Name.Text;

  ziel_pfad_name := Edit_Neu_Pfad.Text+'\'+ziel_pfad_name+'.PAS';

  if FileExists(ziel_pfad_name) then begin
    buttonSelected := MessageDlg('Die Datei:'+ziel_pfad_name+' existiert bereits.'+
                                 #13+#10+'Überschreiben?',mtCustom,
                              [mbYes,mbCancel], 0);

    // Show the button type selected
    if buttonSelected = mrYes then begin
      if ComboBox_Board.ItemIndex=0 then
        Datei_erzeugen(ziel_pfad_name)
      else
        Muster_Datei_kopieren(ziel_pfad_name);

    end; { if buttonSelected = mrYes then }

  end
  else begin

    if ComboBox_Board.ItemIndex=0 then
        Datei_erzeugen(ziel_pfad_name)
      else
        Muster_Datei_kopieren(ziel_pfad_name);

  end; { else FileExists(Edit_Neu_Pfad.Text... }

  Register_Datei_kopieren;

  SYSTEM_Datei_kopieren;

end; { procedure TForm_Neu.neue_Datei_erzeugen }







procedure TForm_Neu.Button_Datei_erzeugenClick(Sender: TObject);
begin

  neue_Datei_erzeugen;

end; { procedure TForm_Neu.Button_Datei_erzeugenClick }





procedure TForm_Neu.Button_Neu_NameClick(Sender: TObject);
begin

  if (SelectDirectoryDialog1.Execute) then begin
      Edit_Neu_Pfad.Text := SelectDirectoryDialog1.FileName;
  end;

end; { procedure TForm_Neu.Button_Neu_NameClick }







procedure TForm_Neu.Datei_erzeugen(ziel_pfad_name : String);
var
  Datei_File : TStringList;
  Zeile : String;

begin


  Datei_File := TStringList.Create;

  Zeile:='PROGRAM '+Edit_Neu_Name.Text+';';
  Datei_File.Add(Zeile);

  Zeile:='';
  Datei_File.Add(Zeile);

  Zeile:='DEVICE = '+
    Form_Device.ATMEGA_Array[ComboBox_uC_Typ.ItemIndex].RONPAS_name+';';
  Datei_File.Add(Zeile);

  Zeile:='';
  Datei_File.Add(Zeile);

  // INC-Datei
  Zeile:='{$I '+Form_Device.ATMEGA_Array[ComboBox_uC_Typ.ItemIndex].REG_name+'}';
  Datei_File.Add(Zeile);



  Zeile:='';
  Datei_File.Add(Zeile);

  Zeile:='BEGIN';
  Datei_File.Add(Zeile);

  Zeile:='';
  Datei_File.Add(Zeile);

  Zeile:='END '+Edit_Neu_Name.Text+'.';
  Datei_File.Add(Zeile);

  if not directoryexists(Edit_Neu_Pfad.Text) then
    MkDir(Edit_Neu_Pfad.Text);

  Datei_File.SaveToFile(ziel_pfad_name);
  Datei_File.Free;


  if Length(Form_Device.ATMEGA_Array[ComboBox_uC_Typ.ItemIndex].REG_name)>0 then begin

    Register_Datei_kopieren;

  end
  else
    ListBox_Meldungen_Add_Item_Color('*** Fehler: die Register-Datei wurde nicht angegeben',cl_dunkel_rot);

  SYSTEM_Datei_kopieren;

  Form_RP.INC_Dateien_Sichern_und_Schliessen;

  Form_RP.Source_laden;


end; { procedure TForm_Neu.Datei_erzeugen }







procedure TForm_Neu.Muster_Datei_kopieren(ziel_pfad_name : String);
var
  quelle_pfad_name : String;
begin

  quelle_pfad_name := GetCurrentDir;

  quelle_pfad_name := quelle_pfad_name + '\' + templates_path +
                      '\' + Board_Array[ComboBox_Board.ItemIndex].Datei;

  if FileExists(quelle_pfad_name) then begin

    if CopyFile( PChar(quelle_pfad_name), PChar(ziel_pfad_name), False) then begin

      ListBox_Meldungen.Items.Add('Datei:' + ziel_pfad_name + ' wurde kopiert');

      Form_RP.INC_Dateien_Sichern_und_Schliessen;
      Form_RP.Source_laden;

    end
    else
      ListBox_Meldungen.Items.Add('*** Fehler: Datei:'+
                                ziel_pfad_name+
                                ' wurde nicht kopiert')

  end
  else
    ListBox_Meldungen.Items.Add('*** Fehler: Musterdatei:'+
                                Board_Array[ComboBox_Board.ItemIndex].Datei+
                                ' konnte nicht gefunden werden');



end; { procedure TForm_Neu.Muster_Datei_kopieren }






procedure TForm_Neu.Register_Datei_kopieren;
var
  quelle_pfad_name,
  ziel_pfad_name : String;
begin


  quelle_pfad_name := GetCurrentDir;

  quelle_pfad_name := quelle_pfad_name + '\' + register_path +
                      '\' + Form_Device.ATMEGA_Array[ComboBox_uC_Typ.ItemIndex].REG_name;

  ziel_pfad_name := Edit_Neu_Pfad.Text + '\' +
                    Form_Device.ATMEGA_Array[ComboBox_uC_Typ.ItemIndex].REG_name;


  if FileExists(quelle_pfad_name) then begin

    if CopyFile( PChar(quelle_pfad_name), PChar(ziel_pfad_name), False) then begin

      ListBox_Meldungen.Items.Add('Register-Datei:' + ziel_pfad_name + ' wurde kopiert');

    end
    else
      ListBox_Meldungen.Items.Add('*** Fehler: Register-Datei:'+
                                ziel_pfad_name+
                                ' wurde nicht kopiert')

  end
  else
    ListBox_Meldungen.Items.Add('*** Fehler: Register-Datei:'+
                                Form_Device.ATMEGA_Array[ComboBox_uC_Typ.ItemIndex].REG_name +
                                ' konnte nicht gefunden werden');



end; { procedure TForm_Neu.Register_Datei_kopieren }






procedure TForm_Neu.SYSTEM_Datei_kopieren;
var
  quelle_pfad_name,
  ziel_pfad_name : String;
begin


  quelle_pfad_name := GetCurrentDir;

  quelle_pfad_name := quelle_pfad_name + '\' + templates_path +
                      '\SYSTEM.INC';

  ziel_pfad_name := Edit_Neu_Pfad.Text + '\SYSTEM.INC';


  if FileExists(quelle_pfad_name) then begin

    if CopyFile( PChar(quelle_pfad_name), PChar(ziel_pfad_name), False) then begin

      ListBox_Meldungen.Items.Add('SYSTEM-Datei:' + ziel_pfad_name + ' wurde kopiert');

    end
    else
      ListBox_Meldungen.Items.Add('*** Fehler: SYSTEM-Datei:'+
                                ziel_pfad_name+
                                ' wurde nicht kopiert')

  end
  else
    ListBox_Meldungen.Items.Add('*** Fehler: SYSTEM-Datei:'+
                                Form_Device.ATMEGA_Array[ComboBox_uC_Typ.ItemIndex].REG_name +
                                ' konnte nicht gefunden werden');



end; { procedure TForm_Neu.SYSTEM_Datei_kopieren }






{ ***** Listbox_Meldungen ***** }





procedure TForm_Neu.ListBox_Meldungen_Clear;
var
  FC_counter : Integer;

begin

  for FC_counter:=0 to Length_Color_List do begin
    Color_List[FC_counter]:=ClBlack;
  end;

  ListBox_Meldungen.Clear;

end; { procedure TForm_Neu.ListBox_Meldungen_Clear }






procedure TForm_Neu.ListBox_Meldungen_Add_Item_Color(AI_Text : String;
                                  AI_Color : TColor);
var
  AI_Index : Integer;

begin

  ListBox_Meldungen.Items.Add(AI_Text);
  AI_Index:=ListBox_Meldungen.Count-1;
  Color_List[AI_Index]:=AI_Color;

end; { procedure TForm_Neu.ListBox_Meldungen_Add_Item_Color }





procedure TForm_Neu.ListBox_MeldungenDrawItem(Control: TWinControl; Index: Integer;
  ARect: TRect; State: TOwnerDrawState);
var
  VG_Color : TColor;
begin

  with (Control as TListbox) do begin

    if Index<Length_Color_List then begin

      VG_Color:=Color_List[Index];
      Canvas.Font.Color:=VG_Color;

      Canvas.FillRect(ARect); // Hintergrund malen
      Canvas.TextOut(ARect.Left, ARect.Top, Items[Index]); // Text ausgeben

    end; { if Index<Length_Color_List then }

  end; { with (Control as TListbox) do }

end; { procedure TForm_Neu.ListBox1DrawItem }








procedure TForm_Neu.ComboBox_BoardChange(Sender: TObject);
begin
  Anzeige_Board_Array;
  Anzeige_ATMEGA_Array;
end; { procedure TForm_Neu.ComboBox_BoardChange }





procedure TForm_Neu.ComboBox_uC_TypChange(Sender: TObject);
begin
  Anzeige_ATMEGA_Array;
end;








procedure TForm_Neu.Button_SchliessenClick(Sender: TObject);
begin
  Form_Neu.Visible:=false;
end;





end.

