


{ * VAR * }


function ZWC_class.NAME_vorhanden(SNAME : String) : Boolean;
var
  S_Zaehler : Integer;
  SN_vorhanden : Boolean;
begin
  SN_vorhanden:=false;
  for S_Zaehler:=1 to NAME_TAB_counter do begin
    if NAME_TAB[S_Zaehler].bezeichner=SNAME then
      SN_vorhanden:=true;

  end; { for S_Zaehler:=1 to NAME_TAB_counter do }

  Result:=SN_vorhanden;
end; { function ZWC_class.VAR_NAME_vorhanden }







function ZWC_class.NAME_und_ANW_type_vorhanden(SNAME : String; ANW_type : Char) : Boolean;
var
  S_Zaehler : Integer;
  SN_vorhanden : Boolean;
begin
  SN_vorhanden:=false;
  for S_Zaehler:=1 to NAME_TAB_counter do begin
    if (NAME_TAB[S_Zaehler].bezeichner=SNAME) and (NAME_TAB[S_Zaehler].ANW_type=ANW_type) then
      SN_vorhanden:=true;

  end; { for S_Zaehler:=1 to NAME_TAB_counter do }

  Result:=SN_vorhanden;
end; { function ZWC_class.VAR_NAME_vorhanden }




function ZWC_class.NAME_und_ANW_TO_TYPE(SNAME : String; A_TYPE : Char) : ASM_type_Typ;
var
  S_Zaehler : Integer;
  S_ASM_type : ASM_type_Typ;
begin
  S_ASM_type:=AT_kein_typ;
  for S_Zaehler:=1 to NAME_TAB_counter do begin
    if (NAME_TAB[S_Zaehler].bezeichner=SNAME) and (NAME_TAB[S_Zaehler].ANW_type=A_TYPE) then
      S_ASM_type:=NAME_TAB[S_Zaehler].ASM_type;

  end; { for S_Zaehler:=1 to NAME_TAB_counter do }

  Result:=S_ASM_type;
end; { function ZWC_class.VAR_NAME_und_ANW_TO_TYPE }







function ZWC_class.NAME_TO_ANW_und_ASM(SNAME : String;
                                       var S_ANW_type : Char;
                                       var S_ASM_type : ASM_type_Typ) : Boolean;
var
  S_Zaehler : Integer;
  SN_vorhanden : Boolean;
begin
  SN_vorhanden:=false;

  for S_Zaehler:=1 to NAME_TAB_counter do begin
    if NAME_TAB[S_Zaehler].bezeichner=SNAME then begin
      S_ANW_type:=NAME_TAB[S_Zaehler].ANW_type;
      S_ASM_type:=NAME_TAB[S_Zaehler].ASM_type;
      SN_vorhanden:=true;
    end; { if NAME_TAB[S_Zaehler].bezeichner=SNAME then }
  end; { for S_Zaehler:=1 to NAME_TAB_counter do }

  Result:=SN_vorhanden;
end; { function ZWC_class.NAME_TO_ANW }






function ZWC_class.NAME_in_NAME_TAB_suchen(SNAME : String) : Integer;
var
  S_Zaehler, I_Pos : Integer;

begin
  I_Pos:=0;

  for S_Zaehler:=1 to NAME_TAB_counter do begin
    if NAME_TAB[S_Zaehler].bezeichner=SNAME then begin
      I_Pos:=S_Zaehler;
    end; { if NAME_TAB[S_Zaehler].bezeichner=SNAME then }
  end; { for S_Zaehler:=1 to NAME_TAB_counter do }


  if I_Pos=0 then
    Fehler_cl.Registrieren('ZwischenCode/NAME_in_NAME_TAB_suchen',
                           'Der Name <'+SNAME+'> wurde nicht gefunden',
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);


  Result:=I_Pos;
end; { function ZWC_class.NAME_in_NAME_TAB_suchen }







function ZWC_class.CONST_NAME_TO_WERT(S_NAME : String) : String;
var
  S_Zaehler : Integer;
  S_WERT : String;
begin
  S_WERT:='';
  for S_Zaehler:=1 to NAME_TAB_counter do begin
    if (NAME_TAB[S_Zaehler].bezeichner=S_NAME) and (NAME_TAB[S_Zaehler].ANW_type='C') then
      S_WERT:=NAME_TAB[S_Zaehler].wert;

  end; { for S_Zaehler:=1 to ZC_CONST_TAB_counter do }

  if S_WERT='' then
    Fehler_cl.Registrieren('ZwischenCode/CONST_NAME_TO_WERT',
                           'Die Konstante <'+S_NAME+'> wurde nicht gefunden',
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);


  Result:=S_WERT;
end; { function ZWC_class.CONST_NAME_TO_WERT }





function ZWC_class.Name_in_PROC_LIS_suchen(S_NAME : String) : Integer;
var
  I_Zaehler, I_Pos : Integer;
begin
  I_Pos:=0;
  if PROC_LIS.counter>1 then begin
    for I_Zaehler:=1 to PROC_LIS.counter-1 do begin
      if PROC_LIS.LISTE[I_Zaehler].Name=S_NAME then
        I_Pos:=I_Zaehler;

    end; { for S_Zaehler:=1 to ZC_CONST_TAB_counter do }
    if I_Pos=0 then
      Fehler_cl.Registrieren('ZwischenCode/Name_in_PROC_LIS_suchen',
                             'Die Prozedur <'+S_NAME+'> wurde nicht gefunden',
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);


  end
  else
    Fehler_cl.Registrieren('ZwischenCode/Name_in_PROC_LIS_suchen',
                           'Es wurden noch keine Prozeduren definiert',
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

  Result:=I_Pos;
end; { ZWC_class.function Name_in_PROC_LIS_suchen }







function ZWC_class.Name_in_CONST_ARRAY_LIS_suchen(S_NAME : String) : Integer;
var
  I_Zaehler, I_Pos : Integer;
begin
  I_Pos:=0;
  if CONST_ARRAY.counter>0 then begin
    for I_Zaehler:=1 to CONST_ARRAY.counter do begin
      if CONST_ARRAY.LISTE[I_Zaehler].Bezeichner=S_NAME then
        I_Pos:=I_Zaehler;

    end; { for S_Zaehler:=1 to ZC_CONST_TAB_counter do }
    if I_Pos=0 then
      Fehler_cl.Registrieren('ZwischenCode/Name_in_CONST_ARRAY_LIS_suchen',
                             'Das Konstanten-ARRAY <'+S_NAME+'> wurde nicht gefunden',
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);


  end
  else
    Fehler_cl.Registrieren('ZwischenCode/Name_in_CONST_ARRAY_LIS_suchen',
                           'Es wurden noch kein Konstanten-ARRAY definiert',
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

  Result:=I_Pos;
end; { ZWC_class.function Name_in_CONST_ARRAY_LIS_suchen }










function ZWC_class.Name_in_VAR_ARRAY_LIS_suchen(S_NAME : String) : Integer;
var
  I_Zaehler, I_Pos : Integer;
begin
  I_Pos:=0;
  if VAR_ARRAY.counter>0 then begin
    for I_Zaehler:=1 to VAR_ARRAY.counter do begin
      if VAR_ARRAY.LISTE[I_Zaehler].Bezeichner=S_NAME then
        I_Pos:=I_Zaehler;

    end; { for S_Zaehler:=1 to ZC_CONST_TAB_counter do }
    if I_Pos=0 then
      Fehler_cl.Registrieren('ZwischenCode/Name_in_VAR_ARRAY_LIS_suchen',
                             'Das Variablen-ARRAY <'+S_NAME+'> wurde nicht gefunden',
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);


  end
  else
    Fehler_cl.Registrieren('ZwischenCode/Name_in_VAR_ARRAY_LIS_suchen',
                           'Es wurden noch kein Variablen-ARRAY definiert',
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

  Result:=I_Pos;
end; { function ZWC_class.Name_in_VAR_ARRAY_LIS_suchen }











// ********************************************
//          Deklaration - VAR
// ********************************************



function ZWC_class.VAR_NAME_eintragen(VN : String) : Boolean;
var
  VN_erfolgreich : Boolean;
begin
  VAR_Liste_aktiv:=false;

  VAR_Listen_Pos:=0;
  VN_erfolgreich:=false;
  if NAME_TAB[NAME_TAB_counter].bezeichner='' then begin
      if NAME_TAB[NAME_TAB_counter].ASM_type=AT_kein_typ  then begin
        if not NAME_vorhanden(VN) then begin
          NAME_TAB[NAME_TAB_counter].bezeichner:=VN;
          NAME_TAB[NAME_TAB_counter].ANW_type:='V';
          VN_erfolgreich:=true;
          VAR_Listen_Pos:=NAME_TAB_counter;
        end
        else
          Fehler_cl.Registrieren('ZwischenCode/VAR_NAME_eintragen','Name bereits vergeben ('+VN+')',
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

      end
      else
        Fehler_cl.Registrieren('ZwischenCode/VAR_NAME_eintragen','Typ zur Variable bereits eingetragen ('+VN+')',
                                Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                                Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                                Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);
  end
  else
    Fehler_cl.Registrieren('ZwischenCode/VAR_NAME_eintragen','Variable bereits eingetragen ('+VN+')',
                            Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                            Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                            Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

  Result:=VN_erfolgreich;
end; { procedure ZWC_class.VAR_NAME_eintragen }






function ZWC_class.VAR_LISTE_eintragen(VL : String) : Boolean;
var
  VL_erfolgreich : Boolean;
begin
  VAR_Liste_aktiv:=true;
  VL_erfolgreich:=false;
  Inc_NAME_TAB_counter;
  if NAME_TAB[NAME_TAB_counter].bezeichner='' then begin
      if NAME_TAB[NAME_TAB_counter].ASM_type=AT_kein_typ  then begin
        if not NAME_vorhanden(VL) then begin
          NAME_TAB[NAME_TAB_counter].bezeichner:=VL;
          NAME_TAB[NAME_TAB_counter].ANW_type:='V';
          VL_erfolgreich:=true;
        end
        else
          Fehler_cl.Registrieren('ZwischenCode/VAR_LISTE_eintragen','Variable bereits vorhanden ('+VL+')',
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

      end
      else
        Fehler_cl.Registrieren('ZwischenCode/VAR_LISTE_eintragen','Typ zur Variable bereits eingetragen ('+VL+')',
                                Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                                Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                                Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);
  end
  else
    Fehler_cl.Registrieren('ZwischenCode/VAR_LISTE_eintragen','Variable bereits eingetragen ('+VL+')',
                            Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                            Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                            Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

  Result:=VL_erfolgreich;
end; { procedure ZWC_class.VAR_LISTE_eintragen }





procedure ZWC_class.Type_in_VAR_Liste_eintragen(VT : String);
var
  L_Zaehler : Integer;
  AST : ASM_type_Typ;
begin
  if VAR_Listen_Pos>0 then begin
    AST:=TYPENAME_IN_TYPE(VT);
    for L_Zaehler:=VAR_Listen_Pos to NAME_TAB_counter do begin
      NAME_TAB[L_Zaehler].ASM_type:=AST;
    end; { for L_Zaehler:=VAR_Listen_Pos to NAME_TAB_counter do }
  end; { if VAR_Listen_Pos>0 then }
end; { procedure Type_in_VAR_Liste_eintragen }






function ZWC_class.VAR_TYPE_eintragen(VT : String) : Boolean;
var
  VT_erfolgreich : Boolean;

begin
  VT_erfolgreich:=false;
  if NAME_TAB[NAME_TAB_counter].bezeichner<>'' then begin
      if NAME_TAB[NAME_TAB_counter].ASM_type=AT_kein_typ  then begin
        if VAR_Liste_aktiv then
          Type_in_VAR_Liste_eintragen(VT)
        else
          NAME_TAB[NAME_TAB_counter].ASM_type:=TYPENAME_IN_TYPE(VT);

        VT_erfolgreich:=true;
        Inc_NAME_TAB_counter;

      end
      else
        Fehler_cl.Registrieren('ZwischenCode/VAR_TYPE_eintragen','Typ zur Variable bereits eingetragen ('+VT+')',
                                Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                                Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                                Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);
  end
  else
    Fehler_cl.Registrieren('ZwischenCode/VAR_TYPE_eintragen','Variablenname zum Typ noch nicht eingetragen ('+VT+')',
                            Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                            Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                            Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

  VAR_Liste_aktiv:=false;
  VAR_Listen_Pos:=0;
  Result:=VT_erfolgreich;
end; { procedure ZWC_class.VAR_TYPE_eintragen }





function ZWC_class.VAR_BIT_REGISTER_eintragen(VBR : String) : Boolean;
var
  VBR_erfolgreich : Boolean;
  VBR_Name : String;
  VBR_ASM_type : ASM_type_Typ;
  VBR_ANW_type : Char;
begin
  VBR_erfolgreich:=false;

  if NAME_TAB[NAME_TAB_counter].bezeichner<>'' then begin

    if NAME_TAB[NAME_TAB_counter].ASM_type=AT_kein_typ then begin
      NAME_TAB[NAME_TAB_counter].ANW_type:='B';
      VBR_Name:=NAME_TAB[NAME_TAB_counter].Bezeichner;

      if NAME_TO_ANW_und_ASM(VBR,VBR_ANW_type,VBR_ASM_type) then begin

        Inc_BIT_LIS_counter;
        BIT_LIS.LISTE[BIT_LIS.counter].Bezeichner:=VBR_Name;
        BIT_LIS.LISTE[BIT_LIS.counter].VAR_REG:=VBR;
        BIT_LIS.LISTE[BIT_LIS.counter].ASM_type:=VBR_ASM_type;

        case VBR_ASM_type of
          AT_byte_con_reg,
          AT_byte_con_var  : BIT_LIS.LISTE[BIT_LIS.counter].ASM_Grund_type:=AT_byte;
          AT_word_con_reg,
          AT_word_con_var  : BIT_LIS.LISTE[BIT_LIS.counter].ASM_Grund_type:=AT_word;
          AT_byte, AT_word, AT_dword : BIT_LIS.LISTE[BIT_LIS.counter].ASM_Grund_type:=VBR_ASM_type;
        else
          Fehler_cl.Registrieren('ZwischenCode/VAR_BIT_REGISTER_eintragen',
                                 'Der Variablen/Register-Type <'+
                                 Compiler_cl.ASM_type_Typ_in_Bezeichner(VBR_ASM_type)+
                                 '> wird nicht unterstuetzt',
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

        end; { case VBR_ASM_type of }

        BIT_LIS.LISTE[BIT_LIS.counter].ANW_Type:=VBR_ANW_type;

        VBR_erfolgreich:=true;

      end
      else
        Fehler_cl.Registrieren('ZwischenCode/VAR_BIT_REGISTER_eintragen',
                               'Die Variable <'+VBR+'> konnte nicht gefunden werden',
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

    end
    else
      Fehler_cl.Registrieren('ZwischenCode/VAR_BIT_REGISTER_eintragen',
                             'Type bereits eingetragen',
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);
  end
  else
    Fehler_cl.Registrieren('ZwischenCode/VAR_BIT_REGISTER_eintragen',
                           'Name fuer die Bit-Variable noch nicht eingetragen',
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

  Result:=VBR_erfolgreich;
end; { procedure ZWC_class.VAR_BIT_REGISTER_eintragen }







function ZWC_class.VAR_BIT_POSITION_eintragen(VB_POS : String) : Boolean;
var
  VBP_erfolgreich : Boolean;
  VB_Position : LongInt;

begin
  VBP_erfolgreich:=false;

  if NAME_TAB[NAME_TAB_counter].bezeichner<>'' then begin

    if NAME_TAB[NAME_TAB_counter].ASM_type=AT_kein_typ then begin

      VB_Position:=StrToInt(VB_POS);

      if BIT_LIS.LISTE[BIT_LIS.counter].ASM_Grund_type=AT_byte then begin

        if (VB_Position>=0) and (VB_Position<=7) then begin
          BIT_LIS.LISTE[BIT_LIS.counter].Bit_Position:=VB_Position;
          VBP_erfolgreich:=true;
        end
        else
          Fehler_cl.Registrieren('ZwischenCode/VAR_BIT_REGISTER_eintragen',
                                 'fuer die Bitposition eines Bytes sind nur Werte von 0..7 zugelassen',
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

      end; { if BIT_LIS.LISTE[BIT_LIS.counter].ASM_Grund_type=AT_byte then }

      if BIT_LIS.LISTE[BIT_LIS.counter].ASM_Grund_type=AT_word then begin

        if (VB_Position>=0) and (VB_Position<=15) then begin
          BIT_LIS.LISTE[BIT_LIS.counter].Bit_Position:=VB_Position;
          VBP_erfolgreich:=true;
        end
        else
          Fehler_cl.Registrieren('ZwischenCode/VAR_BIT_REGISTER_eintragen',
                                 'fuer die Bitposition eines Words sind nur Werte von 0..15 zugelassen',
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

      end; { if BIT_LIS.LISTE[BIT_LIS.counter].ASM_Grund_type=AT_word then }


      if BIT_LIS.LISTE[BIT_LIS.counter].ASM_Grund_type=AT_dword then begin

        if (VB_Position>=0) and (VB_Position<=31) then begin
          BIT_LIS.LISTE[BIT_LIS.counter].Bit_Position:=VB_Position;
          VBP_erfolgreich:=true;
        end
        else
          Fehler_cl.Registrieren('ZwischenCode/VAR_BIT_REGISTER_eintragen',
                                 'fuer die Bitposition eines DWords sind nur Werte von 0..31 zugelassen',
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

      end; { if BIT_LIS.LISTE[BIT_LIS.counter].ASM_Grund_type=AT_dword then }

    end
    else
      Fehler_cl.Registrieren('ZwischenCode/VAR_BIT_REGISTER_eintragen',
                             'Type bereits eingetragen',
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);
  end
  else
    Fehler_cl.Registrieren('ZwischenCode/VAR_BIT_REGISTER_eintragen',
                           'Name fuer die Bit-Variable noch nicht eingetragen',
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

  Result:=VBP_erfolgreich;
end; { function ZWC_class.VAR_BIT_POSITION_eintragen }





function ZWC_class.VAR_BIT_TYPE_eintragen(VB_TYPE : String) : Boolean;
var
  VBT_erfolgreich : Boolean;
  VBT_ASM_type : ASM_type_Typ;
begin
  VBT_erfolgreich:=false;

  if NAME_TAB[NAME_TAB_counter].bezeichner<>'' then begin

    if NAME_TAB[NAME_TAB_counter].ASM_type=AT_kein_typ then begin

      VBT_ASM_type:=TYPENAME_IN_TYPE(VB_TYPE);

      if VBT_ASM_type=AT_bit then begin

        NAME_TAB[NAME_TAB_counter].ASM_type:=VBT_ASM_type;
        Inc_NAME_TAB_counter;
        VBT_erfolgreich:=true;

      end
      else
        Fehler_cl.Registrieren('ZwischenCode/VAR_BIT_TYPE_eintragen',
                               'es ist nur der Type <Bit> zugelassen',
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);


    end
    else
      Fehler_cl.Registrieren('ZwischenCode/VAR_BIT_TYPE_eintragen',
                             'Type bereits eingetragen',
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);
  end
  else
    Fehler_cl.Registrieren('ZwischenCode/VAR_BIT_TYPE_eintragen',
                           'Name fuer die Bit-Variable noch nicht eingetragen',
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

  Result:=VBT_erfolgreich;
end; { function ZWC_class.VAR_BIT_TYPE_eintragen }







procedure ZWC_class.VAR_ARRAY_von_eintragen(VAV : String; VAV_UT : SI_Unter_Typ);
var
  VAV_Wert : LongInt;
  S_Zahl : String;
begin

  if NAME_TAB[NAME_TAB_counter].bezeichner<>'' then begin

    if CONST_WERT_ueberpruefen(VAV,VAV_UT,AT_word) then begin

      S_Zahl:='$'+Copy(VAV,3,Length(VAV)-2);
      VAV_Wert:=StrToInt(S_Zahl);

      if VAV_Wert<65536 then begin
        NAME_TAB[NAME_TAB_counter].ANW_type:='Y';
        Inc_VAR_ARRAY_counter;
        VAR_ARRAY.LISTE[VAR_ARRAY.counter].Bezeichner:=NAME_TAB[NAME_TAB_counter].Bezeichner;
        VAR_ARRAY.LISTE[VAR_ARRAY.counter].Anfang_1d:=Word(VAV_Wert);
        VAR_ARRAY.LISTE[VAR_ARRAY.counter].Array_ist_1d:=true;
      end
      else
        Fehler_cl.Registrieren('ZwischenCode/VAR_ARRAY_von_eintragen',
                               'der Zahlenwert fuer ARRAY-Anfang ('+VAV+') ueberschreitet den Maximalwert '+
                               'des Types Word (65535)',
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

    end; { if CONST_WERT_ueberpruefen(VAV,VAV_UT,AT_word) then }

  end { if NAME_TAB[NAME_TAB_counter].bezeichner<>'' then }
  else
    Fehler_cl.Registrieren('ZwischenCode/VAR_ARRAY_von_eintragen',
                           'Name des ARRAYS noch nicht eingetragen ('+VAV+')',
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

end; { procedure ZWC_class.VAR_ARRAY_von_eintragen }






procedure ZWC_class.VAR_ARRAY_bis_eintragen(VAB : String; VAB_UT : SI_Unter_Typ);
var
  VAV_Wert, VAB_Wert, Laenge : LongInt;
  S_Zahl : String;
begin

  if NAME_TAB[NAME_TAB_counter].bezeichner<>'' then begin

    if CONST_WERT_ueberpruefen(VAB,VAB_UT,AT_word) then begin

      S_Zahl:='$'+Copy(VAB,3,Length(VAB)-2);
      VAB_Wert:=StrToInt(S_Zahl);

      if VAB_Wert<65536 then begin

        VAV_Wert:=VAR_ARRAY.LISTE[VAR_ARRAY.counter].Anfang_1d;
        Laenge:=VAB_Wert-VAV_Wert+1;

        if Laenge>1 then begin

          VAR_ARRAY.LISTE[VAR_ARRAY.counter].Laenge_1d:=Word(Laenge);


        end
        else
          Fehler_cl.Registrieren('ZwischenCode/VAR_ARRAY_bis_eintragen',
                                 'das ARRAY muss mindestens 2 Elemente enthalten ('+IntToStr(Laenge)+')',
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

      end
      else
        Fehler_cl.Registrieren('ZwischenCode/VAR_ARRAY_bis_eintragen',
                               'der Zahlenwert fuer ARRAY-Ende ('+VAB+') ueberschreitet den Maximalwert '+
                               'des Types Word (65535)',
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

    end; { if CONST_WERT_ueberpruefen(CAE,CAE_UT,AT_word) then }

  end
  else
    Fehler_cl.Registrieren('ZwischenCode/VAR_ARRAY_bis_eintragen',
                           'Name des ARRAYS noch nicht eingetragen ('+VAB+')',
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);


end; { procedure ZWC_class.VAR_ARRAY_bis_eintragen }









function ZWC_class.VAR_ARRAY_CONST_bis_eintragen(VAC : String) : Boolean;
var
  CW : String;
  NAME_TAB_POS : Cardinal;
  VAR_ARRAY_CONST_ok : Boolean;
begin

  VAR_ARRAY_CONST_ok:=false;

  NAME_TAB_POS:=NAME_in_NAME_TAB_suchen(VAC);

  if (NAME_TAB[NAME_TAB_POS].ASM_type=AT_word) then begin
    VAR_ARRAY_CONST_ok:=true;
    CW:=NAME_TAB[NAME_TAB_POS].Wert;
    VAR_ARRAY_bis_eintragen(CW,UT_Hex_Zahl);
  end { if (NAME_TAB[NAME_TAB_POS].ASM_type=AT_word) then }
  else Fehler_cl.Registrieren('ZwischenCode/VAR_ARRAY_CONST_bis_eintragen',
                           'der Zeiger des ARRAYs muss vom Typ Word sein',
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

  RESULT:=VAR_ARRAY_CONST_ok;

end; { procedure ZWC_class.VAR_ARRAY_CONST_bis_eintragen }









procedure ZWC_class.VAR_ARRAY_2d_von_eintragen(VAV : String; VAV_UT : SI_Unter_Typ);
var
  VAV_Wert : LongInt;
  S_Zahl : String;
begin

    if CONST_WERT_ueberpruefen(VAV,VAV_UT,AT_word) then begin

      S_Zahl:='$'+Copy(VAV,3,Length(VAV)-2);
      VAV_Wert:=StrToInt(S_Zahl);

      if VAV_Wert<65536 then begin
        NAME_TAB[NAME_TAB_counter].ANW_type:='Z';
        VAR_ARRAY.LISTE[VAR_ARRAY.counter].Array_ist_1d:=false;  // ist 2D-Array
        VAR_ARRAY.LISTE[VAR_ARRAY.counter].Anfang_2d:=Word(VAV_Wert);
      end
      else
        Fehler_cl.Registrieren('ZwischenCode/VAR_ARRAY_2d_von_eintragen',
                               'der Zahlenwert fuer ARRAY-2D-Anfang ('+VAV+') ueberschreitet den Maximalwert '+
                               'des Types Word (65535)',
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

    end; { if CONST_WERT_ueberpruefen(VAV,VAV_UT,AT_word) then }


end; { procedure ZWC_class.VAR_ARRAY_von_eintragen }






procedure ZWC_class.VAR_ARRAY_2d_bis_eintragen(VAB : String; VAB_UT : SI_Unter_Typ);
var
  VAV_Wert, VAB_Wert, Laenge : LongInt;
  S_Zahl : String;
begin

  if NAME_TAB[NAME_TAB_counter].bezeichner<>'' then begin

    if CONST_WERT_ueberpruefen(VAB,VAB_UT,AT_word) then begin

      S_Zahl:='$'+Copy(VAB,3,Length(VAB)-2);
      VAB_Wert:=StrToInt(S_Zahl);

      if VAB_Wert<65536 then begin
        VAV_Wert:=VAR_ARRAY.LISTE[VAR_ARRAY.counter].Anfang_2d;
        Laenge:=VAB_Wert-VAV_Wert+1;

        if Laenge>1 then begin

          VAR_ARRAY.LISTE[VAR_ARRAY.counter].Laenge_2d:=Word(Laenge);

        end
        else
          Fehler_cl.Registrieren('ZwischenCode/VAR_ARRAY_2d_bis_eintragen',
                                 'das ARRAY muss mindestens 2 Elemente enthalten ('+IntToStr(Laenge)+')',
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

      end
      else
        Fehler_cl.Registrieren('ZwischenCode/VAR_ARRAY_2d_bis_eintragen',
                               'der Zahlenwert fuer 2D-ARRAY-Ende ('+VAB+') ueberschreitet den Maximalwert '+
                               'des Types Word (65535)',
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

    end; { if CONST_WERT_ueberpruefen(CAE,CAE_UT,AT_word) then }

  end
  else
    Fehler_cl.Registrieren('ZwischenCode/VAR_ARRAY_2d_bis_eintragen',
                           'Name des 2D-ARRAYS noch nicht eingetragen ('+VAB+')',
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

end; { procedure ZWC_class.VAR_ARRAY_2d_bis_eintragen }








function ZWC_class.VAR_ARRAY_2d_CONST_bis_eintragen(VAC : String) : Boolean;
var
  CW : String;
  NAME_TAB_POS : Cardinal;
  VAR_ARRAY_2d_CONST_ok : Boolean;
begin

  VAR_ARRAY_2d_CONST_ok:=false;

  NAME_TAB_POS:=NAME_in_NAME_TAB_suchen(VAC);

  if (NAME_TAB[NAME_TAB_POS].ASM_type=AT_word) then begin
    VAR_ARRAY_2d_CONST_ok:=true;
    CW:=NAME_TAB[NAME_TAB_POS].Wert;
    VAR_ARRAY_2d_bis_eintragen(CW,UT_Hex_Zahl);
  end { if (NAME_TAB[NAME_TAB_POS].ASM_type=AT_word) then }
  else Fehler_cl.Registrieren('ZwischenCode/VAR_ARRAY_2d_CONST_bis_eintragen',
                           'der Zeiger des 2D-ARRAYs muss vom Typ Word sein',
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

  RESULT:=VAR_ARRAY_2d_CONST_ok;

end; { procedure ZWC_class.VAR_ARRAY_2d_CONST_bis_eintragen }







procedure ZWC_class.VAR_ARRAY_Type_eintragen(VAT : String);
var
  VAT_ASM_type : ASM_type_Typ;
begin

  if NAME_TAB[NAME_TAB_counter].bezeichner<>'' then begin
    if NAME_TAB[NAME_TAB_counter].ASM_type=AT_kein_typ then begin
      VAT_ASM_type:=TYPENAME_IN_TYPE(VAT);

      if VAT_ASM_type IN [AT_boolean, AT_byte, AT_char, AT_word, AT_dword] then begin
        NAME_TAB[NAME_TAB_counter].ASM_type:=VAT_ASM_type;
        VAR_ARRAY.LISTE[VAR_ARRAY.counter].ASM_type:=VAT_ASM_type;
        Inc(NAME_TAB_counter);

      end
      else
        Fehler_cl.Registrieren('ZwischenCode/VAR_ARRAY_Type_eintragen',
                               'in eiem ARRAY koennen nur die Typen: Boolean, Byte, Char, Word, DWord genutzt werden',
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

    end
    else
      Fehler_cl.Registrieren('ZwischenCode/VAR_ARRAY_Type_eintragen',
                             'Typ des ARRAYS bereits eingetragen ('+VAT+')',
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

   end
   else
     Fehler_cl.Registrieren('ZwischenCode/VAR_ARRAY_Type_eintragen',
                            'Name des ARRAYS noch nicht eingetragen ('+VAT+')',
                            Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                            Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                            Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

end; { procedure ZWC_class.VAR_ARRAY_Type_eintragen }







function ZWC_class.VAR_STRING_Type_eintragen(VST : String) : Boolean;
var
  VST_ASM_type : ASM_type_Typ;
  STR_erfolgreich : Boolean;
begin
  STR_erfolgreich:=false;

  if NAME_TAB[NAME_TAB_counter].bezeichner<>'' then begin
    if NAME_TAB[NAME_TAB_counter].ASM_type=AT_kein_typ then begin
      VST_ASM_type:=TYPENAME_IN_TYPE(VST);

      if VST_ASM_type = AT_string then begin

        if VAR_Liste_aktiv then
          Type_in_VAR_Liste_eintragen(VST)
        else
          NAME_TAB[NAME_TAB_counter].ASM_type:=VST_ASM_type;

        STR_erfolgreich:=true;
      end; { if VAT_ASM_type = AT_string then }
    end; { if NAME_TAB[NAME_TAB_counter].ASM_type=AT_kein_typ then }
  end; { if NAME_TAB[NAME_TAB_counter].bezeichner<>'' then }

  Result:=STR_erfolgreich;

end; { function ZWC_class.VAR_STRING_Type_eintragen }










procedure ZWC_class.VAR_STRING_LEN_eintragen(VSL : String; VSL_UT : SI_Unter_Typ);
var
  Laenge : LongInt;
  S_Zahl : String;


  procedure Laenge_in_VAR_Liste_eintragen;
  var
    L_Zaehler : Integer;
  begin
    if VAR_Listen_Pos>0 then begin
      for L_Zaehler:=VAR_Listen_Pos to NAME_TAB_counter do begin
        NAME_TAB[L_Zaehler].Laenge:=Laenge;
      end; { for L_Zaehler:=VAR_Listen_Pos to NAME_TAB_counter do }
    end; { if VAR_Listen_Pos>0 then }
  end; { procedure Type_in_VAR_Liste_eintragen }


begin

  if NAME_TAB[NAME_TAB_counter].bezeichner<>'' then begin

    if CONST_WERT_ueberpruefen(VSL,VSL_UT,AT_byte) then begin

      S_Zahl:='$'+Copy(VSL,3,Length(VSL)-2);
      Laenge:=StrToInt(S_Zahl);

      if Laenge<255 then begin

        if VAR_Liste_aktiv then
          Laenge_in_VAR_Liste_eintragen
        else
          NAME_TAB[NAME_TAB_counter].Laenge:=Laenge;


        Inc(NAME_TAB_counter);

      end
      else
        Fehler_cl.Registrieren('ZwischenCode/VAR_STRING_LEN_eintragen',
                               'die Lange einer STRING darf maximal 254 betragen ('+VSL+')',
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

    end; { if CONST_WERT_ueberpruefen(CAE,CAE_UT,AT_word) then }

  end
  else
    Fehler_cl.Registrieren('ZwischenCode/VAR_STRING_LEN_eintragen',
                           'Name der STRING noch nicht eingetragen ('+VSL+')',
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

  VAR_Liste_aktiv:=false;
  VAR_Listen_Pos:=0;

end; { procedure ZWC_class.VAR_STRING_LEN_eintragen }









function ZWC_class.VAR_Ende : Boolean;
var
  VE_erfolgreich : Boolean;
begin
  VE_erfolgreich:=false;
  if NAME_TAB[NAME_TAB_counter].bezeichner='' then begin
    VE_erfolgreich:=true;
  end
  else
    Fehler_cl.Registrieren('ZwischenCode/VAR_Ende',
                           'Name eingetragen ('+
                           NAME_TAB[NAME_TAB_counter].bezeichner+
                           '), aber Variablendefinition unvollstaendig',
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

  Result:=VE_erfolgreich;
end; { function ZWC_class.VAR_Ende }












// ********************************************
//          Deklaration - CONST
// ********************************************



function ZWC_class.CONST_NAME_eintragen(CN : String) : Boolean;
var
  CN_erfolgreich : Boolean;
begin
  CN_erfolgreich:=false;
  if NAME_TAB[NAME_TAB_counter].bezeichner='' then begin
    if NAME_TAB[NAME_TAB_counter].ASM_type=AT_kein_typ  then begin
      if not NAME_vorhanden(CN) then begin
        NAME_TAB[NAME_TAB_counter].bezeichner:=CN;
        NAME_TAB[NAME_TAB_counter].ANW_type:='C';
        CN_erfolgreich:=true;
      end
      else
        Fehler_cl.Registrieren('ZwischenCode/CONST_NAME_eintragen','Name bereits vergeben ('+CN+')',
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

    end
    else
      Fehler_cl.Registrieren('ZwischenCode/CONST_NAME_eintragen','Typ zur Konstante bereits eingetragen ('+CN+')',
                              Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                              Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                              Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);
  end
  else
    Fehler_cl.Registrieren('ZwischenCode/CONST_NAME_eintragen','Konstante bereits eingetragen ('+CN+')',
                            Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                            Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                            Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

  Result:=CN_erfolgreich;
end; { procedure ZWC_class.CONST_NAME_eintragen }




function ZWC_class.CONST_TYPE_eintragen(CT : String) : Boolean;
var
  CT_erfolgreich : Boolean;


begin
  CT_erfolgreich:=false;
  if NAME_TAB[NAME_TAB_counter].bezeichner<>'' then begin
      if NAME_TAB[NAME_TAB_counter].ASM_type=AT_kein_typ  then begin
        NAME_TAB[NAME_TAB_counter].ASM_type:=TYPENAME_IN_TYPE(CT);
        CT_erfolgreich:=true;
      end
      else
        Fehler_cl.Registrieren('ZwischenCode/CONST_TYPE_eintragen','Typ zur Konstante bereits eingetragen ('+CT+')',
                                Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                                Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                                Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);
  end
  else
    Fehler_cl.Registrieren('ZwischenCode/CONST_TYPE_eintragen','Konstantennname zum Typ noch nicht eingetragen ('+CT+')',
                            Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                            Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                            Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);


  Result:=CT_erfolgreich;
end; { procedure ZWC_class.CONST_TYPE_eintragen }







function ZWC_class.CONST_WERT_ueberpruefen(var CW : String; CUT : SI_Unter_Typ; CT : ASM_type_Typ) : Boolean;
var
  CWu_erfolgreich : Boolean;
  CW_Zahl, Nachkomma : QWord;
  Curr_Zahl : Currency;
  NK_String : String;

begin
  CWu_erfolgreich:=false;
  case CT of
    AT_boolean :
      begin
        case CUT of
          UT_Bez_TRUE :
            begin
              CW:='0xFF';
              CWu_erfolgreich:=true;
            end;
          UT_Bez_FALSE :
            begin
              CW:='0x00';
              CWu_erfolgreich:=true;
            end;
        else
          Fehler_cl.Registrieren('ZwischenCode/CONST_WERT_ueberpruefen',
            'Einer Boolean-Konstante kann nur den Wert TRUE oder FALSE zugewiesen werden ('+CW+')',
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);
        end; { case CUT of }
      end; { AT_boolean }
    AT_byte    :
      begin
        case CUT of
          UT_Dezi_Zahl, UT_Bin_Zahl, UT_Hex_Zahl :
            begin
              CW_Zahl:=SysUtils.StrToQWordDef(CW,$FFFFFFFFFFFF);
              if CW_Zahl=$FFFFFFFFFFFF then
                Fehler_cl.Registrieren('ZwischenCode/CONST_WERT_ueberpruefen',
                'Einer Byte-Konstante kann nur eine Zahl zugewiesen werden ('+CW+')',
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

              if (CW_Zahl<0) or (CW_Zahl>255) then
                Fehler_cl.Registrieren('ZwischenCode/CONST_WERT_ueberpruefen',
                'Wertebereich ueberschritten - BYTE = 0..255 ('+CW+')',
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

              if not Fehler_cl.gemeldet then begin
                CW:='0x'+IntToHex(CW_Zahl,2);
                CWu_erfolgreich:=true;
              end;

            end; { UT_Dezi_Zahl, UT_Bin_Zahl, UT_Hex_Zahl }

        else
          Fehler_cl.Registrieren('ZwischenCode/CONST_WERT_ueberpruefen',
            'Einer Byte-Konstante kann nur eine Zahl (Dezimal, Hexadezimal, Binaer) zugewiesen werden ('+CW+')',
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

        end; { case CUT of }

      end; { AT_byte }

    AT_word :

      begin
        case CUT of
          UT_Dezi_Zahl, UT_Bin_Zahl, UT_Hex_Zahl :
            begin
              CW_Zahl:=SysUtils.StrToQWordDef(CW,$FFFFFFFFFFFF);
              if CW_Zahl=$FFFFFFFFFFFF then
                Fehler_cl.Registrieren('ZwischenCode/CONST_WERT_ueberpruefen',
                'Einer Word-Konstante kann nur eine Zahl zugewiesen werden ('+CW+')',
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

              if (CW_Zahl<0) or (CW_Zahl>65535) then
                Fehler_cl.Registrieren('ZwischenCode/CONST_WERT_ueberpruefen',
                'Wertebereich ueberschritten - WORD = 0..65535 ('+CW+')',
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

              if not Fehler_cl.gemeldet then begin
                CW:='0x'+IntToHex(CW_Zahl,4);
                CWu_erfolgreich:=true;
              end;

            end; { UT_Dezi_Zahl, UT_Bin_Zahl, UT_Hex_Zahl }

        else
          Fehler_cl.Registrieren('ZwischenCode/CONST_WERT_ueberpruefen',
            'Einer Word-Konstante kann nur eine Zahl (Dezimal, Hexadezimal, Binaer) zugewiesen werden ('+CW+')',
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);
        end; { case CUT of }

      end; { AT_word }


    AT_dword :

      begin
        case CUT of
          UT_Dezi_Zahl, UT_Bin_Zahl, UT_Hex_Zahl :
            begin
              CW_Zahl:=SysUtils.StrToQWordDef(CW,$FFFFFFFFFFFF);
              if CW_Zahl=$FFFFFFFFFFFF then
                Fehler_cl.Registrieren('ZwischenCode/CONST_WERT_ueberpruefen',
                'Einer DWord-Konstante kann nur eine Zahl zugewiesen werden ('+CW+')',
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

              if (CW_Zahl<0) or (CW_Zahl>4294967295) then
                Fehler_cl.Registrieren('ZwischenCode/CONST_WERT_ueberpruefen',
                'Wertebereich ueberschritten - DWORD = 0..4294967295 ('+CW+')',
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);
              if not Fehler_cl.gemeldet then begin
                CW:=IntToHex(CW_Zahl,8);
                CWu_erfolgreich:=true;
              end;

            end; { UT_Dezi_Zahl, UT_Bin_Zahl, UT_Hex_Zahl }

        else
          Fehler_cl.Registrieren('ZwischenCode/CONST_WERT_ueberpruefen',
            'Einer DWord-Konstante kann nur eine Zahl (Dezimal, Hexadezimal, Binaer) zugewiesen werden ('+CW+')',
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);
        end; { case CUT of }

      end; { AT_dword }



    AT_char, AT_string :
      begin
        if CUT=UT_Char_Zahl then begin

          IF Length(CW)>1 then begin
            CW:=Copy(CW,2,Length(CW));
          end
          else
            Fehler_cl.Registrieren('ZWC_01/CONST_WERT_ueberpruefen',
            'Einer numerische CHAR-Konstante kann nur eine Zahl zugewiesen werden ('+CW+')',
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);


          CW_Zahl:=SysUtils.StrToQWordDef(CW,$FFFFFFFFFFFF);
          if CW_Zahl=$FFFFFFFFFFFF then
            Fehler_cl.Registrieren('ZWC_01/CONST_WERT_ueberpruefen',
            'Einer numerische CHAR-Konstante kann nur eine Zahl zugewiesen werden ('+CW+')',
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

          if (CW_Zahl<0) or (CW_Zahl>255) then
            Fehler_cl.Registrieren('ZWC_01/CONST_WERT_ueberpruefen',
            'Wertebereich ueberschritten - BYTE = 0..255 ('+CW+')',
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

          if not Fehler_cl.gemeldet then begin
            CW:='0x'+IntToHex(CW_Zahl,2);
            CWu_erfolgreich:=true;
          end;

        end
        else begin

          if (CT=AT_char) and (CW='\') then begin
            CW:='0x5C';
          end
          else begin
            CW:=CHR($27)+CW+CHR($27);
          end; { if (CT=AT_char) and (CW='\') then }

          CWu_erfolgreich:=true;
        end;
      end; { AT_char, AT_string }



    AT_currency :
      begin

        case CUT of
          UT_Dezi_Zahl, UT_Hex_Zahl, UT_Curr_Zahl :
            begin

              if Pos('.',CW)>0 then begin

                NK_String:=Copy(CW,Pos('.',CW)+1,5);

                While Length(NK_String)<4 do
                  NK_String:=NK_String+'0';

                Delete(CW,Pos('.',CW),Length(CW));
                Nachkomma:=StrToInt(NK_String);

              end
              else
                Nachkomma:=0;

              Curr_Zahl:=SysUtils.StrToCurr(CW);
              CW_Zahl:=QWord(Curr_Zahl)+Nachkomma;
              CW:=IntToStr(CW_Zahl);
             // CW:=IntToHex(CW_Zahl,16);
              CWu_erfolgreich:=true;


            end; { UT_Dezi_Zahl, UT_Curr_Zahl, UT_Hex_Zahl }

        else
          Fehler_cl.Registrieren('ZwischenCode/CONST_WERT_ueberpruefen',
            'Einer Currency-Konstante kann nur eine Zahl (Dezimal, Hexadezimal, Currency) zugewiesen werden ('+CW+')',
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);
        end; { case CUT of }

      end; { AT_currency }



  else
    Fehler_cl.Registrieren('ZwischenCode/CONST_WERT_ueberpruefen',
                           'Der Konstantenwert CW wurde nicht ausgewertet ('+
                           IntToStr(NAME_TAB_counter)+')',
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);
  end;
  Result:=CWu_erfolgreich;
end; { function ZWC_class.CONST_WERT_ueberpruefen }





function ZWC_class.CONST_WERT_eintragen(CW : String; CUT : SI_Unter_Typ) : Boolean;
var
  CW_erfolgreich : Boolean;

begin
  CW_erfolgreich:=false;

  if CONST_WERT_ueberpruefen(CW,CUT,NAME_TAB[NAME_TAB_counter].ASM_type) then begin

    Inc_CONST_TERM_counter;
    CONST_TERM.LISTE[CONST_TERM.counter].Wert:=CW;
    CONST_TERM.LISTE[CONST_TERM.counter].Kennzeichner:='C';

    CW_erfolgreich:=true;

  end; { if CONST_WERT_ueberpruefen(CW,CUT,ZC_CONST_TAB[ZC_CONST_TAB_counter].ASM_type) then }

  Result:=CW_erfolgreich;

end; { function ZWC_class.CONST_WERT_eintragen }






function ZWC_class.CONST_Bezeichner_eintragen(CB : String) : Boolean;
var
  CB_erfolgreich : Boolean;
  name_pos : Integer;

begin
  CB_erfolgreich:=false;

  name_pos:=NAME_in_NAME_TAB_suchen(CB);

  if name_pos>0 then begin

    if NAME_TAB_counter>name_pos then begin

      if NAME_TAB[NAME_TAB_counter].ASM_type=NAME_TAB[name_pos].ASM_type then begin

        Inc_CONST_TERM_counter;
        CONST_TERM.LISTE[CONST_TERM.counter].Wert:=NAME_TAB[name_pos].Wert;
        CONST_TERM.LISTE[CONST_TERM.counter].Kennzeichner:='C';
        CB_erfolgreich:=true;

      end
      else
        Fehler_cl.Registrieren('ZwischenCode/CONST_Bezeichner_eintragen',
                               'Der Typ der neuen Kostante <'+
                               NAME_TAB[NAME_TAB_counter].bezeichner+
                               '> ('+
                               Compiler_cl.ASM_type_Typ_in_Bezeichner(NAME_TAB[NAME_TAB_counter].ASM_type)+
                               ') stimmt nicht mit dem Typ der zuzuweisenden Konstante <'+
                               NAME_TAB[name_pos].bezeichner+'='+
                               NAME_TAB[name_pos].Wert+
                               '> ('+
                               Compiler_cl.ASM_type_Typ_in_Bezeichner(NAME_TAB[name_pos].ASM_type)+
                               ') ueberein',
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

    end
    else
      Fehler_cl.Registrieren('ZwischenCode/CONST_Bezeichner_eintragen',
                             'Der aktuelle Konstanten-Bezeichner ('+CB+
                             ') kann nicht fuer die Definition dieser Konstante genutzt werden',
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

  end
  else
    Fehler_cl.Registrieren('ZwischenCode/CONST_Bezeichner_eintragen',
                           'Der Bezeichner ('+CB+') wurde nicht gefunden',
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);


  Result:=CB_erfolgreich;

end; { function ZWC_class.CONST_Bezeichner_eintragen }








procedure ZWC_class.CONST_Operator_eintragen(C_OP : Char);
begin

  Inc_CONST_TERM_counter;
  CONST_TERM.LISTE[CONST_TERM.counter].Wert:='';
  CONST_TERM.LISTE[CONST_TERM.counter].Kennzeichner:=C_OP;

end; { procedure ZWC_class.CONST_Operator_eintragen }










function ZWC_class.CONST_Term_berechnen : Boolean;
var
  CT_erfolgreich, Erster_Wert_ist_negativ,
  Zweiter_Wert_ist_negativ  : Boolean;
  VZ_Zaehler{, name_pos} : Integer;



    procedure Term_Addition;
    var
      Summand1, Summand2, Summe : Int64;
    begin

      case NAME_TAB[NAME_TAB_counter].ASM_type of

        AT_byte, AT_word :
          begin
            Summand1:=StrToInt(CONST_TERM.LISTE[1].Wert);
            Summand2:=StrToInt(CONST_TERM.LISTE[3].Wert);
            Summe:=Summand1+Summand2;
            CONST_TERM.LISTE[1].Wert:=IntToStr(Summe);
          end; { AT_byte, AT_word }

        AT_dword :
          begin
            Summand1:=StrToInt('0x0'+CONST_TERM.LISTE[1].Wert);
            Summand2:=StrToInt('0x0'+CONST_TERM.LISTE[3].Wert);
            Summe:=Summand1+Summand2;
            CONST_TERM.LISTE[1].Wert:=IntToStr(Summe);
          end; { AT_dword }

        AT_currency :
          begin

            if Length(CONST_TERM.LISTE[1].Wert)>0 then begin
              if CONST_TERM.LISTE[1].Wert[1]='-' then begin
                Erster_Wert_ist_negativ := not Erster_Wert_ist_negativ;
                Delete(CONST_TERM.LISTE[1].Wert,1,1);
              end;
            end; { if Length(CONST_TERM.LISTE[1].Wert)>0 then }

            if Length(CONST_TERM.LISTE[3].Wert)>0 then begin
              if CONST_TERM.LISTE[3].Wert[1]='-' then begin
                Zweiter_Wert_ist_negativ := not Zweiter_Wert_ist_negativ;
                Delete(CONST_TERM.LISTE[3].Wert,1,1);
              end;
            end; { if Length(CONST_TERM.LISTE[3].Wert)>0 then }

            Summand1:=StrToInt(CONST_TERM.LISTE[1].Wert);
             Summand2:=StrToInt(CONST_TERM.LISTE[3].Wert);

            // Addition
            if (not Erster_Wert_ist_negativ) and (not Zweiter_Wert_ist_negativ) then
              Summe:=Summand1+Summand2;

            // Subtraktion
            if Erster_Wert_ist_negativ and (not Zweiter_Wert_ist_negativ) then
              Summe:=Summand2-Summand1;

            // Subtraktion
            if (not Erster_Wert_ist_negativ) and Zweiter_Wert_ist_negativ then
              Summe:=Summand1-Summand2;

            // Addition
            if Erster_Wert_ist_negativ and Zweiter_Wert_ist_negativ then begin
              Summe:=Summand1+Summand2;
              Summe:=0-Summe;
            end;

            CONST_TERM.LISTE[1].Wert:=IntToStr(Summe);

            Erster_Wert_ist_negativ:=false;
            Zweiter_Wert_ist_negativ:=false;

          end; { AT_byte, AT_word }

      end; { case NAME_TAB[NAME_TAB_counter].ASM_type of }

    end; { procedure Term_Addition }




    procedure Term_Subtraktion;
    var
      Minuend, Subtrahend, Differenz : Int64;
    begin

      case NAME_TAB[NAME_TAB_counter].ASM_type of

        AT_byte, AT_word :
          begin
            Minuend:=StrToInt(CONST_TERM.LISTE[1].Wert);
            Subtrahend:=StrToInt(CONST_TERM.LISTE[3].Wert);
            Differenz:=Minuend-Subtrahend;
            CONST_TERM.LISTE[1].Wert:=IntToStr(Differenz);
          end; { AT_byte, AT_word }

        AT_dword :
          begin
            Minuend:=StrToInt('0x0'+CONST_TERM.LISTE[1].Wert);
            Subtrahend:=StrToInt('0x0'+CONST_TERM.LISTE[3].Wert);
            Differenz:=Minuend-Subtrahend;
            CONST_TERM.LISTE[1].Wert:=IntToStr(Differenz);
          end; { AT_dword }

        AT_currency :
          begin

            if Length(CONST_TERM.LISTE[1].Wert)>0 then begin
              if CONST_TERM.LISTE[1].Wert[1]='-' then begin
                Erster_Wert_ist_negativ := not Erster_Wert_ist_negativ;
                Delete(CONST_TERM.LISTE[1].Wert,1,1);
              end;
            end; { if Length(CONST_TERM.LISTE[1].Wert)>0 then }

            if Length(CONST_TERM.LISTE[3].Wert)>0 then begin
              if CONST_TERM.LISTE[3].Wert[1]='-' then begin
                Zweiter_Wert_ist_negativ := not Zweiter_Wert_ist_negativ;
                Delete(CONST_TERM.LISTE[3].Wert,1,1);
              end;
            end; { if Length(CONST_TERM.LISTE[3].Wert)>0 then }

            Minuend:=StrToInt(CONST_TERM.LISTE[1].Wert);
            Subtrahend:=StrToInt(CONST_TERM.LISTE[3].Wert);

            // Subtraktion
            if (not Erster_Wert_ist_negativ) and (not Zweiter_Wert_ist_negativ) then
              Differenz:=Minuend-Subtrahend;

            // Addition und -
            if Erster_Wert_ist_negativ and (not Zweiter_Wert_ist_negativ) then begin
              Differenz:=Minuend+Subtrahend;
              Differenz:=0-Differenz;
            end;

            // Addition
            if (not Erster_Wert_ist_negativ) and Zweiter_Wert_ist_negativ then
              Differenz:=Minuend+Subtrahend;

            // Subtraktion (vertauscht)
            if Erster_Wert_ist_negativ and Zweiter_Wert_ist_negativ then
              Differenz:=Subtrahend-Minuend;

            CONST_TERM.LISTE[1].Wert:=IntToStr(Differenz);

            Erster_Wert_ist_negativ:=false;
            Zweiter_Wert_ist_negativ:=false;

          end; { AT_currency }

      end; { case NAME_TAB[NAME_TAB_counter].ASM_type of }

    end; { procedure Term_Subtraktion }






    procedure Term_Multiplikation;
    var
      Faktor1, Faktor2, Produkt : LongInt;
    begin

      case NAME_TAB[NAME_TAB_counter].ASM_type of

        AT_byte, AT_word :
          begin
            Faktor1:=StrToInt(CONST_TERM.LISTE[1].Wert);
            Faktor2:=StrToInt(CONST_TERM.LISTE[3].Wert);
            Produkt:=Faktor1*Faktor2;
            CONST_TERM.LISTE[1].Wert:=IntToStr(Produkt);
          end; { AT_byte, AT_word }

        AT_dword :
          begin
            Faktor1:=StrToInt('0x0'+CONST_TERM.LISTE[1].Wert);
            Faktor2:=StrToInt('0x0'+CONST_TERM.LISTE[3].Wert);
            Produkt:=Faktor1*Faktor2;
            CONST_TERM.LISTE[1].Wert:=IntToStr(Produkt);
          end; { AT_dword }

        AT_currency :
          begin

            if Length(CONST_TERM.LISTE[1].Wert)>0 then begin
              if CONST_TERM.LISTE[1].Wert[1]='-' then begin
                Erster_Wert_ist_negativ := not Erster_Wert_ist_negativ;
                Delete(CONST_TERM.LISTE[1].Wert,1,1);
              end;
            end; { if Length(CONST_TERM.LISTE[1].Wert)>0 then }

            if Length(CONST_TERM.LISTE[3].Wert)>0 then begin
              if CONST_TERM.LISTE[3].Wert[1]='-' then begin
                Zweiter_Wert_ist_negativ := not Zweiter_Wert_ist_negativ;
                Delete(CONST_TERM.LISTE[3].Wert,1,1);
              end;
            end; { if Length(CONST_TERM.LISTE[3].Wert)>0 then }

            Faktor1:=StrToInt(CONST_TERM.LISTE[1].Wert);
            Faktor2:=StrToInt(CONST_TERM.LISTE[3].Wert);

            Produkt:=Faktor1*Faktor2 DIV 10000;


            // - * +
            if Erster_Wert_ist_negativ and (not Zweiter_Wert_ist_negativ) then
              Produkt:=0-Produkt;

            // + * -
            if (not Erster_Wert_ist_negativ) and Zweiter_Wert_ist_negativ then
              Produkt:=0-Produkt;

            CONST_TERM.LISTE[1].Wert:=IntToStr(Produkt);

            Erster_Wert_ist_negativ:=false;
            Zweiter_Wert_ist_negativ:=false;

          end; { AT_currency }

       end; { case NAME_TAB[NAME_TAB_counter].ASM_type of }

    end; { procedure Term_Multiplikation }



    procedure Term_Division;
    var
      Divident, Divisor, Quotient : LongInt;
    begin


      case NAME_TAB[NAME_TAB_counter].ASM_type of

        AT_byte, AT_word :
          begin
            Divident:=StrToInt(CONST_TERM.LISTE[1].Wert);
            Divisor:=StrToInt(CONST_TERM.LISTE[3].Wert);
            Quotient:=Divident div Divisor;
            CONST_TERM.LISTE[1].Wert:=IntToStr(Quotient);
          end; { AT_byte, AT_word }

        AT_dword :
          begin
            Divident:=StrToInt('0x0'+CONST_TERM.LISTE[1].Wert);
            Divisor:=StrToInt('0x0'+CONST_TERM.LISTE[3].Wert);
            Quotient:=Divident div Divisor;
            CONST_TERM.LISTE[1].Wert:=IntToStr(Quotient);
          end; { AT_dword }

        AT_currency :
          begin

            if Length(CONST_TERM.LISTE[1].Wert)>0 then begin
              if CONST_TERM.LISTE[1].Wert[1]='-' then begin
                Erster_Wert_ist_negativ := not Erster_Wert_ist_negativ;
                Delete(CONST_TERM.LISTE[1].Wert,1,1);
              end;
            end; { if Length(CONST_TERM.LISTE[1].Wert)>0 then }

            if Length(CONST_TERM.LISTE[3].Wert)>0 then begin
              if CONST_TERM.LISTE[3].Wert[1]='-' then begin
                Zweiter_Wert_ist_negativ := not Zweiter_Wert_ist_negativ;
                Delete(CONST_TERM.LISTE[3].Wert,1,1);
              end;
            end; { if Length(CONST_TERM.LISTE[3].Wert)>0 then }

            Divident:=StrToInt(CONST_TERM.LISTE[1].Wert);
            Divisor:=StrToInt(CONST_TERM.LISTE[3].Wert);

            Quotient:=Divident div Divisor * 10000;


            // - * +
            if Erster_Wert_ist_negativ and (not Zweiter_Wert_ist_negativ) then
              Quotient:=0-Quotient;

            // + * -
            if (not Erster_Wert_ist_negativ) and Zweiter_Wert_ist_negativ then
              Quotient:=0-Quotient;

            CONST_TERM.LISTE[1].Wert:=IntToStr(Quotient);

            Erster_Wert_ist_negativ:=false;
            Zweiter_Wert_ist_negativ:=false;

          end; { AT_currency }

      end; { case NAME_TAB[NAME_TAB_counter].ASM_type of }

    end; { procedure Term_Division }




  procedure Berechnung_mehrerer_Termelemente;
  var
    CT_Zaehler : Integer;
  begin

    while CONST_TERM.counter>1 do begin

      if CONST_TERM.LISTE[2].Kennzeichner<>'C' then begin

        if CONST_TERM.counter>2 then begin

          // Auswertung des Vorzeichens
          if CONST_TERM.LISTE[3].Kennzeichner='-' then begin
            Zweiter_Wert_ist_negativ:=true;
            if CONST_TERM.counter>3 then begin
              for CT_Zaehler:=3 to CONST_TERM.counter-1 do begin
                CONST_TERM.LISTE[CT_Zaehler].Kennzeichner:=CONST_TERM.LISTE[CT_Zaehler+1].Kennzeichner;
                CONST_TERM.LISTE[CT_Zaehler].Wert:=CONST_TERM.LISTE[CT_Zaehler+1].Wert;
              end;
              Dec(CONST_TERM.counter);
            end; { if CONST_TERM.counter>1 then }
          end; { if CONST_TERM.LISTE[3].Kennzeichner='-' then }

          if CONST_TERM.LISTE[3].Kennzeichner='C' then begin

            case CONST_TERM.LISTE[2].Kennzeichner of
              '+' : Term_Addition;
              '-' : Term_Subtraktion;
              '*' : Term_Multiplikation;
              '/' : Term_Division;
            else
              Fehler_cl.Registrieren('ZwischenCode/CONST_Term_berechnen',
                                     'der Operator <'+CONST_TERM.LISTE[2].Kennzeichner+
                                     '> konnte nicht ausgewertet',
                                     Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                                     Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                                     Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);
              CONST_TERM.counter:=1;
            end; { case CONST_TERM.LISTE[2].Kennzeichner of }


            if CONST_TERM.counter>3 then begin

              for CT_Zaehler:=2 to CONST_TERM.counter-2 do begin
                CONST_TERM.LISTE[CT_Zaehler].Kennzeichner:=CONST_TERM.LISTE[CT_Zaehler+2].Kennzeichner;
                CONST_TERM.LISTE[CT_Zaehler].Wert:=CONST_TERM.LISTE[CT_Zaehler+2].Wert;
              end;
              CONST_TERM.counter:=CONST_TERM.counter-2;

            end
            else
              CONST_TERM.counter:=1;


          end
          else begin
            Fehler_cl.Registrieren('ZwischenCode/CONST_Term_berechnen',
                                   'das dritte Term-Element muss ein Konstanten-Wert oder ein '+
                                   'Konstanten-Bezeichner sein',
                                   Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                                   Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                                   Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);
            CONST_TERM.counter:=1;

          end; { if CONST_TERM.counter>2 then  }

        end
        else begin
          Fehler_cl.Registrieren('ZwischenCode/CONST_Term_berechnen',
                                 'nach dem Operator muss ein Konstanten-Wert oder ein '+
                                 'Konstanten-Bezeichner angegeben werden',
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);
          CONST_TERM.counter:=1;

        end; { if CONST_TERM.counter>2 then  }


      end
      else begin
        Fehler_cl.Registrieren('ZwischenCode/CONST_Term_berechnen',
                               'das zweite Term-Element muss ein Operator(+-*/) sein',
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);
        CONST_TERM.counter:=1;

      end; { if CONST_TERM.LISTE[2].Kennzeichner<>'C' then }

    end; { while CONST_TERM.counter>1 do }


  end; { procedure Berechnung_mehrerer_Termelemente }




  procedure Kontrolle_des_Wertebereiches_des_Ergebnisses;
  begin

    if not CONST_WERT_ueberpruefen
        (CONST_TERM.LISTE[1].Wert,UT_Hex_Zahl,NAME_TAB[NAME_TAB_counter].ASM_type) then

      Fehler_cl.Registrieren('ZwischenCode/CONST_Term_berechnen/Kontrolle_des_Wertebereiches_des_Ergebnisses',
                             'Der Typ der Konstante <'+
                             Compiler_cl.ASM_type_Typ_in_Bezeichner(NAME_TAB[NAME_TAB_counter].ASM_type)+
                             '> wird nicht unterstuetzt',
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

  end; { procedure Kontrolle_des_Wertebereiches_des_Ergebnisses }




begin
  CT_erfolgreich:=false;
  Erster_Wert_ist_negativ:=false;
  Zweiter_Wert_ist_negativ:=false;
  if NAME_TAB[NAME_TAB_counter].bezeichner<>'' then begin
      if NAME_TAB[NAME_TAB_counter].ASM_type<>AT_kein_typ  then begin
        if NAME_TAB[NAME_TAB_counter].Wert=''  then begin

          if CONST_TERM.counter>0 then begin

            // Auswertung des Vorzeichens
            if CONST_TERM.LISTE[1].Kennzeichner='-' then begin
              Erster_Wert_ist_negativ:=true;
              if CONST_TERM.counter>1 then begin
                for VZ_Zaehler:=1 to CONST_TERM.counter-1 do begin
                  CONST_TERM.LISTE[VZ_Zaehler].Kennzeichner:=CONST_TERM.LISTE[VZ_Zaehler+1].Kennzeichner;
                  CONST_TERM.LISTE[VZ_Zaehler].Wert:=CONST_TERM.LISTE[VZ_Zaehler+1].Wert;
                end;
                Dec(CONST_TERM.counter);
              end; { if CONST_TERM.counter>1 then }
            end; { if CONST_TERM.LISTE[1].Kennzeichner='-' then }


            if CONST_TERM.LISTE[1].Kennzeichner='C' then begin

              if CONST_TERM.counter>1 then begin

                if NAME_TAB[NAME_TAB_counter].ASM_type IN [AT_byte, AT_word,
                                                           AT_dword, AT_currency] then begin
                  Berechnung_mehrerer_Termelemente; // Ergebnis an Stelle: CONST_TERM.LISTE[1].Wert

                  if NAME_TAB[NAME_TAB_counter].ASM_type <> AT_currency then
                    Kontrolle_des_Wertebereiches_des_Ergebnisses;

                end
                else begin
                  Fehler_cl.Registrieren('ZwischenCode/CONST_Term_berechnen',
                                         'Terme mit mehreren Elementen werden nur fuer die '+
                                         'Typen: Byte, Word und DWord unterstuetzt',
                                         Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                                         Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                                         Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);
                end; { if NAME_TAB[NAME_TAB_counter].ASM_type IN [AT_byte, AT_word, AT_dword] then }

              end { if CONST_TERM.counter>1 then }
              else begin

                // Terme mit nur einem Wert
                if NAME_TAB[NAME_TAB_counter].ASM_type = AT_currency then begin

                    if Erster_Wert_ist_negativ then
                      CONST_TERM.LISTE[1].Wert:='-'+CONST_TERM.LISTE[1].Wert;

                end; { if NAME_TAB[NAME_TAB_counter].ASM_type = AT_currency then }


              end; { if CONST_TERM.counter=1 then }


              // Eischreiben des Konstanten-Wertes
              NAME_TAB[NAME_TAB_counter].ANW_type:='C';
              NAME_TAB[NAME_TAB_counter].Wert:=CONST_TERM.LISTE[1].Wert;

              CONST_TERM.LISTE[1].Kennzeichner:=' ';
              CONST_TERM.LISTE[1].Wert:='';
              CONST_TERM.counter:=0;

              CT_erfolgreich:=true;
              Inc(NAME_TAB_counter);

            end
            else
              Fehler_cl.Registrieren('ZwischenCode/CONST_Term_berechnen',
                                     'das erste Term-Element muss ein Konstanten-Wert oder ein '+
                                     'Konstanten-Bezeichner sein',
                                     Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                                     Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                                     Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

          end
          else
            Fehler_cl.Registrieren('ZwischenCode/CONST_Term_berechnen',
                                   'es wurde kein Wert fuer die Konstante angegeben',
                                   Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                                   Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                                   Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

        end
        else
          Fehler_cl.Registrieren('ZwischenCode/CONST_Term_berechnen',
                                   'Wert zur Konstante bereits eingetragen ('+
                                     NAME_TAB[NAME_TAB_counter].Wert+')',
                                   Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                                   Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                                   Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);
      end
      else
        Fehler_cl.Registrieren('ZwischenCode/CONST_Term_berechnen',
                               'Typ zur Konstante noch nicht angegeben',
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);
  end
  else
    Fehler_cl.Registrieren('ZwischenCode/CONST_Bezeichner_eintragen',
                           'Name der Konstante noch nicht angegeben',
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

  Result:=CT_erfolgreich;
end; { function ZWC_class.CONST_Term_berechnen }


















function ZWC_class.CONST_ARRAY_von_eintragen(CAA : String; CAA_UT : SI_Unter_Typ) : Boolean;
var
  CAA_erfolgreich : Boolean;
  CAA_Wert : LongInt;
  S_Zahl : String;
begin
  CAA_erfolgreich:=false;
  if NAME_TAB[NAME_TAB_counter].bezeichner<>'' then begin

    if CONST_WERT_ueberpruefen(CAA,CAA_UT,AT_word) then begin

      S_Zahl:='$'+Copy(CAA,3,Length(CAA)-2);
      CAA_Wert:=StrToInt(S_Zahl);

      if CAA_Wert<65536 then begin
        NAME_TAB[NAME_TAB_counter].ANW_type:='A';
        Inc_CONST_ARRAY_counter;
        CONST_ARRAY.LISTE[CONST_ARRAY.counter].Bezeichner:=NAME_TAB[NAME_TAB_counter].Bezeichner;
        CONST_ARRAY.LISTE[CONST_ARRAY.counter].Anfang:=Word(CAA_Wert);
        CAA_erfolgreich:=true;
      end
      else
        Fehler_cl.Registrieren('ZwischenCode/CONST_ARRAY_von_eintragen',
                               'der Zahlenwert fuer ARRAY-Anfang ('+CAA+') ueberschreitet den Maximalwert '+
                               'des Types Word (65535)',
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

    end;

  end
  else
    Fehler_cl.Registrieren('ZwischenCode/CONST_ARRAY_von_eintragen',
                           'Name des ARRAYS noch nicht eingetragen ('+CAA+')',
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

  Result:=CAA_erfolgreich;
end; { procedure ZWC_class.CONST_ARRAY_von_eintragen }







function ZWC_class.CONST_ARRAY_bis_WERT_eintragen(CAE : String; CAE_UT : SI_Unter_Typ) : Boolean;
var
  CAE_erfolgreich : Boolean;
  CAE_Wert, CAA_Wert, Laenge : LongInt;
  S_Zahl : String;
begin
  CAE_erfolgreich:=false;
  if NAME_TAB[NAME_TAB_counter].bezeichner<>'' then begin

    if CONST_WERT_ueberpruefen(CAE,CAE_UT,AT_word) then begin

      S_Zahl:='$'+Copy(CAE,3,Length(CAE)-2);
      CAE_Wert:=StrToInt(S_Zahl);

      if CAE_Wert<65536 then begin

        CAA_Wert:=CONST_ARRAY.LISTE[CONST_ARRAY.counter].Anfang;
        Laenge:=CAE_Wert-CAA_Wert+1;

        if Laenge>1 then begin

          CONST_ARRAY.LISTE[CONST_ARRAY.counter].Laenge:=Word(Laenge);
          CAE_erfolgreich:=true;

        end
        else
          Fehler_cl.Registrieren('ZwischenCode/CONST_ARRAY_bis_WERT_eintragen',
                                 'das ARRAY muss mindestens 2 Elemente enthalten ('+IntToStr(Laenge)+')',
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

      end
      else
        Fehler_cl.Registrieren('ZwischenCode/CONST_ARRAY_bis_WERT_eintragen',
                               'der Zahlenwert fuer ARRAY-Ende ('+CAE+') ueberschreitet den Maximalwert '+
                               'des Types Word (65535)',
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

    end; { if CONST_WERT_ueberpruefen(CAE,CAE_UT,AT_word) then }

  end
  else
    Fehler_cl.Registrieren('ZwischenCode/CONST_ARRAY_bis_WERT_eintragen',
                           'Name des ARRAYS noch nicht eingetragen ('+CAE+')',
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

  Result:=CAE_erfolgreich;

end; { procedure ZWC_class.CONST_ARRAY_bis_WERT_eintragen }














function ZWC_class.CONST_ARRAY_bis_CONST_eintragen(CAE : String) : Boolean;
var
  CAE_erfolgreich : Boolean;
  CAE_Wert, CAA_Wert, Laenge : LongInt;
  Name_Pos : Integer;
  CAE_STR_Wert, S_Zahl : String;
begin
  CAE_erfolgreich:=false;

  Name_Pos:=NAME_in_NAME_TAB_suchen(CAE);

  CAE_STR_Wert:=NAME_TAB[Name_Pos].Wert;

  if NAME_TAB[NAME_TAB_counter].bezeichner<>'' then begin

    if NAME_TAB[Name_Pos].ASM_type=AT_word then begin

      S_Zahl:='$'+Copy(CAE_STR_Wert,3,Length(CAE_STR_Wert)-2);
      CAE_Wert:=StrToInt(S_Zahl);

      if CAE_Wert<65536 then begin

        CAA_Wert:=CONST_ARRAY.LISTE[CONST_ARRAY.counter].Anfang;
        Laenge:=CAE_Wert-CAA_Wert+1;

        if Laenge>1 then begin

          CONST_ARRAY.LISTE[CONST_ARRAY.counter].Laenge:=Word(Laenge);
          CAE_erfolgreich:=true;

        end
        else
          Fehler_cl.Registrieren('ZwischenCode/CONST_ARRAY_bis_CONST_eintragen',
                                 'das ARRAY muss mindestens 2 Elemente enthalten ('+IntToStr(Laenge)+')',
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

      end
      else
        Fehler_cl.Registrieren('ZwischenCode/CONST_ARRAY_bis_CONST_eintragen',
                               'der Zahlenwert fuer ARRAY-Ende ('+CAE+') ueberschreitet den Maximalwert '+
                               'des Types Word (65535)',
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);


    end { if NAME_TAB[Name_Pos].ASM_type=AT_word then }
    else
      Fehler_cl.Registrieren('ZwischenCode/CONST_ARRAY_bis_CONST_eintragen',
                             'der Endwertes fuer das Konstanten-ARRAY muss vom Typ <WORD> sein',
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

  end
  else
    Fehler_cl.Registrieren('ZwischenCode/CONST_ARRAY_bis_CONST_eintragen',
                           'Name des ARRAYS noch nicht eingetragen ('+CAE+')',
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

  Result:=CAE_erfolgreich;

end; { procedure ZWC_class.CONST_ARRAY_bis_CONST_eintragen }














function ZWC_class.CONST_ARRAY_Type_eintragen(CAT : String) : Boolean;
var
  CAT_erfolgreich : Boolean;
  CAT_ASM_type : ASM_type_Typ;
begin
  CAT_erfolgreich:=false;

  if NAME_TAB[NAME_TAB_counter].bezeichner<>'' then begin
    if NAME_TAB[NAME_TAB_counter].ASM_type=AT_kein_typ  then begin
      CAT_ASM_type:=TYPENAME_IN_TYPE(CAT);

      if CAT_ASM_type IN [AT_boolean, AT_byte, AT_char, AT_word, AT_dword] then begin
         NAME_TAB[NAME_TAB_counter].ASM_type:=CAT_ASM_type;
         CONST_ARRAY.LISTE[CONST_ARRAY.counter].ASM_type:=CAT_ASM_type;
         CAT_erfolgreich:=true;
      end
      else
        Fehler_cl.Registrieren('ZwischenCode/CONST_ARRAY_Type_eintragen',
                               'in eiem ARRAY koennen nur die Typen: Boolean, Byte, Word, Char genutzt werden',
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

    end
    else
      Fehler_cl.Registrieren('ZwischenCode/CONST_ARRAY_Type_eintragen','Typ des ARRAYS bereits eingetragen ('+CAT+')',
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

   end
   else
     Fehler_cl.Registrieren('ZwischenCode/CONST_ARRAY_Type_eintragen','Name des ARRAYS noch nicht eingetragen ('+CAT+')',
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

  Result:=CAT_erfolgreich;

end; { function ZWC_class.CONST_ARRAY_Type_eintragen }





function ZWC_class.CONST_ARRAY_Element_eintragen(CAE : String; CAE_UT : SI_Unter_Typ) : Boolean;
var
  CAE_erfolgreich : Boolean;
  CAE_ASM_type : ASM_type_Typ;
  Laenge_Liste, Laenge_Definition : Word;
begin
  CAE_erfolgreich:=false;
  if NAME_TAB[NAME_TAB_counter].bezeichner<>'' then begin

    CAE_ASM_type:=NAME_TAB[NAME_TAB_counter].ASM_type;
    if CONST_WERT_ueberpruefen(CAE,CAE_UT,CAE_ASM_type) then begin

      Laenge_Liste:=CONST_ARRAY.LISTE[CONST_ARRAY.counter].Werte.Count+1;
      Laenge_Definition:=CONST_ARRAY.LISTE[CONST_ARRAY.counter].Laenge;

      if Laenge_Liste<=Laenge_Definition then begin
        CONST_ARRAY.LISTE[CONST_ARRAY.counter].Werte.Add(CAE);
        CAE_erfolgreich:=true;
      end
      else
        Fehler_cl.Registrieren('ZwischenCode/CONST_ARRAY_Element_eintragen',
                               'Anzahl der vereinbarten Array-Elemente wurde ueberschritten ('+
                               IntToStr(Laenge_Definition)+')',
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);


    end; { if CONST_WERT_ueberpruefen(CAE,CAE_UT,AT_word) then }

  end
  else
    Fehler_cl.Registrieren('ZwischenCode/CONST_ARRAY_Element_eintragen',
                           'Name des ARRAYS noch nicht eingetragen ('+CAE+')',
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

  Result:=CAE_erfolgreich;

end; { function ZWC_class.CONST_ARRAY_Element_eintragen }






procedure ZWC_class.CONST_ARRAY_Ende_eintragen;
var
  Laenge_Liste, Laenge_Definition : Word;
begin

  Laenge_Liste:=CONST_ARRAY.LISTE[CONST_ARRAY.counter].Werte.Count;
  Laenge_Definition:=CONST_ARRAY.LISTE[CONST_ARRAY.counter].Laenge;

  if Laenge_Liste<>Laenge_Definition then
    Fehler_cl.Registrieren('ZwischenCode/CONST_ARRAY_Ende_eintragen',
                           'die Anzahl der vereinbarten Array-Elemente ('+IntToStr(Laenge_Definition)+
                           ') stimmt nicht mit der Anzahl der eingetragenen Array-Elemente ('+
                           IntToStr(Laenge_Liste)+') ueberein',
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

  // Freigane der NAME_TAB fuer den naechsten Eintrag
  Inc(NAME_TAB_counter);

end; { procedure ZWC_class.CONST_ARRAY_Ende_eintragen }













// ********************************************
//              Zuweisung
// ********************************************



function ZWC_class.Zuweisung_Ziel_eintragen(ZZ : String) : Boolean;
var
  ZZ_erfolgreich : Boolean;
  ZZ_type : ASM_type_Typ;
  ANW_type : Char;
begin
    {
  if ZZ<>'X_KUR_POS' then
    ZZ_erfolgreich:=true;
       }


  ZZ_erfolgreich:=false;




  if NAME_TO_ANW_und_ASM(ZZ,ANW_type,ZZ_type) then begin

    if (ANW_type IN ['V','L','D']) and (ZZ_type<>AT_kein_typ) then begin

      Inc_ZUW_LIS_LISTcounter;

      ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].ziel:=ZZ;
      ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_type:=ZZ_type;
      ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].ziel_ANW_type:=ANW_type;
      ZZ_erfolgreich:=true;

      case ZZ_type of
        AT_byte_con_reg : ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_Grund_type:=AT_byte;
        AT_word_con_reg : ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_Grund_type:=AT_word;
        AT_byte_con_var : ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_Grund_type:=AT_byte;
        AT_word_con_var : ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_Grund_type:=AT_word;
      else
        ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_Grund_type:=ZZ_type;
      end;

    end; { if (ANW_type IN []) and }

  end; { if NAME_TO_ANW_und_ASM(ZZ,ANW_type,ZZ_type) then }


  Result:=ZZ_erfolgreich;
end; { function ZWC_class.Zuweisung_Ziel_eintragen }













// testet, ob der Bezeichner ZZ in der Namenliste vorhanden ist
// dann wird getestet, ob es sich hier wirklich um ein eindimensionales
// ARRAY handelt (dann ist der ANW_type='Y')
function ZWC_class.Zuweisung_Ziel_VAR_ARRAY_1D_eintragen(ZZ : String) : Boolean;
var
  ZZ_erfolgreich : Boolean;
  ZZ_type : ASM_type_Typ;
  ANW_type : Char;
begin
  ZZ_erfolgreich:=false;

  if NAME_TO_ANW_und_ASM(ZZ,ANW_type,ZZ_type) then begin

    if (ANW_type='Y') and (ZZ_type<>AT_kein_typ) then begin

      Inc_ZUW_LIS_LISTcounter;

      ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].nur_ein_Array:=true;
      ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel:=ZZ;
      ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_type:=ZZ_type;
      ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_Grund_type:=ZZ_type;
      ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].ziel_ANW_type:=ANW_type;


      Inc_ZUW_LIS_LISTcounter;

      // !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
      ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_Grund_type:=AT_word;
      ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_type:=AT_word;

      ZZ_erfolgreich:=true;

    end; { if (ANW_type='Y') and (ZZ_type<>AT_kein_typ) then }

  end; { if NAME_TO_ANW_und_ASM(ZZ,ANW_type,ZZ_type) then }


  Result:=ZZ_erfolgreich;
end; { function ZWC_class.Zuweisung_Ziel_VAR_ARRAY_1D_eintragen }


















// testet, ob der Bezeichner ZZ in der Namenliste vorhanden ist
// dann wird getestet, ob es sich hier wirklich um ein zweidimensionales
// ARRAY handelt (dann ist der ANW_type='Z')
function ZWC_class.Zuweisung_Ziel_VAR_ARRAY_2D_eintragen(ZZ : String) : Boolean;
var
  ZZ_erfolgreich : Boolean;
  ZZ_type : ASM_type_Typ;
  ANW_type : Char;
begin
  ZZ_erfolgreich:=false;

  if NAME_TO_ANW_und_ASM(ZZ,ANW_type,ZZ_type) then begin

    if (ANW_type='Z') and (ZZ_type<>AT_kein_typ) then begin

      Inc_ZUW_LIS_LISTcounter;

      ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].nur_ein_Array:=true;
      ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel:=ZZ;
      ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_type:=ZZ_type;
      ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_Grund_type:=ZZ_type;
      ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].ziel_ANW_type:=ANW_type;


      Inc_ZUW_LIS_LISTcounter;

      // !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
      ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_Grund_type:=AT_word;
      ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_type:=AT_word;




      Inc_ZUW_LIS_LISTcounter;

      // !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
      ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_Grund_type:=AT_word;
      ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_type:=AT_word;




      ZZ_erfolgreich:=true;

    end; { if (ANW_type='Y') and (ZZ_type<>AT_kein_typ) then }

  end; { if NAME_TO_ANW_und_ASM(ZZ,ANW_type,ZZ_type) then }


  Result:=ZZ_erfolgreich;
end; { function ZWC_class.Zuweisung_Ziel_VAR_ARRAY_2D_eintragen }






















procedure ZWC_class.Zuweisung_Ziel_VAR_ARRAY_POS_1D_eintragen;
begin

  Faktor_STM_TAB_eintragen('VAR ARRAY-1D POSITION');
  Ruecksetzen_Zuweisung;


  STM_LISTE[STM_LISTE_counter].Bemerkung:=
            '; VAR ARRAY Ziel Zeiger berechnen ('+ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel+')';


  STM_LISTE[STM_LISTE_counter].statement:=STM_LDI_word_L;
  STM_LISTE[STM_LISTE_counter].parameter1:=ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel;
  STM_LISTE[STM_LISTE_counter].parameter2:='ZL';
  Inc_STM_TAB_counter;

  STM_LISTE[STM_LISTE_counter].statement:=STM_LDI_word_H;
  STM_LISTE[STM_LISTE_counter].parameter1:=ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel;
  STM_LISTE[STM_LISTE_counter].parameter2:='ZH';
  Inc_STM_TAB_counter;




  case ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_type of

    AT_word : begin

      // bei einem Word-Array muss der Zeiger mit 2 multipliziert werden
      STM_LISTE[STM_LISTE_counter].statement:=STM_SHL_word;
      STM_LISTE[STM_LISTE_counter].Parameter1:='R16';
      STM_LISTE[STM_LISTE_counter].parameter2:='R17';
      Inc_STM_TAB_counter;
              end; { AT_word }

   AT_dword : begin

      // bei einem Word-Array muss der Zeiger mit 4 multipliziert werden
      STM_LISTE[STM_LISTE_counter].statement:=STM_SHL_word;
      STM_LISTE[STM_LISTE_counter].Parameter1:='R16';
      STM_LISTE[STM_LISTE_counter].parameter2:='R17';
      Inc_STM_TAB_counter;

      STM_LISTE[STM_LISTE_counter].statement:=STM_SHL_word;
      STM_LISTE[STM_LISTE_counter].Parameter1:='R16';
      STM_LISTE[STM_LISTE_counter].parameter2:='R17';
      Inc_STM_TAB_counter;

              end; { AT_dword }


  end; { case ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_type of }




  STM_LISTE[STM_LISTE_counter].statement:=STM_zuw_op_add_word_L;
  STM_LISTE[STM_LISTE_counter].Parameter1:='R16';
  STM_LISTE[STM_LISTE_counter].parameter2:='ZL';
  Inc_STM_TAB_counter;

  STM_LISTE[STM_LISTE_counter].statement:=STM_zuw_op_add_word_H;
  STM_LISTE[STM_LISTE_counter].Parameter1:='R17';
  STM_LISTE[STM_LISTE_counter].parameter2:='ZH';
  Inc_STM_TAB_counter;

  STM_LISTE[STM_LISTE_counter].statement:=STM_PUSH;
  STM_LISTE[STM_LISTE_counter].parameter1:='ZL';
  Inc_STM_TAB_counter;

  STM_LISTE[STM_LISTE_counter].statement:=STM_PUSH;
  STM_LISTE[STM_LISTE_counter].parameter1:='ZH';
  Inc_STM_TAB_counter;

end; { procedure ZWC_class.Zuweisung_Ziel_VAR_ARRAY_POS_1D_eintragen }
















procedure ZWC_class.Zuweisung_Ziel_VAR_ARRAY_POS_2D_01_eintragen;
var
  POS_VAR_ARRAY : Integer;
  ST1, HexWert : String;
  VA_REC : VAR_ARRAY_REC;
  VA_Laenge2 : Word;

begin

  Faktor_STM_TAB_eintragen('VAR ARRAY-2D POSITION 01');
  Ruecksetzen_Zuweisung;


  /// aaaaaaa


  // Multiplikation mit Laenge 2. Dimension

  // ARRAY-Name
 // ST1:=ZUW_LIS.LISTE[1].Ziel;

  ST1:=ZUW_LIS.LISTE[ZUW_LIS.LISTcounter-1].Ziel;
  POS_VAR_ARRAY:=Name_in_VAR_ARRAY_LIS_suchen(ST1);


  if POS_VAR_ARRAY>0 then begin

    // Daten zum ARRAY in VA_REC
    VA_REC:=VAR_ARRAY.LISTE[POS_VAR_ARRAY];
    // Laenge 2. Dimension
    VA_Laenge2:=VA_REC.Laenge_2d;

  end
  else begin
    Fehler_melden('ZWC_01/Zuweisung_Ziel_VAR_ARRAY_POS_2D_01_eintragen',
                  'das gesuchte ARRAY <'+ST1+
                  '> wurde nicht gefunden');
    VA_Laenge2:=0;
  end;


  // Laenge 2. Dimension in HEX-Wert
  HexWert:='0x'+IntToHex(VA_Laenge2,4);

  // Laenge 2. Dimension in R18 und R19
  STM_LISTE[STM_LISTE_counter].statement:=STM_LDI_word_L;
  STM_LISTE[STM_LISTE_counter].Parameter1:=HexWert;
  STM_LISTE[STM_LISTE_counter].Parameter2:='R18';
  Inc_STM_TAB_counter;

  STM_LISTE[STM_LISTE_counter].statement:=STM_LDI_word_H;
  STM_LISTE[STM_LISTE_counter].Parameter1:=HexWert;
  STM_LISTE[STM_LISTE_counter].Parameter2:='R19';
  Inc_STM_TAB_counter;


  // Multiplikation der Position in 1. Dimension mit Laenge 2. Dimension
  STM_LISTE[STM_LISTE_counter].Statement:=STM_zuw_op_mul_word;
  Inc_STM_TAB_counter;



  // Ergebnisses der Multiplikation D1 * (Laenge D2) in den Stack
  STM_LISTE[STM_LISTE_counter].statement:=STM_PUSH;
  STM_LISTE[STM_LISTE_counter].parameter1:='R16';
  Inc_STM_TAB_counter;

  STM_LISTE[STM_LISTE_counter].statement:=STM_PUSH;
  STM_LISTE[STM_LISTE_counter].parameter1:='R17';
  Inc_STM_TAB_counter;


end; { procedure ZWC_class.Zuweisung_Ziel_VAR_ARRAY_POS_2D_01_eintragen }









procedure ZWC_class.Zuweisung_Ziel_VAR_ARRAY_POS_2D_02_eintragen;
begin

  Faktor_STM_TAB_eintragen('VAR ARRAY-2D POSITION 02');
  Ruecksetzen_Zuweisung;


  // Rueckholen des Ergebnisses der Multiplikation D1 * (Laenge D2)
  STM_LISTE[STM_LISTE_counter].statement:=STM_POP;
  STM_LISTE[STM_LISTE_counter].parameter1:='R19';
  Inc_STM_TAB_counter;

  STM_LISTE[STM_LISTE_counter].statement:=STM_POP;
  STM_LISTE[STM_LISTE_counter].parameter1:='R18';
  Inc_STM_TAB_counter;


  // (Position 1D * Laenge 2D) + Position 2D
  STM_LISTE[STM_LISTE_counter].statement:=STM_zuw_op_add_word_L;
  STM_LISTE[STM_LISTE_counter].Parameter1:='R18';
  STM_LISTE[STM_LISTE_counter].parameter2:='R16';
  Inc_STM_TAB_counter;

  STM_LISTE[STM_LISTE_counter].statement:=STM_zuw_op_add_word_H;
  STM_LISTE[STM_LISTE_counter].Parameter1:='R19';
  STM_LISTE[STM_LISTE_counter].parameter2:='R17';
  Inc_STM_TAB_counter;



  STM_LISTE[STM_LISTE_counter].Bemerkung:=
            '; VAR ARRAY Ziel Zeiger berechnen ('+ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel+')';


  STM_LISTE[STM_LISTE_counter].statement:=STM_LDI_word_L;
  STM_LISTE[STM_LISTE_counter].parameter1:=ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel;
  STM_LISTE[STM_LISTE_counter].parameter2:='ZL';
  Inc_STM_TAB_counter;

  STM_LISTE[STM_LISTE_counter].statement:=STM_LDI_word_H;
  STM_LISTE[STM_LISTE_counter].parameter1:=ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel;
  STM_LISTE[STM_LISTE_counter].parameter2:='ZH';
  Inc_STM_TAB_counter;




  case ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_type of

    AT_word : begin

      // bei einem Word-Array muss der Zeiger mit 2 multipliziert werden
      STM_LISTE[STM_LISTE_counter].statement:=STM_SHL_word;
      STM_LISTE[STM_LISTE_counter].Parameter1:='R16';
      STM_LISTE[STM_LISTE_counter].parameter2:='R17';
      Inc_STM_TAB_counter;
              end; { AT_word }

   AT_dword : begin

      // bei einem Word-Array muss der Zeiger mit 4 multipliziert werden
      STM_LISTE[STM_LISTE_counter].statement:=STM_SHL_word;
      STM_LISTE[STM_LISTE_counter].Parameter1:='R16';
      STM_LISTE[STM_LISTE_counter].parameter2:='R17';
      Inc_STM_TAB_counter;

      STM_LISTE[STM_LISTE_counter].statement:=STM_SHL_word;
      STM_LISTE[STM_LISTE_counter].Parameter1:='R16';
      STM_LISTE[STM_LISTE_counter].parameter2:='R17';
      Inc_STM_TAB_counter;

              end; { AT_dword }


  end; { case ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_type of }




  STM_LISTE[STM_LISTE_counter].statement:=STM_zuw_op_add_word_L;
  STM_LISTE[STM_LISTE_counter].Parameter1:='R16';
  STM_LISTE[STM_LISTE_counter].parameter2:='ZL';
  Inc_STM_TAB_counter;

  STM_LISTE[STM_LISTE_counter].statement:=STM_zuw_op_add_word_H;
  STM_LISTE[STM_LISTE_counter].Parameter1:='R17';
  STM_LISTE[STM_LISTE_counter].parameter2:='ZH';
  Inc_STM_TAB_counter;

  STM_LISTE[STM_LISTE_counter].statement:=STM_PUSH;
  STM_LISTE[STM_LISTE_counter].parameter1:='ZL';
  Inc_STM_TAB_counter;

  STM_LISTE[STM_LISTE_counter].statement:=STM_PUSH;
  STM_LISTE[STM_LISTE_counter].parameter1:='ZH';
  Inc_STM_TAB_counter;

end; { procedure ZWC_class.Zuweisung_Ziel_VAR_ARRAY_POS_1D_eintragen }








procedure ZWC_class.Zuweisung_Quelle_Fehlertest;
begin
  if (ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].QUELLcounter>0) then begin
    if ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Quelle[ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].QUELLcounter].Q_Operator=kein_UT then
      Fehler_cl.Registrieren('ZwischenCode/Zuweisung_Quelle_VAR_eintragen',
                             'nach den ersten Faktor muss ein Operator folgen',
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

  end; { if (ZC_ZUW_REC.counter>0) then }
end; { procedure ZWC_class.Zuweisung_Quelle_Fehlertest }








function ZWC_class.Zuweisung_Quelle_VAR_eintragen(Z_Quelle : String) : Boolean;
var
  ZQV_erfolgreich : Boolean;
  ZQV_type, ZQV_type2 : ASM_type_Typ;
  ZQV_ANW_Type : Char;
begin

  Zuweisung_Quelle_Fehlertest;

  ZQV_erfolgreich:=false;

  // 1. Namen suchen
  if NAME_TO_ANW_und_ASM(Z_Quelle,ZQV_ANW_Type,ZQV_type) then begin

    // 2. nur V,D,L soll ausgewertet werden
    if (ZQV_ANW_Type IN ['V','D','L']) and
       (not ((ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_type=AT_char) and (ZQV_type=AT_string))) then begin

      if ZQV_type<>AT_kein_typ then begin
        ZQV_type2:=ZQV_type;

        // Ausnahmen Ziel ist con_reg
        if (ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_type=AT_byte_con_reg) and (ZQV_type2 IN [AT_boolean, AT_byte, AT_char]) then
          ZQV_type2:=ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_type;

        if (ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_type=AT_word_con_reg) and (ZQV_type2=AT_word) then
          ZQV_type2:=ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_type;

        // Ausnahmen Ziel ist con_var
        if (ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_type=AT_byte_con_var) and (ZQV_type2 IN [AT_boolean, AT_byte, AT_char]) then
          ZQV_type2:=ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_type;

        if (ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_type=AT_word_con_var) and (ZQV_type2=AT_word) then
          ZQV_type2:=ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_type;

        // Ausnahmen Quelle ist con_reg
        if (ZQV_type2=AT_byte_con_reg) and (ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_type IN [AT_boolean, AT_byte, AT_char]) then
          ZQV_type2:=ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_type;

        if (ZQV_type2=AT_word_con_reg) and (ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_type=AT_word) then
          ZQV_type2:=ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_type;

        // Ausnahmen Quelle ist con_var
        if (ZQV_type2=AT_byte_con_var) and (ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_type IN [AT_boolean, AT_byte, AT_char]) then
          ZQV_type2:=ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_type;

        if (ZQV_type2=AT_word_con_var) and (ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_type=AT_word) then
          ZQV_type2:=ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_type;

        // Ausnahme DWord Vergleich bei Boolean (x1<x2)
        if (ZQV_type2=AT_dword) and (ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_type=AT_boolean) then
          ZQV_type2:=ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_type;

        // Ausnahme Word Vergleich bei Boolean (x1<x2)
        if (ZQV_type2=AT_word) and (ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_type=AT_boolean) then
          ZQV_type2:=ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_type;

        // Ausnahme Byte Vergleich bei Boolean (x1<x2)
        if (ZQV_type2=AT_byte) and (ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_type=AT_boolean) then
          ZQV_type2:=ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_type;

        // Ausnahme Char-Zuweisung in Strings
        if (ZQV_type2=AT_char) and (ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_type=AT_string) then
          ZQV_type2:=ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_type;


        // Ausnahme Currency Vergleich bei Boolean (x1<x2)
        if (ZQV_type2=AT_currency) and (ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_type=AT_boolean) then
          ZQV_type2:=ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_type;




        if ZQV_type2=ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_type then begin

          if not ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].nur_eine_Quelle then begin

            Inc_ZUW_Quelle_counter;
            ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Quelle[ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].
                         QUELLcounter].Name:=Z_Quelle;
            ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Quelle[ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].
                         QUELLcounter].ANW_type:=ZQV_ANW_Type;
            ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Quelle[ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].
                         QUELLcounter].ASM_type:=ZQV_type;

            ZQV_erfolgreich:=true;

          end
          else
            Fehler_cl.Registrieren('ZwischenCode/Zuweisung_Quelle_VAR_eintragen',
                                   'wird ein Array zugewiesen, darf kein weiterer Faktor zugewiesen werden',
                                   Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                                   Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                                   Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);


        end  { if ZQV_type2=ZC_ZUW_REC.Ziel_ASM_type then }
        else
          Fehler_cl.Registrieren('ZwischenCode/Zuweisung_Quelle_VAR_eintragen',
                                 'Zieltyp ('+TYPE_IN_TYPENAME(ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_type)+
                                 ') ungleich Quelltyp ('+
                                 TYPE_IN_TYPENAME(ZQV_type)+')',
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

      end; { if ZQV_type<>AT_kein_typ then }

    end; { if ZQV_ANW_Type IN ['V','D','L'] then }

  end; { if NAME_TO_ANW_und_ASM(Z_Quelle,ZQV_ANW_Type,ZQV_type) then }

  Result:=ZQV_erfolgreich;
end; { function ZWC_class.Zuweisung_Quelle_VAR_eintragen }












function ZWC_class.Zuweisung_Quelle_CONST_ARRAY_eintragen(Z_Quelle : String) : Boolean;
var
  QCA_erfolgreich : Boolean;
  ZQV_ANW_Type : Char;
  ZQV_type : ASM_type_Typ;
begin


  QCA_erfolgreich:=false;


  // 1. Namen suchen
  if NAME_TO_ANW_und_ASM(Z_Quelle,ZQV_ANW_Type,ZQV_type) then begin

    if ZQV_ANW_Type='A' then begin

      if (not ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].nur_eine_Quelle) and
         (not ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].nur_ein_Array) then begin

        ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].nur_eine_Quelle:=true;

        if ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].QUELLcounter=0 then begin

          if ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_Grund_type=ZQV_type then begin

            Inc_ZUW_Quelle_counter;
            ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Quelle[ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].
                          QUELLcounter].Name:=Z_Quelle;
            ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Quelle[ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].
                          QUELLcounter].ANW_type:=ZQV_ANW_Type;
            ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Quelle[ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].
                          QUELLcounter].ASM_type:=ZQV_type;

            Inc_ZUW_LIS_LISTcounter;

            // !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
            ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_Grund_type:=AT_word;
            ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_type:=AT_word;

            QCA_erfolgreich:=true;

          end
          else
            Fehler_cl.Registrieren('ZwischenCode/Zuweisung_Quelle_CONST_ARRAY_eintragen',
                                 'Unterschiedliche Typen in der Zuweisung. '+
                                 ' Das Zuweisungsziel ist vom Typ: <'+
                                 Compiler_cl.ASM_type_Typ_in_Bezeichner(
                                    ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_Grund_type)+
                                 '> und das ARRAY ist vom Typ: <'+
                                 Compiler_cl.ASM_type_Typ_in_Bezeichner(
                                    ZQV_type)+'>',
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);


        end
        else
          Fehler_cl.Registrieren('ZwischenCode/Zuweisung_Quelle_CONST_ARRAY_eintragen',
                                 'wird ein Array zugewiesen, darf kein weiterer Faktor zugewiesen werden',
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

      end
      else
        Fehler_cl.Registrieren('ZwischenCode/Zuweisung_Quelle_CONST_ARRAY_eintragen',
                               'wird ein Array zugewiesen, darf kein weiterer Faktor zugewiesen werden',
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);



    end; { if ZQV_ANW_Type='A' then }

  end; { if NAME_TO_ANW_und_ASM(Z_Quelle,ZQV_ANW_Type,ZQV_type) then }

  Result:=QCA_erfolgreich;

end; { function ZWC_class.Zuweisung_Quelle_CONST_ARRAY_eintragen }



























// wird fuer 'Y' = Variable (ARRAY-1D) und fuer 'V' = Variable (VAR) STRING genutzt
function ZWC_class.Zuweisung_Quelle_VAR_ARRAY_1D_eintragen(Z_Quelle : String) : Boolean;
var
  QCA_erfolgreich : Boolean;
  ZQV_ANW_Type : Char;
  ZQV_type : ASM_type_Typ;
begin

  QCA_erfolgreich:=false;

  // 1. Namen suchen
  if NAME_TO_ANW_und_ASM(Z_Quelle,ZQV_ANW_Type,ZQV_type) then begin

    if (ZQV_ANW_Type='Y') or
       ((ZQV_ANW_Type='V') and (ZQV_type=AT_string) and (ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_type=AT_char)) then begin

      if (not ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].nur_eine_Quelle) and
         (not ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].nur_ein_Array) then begin

        ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].nur_eine_Quelle:=true;

        if ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].QUELLcounter=0 then begin

          if (ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_Grund_type=ZQV_type) or
             ((ZQV_type=AT_string) and (ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_type=AT_char))
          then begin

            Inc_ZUW_Quelle_counter;
            ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Quelle[ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].
                     QUELLcounter].Name:=Z_Quelle;
            ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Quelle[ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].
                     QUELLcounter].ANW_type:=ZQV_ANW_Type;
            ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Quelle[ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].
                     QUELLcounter].ASM_type:=ZQV_type;

            Inc_ZUW_LIS_LISTcounter;

            if ZQV_ANW_Type='Y' then begin

              // !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
              ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_Grund_type:=AT_word;
              ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_type:=AT_word;

            end
            else begin

              ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_Grund_type:=AT_byte;
              ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_type:=AT_byte;

            end;

            QCA_erfolgreich:=true;

          end
          else
            Fehler_cl.Registrieren('ZwischenCode/Zuweisung_Quelle_VAR_ARRAY_eintragen',
                                 'Unterschiedliche Typen in der Zuweisung. '+
                                 ' Das Zuweisungsziel ist vom Typ: <'+
                                 Compiler_cl.ASM_type_Typ_in_Bezeichner(
                                    ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_Grund_type)+
                                 '> und das ARRAY ist vom Typ: <'+
                                 Compiler_cl.ASM_type_Typ_in_Bezeichner(
                                    ZQV_type)+'>',
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

        end
        else
          Fehler_cl.Registrieren('ZwischenCode/Zuweisung_Quelle_VAR_ARRAY_eintragen',
                                 'wird ein Array zugewiesen, darf kein weiterer Faktor zugewiesen werden',
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

      end
      else
        Fehler_cl.Registrieren('ZwischenCode/Zuweisung_Quelle_VAR_ARRAY_eintragen',
                               'wird ein Array zugewiesen, darf kein weiterer Faktor zugewiesen werden',
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

    end; { if ZQV_ANW_Type='A' then }

  end; { if NAME_TO_ANW_und_ASM(Z_Quelle,ZQV_ANW_Type,ZQV_type) then }

  Result:=QCA_erfolgreich;

end; { function ZWC_class.Zuweisung_Quelle_VAR_ARRAY_1D_eintragen }












// wird fuer 'Z' = Variable (ARRAY-2D)genutzt
function ZWC_class.Zuweisung_Quelle_VAR_ARRAY_2D_eintragen(Z_Quelle : String) : Boolean;
var
  QCA_erfolgreich : Boolean;
  ZQV_ANW_Type : Char;
  ZQV_type : ASM_type_Typ;
begin

  QCA_erfolgreich:=false;

  // 1. Namen suchen
  if NAME_TO_ANW_und_ASM(Z_Quelle,ZQV_ANW_Type,ZQV_type) then begin

    if (ZQV_ANW_Type='Z') then begin

      if (not ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].nur_eine_Quelle) and
         (not ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].nur_ein_Array) then begin

        ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].nur_eine_Quelle:=true;

        if ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].QUELLcounter=0 then begin

          if (ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_Grund_type=ZQV_type) then begin

            Inc_ZUW_Quelle_counter;
            ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Quelle[ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].
                     QUELLcounter].Name:=Z_Quelle;
            ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Quelle[ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].
                     QUELLcounter].ANW_type:=ZQV_ANW_Type;
            ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Quelle[ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].
                     QUELLcounter].ASM_type:=ZQV_type;


            Inc_ZUW_LIS_LISTcounter;

            // !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
            ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_Grund_type:=AT_word;
            ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_type:=AT_word;


            Inc_ZUW_LIS_LISTcounter;

            // !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
            ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_Grund_type:=AT_word;
            ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_type:=AT_word;


            QCA_erfolgreich:=true;

          end
          else
            Fehler_cl.Registrieren('ZwischenCode/Zuweisung_Quelle_VAR_ARRAY_2D_eintragen',
                                 'Unterschiedliche Typen in der Zuweisung. '+
                                 ' Das Zuweisungsziel ist vom Typ: <'+
                                 Compiler_cl.ASM_type_Typ_in_Bezeichner(
                                    ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_Grund_type)+
                                 '> und das ARRAY ist vom Typ: <'+
                                 Compiler_cl.ASM_type_Typ_in_Bezeichner(
                                    ZQV_type)+'>',
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

        end
        else
          Fehler_cl.Registrieren('ZwischenCode/Zuweisung_Quelle_VAR_ARRAY_2D_eintragen',
                                 'wird ein Array zugewiesen, darf kein weiterer Faktor zugewiesen werden',
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

      end
      else
        Fehler_cl.Registrieren('ZwischenCode/Zuweisung_Quelle_VAR_ARRAY_2D_eintragen',
                               'wird ein Array zugewiesen, darf kein weiterer Faktor zugewiesen werden',
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

    end; { if ZQV_ANW_Type='Z' then }

  end; { if NAME_TO_ANW_und_ASM(Z_Quelle,ZQV_ANW_Type,ZQV_type) then }

  Result:=QCA_erfolgreich;

end; { function ZWC_class.Zuweisung_Quelle_VAR_ARRAY_2D_eintragen }







procedure ZWC_class.Zuweisung_Quelle_VAR_ARRAY_POS_1D_eintragen;
begin

  Faktor_STM_TAB_eintragen('ARRAY');

  Ruecksetzen_Zuweisung;

end; { procedure ZWC_class.Zuweisung_Quelle_VAR_ARRAY_POS_1D_eintragen }










procedure ZWC_class.Zuweisung_Quelle_VAR_ARRAY_POS_2D_01_eintragen;
var
  POS_VAR_ARRAY : Integer;
  ST1, HexWert : String;
  VA_REC : VAR_ARRAY_REC;
  VA_Laenge2 : Word;

begin

  Faktor_STM_TAB_eintragen('ARRAY-2D - 1.Parameter');

  Ruecksetzen_Zuweisung;


  // Multiplikation erster ARRAY-Parameter mit Laenge 2. Dimension

  // ARRAY-Name
  ST1:=ZUW_LIS.LISTE[ZUW_LIS.LISTcounter-1].Quelle[1].Name;
  POS_VAR_ARRAY:=Name_in_VAR_ARRAY_LIS_suchen(ST1);


  if POS_VAR_ARRAY>0 then begin

    // Daten zum ARRAY in VA_REC
    VA_REC:=VAR_ARRAY.LISTE[POS_VAR_ARRAY];
    // Laenge 2. Dimension
    VA_Laenge2:=VA_REC.Laenge_2d;

  end
  else begin
    Fehler_melden('ZWC_01/Zuweisung_Quelle_VAR_ARRAY_POS_2D_01_eintragen',
                  'das gesuchte ARRAY <'+ST1+
                  '> wurde nicht gefunden');
    VA_Laenge2:=0;
  end;




  // Laenge 2. Dimension in HEX-Wert
  HexWert:='0x'+IntToHex(VA_Laenge2,4);

  STM_LISTE[STM_LISTE_counter].Bemerkung:=
            '; Laenge 2. ARRAY-Dimension in R18 und R19';

  // Laenge 2. Dimension in R18 und R19
  STM_LISTE[STM_LISTE_counter].statement:=STM_LDI_word_L;
  STM_LISTE[STM_LISTE_counter].Parameter1:=HexWert;
  STM_LISTE[STM_LISTE_counter].Parameter2:='R18';
  Inc_STM_TAB_counter;

  STM_LISTE[STM_LISTE_counter].statement:=STM_LDI_word_H;
  STM_LISTE[STM_LISTE_counter].Parameter1:=HexWert;
  STM_LISTE[STM_LISTE_counter].Parameter2:='R19';
  Inc_STM_TAB_counter;



  STM_LISTE[STM_LISTE_counter].Bemerkung:=
            '; Multiplikation erster ARRAY-Parameter (D1) mit Laenge 2. Dimension';

  // Multiplikation der Position in 1. Dimension mit Laenge 2. Dimension
  STM_LISTE[STM_LISTE_counter].Statement:=STM_zuw_op_mul_word;
  Inc_STM_TAB_counter;



  STM_LISTE[STM_LISTE_counter].Bemerkung:=
            '; Ergebnisses der Multiplikation D1 * (Laenge D2) in den Stack ';

  // Ergebnisses der Multiplikation D1 * (Laenge D2) in den Stack
  STM_LISTE[STM_LISTE_counter].statement:=STM_PUSH;
  STM_LISTE[STM_LISTE_counter].parameter1:='R16';
  Inc_STM_TAB_counter;

  STM_LISTE[STM_LISTE_counter].statement:=STM_PUSH;
  STM_LISTE[STM_LISTE_counter].parameter1:='R17';
  Inc_STM_TAB_counter;




end; { procedure ZWC_class.Zuweisung_Quelle_VAR_ARRAY_POS_2D_01_eintragen }





procedure ZWC_class.Zuweisung_Quelle_VAR_ARRAY_POS_2D_02_eintragen;
begin

  Faktor_STM_TAB_eintragen('ARRAY-2D - 2.Parameter');

  Ruecksetzen_Zuweisung;



  STM_LISTE[STM_LISTE_counter].Bemerkung:=
            '; Rueckholen des Ergebnisses der Multiplikation D1 * (Laenge D2) vom Stack';

  // Rueckholen des Ergebnisses der Multiplikation D1 * (Laenge D2)
  STM_LISTE[STM_LISTE_counter].statement:=STM_POP;
  STM_LISTE[STM_LISTE_counter].parameter1:='R19';
  Inc_STM_TAB_counter;

  STM_LISTE[STM_LISTE_counter].statement:=STM_POP;
  STM_LISTE[STM_LISTE_counter].parameter1:='R18';
  Inc_STM_TAB_counter;



  STM_LISTE[STM_LISTE_counter].Bemerkung:=
              '; (Position 1D * Laenge 2D) + Position 2D';

  // (Position 1D * Laenge 2D) + Position 2D
  STM_LISTE[STM_LISTE_counter].statement:=STM_zuw_op_add_word_L;
  STM_LISTE[STM_LISTE_counter].Parameter1:='R18';
  STM_LISTE[STM_LISTE_counter].parameter2:='R16';
  Inc_STM_TAB_counter;

  STM_LISTE[STM_LISTE_counter].statement:=STM_zuw_op_add_word_H;
  STM_LISTE[STM_LISTE_counter].Parameter1:='R19';
  STM_LISTE[STM_LISTE_counter].parameter2:='R17';
  Inc_STM_TAB_counter;


end; { procedure ZWC_class.Zuweisung_Quelle_VAR_ARRAY_POS_2D_02_eintragen }























function ZWC_class.Zuweisung_Quelle_CONST_eintragen(Z_Quelle : String) : Boolean;
var
  ZQC_erfolgreich : Boolean;
  Quelle_ASM_type, Quelle2_ASM_type, Quelle_ASM_Grund_type : ASM_type_Typ;
begin
  ZQC_erfolgreich:=false;

  Zuweisung_Quelle_Fehlertest;

  Quelle_ASM_type:=NAME_und_ANW_TO_TYPE(Z_Quelle,'C');

  if Quelle_ASM_type<>AT_kein_typ then begin

    case Quelle_ASM_type of
      AT_byte_con_reg, AT_byte_con_var : Quelle_ASM_Grund_type:=AT_byte;
      AT_word_con_reg, AT_word_con_var : Quelle_ASM_Grund_type:=AT_word;
    else
      Quelle_ASM_Grund_type:=Quelle_ASM_type;
    end;

    Quelle2_ASM_type:=Quelle_ASM_Grund_type;

    if (Quelle2_ASM_type=AT_dword) and (ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_type=AT_boolean) then
      Quelle2_ASM_type:=ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_type;

    if (Quelle2_ASM_type=AT_word) and (ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_type=AT_boolean) then
      Quelle2_ASM_type:=ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_type;

    if (Quelle2_ASM_type=AT_byte) and (ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_type=AT_boolean) then
      Quelle2_ASM_type:=ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_type;

    if (Quelle2_ASM_type=AT_currency) and (ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_type=AT_boolean) then
      Quelle2_ASM_type:=ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_type;


    if Quelle2_ASM_type=ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_Grund_type then begin

      if not ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].nur_eine_Quelle then begin

        Inc_ZUW_Quelle_counter;

        ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Quelle[ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].
                   QUELLcounter].Name:=Z_Quelle;
        ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Quelle[ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].
                   QUELLcounter].ASM_type:=Quelle_ASM_type;
        ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Quelle[ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].
                   QUELLcounter].ASM_Grund_type:=Quelle_ASM_Grund_type;
        ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Quelle[ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].
                   QUELLcounter].ANW_type:='C';
        ZQC_erfolgreich:=true;

      end
      else
        Fehler_cl.Registrieren('ZwischenCode/Zuweisung_Quelle_CONST_eintragen',
                               'wird ein Array zugewiesen, darf kein weiterer Faktor zugewiesen werden',
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

    end
    else
      Fehler_cl.Registrieren('ZwischenCode/Zuweisung_Quelle_CONST_eintragen',
                             'Zieltyp ('+TYPE_IN_TYPENAME(ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_type)+') ungleich Quelltyp ('+
                             TYPE_IN_TYPENAME(Quelle_ASM_type),
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

  end; { if VAR_NAME_TO_TYPE()<>AT_kein_typ then }

  Result:=ZQC_erfolgreich;

end; { function Zuweisung_Quelle_CONST_eintragen }












function ZWC_class.Zuweisung_Quelle_CONRD_eintragen(CW : String; CUT : SI_Unter_Typ; VZ_negativ : Boolean) : Boolean;
var
  ZQC_erfolgreich : Boolean;
  Quelle_ASM_type, Quelle_ASM_Grund_type : ASM_type_Typ;
  S_Zahl : String;
  CW_Zahl : LongInt;


  function negatives_Vorzeichen_erlaubt(ASM_Grund_type : ASM_type_Typ) : Boolean;
  var
    negatives_Vorzeichen : Boolean;
  begin

    negatives_Vorzeichen:=false;

    case ASM_Grund_type of
      AT_currency : negatives_Vorzeichen:=true;
    else
      Fehler_melden('ZWC_01/Zuweisung_Quelle_CONRD_eintragen/negatives_Vorzeichen_erlaubt',
                    'der genutzte Typ <'+TYPE_IN_TYPENAME(ASM_Grund_type)+
                    '> unterstuetzt keine negativen Zahlen');
    end; { case ASM_Grund_type of }

    Result:=negatives_Vorzeichen;

  end; { function negatives_Vorzeichen_erlaubt }


begin


       {
  if CW='7' then
    ZQC_erfolgreich:=true;
         }

  ZQC_erfolgreich:=false;


  Zuweisung_Quelle_Fehlertest;

  Quelle_ASM_Grund_type:=ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_Grund_type;

  Quelle_ASM_type:=Quelle_ASM_Grund_type;

  if (ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_type=AT_boolean) and
     (CUT IN [UT_Dezi_Zahl, UT_Bin_Zahl, UT_Hex_Zahl]) then begin
    Quelle_ASM_type:=AT_dword;
  end; { if (ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_type=AT_boolean) }


  if (ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_type=AT_boolean) and
     (CUT IN [UT_Curr_Zahl]) then begin
    Quelle_ASM_type:=AT_currency;
  end; { if (ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_type=AT_boolean) }


  if VZ_negativ then begin

    if negatives_Vorzeichen_erlaubt(Quelle_ASM_type) then
      CW:='-'+CW;

  end; { if VZ_negativ then }


  if CONST_WERT_ueberpruefen(CW,CUT,Quelle_ASM_type) then begin

    if not ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].nur_eine_Quelle then begin

      Inc_ZUW_Quelle_counter;

      if (ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_type=AT_boolean) and (Quelle_ASM_type=AT_dword) then begin
        S_Zahl:='$'+Copy(CW,3,Length(CW)-2);
        CW_Zahl:=StrToInt(S_Zahl);

        if CW_Zahl<256 then begin
          CW:='0x'+IntToHex(CW_Zahl,2);
          Quelle_ASM_type:=AT_byte;
        end { if W_Zahl<256 then }
        else begin

          if CW_Zahl<$10000 then begin
            CW:='0x'+IntToHex(CW_Zahl,4);
            Quelle_ASM_type:=AT_word;
          end;

        end;

      end; { if (ZC_ZUW_REC.Ziel_ASM_type=AT_boolean) and (Quelle_ASM_type=AT_dword) then }

      ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Quelle[ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].
                         QUELLcounter].ASM_type:=Quelle_ASM_type;
      ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Quelle[ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].
                         QUELLcounter].ASM_Grund_type:=Quelle_ASM_Grund_type;
      ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Quelle[ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].
                         QUELLcounter].ANW_type:='W';
      ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Quelle[ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].
                         QUELLcounter].Wert:=CW;
      ZQC_erfolgreich:=true;



    end
    else
      Fehler_cl.Registrieren('ZwischenCode/Zuweisung_Quelle_CONRD_eintragen',
                             'wird ein Array zugewiesen, darf kein weiterer Faktor zugewiesen werden',
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);



  end; { if CONST_WERT_ueberpruefen(CW,CUT,ZC_CONST_TAB[ZC_CONST_TAB_counter].ASM_type) then }

  Result:=ZQC_erfolgreich;

end; { function ZWC_class.Zuweisung_Quelle_CONRD_eintragen }








function ZWC_class.Zuweisung_Quelle_FKT_eintragen(FKT_Name : String) : Boolean;
var
  FKT_erfolgreich : Boolean;
  Quelle_ASM_type : ASM_type_Typ;

begin

  FKT_erfolgreich:=false;

  Zuweisung_Quelle_Fehlertest;

  Quelle_ASM_type:=NAME_und_ANW_TO_TYPE(FKT_Name,'F');

  if Quelle_ASM_type<>AT_kein_typ then begin

    if Quelle_ASM_type=ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_type then begin

      if not ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].nur_eine_Quelle then begin

        Inc_ZUW_Quelle_counter;

        akt_CALL_PROC.PROC_Pos:=Name_in_PROC_LIS_suchen(FKT_Name);
        ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Quelle[ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].
                     QUELLcounter].Name:=FKT_Name;
        ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Quelle[ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].
                     QUELLcounter].ANW_type:='F';
        ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Quelle[ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].
                     QUELLcounter].ASM_type:=ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_type;

        FKT_erfolgreich:=true;




      end
      else
        Fehler_cl.Registrieren('ZwischenCode/Zuweisung_Quelle_FKT_eintragen',
                               'wird ein Array zugewiesen, darf kein weiterer Faktor zugewiesen werden',
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);



    end
    else
      Fehler_cl.Registrieren('ZwischenCode/Zuweisung_Quelle_FKT_eintragen',
                             'Zieltyp der Funktion ('+
                             TYPE_IN_TYPENAME(ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_type)+
                             ') ungleich Typ der Zuweisung ('+
                             TYPE_IN_TYPENAME(Quelle_ASM_type),
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

  end; { if FKT_type<>AT_kein_typ then }

  Result:=FKT_erfolgreich;
end; { function ZWC_class.Zuweisung_Quelle_FKT_eintragen }






function ZWC_class.Zuweisung_DZ_Operator_eintragen(UT_Operator : SI_Unter_Typ) : Boolean;
var
  OPE_erfolgreich : Boolean;
begin
  OPE_erfolgreich:=false;

  if (ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].QUELLcounter>0) then begin

    if ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Quelle[ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].QUELLcounter].Q_Operator<>kein_UT then
      Fehler_cl.Registrieren('ZwischenCode/Zuweisung_DZ_Operator_eintragen',
                             'es ist bereits ein Operator eingetragen',
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);


    ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Quelle[ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].QUELLcounter].Q_Operator:=UT_Operator;
    OPE_erfolgreich:=true;

  end { if (ZC_ZUW_REC.counter>0) then }
  else
    Fehler_cl.Registrieren('ZwischenCode/Zuweisung_DZ_Operator_eintragen',
                           'vor dem Operator muss ein Faktor stehen',
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

  Result:=OPE_erfolgreich;

end; { function ZWC_class.Zuweisung_DZ_Operator_eintragen }







function ZWC_class.Zuweisung_Quelle_B2W_eintragen(B2W_Quelle : String) : Boolean;
var
  B2W_erfolgreich : Boolean;
  B2W_type : ASM_type_Typ;
  B2W_ANW_Type : Char;
begin

  B2W_erfolgreich:=false;

  // 1. Namen suchen
  if NAME_TO_ANW_und_ASM(B2W_Quelle,B2W_ANW_Type,B2W_type) then begin

    // 2. nur V,D,L soll ausgewertet werden
    if B2W_ANW_Type IN ['V','D','L'] then begin

      if ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_Grund_type=AT_word then begin
        if B2W_type=AT_byte then begin

          Inc_ZUW_Quelle_counter;
          ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Quelle[ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].
          QUELLcounter].Name:=B2W_Quelle;
          ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Quelle[ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].
          QUELLcounter].ANW_type:='S';
          ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Quelle[ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].
          QUELLcounter].ANW_type2:=B2W_ANW_Type;
          ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Quelle[ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].
          QUELLcounter].ASM_type:=AT_byte;
          ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Quelle[ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].
          QUELLcounter].ASM_Grund_type:=AT_byte;
          ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Quelle[ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].
          QUELLcounter].Wert:='W';

          B2W_erfolgreich:=true;

        end  { if B2W_type=AT_byte then }
        else
          Fehler_cl.Registrieren('ZwischenCode/Zuweisung_Quelle_B2W_eintragen',
                                 'Quelltyp ('+
                                 TYPE_IN_TYPENAME(B2W_type)+') muss vom Type Byte sein',
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);


      end  { if ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_Grund_type=AT_word then }
      else
        Fehler_cl.Registrieren('ZwischenCode/Zuweisung_Quelle_B2W_eintragen',
                               'Zieltyp ('+TYPE_IN_TYPENAME(ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_type)+
                               ') muss vom Type-Word sein',
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

    end; { if B2W_ANW_Type IN ['V','D','L'] then }

  end { if NAME_TO_ANW_und_ASM(B2W_Quelle,B2W_ANW_Type,B2W_type) then }
  else
    Fehler_cl.Registrieren('ZwischenCode/Zuweisung_Quelle_B2W_eintragen',
                           'es konnte keine Variable mit dem Namen <'+B2W_Quelle+'> gefunden werden',
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

  Result:=B2W_erfolgreich;
end; { function ZWC_class.Zuweisung_Quelle_B2W_eintragen }












function ZWC_class.Zuweisung_Quelle_B2C_eintragen(B2C_Quelle : String) : Boolean;
var
  B2C_erfolgreich : Boolean;
  B2C_type : ASM_type_Typ;
  B2C_ANW_Type : Char;
begin

  B2C_erfolgreich:=false;

  // 1. Namen suchen
  if NAME_TO_ANW_und_ASM(B2C_Quelle,B2C_ANW_Type,B2C_type) then begin

    // 2. nur V,D,L soll ausgewertet werden
    if B2C_ANW_Type IN ['V','D','L'] then begin

      if ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_Grund_type=AT_char then begin
        if B2C_type=AT_byte then begin

          Inc_ZUW_Quelle_counter;
          ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Quelle[ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].
          QUELLcounter].Name:=B2C_Quelle;
          ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Quelle[ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].
          QUELLcounter].ANW_type:='S';
          ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Quelle[ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].
          QUELLcounter].ANW_type2:=B2C_ANW_Type;
          ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Quelle[ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].
          QUELLcounter].ASM_type:=AT_byte;
          ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Quelle[ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].
          QUELLcounter].ASM_Grund_type:=AT_byte;
          ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Quelle[ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].
          QUELLcounter].Wert:='B';

          B2C_erfolgreich:=true;

        end  { if B2W_type=AT_byte then }
        else
          Fehler_cl.Registrieren('ZwischenCode/Zuweisung_Quelle_B2W_eintragen',
                                 'Quelltyp ('+
                                 TYPE_IN_TYPENAME(B2C_type)+') muss vom Type Byte sein',
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);


      end  { if ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_Grund_type=AT_word then }
      else
        Fehler_cl.Registrieren('ZwischenCode/Zuweisung_Quelle_B2C_eintragen',
                               'Zieltyp ('+TYPE_IN_TYPENAME(ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_type)+
                               ') muss vom Type-Char sein',
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

    end; { if B2C_ANW_Type IN ['V','D','L'] then }

  end { if NAME_TO_ANW_und_ASM(B2C_Quelle,B2C_ANW_Type,B2C_type) then }
  else
    Fehler_cl.Registrieren('ZwischenCode/Zuweisung_Quelle_B2C_eintragen',
                           'es konnte keine Variable mit dem Namen <'+B2C_Quelle+'> gefunden werden',
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

  Result:=B2C_erfolgreich;
end; { function ZWC_class.Zuweisung_Quelle_B2C_eintragen }






function ZWC_class.Zuweisung_Quelle_C2B_eintragen(C2B_Quelle : String) : Boolean;
var
  C2B_erfolgreich : Boolean;
  C2B_type : ASM_type_Typ;
  C2B_ANW_Type : Char;
begin

  C2B_erfolgreich:=false;

  // 1. Namen suchen
  if NAME_TO_ANW_und_ASM(C2B_Quelle,C2B_ANW_Type,C2B_type) then begin

    // 2. nur V,D,L soll ausgewertet werden
    if C2B_ANW_Type IN ['V','D','L'] then begin

      if ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_Grund_type=AT_byte then begin
        if C2B_type=AT_char then begin

          Inc_ZUW_Quelle_counter;
          ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Quelle[ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].
          QUELLcounter].Name:=C2B_Quelle;
          ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Quelle[ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].
          QUELLcounter].ANW_type:='S';
          ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Quelle[ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].
          QUELLcounter].ANW_type2:=C2B_ANW_Type;
          ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Quelle[ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].
          QUELLcounter].ASM_type:=AT_char;
          ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Quelle[ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].
          QUELLcounter].ASM_Grund_type:=AT_char;
          ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Quelle[ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].
          QUELLcounter].Wert:='C';

          C2B_erfolgreich:=true;

        end  { if B2W_type=AT_byte then }
        else
          Fehler_cl.Registrieren('ZwischenCode/Zuweisung_Quelle_C2B_eintragen',
                                 'Quelltyp ('+
                                 TYPE_IN_TYPENAME(C2B_type)+') muss vom Type Char sein',
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);


      end  { if ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_Grund_type=AT_word then }
      else
        Fehler_cl.Registrieren('ZwischenCode/Zuweisung_Quelle_C2B_eintragen',
                               'Zieltyp ('+TYPE_IN_TYPENAME(ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_type)+
                               ') muss vom Type-Byte sein',
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

    end; { if C2B_ANW_Type IN ['V','D','L'] then }

  end { if NAME_TO_ANW_und_ASM(C2B_Quelle,C2B_ANW_Type,C2B_type) then }
  else
    Fehler_cl.Registrieren('ZwischenCode/Zuweisung_Quelle_C2B_eintragen',
                           'es konnte keine Variable mit dem Namen <'+C2B_Quelle+'> gefunden werden',
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

  Result:=C2B_erfolgreich;
end; { function ZWC_class.Zuweisung_Quelle_C2B_eintragen }









function ZWC_class.Zuweisung_Quelle_LOW_eintragen(LOW_Quelle : String) : Boolean;
var
  LOW_erfolgreich : Boolean;
  LOW_type : ASM_type_Typ;
  LOW_ANW_Type : Char;
begin

  LOW_erfolgreich:=false;

  // 1. Namen suchen
  if NAME_TO_ANW_und_ASM(LOW_Quelle,LOW_ANW_Type,LOW_type) then begin

    // 2. nur V,D,L soll ausgewertet werden
    if LOW_ANW_Type IN ['V','D','L','C'] then begin

      if ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_Grund_type=AT_byte then begin
        if LOW_type=AT_word then begin

          Inc_ZUW_Quelle_counter;
          ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Quelle[ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].
          QUELLcounter].Name:=LOW_Quelle;
          ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Quelle[ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].
          QUELLcounter].ANW_type:='S';
          ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Quelle[ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].
          QUELLcounter].ANW_type2:=LOW_ANW_Type;
          ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Quelle[ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].
          QUELLcounter].ASM_type:=AT_word;
          ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Quelle[ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].
          QUELLcounter].ASM_Grund_type:=AT_word;
          ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Quelle[ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].
          QUELLcounter].Wert:='L';

          LOW_erfolgreich:=true;

        end  { if B2W_type=AT_word then }
        else
          Fehler_cl.Registrieren('ZwischenCode/Zuweisung_Quelle_LOW_eintragen',
                                 'Quelltyp ('+
                                 TYPE_IN_TYPENAME(LOW_type)+') muss vom Type Word sein',
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);


      end  { if ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_Grund_type=AT_byte }
      else
        Fehler_cl.Registrieren('ZwischenCode/Zuweisung_Quelle_LOW_eintragen',
                               'Zieltyp ('+TYPE_IN_TYPENAME(ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_type)+
                               ') muss vom Type-Byte sein',
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

    end; { if LOW_ANW_Type IN ['V','D','L'] then }

  end { if NAME_TO_ANW_und_ASM(LOW_Quelle,LOW_ANW_Type,LOW_type) then }
  else
    Fehler_cl.Registrieren('ZwischenCode/Zuweisung_Quelle_LOW_eintragen',
                           'es konnte keine Variable mit dem Namen <'+LOW_Quelle+'> gefunden werden',
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

  Result:=LOW_erfolgreich;
end; { function ZWC_class.Zuweisung_Quelle_LOW_eintragen }










function ZWC_class.Zuweisung_Quelle_HIGH_eintragen(HIGH_Quelle : String) : Boolean;
var
  HIGH_erfolgreich : Boolean;
  HIGH_type : ASM_type_Typ;
  HIGH_ANW_Type : Char;
begin

  HIGH_erfolgreich:=false;

  // 1. Namen suchen
  if NAME_TO_ANW_und_ASM(HIGH_Quelle,HIGH_ANW_Type,HIGH_type) then begin

    // 2. nur V,D,L soll ausgewertet werden
    if HIGH_ANW_Type IN ['V','D','L','C'] then begin

      if ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_Grund_type=AT_byte then begin
        if HIGH_type=AT_word then begin

          Inc_ZUW_Quelle_counter;
          ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Quelle[ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].
          QUELLcounter].Name:=HIGH_Quelle;
          ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Quelle[ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].
          QUELLcounter].ANW_type:='S';
          ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Quelle[ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].
          QUELLcounter].ANW_type2:=HIGH_ANW_Type;
          ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Quelle[ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].
          QUELLcounter].ASM_type:=AT_word;
          ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Quelle[ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].
          QUELLcounter].ASM_Grund_type:=AT_word;
          ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Quelle[ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].
          QUELLcounter].Wert:='H';

          HIGH_erfolgreich:=true;

        end  { if B2W_type=AT_word then }
        else
          Fehler_cl.Registrieren('ZwischenCode/Zuweisung_Quelle_HIGH_eintragen',
                                 'Quelltyp ('+
                                 TYPE_IN_TYPENAME(HIGH_type)+') muss vom Type Word sein',
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);


      end  { if ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_Grund_type=AT_byte }
      else
        Fehler_cl.Registrieren('ZwischenCode/Zuweisung_Quelle_HIGH_eintragen',
                               'Zieltyp ('+TYPE_IN_TYPENAME(ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_type)+
                               ') muss vom Type-Byte sein',
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

    end; { if LOW_ANW_Type IN ['V','D','L'] then }

  end { if NAME_TO_ANW_und_ASM(HIGH_Quelle,HIGH_ANW_Type,HIGH_type) then }
  else
    Fehler_cl.Registrieren('ZwischenCode/Zuweisung_Quelle_HIGH_eintragen',
                           'es konnte keine Variable mit dem Namen <'+HIGH_Quelle+'> gefunden werden',
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

  Result:=HIGH_erfolgreich;
end; { function ZWC_class.Zuweisung_Quelle_HIGH_eintragen }











function ZWC_class.Zuweisung_Quelle_BITHIGH_eintragen(TB_Quelle : String;
                                                      HL : Boolean) : Boolean;
var
  TB_erfolgreich : Boolean;
  TB_type : ASM_type_Typ;
  TB_ANW_Type : Char;
  TB_Pos : Integer;
begin

  TB_erfolgreich:=false;

  // 1. Namen suchen
  if NAME_TO_ANW_und_ASM(TB_Quelle,TB_ANW_Type,TB_type) then begin

    // 2. nur B soll ausgewertet werden
    if TB_ANW_Type='B' then begin

      if ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_Grund_type=AT_boolean then begin
        if TB_type=AT_bit then begin

          TB_Pos:=BIT_LIS_suchen(TB_Quelle);
          TB_type:=BIT_LIS.LISTE[TB_Pos].ASM_type;

          Inc_ZUW_Quelle_counter;
          ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Quelle[ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].
          QUELLcounter].Name:=TB_Quelle;
          ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Quelle[ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].
          QUELLcounter].ANW_type:='S';
          ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Quelle[ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].
          QUELLcounter].ANW_type2:=TB_ANW_Type;
          ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Quelle[ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].
          QUELLcounter].ASM_type:=TB_type;
          ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Quelle[ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].
          QUELLcounter].ASM_Grund_type:=TB_type;
          if HL then
            ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Quelle[ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].QUELLcounter].Wert:='T'
          else
            ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Quelle[ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].QUELLcounter].Wert:='U';

          TB_erfolgreich:=true;

        end  { if TB_type=AT_bit then }
        else
          Fehler_cl.Registrieren('ZwischenCode/Zuweisung_Quelle_BITHIGH_eintragen',
                                 'Quelltyp ('+
                                 TYPE_IN_TYPENAME(TB_type)+') muss vom Type Word sein',
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);


      end  { if ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_Grund_type=AT_boolean then }
      else
        Fehler_cl.Registrieren('ZwischenCode/Zuweisung_Quelle_BITHIGH_eintragen',
                               'Zieltyp ('+TYPE_IN_TYPENAME(ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_type)+
                               ') muss vom Type-Bit sein',
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

    end; { if TB_ANW_Type='B' then }

  end { if NAME_TO_ANW_und_ASM(TB_Quelle,TB_ANW_Type,TB_type) then }
  else
    Fehler_cl.Registrieren('ZwischenCode/Zuweisung_Quelle_BITHIGH_eintragen',
                           'es konnte keine Variable mit dem Namen <'+TB_Quelle+'> gefunden werden',
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

  Result:=TB_erfolgreich;
end; { function ZWC_class.Zuweisung_Quelle_BITHIGH_eintragen }








function ZWC_class.Zuweisung_Quelle_LENGTH_eintragen(ZL_Quelle : String) : Boolean;
var
  ZL_erfolgreich : Boolean;
  ZL_type : ASM_type_Typ;
  ZL_ANW_Type : Char;
begin

  ZL_erfolgreich:=false;

  // 1. Namen suchen
  if NAME_TO_ANW_und_ASM(ZL_Quelle,ZL_ANW_Type,ZL_type) then begin

    // 2. nur V soll ausgewertet werden
    if ZL_ANW_Type='V' then begin

      if ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_Grund_type=AT_byte then begin
        if ZL_type=AT_string then begin

          Inc_ZUW_Quelle_counter;
          ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Quelle[ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].
          QUELLcounter].Name:=ZL_Quelle;
          ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Quelle[ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].
          QUELLcounter].ANW_type:='S';
          ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Quelle[ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].
          QUELLcounter].ANW_type2:=ZL_ANW_Type;
          ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Quelle[ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].
          QUELLcounter].ASM_type:=ZL_type;
          ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Quelle[ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].
          QUELLcounter].ASM_Grund_type:=ZL_type;
          ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Quelle[ZUW_LIS.LISTE
                            [ZUW_LIS.LISTcounter].QUELLcounter].Wert:='S';

          ZL_erfolgreich:=true;

        end  { if TB_type=AT_bit then }
        else
          Fehler_cl.Registrieren('ZwischenCode/Zuweisung_Quelle_LENGTH_eintragen',
                                 'Quelltyp ('+
                                 TYPE_IN_TYPENAME(ZL_type)+') muss vom Type String sein',
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);


      end  { if ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_Grund_type=AT_boolean then }
      else
        Fehler_cl.Registrieren('ZwischenCode/Zuweisung_Quelle_LENGTH_eintragen',
                               'Zieltyp ('+TYPE_IN_TYPENAME(ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_type)+
                               ') muss vom Type-Byte sein',
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

    end; { if TB_ANW_Type='B' then }

  end { if NAME_TO_ANW_und_ASM(TB_Quelle,TB_ANW_Type,TB_type) then }
  else
    Fehler_cl.Registrieren('ZwischenCode/Zuweisung_Quelle_LENGTH_eintragen',
                           'es konnte keine Variable mit dem Namen <'+ZL_Quelle+'> gefunden werden',
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

  Result:=ZL_erfolgreich;
end; { function ZWC_class.Zuweisung_Quelle_LENGTH_eintragen }





























function ZWC_class.Zuweisung_Quelle_DWBYTE_eintragen(BytePosition : Integer;
                                                     DWBYTE_Quelle : String) : Boolean;
var
  DWBYTE_erfolgreich : Boolean;
  DWBYTE_type : ASM_type_Typ;
  DWBYTE_ANW_Type : Char;
begin

  DWBYTE_erfolgreich:=false;

  // 1. Namen suchen
  if NAME_TO_ANW_und_ASM(DWBYTE_Quelle,DWBYTE_ANW_Type,DWBYTE_type) then begin

    // 2. nur V,D,L soll ausgewertet werden
    if DWBYTE_ANW_Type IN ['V','D','L','C'] then begin

      if ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_Grund_type=AT_byte then begin
        if DWBYTE_type=AT_dword then begin

          Inc_ZUW_Quelle_counter;
          ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Quelle[ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].
          QUELLcounter].Name:=DWBYTE_Quelle;
          ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Quelle[ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].
          QUELLcounter].ANW_type:='S';
          ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Quelle[ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].
          QUELLcounter].ANW_type2:=DWBYTE_ANW_Type;
          ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Quelle[ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].
          QUELLcounter].ASM_type:=AT_dword;
          ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Quelle[ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].
          QUELLcounter].ASM_Grund_type:=AT_dword;
          ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Quelle[ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].
          QUELLcounter].Wert:=IntToStr(BytePosition);

          DWBYTE_erfolgreich:=true;

        end  { if B2W_type=AT_word then }
        else
          Fehler_cl.Registrieren('ZwischenCode/Zuweisung_Quelle_DWBYTE_eintragen',
                                 'Quelltyp ('+
                                 TYPE_IN_TYPENAME(DWBYTE_type)+') muss vom Type DWord sein',
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);


      end  { if ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_Grund_type=AT_byte }
      else
        Fehler_cl.Registrieren('ZwischenCode/Zuweisung_Quelle_DWBYTE_eintragen',
                               'Zieltyp ('+TYPE_IN_TYPENAME(ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_type)+
                               ') muss vom Type-Byte sein',
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

    end; { if LOW_ANW_Type IN ['V','D','L','C'] then }

  end { if NAME_TO_ANW_und_ASM(LOW_Quelle,LOW_ANW_Type,LOW_type) then }
  else
    Fehler_cl.Registrieren('ZwischenCode/Zuweisung_Quelle_DWBYTE_eintragen',
                           'es konnte keine Variable mit dem Namen <'+DWBYTE_Quelle+'> gefunden werden',
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

  Result:=DWBYTE_erfolgreich;
end; { function ZWC_class.Zuweisung_Quelle_DWBYTE_eintragen }











function ZWC_class.Zuweisung_Quelle_DWLOW_eintragen(DWLOW_Quelle : String) : Boolean;
var
  DWLOW_erfolgreich : Boolean;
  DWLOW_type : ASM_type_Typ;
  DWLOW_ANW_Type : Char;
begin

  DWLOW_erfolgreich:=false;

  // 1. Namen suchen
  if NAME_TO_ANW_und_ASM(DWLOW_Quelle,DWLOW_ANW_Type,DWLOW_type) then begin

    // 2. nur V,D,L soll ausgewertet werden
    if DWLOW_ANW_Type IN ['V','D','L','C'] then begin

      if ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_Grund_type=AT_word then begin
        if DWLOW_type=AT_dword then begin

          Inc_ZUW_Quelle_counter;
          ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Quelle[ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].
          QUELLcounter].Name:=DWLOW_Quelle;
          ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Quelle[ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].
          QUELLcounter].ANW_type:='S';
          ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Quelle[ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].
          QUELLcounter].ANW_type2:=DWLOW_ANW_Type;
          ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Quelle[ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].
          QUELLcounter].ASM_type:=AT_dword;
          ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Quelle[ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].
          QUELLcounter].ASM_Grund_type:=AT_dword;
          ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Quelle[ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].
          QUELLcounter].Wert:='M';

          DWLOW_erfolgreich:=true;

        end  { if B2W_type=AT_word then }
        else
          Fehler_cl.Registrieren('ZwischenCode/Zuweisung_Quelle_DWLOW_eintragen',
                                 'Quelltyp ('+
                                 TYPE_IN_TYPENAME(DWLOW_type)+') muss vom Type DWord sein',
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);


      end  { if ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_Grund_type=AT_byte }
      else
        Fehler_cl.Registrieren('ZwischenCode/Zuweisung_Quelle_DWLOW_eintragen',
                               'Zieltyp ('+TYPE_IN_TYPENAME(ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_type)+
                               ') muss vom Type-Word sein',
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

    end; { if LOW_ANW_Type IN ['V','D','L','C'] then }

  end { if NAME_TO_ANW_und_ASM(DWLOW_Quelle,DWLOW_ANW_Type,DWLOW_type) then }
  else
    Fehler_cl.Registrieren('ZwischenCode/Zuweisung_Quelle_DWLOW_eintragen',
                           'es konnte keine Variable mit dem Namen <'+DWLOW_Quelle+'> gefunden werden',
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

  Result:=DWLOW_erfolgreich;
end; { function ZWC_class.Zuweisung_Quelle_DWLOW_eintragen }






function ZWC_class.Zuweisung_Quelle_DWHIGH_eintragen(DWHIGH_Quelle : String) : Boolean;
var
  DWHIGH_erfolgreich : Boolean;
  DWHIGH_type : ASM_type_Typ;
  DWHIGH_ANW_Type : Char;
begin

  DWHIGH_erfolgreich:=false;

  // 1. Namen suchen
  if NAME_TO_ANW_und_ASM(DWHIGH_Quelle,DWHIGH_ANW_Type,DWHIGH_type) then begin

    // 2. nur V,D,L,C soll ausgewertet werden
    if DWHIGH_ANW_Type IN ['V','D','L','C'] then begin

      if ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_Grund_type=AT_word then begin
        if DWHIGH_type=AT_dword then begin

          Inc_ZUW_Quelle_counter;
          ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Quelle[ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].
          QUELLcounter].Name:=DWHIGH_Quelle;
          ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Quelle[ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].
          QUELLcounter].ANW_type:='S';
          ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Quelle[ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].
          QUELLcounter].ANW_type2:=DWHIGH_ANW_Type;
          ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Quelle[ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].
          QUELLcounter].ASM_type:=AT_dword;
          ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Quelle[ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].
          QUELLcounter].ASM_Grund_type:=AT_dword;
          ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Quelle[ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].
          QUELLcounter].Wert:='N';

          DWHIGH_erfolgreich:=true;

        end  { if B2W_type=AT_word then }
        else
          Fehler_cl.Registrieren('ZwischenCode/Zuweisung_Quelle_DWHIGH_eintragen',
                                 'Quelltyp ('+
                                 TYPE_IN_TYPENAME(DWHIGH_type)+') muss vom Type DWord sein',
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);


      end  { if ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_Grund_type=AT_byte }
      else
        Fehler_cl.Registrieren('ZwischenCode/Zuweisung_Quelle_DWHIGH_eintragen',
                               'Zieltyp ('+TYPE_IN_TYPENAME(ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_type)+
                               ') muss vom Type-Word sein',
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

    end; { if LOW_ANW_Type IN ['V','D','L'] then }

  end { if NAME_TO_ANW_und_ASM(LOW_Quelle,LOW_ANW_Type,LOW_type) then }
  else
    Fehler_cl.Registrieren('ZwischenCode/Zuweisung_Quelle_DWHIGH_eintragen',
                           'es konnte keine Variable mit dem Namen <'+DWHIGH_Quelle+'> gefunden werden',
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

  Result:=DWHIGH_erfolgreich;
end; { function ZWC_class.Zuweisung_Quelle_DWHIGH_eintragen }





function ZWC_class.Zuweisung_Quelle_WORDTODW_eintragen(WORDTODW_Quelle : String) : Boolean;
var
  WORDTODW_erfolgreich : Boolean;
  WORDTODW_type : ASM_type_Typ;
  WORDTODW_ANW_Type : Char;
begin

  WORDTODW_erfolgreich:=false;

  // 1. Namen suchen
  if NAME_TO_ANW_und_ASM(WORDTODW_Quelle,WORDTODW_ANW_Type,WORDTODW_type) then begin

    // 2. nur V,D,L soll ausgewertet werden
    if WORDTODW_ANW_Type IN ['V','D','L','C'] then begin

      if ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_Grund_type=AT_dword then begin
        if WORDTODW_type=AT_word then begin

          Inc_ZUW_Quelle_counter;
          ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Quelle[ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].
          QUELLcounter].Name:=WORDTODW_Quelle;
          ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Quelle[ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].
          QUELLcounter].ANW_type:='S';
          ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Quelle[ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].
          QUELLcounter].ANW_type2:=WORDTODW_ANW_Type;
          ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Quelle[ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].
          QUELLcounter].ASM_type:=AT_word;
          ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Quelle[ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].
          QUELLcounter].ASM_Grund_type:=AT_word;
          ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Quelle[ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].
          QUELLcounter].Wert:='D';

          WORDTODW_erfolgreich:=true;

        end  { if B2W_type=AT_word then }
        else
          Fehler_cl.Registrieren('ZwischenCode/Zuweisung_Quelle_WORDTODW_eintragen',
                                 'Quelltyp ('+
                                 TYPE_IN_TYPENAME(WORDTODW_type)+') muss vom Type Word sein',
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);


      end  { if ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_Grund_type=AT_byte }
      else
        Fehler_cl.Registrieren('ZwischenCode/Zuweisung_Quelle_WORDTODW_eintragen',
                               'Zieltyp ('+TYPE_IN_TYPENAME(ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_type)+
                               ') muss vom Type-DWord sein',
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

    end; { if LOW_ANW_Type IN ['V','D','L'] then }

  end { if NAME_TO_ANW_und_ASM(LOW_Quelle,LOW_ANW_Type,LOW_type) then }
  else
    Fehler_cl.Registrieren('ZwischenCode/Zuweisung_Quelle_WORDTODW_eintragen',
                           'es konnte keine Variable mit dem Namen <'+WORDTODW_Quelle+'> gefunden werden',
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

  Result:=WORDTODW_erfolgreich;
end; { function ZWC_class.Zuweisung_Quelle_WORDTODW_eintragen }







function ZWC_class.Zuweisung_Quelle_BYTETODW_eintragen(BYTETODW_Quelle : String) : Boolean;
var
  BYTETODW_erfolgreich : Boolean;
  BYTETODW_type : ASM_type_Typ;
  BYTETODW_ANW_Type : Char;
begin

  BYTETODW_erfolgreich:=false;

  // 1. Namen suchen
  if NAME_TO_ANW_und_ASM(BYTETODW_Quelle,BYTETODW_ANW_Type,BYTETODW_type) then begin

    // 2. nur V,D,L soll ausgewertet werden
    if BYTETODW_ANW_Type IN ['V','D','L','C'] then begin

      if ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_Grund_type=AT_dword then begin
        if BYTETODW_type=AT_byte then begin

          Inc_ZUW_Quelle_counter;
          ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Quelle[ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].
          QUELLcounter].Name:=BYTETODW_Quelle;
          ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Quelle[ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].
          QUELLcounter].ANW_type:='S';
          ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Quelle[ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].
          QUELLcounter].ANW_type2:=BYTETODW_ANW_Type;
          ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Quelle[ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].
          QUELLcounter].ASM_type:=AT_byte;
          ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Quelle[ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].
          QUELLcounter].ASM_Grund_type:=AT_byte;
          ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Quelle[ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].
          QUELLcounter].Wert:='E';

          BYTETODW_erfolgreich:=true;

        end  { if B2W_type=AT_word then }
        else
          Fehler_cl.Registrieren('ZwischenCode/Zuweisung_Quelle_BYTETODW_eintragen',
                                 'Quelltyp ('+
                                 TYPE_IN_TYPENAME(BYTETODW_type)+') muss vom Type Byte sein',
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);


      end  { if ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_Grund_type=AT_byte }
      else
        Fehler_cl.Registrieren('ZwischenCode/Zuweisung_Quelle_BYTETODW_eintragen',
                               'Zieltyp ('+TYPE_IN_TYPENAME(ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_type)+
                               ') muss vom Type-DWord sein',
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

    end; { if BYTETODW_ANW_Type IN ['V','D','L'.'C'] then }

  end { if NAME_TO_ANW_und_ASM(BYTETODW_Quelle,BYTETODW_ANW_Type,BYTETODW_type) then }
  else
    Fehler_cl.Registrieren('ZwischenCode/Zuweisung_Quelle_BYTETODW_eintragen',
                           'es konnte keine Variable mit dem Namen <'+BYTETODW_Quelle+'> gefunden werden',
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

  Result:=BYTETODW_erfolgreich;
end; { function ZWC_class.Zuweisung_Quelle_BYTETODW_eintragen }








