

// ********************************************
//                ASM
// ********************************************





procedure ZWC_class.ASM_Zeilen_in_Assembler(ZeiNr_Anfang, ZeiNr_Ende : String);
begin
  STM_LISTE[STM_LISTE_counter].Bemerkung:='; ASM';
  STM_LISTE[STM_LISTE_counter].statement:=STM_asm;
  STM_LISTE[STM_LISTE_counter].parameter1:=ZeiNr_Anfang;
  STM_LISTE[STM_LISTE_counter].parameter2:=ZeiNr_Ende;
  Inc_STM_TAB_counter;
end; { procedure ZWC_class.ASM_Zeilen_in_Assembler }






// ********************************************
//                FOR TO DO
// ********************************************



procedure ZWC_class.FTD_Ziel_uebernehmen;
begin

  Inc_FTD_LISTE_counter;

  FTD_LIS.LISTE[FTD_LIS.counter].ASM_type:=ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_type;
  FTD_LIS.LISTE[FTD_LIS.counter].ziel:=ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].ziel;
  FTD_LIS.LISTE[FTD_LIS.counter].ziel_ANW_type:=ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].ziel_ANW_type;

  Zuweisung_in_STM_TAB_eintragen;

  Inc_ZUW_LIS_LISTcounter;
  ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_type:=FTD_LIS.LISTE[FTD_LIS.counter].ASM_type;
  ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_Grund_type:=FTD_LIS.LISTE[FTD_LIS.counter].ASM_type;

  if not (FTD_LIS.LISTE[FTD_LIS.counter].ASM_type IN [AT_byte, AT_char, AT_word, AT_dword]) then
    Fehler_cl.Registrieren('ZwischenCode/FTD_Ziel_uebernehmen',
                           'Der Zaehler in einer FOR_TO_DO-Schleife darf nur vom Typ Byte, Char, Word oder DWord sein',
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

end; { procedure ZWC_class.FTD_Ziel_uebernehmen }







procedure ZWC_class.FTD_Schalter_TO;
begin
  FTD_LIS.LISTE[FTD_LIS.counter].to_downto:=true;
end; { procedure ZWC_class.FTD_Schalter_TO }






procedure ZWC_class.FTD_Schalter_DOWNTO;
begin
  FTD_LIS.LISTE[FTD_LIS.counter].to_downto:=false;
end; { procedure ZWC_class.FTD_Schalter_DOWNTO }








procedure ZWC_class.FTD_Vergleich_uebernehmen;
var
  lokalen_Parameter : Integer;
begin

  Faktor_STM_TAB_eintragen('FOR TO DO');

  FTD_LIS.LISTE[FTD_LIS.counter].Vergl_ANW_type:=
           ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Quelle[ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].QUELLcounter].ANW_type;


  // Generierung der FTD-Marken
  FTD_LIS.LISTE[FTD_LIS.counter].Marke_Start:=erzeuge_Marke('FTD');
  FTD_LIS.LISTE[FTD_LIS.counter].Marke_StatementList:=erzeuge_Marke('FTD');
  FTD_LIS.LISTE[FTD_LIS.counter].Marke_Ende:=erzeuge_Marke('FTD');


  // Vorbereitungsteil FTD
  case FTD_LIS.LISTE[FTD_LIS.counter].ASM_type of

    AT_byte, AT_char :
      begin
         case FTD_LIS.LISTE[FTD_LIS.counter].Ziel_ANW_type of
          'V' :
            begin
              STM_LISTE[STM_LISTE_counter].Bemerkung:='; FOR TO DO - Laden des Byte-Zaehlwertes';
              STM_LISTE[STM_LISTE_counter].statement:=STM_LDS;
              STM_LISTE[STM_LISTE_counter].Parameter2:='R17';
              STM_LISTE[STM_LISTE_counter].Parameter1:=FTD_LIS.LISTE[FTD_LIS.counter].Ziel;
              Inc_STM_TAB_counter;
              STM_LISTE[STM_LISTE_counter].Bemerkung:='; FOR TO DO - Vergleichswert Byte in Stack';
              STM_LISTE[STM_LISTE_counter].statement:=STM_PUSH;
              STM_LISTE[STM_LISTE_counter].Parameter1:='R16';
              Inc_STM_TAB_counter;
            end;
          'L','D' :
            begin
              lokalen_Parameter:=lokalen_Parameter_suchen(FTD_LIS.LISTE[FTD_LIS.counter].Ziel);

              STM_LISTE[STM_LISTE_counter].Bemerkung:='; FOR TO DO - Laden des lokal Byte-Zaehlwertes';
              STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
              STM_LISTE[STM_LISTE_counter].Parameter2:='R17';
              STM_LISTE[STM_LISTE_counter].Parameter1:=
                               PROC_LIS.LISTE[PROC_LIS.counter].PPR_ARR[lokalen_Parameter].Register_L;
              Inc_STM_TAB_counter;
              STM_LISTE[STM_LISTE_counter].Bemerkung:='; FOR TO DO - Vergleichswert lokal Byte in Stack';
              STM_LISTE[STM_LISTE_counter].statement:=STM_PUSH;
              STM_LISTE[STM_LISTE_counter].Parameter1:='R16';
              Inc_STM_TAB_counter;
            end;

        else
          Fehler_cl.Registrieren('ZwischenCode/FTD_Vergleich_uebernehmen',
                             'ANW-Type <'+FTD_LIS.LISTE[FTD_LIS.counter].Ziel_ANW_type+'> wird nicht ausgewertet',
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

        end; { case FTD_LIS.LISTE[FTD_LIS.counter].Ziel_ANW_type of }
      end; { AT_byte }


    AT_word :
      begin
        case FTD_LIS.LISTE[FTD_LIS.counter].Ziel_ANW_type of
          'V' :
            begin
              STM_LISTE[STM_LISTE_counter].Bemerkung:='; FOR TO DO - Laden des Word-Zaehlwertes';
              STM_LISTE[STM_LISTE_counter].statement:=STM_LDS;
              STM_LISTE[STM_LISTE_counter].Parameter2:='R18';
              STM_LISTE[STM_LISTE_counter].Parameter1:=FTD_LIS.LISTE[FTD_LIS.counter].Ziel;
              Inc_STM_TAB_counter;
              STM_LISTE[STM_LISTE_counter].statement:=STM_LDS;
              STM_LISTE[STM_LISTE_counter].Parameter2:='R19';
              STM_LISTE[STM_LISTE_counter].Parameter1:=FTD_LIS.LISTE[FTD_LIS.counter].Ziel+'+1';
              Inc_STM_TAB_counter;
            end;
          'L','D' :
            begin
              lokalen_Parameter:=lokalen_Parameter_suchen(FTD_LIS.LISTE[FTD_LIS.counter].Ziel);

              STM_LISTE[STM_LISTE_counter].Bemerkung:='; FOR TO DO - Laden des lokal Word-Zaehlwertes';
              STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
              STM_LISTE[STM_LISTE_counter].Parameter2:='R18';
              STM_LISTE[STM_LISTE_counter].Parameter1:=
                            PROC_LIS.LISTE[PROC_LIS.counter].PPR_ARR[lokalen_Parameter].Register_L;
              Inc_STM_TAB_counter;
              STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
              STM_LISTE[STM_LISTE_counter].Parameter2:='R19';
              STM_LISTE[STM_LISTE_counter].Parameter1:=
                            PROC_LIS.LISTE[PROC_LIS.counter].PPR_ARR[lokalen_Parameter].Register_H;
              Inc_STM_TAB_counter;
            end;
        else
          Fehler_cl.Registrieren('ZwischenCode/FTD_Vergleich_uebernehmen',
                             'ANW-Type <'+FTD_LIS.LISTE[FTD_LIS.counter].Ziel_ANW_type+'> wird nicht ausgewertet',
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

        end; { case FTD_LIS.LISTE[FTD_LIS.counter].Ziel_ANW_type of }

        STM_LISTE[STM_LISTE_counter].Bemerkung:='; FOR TO DO - Vergleichswert Word in Stack';
        STM_LISTE[STM_LISTE_counter].statement:=STM_PUSH;
        STM_LISTE[STM_LISTE_counter].Parameter1:='R16';
        Inc_STM_TAB_counter;
        STM_LISTE[STM_LISTE_counter].statement:=STM_PUSH;
        STM_LISTE[STM_LISTE_counter].Parameter1:='R17';
        Inc_STM_TAB_counter;
      end; { AT_word }


    AT_dword :
      begin
        case FTD_LIS.LISTE[FTD_LIS.counter].Ziel_ANW_type of
          'V' :
            begin
              STM_LISTE[STM_LISTE_counter].Bemerkung:='; FOR TO DO - Laden des DWord-Zaehlwertes';
              STM_LISTE[STM_LISTE_counter].statement:=STM_LDS;
              STM_LISTE[STM_LISTE_counter].Parameter2:='R20';
              STM_LISTE[STM_LISTE_counter].Parameter1:=FTD_LIS.LISTE[FTD_LIS.counter].Ziel;
              Inc_STM_TAB_counter;
              STM_LISTE[STM_LISTE_counter].statement:=STM_LDS;
              STM_LISTE[STM_LISTE_counter].Parameter2:='R21';
              STM_LISTE[STM_LISTE_counter].Parameter1:=FTD_LIS.LISTE[FTD_LIS.counter].Ziel+'+1';
              Inc_STM_TAB_counter;
              STM_LISTE[STM_LISTE_counter].statement:=STM_LDS;
              STM_LISTE[STM_LISTE_counter].Parameter2:='R22';
              STM_LISTE[STM_LISTE_counter].Parameter1:=FTD_LIS.LISTE[FTD_LIS.counter].Ziel+'+2';
              Inc_STM_TAB_counter;
              STM_LISTE[STM_LISTE_counter].statement:=STM_LDS;
              STM_LISTE[STM_LISTE_counter].Parameter2:='R23';
              STM_LISTE[STM_LISTE_counter].Parameter1:=FTD_LIS.LISTE[FTD_LIS.counter].Ziel+'+3';
              Inc_STM_TAB_counter;
            end;
          'L','D' :
            begin
              lokalen_Parameter:=lokalen_Parameter_suchen(FTD_LIS.LISTE[FTD_LIS.counter].Ziel);

              STM_LISTE[STM_LISTE_counter].Bemerkung:='; FOR TO DO - Laden des lokal DWord-Zaehlwertes';
              STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
              STM_LISTE[STM_LISTE_counter].Parameter2:='R20';
              STM_LISTE[STM_LISTE_counter].Parameter1:=
                            PROC_LIS.LISTE[PROC_LIS.counter].PPR_ARR[lokalen_Parameter].Register_L;
              Inc_STM_TAB_counter;
              STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
              STM_LISTE[STM_LISTE_counter].Parameter2:='R21';
              STM_LISTE[STM_LISTE_counter].Parameter1:=
                            PROC_LIS.LISTE[PROC_LIS.counter].PPR_ARR[lokalen_Parameter].Register_H;
              Inc_STM_TAB_counter;

              STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
              STM_LISTE[STM_LISTE_counter].Parameter2:='R22';
              STM_LISTE[STM_LISTE_counter].Parameter1:=
                            PROC_LIS.LISTE[PROC_LIS.counter].PPR_ARR[lokalen_Parameter].Register_LH;
              Inc_STM_TAB_counter;
              STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
              STM_LISTE[STM_LISTE_counter].Parameter2:='R23';
              STM_LISTE[STM_LISTE_counter].Parameter1:=
                            PROC_LIS.LISTE[PROC_LIS.counter].PPR_ARR[lokalen_Parameter].Register_HH;
              Inc_STM_TAB_counter;

            end;
        else
          Fehler_cl.Registrieren('ZwischenCode/FTD_Vergleich_uebernehmen',
                             'ANW-Type <'+FTD_LIS.LISTE[FTD_LIS.counter].Ziel_ANW_type+'> wird nicht ausgewertet',
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

        end; { case FTD_LIS.LISTE[FTD_LIS.counter].Ziel_ANW_type of }

        STM_LISTE[STM_LISTE_counter].Bemerkung:='; FOR TO DO - Vergleichswert DWord in Stack';
        STM_LISTE[STM_LISTE_counter].statement:=STM_PUSH;
        STM_LISTE[STM_LISTE_counter].Parameter1:='R16';
        Inc_STM_TAB_counter;
        STM_LISTE[STM_LISTE_counter].statement:=STM_PUSH;
        STM_LISTE[STM_LISTE_counter].Parameter1:='R17';
        Inc_STM_TAB_counter;
        STM_LISTE[STM_LISTE_counter].statement:=STM_PUSH;
        STM_LISTE[STM_LISTE_counter].Parameter1:='R18';
        Inc_STM_TAB_counter;
        STM_LISTE[STM_LISTE_counter].statement:=STM_PUSH;
        STM_LISTE[STM_LISTE_counter].Parameter1:='R19';
        Inc_STM_TAB_counter;
      end; { AT_dword }


  else
    Fehler_cl.Registrieren('ZwischenCode/FUNCTION_beenden', 'Der Typ '+
                           Compiler_cl.ASM_type_Typ_in_Bezeichner(FTD_LIS.LISTE[FTD_LIS.counter].ASM_type)+
                           ' des - FOR TO DO - Zaehlwertes wird nicht unterstuetzt',
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

  end; { case FOR_TO_DO.ASM_type of }


  // Setzen der Start-Marke
  STM_LISTE[STM_LISTE_counter].Bemerkung:='; FOR TO DO - Marke_Start';
  STM_LISTE[STM_LISTE_counter].statement:=STM_sprungmarke;
  STM_LISTE[STM_LISTE_counter].Parameter1:=FTD_LIS.LISTE[FTD_LIS.counter].Marke_Start;
  Inc_STM_TAB_counter;



  // Vergleichsteil FTD
  case FTD_LIS.LISTE[FTD_LIS.counter].ASM_type of

    AT_byte, AT_char :
      begin

        if FTD_LIS.LISTE[FTD_LIS.counter].to_downto then begin
          STM_LISTE[STM_LISTE_counter].Bemerkung:='; FOR TO DO - Byte-Vergleichsteil (TO)';
          STM_LISTE[STM_LISTE_counter].statement:=STM_ftd_vergl_to_byte;
          Inc_STM_TAB_counter;
        end
        else begin
          STM_LISTE[STM_LISTE_counter].Bemerkung:='; FOR TO DO - Byte-Vergleichsteil (DOWNTO)';
          STM_LISTE[STM_LISTE_counter].statement:=STM_ftd_vergl_downto_byte;
          Inc_STM_TAB_counter;
        end;

        STM_LISTE[STM_LISTE_counter].statement:=STM_BRCC_Marke;
        STM_LISTE[STM_LISTE_counter].Parameter1:=FTD_LIS.LISTE[FTD_LIS.counter].Marke_StatementList;
        Inc_STM_TAB_counter;

        // bei grossem Speicher JMP !!!
        STM_LISTE[STM_LISTE_counter].statement:=STM_RJMP_Marke;
        STM_LISTE[STM_LISTE_counter].Parameter1:=FTD_LIS.LISTE[FTD_LIS.counter].Marke_Ende;
        Inc_STM_TAB_counter;
      end; { AT_byte }


    AT_word :
      begin

        if FTD_LIS.LISTE[FTD_LIS.counter].to_downto then begin
          STM_LISTE[STM_LISTE_counter].Bemerkung:='; FOR TO DO - Word-Vergleichsteil (TO)';
          STM_LISTE[STM_LISTE_counter].statement:=STM_ftd_vergl_to_word;
          Inc_STM_TAB_counter;
        end
        else begin
          STM_LISTE[STM_LISTE_counter].Bemerkung:='; FOR TO DO - Word-Vergleichsteil (DOWNTO)';
          STM_LISTE[STM_LISTE_counter].statement:=STM_ftd_vergl_downto_word;
          Inc_STM_TAB_counter;
        end;

        STM_LISTE[STM_LISTE_counter].statement:=STM_BRCC_Marke;
        STM_LISTE[STM_LISTE_counter].Parameter1:=FTD_LIS.LISTE[FTD_LIS.counter].Marke_StatementList;
        Inc_STM_TAB_counter;

        // bei grossem Speicher JMP !!!
        STM_LISTE[STM_LISTE_counter].statement:=STM_RJMP_Marke;
        STM_LISTE[STM_LISTE_counter].Parameter1:=FTD_LIS.LISTE[FTD_LIS.counter].Marke_Ende;
        Inc_STM_TAB_counter;
      end; { AT_word }



    AT_dword :
      begin

        if FTD_LIS.LISTE[FTD_LIS.counter].to_downto then begin
          STM_LISTE[STM_LISTE_counter].Bemerkung:='; FOR TO DO - DWord-Vergleichsteil (TO)';
          STM_LISTE[STM_LISTE_counter].statement:=STM_ftd_vergl_to_dword;
          Inc_STM_TAB_counter;
        end
        else begin
          STM_LISTE[STM_LISTE_counter].Bemerkung:='; FOR TO DO - DWord-Vergleichsteil (DOWNTO)';
          STM_LISTE[STM_LISTE_counter].statement:=STM_ftd_vergl_downto_dword;
          Inc_STM_TAB_counter;
        end;

        STM_LISTE[STM_LISTE_counter].statement:=STM_BRCC_Marke;
        STM_LISTE[STM_LISTE_counter].Parameter1:=FTD_LIS.LISTE[FTD_LIS.counter].Marke_StatementList;
        Inc_STM_TAB_counter;

        // bei grossem Speicher JMP !!!
        STM_LISTE[STM_LISTE_counter].statement:=STM_RJMP_Marke;
        STM_LISTE[STM_LISTE_counter].Parameter1:=FTD_LIS.LISTE[FTD_LIS.counter].Marke_Ende;
        Inc_STM_TAB_counter;
      end; { AT_dword }


  end; { case FOR_TO_DO.ASM_type of }

  STM_LISTE[STM_LISTE_counter].Bemerkung:='; FOR TO DO - Beginn der Statements in der Schleife';
  STM_LISTE[STM_LISTE_counter].statement:=STM_sprungmarke;
  STM_LISTE[STM_LISTE_counter].Parameter1:=FTD_LIS.LISTE[FTD_LIS.counter].Marke_StatementList;
  Inc_STM_TAB_counter;



end; { procedure ZWC_class.FTD_Vergleich_uebernehmen }




procedure ZWC_class.FTD_Abschluss_der_Schleife;
var
  lokalen_Parameter : Integer;
begin

  // Vergleichsteil FTD
  case FTD_LIS.LISTE[FTD_LIS.counter].ASM_type of


    AT_byte, AT_char :
      begin
        case FTD_LIS.LISTE[FTD_LIS.counter].Ziel_ANW_type of
          'V' :
            begin
              if FTD_LIS.LISTE[FTD_LIS.counter].to_downto then
                STM_LISTE[STM_LISTE_counter].Bemerkung:='; FOR TO DO - (global)Byte-INC-Zaehler'
              else
                STM_LISTE[STM_LISTE_counter].Bemerkung:='; FOR TO DO - (global)Byte-DEC-Zaehler';

              STM_LISTE[STM_LISTE_counter].statement:=STM_LDS;
              STM_LISTE[STM_LISTE_counter].Parameter2:='R17';
              STM_LISTE[STM_LISTE_counter].Parameter1:=FTD_LIS.LISTE[FTD_LIS.counter].Ziel;
              Inc_STM_TAB_counter;

              if FTD_LIS.LISTE[FTD_LIS.counter].to_downto then begin
                STM_LISTE[STM_LISTE_counter].statement:=STM_INC_byte;
                STM_LISTE[STM_LISTE_counter].Parameter1:='R17';
                Inc_STM_TAB_counter;
              end
              else begin
                STM_LISTE[STM_LISTE_counter].statement:=STM_DEC_byte;
                STM_LISTE[STM_LISTE_counter].Parameter1:='R17';
                Inc_STM_TAB_counter;
              end; { if FTD_LIS.LISTE[FTD_LIS.counter].to_downto }

              STM_LISTE[STM_LISTE_counter].statement:=STM_STS;
              STM_LISTE[STM_LISTE_counter].Parameter2:=FTD_LIS.LISTE[FTD_LIS.counter].Ziel;
              STM_LISTE[STM_LISTE_counter].Parameter1:='R17';
              Inc_STM_TAB_counter;
            end; { 'V' }
          'L', 'D' :
            begin
              lokalen_Parameter:=lokalen_Parameter_suchen(FTD_LIS.LISTE[FTD_LIS.counter].Ziel);

              if FTD_LIS.LISTE[FTD_LIS.counter].to_downto then
                STM_LISTE[STM_LISTE_counter].Bemerkung:='; FOR TO DO - (lokal)Byte-INC-Zaehler'
              else
                STM_LISTE[STM_LISTE_counter].Bemerkung:='; FOR TO DO - (lokal)Byte-DEC-Zaehler';

              STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
              STM_LISTE[STM_LISTE_counter].Parameter2:='R17';
              STM_LISTE[STM_LISTE_counter].Parameter1:=
                                PROC_LIS.LISTE[PROC_LIS.counter].PPR_ARR[lokalen_Parameter].Register_L;
              Inc_STM_TAB_counter;

              if FTD_LIS.LISTE[FTD_LIS.counter].to_downto then begin
                STM_LISTE[STM_LISTE_counter].statement:=STM_INC_byte;
                STM_LISTE[STM_LISTE_counter].Parameter1:='R17';
                Inc_STM_TAB_counter;
              end
              else begin
                STM_LISTE[STM_LISTE_counter].statement:=STM_DEC_byte;
                STM_LISTE[STM_LISTE_counter].Parameter1:='R17';
                Inc_STM_TAB_counter;
              end; { if FTD_LIS.LISTE[FTD_LIS.counter].to_downto }

              STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
              STM_LISTE[STM_LISTE_counter].Parameter2:=
                                PROC_LIS.LISTE[PROC_LIS.counter].PPR_ARR[lokalen_Parameter].Register_L;
              STM_LISTE[STM_LISTE_counter].Parameter1:='R17';
              Inc_STM_TAB_counter;
            end; { 'L', 'D' }
        else
          Fehler_cl.Registrieren('ZwischenCode/FTD_Abschluss_der_Schleife',
                             'ANW-Type <'+FTD_LIS.LISTE[FTD_LIS.counter].Ziel_ANW_type+'> wird nicht ausgewertet',
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

        end; { case FTD_LIS.LISTE[FTD_LIS.counter].Vergl_ANW_type }
      end; { AT_byte }


    AT_word :
      begin

         case FTD_LIS.LISTE[FTD_LIS.counter].Ziel_ANW_type of
          'V' :
            begin
              if FTD_LIS.LISTE[FTD_LIS.counter].to_downto then
                STM_LISTE[STM_LISTE_counter].Bemerkung:='; FOR TO DO - (global)Word-INC-Zaehler'
              else
                STM_LISTE[STM_LISTE_counter].Bemerkung:='; FOR TO DO - (global)Word-DEC-Zaehler';

              STM_LISTE[STM_LISTE_counter].statement:=STM_LDS;
              STM_LISTE[STM_LISTE_counter].Parameter2:='R18';
              STM_LISTE[STM_LISTE_counter].Parameter1:=FTD_LIS.LISTE[FTD_LIS.counter].Ziel;
              Inc_STM_TAB_counter;
              STM_LISTE[STM_LISTE_counter].statement:=STM_LDS;
              STM_LISTE[STM_LISTE_counter].Parameter2:='R19';
              STM_LISTE[STM_LISTE_counter].Parameter1:=FTD_LIS.LISTE[FTD_LIS.counter].Ziel+'+1';
              Inc_STM_TAB_counter;

              if FTD_LIS.LISTE[FTD_LIS.counter].to_downto then begin
                STM_LISTE[STM_LISTE_counter].statement:=STM_INC_word;
                STM_LISTE[STM_LISTE_counter].Parameter1:='R18';
                STM_LISTE[STM_LISTE_counter].Parameter2:='R19';
                Inc_STM_TAB_counter;
              end
              else begin
                STM_LISTE[STM_LISTE_counter].statement:=STM_DEC_word;
                STM_LISTE[STM_LISTE_counter].Parameter1:='R18';
                STM_LISTE[STM_LISTE_counter].Parameter2:='R19';
                Inc_STM_TAB_counter;
              end; { if FTD_LIS.LISTE[FTD_LIS.counter].to_downto then }

              STM_LISTE[STM_LISTE_counter].statement:=STM_STS;
              STM_LISTE[STM_LISTE_counter].Parameter2:=FTD_LIS.LISTE[FTD_LIS.counter].Ziel;
              STM_LISTE[STM_LISTE_counter].Parameter1:='R18';
              Inc_STM_TAB_counter;
              STM_LISTE[STM_LISTE_counter].statement:=STM_STS;
              STM_LISTE[STM_LISTE_counter].Parameter2:=FTD_LIS.LISTE[FTD_LIS.counter].Ziel+'+1';
              STM_LISTE[STM_LISTE_counter].Parameter1:='R19';
              Inc_STM_TAB_counter;
            end; { 'V' }
          'L', 'D' :
            begin
              lokalen_Parameter:=lokalen_Parameter_suchen(FTD_LIS.LISTE[FTD_LIS.counter].Ziel);

              if FTD_LIS.LISTE[FTD_LIS.counter].to_downto then
                STM_LISTE[STM_LISTE_counter].Bemerkung:='; FOR TO DO - (lokal)Word-INC-Zaehler'
              else
                STM_LISTE[STM_LISTE_counter].Bemerkung:='; FOR TO DO - (lokal)Word-DEC-Zaehler';

              STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
              STM_LISTE[STM_LISTE_counter].Parameter2:='R18';
              STM_LISTE[STM_LISTE_counter].Parameter1:=
                                PROC_LIS.LISTE[PROC_LIS.counter].PPR_ARR[lokalen_Parameter].Register_L;
              Inc_STM_TAB_counter;
              STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
              STM_LISTE[STM_LISTE_counter].Parameter2:='R19';
              STM_LISTE[STM_LISTE_counter].Parameter1:=
                                PROC_LIS.LISTE[PROC_LIS.counter].PPR_ARR[lokalen_Parameter].Register_H;
              Inc_STM_TAB_counter;

              if FTD_LIS.LISTE[FTD_LIS.counter].to_downto then begin
                STM_LISTE[STM_LISTE_counter].statement:=STM_INC_word;
                STM_LISTE[STM_LISTE_counter].Parameter1:='R18';
                STM_LISTE[STM_LISTE_counter].Parameter2:='R19';
                Inc_STM_TAB_counter;
              end
              else begin
                STM_LISTE[STM_LISTE_counter].statement:=STM_DEC_word;
                STM_LISTE[STM_LISTE_counter].Parameter1:='R18';
                STM_LISTE[STM_LISTE_counter].Parameter2:='R19';
                Inc_STM_TAB_counter;
              end; { if FTD_LIS.LISTE[FTD_LIS.counter].to_downto then }


              STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
              STM_LISTE[STM_LISTE_counter].Parameter2:=
                                PROC_LIS.LISTE[PROC_LIS.counter].PPR_ARR[lokalen_Parameter].Register_L;
              STM_LISTE[STM_LISTE_counter].Parameter1:='R18';
              Inc_STM_TAB_counter;
              STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
              STM_LISTE[STM_LISTE_counter].Parameter2:=
                                PROC_LIS.LISTE[PROC_LIS.counter].PPR_ARR[lokalen_Parameter].Register_H;
              STM_LISTE[STM_LISTE_counter].Parameter1:='R19';
              Inc_STM_TAB_counter;
            end; { 'L', 'D' }
        else
          Fehler_cl.Registrieren('ZwischenCode/FTD_Abschluss_der_Schleife',
                             'ANW-Type <'+FTD_LIS.LISTE[FTD_LIS.counter].Ziel_ANW_type+'> wird nicht ausgewertet',
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

        end; { case FTD_LIS.LISTE[FTD_LIS.counter].Vergl_ANW_type }

      end; { AT_word }


    AT_dword :
      begin

         case FTD_LIS.LISTE[FTD_LIS.counter].Ziel_ANW_type of
          'V' :
            begin
              if FTD_LIS.LISTE[FTD_LIS.counter].to_downto then
                STM_LISTE[STM_LISTE_counter].Bemerkung:='; FOR TO DO - (global)DWord-INC-Zaehler'
              else
                STM_LISTE[STM_LISTE_counter].Bemerkung:='; FOR TO DO - (global)DWord-DEC-Zaehler';

              STM_LISTE[STM_LISTE_counter].statement:=STM_LDS;
              STM_LISTE[STM_LISTE_counter].Parameter2:='R20';
              STM_LISTE[STM_LISTE_counter].Parameter1:=FTD_LIS.LISTE[FTD_LIS.counter].Ziel;
              Inc_STM_TAB_counter;
              STM_LISTE[STM_LISTE_counter].statement:=STM_LDS;
              STM_LISTE[STM_LISTE_counter].Parameter2:='R21';
              STM_LISTE[STM_LISTE_counter].Parameter1:=FTD_LIS.LISTE[FTD_LIS.counter].Ziel+'+1';
              Inc_STM_TAB_counter;
              STM_LISTE[STM_LISTE_counter].statement:=STM_LDS;
              STM_LISTE[STM_LISTE_counter].Parameter2:='R22';
              STM_LISTE[STM_LISTE_counter].Parameter1:=FTD_LIS.LISTE[FTD_LIS.counter].Ziel+'+2';
              Inc_STM_TAB_counter;
              STM_LISTE[STM_LISTE_counter].statement:=STM_LDS;
              STM_LISTE[STM_LISTE_counter].Parameter2:='R23';
              STM_LISTE[STM_LISTE_counter].Parameter1:=FTD_LIS.LISTE[FTD_LIS.counter].Ziel+'+3';
              Inc_STM_TAB_counter;

              if FTD_LIS.LISTE[FTD_LIS.counter].to_downto then begin
                STM_LISTE[STM_LISTE_counter].statement:=STM_INC_dword_l1;
                STM_LISTE[STM_LISTE_counter].Parameter1:='R20';
                STM_LISTE[STM_LISTE_counter].Parameter2:='R21';
                Inc_STM_TAB_counter;
                STM_LISTE[STM_LISTE_counter].statement:=STM_INC_dword_l2;
                STM_LISTE[STM_LISTE_counter].Parameter1:='R22';
                STM_LISTE[STM_LISTE_counter].Parameter2:='R23';
                Inc_STM_TAB_counter;
              end
              else begin
                STM_LISTE[STM_LISTE_counter].statement:=STM_DEC_dword_l1;
                STM_LISTE[STM_LISTE_counter].Parameter1:='R20';
                STM_LISTE[STM_LISTE_counter].Parameter2:='R21';
                Inc_STM_TAB_counter;
                STM_LISTE[STM_LISTE_counter].statement:=STM_DEC_dword_l2;
                STM_LISTE[STM_LISTE_counter].Parameter1:='R22';
                STM_LISTE[STM_LISTE_counter].Parameter2:='R23';
                Inc_STM_TAB_counter;
              end; { if FTD_LIS.LISTE[FTD_LIS.counter].to_downto then }

              STM_LISTE[STM_LISTE_counter].statement:=STM_STS;
              STM_LISTE[STM_LISTE_counter].Parameter2:=FTD_LIS.LISTE[FTD_LIS.counter].Ziel;
              STM_LISTE[STM_LISTE_counter].Parameter1:='R20';
              Inc_STM_TAB_counter;
              STM_LISTE[STM_LISTE_counter].statement:=STM_STS;
              STM_LISTE[STM_LISTE_counter].Parameter2:=FTD_LIS.LISTE[FTD_LIS.counter].Ziel+'+1';
              STM_LISTE[STM_LISTE_counter].Parameter1:='R21';
              Inc_STM_TAB_counter;
              STM_LISTE[STM_LISTE_counter].statement:=STM_STS;
              STM_LISTE[STM_LISTE_counter].Parameter2:=FTD_LIS.LISTE[FTD_LIS.counter].Ziel+'+2';
              STM_LISTE[STM_LISTE_counter].Parameter1:='R22';
              Inc_STM_TAB_counter;
              STM_LISTE[STM_LISTE_counter].statement:=STM_STS;
              STM_LISTE[STM_LISTE_counter].Parameter2:=FTD_LIS.LISTE[FTD_LIS.counter].Ziel+'+3';
              STM_LISTE[STM_LISTE_counter].Parameter1:='R23';
              Inc_STM_TAB_counter;
            end; { 'V' }

          'L', 'D' :
            begin
              lokalen_Parameter:=lokalen_Parameter_suchen(FTD_LIS.LISTE[FTD_LIS.counter].Ziel);

              if FTD_LIS.LISTE[FTD_LIS.counter].to_downto then
                STM_LISTE[STM_LISTE_counter].Bemerkung:='; FOR TO DO - (lokal)DWord-INC-Zaehler'
              else
                STM_LISTE[STM_LISTE_counter].Bemerkung:='; FOR TO DO - (lokal)DWord-DEC-Zaehler';

              STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
              STM_LISTE[STM_LISTE_counter].Parameter2:='R20';
              STM_LISTE[STM_LISTE_counter].Parameter1:=
                                PROC_LIS.LISTE[PROC_LIS.counter].PPR_ARR[lokalen_Parameter].Register_L;
              Inc_STM_TAB_counter;
              STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
              STM_LISTE[STM_LISTE_counter].Parameter2:='R21';
              STM_LISTE[STM_LISTE_counter].Parameter1:=
                                PROC_LIS.LISTE[PROC_LIS.counter].PPR_ARR[lokalen_Parameter].Register_H;
              Inc_STM_TAB_counter;
              STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
              STM_LISTE[STM_LISTE_counter].Parameter2:='R22';
              STM_LISTE[STM_LISTE_counter].Parameter1:=
                                PROC_LIS.LISTE[PROC_LIS.counter].PPR_ARR[lokalen_Parameter].Register_LH;
              Inc_STM_TAB_counter;
              STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
              STM_LISTE[STM_LISTE_counter].Parameter2:='R23';
              STM_LISTE[STM_LISTE_counter].Parameter1:=
                                PROC_LIS.LISTE[PROC_LIS.counter].PPR_ARR[lokalen_Parameter].Register_HH;
              Inc_STM_TAB_counter;

              if FTD_LIS.LISTE[FTD_LIS.counter].to_downto then begin
                STM_LISTE[STM_LISTE_counter].statement:=STM_INC_dword_l1;
                STM_LISTE[STM_LISTE_counter].Parameter1:='R20';
                STM_LISTE[STM_LISTE_counter].Parameter2:='R21';
                Inc_STM_TAB_counter;
                STM_LISTE[STM_LISTE_counter].statement:=STM_INC_dword_l2;
                STM_LISTE[STM_LISTE_counter].Parameter1:='R22';
                STM_LISTE[STM_LISTE_counter].Parameter2:='R23';
                Inc_STM_TAB_counter;
              end
              else begin
                STM_LISTE[STM_LISTE_counter].statement:=STM_DEC_dword_l1;
                STM_LISTE[STM_LISTE_counter].Parameter1:='R20';
                STM_LISTE[STM_LISTE_counter].Parameter2:='R21';
                Inc_STM_TAB_counter;
                STM_LISTE[STM_LISTE_counter].statement:=STM_DEC_dword_l2;
                STM_LISTE[STM_LISTE_counter].Parameter1:='R22';
                STM_LISTE[STM_LISTE_counter].Parameter2:='R23';
                Inc_STM_TAB_counter;
              end; { if FTD_LIS.LISTE[FTD_LIS.counter].to_downto then }


              STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
              STM_LISTE[STM_LISTE_counter].Parameter2:=
                                PROC_LIS.LISTE[PROC_LIS.counter].PPR_ARR[lokalen_Parameter].Register_L;
              STM_LISTE[STM_LISTE_counter].Parameter1:='R20';
              Inc_STM_TAB_counter;
              STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
              STM_LISTE[STM_LISTE_counter].Parameter2:=
                                PROC_LIS.LISTE[PROC_LIS.counter].PPR_ARR[lokalen_Parameter].Register_H;
              STM_LISTE[STM_LISTE_counter].Parameter1:='R21';
              Inc_STM_TAB_counter;
              STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
              STM_LISTE[STM_LISTE_counter].Parameter2:=
                                PROC_LIS.LISTE[PROC_LIS.counter].PPR_ARR[lokalen_Parameter].Register_LH;
              STM_LISTE[STM_LISTE_counter].Parameter1:='R22';
              Inc_STM_TAB_counter;
              STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
              STM_LISTE[STM_LISTE_counter].Parameter2:=
                                PROC_LIS.LISTE[PROC_LIS.counter].PPR_ARR[lokalen_Parameter].Register_HH;
              STM_LISTE[STM_LISTE_counter].Parameter1:='R23';
              Inc_STM_TAB_counter;
            end; { 'L', 'D' }
        else
          Fehler_cl.Registrieren('ZwischenCode/FTD_Abschluss_der_Schleife',
                             'ANW-Type <'+FTD_LIS.LISTE[FTD_LIS.counter].Ziel_ANW_type+'> wird nicht ausgewertet',
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

        end; { case FTD_LIS.LISTE[FTD_LIS.counter].Vergl_ANW_type }

      end; { AT_dword }



  end; { case FOR_TO_DO.ASM_type of }

  STM_LISTE[STM_LISTE_counter].Bemerkung:='; FOR TO DO - Sprung zur Auswertung';
  STM_LISTE[STM_LISTE_counter].statement:=STM_RJMP_Marke;
  STM_LISTE[STM_LISTE_counter].Parameter1:=FTD_LIS.LISTE[FTD_LIS.counter].Marke_Start;
  Inc_STM_TAB_counter;

  STM_LISTE[STM_LISTE_counter].Bemerkung:='; FOR TO DO - Ende';
  STM_LISTE[STM_LISTE_counter].statement:=STM_sprungmarke;
  STM_LISTE[STM_LISTE_counter].Parameter1:=FTD_LIS.LISTE[FTD_LIS.counter].Marke_Ende;
  Inc_STM_TAB_counter;

  // Ende FTD - Vergleichswert vom Stack holen
  case FTD_LIS.LISTE[FTD_LIS.counter].ASM_type of
    AT_byte, AT_char :
      begin
        STM_LISTE[STM_LISTE_counter].Bemerkung:='; FOR TO DO - Vergleichswert (Byte) vom Stack holen';
        STM_LISTE[STM_LISTE_counter].statement:=STM_POP;
        STM_LISTE[STM_LISTE_counter].Parameter1:='R16';
        Inc_STM_TAB_counter;
      end;
    AT_word :
      begin
        STM_LISTE[STM_LISTE_counter].Bemerkung:='; FOR TO DO - Vergleichswert (Word) vom Stack holen';
        STM_LISTE[STM_LISTE_counter].statement:=STM_POP;
        STM_LISTE[STM_LISTE_counter].Parameter1:='R17';
        Inc_STM_TAB_counter;
        STM_LISTE[STM_LISTE_counter].statement:=STM_POP;
        STM_LISTE[STM_LISTE_counter].Parameter1:='R16';
        Inc_STM_TAB_counter;
      end;
    AT_dword :
      begin
        STM_LISTE[STM_LISTE_counter].Bemerkung:='; FOR TO DO - Vergleichswert (DWord) vom Stack holen';
        STM_LISTE[STM_LISTE_counter].statement:=STM_POP;
        STM_LISTE[STM_LISTE_counter].Parameter1:='R19';
        Inc_STM_TAB_counter;
        STM_LISTE[STM_LISTE_counter].statement:=STM_POP;
        STM_LISTE[STM_LISTE_counter].Parameter1:='R18';
        Inc_STM_TAB_counter;
        STM_LISTE[STM_LISTE_counter].statement:=STM_POP;
        STM_LISTE[STM_LISTE_counter].Parameter1:='R17';
        Inc_STM_TAB_counter;
        STM_LISTE[STM_LISTE_counter].statement:=STM_POP;
        STM_LISTE[STM_LISTE_counter].Parameter1:='R16';
        Inc_STM_TAB_counter;
      end;
  end; { case FOR_TO_DO.ASM_type of }


  // Ruecksetzen_FTD_LIS;
  with FTD_LIS.LISTE[FTD_LIS.counter] do begin
    Ziel:='';
    Marke_Start:='';
    Marke_StatementList:='';
    Marke_Ende:='';
    ASM_type:=AT_kein_typ;
    Ziel_ANW_type:='X';
  end; { with FTD_LIS.LISTE[FTD_LIS.counter] do }



  DEC(FTD_LIS.counter);

  if FTD_LIS.counter<0 then
    Fehler_cl.Registrieren('ZwischenCode/FTD_Abschluss_der_Schleife',
                            'FOR TO DO-Schleife mehrfach beendet',
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

  // Loeschen aller Zwischenwerte der Zuweisung
  Ruecksetzen_Zuweisung;


end; { procedure ZWC_class.FTD_Abschluss_der_Schleife }






// ********************************************
//                LOOP
// ********************************************



 procedure ZWC_class.loop_start;
 begin
   LOOP_MARKE.Start_Marke:=erzeuge_Marke('LOOP');

   STM_LISTE[STM_LISTE_counter].Bemerkung:='; LOOP - Start_Marke';
   STM_LISTE[STM_LISTE_counter].statement:=STM_sprungmarke;
   STM_LISTE[STM_LISTE_counter].Parameter1:=LOOP_MARKE.Start_Marke;
   Inc_STM_TAB_counter;

 end; { procedure ZWC_class.loop_start }




 procedure ZWC_class.loop_end;
 begin

   STM_LISTE[STM_LISTE_counter].Bemerkung:='; LOOP - Ende';
   STM_LISTE[STM_LISTE_counter].statement:=STM_RJMP_Marke;
   STM_LISTE[STM_LISTE_counter].Parameter1:=LOOP_MARKE.Start_Marke;
   Inc_STM_TAB_counter;

 end; { procedure ZWC_class.loop_end }











// ********************************************
//                IF THEN
// ********************************************





 procedure ZWC_class.if_then_init;
 begin

   Inc_ZUW_LIS_LISTcounter;

   ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_type:=AT_boolean;
   ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_Grund_type:=AT_boolean;
   ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ANW_type:='V';

   Inc_IF_THEN_LIS_counter;

   IF_THEN_LIS.LISTE[IF_THEN_LIS.counter].Start_Marke:=erzeuge_Marke('IF');
   IF_THEN_LIS.LISTE[IF_THEN_LIS.counter].Ende_True_Marke:=erzeuge_Marke('IF');
   IF_THEN_LIS.LISTE[IF_THEN_LIS.counter].Ende_Else_Marke:=erzeuge_Marke('IF');
   IF_THEN_LIS.LISTE[IF_THEN_LIS.counter].mit_Else:=false;

 end; { procedure ZWC_class.if_then_init }




  procedure ZWC_class.if_then_start;
  begin

    Faktor_STM_TAB_eintragen('IF THEN');

    STM_LISTE[STM_LISTE_counter].Bemerkung:='; IF_THEN - Vergleich';
    STM_LISTE[STM_LISTE_counter].statement:=STM_bo_cp;
    STM_LISTE[STM_LISTE_counter].Parameter1:=IF_THEN_LIS.LISTE[IF_THEN_LIS.counter].Start_Marke;
    STM_LISTE[STM_LISTE_counter].Parameter2:=IF_THEN_LIS.LISTE[IF_THEN_LIS.counter].Ende_True_Marke;
    Inc_STM_TAB_counter;

    // Loeschen aller Zwischenwerte der Zuweisung
    Ruecksetzen_Zuweisung;

  end; { procedure ZWC_class.if_then_start }





  procedure ZWC_class.if_then_else;
  begin
    IF_THEN_LIS.LISTE[IF_THEN_LIS.counter].mit_Else:=true;

    STM_LISTE[STM_LISTE_counter].Bemerkung:='; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts';
    STM_LISTE[STM_LISTE_counter].statement:=STM_RJMP_Marke;
    STM_LISTE[STM_LISTE_counter].Parameter1:=IF_THEN_LIS.LISTE[IF_THEN_LIS.counter].Ende_Else_Marke;
    Inc_STM_TAB_counter;

    STM_LISTE[STM_LISTE_counter].Bemerkung:='; IF_THEN_ELSE - Beginn ELSE-Abschnitt';
    STM_LISTE[STM_LISTE_counter].statement:=STM_sprungmarke;
    STM_LISTE[STM_LISTE_counter].Parameter1:=IF_THEN_LIS.LISTE[IF_THEN_LIS.counter].Ende_True_Marke;
    Inc_STM_TAB_counter;

  end; { procedure ZWC_class.if_then_else }


  procedure ZWC_class.if_then_end;
  begin

    if IF_THEN_LIS.LISTE[IF_THEN_LIS.counter].mit_Else then begin

      STM_LISTE[STM_LISTE_counter].Bemerkung:='; IF_THEN_ELSE - Ende';
      STM_LISTE[STM_LISTE_counter].statement:=STM_sprungmarke;
      STM_LISTE[STM_LISTE_counter].Parameter1:=IF_THEN_LIS.LISTE[IF_THEN_LIS.counter].Ende_Else_Marke;
      Inc_STM_TAB_counter;

    end
    else begin

      STM_LISTE[STM_LISTE_counter].Bemerkung:='; IF_THEN - Ende';
      STM_LISTE[STM_LISTE_counter].statement:=STM_sprungmarke;
      STM_LISTE[STM_LISTE_counter].Parameter1:=IF_THEN_LIS.LISTE[IF_THEN_LIS.counter].Ende_True_Marke;
      Inc_STM_TAB_counter;

    end;


    // Ruecksetzen IF THEN Liste
    with IF_THEN_LIS.LISTE[IF_THEN_LIS.counter] do begin
      Start_Marke:='';
      Ende_True_Marke:='';
      Ende_Else_Marke:='';
      mit_Else:=false;
    end; { with IF_THEN_LIS.LISTE[IF_THEN_LIS.counter] do }


    Dec(IF_THEN_LIS.counter);

    if IF_THEN_LIS.counter<0 then
      Fehler_cl.Registrieren('ZwischenCode/FTD_Abschluss_der_Schleife',
                             'IF-THEN-Schleife mehrfach beendet',
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);


  end; { procedure ZWC_class.if_then_end }







// ********************************************
//       INC, DEC, SHL, SHR, NOP
// ********************************************



function ZWC_class.INC_var_lesen(INC_VAR_NAME : String) : Boolean;
var
  INC_erfolgreich : Boolean;
  INC_ANW_type : Char;
  INC_ASM_type : ASM_type_Typ;
  lok_PAR_Pos : Integer;
begin
  INC_erfolgreich:=false;

  if NAME_TO_ANW_und_ASM(INC_VAR_NAME,INC_ANW_type,INC_ASM_type) then begin

    case INC_ANW_type of
      'V' :
        begin

          case INC_ASM_type of

            AT_byte, AT_char :
              begin
                STM_LISTE[STM_LISTE_counter].Bemerkung:='; INC('+INC_VAR_NAME+') - Byte';
                STM_LISTE[STM_LISTE_counter].statement:=STM_LDS;
                STM_LISTE[STM_LISTE_counter].Parameter1:=INC_VAR_NAME;
                STM_LISTE[STM_LISTE_counter].Parameter2:='R16';
                Inc_STM_TAB_counter;
                STM_LISTE[STM_LISTE_counter].statement:=STM_INC_byte;
                STM_LISTE[STM_LISTE_counter].Parameter1:='R16';
                Inc_STM_TAB_counter;
                STM_LISTE[STM_LISTE_counter].statement:=STM_STS;
                STM_LISTE[STM_LISTE_counter].Parameter1:='R16';
                STM_LISTE[STM_LISTE_counter].Parameter2:=INC_VAR_NAME;
                Inc_STM_TAB_counter;
              end; { AT_byte }

            AT_word :
              begin
                STM_LISTE[STM_LISTE_counter].Bemerkung:='; INC('+INC_VAR_NAME+') - Word';
                STM_LISTE[STM_LISTE_counter].statement:=STM_LDS;
                STM_LISTE[STM_LISTE_counter].Parameter1:=INC_VAR_NAME;
                STM_LISTE[STM_LISTE_counter].Parameter2:='R24';
                Inc_STM_TAB_counter;
                STM_LISTE[STM_LISTE_counter].statement:=STM_LDS;
                STM_LISTE[STM_LISTE_counter].Parameter1:=INC_VAR_NAME+'+1';
                STM_LISTE[STM_LISTE_counter].Parameter2:='R25';
                Inc_STM_TAB_counter;
                STM_LISTE[STM_LISTE_counter].statement:=STM_ADIW;
                STM_LISTE[STM_LISTE_counter].Parameter2:='R25';
                STM_LISTE[STM_LISTE_counter].Parameter1:='R24';
                Inc_STM_TAB_counter;
                STM_LISTE[STM_LISTE_counter].statement:=STM_STS;
                STM_LISTE[STM_LISTE_counter].Parameter1:='R24';
                STM_LISTE[STM_LISTE_counter].Parameter2:=INC_VAR_NAME;
                Inc_STM_TAB_counter;
                STM_LISTE[STM_LISTE_counter].statement:=STM_STS;
                STM_LISTE[STM_LISTE_counter].Parameter1:='R25';
                STM_LISTE[STM_LISTE_counter].Parameter2:=INC_VAR_NAME+'+1';
                Inc_STM_TAB_counter;
              end; { AT_word }


            AT_dword :
              begin

                STM_LISTE[STM_LISTE_counter].Bemerkung:='; INC('+INC_VAR_NAME+') - DWord';
                STM_LISTE[STM_LISTE_counter].statement:=STM_LDS;
                STM_LISTE[STM_LISTE_counter].Parameter1:=INC_VAR_NAME;
                STM_LISTE[STM_LISTE_counter].Parameter2:='R16';
                Inc_STM_TAB_counter;
                STM_LISTE[STM_LISTE_counter].statement:=STM_LDS;
                STM_LISTE[STM_LISTE_counter].Parameter1:=INC_VAR_NAME+'+1';
                STM_LISTE[STM_LISTE_counter].Parameter2:='R17';
                Inc_STM_TAB_counter;
                STM_LISTE[STM_LISTE_counter].statement:=STM_LDS;
                STM_LISTE[STM_LISTE_counter].Parameter1:=INC_VAR_NAME+'+2';
                STM_LISTE[STM_LISTE_counter].Parameter2:='R18';
                Inc_STM_TAB_counter;
                STM_LISTE[STM_LISTE_counter].statement:=STM_LDS;
                STM_LISTE[STM_LISTE_counter].Parameter1:=INC_VAR_NAME+'+3';
                STM_LISTE[STM_LISTE_counter].Parameter2:='R19';
                Inc_STM_TAB_counter;
                STM_LISTE[STM_LISTE_counter].statement:=STM_INC_dword;
                Inc_STM_TAB_counter;
                STM_LISTE[STM_LISTE_counter].statement:=STM_STS;
                STM_LISTE[STM_LISTE_counter].Parameter1:='R16';
                STM_LISTE[STM_LISTE_counter].Parameter2:=INC_VAR_NAME;
                Inc_STM_TAB_counter;
                STM_LISTE[STM_LISTE_counter].statement:=STM_STS;
                STM_LISTE[STM_LISTE_counter].Parameter1:='R17';
                STM_LISTE[STM_LISTE_counter].Parameter2:=INC_VAR_NAME+'+1';
                Inc_STM_TAB_counter;
                STM_LISTE[STM_LISTE_counter].statement:=STM_STS;
                STM_LISTE[STM_LISTE_counter].Parameter1:='R18';
                STM_LISTE[STM_LISTE_counter].Parameter2:=INC_VAR_NAME+'+2';
                Inc_STM_TAB_counter;
                STM_LISTE[STM_LISTE_counter].statement:=STM_STS;
                STM_LISTE[STM_LISTE_counter].Parameter1:='R19';
                STM_LISTE[STM_LISTE_counter].Parameter2:=INC_VAR_NAME+'+3';
                Inc_STM_TAB_counter;
              end; { AT_dword }


          else
            Fehler_cl.Registrieren('ZwischenCode/INC_var_lesen',
                                   'DEC kann nur fuer Byte-, Word- oder DWord-Variablen werden',
                                   Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                                   Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                                   Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

          end; { case DEC_ASM_type of }

      end; { 'V' }



      'L','D' :
        begin

          lok_PAR_Pos:=lokalen_Parameter_suchen(INC_VAR_NAME);

          case INC_ASM_type of

            AT_byte, AT_char :
              begin
                STM_LISTE[STM_LISTE_counter].Bemerkung:='; INC('+INC_VAR_NAME+') - Byte';

                STM_LISTE[STM_LISTE_counter].statement:=STM_INC_byte;
                STM_LISTE[STM_LISTE_counter].Parameter1:=
                         PROC_LIS.LISTE[PROC_LIS.counter].PPR_ARR[lok_PAR_Pos].Register_L;
                Inc_STM_TAB_counter;

              end; { AT_byte }

            AT_word :
              begin
                STM_LISTE[STM_LISTE_counter].Bemerkung:='; INC('+INC_VAR_NAME+') - Word';

                if ASM_Switch.use_MOVW then begin

                  STM_LISTE[STM_LISTE_counter].statement:=STM_MOVW;
                  STM_LISTE[STM_LISTE_counter].parameter1:=
                           PROC_LIS.LISTE[PROC_LIS.counter].PPR_ARR[lok_PAR_Pos].Register_H+':'+
                           PROC_LIS.LISTE[PROC_LIS.counter].PPR_ARR[lok_PAR_Pos].Register_L;
                  STM_LISTE[STM_LISTE_counter].parameter2:='R25:R24';
                  Inc_STM_TAB_counter;

                end
                else begin

                  STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
                  STM_LISTE[STM_LISTE_counter].parameter1:=
                           PROC_LIS.LISTE[PROC_LIS.counter].PPR_ARR[lok_PAR_Pos].Register_L;
                  STM_LISTE[STM_LISTE_counter].parameter2:='R24';
                  Inc_STM_TAB_counter;

                  STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
                  STM_LISTE[STM_LISTE_counter].parameter1:=
                           PROC_LIS.LISTE[PROC_LIS.counter].PPR_ARR[lok_PAR_Pos].Register_H;
                  STM_LISTE[STM_LISTE_counter].parameter2:='R25';
                  Inc_STM_TAB_counter;

                end; { if use_MOVW then }

                STM_LISTE[STM_LISTE_counter].statement:=STM_ADIW;
                STM_LISTE[STM_LISTE_counter].parameter2:='R25';
                STM_LISTE[STM_LISTE_counter].parameter1:='R24';
                Inc_STM_TAB_counter;



                if ASM_Switch.use_MOVW then begin

                  STM_LISTE[STM_LISTE_counter].statement:=STM_MOVW;
                  STM_LISTE[STM_LISTE_counter].parameter2:=
                           PROC_LIS.LISTE[PROC_LIS.counter].PPR_ARR[lok_PAR_Pos].Register_H+':'+
                           PROC_LIS.LISTE[PROC_LIS.counter].PPR_ARR[lok_PAR_Pos].Register_L;
                  STM_LISTE[STM_LISTE_counter].parameter1:='R25:R24';
                  Inc_STM_TAB_counter;

                end
                else begin

                  STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
                  STM_LISTE[STM_LISTE_counter].parameter2:=
                           PROC_LIS.LISTE[PROC_LIS.counter].PPR_ARR[lok_PAR_Pos].Register_L;
                  STM_LISTE[STM_LISTE_counter].parameter1:='R24';
                  Inc_STM_TAB_counter;
                  STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
                  STM_LISTE[STM_LISTE_counter].parameter2:=
                           PROC_LIS.LISTE[PROC_LIS.counter].PPR_ARR[lok_PAR_Pos].Register_H;
                  STM_LISTE[STM_LISTE_counter].parameter1:='R25';
                  Inc_STM_TAB_counter;

                end; { if use_MOVW then }

              end; { AT_word }


            AT_dword :
              begin

                STM_LISTE[STM_LISTE_counter].Bemerkung:='; INC('+INC_VAR_NAME+') - DWord';

                STM_LISTE[STM_LISTE_counter].statement:=STM_INC_dword_l1;
                STM_LISTE[STM_LISTE_counter].Parameter1:=
                  PROC_LIS.LISTE[PROC_LIS.counter].PPR_ARR[lok_PAR_Pos].Register_L;
                STM_LISTE[STM_LISTE_counter].Parameter2:=
                  PROC_LIS.LISTE[PROC_LIS.counter].PPR_ARR[lok_PAR_Pos].Register_H;
                Inc_STM_TAB_counter;
                STM_LISTE[STM_LISTE_counter].statement:=STM_INC_dword_l2;
                STM_LISTE[STM_LISTE_counter].Parameter1:=
                  PROC_LIS.LISTE[PROC_LIS.counter].PPR_ARR[lok_PAR_Pos].Register_LH;
                STM_LISTE[STM_LISTE_counter].Parameter2:=
                  PROC_LIS.LISTE[PROC_LIS.counter].PPR_ARR[lok_PAR_Pos].Register_HH;
                Inc_STM_TAB_counter;

              end; { AT_dword }


          else
            Fehler_cl.Registrieren('ZwischenCode/INC_var_lesen',
                                   'INC kann nur fuer Byte-, Word- oder DWord-Variablen genutzt werden',
                                   Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                                   Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                                   Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

          end; { case DEC_ASM_type of }

      end; { 'L','D' }


    else
      Fehler_cl.Registrieren('ZwischenCode/INC_var_lesen',
                             'Es koennen nur Variablen inkrementiert werden',
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

    end; { case INC_ANW_type of }


    INC_erfolgreich:=true;



  end { if NAME_TO_ANW_und_ASM(INC_VAR_NAME,INC_ANW_type,INC_ASM_type) then }
  else
    Fehler_cl.Registrieren('ZwischenCode/INC_var_lesen',
                           'Name <'+INC_VAR_NAME+'> der INC-Variablen konnte nicht gefunden werden',
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);


  Result:=INC_erfolgreich;
end; { function ZWC_class.INC_var_lesen }






function ZWC_class.DEC_var_lesen(DEC_VAR_NAME : String) : Boolean;
var
  DEC_erfolgreich : Boolean;
  DEC_ANW_type : Char;
  DEC_ASM_type : ASM_type_Typ;
  lok_PAR_Pos : Integer;
begin
  DEC_erfolgreich:=false;

  if NAME_TO_ANW_und_ASM(DEC_VAR_NAME,DEC_ANW_type,DEC_ASM_type) then begin


    case DEC_ANW_type of
      'V' :
        begin

          case DEC_ASM_type of

            AT_byte, AT_char :
              begin
                STM_LISTE[STM_LISTE_counter].Bemerkung:='; DEC('+DEC_VAR_NAME+') - Byte';
                STM_LISTE[STM_LISTE_counter].statement:=STM_LDS;
                STM_LISTE[STM_LISTE_counter].Parameter1:=DEC_VAR_NAME;
                STM_LISTE[STM_LISTE_counter].Parameter2:='R16';
                Inc_STM_TAB_counter;
                STM_LISTE[STM_LISTE_counter].statement:=STM_DEC_byte;
                STM_LISTE[STM_LISTE_counter].Parameter1:='R16';
                Inc_STM_TAB_counter;
                STM_LISTE[STM_LISTE_counter].statement:=STM_STS;
                STM_LISTE[STM_LISTE_counter].Parameter1:='R16';
                STM_LISTE[STM_LISTE_counter].Parameter2:=DEC_VAR_NAME;
                Inc_STM_TAB_counter;
              end; { AT_byte }

            AT_word :
              begin
                STM_LISTE[STM_LISTE_counter].Bemerkung:='; DEC('+DEC_VAR_NAME+') - Word';
                STM_LISTE[STM_LISTE_counter].statement:=STM_LDS;
                STM_LISTE[STM_LISTE_counter].Parameter1:=DEC_VAR_NAME;
                STM_LISTE[STM_LISTE_counter].Parameter2:='R24';
                Inc_STM_TAB_counter;
                STM_LISTE[STM_LISTE_counter].statement:=STM_LDS;
                STM_LISTE[STM_LISTE_counter].Parameter1:=DEC_VAR_NAME+'+1';
                STM_LISTE[STM_LISTE_counter].Parameter2:='R25';
                Inc_STM_TAB_counter;
                STM_LISTE[STM_LISTE_counter].statement:=STM_SBIW_1;
                STM_LISTE[STM_LISTE_counter].Parameter2:='R25';
                STM_LISTE[STM_LISTE_counter].Parameter1:='R24';
                Inc_STM_TAB_counter;
                STM_LISTE[STM_LISTE_counter].statement:=STM_STS;
                STM_LISTE[STM_LISTE_counter].Parameter1:='R24';
                STM_LISTE[STM_LISTE_counter].Parameter2:=DEC_VAR_NAME;
                Inc_STM_TAB_counter;
                STM_LISTE[STM_LISTE_counter].statement:=STM_STS;
                STM_LISTE[STM_LISTE_counter].Parameter1:='R25';
                STM_LISTE[STM_LISTE_counter].Parameter2:=DEC_VAR_NAME+'+1';
                Inc_STM_TAB_counter;
              end; { AT_word }

            AT_dword :
              begin

                STM_LISTE[STM_LISTE_counter].Bemerkung:='; DEC('+DEC_VAR_NAME+') - DWord';
                STM_LISTE[STM_LISTE_counter].statement:=STM_LDS;
                STM_LISTE[STM_LISTE_counter].Parameter1:=DEC_VAR_NAME;
                STM_LISTE[STM_LISTE_counter].Parameter2:='R16';
                Inc_STM_TAB_counter;
                STM_LISTE[STM_LISTE_counter].statement:=STM_LDS;
                STM_LISTE[STM_LISTE_counter].Parameter1:=DEC_VAR_NAME+'+1';
                STM_LISTE[STM_LISTE_counter].Parameter2:='R17';
                Inc_STM_TAB_counter;
                STM_LISTE[STM_LISTE_counter].statement:=STM_LDS;
                STM_LISTE[STM_LISTE_counter].Parameter1:=DEC_VAR_NAME+'+2';
                STM_LISTE[STM_LISTE_counter].Parameter2:='R18';
                Inc_STM_TAB_counter;
                STM_LISTE[STM_LISTE_counter].statement:=STM_LDS;
                STM_LISTE[STM_LISTE_counter].Parameter1:=DEC_VAR_NAME+'+3';
                STM_LISTE[STM_LISTE_counter].Parameter2:='R19';
                Inc_STM_TAB_counter;
                STM_LISTE[STM_LISTE_counter].statement:=STM_DEC_dword;
                Inc_STM_TAB_counter;
                STM_LISTE[STM_LISTE_counter].statement:=STM_STS;
                STM_LISTE[STM_LISTE_counter].Parameter1:='R16';
                STM_LISTE[STM_LISTE_counter].Parameter2:=DEC_VAR_NAME;
                Inc_STM_TAB_counter;
                STM_LISTE[STM_LISTE_counter].statement:=STM_STS;
                STM_LISTE[STM_LISTE_counter].Parameter1:='R17';
                STM_LISTE[STM_LISTE_counter].Parameter2:=DEC_VAR_NAME+'+1';
                Inc_STM_TAB_counter;
                STM_LISTE[STM_LISTE_counter].statement:=STM_STS;
                STM_LISTE[STM_LISTE_counter].Parameter1:='R18';
                STM_LISTE[STM_LISTE_counter].Parameter2:=DEC_VAR_NAME+'+2';
                Inc_STM_TAB_counter;
                STM_LISTE[STM_LISTE_counter].statement:=STM_STS;
                STM_LISTE[STM_LISTE_counter].Parameter1:='R19';
                STM_LISTE[STM_LISTE_counter].Parameter2:=DEC_VAR_NAME+'+3';
                Inc_STM_TAB_counter;
              end; { AT_dword }

          else
            Fehler_cl.Registrieren('ZwischenCode/DEC_var_lesen',
                                   'DEC kann nur fuer Byte-, Word- oder DWord-Variablen genutzt werden',
                                   Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                                   Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                                   Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

          end; { case DEC_ASM_type of }

      end; { 'V' }



      'L','D' :
        begin

          lok_PAR_Pos:=lokalen_Parameter_suchen(DEC_VAR_NAME);

          case DEC_ASM_type of

            AT_byte, AT_char :
              begin
                STM_LISTE[STM_LISTE_counter].Bemerkung:='; DEC('+DEC_VAR_NAME+') - Byte';

                STM_LISTE[STM_LISTE_counter].statement:=STM_DEC_byte;
                STM_LISTE[STM_LISTE_counter].Parameter1:=
                         PROC_LIS.LISTE[PROC_LIS.counter].PPR_ARR[lok_PAR_Pos].Register_L;
                Inc_STM_TAB_counter;

              end; { AT_byte }

            AT_word :
              begin
                STM_LISTE[STM_LISTE_counter].Bemerkung:='; DEC('+DEC_VAR_NAME+') - Word';


                if ASM_Switch.use_MOVW then begin

                  STM_LISTE[STM_LISTE_counter].statement:=STM_MOVW;
                  STM_LISTE[STM_LISTE_counter].parameter1:=
                           PROC_LIS.LISTE[PROC_LIS.counter].PPR_ARR[lok_PAR_Pos].Register_H+':'+
                           PROC_LIS.LISTE[PROC_LIS.counter].PPR_ARR[lok_PAR_Pos].Register_L;
                  STM_LISTE[STM_LISTE_counter].parameter2:='R25:R24';
                  Inc_STM_TAB_counter;

                end
                else begin

                  STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
                  STM_LISTE[STM_LISTE_counter].parameter1:=
                           PROC_LIS.LISTE[PROC_LIS.counter].PPR_ARR[lok_PAR_Pos].Register_L;
                  STM_LISTE[STM_LISTE_counter].parameter2:='R24';
                  Inc_STM_TAB_counter;
                  STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
                  STM_LISTE[STM_LISTE_counter].parameter1:=
                           PROC_LIS.LISTE[PROC_LIS.counter].PPR_ARR[lok_PAR_Pos].Register_H;
                  STM_LISTE[STM_LISTE_counter].parameter2:='R25';
                  Inc_STM_TAB_counter;

                end; { if use_MOVW then }

                STM_LISTE[STM_LISTE_counter].statement:=STM_SBIW_1;
                STM_LISTE[STM_LISTE_counter].parameter2:='R25';
                STM_LISTE[STM_LISTE_counter].parameter1:='R24';
                Inc_STM_TAB_counter;

                if ASM_Switch.use_MOVW then begin

                  STM_LISTE[STM_LISTE_counter].statement:=STM_MOVW;
                  STM_LISTE[STM_LISTE_counter].parameter2:=
                           PROC_LIS.LISTE[PROC_LIS.counter].PPR_ARR[lok_PAR_Pos].Register_H+':'+
                           PROC_LIS.LISTE[PROC_LIS.counter].PPR_ARR[lok_PAR_Pos].Register_L;
                  STM_LISTE[STM_LISTE_counter].parameter1:='R25:R24';
                  Inc_STM_TAB_counter;

                end
                else begin

                  STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
                  STM_LISTE[STM_LISTE_counter].parameter2:=
                           PROC_LIS.LISTE[PROC_LIS.counter].PPR_ARR[lok_PAR_Pos].Register_L;
                  STM_LISTE[STM_LISTE_counter].parameter1:='R24';
                  Inc_STM_TAB_counter;
                  STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
                  STM_LISTE[STM_LISTE_counter].parameter2:=
                           PROC_LIS.LISTE[PROC_LIS.counter].PPR_ARR[lok_PAR_Pos].Register_H;
                  STM_LISTE[STM_LISTE_counter].parameter1:='R25';
                  Inc_STM_TAB_counter;

                end; { if use_MOVW then }

              end; { AT_word }

            AT_dword :
              begin

                STM_LISTE[STM_LISTE_counter].Bemerkung:='; DEC('+DEC_VAR_NAME+') - DWord';

                STM_LISTE[STM_LISTE_counter].statement:=STM_DEC_dword_l1;
                STM_LISTE[STM_LISTE_counter].Parameter1:=
                  PROC_LIS.LISTE[PROC_LIS.counter].PPR_ARR[lok_PAR_Pos].Register_L;
                STM_LISTE[STM_LISTE_counter].Parameter2:=
                  PROC_LIS.LISTE[PROC_LIS.counter].PPR_ARR[lok_PAR_Pos].Register_H;
                Inc_STM_TAB_counter;
                STM_LISTE[STM_LISTE_counter].statement:=STM_DEC_dword_l2;
                STM_LISTE[STM_LISTE_counter].Parameter1:=
                  PROC_LIS.LISTE[PROC_LIS.counter].PPR_ARR[lok_PAR_Pos].Register_LH;
                STM_LISTE[STM_LISTE_counter].Parameter2:=
                  PROC_LIS.LISTE[PROC_LIS.counter].PPR_ARR[lok_PAR_Pos].Register_HH;
                Inc_STM_TAB_counter;

              end; { AT_dword }




          else
            Fehler_cl.Registrieren('ZwischenCode/DEC_var_lesen',
                                   'DEC kann nur fuer Byte-, Word- oder DWord-Variablen genutzt werden',
                                   Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                                   Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                                   Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

          end; { case DEC_ASM_type of }

      end; { 'L','D' }

    else
      Fehler_cl.Registrieren('ZwischenCode/DEC_var_lesen',
                             'Es koennen nur Variablen dekrementiert werden',
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

    end; { case DEC_ANW_type of }


    DEC_erfolgreich:=true;


  end { if NAME_TO_ANW_und_ASM(DEC_VAR_NAME,DEC_ANW_type,DEC_ASM_type) then }
  else
    Fehler_cl.Registrieren('ZwischenCode/DEC_var_lesen',
                           'Name <'+DEC_VAR_NAME+'> der DEC-Variablen konnte nicht gefunden werden',
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);


  Result:=DEC_erfolgreich;
end; { function ZWC_class.DEC_var_lesen }






function ZWC_class.SHL_var_lesen(SHL_VAR_NAME : String) : Boolean;
var
  SHL_erfolgreich : Boolean;
  SHL_ANW_type : Char;
  SHL_ASM_type : ASM_type_Typ;
  lok_PAR_Pos : Integer;
begin
  SHL_erfolgreich:=false;

  if NAME_TO_ANW_und_ASM(SHL_VAR_NAME,SHL_ANW_type,SHL_ASM_type) then begin

    case SHL_ANW_type of
      'V' :
        begin

          case SHL_ASM_type of

            AT_byte :
              begin
                STM_LISTE[STM_LISTE_counter].Bemerkung:='; SHL('+SHL_VAR_NAME+') - Byte';
                STM_LISTE[STM_LISTE_counter].statement:=STM_LDS;
                STM_LISTE[STM_LISTE_counter].Parameter1:=SHL_VAR_NAME;
                STM_LISTE[STM_LISTE_counter].Parameter2:='R16';
                Inc_STM_TAB_counter;
                STM_LISTE[STM_LISTE_counter].statement:=STM_LSL;
                STM_LISTE[STM_LISTE_counter].Parameter1:='R16';
                Inc_STM_TAB_counter;
                STM_LISTE[STM_LISTE_counter].statement:=STM_STS;
                STM_LISTE[STM_LISTE_counter].Parameter1:='R16';
                STM_LISTE[STM_LISTE_counter].Parameter2:=SHL_VAR_NAME;
                Inc_STM_TAB_counter;
              end; { AT_byte }

            AT_word :
              begin
                STM_LISTE[STM_LISTE_counter].Bemerkung:='; SHL('+SHL_VAR_NAME+') - Word';
                STM_LISTE[STM_LISTE_counter].statement:=STM_LDS;
                STM_LISTE[STM_LISTE_counter].Parameter1:=SHL_VAR_NAME;
                STM_LISTE[STM_LISTE_counter].Parameter2:='R16';
                Inc_STM_TAB_counter;
                STM_LISTE[STM_LISTE_counter].statement:=STM_LDS;
                STM_LISTE[STM_LISTE_counter].Parameter1:=SHL_VAR_NAME+'+1';
                STM_LISTE[STM_LISTE_counter].Parameter2:='R17';
                Inc_STM_TAB_counter;
                STM_LISTE[STM_LISTE_counter].statement:=STM_SHL_word;
                STM_LISTE[STM_LISTE_counter].Parameter1:='R16';
                STM_LISTE[STM_LISTE_counter].Parameter2:='R17';
                Inc_STM_TAB_counter;
                STM_LISTE[STM_LISTE_counter].statement:=STM_STS;
                STM_LISTE[STM_LISTE_counter].Parameter1:='R16';
                STM_LISTE[STM_LISTE_counter].Parameter2:=SHL_VAR_NAME;
                Inc_STM_TAB_counter;
                STM_LISTE[STM_LISTE_counter].statement:=STM_STS;
                STM_LISTE[STM_LISTE_counter].Parameter1:='R17';
                STM_LISTE[STM_LISTE_counter].Parameter2:=SHL_VAR_NAME+'+1';
                Inc_STM_TAB_counter;
              end; { AT_word }

            AT_dword :
              begin
                STM_LISTE[STM_LISTE_counter].Bemerkung:='; SHL('+SHL_VAR_NAME+') - DWord';
                STM_LISTE[STM_LISTE_counter].statement:=STM_LDS;
                STM_LISTE[STM_LISTE_counter].Parameter1:=SHL_VAR_NAME;
                STM_LISTE[STM_LISTE_counter].Parameter2:='R16';
                Inc_STM_TAB_counter;
                STM_LISTE[STM_LISTE_counter].statement:=STM_LDS;
                STM_LISTE[STM_LISTE_counter].Parameter1:=SHL_VAR_NAME+'+1';
                STM_LISTE[STM_LISTE_counter].Parameter2:='R17';
                Inc_STM_TAB_counter;
                STM_LISTE[STM_LISTE_counter].statement:=STM_LDS;
                STM_LISTE[STM_LISTE_counter].Parameter1:=SHL_VAR_NAME+'+2';
                STM_LISTE[STM_LISTE_counter].Parameter2:='R18';
                Inc_STM_TAB_counter;
                STM_LISTE[STM_LISTE_counter].statement:=STM_LDS;
                STM_LISTE[STM_LISTE_counter].Parameter1:=SHL_VAR_NAME+'+3';
                STM_LISTE[STM_LISTE_counter].Parameter2:='R19';
                Inc_STM_TAB_counter;

                STM_LISTE[STM_LISTE_counter].statement:=STM_LSL;
                STM_LISTE[STM_LISTE_counter].Parameter1:='R16';
                Inc_STM_TAB_counter;
                STM_LISTE[STM_LISTE_counter].statement:=STM_ROL;
                STM_LISTE[STM_LISTE_counter].Parameter1:='R17';
                Inc_STM_TAB_counter;
                STM_LISTE[STM_LISTE_counter].statement:=STM_ROL;
                STM_LISTE[STM_LISTE_counter].Parameter1:='R18';
                Inc_STM_TAB_counter;
                STM_LISTE[STM_LISTE_counter].statement:=STM_ROL;
                STM_LISTE[STM_LISTE_counter].Parameter1:='R19';
                Inc_STM_TAB_counter;

                STM_LISTE[STM_LISTE_counter].statement:=STM_STS;
                STM_LISTE[STM_LISTE_counter].Parameter1:='R16';
                STM_LISTE[STM_LISTE_counter].Parameter2:=SHL_VAR_NAME;
                Inc_STM_TAB_counter;
                STM_LISTE[STM_LISTE_counter].statement:=STM_STS;
                STM_LISTE[STM_LISTE_counter].Parameter1:='R17';
                STM_LISTE[STM_LISTE_counter].Parameter2:=SHL_VAR_NAME+'+1';
                Inc_STM_TAB_counter;
                STM_LISTE[STM_LISTE_counter].statement:=STM_STS;
                STM_LISTE[STM_LISTE_counter].Parameter1:='R18';
                STM_LISTE[STM_LISTE_counter].Parameter2:=SHL_VAR_NAME+'+2';
                Inc_STM_TAB_counter;
                STM_LISTE[STM_LISTE_counter].statement:=STM_STS;
                STM_LISTE[STM_LISTE_counter].Parameter1:='R19';
                STM_LISTE[STM_LISTE_counter].Parameter2:=SHL_VAR_NAME+'+3';
                Inc_STM_TAB_counter;
              end; { AT_dword }


          else
            Fehler_cl.Registrieren('ZwischenCode/SHL_var_lesen',
                                   'SHL kann nur fuer Byte-, Word- oder DWord-Variablen genutzt werden',
                                   Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                                   Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                                   Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);
          end; { case INC_ASM_type of }
      end; { 'V' }



      'L','D' :
        begin

          lok_PAR_Pos:=lokalen_Parameter_suchen(SHL_VAR_NAME);

          case SHL_ASM_type of

            AT_byte :
              begin
                STM_LISTE[STM_LISTE_counter].Bemerkung:='; SHL('+SHL_VAR_NAME+') - Byte';

                STM_LISTE[STM_LISTE_counter].statement:=STM_LSL;
                STM_LISTE[STM_LISTE_counter].Parameter1:=
                         PROC_LIS.LISTE[PROC_LIS.counter].PPR_ARR[lok_PAR_Pos].Register_L;
                Inc_STM_TAB_counter;

              end; { AT_byte }


            AT_word :
              begin
                STM_LISTE[STM_LISTE_counter].Bemerkung:='; SHL('+SHL_VAR_NAME+') - Word';

                STM_LISTE[STM_LISTE_counter].statement:=STM_SHL_word;
                STM_LISTE[STM_LISTE_counter].Parameter1:=
                         PROC_LIS.LISTE[PROC_LIS.counter].PPR_ARR[lok_PAR_Pos].Register_L;
                STM_LISTE[STM_LISTE_counter].Parameter2:=
                         PROC_LIS.LISTE[PROC_LIS.counter].PPR_ARR[lok_PAR_Pos].Register_H;
                Inc_STM_TAB_counter;

              end; { AT_word }


            AT_dword :
              begin
                STM_LISTE[STM_LISTE_counter].Bemerkung:='; SHL('+SHL_VAR_NAME+') - DWord';

                STM_LISTE[STM_LISTE_counter].statement:=STM_LSL;
                STM_LISTE[STM_LISTE_counter].Parameter1:=
                         PROC_LIS.LISTE[PROC_LIS.counter].PPR_ARR[lok_PAR_Pos].Register_L;
                Inc_STM_TAB_counter;

                STM_LISTE[STM_LISTE_counter].statement:=STM_ROL;
                STM_LISTE[STM_LISTE_counter].Parameter1:=
                         PROC_LIS.LISTE[PROC_LIS.counter].PPR_ARR[lok_PAR_Pos].Register_H;
                Inc_STM_TAB_counter;

                STM_LISTE[STM_LISTE_counter].statement:=STM_ROL;
                STM_LISTE[STM_LISTE_counter].Parameter1:=
                         PROC_LIS.LISTE[PROC_LIS.counter].PPR_ARR[lok_PAR_Pos].Register_LH;
                Inc_STM_TAB_counter;

                STM_LISTE[STM_LISTE_counter].statement:=STM_ROL;
                STM_LISTE[STM_LISTE_counter].Parameter1:=
                         PROC_LIS.LISTE[PROC_LIS.counter].PPR_ARR[lok_PAR_Pos].Register_HH;
                Inc_STM_TAB_counter;

              end; { AT_dword }

          else
            Fehler_cl.Registrieren('ZwischenCode/SHL_var_lesen',
                                   'SHL kann nur fuer Byte-, Word- oder DWord-Variablen genutzt werden',
                                   Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                                   Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                                   Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

          end; { case SHL_ASM_type of }

      end; { 'L','D' }


    else
      Fehler_cl.Registrieren('ZwischenCode/SHL_var_lesen',
                             'Es koennen nur Variablen geschiftet werden',
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

    end; { case SHR_ANW_type of }


    SHL_erfolgreich:=true;


  end { if NAME_TO_ANW_und_ASM(SHL_VAR_NAME,SHL_ANW_type,SHL_ASM_type) then }
  else
    Fehler_cl.Registrieren('ZwischenCode/SHL_var_lesen',
                           'Name <'+SHL_VAR_NAME+'> der SHL-Variablen konnte nicht gefunden werden',
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);


  Result:=SHL_erfolgreich;
end; { function ZWC_class.SHL_var_lesen }






function ZWC_class.SHR_var_lesen(SHR_VAR_NAME : String) : Boolean;
var
  SHR_erfolgreich : Boolean;
  SHR_ANW_type : Char;
  SHR_ASM_type : ASM_type_Typ;
  lok_PAR_Pos : Integer;
begin
  SHR_erfolgreich:=false;

  if NAME_TO_ANW_und_ASM(SHR_VAR_NAME,SHR_ANW_type,SHR_ASM_type) then begin

    case SHR_ANW_type of
      'V' :
        begin

          case SHR_ASM_type of

            AT_byte :
              begin
                STM_LISTE[STM_LISTE_counter].Bemerkung:='; SHR('+SHR_VAR_NAME+') - Byte';
                STM_LISTE[STM_LISTE_counter].statement:=STM_LDS;
                STM_LISTE[STM_LISTE_counter].Parameter1:=SHR_VAR_NAME;
                STM_LISTE[STM_LISTE_counter].Parameter2:='R16';
                Inc_STM_TAB_counter;
                STM_LISTE[STM_LISTE_counter].statement:=STM_SHR_byte;
                STM_LISTE[STM_LISTE_counter].Parameter1:='R16';
                Inc_STM_TAB_counter;
                STM_LISTE[STM_LISTE_counter].statement:=STM_STS;
                STM_LISTE[STM_LISTE_counter].Parameter1:='R16';
                STM_LISTE[STM_LISTE_counter].Parameter2:=SHR_VAR_NAME;
                Inc_STM_TAB_counter;
              end; { AT_byte }

            AT_word :
              begin
                STM_LISTE[STM_LISTE_counter].Bemerkung:='; SHR('+SHR_VAR_NAME+') - Word';
                STM_LISTE[STM_LISTE_counter].statement:=STM_LDS;
                STM_LISTE[STM_LISTE_counter].Parameter1:=SHR_VAR_NAME;
                STM_LISTE[STM_LISTE_counter].Parameter2:='R16';
                Inc_STM_TAB_counter;
                STM_LISTE[STM_LISTE_counter].statement:=STM_LDS;
                STM_LISTE[STM_LISTE_counter].Parameter1:=SHR_VAR_NAME+'+1';
                STM_LISTE[STM_LISTE_counter].Parameter2:='R17';
                Inc_STM_TAB_counter;
                STM_LISTE[STM_LISTE_counter].statement:=STM_SHR_word;
                STM_LISTE[STM_LISTE_counter].Parameter1:='R17';
                STM_LISTE[STM_LISTE_counter].Parameter2:='R16';
                Inc_STM_TAB_counter;
                STM_LISTE[STM_LISTE_counter].statement:=STM_STS;
                STM_LISTE[STM_LISTE_counter].Parameter1:='R16';
                STM_LISTE[STM_LISTE_counter].Parameter2:=SHR_VAR_NAME;
                Inc_STM_TAB_counter;
                STM_LISTE[STM_LISTE_counter].statement:=STM_STS;
                STM_LISTE[STM_LISTE_counter].Parameter1:='R17';
                STM_LISTE[STM_LISTE_counter].Parameter2:=SHR_VAR_NAME+'+1';
                Inc_STM_TAB_counter;
              end; { AT_word }


            AT_dword :
              begin
                STM_LISTE[STM_LISTE_counter].Bemerkung:='; SHR('+SHR_VAR_NAME+') - DWord';
                STM_LISTE[STM_LISTE_counter].statement:=STM_LDS;
                STM_LISTE[STM_LISTE_counter].Parameter1:=SHR_VAR_NAME;
                STM_LISTE[STM_LISTE_counter].Parameter2:='R16';
                Inc_STM_TAB_counter;
                STM_LISTE[STM_LISTE_counter].statement:=STM_LDS;
                STM_LISTE[STM_LISTE_counter].Parameter1:=SHR_VAR_NAME+'+1';
                STM_LISTE[STM_LISTE_counter].Parameter2:='R17';
                Inc_STM_TAB_counter;
                STM_LISTE[STM_LISTE_counter].statement:=STM_LDS;
                STM_LISTE[STM_LISTE_counter].Parameter1:=SHR_VAR_NAME+'+2';
                STM_LISTE[STM_LISTE_counter].Parameter2:='R18';
                Inc_STM_TAB_counter;
                STM_LISTE[STM_LISTE_counter].statement:=STM_LDS;
                STM_LISTE[STM_LISTE_counter].Parameter1:=SHR_VAR_NAME+'+3';
                STM_LISTE[STM_LISTE_counter].Parameter2:='R19';
                Inc_STM_TAB_counter;

                STM_LISTE[STM_LISTE_counter].statement:=STM_LSR;
                STM_LISTE[STM_LISTE_counter].Parameter1:='R19';
                Inc_STM_TAB_counter;
                STM_LISTE[STM_LISTE_counter].statement:=STM_ROR;
                STM_LISTE[STM_LISTE_counter].Parameter1:='R18';
                Inc_STM_TAB_counter;
                STM_LISTE[STM_LISTE_counter].statement:=STM_ROR;
                STM_LISTE[STM_LISTE_counter].Parameter1:='R17';
                Inc_STM_TAB_counter;
                STM_LISTE[STM_LISTE_counter].statement:=STM_ROR;
                STM_LISTE[STM_LISTE_counter].Parameter1:='R16';
                Inc_STM_TAB_counter;

                STM_LISTE[STM_LISTE_counter].statement:=STM_STS;
                STM_LISTE[STM_LISTE_counter].Parameter1:='R16';
                STM_LISTE[STM_LISTE_counter].Parameter2:=SHR_VAR_NAME;
                Inc_STM_TAB_counter;
                STM_LISTE[STM_LISTE_counter].statement:=STM_STS;
                STM_LISTE[STM_LISTE_counter].Parameter1:='R17';
                STM_LISTE[STM_LISTE_counter].Parameter2:=SHR_VAR_NAME+'+1';
                Inc_STM_TAB_counter;
                STM_LISTE[STM_LISTE_counter].statement:=STM_STS;
                STM_LISTE[STM_LISTE_counter].Parameter1:='R18';
                STM_LISTE[STM_LISTE_counter].Parameter2:=SHR_VAR_NAME+'+2';
                Inc_STM_TAB_counter;
                STM_LISTE[STM_LISTE_counter].statement:=STM_STS;
                STM_LISTE[STM_LISTE_counter].Parameter1:='R19';
                STM_LISTE[STM_LISTE_counter].Parameter2:=SHR_VAR_NAME+'+3';
                Inc_STM_TAB_counter;
              end; { AT_dword }


          else
            Fehler_cl.Registrieren('ZwischenCode/SHR_var_lesen',
                                   'SHR kann nur fuer Byte-, Word- oder DWord-Variablen genutzt werden',
                                   Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                                   Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                                   Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

          end; { case SHR_ASM_type of }

      end; { 'V' }


      'L','D' :
        begin

          lok_PAR_Pos:=lokalen_Parameter_suchen(SHR_VAR_NAME);

          case SHR_ASM_type of

            AT_byte :
              begin
                STM_LISTE[STM_LISTE_counter].Bemerkung:='; SHR('+SHR_VAR_NAME+') - Byte';

                STM_LISTE[STM_LISTE_counter].statement:=STM_SHR_byte;
                STM_LISTE[STM_LISTE_counter].Parameter1:=
                         PROC_LIS.LISTE[PROC_LIS.counter].PPR_ARR[lok_PAR_Pos].Register_L;
                Inc_STM_TAB_counter;

              end; { AT_byte }

            AT_word :
              begin
                STM_LISTE[STM_LISTE_counter].Bemerkung:='; SHR('+SHR_VAR_NAME+') - Word';

                STM_LISTE[STM_LISTE_counter].statement:=STM_SHR_word;
                STM_LISTE[STM_LISTE_counter].Parameter1:=
                         PROC_LIS.LISTE[PROC_LIS.counter].PPR_ARR[lok_PAR_Pos].Register_H;
                STM_LISTE[STM_LISTE_counter].Parameter2:=
                         PROC_LIS.LISTE[PROC_LIS.counter].PPR_ARR[lok_PAR_Pos].Register_L;
                Inc_STM_TAB_counter;

              end; { AT_word }

            AT_dword :
              begin
                STM_LISTE[STM_LISTE_counter].Bemerkung:='; SHR('+SHR_VAR_NAME+') - DWord';

                STM_LISTE[STM_LISTE_counter].statement:=STM_LSR;
                STM_LISTE[STM_LISTE_counter].Parameter1:=
                         PROC_LIS.LISTE[PROC_LIS.counter].PPR_ARR[lok_PAR_Pos].Register_HH;
                Inc_STM_TAB_counter;

                STM_LISTE[STM_LISTE_counter].statement:=STM_ROR;
                STM_LISTE[STM_LISTE_counter].Parameter1:=
                         PROC_LIS.LISTE[PROC_LIS.counter].PPR_ARR[lok_PAR_Pos].Register_LH;
                Inc_STM_TAB_counter;

                STM_LISTE[STM_LISTE_counter].statement:=STM_ROR;
                STM_LISTE[STM_LISTE_counter].Parameter1:=
                         PROC_LIS.LISTE[PROC_LIS.counter].PPR_ARR[lok_PAR_Pos].Register_H;
                Inc_STM_TAB_counter;

                STM_LISTE[STM_LISTE_counter].statement:=STM_ROR;
                STM_LISTE[STM_LISTE_counter].Parameter1:=
                         PROC_LIS.LISTE[PROC_LIS.counter].PPR_ARR[lok_PAR_Pos].Register_L;
                Inc_STM_TAB_counter;

              end; { AT_dword }


          else
            Fehler_cl.Registrieren('ZwischenCode/SHR_var_lesen',
                                   'SHR kann nur fuer Byte-, Word- oder DWord-Variablen genutzt werden',
                                   Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                                   Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                                   Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

          end; { case SHR_ASM_type of }

      end; { 'L','D' }


    else
      Fehler_cl.Registrieren('ZwischenCode/SHR_var_lesen',
                             'Es koennen nur Variablen geschiftet werden',
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

    end; { case SHR_ANW_type of }


    SHR_erfolgreich:=true;


  end { if NAME_TO_ANW_und_ASM(SHR_VAR_NAME,SHR_ANW_type,SHR_ASM_type) then }
  else
    Fehler_cl.Registrieren('ZwischenCode/SHR_var_lesen',
                           'Name <'+SHR_VAR_NAME+'> der SHR-Variablen konnte nicht gefunden werden',
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

  Result:=SHR_erfolgreich;
end; { function ZWC_class.SHR_var_lesen }










function ZWC_class.SETBIT_var_lesen(SETBIT_VAR_NAME : String) : Boolean;
var
  SB_erfolgreich : Boolean;
  SB_ANW_type, SB_VAR_ANW_type : Char;
  SB_ASM_type, SB_VAR_ASM_type : ASM_type_Typ;
  SB_Pos : Integer;
begin
  SB_erfolgreich:=false;

  if NAME_TO_ANW_und_ASM(SETBIT_VAR_NAME,SB_ANW_type,SB_ASM_type) then begin

    if (SB_ANW_type='B') then begin

      SB_Pos:=BIT_LIS_suchen(SETBIT_VAR_NAME);
      SB_VAR_ASM_type:=BIT_LIS.LISTE[SB_Pos].ASM_type;
      SB_VAR_ANW_type:=BIT_LIS.LISTE[SB_Pos].ANW_Type;

      STM_LISTE[STM_LISTE_counter].Bemerkung:='; SetBit('+SETBIT_VAR_NAME+')';

      if SB_VAR_ANW_type='V' then begin

        case SB_VAR_ASM_type of
          AT_byte_con_reg :
            begin
              STM_LISTE[STM_LISTE_counter].statement:=STM_SBI;
              STM_LISTE[STM_LISTE_counter].Parameter1:=IntToStr(BIT_LIS.LISTE[SB_Pos].Bit_Position);
              STM_LISTE[STM_LISTE_counter].Parameter2:=BIT_LIS.LISTE[SB_Pos].VAR_REG;
              Inc_STM_TAB_counter;
            end; { AT_byte_con_reg }

          AT_word_con_reg :
            begin
              if BIT_LIS.LISTE[SB_Pos].Bit_Position<8 then begin
                STM_LISTE[STM_LISTE_counter].statement:=STM_SBI;
                STM_LISTE[STM_LISTE_counter].Parameter1:=IntToStr(BIT_LIS.LISTE[SB_Pos].Bit_Position);
                STM_LISTE[STM_LISTE_counter].Parameter2:=BIT_LIS.LISTE[SB_Pos].VAR_REG;
                Inc_STM_TAB_counter;
              end
              else begin

                STM_LISTE[STM_LISTE_counter].statement:=STM_IN_word_H;
                STM_LISTE[STM_LISTE_counter].Parameter1:=BIT_LIS.LISTE[SB_Pos].VAR_REG;
                STM_LISTE[STM_LISTE_counter].Parameter2:='R17';
                Inc_STM_TAB_counter;

                STM_LISTE[STM_LISTE_counter].statement:=STM_SBR;
                STM_LISTE[STM_LISTE_counter].Parameter1:=BIT_TO_ByteMaske(BIT_LIS.LISTE[SB_Pos].Bit_Position-8);
                STM_LISTE[STM_LISTE_counter].Parameter2:='R16';
                Inc_STM_TAB_counter;

                STM_LISTE[STM_LISTE_counter].Statement:=STM_OUT;
                STM_LISTE[STM_LISTE_counter].Parameter2:=BIT_LIS.LISTE[SB_Pos].VAR_REG+'+1';
                STM_LISTE[STM_LISTE_counter].Parameter1:='R17';
                Inc_STM_TAB_counter;

              end; { if BIT_LIS.LISTE[SB_Pos].Bit_Position<8 then }

            end; { AT_word_con_reg }


          AT_byte, AT_byte_con_var :
            begin
              STM_LISTE[STM_LISTE_counter].statement:=STM_LDS;
              STM_LISTE[STM_LISTE_counter].Parameter1:=BIT_LIS.LISTE[SB_Pos].VAR_REG;
              STM_LISTE[STM_LISTE_counter].Parameter2:='R16';
              Inc_STM_TAB_counter;

              STM_LISTE[STM_LISTE_counter].statement:=STM_SBR;
              STM_LISTE[STM_LISTE_counter].Parameter1:=BIT_TO_ByteMaske(BIT_LIS.LISTE[SB_Pos].Bit_Position);
              STM_LISTE[STM_LISTE_counter].Parameter2:='R16';
              Inc_STM_TAB_counter;

              STM_LISTE[STM_LISTE_counter].statement:=STM_STS;
              STM_LISTE[STM_LISTE_counter].Parameter1:='R16';
              STM_LISTE[STM_LISTE_counter].Parameter2:=BIT_LIS.LISTE[SB_Pos].VAR_REG;
              Inc_STM_TAB_counter;
            end; { AT_byte }



          AT_word, AT_word_con_var :
            begin
              if BIT_LIS.LISTE[SB_Pos].Bit_Position<8 then begin

                STM_LISTE[STM_LISTE_counter].statement:=STM_LDS;
                STM_LISTE[STM_LISTE_counter].Parameter1:=BIT_LIS.LISTE[SB_Pos].VAR_REG;
                STM_LISTE[STM_LISTE_counter].Parameter2:='R16';
                Inc_STM_TAB_counter;

                STM_LISTE[STM_LISTE_counter].statement:=STM_SBR;
                STM_LISTE[STM_LISTE_counter].Parameter1:=BIT_TO_ByteMaske(BIT_LIS.LISTE[SB_Pos].Bit_Position);
                STM_LISTE[STM_LISTE_counter].Parameter2:='R16';
                Inc_STM_TAB_counter;

                STM_LISTE[STM_LISTE_counter].statement:=STM_STS;
                STM_LISTE[STM_LISTE_counter].Parameter1:='R16';
                STM_LISTE[STM_LISTE_counter].Parameter2:=BIT_LIS.LISTE[SB_Pos].VAR_REG;
                Inc_STM_TAB_counter;

              end
              else begin

                STM_LISTE[STM_LISTE_counter].statement:=STM_LDS;
                STM_LISTE[STM_LISTE_counter].Parameter1:=BIT_LIS.LISTE[SB_Pos].VAR_REG+'+1';
                STM_LISTE[STM_LISTE_counter].Parameter2:='R16';
                Inc_STM_TAB_counter;

                STM_LISTE[STM_LISTE_counter].statement:=STM_SBR;
                STM_LISTE[STM_LISTE_counter].Parameter1:=BIT_TO_ByteMaske(BIT_LIS.LISTE[SB_Pos].Bit_Position-8);
                STM_LISTE[STM_LISTE_counter].Parameter2:='R16';
                Inc_STM_TAB_counter;

                STM_LISTE[STM_LISTE_counter].statement:=STM_STS;
                STM_LISTE[STM_LISTE_counter].Parameter1:='R16';
                STM_LISTE[STM_LISTE_counter].Parameter2:=BIT_LIS.LISTE[SB_Pos].VAR_REG+'+1';
                Inc_STM_TAB_counter;

              end;
            end; { AT_word }


          AT_dword :
            begin
              case BIT_LIS.LISTE[SB_Pos].Bit_Position of
                0..7 : begin
                       STM_LISTE[STM_LISTE_counter].statement:=STM_LDS;
                       STM_LISTE[STM_LISTE_counter].Parameter1:=BIT_LIS.LISTE[SB_Pos].VAR_REG;
                       STM_LISTE[STM_LISTE_counter].Parameter2:='R16';
                       Inc_STM_TAB_counter;

                       STM_LISTE[STM_LISTE_counter].statement:=STM_SBR;
                       STM_LISTE[STM_LISTE_counter].Parameter1:=
                                   BIT_TO_ByteMaske(BIT_LIS.LISTE[SB_Pos].Bit_Position);
                       STM_LISTE[STM_LISTE_counter].Parameter2:='R16';
                       Inc_STM_TAB_counter;

                       STM_LISTE[STM_LISTE_counter].statement:=STM_STS;
                       STM_LISTE[STM_LISTE_counter].Parameter1:='R16';
                       STM_LISTE[STM_LISTE_counter].Parameter2:=BIT_LIS.LISTE[SB_Pos].VAR_REG;
                       Inc_STM_TAB_counter;
                     end; { 0..7 }


              8..15 : begin
                     STM_LISTE[STM_LISTE_counter].statement:=STM_LDS;
                     STM_LISTE[STM_LISTE_counter].Parameter1:=BIT_LIS.LISTE[SB_Pos].VAR_REG+'+1';
                     STM_LISTE[STM_LISTE_counter].Parameter2:='R16';
                     Inc_STM_TAB_counter;

                     STM_LISTE[STM_LISTE_counter].statement:=STM_SBR;
                     STM_LISTE[STM_LISTE_counter].Parameter1:=
                                 BIT_TO_ByteMaske(BIT_LIS.LISTE[SB_Pos].Bit_Position-8);
                     STM_LISTE[STM_LISTE_counter].Parameter2:='R16';
                     Inc_STM_TAB_counter;

                     STM_LISTE[STM_LISTE_counter].statement:=STM_STS;
                     STM_LISTE[STM_LISTE_counter].Parameter1:='R16';
                     STM_LISTE[STM_LISTE_counter].Parameter2:=BIT_LIS.LISTE[SB_Pos].VAR_REG+'+1';
                     Inc_STM_TAB_counter;
                   end; { 8..15 }

              16..23 : begin
                     STM_LISTE[STM_LISTE_counter].statement:=STM_LDS;
                     STM_LISTE[STM_LISTE_counter].Parameter1:=BIT_LIS.LISTE[SB_Pos].VAR_REG+'+2';
                     STM_LISTE[STM_LISTE_counter].Parameter2:='R16';
                     Inc_STM_TAB_counter;

                     STM_LISTE[STM_LISTE_counter].statement:=STM_SBR;
                     STM_LISTE[STM_LISTE_counter].Parameter1:=
                                 BIT_TO_ByteMaske(BIT_LIS.LISTE[SB_Pos].Bit_Position-16);
                     STM_LISTE[STM_LISTE_counter].Parameter2:='R16';
                     Inc_STM_TAB_counter;

                     STM_LISTE[STM_LISTE_counter].statement:=STM_STS;
                     STM_LISTE[STM_LISTE_counter].Parameter1:='R16';
                     STM_LISTE[STM_LISTE_counter].Parameter2:=BIT_LIS.LISTE[SB_Pos].VAR_REG+'+2';
                     Inc_STM_TAB_counter;
                   end; { 16..23 }

              24..31 : begin
                     STM_LISTE[STM_LISTE_counter].statement:=STM_LDS;
                     STM_LISTE[STM_LISTE_counter].Parameter1:=BIT_LIS.LISTE[SB_Pos].VAR_REG+'+3';
                     STM_LISTE[STM_LISTE_counter].Parameter2:='R16';
                     Inc_STM_TAB_counter;

                     STM_LISTE[STM_LISTE_counter].statement:=STM_SBR;
                     STM_LISTE[STM_LISTE_counter].Parameter1:=
                                 BIT_TO_ByteMaske(BIT_LIS.LISTE[SB_Pos].Bit_Position-24);
                     STM_LISTE[STM_LISTE_counter].Parameter2:='R16';
                     Inc_STM_TAB_counter;

                     STM_LISTE[STM_LISTE_counter].statement:=STM_STS;
                     STM_LISTE[STM_LISTE_counter].Parameter1:='R16';
                     STM_LISTE[STM_LISTE_counter].Parameter2:=BIT_LIS.LISTE[SB_Pos].VAR_REG+'+3';
                     Inc_STM_TAB_counter;
                   end; { 17..31 }

              else
                Fehler_cl.Registrieren('ZwischenCode/SETBIT_var_lesen',
                                 'SETBIT fuer <'+
                                 IntToStr(BIT_LIS.LISTE[SB_Pos].Bit_Position)+
                                 '> nicht programmiert',
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);
              end; { case BIT_LIS.LISTE[SB_Pos].Bit_Position of }


            end; { AT_dword }


        else
          Fehler_cl.Registrieren('ZwischenCode/SETBIT_var_lesen',
                                 'SETBIT fuer <'+
                                 Compiler_cl.ASM_type_Typ_in_Bezeichner(SB_VAR_ASM_type)+
                                 '> nicht programmiert',
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

        end; { case INC_ASM_type of }

        SB_erfolgreich:=true;

      end { if SB_VAR_ANW_type='V' then }
      else
        Fehler_cl.Registrieren('ZwischenCode/SETBIT_var_lesen',
                               'SETBIT ist nur fuer Register und globale Variablen programmiert',
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

    end { if (SB_ANW_type='B') then }
    else
      Fehler_cl.Registrieren('ZwischenCode/SETBIT_var_lesen',
                             'fuer SETBIT wird eine BIT-Variable benoetigt',
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);


  end { if NAME_TO_ANW_und_ASM(SETBIT_VAR_NAME,SB_ANW_type,SB_VAR_ASM_type) then }
  else
    Fehler_cl.Registrieren('ZwischenCode/SETBIT_var_lesen',
                           'Name <'+SETBIT_VAR_NAME+'> der SETBIT-Variablen konnte nicht gefunden werden',
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

  Result:=SB_erfolgreich;
end; { function ZWC_class.SETBIT_var_lesen }












function ZWC_class.CLEARBIT_var_lesen(CLEARBIT_VAR_NAME : String) : Boolean;
var
  CB_erfolgreich : Boolean;
  CB_ANW_type, CB_VAR_ANW_type : Char;
  CB_ASM_type, CB_VAR_ASM_type : ASM_type_Typ;
  CB_Pos : Integer;
begin
  CB_erfolgreich:=false;

  if NAME_TO_ANW_und_ASM(CLEARBIT_VAR_NAME,CB_ANW_type,CB_ASM_type) then begin

    if (CB_ANW_type='B') then begin

      CB_Pos:=BIT_LIS_suchen(CLEARBIT_VAR_NAME);
      CB_VAR_ASM_type:=BIT_LIS.LISTE[CB_Pos].ASM_type;
      CB_VAR_ANW_type:=BIT_LIS.LISTE[CB_Pos].ANW_Type;

      STM_LISTE[STM_LISTE_counter].Bemerkung:='; ClearBit('+CLEARBIT_VAR_NAME+')';

      if CB_VAR_ANW_type='V' then begin


        case CB_VAR_ASM_type of
          AT_byte_con_reg :
            begin
              STM_LISTE[STM_LISTE_counter].statement:=STM_CBI;
              STM_LISTE[STM_LISTE_counter].Parameter1:=IntToStr(BIT_LIS.LISTE[CB_Pos].Bit_Position);
              STM_LISTE[STM_LISTE_counter].Parameter2:=BIT_LIS.LISTE[CB_Pos].VAR_REG;
              Inc_STM_TAB_counter;
            end;
          AT_word_con_reg :
            begin
              if BIT_LIS.LISTE[CB_Pos].Bit_Position<8 then begin
                STM_LISTE[STM_LISTE_counter].statement:=STM_CBI;
                STM_LISTE[STM_LISTE_counter].Parameter1:=IntToStr(BIT_LIS.LISTE[CB_Pos].Bit_Position);
                STM_LISTE[STM_LISTE_counter].Parameter2:=BIT_LIS.LISTE[CB_Pos].VAR_REG;
                Inc_STM_TAB_counter;
              end
              else begin

                STM_LISTE[STM_LISTE_counter].statement:=STM_IN_word_H;
                STM_LISTE[STM_LISTE_counter].Parameter1:=BIT_LIS.LISTE[CB_Pos].VAR_REG;
                STM_LISTE[STM_LISTE_counter].Parameter2:='R17';
                Inc_STM_TAB_counter;

                STM_LISTE[STM_LISTE_counter].statement:=STM_CBR;
                STM_LISTE[STM_LISTE_counter].Parameter1:=BIT_TO_ByteMaske(BIT_LIS.LISTE[CB_Pos].Bit_Position-8);
                STM_LISTE[STM_LISTE_counter].Parameter2:='R16';
                Inc_STM_TAB_counter;

                STM_LISTE[STM_LISTE_counter].Statement:=STM_OUT;
                STM_LISTE[STM_LISTE_counter].Parameter2:=BIT_LIS.LISTE[CB_Pos].VAR_REG+'+1';
                STM_LISTE[STM_LISTE_counter].Parameter1:='R17';
                Inc_STM_TAB_counter;

              end; { if BIT_LIS.LISTE[CB_Pos].Bit_Position<8 then }

            end; { AT_word_con_reg }


          AT_byte, AT_byte_con_var :
            begin
              STM_LISTE[STM_LISTE_counter].statement:=STM_LDS;
              STM_LISTE[STM_LISTE_counter].Parameter1:=BIT_LIS.LISTE[CB_Pos].VAR_REG;
              STM_LISTE[STM_LISTE_counter].Parameter2:='R16';
              Inc_STM_TAB_counter;

              STM_LISTE[STM_LISTE_counter].statement:=STM_CBR;
              STM_LISTE[STM_LISTE_counter].Parameter1:=BIT_TO_ByteMaske(BIT_LIS.LISTE[CB_Pos].Bit_Position);
              STM_LISTE[STM_LISTE_counter].Parameter2:='R16';
              Inc_STM_TAB_counter;

              STM_LISTE[STM_LISTE_counter].statement:=STM_STS;
              STM_LISTE[STM_LISTE_counter].Parameter1:='R16';
              STM_LISTE[STM_LISTE_counter].Parameter2:=BIT_LIS.LISTE[CB_Pos].VAR_REG;
              Inc_STM_TAB_counter;
            end; { AT_byte }



          AT_word, AT_word_con_var :
            begin
              if BIT_LIS.LISTE[CB_Pos].Bit_Position<8 then begin

                STM_LISTE[STM_LISTE_counter].statement:=STM_LDS;
                STM_LISTE[STM_LISTE_counter].Parameter1:=BIT_LIS.LISTE[CB_Pos].VAR_REG;
                STM_LISTE[STM_LISTE_counter].Parameter2:='R16';
                Inc_STM_TAB_counter;

                STM_LISTE[STM_LISTE_counter].statement:=STM_CBR;
                STM_LISTE[STM_LISTE_counter].Parameter1:=BIT_TO_ByteMaske(BIT_LIS.LISTE[CB_Pos].Bit_Position);
                STM_LISTE[STM_LISTE_counter].Parameter2:='R16';
                Inc_STM_TAB_counter;

                STM_LISTE[STM_LISTE_counter].statement:=STM_STS;
                STM_LISTE[STM_LISTE_counter].Parameter1:='R16';
                STM_LISTE[STM_LISTE_counter].Parameter2:=BIT_LIS.LISTE[CB_Pos].VAR_REG;
                Inc_STM_TAB_counter;

              end
              else begin

                STM_LISTE[STM_LISTE_counter].statement:=STM_LDS;
                STM_LISTE[STM_LISTE_counter].Parameter1:=BIT_LIS.LISTE[CB_Pos].VAR_REG+'+1';
                STM_LISTE[STM_LISTE_counter].Parameter2:='R16';
                Inc_STM_TAB_counter;

                STM_LISTE[STM_LISTE_counter].statement:=STM_CBR;
                STM_LISTE[STM_LISTE_counter].Parameter1:=BIT_TO_ByteMaske(BIT_LIS.LISTE[CB_Pos].Bit_Position-8);
                STM_LISTE[STM_LISTE_counter].Parameter2:='R16';
                Inc_STM_TAB_counter;

                STM_LISTE[STM_LISTE_counter].statement:=STM_STS;
                STM_LISTE[STM_LISTE_counter].Parameter1:='R16';
                STM_LISTE[STM_LISTE_counter].Parameter2:=BIT_LIS.LISTE[CB_Pos].VAR_REG+'+1';
                Inc_STM_TAB_counter;

              end;
            end; { AT_word }






          AT_dword :
            begin
              case BIT_LIS.LISTE[CB_Pos].Bit_Position of
                0..7 : begin
                       STM_LISTE[STM_LISTE_counter].statement:=STM_LDS;
                       STM_LISTE[STM_LISTE_counter].Parameter1:=BIT_LIS.LISTE[CB_Pos].VAR_REG;
                       STM_LISTE[STM_LISTE_counter].Parameter2:='R16';
                       Inc_STM_TAB_counter;

                       STM_LISTE[STM_LISTE_counter].statement:=STM_CBR;
                       STM_LISTE[STM_LISTE_counter].Parameter1:=
                                   BIT_TO_ByteMaske(BIT_LIS.LISTE[CB_Pos].Bit_Position);
                       STM_LISTE[STM_LISTE_counter].Parameter2:='R16';
                       Inc_STM_TAB_counter;

                       STM_LISTE[STM_LISTE_counter].statement:=STM_STS;
                       STM_LISTE[STM_LISTE_counter].Parameter1:='R16';
                       STM_LISTE[STM_LISTE_counter].Parameter2:=BIT_LIS.LISTE[CB_Pos].VAR_REG;
                       Inc_STM_TAB_counter;
                     end; { 0..7 }


              8..15 : begin
                     STM_LISTE[STM_LISTE_counter].statement:=STM_LDS;
                     STM_LISTE[STM_LISTE_counter].Parameter1:=BIT_LIS.LISTE[CB_Pos].VAR_REG+'+1';
                     STM_LISTE[STM_LISTE_counter].Parameter2:='R16';
                     Inc_STM_TAB_counter;

                     STM_LISTE[STM_LISTE_counter].statement:=STM_CBR;
                     STM_LISTE[STM_LISTE_counter].Parameter1:=
                                 BIT_TO_ByteMaske(BIT_LIS.LISTE[CB_Pos].Bit_Position-8);
                     STM_LISTE[STM_LISTE_counter].Parameter2:='R16';
                     Inc_STM_TAB_counter;

                     STM_LISTE[STM_LISTE_counter].statement:=STM_STS;
                     STM_LISTE[STM_LISTE_counter].Parameter1:='R16';
                     STM_LISTE[STM_LISTE_counter].Parameter2:=BIT_LIS.LISTE[CB_Pos].VAR_REG+'+1';
                     Inc_STM_TAB_counter;
                   end; { 8..15 }

              16..23 : begin
                     STM_LISTE[STM_LISTE_counter].statement:=STM_LDS;
                     STM_LISTE[STM_LISTE_counter].Parameter1:=BIT_LIS.LISTE[CB_Pos].VAR_REG+'+2';
                     STM_LISTE[STM_LISTE_counter].Parameter2:='R16';
                     Inc_STM_TAB_counter;

                     STM_LISTE[STM_LISTE_counter].statement:=STM_CBR;
                     STM_LISTE[STM_LISTE_counter].Parameter1:=
                                 BIT_TO_ByteMaske(BIT_LIS.LISTE[CB_Pos].Bit_Position-16);
                     STM_LISTE[STM_LISTE_counter].Parameter2:='R16';
                     Inc_STM_TAB_counter;

                     STM_LISTE[STM_LISTE_counter].statement:=STM_STS;
                     STM_LISTE[STM_LISTE_counter].Parameter1:='R16';
                     STM_LISTE[STM_LISTE_counter].Parameter2:=BIT_LIS.LISTE[CB_Pos].VAR_REG+'+2';
                     Inc_STM_TAB_counter;
                   end; { 16..23 }

              24..31 : begin
                     STM_LISTE[STM_LISTE_counter].statement:=STM_LDS;
                     STM_LISTE[STM_LISTE_counter].Parameter1:=BIT_LIS.LISTE[CB_Pos].VAR_REG+'+3';
                     STM_LISTE[STM_LISTE_counter].Parameter2:='R16';
                     Inc_STM_TAB_counter;

                     STM_LISTE[STM_LISTE_counter].statement:=STM_CBR;
                     STM_LISTE[STM_LISTE_counter].Parameter1:=
                                 BIT_TO_ByteMaske(BIT_LIS.LISTE[CB_Pos].Bit_Position-24);
                     STM_LISTE[STM_LISTE_counter].Parameter2:='R16';
                     Inc_STM_TAB_counter;

                     STM_LISTE[STM_LISTE_counter].statement:=STM_STS;
                     STM_LISTE[STM_LISTE_counter].Parameter1:='R16';
                     STM_LISTE[STM_LISTE_counter].Parameter2:=BIT_LIS.LISTE[CB_Pos].VAR_REG+'+3';
                     Inc_STM_TAB_counter;
                   end; { 17..31 }


              else
                Fehler_cl.Registrieren('ZwischenCode/CLEARBIT_var_lesen',
                                 'CLEARBIT fuer <'+
                                 IntToStr(BIT_LIS.LISTE[CB_Pos].Bit_Position)+
                                 '> nicht programmiert',
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);
              end; { case BIT_LIS.LISTE[CB_Pos].Bit_Position of }

            end; { AT_dword }

        else
          Fehler_cl.Registrieren('ZwischenCode/CLEARBIT_var_lesen',
                                 'CLEARBIT fuer <'+
                                 Compiler_cl.ASM_type_Typ_in_Bezeichner(CB_VAR_ASM_type)+
                                 '> nicht programmiert',
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

        end; { case INC_ASM_type of }

        CB_erfolgreich:=true;


      end { if SB_VAR_ANW_type='V' then }
      else
        Fehler_cl.Registrieren('ZwischenCode/CLEARBIT_var_lesen',
                               'CLEARBIT ist nur fuer Register und globale Variablen programmiert',
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                               Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

    end { if (CB_ANW_type='B') then }
    else
      Fehler_cl.Registrieren('ZwischenCode/CLEARBIT_var_lesen',
                             'fuer CLEARBIT wird eine BIT-Variable benoetigt',
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);


  end { if NAME_TO_ANW_und_ASM(CLEARBIT_VAR_NAME,CB_ANW_type,CB_ASM_type) then }
  else
    Fehler_cl.Registrieren('ZwischenCode/CLEARBIT_var_lesen',
                           'Name <'+CLEARBIT_VAR_NAME+'> der CLEARBIT-Variablen konnte nicht gefunden werden',
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

  Result:=CB_erfolgreich;
end; { function ZWC_class.CLEARBIT_var_lesen }






procedure ZWC_class.NOP_schreiben;
begin
  STM_LISTE[STM_LISTE_counter].Bemerkung:='; NOP';
  STM_LISTE[STM_LISTE_counter].statement:=STM_NOP;
  Inc_STM_TAB_counter;
end; { procedure ZWC_class.NOP_schreiben }






// ********************************************
//               WHILE DO
// ********************************************





procedure ZWC_class.while_init;
begin

  Inc_ZUW_LIS_LISTcounter;

  ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_type:=AT_boolean;
  ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ASM_Grund_type:=AT_boolean;
  ZUW_LIS.LISTE[ZUW_LIS.LISTcounter].Ziel_ANW_type:='V';

  Inc_WHILE_LIS_counter;

  WHILE_LIS.LISTE[WHILE_LIS.counter].Vergleich_Marke:=erzeuge_Marke('WHILE');
  WHILE_LIS.LISTE[WHILE_LIS.counter].Start_Marke:=erzeuge_Marke('WHILE');
  WHILE_LIS.LISTE[WHILE_LIS.counter].Ende_Marke:=erzeuge_Marke('WHILE');


  STM_LISTE[STM_LISTE_counter].Bemerkung:='; WHILE DO ...';
  STM_LISTE[STM_LISTE_counter].statement:=STM_sprungmarke;
  STM_LISTE[STM_LISTE_counter].Parameter1:=WHILE_LIS.LISTE[WHILE_LIS.counter].Vergleich_Marke;
  Inc_STM_TAB_counter;


end; { procedure ZWC_class.while_init }




procedure ZWC_class.while_start;
begin

  Faktor_STM_TAB_eintragen('WHILE');

  STM_LISTE[STM_LISTE_counter].Bemerkung:='; WHILE - Vergleich';
  STM_LISTE[STM_LISTE_counter].statement:=STM_bo_cp;
  STM_LISTE[STM_LISTE_counter].Parameter1:=WHILE_LIS.LISTE[WHILE_LIS.counter].Start_Marke;
  STM_LISTE[STM_LISTE_counter].Parameter2:=WHILE_LIS.LISTE[WHILE_LIS.counter].Ende_Marke;
  Inc_STM_TAB_counter;

  // Loeschen aller Zwischenwerte der Zuweisung
  Ruecksetzen_Zuweisung;

end; { procedure ZWC_class.while_start }





procedure ZWC_class.while_end;
begin

  STM_LISTE[STM_LISTE_counter].Bemerkung:='; WHILE DO ...';
  STM_LISTE[STM_LISTE_counter].statement:=STM_RJMP_Marke;
  STM_LISTE[STM_LISTE_counter].Parameter1:=WHILE_LIS.LISTE[WHILE_LIS.counter].Vergleich_Marke;
  Inc_STM_TAB_counter;


  STM_LISTE[STM_LISTE_counter].statement:=STM_sprungmarke;
  STM_LISTE[STM_LISTE_counter].Parameter1:=WHILE_LIS.LISTE[WHILE_LIS.counter].Ende_Marke;
  Inc_STM_TAB_counter;


  // Ruecksetzen WHILE-Liste
  with WHILE_LIS.LISTE[WHILE_LIS.counter] do begin
    Vergleich_Marke:='';
    Start_Marke:='';
    Ende_Marke:='';
  end; { with WHILE_LIS.LISTE[WHILE_LIS.counter] do }



  Dec(WHILE_LIS.counter);

  if WHILE_LIS.counter<0 then
    Fehler_cl.Registrieren('ZwischenCode/while_end',
                           'WHILE-Schleife mehrfach beendet',
                            Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                            Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                            Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

end; { procedure ZWC_class.while_end }









// ********************************************
//               CASE OF
// ********************************************










function ZWC_class.CASE_var_lesen(CASE_VAR_NAME : String) : Boolean;
var
  CV_erfolgreich : Boolean;
  CV_ANW_type : Char;
  CV_ASM_type : ASM_type_Typ;
  lok_PAR_Pos : Integer;
  Register_L, Register_H,
  Register_LH, Register_HH : String;
begin
  CV_erfolgreich:=false;

  if NAME_TO_ANW_und_ASM(CASE_VAR_NAME,CV_ANW_type,CV_ASM_type) then begin

    if CV_ANW_type IN ['V','L','D'] then begin

      Inc_CASE_LIS_counter;

      CASE_LIS.LISTE[CASE_LIS.counter].Ende_Marke:=erzeuge_Marke('CASE');
      CASE_LIS.LISTE[CASE_LIS.counter].naechstes_Element_Marke:=erzeuge_Marke('CASE');
      CASE_LIS.LISTE[CASE_LIS.counter].ASM_type:=CV_ASM_type;


      case CV_ANW_type of

        'V' : begin

          case CV_ASM_type of

            AT_byte, AT_boolean, AT_char : begin

              STM_LISTE[STM_LISTE_counter].Bemerkung:='; CASE OF - Byte-VAR ('+CASE_VAR_NAME+')';

              STM_LISTE[STM_LISTE_counter].statement:=STM_LDS;
              STM_LISTE[STM_LISTE_counter].Parameter1:=CASE_VAR_NAME;
              STM_LISTE[STM_LISTE_counter].Parameter2:='R16';
              Inc_STM_TAB_counter;

            end; { AT_byte }


            AT_word : begin

              STM_LISTE[STM_LISTE_counter].Bemerkung:='; CASE OF - Word-VAR ('+CASE_VAR_NAME+')';

              STM_LISTE[STM_LISTE_counter].statement:=STM_LDS;
              STM_LISTE[STM_LISTE_counter].Parameter1:=CASE_VAR_NAME;
              STM_LISTE[STM_LISTE_counter].Parameter2:='R16';
              Inc_STM_TAB_counter;

              STM_LISTE[STM_LISTE_counter].statement:=STM_LDS;
              STM_LISTE[STM_LISTE_counter].Parameter1:=CASE_VAR_NAME+'+1';
              STM_LISTE[STM_LISTE_counter].Parameter2:='R17';
              Inc_STM_TAB_counter;

            end; { AT_word }


            AT_dword : begin

              STM_LISTE[STM_LISTE_counter].Bemerkung:='; CASE OF - DWord-VAR ('+CASE_VAR_NAME+')';

              STM_LISTE[STM_LISTE_counter].statement:=STM_LDS;
              STM_LISTE[STM_LISTE_counter].Parameter1:=CASE_VAR_NAME;
              STM_LISTE[STM_LISTE_counter].Parameter2:='R16';
              Inc_STM_TAB_counter;

              STM_LISTE[STM_LISTE_counter].statement:=STM_LDS;
              STM_LISTE[STM_LISTE_counter].Parameter1:=CASE_VAR_NAME+'+1';
              STM_LISTE[STM_LISTE_counter].Parameter2:='R17';
              Inc_STM_TAB_counter;

              STM_LISTE[STM_LISTE_counter].statement:=STM_LDS;
              STM_LISTE[STM_LISTE_counter].Parameter1:=CASE_VAR_NAME+'+2';
              STM_LISTE[STM_LISTE_counter].Parameter2:='R18';
              Inc_STM_TAB_counter;

              STM_LISTE[STM_LISTE_counter].statement:=STM_LDS;
              STM_LISTE[STM_LISTE_counter].Parameter1:=CASE_VAR_NAME+'+3';
              STM_LISTE[STM_LISTE_counter].Parameter2:='R19';
              Inc_STM_TAB_counter;

            end; { AT_dword }


          else
            Fehler_cl.Registrieren('ZwischenCode/CASE_var_lesen/ANW_type=V',
                                   'CASE fuer den ASM-Type <'+
                                   Compiler_cl.ASM_type_Typ_in_Bezeichner(CV_ASM_type)+
                                   '> nicht programmiert',
                                   Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                                   Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                                   Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

          end; { case CV_ASM_type of }


        end; { 'V' }



        'L','D' : begin


          lok_PAR_Pos:=lokalen_Parameter_suchen(CASE_VAR_NAME);
          Register_L:=PROC_LIS.LISTE[PROC_LIS.counter].PPR_ARR[lok_PAR_Pos].Register_L;
          Register_H:=PROC_LIS.LISTE[PROC_LIS.counter].PPR_ARR[lok_PAR_Pos].Register_H;
          Register_LH:=PROC_LIS.LISTE[PROC_LIS.counter].PPR_ARR[lok_PAR_Pos].Register_LH;
          Register_HH:=PROC_LIS.LISTE[PROC_LIS.counter].PPR_ARR[lok_PAR_Pos].Register_HH;

          case CV_ANW_type of
          'L' :
            STM_LISTE[STM_LISTE_counter].Bemerkung:='; CASE OF - lokaler Uebergabeparameter ('+
                 CASE_VAR_NAME+')';
          'D' :
            STM_LISTE[STM_LISTE_counter].Bemerkung:='; CASE OF - lokale, dynamische Variable VAR ('+
                 CASE_VAR_NAME+')';
        end;


          case CV_ASM_type of

            AT_byte, AT_boolean, AT_char : begin

              STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
              STM_LISTE[STM_LISTE_counter].Parameter1:=Register_L;
              STM_LISTE[STM_LISTE_counter].Parameter2:='R16';
              Inc_STM_TAB_counter;

            end; { AT_byte }


            AT_word : begin

              STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
              STM_LISTE[STM_LISTE_counter].Parameter1:=Register_L;
              STM_LISTE[STM_LISTE_counter].Parameter2:='R16';
              Inc_STM_TAB_counter;

              STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
              STM_LISTE[STM_LISTE_counter].Parameter1:=Register_H;
              STM_LISTE[STM_LISTE_counter].Parameter2:='R17';
              Inc_STM_TAB_counter;

            end; { AT_word }


            AT_dword : begin

              STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
              STM_LISTE[STM_LISTE_counter].Parameter1:=Register_L;
              STM_LISTE[STM_LISTE_counter].Parameter2:='R16';
              Inc_STM_TAB_counter;

              STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
              STM_LISTE[STM_LISTE_counter].Parameter1:=Register_H;
              STM_LISTE[STM_LISTE_counter].Parameter2:='R17';
              Inc_STM_TAB_counter;

              STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
              STM_LISTE[STM_LISTE_counter].Parameter1:=Register_LH;
              STM_LISTE[STM_LISTE_counter].Parameter2:='R18';
              Inc_STM_TAB_counter;

              STM_LISTE[STM_LISTE_counter].statement:=STM_MOV;
              STM_LISTE[STM_LISTE_counter].Parameter1:=Register_HH;
              STM_LISTE[STM_LISTE_counter].Parameter2:='R19';
              Inc_STM_TAB_counter;

            end; { AT_dword }



          else
            Fehler_cl.Registrieren('ZwischenCode/CASE_var_lesen/ANW_type=L und D',
                                   'CASE fuer den ASM-Type <'+
                                   Compiler_cl.ASM_type_Typ_in_Bezeichner(CV_ASM_type)+
                                   '> nicht programmiert',
                                   Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                                   Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                                   Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

          end; { case CV_ASM_type of }


        end; { 'L','D' }





      else
          Fehler_cl.Registrieren('ZwischenCode/CASE_var_lesen',
                                 'CASE fuer den ANW-Type <'+
                                 CV_ANW_type+'> nicht programmiert',
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

      end; { case CV_ANW_type of }


      CV_erfolgreich:=true;

    end { if CB_ANW_type IN ['V','L','D'] then }
    else
      Fehler_cl.Registrieren('ZwischenCode/CASE_var_lesen',
                             'CASE kann nur fuer Variablen genutzt werden',
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);


  end { if NAME_TO_ANW_und_ASM(DEC_VAR_NAME,DEC_ANW_type,DEC_ASM_type) then }
  else
    Fehler_cl.Registrieren('ZwischenCode/CASE_var_lesen',
                           'Name <'+CASE_VAR_NAME+'> der CASE-Variablen konnte nicht gefunden werden',
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);



  Result:=CV_erfolgreich;
end; { function ZWC_class.CASE_var_lesen }





procedure ZWC_class.CASE_STM_Einzel_Element(ASM_Wert, Ori_Wert : String);
var
  aktuelles_Element_Marke, ByteWert : String;
begin
    if CASE_LIS.LISTE[CASE_LIS.counter].erstes_Element then
      CASE_LIS.LISTE[CASE_LIS.counter].erstes_Element:=false
    else begin

      STM_LISTE[STM_LISTE_counter].Bemerkung:='; CASE - Sprung zu ENDCASE';
      STM_LISTE[STM_LISTE_counter].statement:=STM_RJMP_Marke;
      STM_LISTE[STM_LISTE_counter].Parameter1:=
             CASE_LIS.LISTE[CASE_LIS.counter].Ende_Marke;
      Inc_STM_TAB_counter;

      STM_LISTE[STM_LISTE_counter].statement:=STM_sprungmarke;
      STM_LISTE[STM_LISTE_counter].Parameter1:=
             CASE_LIS.LISTE[CASE_LIS.counter].naechstes_Element_Marke;
      Inc_STM_TAB_counter;

      CASE_LIS.LISTE[CASE_LIS.counter].naechstes_Element_Marke:=erzeuge_Marke('CASE');

    end; { if CASE_LIS.LISTE[CASE_LIS.counter].erstes_Element then }

    aktuelles_Element_Marke:=erzeuge_Marke('CASE');
    STM_LISTE[STM_LISTE_counter].Bemerkung:='; CASE OF - vergleiche Einzel-Element ('+Ori_Wert+')';

    case CASE_LIS.LISTE[CASE_LIS.counter].ASM_type of

      AT_byte, AT_boolean, AT_char : begin

        STM_LISTE[STM_LISTE_counter].statement:=STM_CPI;
        STM_LISTE[STM_LISTE_counter].Parameter1:=ASM_Wert;
        STM_LISTE[STM_LISTE_counter].Parameter2:='R16';
        Inc_STM_TAB_counter;

        STM_LISTE[STM_LISTE_counter].statement:=STM_BREQ_Marke;
        STM_LISTE[STM_LISTE_counter].Parameter1:=aktuelles_Element_Marke;
        Inc_STM_TAB_counter;

        STM_LISTE[STM_LISTE_counter].statement:=STM_RJMP_Marke;
        STM_LISTE[STM_LISTE_counter].Parameter1:=
               CASE_LIS.LISTE[CASE_LIS.counter].naechstes_Element_Marke;
        Inc_STM_TAB_counter;

        STM_LISTE[STM_LISTE_counter].statement:=STM_sprungmarke;
        STM_LISTE[STM_LISTE_counter].Parameter1:=aktuelles_Element_Marke;
        Inc_STM_TAB_counter;

      end; { AT_byte, AT_boolean, AT_char }


      AT_word : begin

        STM_LISTE[STM_LISTE_counter].statement:=STM_LDI_word_L;
        STM_LISTE[STM_LISTE_counter].Parameter1:=ASM_Wert;
        STM_LISTE[STM_LISTE_counter].Parameter2:='R18';
        Inc_STM_TAB_counter;

        STM_LISTE[STM_LISTE_counter].statement:=STM_LDI_word_H;
        STM_LISTE[STM_LISTE_counter].Parameter1:=ASM_Wert;
        STM_LISTE[STM_LISTE_counter].Parameter2:='R19';
        Inc_STM_TAB_counter;

        STM_LISTE[STM_LISTE_counter].statement:=STM_CP_word_L;
        STM_LISTE[STM_LISTE_counter].Parameter1:='R18';
        STM_LISTE[STM_LISTE_counter].Parameter2:='R16';
        Inc_STM_TAB_counter;

        STM_LISTE[STM_LISTE_counter].statement:=STM_CP_word_H;
        STM_LISTE[STM_LISTE_counter].Parameter1:='R19';
        STM_LISTE[STM_LISTE_counter].Parameter2:='R17';
        Inc_STM_TAB_counter;

        STM_LISTE[STM_LISTE_counter].statement:=STM_BREQ_Marke;
        STM_LISTE[STM_LISTE_counter].Parameter1:=aktuelles_Element_Marke;
        Inc_STM_TAB_counter;

        STM_LISTE[STM_LISTE_counter].statement:=STM_RJMP_Marke;
        STM_LISTE[STM_LISTE_counter].Parameter1:=
               CASE_LIS.LISTE[CASE_LIS.counter].naechstes_Element_Marke;
        Inc_STM_TAB_counter;

        STM_LISTE[STM_LISTE_counter].statement:=STM_sprungmarke;
        STM_LISTE[STM_LISTE_counter].Parameter1:=aktuelles_Element_Marke;
        Inc_STM_TAB_counter;

      end; { AT_word }


      AT_dword : begin

        ByteWert:='0x'+Copy(ASM_Wert,7,2);
        STM_LISTE[STM_LISTE_counter].statement:=STM_LDI;
        STM_LISTE[STM_LISTE_counter].Parameter1:=ByteWert;
        STM_LISTE[STM_LISTE_counter].Parameter2:='R20';
        Inc_STM_TAB_counter;

        ByteWert:='0x'+Copy(ASM_Wert,5,2);
        STM_LISTE[STM_LISTE_counter].statement:=STM_LDI;
        STM_LISTE[STM_LISTE_counter].Parameter1:=ByteWert;
        STM_LISTE[STM_LISTE_counter].Parameter2:='R21';
        Inc_STM_TAB_counter;

        ByteWert:='0x'+Copy(ASM_Wert,3,2);
        STM_LISTE[STM_LISTE_counter].statement:=STM_LDI;
        STM_LISTE[STM_LISTE_counter].Parameter1:=ByteWert;
        STM_LISTE[STM_LISTE_counter].Parameter2:='R22';
        Inc_STM_TAB_counter;

        ByteWert:='0x'+Copy(ASM_Wert,1,2);
        STM_LISTE[STM_LISTE_counter].statement:=STM_LDI;
        STM_LISTE[STM_LISTE_counter].Parameter1:=ByteWert;
        STM_LISTE[STM_LISTE_counter].Parameter2:='R23';
        Inc_STM_TAB_counter;



        STM_LISTE[STM_LISTE_counter].statement:=STM_CP;
        STM_LISTE[STM_LISTE_counter].Parameter1:='R20';
        STM_LISTE[STM_LISTE_counter].Parameter2:='R16';
        Inc_STM_TAB_counter;

        STM_LISTE[STM_LISTE_counter].statement:=STM_CPC;
        STM_LISTE[STM_LISTE_counter].Parameter1:='R21';
        STM_LISTE[STM_LISTE_counter].Parameter2:='R17';
        Inc_STM_TAB_counter;

        STM_LISTE[STM_LISTE_counter].statement:=STM_CPC;
        STM_LISTE[STM_LISTE_counter].Parameter1:='R22';
        STM_LISTE[STM_LISTE_counter].Parameter2:='R18';
        Inc_STM_TAB_counter;

        STM_LISTE[STM_LISTE_counter].statement:=STM_CPC;
        STM_LISTE[STM_LISTE_counter].Parameter1:='R23';
        STM_LISTE[STM_LISTE_counter].Parameter2:='R19';
        Inc_STM_TAB_counter;


        STM_LISTE[STM_LISTE_counter].statement:=STM_BREQ_Marke;
        STM_LISTE[STM_LISTE_counter].Parameter1:=aktuelles_Element_Marke;
        Inc_STM_TAB_counter;

        STM_LISTE[STM_LISTE_counter].statement:=STM_RJMP_Marke;
        STM_LISTE[STM_LISTE_counter].Parameter1:=
               CASE_LIS.LISTE[CASE_LIS.counter].naechstes_Element_Marke;
        Inc_STM_TAB_counter;

        STM_LISTE[STM_LISTE_counter].statement:=STM_sprungmarke;
        STM_LISTE[STM_LISTE_counter].Parameter1:=aktuelles_Element_Marke;
        Inc_STM_TAB_counter;

      end; { AT_dword }


    else
      Fehler_cl.Registrieren('ZwischenCode/CASE_Element_lesen',
                             'Der Typ '+Compiler_cl.ASM_type_Typ_in_Bezeichner(
                             CASE_LIS.LISTE[CASE_LIS.counter].ASM_type)+
                               ' ist nicht programmiert',
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

    end; { case CASE_LIS.LISTE[CASE_LIS.counter].ASM_type of }

end; { procedure ZWC_class.CASE_STM_Einzel_Element }









{ ??????????????????????????????????????????????????????????????????  }







procedure ZWC_class.CASE_STM_Bereich_Element(ASM_Wert_von, ASM_Wert_bis,
                                             Ori_Wert_von, Ori_Wert_bis : String);
var
  aktuelles_Element_Marke, Zwischen_Marke,
  ByteWert : String;
  Wert_von, Wert_bis : LongInt;
begin

  if CASE_LIS.LISTE[CASE_LIS.counter].ASM_type=AT_dword then begin

    Wert_von:=StrToInt('$'+ASM_Wert_von);
    Wert_bis:=StrToInt('$'+ASM_Wert_bis);

  end
  else begin

    Wert_von:=StrToInt('$'+Copy(ASM_Wert_von,3,Length(ASM_Wert_von)-2));
    Wert_bis:=StrToInt('$'+Copy(ASM_Wert_bis,3,Length(ASM_Wert_bis)-2));

  end;

  if not (Wert_von<Wert_bis) then
    Fehler_cl.Registrieren('ZwischenCode/CASE_STM_Bereich_Element',
                           'Der <von> Wert ('+Ori_Wert_von+') in einem CASE-Bereich muss immer kleiner sein '+
                           'als der <bis> wert ('+Ori_Wert_bis+')',
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);



    if CASE_LIS.LISTE[CASE_LIS.counter].erstes_Element then
      CASE_LIS.LISTE[CASE_LIS.counter].erstes_Element:=false
    else begin

      STM_LISTE[STM_LISTE_counter].Bemerkung:='; CASE - Sprung zu ENDCASE';
      STM_LISTE[STM_LISTE_counter].statement:=STM_RJMP_Marke;
      STM_LISTE[STM_LISTE_counter].Parameter1:=
             CASE_LIS.LISTE[CASE_LIS.counter].Ende_Marke;
      Inc_STM_TAB_counter;

      STM_LISTE[STM_LISTE_counter].statement:=STM_sprungmarke;
      STM_LISTE[STM_LISTE_counter].Parameter1:=
             CASE_LIS.LISTE[CASE_LIS.counter].naechstes_Element_Marke;
      Inc_STM_TAB_counter;

      CASE_LIS.LISTE[CASE_LIS.counter].naechstes_Element_Marke:=erzeuge_Marke('CASE');

    end; { if CASE_LIS.LISTE[CASE_LIS.counter].erstes_Element then }

    aktuelles_Element_Marke:=erzeuge_Marke('CASE');
    Zwischen_Marke:=erzeuge_Marke('CASE');

    case CASE_LIS.LISTE[CASE_LIS.counter].ASM_type of

      AT_byte, AT_boolean, AT_char : begin

        STM_LISTE[STM_LISTE_counter].Bemerkung:='; CASE OF - vergleiche Byte-Element-Bereich <von> ('+Ori_Wert_von+')';

        STM_LISTE[STM_LISTE_counter].statement:=STM_CPI;
        STM_LISTE[STM_LISTE_counter].Parameter1:=ASM_Wert_von;
        STM_LISTE[STM_LISTE_counter].Parameter2:='R16';
        Inc_STM_TAB_counter;

        STM_LISTE[STM_LISTE_counter].statement:=STM_BRCC_Marke;
        STM_LISTE[STM_LISTE_counter].Parameter1:=Zwischen_Marke;
        Inc_STM_TAB_counter;

        STM_LISTE[STM_LISTE_counter].statement:=STM_RJMP_Marke;
        STM_LISTE[STM_LISTE_counter].Parameter1:=
               CASE_LIS.LISTE[CASE_LIS.counter].naechstes_Element_Marke;
        Inc_STM_TAB_counter;

        STM_LISTE[STM_LISTE_counter].statement:=STM_sprungmarke;
        STM_LISTE[STM_LISTE_counter].Parameter1:=Zwischen_Marke;
        Inc_STM_TAB_counter;

        STM_LISTE[STM_LISTE_counter].Bemerkung:='; CASE OF - vergleiche Byte-Element-Bereich <bis> ('+Ori_Wert_bis+')';

        STM_LISTE[STM_LISTE_counter].statement:=STM_LDI;
        STM_LISTE[STM_LISTE_counter].Parameter1:=ASM_Wert_bis;
        STM_LISTE[STM_LISTE_counter].Parameter2:='R17';
        Inc_STM_TAB_counter;

        STM_LISTE[STM_LISTE_counter].statement:=STM_CP_byte;
        STM_LISTE[STM_LISTE_counter].Parameter1:='R16';
        STM_LISTE[STM_LISTE_counter].Parameter2:='R17';
        Inc_STM_TAB_counter;

        STM_LISTE[STM_LISTE_counter].statement:=STM_BRCC_Marke;
        STM_LISTE[STM_LISTE_counter].Parameter1:=aktuelles_Element_Marke;
        Inc_STM_TAB_counter;

        STM_LISTE[STM_LISTE_counter].statement:=STM_RJMP_Marke;
        STM_LISTE[STM_LISTE_counter].Parameter1:=
               CASE_LIS.LISTE[CASE_LIS.counter].naechstes_Element_Marke;
        Inc_STM_TAB_counter;

        STM_LISTE[STM_LISTE_counter].statement:=STM_sprungmarke;
        STM_LISTE[STM_LISTE_counter].Parameter1:=aktuelles_Element_Marke;
        Inc_STM_TAB_counter;


      end; { AT_byte, AT_boolean, AT_char }


      AT_word : begin

        STM_LISTE[STM_LISTE_counter].Bemerkung:='; CASE OF - vergleiche Word-Element-Bereich <von> ('+Ori_Wert_von+')';

        STM_LISTE[STM_LISTE_counter].statement:=STM_LDI_word_L;
        STM_LISTE[STM_LISTE_counter].Parameter1:=ASM_Wert_von;
        STM_LISTE[STM_LISTE_counter].Parameter2:='R18';
        Inc_STM_TAB_counter;

        STM_LISTE[STM_LISTE_counter].statement:=STM_LDI_word_H;
        STM_LISTE[STM_LISTE_counter].Parameter1:=ASM_Wert_von;
        STM_LISTE[STM_LISTE_counter].Parameter2:='R19';
        Inc_STM_TAB_counter;

        STM_LISTE[STM_LISTE_counter].statement:=STM_CP_word_L;
        STM_LISTE[STM_LISTE_counter].Parameter1:='R18';
        STM_LISTE[STM_LISTE_counter].Parameter2:='R16';
        Inc_STM_TAB_counter;

        STM_LISTE[STM_LISTE_counter].statement:=STM_CP_word_H;
        STM_LISTE[STM_LISTE_counter].Parameter1:='R19';
        STM_LISTE[STM_LISTE_counter].Parameter2:='R17';
        Inc_STM_TAB_counter;

        STM_LISTE[STM_LISTE_counter].statement:=STM_BRCC_Marke;
        STM_LISTE[STM_LISTE_counter].Parameter1:=Zwischen_Marke;
        Inc_STM_TAB_counter;

        STM_LISTE[STM_LISTE_counter].statement:=STM_RJMP_Marke;
        STM_LISTE[STM_LISTE_counter].Parameter1:=
               CASE_LIS.LISTE[CASE_LIS.counter].naechstes_Element_Marke;
        Inc_STM_TAB_counter;

        STM_LISTE[STM_LISTE_counter].statement:=STM_sprungmarke;
        STM_LISTE[STM_LISTE_counter].Parameter1:=Zwischen_Marke;
        Inc_STM_TAB_counter;

        STM_LISTE[STM_LISTE_counter].Bemerkung:='; CASE OF - vergleiche Word-Element-Bereich <bis> ('+Ori_Wert_bis+')';

        STM_LISTE[STM_LISTE_counter].statement:=STM_LDI_word_L;
        STM_LISTE[STM_LISTE_counter].Parameter1:=ASM_Wert_bis;
        STM_LISTE[STM_LISTE_counter].Parameter2:='R18';
        Inc_STM_TAB_counter;

        STM_LISTE[STM_LISTE_counter].statement:=STM_LDI_word_H;
        STM_LISTE[STM_LISTE_counter].Parameter1:=ASM_Wert_bis;
        STM_LISTE[STM_LISTE_counter].Parameter2:='R19';
        Inc_STM_TAB_counter;

        STM_LISTE[STM_LISTE_counter].statement:=STM_CP_word_L;
        STM_LISTE[STM_LISTE_counter].Parameter2:='R18';
        STM_LISTE[STM_LISTE_counter].Parameter1:='R16';
        Inc_STM_TAB_counter;

        STM_LISTE[STM_LISTE_counter].statement:=STM_CP_word_H;
        STM_LISTE[STM_LISTE_counter].Parameter2:='R19';
        STM_LISTE[STM_LISTE_counter].Parameter1:='R17';
        Inc_STM_TAB_counter;

        STM_LISTE[STM_LISTE_counter].statement:=STM_BRCC_Marke;
        STM_LISTE[STM_LISTE_counter].Parameter1:=aktuelles_Element_Marke;
        Inc_STM_TAB_counter;

        STM_LISTE[STM_LISTE_counter].statement:=STM_RJMP_Marke;
        STM_LISTE[STM_LISTE_counter].Parameter1:=
               CASE_LIS.LISTE[CASE_LIS.counter].naechstes_Element_Marke;
        Inc_STM_TAB_counter;

        STM_LISTE[STM_LISTE_counter].statement:=STM_sprungmarke;
        STM_LISTE[STM_LISTE_counter].Parameter1:=aktuelles_Element_Marke;
        Inc_STM_TAB_counter;

      end; { AT_word }



      AT_dword : begin

        STM_LISTE[STM_LISTE_counter].Bemerkung:='; CASE OF - vergleiche DWord-Element-Bereich <von> ('+Ori_Wert_von+')';

        ByteWert:='0x'+Copy(ASM_Wert_von,7,2);
        STM_LISTE[STM_LISTE_counter].statement:=STM_LDI;
        STM_LISTE[STM_LISTE_counter].Parameter1:=ByteWert;
        STM_LISTE[STM_LISTE_counter].Parameter2:='R20';
        Inc_STM_TAB_counter;

        ByteWert:='0x'+Copy(ASM_Wert_von,5,2);
        STM_LISTE[STM_LISTE_counter].statement:=STM_LDI;
        STM_LISTE[STM_LISTE_counter].Parameter1:=ByteWert;
        STM_LISTE[STM_LISTE_counter].Parameter2:='R21';
        Inc_STM_TAB_counter;

        ByteWert:='0x'+Copy(ASM_Wert_von,3,2);
        STM_LISTE[STM_LISTE_counter].statement:=STM_LDI;
        STM_LISTE[STM_LISTE_counter].Parameter1:=ByteWert;
        STM_LISTE[STM_LISTE_counter].Parameter2:='R22';
        Inc_STM_TAB_counter;

        ByteWert:='0x'+Copy(ASM_Wert_von,1,2);
        STM_LISTE[STM_LISTE_counter].statement:=STM_LDI;
        STM_LISTE[STM_LISTE_counter].Parameter1:=ByteWert;
        STM_LISTE[STM_LISTE_counter].Parameter2:='R23';
        Inc_STM_TAB_counter;

        STM_LISTE[STM_LISTE_counter].statement:=STM_CP;
        STM_LISTE[STM_LISTE_counter].Parameter1:='R20';
        STM_LISTE[STM_LISTE_counter].Parameter2:='R16';
        Inc_STM_TAB_counter;

        STM_LISTE[STM_LISTE_counter].statement:=STM_CPC;
        STM_LISTE[STM_LISTE_counter].Parameter1:='R21';
        STM_LISTE[STM_LISTE_counter].Parameter2:='R17';
        Inc_STM_TAB_counter;

        STM_LISTE[STM_LISTE_counter].statement:=STM_CPC;
        STM_LISTE[STM_LISTE_counter].Parameter1:='R22';
        STM_LISTE[STM_LISTE_counter].Parameter2:='R18';
        Inc_STM_TAB_counter;

        STM_LISTE[STM_LISTE_counter].statement:=STM_CPC;
        STM_LISTE[STM_LISTE_counter].Parameter1:='R23';
        STM_LISTE[STM_LISTE_counter].Parameter2:='R19';
        Inc_STM_TAB_counter;


        STM_LISTE[STM_LISTE_counter].statement:=STM_BRCC_Marke;
        STM_LISTE[STM_LISTE_counter].Parameter1:=Zwischen_Marke;
        Inc_STM_TAB_counter;

        STM_LISTE[STM_LISTE_counter].statement:=STM_RJMP_Marke;
        STM_LISTE[STM_LISTE_counter].Parameter1:=
               CASE_LIS.LISTE[CASE_LIS.counter].naechstes_Element_Marke;
        Inc_STM_TAB_counter;

        STM_LISTE[STM_LISTE_counter].statement:=STM_sprungmarke;
        STM_LISTE[STM_LISTE_counter].Parameter1:=Zwischen_Marke;
        Inc_STM_TAB_counter;

        STM_LISTE[STM_LISTE_counter].Bemerkung:='; CASE OF - vergleiche DWord-Element-Bereich <bis> ('+Ori_Wert_bis+')';


        ByteWert:='0x'+Copy(ASM_Wert_bis,7,2);
        STM_LISTE[STM_LISTE_counter].statement:=STM_LDI;
        STM_LISTE[STM_LISTE_counter].Parameter1:=ByteWert;
        STM_LISTE[STM_LISTE_counter].Parameter2:='R20';
        Inc_STM_TAB_counter;

        ByteWert:='0x'+Copy(ASM_Wert_bis,5,2);
        STM_LISTE[STM_LISTE_counter].statement:=STM_LDI;
        STM_LISTE[STM_LISTE_counter].Parameter1:=ByteWert;
        STM_LISTE[STM_LISTE_counter].Parameter2:='R21';
        Inc_STM_TAB_counter;

        ByteWert:='0x'+Copy(ASM_Wert_bis,3,2);
        STM_LISTE[STM_LISTE_counter].statement:=STM_LDI;
        STM_LISTE[STM_LISTE_counter].Parameter1:=ByteWert;
        STM_LISTE[STM_LISTE_counter].Parameter2:='R22';
        Inc_STM_TAB_counter;

        ByteWert:='0x'+Copy(ASM_Wert_bis,1,2);
        STM_LISTE[STM_LISTE_counter].statement:=STM_LDI;
        STM_LISTE[STM_LISTE_counter].Parameter1:=ByteWert;
        STM_LISTE[STM_LISTE_counter].Parameter2:='R23';
        Inc_STM_TAB_counter;



        STM_LISTE[STM_LISTE_counter].statement:=STM_CP;
        STM_LISTE[STM_LISTE_counter].Parameter2:='R20';
        STM_LISTE[STM_LISTE_counter].Parameter1:='R16';
        Inc_STM_TAB_counter;

        STM_LISTE[STM_LISTE_counter].statement:=STM_CPC;
        STM_LISTE[STM_LISTE_counter].Parameter2:='R21';
        STM_LISTE[STM_LISTE_counter].Parameter1:='R17';
        Inc_STM_TAB_counter;

        STM_LISTE[STM_LISTE_counter].statement:=STM_CPC;
        STM_LISTE[STM_LISTE_counter].Parameter2:='R22';
        STM_LISTE[STM_LISTE_counter].Parameter1:='R18';
        Inc_STM_TAB_counter;

        STM_LISTE[STM_LISTE_counter].statement:=STM_CPC;
        STM_LISTE[STM_LISTE_counter].Parameter2:='R23';
        STM_LISTE[STM_LISTE_counter].Parameter1:='R19';
        Inc_STM_TAB_counter;


        STM_LISTE[STM_LISTE_counter].statement:=STM_BRCC_Marke;
        STM_LISTE[STM_LISTE_counter].Parameter1:=aktuelles_Element_Marke;
        Inc_STM_TAB_counter;

        STM_LISTE[STM_LISTE_counter].statement:=STM_RJMP_Marke;
        STM_LISTE[STM_LISTE_counter].Parameter1:=
               CASE_LIS.LISTE[CASE_LIS.counter].naechstes_Element_Marke;
        Inc_STM_TAB_counter;

        STM_LISTE[STM_LISTE_counter].statement:=STM_sprungmarke;
        STM_LISTE[STM_LISTE_counter].Parameter1:=aktuelles_Element_Marke;
        Inc_STM_TAB_counter;

      end; { AT_dword }



    else
      Fehler_cl.Registrieren('ZwischenCode/CASE_STM_Bereich_Element',
                             'Der Typ '+Compiler_cl.ASM_type_Typ_in_Bezeichner(
                             CASE_LIS.LISTE[CASE_LIS.counter].ASM_type)+
                               ' ist nicht programmiert',
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

    end; { case CASE_LIS.LISTE[CASE_LIS.counter].ASM_type of }

end; { procedure ZWC_class.CASE_STM_Bereich_Element }






procedure ZWC_class.CASE_STM_Listen_Element(ASM_Wert, Ori_Wert : String);
var
  ByteWert : String;
begin

    if CASE_LIS.LISTE[CASE_LIS.counter].erstes_Listen_Element then begin

      CASE_LIS.LISTE[CASE_LIS.counter].erstes_Listen_Element:=false;
      CASE_LIS.LISTE[CASE_LIS.counter].Listen_Element_Marke:=erzeuge_Marke('CASE');

      if CASE_LIS.LISTE[CASE_LIS.counter].erstes_Element then
        CASE_LIS.LISTE[CASE_LIS.counter].erstes_Element:=false
      else begin

          STM_LISTE[STM_LISTE_counter].Bemerkung:='; CASE - Sprung zu ENDCASE';
          STM_LISTE[STM_LISTE_counter].statement:=STM_RJMP_Marke;
          STM_LISTE[STM_LISTE_counter].Parameter1:=
                 CASE_LIS.LISTE[CASE_LIS.counter].Ende_Marke;
          Inc_STM_TAB_counter;

          STM_LISTE[STM_LISTE_counter].statement:=STM_sprungmarke;
          STM_LISTE[STM_LISTE_counter].Parameter1:=
                 CASE_LIS.LISTE[CASE_LIS.counter].naechstes_Element_Marke;
          Inc_STM_TAB_counter;

          CASE_LIS.LISTE[CASE_LIS.counter].naechstes_Element_Marke:=erzeuge_Marke('CASE');

      end; { if CASE_LIS.LISTE[CASE_LIS.counter].erstes_Element then }

    end; { if CASE_LIS.LISTE[CASE_LIS.counter].erstes_Listen_Element then }



    STM_LISTE[STM_LISTE_counter].Bemerkung:='; CASE OF - vergleiche Listen-Element ('+Ori_Wert+')';

    case CASE_LIS.LISTE[CASE_LIS.counter].ASM_type of

      AT_byte, AT_boolean, AT_char : begin

        STM_LISTE[STM_LISTE_counter].statement:=STM_CPI;
        STM_LISTE[STM_LISTE_counter].Parameter1:=ASM_Wert;
        STM_LISTE[STM_LISTE_counter].Parameter2:='R16';
        Inc_STM_TAB_counter;

        STM_LISTE[STM_LISTE_counter].statement:=STM_BREQ_Marke;
        STM_LISTE[STM_LISTE_counter].Parameter1:=
                    CASE_LIS.LISTE[CASE_LIS.counter].Listen_Element_Marke;
        Inc_STM_TAB_counter;

      end; { AT_byte, AT_boolean, AT_char }


      AT_word : begin

        STM_LISTE[STM_LISTE_counter].statement:=STM_LDI_word_L;
        STM_LISTE[STM_LISTE_counter].Parameter1:=ASM_Wert;
        STM_LISTE[STM_LISTE_counter].Parameter2:='R18';
        Inc_STM_TAB_counter;

        STM_LISTE[STM_LISTE_counter].statement:=STM_LDI_word_H;
        STM_LISTE[STM_LISTE_counter].Parameter1:=ASM_Wert;
        STM_LISTE[STM_LISTE_counter].Parameter2:='R19';
        Inc_STM_TAB_counter;

        STM_LISTE[STM_LISTE_counter].statement:=STM_CP_word_L;
        STM_LISTE[STM_LISTE_counter].Parameter1:='R18';
        STM_LISTE[STM_LISTE_counter].Parameter2:='R16';
        Inc_STM_TAB_counter;

        STM_LISTE[STM_LISTE_counter].statement:=STM_CP_word_H;
        STM_LISTE[STM_LISTE_counter].Parameter1:='R19';
        STM_LISTE[STM_LISTE_counter].Parameter2:='R17';
        Inc_STM_TAB_counter;

        STM_LISTE[STM_LISTE_counter].statement:=STM_BREQ_Marke;
        STM_LISTE[STM_LISTE_counter].Parameter1:=
                    CASE_LIS.LISTE[CASE_LIS.counter].Listen_Element_Marke;
        Inc_STM_TAB_counter;

      end; { AT_word }



      AT_dword : begin

        ByteWert:='0x'+Copy(ASM_Wert,7,2);
        STM_LISTE[STM_LISTE_counter].statement:=STM_LDI;
        STM_LISTE[STM_LISTE_counter].Parameter1:=ByteWert;
        STM_LISTE[STM_LISTE_counter].Parameter2:='R20';
        Inc_STM_TAB_counter;

        ByteWert:='0x'+Copy(ASM_Wert,5,2);
        STM_LISTE[STM_LISTE_counter].statement:=STM_LDI;
        STM_LISTE[STM_LISTE_counter].Parameter1:=ByteWert;
        STM_LISTE[STM_LISTE_counter].Parameter2:='R21';
        Inc_STM_TAB_counter;

        ByteWert:='0x'+Copy(ASM_Wert,3,2);
        STM_LISTE[STM_LISTE_counter].statement:=STM_LDI;
        STM_LISTE[STM_LISTE_counter].Parameter1:=ByteWert;
        STM_LISTE[STM_LISTE_counter].Parameter2:='R22';
        Inc_STM_TAB_counter;

        ByteWert:='0x'+Copy(ASM_Wert,1,2);
        STM_LISTE[STM_LISTE_counter].statement:=STM_LDI;
        STM_LISTE[STM_LISTE_counter].Parameter1:=ByteWert;
        STM_LISTE[STM_LISTE_counter].Parameter2:='R23';
        Inc_STM_TAB_counter;

        STM_LISTE[STM_LISTE_counter].statement:=STM_CP;
        STM_LISTE[STM_LISTE_counter].Parameter1:='R20';
        STM_LISTE[STM_LISTE_counter].Parameter2:='R16';
        Inc_STM_TAB_counter;

        STM_LISTE[STM_LISTE_counter].statement:=STM_CPC;
        STM_LISTE[STM_LISTE_counter].Parameter1:='R21';
        STM_LISTE[STM_LISTE_counter].Parameter2:='R17';
        Inc_STM_TAB_counter;

        STM_LISTE[STM_LISTE_counter].statement:=STM_CPC;
        STM_LISTE[STM_LISTE_counter].Parameter1:='R22';
        STM_LISTE[STM_LISTE_counter].Parameter2:='R18';
        Inc_STM_TAB_counter;

        STM_LISTE[STM_LISTE_counter].statement:=STM_CPC;
        STM_LISTE[STM_LISTE_counter].Parameter1:='R23';
        STM_LISTE[STM_LISTE_counter].Parameter2:='R19';
        Inc_STM_TAB_counter;


        STM_LISTE[STM_LISTE_counter].statement:=STM_BREQ_Marke;
        STM_LISTE[STM_LISTE_counter].Parameter1:=
                    CASE_LIS.LISTE[CASE_LIS.counter].Listen_Element_Marke;
        Inc_STM_TAB_counter;

      end; { AT_dword }


    else
      Fehler_cl.Registrieren('ZwischenCode/CASE_STM_Listen_Element',
                             'Der Typ '+Compiler_cl.ASM_type_Typ_in_Bezeichner(
                             CASE_LIS.LISTE[CASE_LIS.counter].ASM_type)+
                               ' ist nicht programmiert',
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

    end; { case CASE_LIS.LISTE[CASE_LIS.counter].ASM_type of }

end; { procedure ZWC_class.CASE_STM_Listen_Element }





procedure ZWC_class.CASE_STM_Listen_Element_Ende(ASM_Wert, Ori_Wert : String);
var
  ByteWert : String;
begin


  STM_LISTE[STM_LISTE_counter].Bemerkung:='; CASE OF - vergleiche letztes Listen-Element ('+Ori_Wert+')';

  case CASE_LIS.LISTE[CASE_LIS.counter].ASM_type of

    AT_byte, AT_boolean, AT_char : begin

      STM_LISTE[STM_LISTE_counter].statement:=STM_CPI;
      STM_LISTE[STM_LISTE_counter].Parameter1:=ASM_Wert;
      STM_LISTE[STM_LISTE_counter].Parameter2:='R16';
      Inc_STM_TAB_counter;

      STM_LISTE[STM_LISTE_counter].statement:=STM_BREQ_Marke;
      STM_LISTE[STM_LISTE_counter].Parameter1:=
                CASE_LIS.LISTE[CASE_LIS.counter].Listen_Element_Marke;
      Inc_STM_TAB_counter;

      STM_LISTE[STM_LISTE_counter].statement:=STM_RJMP_Marke;
      STM_LISTE[STM_LISTE_counter].Parameter1:=
                CASE_LIS.LISTE[CASE_LIS.counter].naechstes_Element_Marke;
      Inc_STM_TAB_counter;

      STM_LISTE[STM_LISTE_counter].statement:=STM_sprungmarke;
      STM_LISTE[STM_LISTE_counter].Parameter1:=
      CASE_LIS.LISTE[CASE_LIS.counter].Listen_Element_Marke;
      Inc_STM_TAB_counter;

    end; { AT_byte, AT_boolean, AT_char }


    AT_word : begin

      STM_LISTE[STM_LISTE_counter].statement:=STM_LDI_word_L;
      STM_LISTE[STM_LISTE_counter].Parameter1:=ASM_Wert;
      STM_LISTE[STM_LISTE_counter].Parameter2:='R18';
      Inc_STM_TAB_counter;

      STM_LISTE[STM_LISTE_counter].statement:=STM_LDI_word_H;
      STM_LISTE[STM_LISTE_counter].Parameter1:=ASM_Wert;
      STM_LISTE[STM_LISTE_counter].Parameter2:='R19';
      Inc_STM_TAB_counter;

      STM_LISTE[STM_LISTE_counter].statement:=STM_CP_word_L;
      STM_LISTE[STM_LISTE_counter].Parameter1:='R18';
      STM_LISTE[STM_LISTE_counter].Parameter2:='R16';
      Inc_STM_TAB_counter;

      STM_LISTE[STM_LISTE_counter].statement:=STM_CP_word_H;
      STM_LISTE[STM_LISTE_counter].Parameter1:='R19';
      STM_LISTE[STM_LISTE_counter].Parameter2:='R17';
      Inc_STM_TAB_counter;


      STM_LISTE[STM_LISTE_counter].statement:=STM_BREQ_Marke;
      STM_LISTE[STM_LISTE_counter].Parameter1:=
                CASE_LIS.LISTE[CASE_LIS.counter].Listen_Element_Marke;
      Inc_STM_TAB_counter;

      STM_LISTE[STM_LISTE_counter].statement:=STM_RJMP_Marke;
      STM_LISTE[STM_LISTE_counter].Parameter1:=
                CASE_LIS.LISTE[CASE_LIS.counter].naechstes_Element_Marke;
      Inc_STM_TAB_counter;

      STM_LISTE[STM_LISTE_counter].statement:=STM_sprungmarke;
      STM_LISTE[STM_LISTE_counter].Parameter1:=
      CASE_LIS.LISTE[CASE_LIS.counter].Listen_Element_Marke;
      Inc_STM_TAB_counter;

    end; { AT_word }


    AT_dword : begin

      ByteWert:='0x'+Copy(ASM_Wert,7,2);
      STM_LISTE[STM_LISTE_counter].statement:=STM_LDI;
      STM_LISTE[STM_LISTE_counter].Parameter1:=ByteWert;
      STM_LISTE[STM_LISTE_counter].Parameter2:='R20';
      Inc_STM_TAB_counter;

      ByteWert:='0x'+Copy(ASM_Wert,5,2);
      STM_LISTE[STM_LISTE_counter].statement:=STM_LDI;
      STM_LISTE[STM_LISTE_counter].Parameter1:=ByteWert;
      STM_LISTE[STM_LISTE_counter].Parameter2:='R21';
      Inc_STM_TAB_counter;

      ByteWert:='0x'+Copy(ASM_Wert,3,2);
      STM_LISTE[STM_LISTE_counter].statement:=STM_LDI;
      STM_LISTE[STM_LISTE_counter].Parameter1:=ByteWert;
      STM_LISTE[STM_LISTE_counter].Parameter2:='R22';
      Inc_STM_TAB_counter;

      ByteWert:='0x'+Copy(ASM_Wert,1,2);
      STM_LISTE[STM_LISTE_counter].statement:=STM_LDI;
      STM_LISTE[STM_LISTE_counter].Parameter1:=ByteWert;
      STM_LISTE[STM_LISTE_counter].Parameter2:='R23';
      Inc_STM_TAB_counter;


      STM_LISTE[STM_LISTE_counter].statement:=STM_CP;
      STM_LISTE[STM_LISTE_counter].Parameter1:='R20';
      STM_LISTE[STM_LISTE_counter].Parameter2:='R16';
      Inc_STM_TAB_counter;

      STM_LISTE[STM_LISTE_counter].statement:=STM_CPC;
      STM_LISTE[STM_LISTE_counter].Parameter1:='R21';
      STM_LISTE[STM_LISTE_counter].Parameter2:='R17';
      Inc_STM_TAB_counter;

      STM_LISTE[STM_LISTE_counter].statement:=STM_CPC;
      STM_LISTE[STM_LISTE_counter].Parameter1:='R22';
      STM_LISTE[STM_LISTE_counter].Parameter2:='R18';
      Inc_STM_TAB_counter;

      STM_LISTE[STM_LISTE_counter].statement:=STM_CPC;
      STM_LISTE[STM_LISTE_counter].Parameter1:='R23';
      STM_LISTE[STM_LISTE_counter].Parameter2:='R19';
      Inc_STM_TAB_counter;


      STM_LISTE[STM_LISTE_counter].statement:=STM_BREQ_Marke;
      STM_LISTE[STM_LISTE_counter].Parameter1:=
                CASE_LIS.LISTE[CASE_LIS.counter].Listen_Element_Marke;
      Inc_STM_TAB_counter;

      STM_LISTE[STM_LISTE_counter].statement:=STM_RJMP_Marke;
      STM_LISTE[STM_LISTE_counter].Parameter1:=
                CASE_LIS.LISTE[CASE_LIS.counter].naechstes_Element_Marke;
      Inc_STM_TAB_counter;

      STM_LISTE[STM_LISTE_counter].statement:=STM_sprungmarke;
      STM_LISTE[STM_LISTE_counter].Parameter1:=
      CASE_LIS.LISTE[CASE_LIS.counter].Listen_Element_Marke;
      Inc_STM_TAB_counter;

    end; { AT_dword }


  else
    Fehler_cl.Registrieren('ZwischenCode/CASE_STM_Listen_Element_Ende',
                           'Der Typ '+Compiler_cl.ASM_type_Typ_in_Bezeichner(
                           CASE_LIS.LISTE[CASE_LIS.counter].ASM_type)+
                             ' ist nicht programmiert',
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

  end; { case CASE_LIS.LISTE[CASE_LIS.counter].ASM_type of }

end; { procedure ZWC_class.CASE_STM_Listen_Element_Ende }





function ZWC_class.CASE_Element_Wert_lesen(EleType, CW : String; CUT : SI_Unter_Typ) : Boolean;
var
  CW_erfolgreich : Boolean;
  Wert_Original : String;
begin
  CW_erfolgreich:=false;

  Wert_Original:=CW;

  if CONST_WERT_ueberpruefen(CW,CUT,CASE_LIS.LISTE[CASE_LIS.counter].ASM_type) then begin

    case EleType of
      // das erste Element ist immer ein Einzel-Element (die Differenzierung nach den anderen
      // Typen erolgt erst beim zweiten Element)
      'E' : begin
              CASE_LIS.LISTE[CASE_LIS.counter].Wert_Original:=Wert_Original;
              CASE_LIS.LISTE[CASE_LIS.counter].Wert_ASM:=CW;
            end; { 'E' }

      'B' : begin
              CASE_STM_Bereich_Element(CASE_LIS.LISTE[CASE_LIS.counter].Wert_ASM,CW,
                                       CASE_LIS.LISTE[CASE_LIS.counter].Wert_Original,Wert_Original);
            end; { 'B' }

      'L' : begin
              CASE_STM_Listen_Element(CASE_LIS.LISTE[CASE_LIS.counter].Wert_ASM,
                                      CASE_LIS.LISTE[CASE_LIS.counter].Wert_Original);

              CASE_LIS.LISTE[CASE_LIS.counter].Wert_Original:=Wert_Original;
              CASE_LIS.LISTE[CASE_LIS.counter].Wert_ASM:=CW;
            end; { 'L' }


    else
      Fehler_cl.Registrieren('ZwischenCode/CASE_Element_CONST_lesen',
                             'der EleType <'+EleType+'> wird nicht ausgewertet',
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                             Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

    end; { case EleType of }


    CW_erfolgreich:=true;


  end; { if CONST_WERT_ueberpruefen(CW,CUT,CASE_LIS.LISTE[CASE_LIS.counter].ASM_type) then }

  Result:=CW_erfolgreich;
end; { function ZWC_class.CASE_Element_Wert_lesen }







function ZWC_class.CASE_Element_CONST_lesen(EleType, CEC : String) : Boolean;
var
  CEC_erfolgreich : Boolean;
  CEC_ASM_type : ASM_type_Typ;
  CEC_ANW_type : Char;
  CW : String;
begin
  CEC_erfolgreich:=false;

  if NAME_TO_ANW_und_ASM(CEC,CEC_ANW_type,CEC_ASM_type) then begin

    if CEC_ASM_type=CASE_LIS.LISTE[CASE_LIS.counter].ASM_type then begin

      if CEC_ANW_type='C' then begin

        CW:=CONST_NAME_TO_WERT(CEC);

        case EleType of
          // das erste Element ist immer ein Einzel-Element (die Differenzierung nach den anderen
          // Typen erfolgt erst beim zweiten Element)
          'E' : begin
                  CASE_LIS.LISTE[CASE_LIS.counter].Wert_Original:=CEC;
                  CASE_LIS.LISTE[CASE_LIS.counter].Wert_ASM:=CW;
                end; { 'E' }

          'B' : begin
                  CASE_STM_Bereich_Element(CASE_LIS.LISTE[CASE_LIS.counter].Wert_ASM,CW,
                                           CASE_LIS.LISTE[CASE_LIS.counter].Wert_Original,CEC);
                end; { 'B' }

          'L' : begin
                  CASE_STM_Listen_Element(CASE_LIS.LISTE[CASE_LIS.counter].Wert_ASM,
                                          CASE_LIS.LISTE[CASE_LIS.counter].Wert_Original);

                  CASE_LIS.LISTE[CASE_LIS.counter].Wert_Original:=CEC;
                  CASE_LIS.LISTE[CASE_LIS.counter].Wert_ASM:=CW;
                end; { 'L' }


        else
          Fehler_cl.Registrieren('ZwischenCode/CASE_Element_CONST_lesen',
                                 'der EleType <'+EleType+'> wird nicht ausgewertet',
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                                 Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);
        end; { case EleType of }

        CEC_erfolgreich:=true;

      end; { if CEC_ANW_type='C' then }

    end { if CEC_ASM_type=CASE_LIS.LISTE[CASE_LIS.counter].ASM_type then begin }
    else
      Fehler_cl.Registrieren('ZwischenCode/CASE_Element_CONST_lesen',
                             'der Typ des Elementes <'+CEC+'> = <'+
                             Compiler_cl.ASM_type_Typ_in_Bezeichner(CEC_ASM_type)+
                             '> stimmt nicht mit dem Typ der Case-Variablen <'+
                             Compiler_cl.ASM_type_Typ_in_Bezeichner(CASE_LIS.LISTE[CASE_LIS.counter].ASM_type)+
                             '> ueberein',
                              Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                              Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                              Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

  end; { if NAME_TO_ANW_und_ASM(CEC,CEC_ANW_type,CEC_ASM_type) then }

  Result:=CEC_erfolgreich;
end; { procedure ZWC_class.CASE_Element_CONST_lesen }






procedure ZWC_class.CASE_Einzel_Element;
begin

  CASE_STM_Einzel_Element(CASE_LIS.LISTE[CASE_LIS.counter].Wert_ASM,
                          CASE_LIS.LISTE[CASE_LIS.counter].Wert_Original);

end; { procedure ZWC_class.CASE_Einzel_Element }





procedure ZWC_class.CASE_Listen_Element_Ende;
begin

  CASE_STM_Listen_Element_Ende(CASE_LIS.LISTE[CASE_LIS.counter].Wert_ASM,
                               CASE_LIS.LISTE[CASE_LIS.counter].Wert_Original);

  CASE_LIS.LISTE[CASE_LIS.counter].erstes_Listen_Element:=true;


end; { procedure ZWC_class.CASE_Listen_Element_Ende }






procedure ZWC_class.case_else;
begin

  if CASE_LIS.LISTE[CASE_LIS.counter].erstes_Element then
    CASE_LIS.LISTE[CASE_LIS.counter].erstes_Element:=false
  else begin

    STM_LISTE[STM_LISTE_counter].Bemerkung:='; CASE - Sprung zu ENDCASE';
    STM_LISTE[STM_LISTE_counter].statement:=STM_RJMP_Marke;
    STM_LISTE[STM_LISTE_counter].Parameter1:=
           CASE_LIS.LISTE[CASE_LIS.counter].Ende_Marke;
    Inc_STM_TAB_counter;

  end; { if CASE_LIS.LISTE[CASE_LIS.counter].erstes_Element then }

  STM_LISTE[STM_LISTE_counter].Bemerkung:='; CASE OF ELSE';

  STM_LISTE[STM_LISTE_counter].statement:=STM_sprungmarke;
  STM_LISTE[STM_LISTE_counter].Parameter1:=CASE_LIS.LISTE[CASE_LIS.counter].naechstes_Element_Marke;
  Inc_STM_TAB_counter;

  CASE_LIS.LISTE[CASE_LIS.counter].mit_ELSE:=true;

end; { procedure ZWC_class.case_else }






procedure ZWC_class.case_end;
begin

  STM_LISTE[STM_LISTE_counter].Bemerkung:='; ENDCASE;';

  if not CASE_LIS.LISTE[CASE_LIS.counter].mit_ELSE then begin

    STM_LISTE[STM_LISTE_counter].statement:=STM_sprungmarke;
    STM_LISTE[STM_LISTE_counter].Parameter1:=CASE_LIS.LISTE[CASE_LIS.counter].naechstes_Element_Marke;
    Inc_STM_TAB_counter;

  end; { if not CASE_LIS.LISTE[CASE_LIS.counter].mit_ELSE then }

  STM_LISTE[STM_LISTE_counter].statement:=STM_sprungmarke;
  STM_LISTE[STM_LISTE_counter].Parameter1:=CASE_LIS.LISTE[CASE_LIS.counter].Ende_Marke;
  Inc_STM_TAB_counter;

  // Ruecksetzen_CASE_LIS;
  with CASE_LIS.LISTE[CASE_LIS.counter] do begin
    naechstes_Element_Marke:='';
    Ende_Marke:='';
    Listen_Element_Marke:='';
    Wert_ASM:='';
    Wert_Original:='';
    ASM_type:=AT_kein_typ;
    erstes_Listen_Element:=true;
    erstes_Element:=true;
    mit_ELSE:=false;
  end; { with CASE_LIS.LISTE[CASE_LIS.counter] do }

  Dec(CASE_LIS.counter);

  if CASE_LIS.counter<0 then
    Fehler_cl.Registrieren('ZwischenCode/case_end',
                           'CASE-Schleife mehrfach beendet',
                            Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                            Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                            Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

end; { procedure ZWC_class.case_end }





// ********************************************
//              ISR
// ********************************************









function ZWC_class.ISR_NAME_RD(ISR_NAME : String) : Boolean;
var
  ISR_erfolgreich : Boolean;
  I_Zaehler : Integer;
begin
  ISR_erfolgreich:=false;

  if ISR_LISTE.counter=1 then begin

    for I_Zaehler:=2 to ISR_LISTE.max_anzahl do begin
      if ISR_LISTE.LISTE[I_Zaehler].ISR_Name=ISR_NAME then begin
        ISR_LISTE.counter:=I_Zaehler;
        ISR_LISTE.enable:=true;
        ISR_LISTE.LISTE[I_Zaehler].enable:=true;
      end; { if ISR_LISTE.LISTE[I_Zaehler].ISR_Name=ISR_NAME then }

    end; { for I_Zaehler:=2 to ISR_LISTE.max_anzahl do }

    if ISR_LISTE.counter>1 then begin

      STM_LISTE[STM_LISTE_counter].Bemerkung:='; ISR - Einsprung';

      STM_LISTE[STM_LISTE_counter].statement:=STM_sprungmarke;
      STM_LISTE[STM_LISTE_counter].Parameter1:=ISR_NAME;
      Inc_STM_TAB_counter;

      STM_LISTE[STM_LISTE_counter].statement:=STM_isr_push;
      Inc_STM_TAB_counter;

      ISR_erfolgreich:=true;
    end
    else
      Fehler_cl.Registrieren('ZwischenCode/ISR_NAME_RD',
                           'Der ISR-Name ('+ISR_NAME+') ist nicht in der ISR-Liste',
                            Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                            Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                            Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);



  end { if ISR_LISTE.counter=1 then }
  else
    Fehler_cl.Registrieren('ZwischenCode/ISR_NAME_RD',
                           'Es ist bereits eine ISR in Bearbeitung ('+
                           ISR_LISTE.LISTE[ISR_LISTE.counter].ISR_Name+')',
                            Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                            Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                            Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);



  Result:=ISR_erfolgreich;

end; { function ZWC_class.ISR_NAME_RD }












function ZWC_class.ISR_NAME_CP(ISR_NAME : String) : Boolean;
var
  ISR_erfolgreich : Boolean;
begin
  ISR_erfolgreich:=false;

  if ISR_LISTE.counter>1 then begin

    if ISR_LISTE.LISTE[ISR_LISTE.counter].ISR_Name=ISR_NAME then begin

      STM_LISTE[STM_LISTE_counter].Bemerkung:='; ISR - Ende';
      STM_LISTE[STM_LISTE_counter].statement:=STM_isr_pop;
      Inc_STM_TAB_counter;

      STM_LISTE[STM_LISTE_counter].statement:=STM_RETI;
      Inc_STM_TAB_counter;

      ISR_LISTE.counter:=1;
      ISR_erfolgreich:=true;

    end
    else
      Fehler_cl.Registrieren('ZwischenCode/ISR_NAME_CP',
                           'Die eroeffnete ISR ('+ISR_LISTE.LISTE[ISR_LISTE.counter].ISR_Name+
                           ') und die zu schliessende ISR ('+ISR_NAME+') stimmen nicht ueberein',
                            Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                            Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                            Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);


  end { if ISR_LISTE.counter=1 then }
  else
    Fehler_cl.Registrieren('ZwischenCode/ISR_NAME_CP',
                           'Die ISR ('+ISR_NAME+') muss erst erffnet werden',
                            Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                            Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                            Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);



  Result:=ISR_erfolgreich;

end; { function ZWC_class.ISR_NAME_CP }






procedure ZWC_class.EnableInts;
begin

  STM_LISTE[STM_LISTE_counter].Bemerkung:='; Interrupt erlauben';
  STM_LISTE[STM_LISTE_counter].statement:=STM_SEI;
  Inc_STM_TAB_counter;

end; { procedure ZWC_class.EnableInts }


procedure ZWC_class.DisableInts;
begin

  STM_LISTE[STM_LISTE_counter].Bemerkung:='; Interrupt verbieten';
  STM_LISTE[STM_LISTE_counter].statement:=STM_CLI;
  Inc_STM_TAB_counter;

end; { procedure ZWC_class.DisableInts }







function ZWC_class.ISR_LISTE_NR(ISR_NR : String) : Boolean;
var
  ISR_erfolgreich : Boolean;
  ISR_Nummer : Integer;
begin
  ISR_erfolgreich:=false;

  ISR_Nummer:=StrToIntDef(ISR_NR,0);
  if ISR_Nummer>1 then begin
    if ISR_Nummer<=ISR_LISTE.max_anzahl then begin
      ISR_LISTE.counter:=ISR_Nummer;
      ISR_erfolgreich:=true;
    end
    else
      Fehler_cl.Registrieren('ZwischenCode/ISR_LISTE_NR',
                             'Die Nummer der ISR-Liste ('+ISR_NR+') darf maximal '+
                              IntToStr(ISR_LISTE.max_anzahl)+' sen',
                              Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                              Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                              Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

  end
  else
    Fehler_cl.Registrieren('ZwischenCode/ISR_LISTE_NR',
                           'Die Nummer der ISR-Liste ('+ISR_NR+') muss mindestens 2 sein',
                            Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                            Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                            Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

  Result:=ISR_erfolgreich;

end; { function ZWC_class.ISR_LISTE_NR }




function ZWC_class.ISR_LISTE_PAR(I_POS : Char; I_NAME : String) : Boolean;
var
  ISR_erfolgreich : Boolean;
begin
  ISR_erfolgreich:=false;

  if ISR_LISTE.counter>1 then begin
    case I_POS of

      'O' : begin
              ISR_LISTE.LISTE[ISR_LISTE.counter].ORG_Name:=I_NAME;
              ISR_erfolgreich:=true;
            end; { 'O' }

      'I' : begin
              ISR_LISTE.LISTE[ISR_LISTE.counter].ISR_Name:=I_NAME;
              ISR_erfolgreich:=true;
            end; { 'I' }

      'B' : begin
              ISR_LISTE.LISTE[ISR_LISTE.counter].Bemerkung:=I_NAME;
              ISR_LISTE.counter:=1;
              ISR_erfolgreich:=true;
            end; { 'B' }

    else
      Fehler_cl.Registrieren('ZwischenCode/ISR_LISTE_PAR',
                           'Der Parameter '+I_POS+' wird nicht unterstuetzt',
                            Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                            Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                            Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

    end; { if ISR_Nummer<2 then }

  end
  else
    Fehler_cl.Registrieren('ZwischenCode/ISR_LISTE_PAR',
                           'Die Nummer der ISR-Liste ('+IntToStr(ISR_LISTE.counter)+') wurde nicht gesetzt',
                            Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                            Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                            Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

  Result:=ISR_erfolgreich;

end; { function ZWC_class.ISR_LISTE_PAR }







// ********************************************
//              Hauptprogramm
// ********************************************





function ZWC_class.DEFINE_lesen(DEF_NAME : String) : Boolean;
var
  DEF_erfolgreich : Boolean;
begin
  DEF_erfolgreich:=true;
  Form_Device.DEFINE_NAME_IN_ATMEGA_Typ_Index(DEF_NAME);

  if Form_Device.ATMEGA_Typ_Index>-1 then begin

     ASM_Include_Datei:='.INCLUDE "'+
          Form_Device.ATMEGA_Array[Form_Device.ATMEGA_Typ_Index].INC_name+'"';

     AVRDUDE_Kurzbezeichnung:=
          Form_Device.ATMEGA_Array[Form_Device.ATMEGA_Typ_Index].AVRDUDE_name;

     // ASM_Switch
     ASM_Switch:=
          Form_Device.ATMEGA_Array[Form_Device.ATMEGA_Typ_Index].ASM_Switch;

     // ISR-Liste
     ISR_LISTE.max_anzahl:=
          Form_Device.ATMEGA_Array[Form_Device.ATMEGA_Typ_Index].ISR_LISTE_max_Anzahl;

  end { if Form_Prommer.ATMEGA_Typ_Index>-1 then }
  else begin
    Fehler_cl.Registrieren('ZwischenCode/DEFINE_lesen',
                           'keinen gueltigen Controllertyp bei DEFINE angegeben',
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

  end; { case DEFINE_NAME of }

  if ISR_LISTE.max_anzahl>Laenge_ISR_Liste then
    Fehler_cl.Registrieren('ZwischenCode/DEFINE_lesen',
                           'ISR_LISTE.max_anzahl>Laenge_ISR_Liste',
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);

  Result:=DEF_erfolgreich;

end; { function ZWC_class.DEFINE_lesen }








procedure ZWC_class.Kopfteil_Code_Segment;
begin

  STM_LISTE[STM_LISTE_counter].Bemerkung:='; *** Codesegment ***';
  STM_LISTE[STM_LISTE_counter].statement:=STM_Codesegment;
  Inc_STM_TAB_counter;

  STM_LISTE[STM_LISTE_counter].Bemerkung:='; *** Sprungtabelle ***';
  STM_LISTE[STM_LISTE_counter].statement:=STM_Sprungtabelle;
  Inc_STM_TAB_counter;


  STM_LISTE[STM_LISTE_counter].Bemerkung:='; Sprung in das Hauptprogramm';


  case ASM_Switch.JMP_Sprungdistanz of
    JMP_Relativ   : STM_LISTE[STM_LISTE_counter].statement:=STM_RJMP_Marke;
    JMP_Word      : STM_LISTE[STM_LISTE_counter].statement:=STM_JMP_Marke;
    JMP_als_EIJMP : STM_LISTE[STM_LISTE_counter].statement:=STM_EIJMP_Marke;
  else
    Fehler_cl.Registrieren('ZWC_04/Kopfteil_Code_Segment',
                           'JMP_Sprungdistanz nicht definiert',
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].datei,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].zeile,
                           Compiler_cl.SI_ARR[Parser_cl.SI_ARR_PAR_zaehler].spalte);
  end; { case JMP_Sprungdistanz of }


  STM_LISTE[STM_LISTE_counter].parameter1:='RESET';
  Inc_STM_TAB_counter;


  STM_LISTE[STM_LISTE_counter].statement:=STM_Interrupttabelle;
  Inc_STM_TAB_counter;

end; { function ZWC_class.Kopfteil_Code_Segment }




procedure ZWC_class.Einsprung_Hauptprogramm_eintragen;
begin
  STM_LISTE[STM_LISTE_counter].Bemerkung:='; Start des Hauptprogramms';
  STM_LISTE[STM_LISTE_counter].statement:=STM_sprungmarke;
  STM_LISTE[STM_LISTE_counter].parameter1:='RESET';
  Inc_STM_TAB_counter;
  STM_LISTE[STM_LISTE_counter].Bemerkung:='; Initialisieren des Stacks';
  STM_LISTE[STM_LISTE_counter].statement:=STM_stack_init;
  Inc_STM_TAB_counter;
end; { function ZWC_class.Einsprung_Hauptprogramm_eintragen }














